;============================================================================
;
;       D A T A   L O A D   /   D A T A   S A V E   R O U T I N E S
;
;============================================================================          
;     This module was originally M41
;============================================================================
          .XLIST
          INCLUDE   PREAMBLE
          .LIST
PUBLIC       SCRATCHD
PUBLIC       PUTPLTTR
PUBLIC       DSKIP
PUBLIC       DBKSP
PUBLIC       DATASAVE
PUBLIC       DATALOAD
PUBLIC       ADDIFILE
PUBLIC       ADDFILE
PUBLIC       GTFLPTRS
PUBLIC       ZEROFIL_
PUBLIC       CATEND
PUBLIC       CUREND1
PUBLIC       CURENDR
PUBLIC       DBKSP
PUBLIC       DSKIP
PUBLIC       ERR_34B
PUBLIC       ERROR_32
PUBLIC       ERROR_82
PUBLIC       ERROR_83
PUBLIC       ERROR_85
PUBLIC       ERROR_86
PUBLIC       FILELOCS
PUBLIC       FILENAME
PUBLIC       FILENAMH
PUBLIC       FILENAMP
PUBLIC       FILENAMS
PUBLIC       FILENMDA
PUBLIC       FILENMXA
PUBLIC       FINDNAMH
PUBLIC       GETFLPTR
PUBLIC       GETPLTTR
PUBLIC       INTINDX
PUBLIC       LISTDC
PUBLIC       NEWEOF
PUBLIC       NEWNAMEF
PUBLIC       SCRATCHD
 
 EXTRN  CPBASE         :DWORD
 EXTRN  _DTLSLST       :BYTE
 EXTRN  ENDDISKR       :NEAR
 EXTRN  RECSCTR        :NEAR
 EXTRN  CCJB           :NEAR
 EXTRN  DTLDDA         :NEAR
 EXTRN  DTLDAC         :NEAR
 EXTRN  DATALDBT       :NEAR
 EXTRN  DATALD         :NEAR
 EXTRN  DTSVBA         :NEAR
 EXTRN  DTSVAC         :NEAR
 EXTRN  DTSVDA         :NEAR
 EXTRN  DATASVBT       :NEAR
 EXTRN  ERROR_19       :NEAR
 EXTRN  PLATTER        :NEAR
 EXTRN  DISKSELC       :NEAR
 EXTRN  SECTOR         :NEAR
 EXTRN  AVARD          :NEAR
 EXTRN  ERROR_28       :NEAR
 EXTRN  DREAD          :NEAR
 EXTRN  ENDSDISK       :NEAR
 EXTRN  RAW            :NEAR
 EXTRN  ALPHA          :NEAR
 EXTRN  ERROR_29       :NEAR
 EXTRN  ERROR_11       :NEAR
 EXTRN  ERROR_13       :NEAR
 EXTRN  MSWRTBEG       :NEAR
 EXTRN  DWRITE?DA      :NEAR
 EXTRN  DWRITE?DAF     :NEAR
 EXTRN  MSWRTEND       :NEAR
 EXTRN  CCL            :NEAR
 EXTRN  DISKSL_P       :NEAR
 EXTRN  DISKSL_C       :NEAR
 EXTRN  LOADDATA       :NEAR
 EXTRN  ENDDISK        :NEAR
 EXTRN  REMCO          :NEAR
 EXTRN  EXPR           :NEAR
 EXTRN  FLTBINA        :NEAR
 EXTRN  FLTBINB        :NEAR
 EXTRN  ERROR          :NEAR
 EXTRN  SAVEDATA       :NEAR
 EXTRN  RFILE_         :NEAR
 EXTRN  FILE_A         :NEAR
 EXTRN  FILE_E         :NEAR
 EXTRN  DREADSF        :NEAR
 EXTRN  LOADDBLK       :NEAR
 EXTRN  GETPLTTR       :NEAR
 EXTRN  DTLDBA         :NEAR
 EXTRN  FILE_PTR       :NEAR
 EXTRN  ERROR_88       :NEAR
 EXTRN  DISKSEL        :NEAR
 EXTRN  ENDSTMT        :NEAR
 EXTRN  ENBLLIST       :NEAR
 EXTRN  LDCMSG14       :BYTE
 EXTRN  WRTSTRCM       :NEAR
 EXTRN  TWRITESP       :NEAR
 EXTRN  WRTVALA        :NEAR
 EXTRN  LDCMSG15       :BYTE
 EXTRN  LDCMSG16       :BYTE
 EXTRN  LDCMSG7        :BYTE
 EXTRN  ENBLDEVD       :NEAR
 EXTRN  PRNTCR         :NEAR
 EXTRN  WRTBLK         :NEAR
 EXTRN  TWRIT2SP       :NEAR
 EXTRN  TWRITE         :NEAR
 EXTRN  TWRIT3SP       :NEAR
 EXTRN  IOBUFTXT       :NEAR
 EXTRN  CPRNTCR        :NEAR
 EXTRN  LISTEND        :NEAR
 EXTRN  DREADS0        :NEAR
 EXTRN  RHASHFLG       :NEAR
 EXTRN  FLTBIN         :NEAR
 EXTRN  ALPHA1         :NEAR
 EXTRN  ARECEVAL       :NEAR
 EXTRN  ERROR_52       :NEAR
 EXTRN  RELALPHC       :NEAR
 EXTRN  RAWOFF         :NEAR
 EXTRN  ERROR_12       :NEAR
 EXTRN  ERROR_34       :NEAR
 EXTRN  RAWON          :NEAR
 EXTRN  plat           :NEAR

;         TITLE     DATALOAD DATASAVE
;*     DATALOAD (DATASAVE): ENTRY POINT FOR DATALOAD OR
;*          DATASAVE. CHECKS FOR 'BM','DA','BA','DC' AND
;*          BRANCHES TO THE APPROPRIATE ROUTINE.
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DATALOAD' OR
;*                      DATASAVE
;*
;*          EXIT: TEXTPTR POINTS AFTER 'BM','BA','DA',OR 'DC'
;*
;         ORG       *
;DATALOAD SB        GETCH     GET NEXT CHARACTER
;         BNEHH     C'B',CH,DTLDBM7     BR IF NOT B
;         BNELL     C'B',CH,DTLDBM7
;         TPS       ,         SAVE PTR TO START OF FIELD
;         SB        GETCH
;         BNEHH     C'M',CH,DTLDBM8     BR IF NOT M
;         BNELL     C'M',CH,DTLDBM8
;         TSP       ,         RESTORE STACK
;         B         DTLDBM

DATALOAD:
        MOV     EDX,TEXTPTR
        MOV     CH,[EDX]
        INC     TEXTPTR
        CMP     CH,'B'
        JNZ     DTLDBM7
        PUSH    EDX
        MOV     EDX,TEXTPTR
        MOV     CH,[EDX]
        INC     TEXTPTR
        CMP     CH,'M'
        JNZ     DTLDBM8
        POP     EDX
        JMP     DTLDBM

;DTLDBM8  TSP       ,         POINT @ B
;         TPA       ,TEXTPTR
;         B         DTLDBM9
;
;DTLDBM7  TPA       ,TEXTPTR  POINT @ 1ST CHARACTER
;

DTLDBM8:
        POP     EDX
        MOV     TEXTPTR,EDX
        JMP     DTLDBM9
DTLDBM7:
        CMP     CH,'A'
        JNZ     DTLDBM17
        PUSH    EDX
        MOV     EDX,TEXTPTR
        MOV     CH,[EDX]
        INC     TEXTPTR
        CMP     CH,'C'
        JNZ     DTLDBM8
        POP     EDX
        JMP     DTLDAC
DTLDBM17:
        MOV     TEXTPTR,EDX

;*        LOOK FOR BA, DC, DA OR BT
;DTLDBM9  LPI       _DTLSLST
;         SB        CCJB      LOOK FOR TYPE
;         B         DTLDDC    'DC'
;         B         DTLDBA    'BA'
;         B         DTLDDA    'DA'
;         B         DATALDBT  'BT'
;         B         DATALD    NULL

DTLDBM9:
        MOV     EDX,OFFSET _DTLSLST
        CALL    CCJB
        JMP     DTLDDC
        JMP     DTLDBA
        JMP     DTLDDA
        JMP     DATALDBT
        JMP     DATALD

;DATASAVE SB        GETCH     GET NEXT CHARACTER
;         BNEHH     C'B',CH,DTSVBM7     BR IF NOT B
;         BNELL     C'B',CH,DTSVBM7
;         TPS       ,         SAVE PTR TO START OF FIELD
;         SB        GETCH
;         BNEHH     C'M',CH,DTSVBM8     BR IF NOT M
;         BNELL     C'M',CH,DTSVBM8
;         TSP       ,         RESTORE STACK
;         B         DTSVBM

DATASAVE:
        MOV     EDX,TEXTPTR
        MOV     CH,[EDX]
        INC     TEXTPTR
        CMP     CH,'B'
        JNZ     DTSVBM7
        PUSH    EDX
        MOV     EDX,TEXTPTR
        MOV     CH,[EDX]
        INC     TEXTPTR
        CMP     CH,'M'
        JNZ     DTSVBM8
        POP     EDX
        JMP     DTSVBM

;DTSVBM8  TSP       ,         POINT @ B
;         TPA       ,TEXTPTR
;         B         DTSVBM9
;
;DTSVBM7  TPA       ,TEXTPTR  POINT @ 1ST CHARACTER
;
;*        LOOK FOR BA, DC, DA OR BT

DTSVBM8:
        POP     EDX
        MOV     TEXTPTR,EDX
        JMP     DTSVBM9
DTSVBM7:
        CMP     CH,'A'
        JNZ     DTSVBM17
        PUSH    EDX
        MOV     EDX,TEXTPTR
        MOV     CH,[EDX]
        INC     TEXTPTR
        CMP     CH,'C'
        JNZ     DTSVBM8
        POP     EDX
        JMP     DTSVAC
;
DTSVBM17:
        MOV     TEXTPTR,EDX

;DTSVBM9  LPI       _DTLSLST
;         SB        CCJB      LOOK FOR TYPE
;         B         DTSVDC    'DC'
;         B         DTSVBA    'BA'
;         B         DTSVDA    'DA'
;         B         DATASVBT  'BT'
;ERR_19U  B         ERROR_19  NULL

DTSVBM9:
        MOV     EDX,OFFSET _DTLSLST
        CALL    CCJB
        JMP     DTSVDC
        JMP     DTSVBA
        JMP     DTSVDA
        JMP     DATASVBT
ERR_19U:
        JMP     ERROR_19

;         TITLE     DTLDBM (DATALOAD BM)
;*     DTLDBM: SCAN & PROCESS A 'DATALOAD BM' STATEMENT
;*
;*          STMT FORMAT:
;*
;*            DATALOAD BM platter [ file#,     ]
;*                                [disk-addr,  ]
;*
;*               (sector-offset [,[variable]]) alpha
;*
;*        THE DIFFERENCE BETWEEN THE BA AND THE BM STATEMENT IS THAT THE BA
;*            READS THE CONTENTS OF EXACTLY ONE SECTOR.  WHERE THE BM WILL
;*            READ AS MANY SECTORS AS ARE NEEDED TO FILL THE ALPHA VARIABLE.
;*
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'BM'
;*                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;*
;*          REGISTER USE:
;*               AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*               AUXE (\ISK CONTROL REG.) = PLATTER,FILE#
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2,B,C
;*               AUXE,F IN EXECUTION PHASE ONLY
;*
;         ORG       *
;DTLDBM   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSELC  PROCESS DISK SELECTION (_n,  or /xyy,)
;         SB        SECTOR    PROCESS SECTOR ADDRESS SPECIFICATION
;         SB        AVARD     PROCESS ALPHA SPECIFICATION
;         BEQL      0,F0,DTLDBM5        FOUND - BRANCH
;         B         ERROR_28  NOT FOUND - ERROR

DTLDBM:
        CALL    PLATTER
        CALL    DISKSELC
        CALL    SECTOR
        CALL    AVARD
        TEST    R0,0FH
        JZ      DTLDBM5
        JMP     ERROR_28

;DTLDBM5  BFL       2,SL,DTLDBM1        BRANCH IF NOT EXECUTION PHASE
;DTLDBM6  TAP       ,VSPTR    CHECK LENGTH ON VALUE STACK
;         TPA+2,R   ,0
;         BER       CH,,DTLDBM2         BR IF ALPHA REC < 256 BYTES LONG
;*        VARIABLE LARGE ENOUGH TO HOLD AT LEAST 256 BYTES

DTLDBM5:
        TEST    SL,2
        JZ      DTLDBM1                ;   2  LENGTH OF RECEIVER  <--- VSPTR
DTLDBM6:                               ;   4  ADDRESS OF RECEIVER VARIABLE  <--- AUX00
        MOV     EDX,VSPTR              ;
        MOV     CX,[EDX]               ;   THE STATE OF VALUE STACK NOW !
                                       ;  REG. CL FOR LABEL DTLDBM2 USE
        MOV     AUX00,EDX              ; READ A WORD , YOU MUST EXCHANGE CH,CL
        ADD     AUX00,2                ; READ A DOUBLE WORD , YOU DON'T EXCHANGE
        CMP     CH,0
        JZ      DTLDBM2

;         AI,W1     X'FF',CH, DECREMENT RECEIVER LENGTH IN VS BY 256 BYTES
;         TAP       ,0        READ ADDRESS OF RECEIVER
;         OR,R      F0,,
;         AI,W1     X'01',CH, ADD 256 TO ADDR OF RECEIVER IN VS
;         MVX       CHCL,PHPL PC'S = ADDRESS OF RECEIVER VARIABLE
;         XPA       ,F        AUX F = RECEIVER ADDR
;*                                                 PC'S = SECTOR TO READ
;         SB        DREAD     READ SECTOR DIRECTLY INTO RECEIVER VARIABLE
;
;         B         DTLDBM6

        sub     cx,100h         ;DEC DOESN'T CHANGE THE CARRY FLAG !!!!!
        MOV     [EDX],CX        ;KEEP THE NEWEST LENGTH INFORMATION IN VALUE STACK
        MOV     EDX,AUX00
        MOV     ECX,[EDX]
        MOV     EAX,ECX
        ADD     EAX,100H
        MOV     [EDX],EAX       ; BEFORE XCHG EDX,AUX0F
        MOV     EDX,ECX         ; EDX --- ADDRESS OF RECEIVER
        XCHG    EDX,AUX0F       ; AUX0F - SECTOR TO READ
        CALL    DREAD
        JMP     DTLDBM6

;DTLDBM3  SB        RECSCTR   SET RECEIVER VARIABLE = NEXT AVAILABLE SECTOR ADDR
;DTLDBM1  B         ENDSDISK  DISABLE DISK, EXIT
;*        READ SECTOR INTO IO BUFFER AND TRANSFER LESS THAN 256 BYTES
;DTLDBM2  BER       CL,,DTLDBM0         IF RECEIVER FULL? YES - BRANCH
;         SB        RIOBUFFR  GET ADDR OF I/O BUFFER
;         XPA       ,F        AUX F = ADDR OF I/O BUFFER

DTLDBM3:
        CALL    RECSCTR
DTLDBM1:
        JMP     ENDSDISK
DTLDBM2:
        CMP     CL,0            ;EXACTLY THE MULTIPLY OF 256 BYTE (ONE SECTOR)
        JZ      DTLDBM0         ;AFTER XCHG EDX,AUX0F
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
                                ; EDX -- SECTOR TO READ
        XCHG    EDX,AUX0F       ; AUX0F- ADDRESS OF I/O BUFFER

;*                                                 PC'S = SECTOR TO READ
;         SB        DREAD     READ SECTOR
;         SB        POPV4     F1F0=LENGTH OF RECEIVER
;*                                                 PC = ADDR OF RECEIVER
;         TPA       ,0        SAVE
;         SB        RIOBUFFR  PC'S = I/O BUFFER ADDRESS
;*                                                 AUX 0 = ADDR OF RECEIVER
;DTLDBM4  XPA+2,R   ,0        PC'S = ADDR OF RECEIVER
;*                                                 PC'S = I/O BUFFER +2

        CALL    DREAD
        MOV     EDX,VSPTR
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR [R0],AX
        MOV     ECX,DWORD PTR [EDX+2]
        ADD     VSPTR,6
        MOV     EDX,ECX
;
        xor     ecx,ecx
        mov     cx,word ptr r0
        mov     edi,edx       ;ADDRESS OF RECEIVER
        mov     edx,dword ptr [cpbase]
        lea     esi,[edx].@iobuffr
                              ; EDX ----- I/O BUFFER ADDRESS
DTLDBM4:                      ; WORD PTR R0 - LENGTH OF RECEIVER

;         OR,W1     +,CH,     WRITE CH (I/O BUFFER EVEN ADDR)
;         AI        X'FF',F0,F0         DECREMENT COUNT
;         BER       F0,,DTLDBM3         DONE - BRANCH
;         XPA+1,W1  CL,0      WRITE 2ND BYTE
;         AI        X'FF',F0,F0         DECREMENT COUNT
;         BNR       F0,,DTLDBM4         NOT DONE - BRANCH
;         B         DTLDBM3
;DTLDBM0  SB        POPV4     RESTORE VALUE STACK
;         B         DTLDBM3

        rep     movsb

        JMP     DTLDBM3
DTLDBM0:
        MOV     EDX,VSPTR
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR [R0],AX
        MOV     ECX,DWORD PTR [EDX+2]
        ADD     VSPTR,6
        MOV     EDX,ECX
        JMP     DTLDBM3

;         TITLE     DTSVBM (DATASAVE BM)
;*
;*     DTSVBM: SCAN & PROCESS A 'DATASAVE BM' STATEMENT
;*
;*          STMT FORMAT:
;*
;*            DATASAVE BM  platter [$] [ file#,   ]
;*                                     [disk-addr,]
;*
;*               (sector-addr [,[variable]]) alpha
;*
;*
;*        THE DIFFERENCE BETWEEN THE BA AND THE BM STATEMENT IS THAT THE BA
;*            WRITES THE CONTENTS TO EXACTLY ONE SECTOR.  WHERE THE BM WILL
;*            WRITE AS MANY SECTORS AS REQUESTED.
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'BM'
;*                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;*
;*          REGISTER USE:
;*               AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*               AUXE (DISK CNTRL REG) = PLATTER,FILE#,R/W
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXE,F IN EXECUTION PHASE ONLY
;*
;         ORG       *
;DTSVBM   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAW       PROCESS READ-AFTER-WRITE SPECIFICATION
;         SB        DISKSELC  PROCESS DISK SELECTION (_n,  or /xyy,)
;         SB        SECTOR    PROCESS SECTOR ADDRESS SPECIFICATION
;         SB        ALPHA     PROCESS ALPHA VARIABLE OR LITERAL
;         BEQL      0,F0,*+2
;         B         ERROR_29  ERROR IF NOT FOUND

DTSVBM:
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSELC
        CALL    SECTOR
        CALL    ALPHA
        CMP     R0,0
        JZ      BP41A_01
        JMP     ERROR_29

;         BFL       2,SL,DTSVBM1        BRANCH IF NOT EXECUTION PHASE
;*        START MULTI-SECTOR WRITE
;         SB        MSWRTBEG  START MULTI SECTOR WRITE
;*        CHECK LENGTH OF ALPHA - JUMP IF LESS THAN 256
;         TAP       ,VSPTR    GET LENGTH FROM VALUE STACK
;         TPA+2,R   ,0        AUX POINTS AT ADDR OF VARI
;         BER       CH,,DTSVBMVL        BR IF < 256

BP41A_01:
        TEST    SL,2
        JZ      DTSVBM1
;
        CALL    MSWRTBEG        ;START MULTI SECTOR WRITE
        MOV     EDX,VSPTR       ;GET LENGTH OF RECEIVER FROM VALUE STACK
        MOV     CX,[EDX]
        MOV     AUX00,EDX
        ADD     AUX00,2         ;AUX00 -- ADDRESS OF RECEIVER
        CMP     CH,0            ;         FOR LABEL DTSVBMVL USE
        JZ      DTSVBMVL

;*        COPY AS MANY SECTORS AS SPECIFIED IN VARIABLE
;
;DTSVBM4  SB        RIOBUFFR  PC'S PT AT I/O BUFFER
;         TPA       ,0        SAVE
;         TAP       ,VSPTR    GET LENGTH
;         TPS+2,R   CHCL = LENGTH
;         AI,W1     X'FF',CH, DECREMENT LENGTH BY 256

DTSVBM4:

        mov     edx,dword ptr [cpbase]
        lea     edi,[edx].@iobuffr
                               ;AUX00 -- TEMPLATELY STORE ADDRESS OF I/O BUFFER
        MOV     EDX,VSPTR
        MOV     CX,[EDX]
        MOV     EAX,EDX
        ADD     EAX,2
        PUSH    EAX             ; ONE PAIR OF THIS LINE AND NEXT THREE LINE
        sub     cx,100h
        MOV     [EDX],CX

;         TSP       PC'S POINT AT VARAIBLE
;         XOR,R     F0,F0,F0  COUNT = X'FF'
;*                                                 F0 = 256
;         AI,W1     X'01',CH, ADD 256 TO VARIABLE PTR
;         MVX       CHCL,PHPL PC'S POINT AT PREVIOUS VARIABLE ADDRESS

        POP     EDX             ; ECX --- ADDRESS OF RECEIVER
        MOV     ECX,[EDX]
        MOV     EAX,ECX
        ADD     EAX,100H
        MOV     [EDX],EAX
        mov     esi,ecx
;
;DTSVBM5  XPA+1,R   ,0        READ 1 BYTES FROM VARIABLE
;         XPA+1,W1  CH,0      WRITE ONE BYTE
;         AI        X'FF',F0,F0
;         BNR       F0,,DTSVBM5         LOOP UNTIL 256 BYTES XFER
;         SB        RIOBUFFR  PC'S POINT AT I/O BUFFER

DTSVBM5:
        mov     ecx,100h
        rep     movsb

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

;         XPA       ,F        PC'S= SECTOR, AUX F=DATA
;         SB        DWRITE?DA   WRITE SECTOR
;         TAP       ,VSPTR    CHECK LENGTH LEFT TO BE MOVED
;         OR,R      +,,
;         BNR       CH,,DTSVBM4
;         BNR       CL,,DTSVBMVL        BR IF LESS THAN 256 TO BE MOVED
;         SB        POPV4     RESTORE VALUE STACK
;         B         DTSVBM6

        XCHG    EDX,AUX0F
        CALL    DWRITE?DA
        MOV     EDX,VSPTR
        MOV     CX,[EDX]
        CMP     CH,0
        JNZ     DTSVBM4
        CMP     CL,0
        JNZ     DTSVBMVL
        MOV     EDX,VSPTR
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR [R0],AX
        MOV     ECX,DWORD PTR [EDX+2]
        ADD     VSPTR,6
        MOV     EDX,ECX
        JMP     DTSVBM6

;*     DTSVBMVL:  IF DATASAVE BM VALUE IS ON LAST PAGE
;*          OF MEMORY, TRANSFER VALUE TO I/O BUFFER
;*          BEFORE WRITE IN ORDER TO PREVENT PARITY
;*          ERRORS.
;*
;*        This patch causes the value to be padded with hex(00)s if the value is
;*        shorter than 256 bytes.  This is done by copying short values to
;*        the IOBUFFER and padding with zeroes.  The code assumes that IOBUFFER
;*        is on a page boundary -- this is the case.
;DTSVBMVL SB        RIOBUFFR  POINT TO 'IOBUFFER'
;         TPA       ,0        AUX0 = ADDRESS OF I/O BUFFER
;         SB        POPV4     GET LENGTH AND ADDRESS OF ALPHA VALUE

DTSVBMVL:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

        MOV     edi,EDX
        MOV     EBX,EDX
        ADD     EBX,100H
        MOV     EDX,VSPTR
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR [R0],AX
        MOV     ECX,DWORD PTR [EDX+2]
        ADD     VSPTR,6
        MOV     EDX,ECX

        mov     esi,edx
        xor     ecx,ecx
        mov     cx,word ptr r0

;DTSVBM3  XPA+1,R   ,0        MOVE VALUE TO I/O BUFFER
;         XPA+1,W1  CH,0
;         AI        0FF,F0,F0 decrement count
;         BNR       F0,,DTSVBM3         branch if more bytes in value
;*        fill rest of IOBUFFER with zeroes
;         TAP       ,0
;         OR,W1     +,,       write zero
;         BNR       F0,PL,*-1 branch if more to buffer
;         AI        0FF,PH,PH point to begin of buffer

DTSVBM3:
        rep     movsb

        mov     al,0
BP41A_03:
        stosb
        CMP     edi,EBX
        JNZ     BP41A_03

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

;DTSVBM2  XPA       ,F        PC'S = SECTOR ADDRESS TO WRITE; AUXF = ADDRESS
;*_     OF DATA TO WRITE
;         SB        DWRITE$   WRITE SECTOR & READ-AFTER-WRITE IF SPECIFIED
;DTSVBM6  SB        MSWRTEND  END MULTI SECTOR WRITE
;         SB        RECSCTR   SET RECEIVER VARIABLE = NEXT AVAILABLE SECTOR ADDR
;DTSVBM1  B         ENDSDISK  DISABLE DISK, EXIT

DTSVBM2:
        XCHG    EDX,AUX0F
        CALL    DWRITE?DA
DTSVBM6:
        CALL    MSWRTEND
        CALL    RECSCTR
DTSVBM1:
        JMP     ENDSDISK

;         TITLE     DTLDDC (DATALOAD DC)
;*     DTLDDC: PROCESS A 'DATALOAD DC' STATEMENT
;*
;*          STMT FORMAT:
;*
;*        1. DATALOAD [DC] [file#,] argument-list
;*
;*        2. DATALOAD [DC] OPEN platter [file#,] filenam
;*
;*        3. DATALOAD [DC] OPEN platter [file#,]
;*
;*               TEMP [,] expression , expression
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DC'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUXB,C,D,E,F (EXECUTION PHASE ONLY)
;*
;         ORG       *
;DTLDDC   MVI       @OPEN,F0
;         SB        CCL       LOOK FOR 'OPEN'
;         BEQL      0,F0,DTLDDC1        BRANCH IF 'DATALOAD DC OPEN'
;*     DATALOAD argument-list

DTLDDC:
        MOV     R0,@OPEN
        CALL    CCL
        TEST    R0,0FH
        JZ      DTLDDC1

;         SB        DISKSL_P  PROCESS _n, SPECIFICATION
;         SB        GETFLPTR  GET FILE PTRS FROM DEVICE TABLE (_n SLOT)
;         SB        LOADDATA  READ DISK & PROCESS ARGUMENT LIST
;         BFL       2,SL,DTLDDC3        BRANCH IF NOT EXECUTION PHASE
;         SB        PUTCPTR   SET CURRENT PTR IN DEV.TBL. TO NEXT AVAILABLE SCTR
;         SB        ENDDISK   RELEASE DISK
;         B         REMCO     SLIDE OVER REST OF STATEMENT; MAY BE IN MIDDLE IF
;*_     EOF WAS ENCOUNTERED.

        CALL    DISKSL_P
        CALL    GETFLPTR
        CALL    LOADDATA
        TEST    SL,2
        JZ      DTLDDC3
        CALL    PUTCPTR
        CALL    ENDDISK
        JMP     REMCO

;*     DATALOAD OPEN
;*
;DTLDDC1  SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSL_C  PROCESS _n, SPECIFICATION
;         BFL       2,SL,*+2  branch if not x-phase
;         SB        ZEROFIL_  clear device table slot (added rel. 1.9)
;         MVI       @TEMP,F0
;         SB        CCL       LOOK FOR 'TEMP'

DTLDDC1:
        CALL    PLATTER
        CALL    DISKSL_C
        TEST    SL,2
        JZ      BP41A_04
        CALL    ZEROFIL_
BP41A_04:
        MOV     R0,@TEMP
        CALL    CCL

;         BEQL      0,F0,DTLDDC2        BRANCH IF 'DATALOAD OPEN TEMP'
;         SB        FILENAMD  SCAN FOR NAME OF FILE TO OPEN
;         BFL       2,SL,DTLDDC3        BRANCH IF NOT EXECUTION PHASE
;         TAP       ,C
;         SB        PUTFLPTR  FILE PTRS ==> DEVICE TABLE _n SLOT
;         SB        PUTPLTTR  PLATTER SPEC. ==> _n DEVICE TABLE SLOT
;DTLDDC3  B         ENDSDISK  DISABLE DISK, EXIT

        TEST    R0,0FH
        JZ      DTLDDC2
        CALL    FILENAMD
        TEST    SL,2
        JZ      DTLDDC3
        MOV     EDX,AUX0C
        CALL    PUTFLPTR
        CALL    PUTPLTTR
DTLDDC3:
        JMP     ENDSDISK

;*     DATALOAD OPEN TEMP
;*
;DTLDDC2  SB        PROCTEMP  PROCESS TEMP FILE PARAMETERS; OPEN FILE
;         B         ENDSDISK  DISABLE DISK EXIT

DTLDDC2:
        CALL    PROCTEMP
        JMP     ENDSDISK

;         TITLE     PROCTEMP
;*     PROCTEMP: PROCESS TEMP FILE PARAMETERS & OPEN THE
;*               TEMPORARY FILE.
;*               (CALLED BY DATALOAD AND DATASAVE DC OPEN)
;*
;*          FORMAT:  TEMP [,] expression , expression
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'TEMP'
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = PLATTER / FILE_
;*
;*          EXIT: IF NOT EXECUTION PHASE, 'B ENDSTIO'
;*
;*          RETURN: TEXTPTR POINTS AFTER 2ND EXPRESSION
;*                  IN EXECUTIN PHASE,
;*                    START,CURRENT(=START),END ADDR OF
;*                         FILE ==> _n DEVICE TABLE SLOT
;*                    F5,4 = START ADDRESS OF FILE
;*                    F7,6 = END ADDRESS OF FILE
;*                    PC'S POINT TO END ADDR IN THE
;*                         _n DEVICE TABLE SLOT
;*                    AUXC = ADDRESS OF I/O BUFFER
;*                    I/O BUFFER CONTAINS SECTOR 0
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,F
;*
;PROCTEMP SB        NXTCHCOM  LOOK FOR COMMA (OPTIONAL)
;         SB        EXPR      PROCESS START EXPRESSION
;         SB        GETCHCOM  LOOK FOR COMMA
;         SB        EXPR      PROCESS END EXPRESSION
;         BFL       2,SL,DTLDDC3        EXIT IF NOT EXECUTION PHASE
;         SB        FLTBINB   COVERT END VALUE TO BINARY
;         MVX       F1F0,F7F6 F7,6 = END

PROCTEMP:
        cmp     byte ptr [textptr],','
        jnz     proctemp1
        inc     textptr
proctemp1:

        CALL    EXPR

        cmp     byte ptr [textptr],','
        jnz     error_13
        inc     textptr

        CALL    EXPR
        TEST    SL,2
        JZ      DTLDDC3
        CALL    FLTBINB                 ; R0R1 PAIRS PASS RESULT OUT
        MOV     AX,WORD PTR R0          ; THE PROCEDURE FLTBINB TAKES  PARAMETERS FROM STACK ?
        MOV     WORD PTR R6,AX

;         SB        FLTBINB   CONVERT START VALUE TO BINARY
;         BLRX      F7F6,F1F0,ERROR_32  ERROR IF END < START
;         MVX       F1F0,F5F4 F5,4 = START
;         SB        CATENDR   GET END OF CAT. AREA ADDRESS FROM SECTOR 0
;         BLERX     F5F4,PHPL,ERR86_86  ERROR IF START <= END OF CAT. AREA
;         SB        PUTFLPTS  START,CURRENT,END OF FILE ADDRS ==> DEVICE TABLE
;         B         PUTPLTTR  PLATTER SPEC. ==> _n DEVICE TABLE SLOT

        CALL    FLTBINB
        MOV     AX,WORD PTR R0
        CMP     AX,WORD PTR R6
        JA      ERROR_32                ;R6R7 --- END ADDRESS
        MOV     WORD PTR R4,AX          ;R4R5 --- START ADDRESS
        CALL    CATENDR                 ; (E)DX  PASS RESULT OUT
        CMP     DX,WORD PTR R4
        JA      ERR86_86
        CALL    PUTFLPTS
        JMP     PUTPLTTR

;ERROR_32 MVI       32,F0     START > END
;         B         ERROR
;ERR86_86 B         ERROR_86  .ADDED TO PREVENT PAGE ERROR

ERROR_32:
        MOV     R0,32H
        JMP     ERROR
ERR86_86:
        JMP     ERROR_86

;         TITLE     DTSVDC (DATASAVE DC)
;*     DTSVDC: PROCESS 'DATASAVE DC' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               1. DATASAVE [DC] [$] [file_,] arg-list
;*
;*               2. DATASAVE [DC] [$] [file_,] END
;*
;*               3. DATASAVE [DC] CLOSE [file_]
;*                                      [ALL  ]
;*
;*               4A. DATASAVE [DC] OPEN platter [$]
;*
;*                         [file_,] (filename  ) filename
;*                                  (expression)
;*
;*               4B. DATASAVE [DC] OPEN platter [$]
;*
;*                         [file_,] filename   , filename
;*                                 expression
;*
;*               5. DATASAVE [DC] OPEN platter [$]
;*
;*                         [file_,] TEMP [,] expr , expr
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DATASAVE DC'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2,3
;*               IN EXECUTION PHASE, AUXA-F
;*
;         ORG       *
;DTSVDC   MVI       @OPEN,F0
;         SB        CCL       LOOK FOR 'OPEN'
;         BEQL      0,F0,DTSVDCO        BRANCH IF FOUND
;         MVI       @CLOSE,F0
;         SB        CCL       LOOK FOR 'CLOSE'
;         BEQL      0,F0,DTSVDCC        BRANCH IF FOUND

DTSVDC:
        MOV     R0,@OPEN
        CALL    CCL
        TEST    R0,0FH
        JZ      DTSVDCO
        MOV     R0,@CLOSE
        CALL    CCL
        TEST    R0,0FH
        JZ      DTSVDCC

;*     DATASAVE arg-list OR DATASAVE END
;*
;         SB        RAW       PROCESS READ AFTER WRITE SPECIFICATION
;         SB        DISKSL_P  PROCESS _n, SPECIFICATION
;         SB        GETFLPTR  GET FILE PTRS FROM DEVICE TABLE
;         SB        SAVEDATA  PROCESS ARG-LIST & RECORD DATA ON DISK
;         SB        PUTCPTR   SET CURRENT SECTOR ADDRESS IN DEVICE TABLE
;         BFL       2,SL,DTSVDC1        BRANCH IF NOT EXECUTION PHASE

        CALL    RAW
        CALL    DISKSL_P
        CALL    GETFLPTR
        CALL    SAVEDATA
        CALL    PUTCPTR
        TEST    SL,2
        JZ      DTSVDC1

;         SB        RIOBUFFR  CH = CONTROL BYTE OF LAST SECTOR WRITTEN
;         BNEH      0A,CH,DTSVDC1       BRANCH IF NOT DATASAVE END
;         SB        GETFLPTR  GET FILE PTRS FROM DEVICE TABLE
;         TAP       ,F
;         MVI       0,F7      FILE TYPE = DATA
;         SB        WRTEOF    WRITE EOF BLOCK (WITH NO. OF USED SECTORS)
;DTSVDC1  B         ENDSDISK  DISABLE DISK, EXIT

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        mov     cx,[edx]
        xchg    ch,cl

        CMP     CH,0A0H
        JNZ     DTSVDC1
        CALL    GETFLPTR        ;AUX0F PASSES THE RESULT OUT !
        MOV     EDX,AUX0F
        MOV     R7,0
        CALL    WRTEOF
DTSVDC1:
        JMP     ENDSDISK

;         TITLE     DATASAVE DC CLOSE
;DTSVDCC  MVI       @ALL,F0
;         SB        CCL       LOOK FOR 'ALL'
;         BNEL      0,F0,DTSVDCC1       BRANCH IF NF
;*%------- DATASAVE DC CLOSE ALL ------------------------------------------------
;         BFL       2,SL,DTSVDCC4       EXIT IF NOT EXECUTION PHASE
;         MVI       0,F2      file_ counter

DTSVDCC:
        MOV     R0,@ALL
        CALL    CCL
        TEST    R0,0FH
        JNZ     DTSVDCC1
        TEST    SL,2
        JZ      DTSVDCC4
        MOV     r2,0            ;R2 IS A COUNTER  , INCREASE ONE EVERY TIME

;DTSVDCC3 SB        RFILE_    CH = max. file_
;         BLR       CH,F2,DTSVDCC2      branch if all file_'s closed
;         OR,W2     F2,,      next file_ to close
;         SB        ZEROFIL_  close next file_
;         AC,1      F2,,F2    increment file_
;         BFL       CA,SH,DTSVDCC3      branch if file_ < 256

DTSVDCC3:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@file_
        mov     cx,[edx]
        xchg    ch,cl
                                 ;CH= MAX FILE
        CMP     CH,r2
        JB      DTSVDCC2
        mov     al,r2
        MOV     [EDX+1],AL
        CALL    ZEROFIL_                 ;al has altered
        add     r2,1
        JNC     DTSVDCC3

;DTSVDCC2 SB        RFILE_
;         ,W2       0,,       file_ = _0
;         B         ENDSDISK  DISABLE DISK, EXIT
;*%------- DATASAVE DC CLOSE _n -------------------------------------------------
;DTSVDCC1 SB        FILE_A    LOOK FOR FILE _
;         BFL       2,SL,DTSVDCC4       EXIT IF NOT EXECUTION PHASE
;         SB        ZEROFIL_  ZERO _n DEVICE TABLE SLOT
;DTSVDCC4 B         ENDSDISK  DISABLE DISK, EXIT

DTSVDCC2:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@file_

        MOV     BYTE PTR [EDX+1],0
        JMP     ENDSDISK
DTSVDCC1:
        CALL    FILE_A
        TEST    SL,2
        JZ      DTSVDCC4
        CALL    ZEROFIL_
DTSVDCC4:
        JMP     ENDSDISK

;         TITLE     DATASAVE DC OPEN
;DTSVDCO  SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAW       PROCESS READ AFTER WRITE SPECIFICATION
;         SB        DISKSL_C  PROCESS _n, SPECIFICATION
;         BFL       2,SL,*+2  branch if not x-phase
;         SB        ZEROFIL_  clear device table slot (added rel 1.9)

DTSVDCO:
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSL_C
        TEST    SL,2
        JZ      BP41A_05
        CALL    ZEROFIL_

;         MVI       @TEMP,F0
;         SB        CCL       LOOK FOR 'TEMP'
;         BEQL      0,F0,DTSVDCT        BRANCH IF FOUND
;         SB        FILELOC   PROCESS FILE LOCATION PARAMETER
;         SB        NXTCHCOM  LOOK FOR COMMA (OPTIONAL)

BP41A_05:
        MOV     R0,@TEMP
        CALL    CCL
        TEST    R0,0FH
        JZ      DTSVDCT
        CALL    FILELOC

        cmp     byte ptr [textptr],','
        jnz     dtsvdco6
        inc     textptr

;DTSVDCO6 SB        GETFLPTR  GET START & END OF FILE ADDRESSES
;         SB        NEWNAME   GET FILENAME FROM TEXT & SCAN FOR IT IN
;*_     DISK INDEX
;         BFL       2,SL,DTSVDCO2       EXIT IF NOT EXECUTION PHASE

DTSVDCO6:
        CALL    GETFLPTR
        CALL    NEWNAME
        TEST    SL,2
        JZ      DTSVDCO2

;DTSVDCO3 MVI       0,F7      FILE TYPE = DATA
;         SB        ADDFILE   ADD FILE TO DISK CATALOG
;         SB        PUTPLTTR  PLATTER SPEC. ==> _n DEVICE TABLE SLOT
;DTSVDCO2 B         ENDSDISK  DISABLE DISK, EXIT
;*     DATASAVE DC OPEN TEMP

DTSVDCO3:
        MOV     R7,0
        CALL    ADDFILE
        CALL    PUTPLTTR
DTSVDCO2:
        JMP     ENDSDISK

;DTSVDCT  SB        PROCTEMP  PROCESS TEMP FILE PARAMETERS
;         BFL       2,SL,DTSVDCT1       BRANCH IF NOT EXECUTION PHASE
;         MVX       F7F6,PHPL
;         TPA       ,D        SAVE END ADDRESS OF FILE
;         SB        WRTEOF1   WRITE EOF BLOCK WITH NO. OF SECTORS USED
;DTSVDCT1 B         ENDSDISK  DISABLE DISK, EXIT

DTSVDCT:
        CALL    PROCTEMP
        TEST    SL,2
        JZ      DTSVDCT1
        MOV     DX,WORD PTR R6
        MOV     AUX0D,EDX
        CALL    WRTEOF1
DTSVDCT1:
        JMP     ENDSDISK

;*        TITLE     DSKIP
;*     DSKIP: PROCESS A 'DSKIP' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               DSKIP [file#,] END
;*                              expression [S]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DSKIP'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXB,C,D,E,F
;*
;         ORG       *
;DSKIP    SB        FILE#A    PROCESS #n, SPECIFICATION
;         BNEL      0,F0,*+2  Skip if #n not found
;         SB        GETCHCOM  Get comma, if #n found
;         SB        GETPLTTR  Get platter from device table
;         MVI       @END,F0
;         SB        CCL       LOOK FOR 'END'
;         BNEL      0,F0,DSKIP1         NF, BRANCH

DSKIP:
        CALL    FILE_A
        TEST    R0,0FH
        JNZ     BP41C_01

        cmp     byte ptr [textptr],','
        jnz     error_13
        inc     textptr

BP41C_01:
        CALL    GETPLTTR
        MOV     R0,@END
        CALL    CCL
        TEST    R0,0FH
        JNZ     DSKIP1

;*     DSKIP END
;*
;         BFL       2,SL,DSKIP2         EXIT IF NOT EXECUTION PHASE
;         SB        FILE_E    Enable disk
;         SB        GETFLPTR  GET FILE PTRS FROM _n DEVICE TABLE SLOT
;         TAP       ,D
;         TPA       ,F        AUXF = END SECTOR ADDRESS OF FILE
;         SB        DREADSF   READ ENDING SECTOR OF FILE

        TEST    SL,2
        JZ      DSKIP2
        CALL    FILE_E
        CALL    GETFLPTR
        MOV     EDX,AUX0D
        MOV     AUX0F,EDX       ;AUX0F = END SECTOR ADDRESS OF FILE
        CALL    DREADSF         ;READ ENDING SECTOR OF FILE
 
;         SB        RIOBUFFR  CL = HIGH BYTE OF NO. OF SECTORS USED
;         OR        CL+,,F1
;         OR        +,,       F1,0 = NO. OF SECTORS USED -1
;         ,R        ,         CH = LOW BYTE OF NO. OF SECTORS USED
;         SC,0      CH,,F0    DECREASE ONE ?
;         SC        F1,,F1
;         BLRX      DD,F1F0,*+2         BRANCH IF NO. OF SECTORS USED > 1

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        mov     cl,[edx+1]
        mov     r1,cl
        mov     ch,[edx+2]
        mov     r0,ch

        DEC     WORD PTR R0
        CMP     WORD PTR R0,0
        JA      BP41C_03

;ERR_87A  B         ERROR_87  NO TRAILER RECORD WRITTEN
;         TAP       ,B        PC'S = START ADDRESS OF FILE
;         OR        -,,
;         ACX,0     F1F0,PHPL,PHPL
;         TPA       ,F        CURRENT ADDRESS = START + USED -2 (POINT TO TRAILER)

ERR_87A:
        JMP     ERROR_87      ;NO TRAILER RECORD WRITTEN
BP41C_03:
        MOV     EDX,AUX0B     ;AUX0B=START ADDRESS
        DEC     EDX           ;R0R1 PAIRS = USED -1
        ADD     DX,WORD PTR R0
        MOV     AUX0F,EDX     ;AUX0F= START + USED  - 2 (one header & one tailer)

;         SB        PUTCPTR   PUT CURRENT ADDRESS IN _n DEVICE TABLE SLOT
;         SB        LOADDBLK  READ TRAILER BLOCK
;         BNEH      0A,CH,ERRJUMP       ERROR IF NOT A TRAILER BLOCK
;DSKIP2   B         ENDSDISK  DISABLE DISK, EXIT
;ERRJUMP  B         ERR_87A   PUT IN FOR A PAGING ERROR 11/16/84
;DSKIP1   SB        SKBSARG   PROCESS DSKIP ARGUMENT
;         BNEL      0,F0,DSKIP3         BRANCH IF 'S' NF

        CALL    PUTCPTR
        CALL    LOADDBLK
        CMP     CH,0A0H
        JNE     ERRJUMP
DSKIP2:
        JMP     ENDSDISK
ERRJUMP:
        JMP     ERR_87A
DSKIP1:
        CALL    SKBSARG
        TEST    R0,0FH
        JNZ     DSKIP3

;*     DSKIP expression S  (SECTORS)
;*
;         SB        GETFLPTR  GET FILE PTRS FROM _n DEVICE TABLE SLOT
;         TAP       ,F        PC'S = CURRENT ADDRESS
;         ACX,0     F7F6,PHPL,PHPL      INCREMENT CURRENT ADDRESS BY SKIP COUNT
;         BTL       1,SH,DSKIP4         BRANCH IF CURRENT > FFFF
;         MVX       PHPL,F1F0 F1,0 = NEW CURRENT ADDRESS
;         BLERX     F1F0,CHCL,*+2       BRANCH IF CURRENT <= END OF FILE ADDRESS

        CALL    GETFLPTR
        MOV     EDX,AUX0F
        ADD     DX,WORD PTR R6
        JC      DSKIP4
        MOV     WORD PTR R0,DX
        CMP     WORD PTR R0,CX          ;CX = END SECTOR ADDRESS
        JBE     BP41C_04

;DSKIP4   MVX       CHCL,PHPL CURRENT ADDRESS = END OF FILE ADDRESS
;         TPA       ,F
;DSKIP7   SB        PUTCPTR   CURRENT ADDRESS --> _n DEVICE TABLE SLOT
;         B         ENDSDISK  DISABLE DISK, EXIT

DSKIP4:
        MOV     DX,CX
BP41C_04:
        MOV     AUX0F,EDX
DSKIP7:
        CALL    PUTCPTR
        JMP     ENDSDISK

;*     DSKIP expression (LOGICAL RECORDS)
;*
;DSKIP3   SB        FILE_E    Enable disk
;         SB        GETFLPTR  GET FILE PTRS
;         B         DSKIP6
;DSKIP5   SB        LOADDBLK  LOAD NEXT BLOCK
;         BEQH      0A,CH,DSKIP8        BRANCH IF TRAILER BLOCK

DSKIP3:
        CALL    FILE_E
        CALL    GETFLPTR
        JMP     DSKIP6
DSKIP5:
        CALL    LOADDBLK
        CMP     CH,0A0H
        JE      DSKIP8
;
;         BFL       1,CH,DSKIP5         BRANCH IF NOT LAST BLOCK OF LOGICAL RECORD
;         SC,0      F6,,F6
;         SC        F7,,F7    DECREMENT SKIP COUNT
;DSKIP6   BLRX      DD,F7F6,DSKIP5      BRANCH IF MORE TO SKIP
;         B         DSKIP7
;DSKIP8   TAP       ,F
;         TPA-1     ,F        DECREMENT SECTOR ADDRESS (TRAILER FOUND)
;         B         DSKIP7

        TEST    CH,1
        JZ      DSKIP5
        DEC     WORD PTR R6         ;R6R7 PAIRS ARE LOGICAL-RECORD COUNTERS
DSKIP6:
        CMP     WORD PTR R6,0
        JNZ     DSKIP5
        JMP     DSKIP7
DSKIP8:
        MOV     EDX,AUX0F
        DEC     AUX0F
        JMP     DSKIP7

;         TITLE     DBKSP (DBACKSPACE)
;*     DKBSP: PROCESS A 'DBACKSPACE' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               DBACKSPACE [file_,] BEG
;*                                   expression [S]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DBACKSPACE'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXB,C,D,E,F
;*
;         ORG       *
;DBKSP    SB        FILE_A    PROCESS _n, SPECIFICATION
;         BNEL      0,F0,*+2  Skip if _n not found
;         SB        GETCHCOM  Get comma, if _n found
;         SB        GETPLTTR  Get platter from device table
;         MVI       @BEG,F0
;         SB        CCL       LOOK FOR 'BEG'
;         BNEL      0,F0,DBKSP1         NF, BRANCH

DBKSP:
        CALL    FILE_A
        TEST    R0,0FH
        JNZ     BP41C_05

        cmp     byte ptr [textptr],','
        jnz     error_13
        inc     textptr

BP41C_05:
        CALL    GETPLTTR
        MOV     R0,@BEG
        CALL    CCL
        TEST    R0,0FH
        JNZ     DBKSP1

;*     DBACKSPACE BEG
;         BFL       2,SL,DBKSP2         Branch if not XPHASE
;DBKSP4   SB        FILE_PTR  POINT TO _n DEVICE TABLE SLOT
;         TPA+2,R   ,0
;         TAP       ,0
;         OR,W1     CH,,      CURRENT ADDRESS = START ADDRESS
;         OR,W2     CL,,
;DBKSP2   B         ENDSDISK  DISABLE DISK, EXIT
;DBKSP1   SB        SKBSARG   PROCESS DBACKSPACE ARGUMENT
;         BNEL      0,F0,DBKSP3         BRANCH IF 'S' NF

        TEST    SL,2
        JZ      DBKSP2
DBKSP4:                         ;PROCESS BEG PORTITION
        CALL    FILE_PTR
        MOV     CX,[EDX]
        MOV     [EDX+2],CX
DBKSP2:
        JMP     ENDSDISK
DBKSP1:
        CALL    SKBSARG
        TEST    R0,0FH
        JNZ     DBKSP3

;*     DBACKSPACE expression S  (SECTORS)
;         SB        FILE_PTR  POINT TO _n DEVICE TABLE SLOT
;         TPA+2,R   ,0        GET START OF FILE ADDRESS
;         TAP       ,0

        CALL    FILE_PTR
        MOV     CX,[EDX]
        XCHG    CH,CL
        ADD     EDX,2

;         MVX,R     CHCL,F3F2           F3,2 = START ADDRESS; CHCL = CURRENT ADDRESS
;         SCX,1     CHCL,F7F6,F1F0      F1,0 = CURRENT ADDRESS - BACKSPACE COUNT
;         BFL       2,SH,DBKSP4         BRANCH IF F1,0 < 0
;         BLRX      F1F0,F3F2,DBKSP4    BRACH IF NEW CURRENT ADDRESS <= START
;         OR,W1     F1,,
;         OR,W2     F0,,      NEW CURRENT ADDRESS ==> _n DEVICE TABLE SLOT
;         B         ENDSDISK  DISABLE DISK, EXIT

        MOV     WORD PTR R2,CX     ; FIRST, MOV CX TO R2R3 PAIR
        MOV     CX,[EDX]           ; SECONDLY, READ A WORD TO CX
        XCHG    CH,CL
        MOV     AX,CX              ; R6R7 PAIR = BACKSPACE COUNT
        SUB     AX,WORD PTR R6
        MOV     WORD PTR R0,AX     ;AX=R1R0=CURRENT ADDRESS - BACKSPACE CONUT
        CMP     AX,0
        JB      DBKSP4
        CMP     AX,WORD PTR R2
        JB      DBKSP4
        MOV     AX,WORD PTR R0
        XCHG    AH,AL
        MOV     [EDX],AX
        JMP     ENDSDISK

;*     DBACKSPACE expression  (LOGICAL RECORDS)
;DBKSP3   SB        GETFLPTR  GET FILE PTRS FROM _n DEVICE TABLE SLOT
;         TAP       ,F        Current sector
;         MVX       PHPL,F3F2 .
;         TAP       ,B        Start of file address
;         BLERX     F3F2,PHPL,DBKSP4    Exit if already at beginning of file
;         SB        FILE_E    Enable disk
;         B         DBKSP7

DBKSP3:
        CALL    GETFLPTR
        MOV     EDX,AUX0F           ;AUX0F=CURRENT SECTOR ADDRESS
        MOV     WORD PTR R2,DX
        MOV     EDX,AUX0B           ;AUX0B= START SECTOR ADDRESS
        CMP     WORD PTR R2,DX
        JBE     DBKSP4
        CALL    FILE_E
        JMP     DBKSP7

;DBKSP5   SC,0      F6,,F6    DECREMENT BACKSPACE COUNT
;         SC        F7,,F7
;         TAP       ,F
;         TPA-1     ,F        AUXF = SECTOR ADDRESS - 1
;         MVX       PHPL,F3F2 F3,2 = CURRENT SECTOR ADDRESS
;         TAP       ,B        PC'S = START ADDRESS OF FILE
;         BLERX     F3F2,PHPL,DBKSP4    BRANCH IF CURRENT <= START ADDRESS
;         SB        LOADDBLK  READ DATA BLOCK

DBKSP5:
        DEC     WORD PTR R6     ;R6R7 = COUNTERS
        MOV     EDX,AUX0F
        DEC     AUX0F           ;AUX0F=CURRENT - 1
        MOV     WORD PTR R2,DX  ;R2R3= CURRENT
        MOV     EDX,AUX0B       ;DX= START
        CMP     WORD PTR R2,DX
        JBE     DBKSP4
        CALL    LOADDBLK

;         BEQH      8,CH,*+2
;         B         ERROR_88  ERROR IF NOT DATA BLOCK
;         SC,1      F2,CL,PL  DECREMENT SECTOR ADDRESS BY NO. OF BLOCKS IN
;         SC        F3,,PH         LOGICAL RECORD
;         TPA       ,F        AUXF = SECTOR ADDRESS

        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,80H
        JZ      BP41C_06
        JMP     ERROR_88
BP41C_06:
        MOV     DX,WORD PTR R2
        MOV     AL,CL
        MOV     AH,0
        SUB     DX,AX
        MOV     AUX0F,EDX

;DBKSP7   BLRX      DD,F7F6,DBKSP5      BRANCH IF BACKSPACE COUNT > 0
;DBKSP6   SB        PUTCPTR   CURRENT SECTOR ADDR ==> _n DEVICE TABLE SLOT
;DBKSP8   B         ENDSDISK  DISABLE DISK, EXIT

DBKSP7:
        CMP     WORD PTR R6,0
        JNZ     DBKSP5
DBKSP6:
        CALL    PUTCPTR
DBKSP8:
        JMP     ENDSDISK

;*     LISTDC: PROCESS A 'LIST DC' STATEMENT (LIST THE
;*             CATALOG INDEX)
;*
;*          STMT FORMAT:
;*
;*               LIST [S] DC platter [ file#   [,]]  [NAME MASK] [TYPE MASK] [W]
;*                                   [disk-addr[,]]
;*
;*                  WHERE:
;*                        NAME MASK - FILE NAME MASK USING WILDCHARACTERS * ?
;*                        TYPE MASK - FILE TYPE MASK USING P D SP OR SD
;*                        W - PRINT THE LISTING IN WIDE FORMAT
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DC'
;*                 'S' PARAMETER ALREADY PROCESSED
;*                 AUX7,BIT0020 = HALT STATUS BIT AT ENTRY
;*
;*          WORKSPACE USAGE:
;*                  WORD 1 LOW BYTE = LENGTH OF NAME MASK (<=8)
;*                        HIGH BYTE = HIGH NIBBLE FILE TYPE MASK
;*                                    80 - ACTIVE PROGRAM FILES
;*                                    40 - ACTIVE DATA FILES
;*                                    20 - SCRATCH PROGRAM FILES
;*                                    10 - SCRATCH DATA FILES
;*
;*                  WORD 2 = POINTER TO FILE NAME MASK
;*
;*          REGISTER USE:
;*               F6   = NO. OF ENTRIES IN CURRENT INDEX
;*                      SECTOR THAT HAVE BEEN PROCESSED
;*               F7   = NO. OF INDEX SECTORS STILL TO BE
;*                      PROCESSED
;*               AUX8 = USED TO CALCULATE NO. OF FREE
;*                      SECTORS IN FILE
;*                      (END - START +1 - USED)
;*               AUX9 = SAVE AREA FOR NEXT INDEX SECTOR
;*                      ADDRESS
;*               AUXA = DISK DEVICE TYPE & ADDRESS
;*               AUXB = SAVE AREA FOR I/O BUFFER POINTER
;*               AUXC = I/O BUFFER POINTER
;*               AUXE = PLATTER SPECIFICATION
;*               AUXF = NEXT SECTOR ADDRESS
;*               AUX7 = HALT STATUS BIT (SH,BIT20) AT
;*                      ENTRY TO LIST DC (SET BY 'LIST')
;*               AUX3 = W OPTION FLAG
;*                      HIGH BYTE = 0 IF LIST W
;*                      HIGH BYTE = 1 IF NO LIST W
;*
;*          DESCRIPTION:
;*               1. SECTOR 0 IS READ INTO STANDARD I/O
;*                  BUFFER TO OBTAIN NO. OF INDEX SECTORS
;*                  & CATALOG LIMITS.
;*               2. THE FOLLOWING INFO. IS DISPLAYED IF NO LIST W:
;*                    "INDEX SECTORS = xx"
;*                    "END CAT. AREA = xxxx"
;*                    "CURRENT END   = xxxx"
;*               3. IF NO MORE ENTRIES IN CURRENT INDEX
;*                  SECTOR, NEXT INDEX SECTOR IS READ INTO
;*                  STANDARD I/O BUFFER.
;*               4. IF CURRENT ENTRY IS NOT USED, THE NEXT
;*                  ENTRY IS GOTTEN FROM I/O BUFFER.
;*               5A. IF MASK OPTION - FILENAME IS CHECKED AGAINST MASK. IF NOT
;*                   NOT VALID PROCEED TO STEP 4
;*                B. IF LIST W CHECK FOR ROOM ON CURRENT LINE AND ISSUE CR IF
;*                   NEEDED THEN DISPLAY FILE NAME. THEN CHECK FOR ROOM ON CURRENT
;*                   LINE  FOR TWO SPACES AND PRINT OR ISSUE A CR IF NO ROOM
;*                C. IF NO LIST W, FILENAME, TYPE, START, END VALUES ARE
;*                   DISPLAYED
;*                D. END SECTOR IS READ (INTO I/O BUFFER
;*                   AT END OF TEXT). NO. OF SECTORS USED
;*                   IS OBTAINED IF NO LIST W
;*                E. NO. OF SECTORS USED & FREE SPACE IS
;*                   DISPLAYED IF NO LIST W.
;*                F. GOTO 4.
;*
;*          NOTE: LIST DC REQUIRES AN I/O BUFFER LARGE
;*                ENOUGH FOR 2 SECTORS (512 BYTES); ERR84
;*                RESULTS IF NOT ENOUGH MEMORY. ONE IS
;*                NEEDED FOR CURRENT INDEX SECTOR; THE
;*                OTHER FOR THE END-OF-FILE SECTOR.
;*                (EOF SECTOR CONTAINS NO. OF SECTORS USED)
;*
;*          HALT/STEP PROCESSING:
;*               1. IF HALT (SH,BIT20) IS ON AT BEGIN OF
;*                  LIST DC, THE ENTIRE LISTING IS PER-
;*                  FORMED AND THEN PROGRAM EXECUTION IS
;*                  TERMINATED.
;*               2. IF HALT IS PRESSED DURING LIST DC, THE
;*                  LISTING AND PROGRAM EXECUTION IS
;*                  TERMINATED IMMEDIATELY.
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2,3
;*               AUX7,8,9,A,B,C,D,E,F IN EXEC.PHASE
;*
;         ORG       *
;LISTDC   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSEL   PROCESS #N OR /XYY PARAMETER
;         SB        FNAMASK   PROCESS FILE NAME MASK
;         SB        FTYPMASK  PROCESS FILE TYPE   IF YES,
;         SB        LISTWF    PROCESS LIST W & SET FLAG
;
;         BTL       XPHASE,SL,*+2       BRANCH IF NOT EXEUCTION PHASE
;         B         ENDSTMT   EXIT IF NOT EXECUTION PHASE

LISTDC:
        CALL    PLATTER
        CALL    DISKSEL
        CALL    FNAMASK
        CALL    FTYPMASK
        CALL    LISTWF
        TEST    SL,XPHASE
        JNZ     LISTDC10
        JMP     ENDSTMT

;LISTDC10 SB        CATENDR   READ SECTOR 0 & GET CATALOG END
;         TPA       ,8        SAVE CAT. END
;         SB        CUREND    GET CURRENT CAT. END
;         TPA       ,9        SAVE IT
;         TAP       ,ACTDEV
;         TPA       ,A        AUXA = DISK DEVICE TYPE & ADDRESS

LISTDC10:
        CALL    CATENDR
        MOV     AUX08,EDX
        CALL    CUREND
        MOV     AUX09,EDX
        MOV     EDX,ACTDEV
        MOV     AUX0A,EDX

;         SB        ENDDISKR  CLOSE DISK IF NOT OPEN BY $OPEN, CBS, OR ADDRESS
;         SB        ENBLLIST  ENABLE LIST DEVICE
;         TAP       ,03       RETRIEVE LIST W FLAG
;         BFL       1,PH,LISTW1         BRANCH IF LIST W (AUX3 = 0)
;         LPI       LDCMSG14
;         SB        WRTSTRCM
;         SB        TWRITESP  PRINT  CR & 'INDEX SECTORS = '

        CALL    ENDDISKR
        CALL    ENBLLIST
        MOV     EDX,AUX03
        TEST    DH,1
        JZ      LISTW1
        MOV     EDX,OFFSET LDCMSG14
        CALL    WRTSTRCM
        CALL    TWRITESP

;LISTW1   SB        RIOBUFFR  GET NO. OF INDEX SECTORS FROM SECTOR 0
;         MV        CL,F0     F1,0 = NO. OF INDEX SECTORS
;         MVI       0,F1
;         MV        CL,F7     F7 = NO. OF INDEX SECTORS
;         TAP       ,03       RETRIEVE LIST W FLAG
;         BTL       1,PH,LISTW2         BRANCH IF NO LIST W
;         BER       F7,,LISTDC6         BRANCH IF NO INDEX SECTORS
;         B         LISTW3    BRANCH IF LIST W

LISTW1:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     R0,CL
        MOV     R1,0
        MOV     R7,CL
        MOV     EDX,AUX03
        TEST    DH,1
        JNZ     LISTW2
        CMP     R7,0
        JZ      LISTDC6
        JMP     LISTW3

;LISTW2   SB        WRTVALA   PRINT NO. OF INDEX SECTORS
;         BER       F7,,LISTDC6         BRANCH IF NO INDEX SECTORS (RELEASE 1.5)
;         BNEH      0,CH,LISTDC14       HASH INDICATOR = 01?
;         BNEL      1,CH,LISTDC14       NO - BRANCH
;         MVI       X'27',K   YES - DISPLAY ' AFTER INDEX SECTORS
;         SB        TWRITE

LISTW2:
        CALL    WRTVALA
        CMP     R7,0
        JZ      LISTDC6
        CMP     CH,01H
        JNZ     LISTDC14
        MOV     K,27H
        CALL    TWRITE

;LISTDC14 LPI       LDCMSG15
;         SB        WRTSTRCM
;         SB        TWRITESP  PRINT CR & 'END CAT. AREA = '
;         TAP       ,8        GET END OF CATALOG AREA ADDRESS
;         MVX       PHPL,F1F0 F1,0 = END CAT. AREA
;         SB        WRTVALA   PRINT END OF CAT. AREA VALUE
;         LPI       LDCMSG16
;         SB        WRTSTRCM
;         SB        TWRITESP  PRINT 'CURRENT END = '

LISTDC14:
        MOV     EDX,OFFSET LDCMSG15
        CALL    WRTSTRCM
        CALL    TWRITESP
        MOV     EDX,AUX08
        MOV     WORD PTR R0,DX
        CALL    WRTVALA
        MOV     EDX,OFFSET LDCMSG16
        CALL    WRTSTRCM
        CALL    TWRITESP

;         TAP       ,9        GET CURRENT END OF CAT. AREA INFO. ADDR
;         MVX       PHPL,F1F0 F1,0 = CURRENT END OF CAT. AREA
;         SB        WRTVALA   PRINT CURRENT END VALUE
;         LPI       LDCMSG7
;         SB        WRTSTRCM  PRINT HEADING (NAME TYPE START END USED FREE)

        MOV     EDX,AUX09
        MOV     WORD PTR R0,DX
        CALL    WRTVALA
        MOV     EDX,OFFSET LDCMSG7
        CALL    WRTSTRCM

;LISTW3   MVI       0,F6      NO. OF ENTRIES PROCESSED = 0
;         SB        RIOBUFRH
;         MVI       06,PL     POINT TO 'IOBUFFER+6'
;         TPA       ,C
;LISTDC7  TAP       ,C
;         OR,0      F0,,      CARRY OFF
;         ACI       0A,PL,PL

LISTW3:
        MOV     R6,0
        MOV     EDX,DWORD PTR [CPBASE]   ;THIS SUBR DOES NOT SET PL
        LEA     EDX,[EDX].@IOBUFFR
        ADD     EDX,6
        MOV     AUX0C,EDX
LISTDC7:
        MOV     EDX,AUX0C
        ADD     EDX,0AH

;LISTDC8  ACI       0,PH,PH
;         TPA       ,C        AUXC POINT TO NEXT ENTRY IN INDEX SECTOR
;LISTDC2  AC,,1     F6,,F6    INCREMENT NO. OF ENTRIES PROCESSED
;LISTDC4  BEQH      0,F6,LISTDC3        BRANCH IF < 16 ENTRIES PROCESSED
;         SC,0      F7,,F7    DECREMENT NO. OF INDEX SECTORS
;         BER       F7,,LISTDC6         EXIT IF NO MORE TO INDEX
;         TAP       ,A

LISTDC8:
        MOV     AUX0C,EDX
LISTDC2:
        INC     R6
LISTDC4:
        TEST    R6,0F0H
        JZ      LISTDC3
        DEC     R7
        JZ      LISTDC6
        MOV     EDX,AUX0A

;         SB        ENBLDEVD  ENABLE DISK
;         SB        DREADSF   READ NEXT INDEX SECTOR
;         SB        ENDDISKR  CLOSE DISK IF NOT HOGGED
;         SB        ENBLLIST  ENABLE LIST DEVICE
;         MVI       0,F6      NO. OF ENTRIES PROCESSED = 0
;         B         LISTDC4

        CALL    ENBLDEVD
        CALL    DREADSF
        CALL    ENDDISKR
        CALL    ENBLLIST
        MOV     R6,0
        JMP     LISTDC4

;LISTDC3  TAP       ,C
;         TPA+2,R   ,C        GET STATUS & FILE TYPE OF NEXT ENTRY
;         OR,0      F0,,      CARRY OFF
;         BEQH      1,CH,LISTDC5        BRANCH IF ENTRY IS USED
;         ACI       10,PL,PL
;         B         LISTDC8

LISTDC3:
        MOV     EDX,AUX0C
        MOV     CX,[EDX]   ;READ ONE WORD --- STATUS FOR ONE BYTE
        XCHG    CH,CL      ;                  TYPE FOR ANOTHER BYTE
        ADD     AUX0C,2
        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,10H
        JZ      LISTDC5
        ADD     EDX,10H
        JMP     LISTDC8

;*%    PROCESS NEXT ENTRY
;LISTDC5  MVX       CHCL,F5F4 F5 = ENTRY STATUS; F4 = FILE TYPE
;         ACI       8,PL,PL
;         ACI       0,PH,PH   POINT TO FILE NAME
;*
;*        THE FOLLOWING CODE IS INSERTED JUST PRIOR TO PRINTING THE FILENAME.
;*        THIS SECTION CHECKS IF THE MASK OPTION HAS BEEN INVOKED.
;*

LISTDC5:
        MOV     WORD PTR R4,CX  ; SAVE FILE TYPE & STATUS  IN R4,R5
        ADD     EDX,08H         ; POINT TO FILE NAME

;         XPA       ,1        AUX 1 PTS TO FILENAME
;         TPS       ,         OLD AUX 1 ON STACK
;         SB        RWORKSPC  POINT AT WORKSPACE
;         OR,R      F0,,      READ FILE TYPE MASK AND
;*                                                  FILENAME MASK LENGTH
;         MV        CL,F2     FILE NAME MASK LENGTH
;         MV        CH,F3     FILE TYPE MASK
;         BNR       F2,,LISTDC11        BR IF FILE NAME MASK OPTION

        XCHG    EDX,AUX01
        PUSH    EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     R2,CL           ;SAVE FILE NAME MASK LEN IN R2
        MOV     R3,CH           ;SAVE FILE TYPE MASK IN R3
        CMP     R2,0
        JNZ     LISTDC11

;*        CHECK FILE TYPE MASK
;
;LISTDC12 SB        FTMATCH   MATCH?
;         BER       F3,,LISTDC22        NO MATCH - JUMP
;
;*        FILE TYPES MATCH
;
;         TSP       ,
;         TPA       ,1
;         TAP       ,0C       RESTORE PTR TO INDEX ENTRY

LISTDC12:
        CALL    FTMATCH
        CMP     R3,0
        JZ      LISTDC22
        POP     EDX
        MOV     AUX01,EDX
        MOV     EDX,AUX0C

;         ACI       6,PL,PL
;         ACI       0,PH,PH
;         MVI       8,F0
;         XPA       ,03       GET LIST W FLAG
;         MV        PH,F3     SAVE W FLAG

        ADD     EDX,06H         ;AUX0C HAS BEEN ADDED 2 PREVIOUSLY
        MOV     R0,8
        XCHG    EDX,AUX03
        MOV     R3,DH           ;R3 SAVE LIST W FLAG

;         XPA       ,03       RESTORE PC
;         BTL       1,F3,LISTW4         BRANCH IF NO LIST W
;         XPA       ,CHARCNT  GET CURRENT CHAR COUNT
;         MVX       PHPL,F3F2 SAVE WIDTH & CHAR COUNT
;         XPA       ,CHARCNT  RESTORE PC
;         AI        8,F2,F2   ADD FILE LGTH TO CHAR COUNT

        XCHG    EDX,AUX03
        TEST    R3,1
        JNZ     LISTW4
        XCHG    EDX,CHARCNT
        MOV     WORD PTR R2,DX
        XCHG    EDX,CHARCNT
        ADD     R2,8

;         BLER      F2,F3,*+2 ROOM ON CURRENT LINE SKIP CR
;         SB        PRNTCR
;         SB        WRTBLK    DISPLAY FILENAME
;         TAP       ,CHARCNT  GET NEW CHAR COUNT
;         MVX       PHPL,F3F2
;         AI        2,F2,F2   ADD SPACES TO CHAR COUNT

        MOV     AL,R2
        CMP     AL,R3
        JBE     BP41_02         ;UNSIGNED NUMBERS COMPARE
        CALL    PRNTCR
BP41_02:
        CALL    WRTBLK
        MOV     EDX ,CHARCNT
        MOV     WORD PTR R2,DX
        ADD     R2,2

;         BLER      F2,F3,*+2 ROOM ON CURRENT LINE SKIP CR
;         SB        PRNTCR
;         TAP       ,CHARCNT  GET NEW CHAR COUNT
;         MV        PL,F2
;         BER       F2,,*+2   SKIP SPACES IF BEGINNING OF LINE

        MOV     AL,R2
        CMP     AL,R3
        JLE     BP41_03
        CALL    PRNTCR
BP41_03:
        MOV     EDX,CHARCNT
        MOV     R2,DL
        CMP     R2,0
        JZ      BP41_04

;         SB        TWRIT2SP
;         TAP       ,C
;         TPA+2     ,C        SAVE START ADDRESS OF FILE
;         TAP       ,C
;         TPA+2     ,B        SAVE END ADDRESS OF FILE
;         B      LISTW5

        CALL    TWRIT2SP
BP41_04:
        ADD     AUX0C,2
        MOV     EDX,AUX0C
        MOV     AUX0B,EDX
        ADD     AUX0B,2
        JMP     LISTW5

;LISTW4   SB        WRTBLK    PRINT FILE NAME
;         SB        TWRIT2SP  PRINT 2 SPACES
;         MVI       20,K
;         BEQL      0,F5,LISTDC9
;         MVI       C'S',K
;         BEQL      1,F5,LISTDC9
;         MVI       C'?',K    UNDEFINED ENTRY TYPE (RELEASE 1.5)

LISTW4:
        CALL    WRTBLK
        CALL    TWRIT2SP
        MOV     K,20H
        TEST    R5,0FH
        JZ      LISTDC9
        MOV     K,'S'
        MOV     AL,R5
        AND     AL,0FH
        CMP     AL,1
        JZ      LISTDC9
        MOV     K,'?'

;LISTDC9  SB        TWRITE    PRINT 'S' IF FILE SCRATCHED
;         MVI       C'P',K
;         BEQH      8,F4,LISTDC1
;         MVI       C'D',K
;         BEQH      0,F4,LISTDC1
;         MVI       C'?',K    UNDEFINED FILE TYPE (RELEASE 1.5)

LISTDC9:
        CALL    TWRITE
        MOV     K,'P'
        MOV     AL,R4
        AND     AL,0F0H
        CMP     AL,80H
        JZ      LISTDC1
;cs-386 format
        cmp     al,40h
        jz      listdc1
;
        MOV     K,'D'
        TEST    R4,0F0H
        JZ      LISTDC1
        MOV     K,'?'

;LISTDC1  SB        TWRITE    PRINT 'D' IF DATA FILE; 'P' IF PROGRAM FILE
;         SB        TWRIT3SP  PRINT 3 SPACES
;         TAP       ,C
;         TPA+2,R   ,C        GET START ADDRESS OF FILE
;         MVX       CHCL,F1F0

LISTDC1:
;
; cs-386 fommat
;
        push    eax
        push    ebx
        mov     eax,dword ptr [cpbase]
        mov     bl,k
        mov     byte ptr [eax].@spreg7,bl
        pop     ebx
        CALL    TWRITE
        pop     eax
        cmp     al,40h
        jnz     listdc386
        mov     k,27h
        call    twrite
        call    twrit2sp
        jmp     listdc386_1
listdc386:
        CALL    TWRIT3SP
listdc386_1:
        MOV     EDX,AUX0C
        MOV     CX,[EDX]
        XCHG    CH,CL
        ADD     AUX0C,2
        MOV     WORD PTR R0,CX

;         TAP       ,A
;         BEQL      #PHOENIX,PH,*+2
;         ANDI      7F,F1,F1  STRIP OFF 16TH BIT IF DIABLO/FLOPPY
;         MVX       F1F0,PHPL
;         TPA       ,8        AUX8 = START ADDRESS OF FILE

        MOV     EDX,AUX0A
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      BP41_05
        AND     R1,07FH
BP41_05:
        MOV     DX,WORD PTR R0
        MOV     AUX08,EDX

;         SB        WRTVALA   PRINT START ADDRESS
;         SB        TWRIT2SP  PRINT 2 SPACES
;         TAP       ,C
;         TPA+2,R   ,B        GET END ADDRESS OF FILE; AUXB = IO BUFFER POINTER
;         MVX       CHCL,F1F0
;         TAP       ,A
;         BEQL      #PHOENIX,PH,*+2

        CALL    WRTVALA
        CALL    TWRIT2SP
        MOV     EDX,AUX0C
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     AUX0B,EDX
        ADD     AUX0B,2
        MOV     WORD PTR R0,CX
        MOV     EDX, AUX0A
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      BP41_01

;         ANDI      7F,F1,F1  STRIP OFF 16TH BIT IF DIABLO/FLOPPY
;         TAP       ,8
;         SCX,1     F1F0,PHPL,PHPL
;         TPA+1     ,8        AUX8 = END - START + 1
;         SB        WRTVALA   PRINT END ADDRESS OF FILE
;         SB        TWRIT2SP  PRINT 2 SPACES

        AND     R1,7FH
BP41_01:
        MOV     EDX,AUX08
        MOV     AX,WORD PTR R0
        SUB     AX,DX           ;2200 INSTR. SCX IF X=0 1'S COMPLEMENT
        MOV     DX,AX           ;                   X=1 2'S COMPLEMENT
        MOV     AUX08,EDX
        INC     AUX08           ;AUX08 =END -START +1
        CALL    WRTVALA
        CALL    TWRIT2SP

;LISTW5   TAP       ,F
;         TPA       ,9        SAVE ADDRESS OF NEXT SECTOR ADDRESS
;         MVI       1,F2
;         SB        IOBUFTXT  POINT TO I/O BUFFER AT END OF TEXT
;         TPA       ,F        AUXF = ADDRESS OF I/O BUFFER FOR EOF SECTOR
;         TPA+1     ,C        AUXC = ADDRESS OF I/O BUFFER FOR EOF SECTOR +1
;         TAP       ,03       RETRIEVE LIST W FLAG

LISTW5:
        MOV     EDX,AUX0F
        MOV     AUX09,EDX
        MOV     R2,1
        CALL    IOBUFTXT
        MOV     AUX0F,EDX
        MOV     AUX0C,EDX
        INC     AUX0C
        MOV     EDX,AUX03

;         BTL       1,PH,LISTW6         BRANCH IF NO LIST W FLAG
;         TAP       ,9
;         TPA       ,F        RESTORE AUXF TO ADDR OF NEXT INDEX SECTOR
;         TAP       ,B
;         XPA       ,C        RESTORE AUXC-POINTS AFTER END ADDR OF CURRENT SECTOR
;         B         LISTDC13  JUMP TO END OF PRINT ROUTINE

        TEST    DH,1
        JNZ     LISTW6
        MOV     EDX,AUX09
        MOV     AUX0F,EDX
        MOV     EDX,AUX0B
        XCHG    EDX,AUX0C
        JMP     LISTDC13

;LISTW6   TAP       ,A
;         SB        ENBLDEVD  ENABLE DISK
;         MVX       CHCL,PHPL PHPL = ADDRESS OF END OF FILE SECTOR
;         SB        DREAD     READ END OF FILE SECTOR
;         TAP       ,9
;         TPA       ,F        RESTORE AUXF TO ADDRESS OF NEXT INDEX SECTOR
;         SB        ENDDISKR  CLOSE DISK IF NOT HOGGED
;         SB        ENBLLIST  ENABLE LIST DEVICE

LISTW6:
        MOV     EDX,AUX0A
        CALL    ENBLDEVD
        MOV     DX,CX
        CALL    DREAD
        MOV     EDX,AUX09
        MOV     AUX0F,EDX
        CALL    ENDDISKR
        CALL    ENBLLIST

;         TAP       ,B
;         XPA       ,C        RESTORE AUXC; POINTS AFTER END ADDRESS IN CUR. SCTR
;         OR,R      +,,
;         MV,R      CH,F1     F1,0 = NO. OF SECTORS USED IN FILE
;         MV        CH,F0
;         TAP       ,8
;         MVX       PHPL,F3F2
;         SCX,1     F3F2,F1F0,PHPL
;         TPA       ,8        AUX8 = END - START +1 - USED = FREE

        MOV     EDX,AUX0B
        XCHG    EDX,AUX0C
        mov     aux0b,edx
        add     aux0b,6
        MOV     CH,[EDX]
        MOV     R1,CH
        INC     EDX
        MOV     CH,[EDX]
        MOV     R0,CH
        MOV     EDX,AUX08
        SUB     DX,WORD PTR R0
        MOV     AUX08,EDX

;         SB        WRTVALA   PRINT NO. OF SECTORS USED
;         SB        TWRIT2SP  PRINT 2 SPACES
;         TAP       ,8
;         MVX       PHPL,F1F0 F1,0 = NO. OF FREE SECTORS
;         SB        WRTVALA   PRINT NO. OF FREE SECTORS
;         SB        PRNTCR    PRINT CR
;LISTDC13 BFH       2,SH,LISTDC7        BRANCH IF NOT HALT/STEP
;LISTDC6  SB        CPRNTCR   ISSUE CR TO END LIST W
;         B         LISTEND

        CALL    WRTVALA
        CALL    TWRIT2SP
        MOV     EDX,AUX08
        MOV     WORD PTR R0,DX
        CALL    WRTVALA

        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@spreg6,1
        JNE     xxxxx
        cmp     byte ptr [eax].@spreg7,"P"
        jne     xxxxx

        call    twrit2sp

        mov     edx,aux0b
        inc     aux0b
        cmp     byte ptr [edx],01h
        jne     write_end
        mov     r0,14
write_again:
        mov     edx,aux0b
        inc     aux0b
        mov     ch,byte ptr [edx]
        mov     k,ch
        call    twrite
        dec     r0
        jnz     write_again
write_end:
xxxxx:
        CALL    PRNTCR
LISTDC13:
        TEST    SH,20H        ;**************************************
        JZ      LISTDC7       ; HOW TO CHECK HALT/STEP KEY PRESSED ?
LISTDC6:
        CALL    CPRNTCR
        JMP     LISTEND

;*        THE FOLLOWING CODE CALLS THE ROUTINE TO DETERMINE WHETHER THE FILENAME
;*        PASSES THE MASK.  IF YES, THEN IT SETS UP FOR PRINTING THE DATA,
;*        OTHERWISE, IT BY PASSES THE PRINT LOGIC.
;*
;LISTDC11 OR        CL+,,F0   LENGTH OF MASK- PC'S POINT AF FILE MASK PTR
;         OR        +,,
;         OR,R      F0,,      READ FILE MASK PTR
;         MVX       CHCL,PHPL PC'S = FILE MASK PTR
;         XPA       ,0
;         TPS       ,         SAVE AUX 0
;         SB        MASKCOMP  PERFORM COMPARISON
;         TSP       ,         RESTORE AUX 0
;         TPA       ,0
;         BER       F0,,LISTDC12        IF F0=0, THEN MATCH FOUND

LISTDC11:
        MOV     R0,CL
        ADD     EDX,2
        MOV     ECX,[EDX]
        MOV     EDX,ECX
        XCHG    EDX,AUX00
        PUSH    EDX
        CALL    MASKCOMP
        POP     EDX
        MOV     AUX00,EDX
        CMP     R0,0
        JZ      LISTDC12

;LISTDC22 TSP       ,         RESTORE AUX 1
;         TPA       ,1
;         XPA       ,0C       PT PASS ENTRY IN INDEX
;         XPA+2     ,0C
;         XPA       ,0C
;         XPA+2     ,0C
;         B         LISTDC13

LISTDC22:
        POP     EDX
        MOV     AUX01,EDX
        ADD     AUX0C,4
        JMP     LISTDC13

;*        LISTWF:  TEST FOR INPUT OF W OPTION AFTER LISTDC TO PRINT A WIDE LISTING
;*                 THE W OPTION FLAG IS SET IN THE HIGH BYTE OF AUX3
;*                 HIGH BYTE = 0 IF LIST W OR = 1 IF NO LIST W
;*
;*                 MODIFIED REGISTERS F0,PHPL,CHCL,AUX3
;*
;LISTWF   MVI       C'W',F0   SET CHAR TO LOOK FOR
;         SB        NXTCH     GET NEXT CHAR & VERIFY
;         MV        F0,PH     W FLAG RECEIVED IN F0
;         TPA       ,03       SAVE W FLAG
;         SR

LISTWF: MOV     DH,1
        CMP     BYTE PTR [TEXTPTR],'W'
        JNE     LISTWF1X
        INC     TEXTPTR
        MOV     DH,0
LISTWF1X:
        MOV     AUX03,EDX
        RET

;         TITLE     ADDIFILE
;*     ADDIFILE: ADD A FILE TO DISK PLATTER INDEX
;*
;*          DESCRIPTION:
;*               A. OVERWRITING AN OLDFILE
;*                    1. NEWFILE ENTRY IS ADDED TO INDEX
;*                    2. IF OLDNAME <> NEWNAME, OLDFILE
;*                       INDEX ENTRY IS DISABLED ( ENTRY
;*                       STATUS = 21)
;*
;*               B. CREATING A NEWFILE
;*                    1. NEWFILE ENTRY IS ADDED TO INDEX
;*                    2. UPDATE CURRENT END OF CATALOG
;*                       AREA IN SECTOR 0 TO END OF NEWFIL
;*
;*          ENTRY:
;*               ENOUGH ROOM EXISTS IN CAT. AREA FOR FILE
;*               EXECUTION PHASE
;*               F7 = FILETYPE (00 IF DATA, 80 IF PROGRAM)
;*               FILENAME (WITH TRAILING SPACES) IN WORKSPACE
;*               I/O BUFFER CONTAINS INDEX SECTOR WITH
;*                    ENTRY FOR NEWFILE
;*               AUXC = ADDRESS OF ENTRY FOR NEWFILE IN
;*                      I/O BUFFER
;*               AUXF = SECTOR ADDRESS OF INDEX SECTOR
;*                      WITH ENTRY FOR NEWFILE
;*               AUXB = START ADDRESS OF FILE
;*               AUXD = END ADDRESS OF FILE
;*               AUXE = FILE#,PLATTER,R/W,ETC
;*               AUXA = 0 IF OVERWRITING AN OLDFILE
;*                      1 IF OVERWRITING SAME FILE
;*                      2 IF CREATING NEW FILE (WITH
;*                        EXTRA SPACE)
;*                      3 IF CREATING NEW FILE (NO EXTRA
;*                        SPACE)
;*
;*               IF OVERWRITING AN OLDFILE,
;*                    AUX8 = SECTOR ADDRESS OF INDEX
;*                           SECTOR WITH OLDFILE ENTRY
;*                    AUX9 = ADDRESS OF OLDFILE ENTRY WHEN
;*                           LOADED INTO I/O BUFFER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-3
;*                              AUX0,1,C,F
;         EJECT
;*     ADD NEWFILE ENTRY TO INDEX
;*
;         ORG       *
;ADDIFILE TAP       ,C        POINT TO ENTRY IN I/O BUFFER TO BE UPDATED
;         ORI,W1    10,,      ENTRY STATUS (ACTIVE FILE) ==> I/O BUFFER
;         XPA+2,W2  F7,B      FILE TYPE ==> I/O BUFFER
;         MVX       PHPL,F1F0 F1,0 = START ADDRESS OF FILE

ADDIFILE:
        MOV     EDX,AUX0C               ;AUX09,0C ====> DWORD
        MOV     BYTE PTR [EDX],10H      ;AUX08,0A,0B,0D,0E,0F ====> WORD
        MOV     AL,R7
        MOV     BYTE PTR [EDX+1],AL

        add     edx,2
        mov     eax,aux0b
        xchg    ah,al
        mov     word ptr [edx],ax

;         XPA       ,B
;         OR,W1     F1,,      START ADDRESS ==> I/O BUFFER
;         XPA+2,W2  F0,D
;         MVX       PHPL,F3F2 F3,2 = END OF FILE ADDRESS

        add     edx,2
        mov     eax,aux0d
        MOV     WORD PTR R2,ax

;         XPA       ,D
;         OR,W1     F3,,      END ADDRESS ==> I/O BUFFER
;         XPA+2,W2  F2,C
;         TAP       ,C
;         TPA+2     ,C


        xchg    ah,al
        mov     word ptr [edx],ax
        add     edx,4
        mov     edi,edx

;         SB        RWORKSPC  POINT TO WORKSPACE
;         XPA+1,R   ,C
;         XPA+1,W1  CH,C      FILENAME ==> I/O BUFFER
;         BNEL      8,PL,*-2
;         SB        DWRITE$F  WRITE INDEX SECTOR TO DISK


        mov     edx,dword ptr [cpbase]
        lea     esi,[edx].@workspc
        mov     ecx,8
        rep     movsb

        CALL    DWRITE?DAF

;         TAP       ,A
;         BFL       2,PL,ADDFILE1       BRANCH IF OLDFILE WAS SPECIFIED
;*     CREATING A NEW FILE
;         SB        DREADS0   READ SECTOR 0 FROM DISK
;         SB        RIOBUFRH  PC'S POINT TO CURRENT END OF CAT. AREA
;         MVI       2,PL

        MOV     EDX,AUX0A
        TEST    DL,2
        JZ      ADDFILE1
        CALL    DREADS0

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

        ADD     EDX,2

;         AC,W2,1   F2,,      END OF FILE ADDRESS + 1 ==> I/O BUFFER (NEXT
;         AC,W1     F3,,           AVAILABLE SECTOR IN CATALOG AREA)
;         ANDX      DD,DK,PHPL    SECTOR ADDRESS = 0
;         TPA       ,F
;         B         DWRITE$F  WRITE UPDATED SECTOR 0

        mov     ax,word ptr r2
        inc     ax
        xchg    ah,al
        mov     [edx],ax

        MOV     AUX0F,0
        JMP     DWRITE?DAF

;*     OVERWRITING OLDFILE
;ADDFILE1 BEQL      0,PL,*+2  BRANCH IF NOT OVERWRITING SAME FILE
;ADDFILE2 SR
;         TAP       ,8        PC'S = SECTOR ADDR OF INDEX SECTOR WITH OLDFIL
;         TPA       ,F
;         SB        DREADSF   READ INDEX SECTOR WITH OLDFILE NAME
;         TAP       ,9        POINT TO FILENAME ENTRY WITH NAME
;         ,R        ,         GET INDEX ENTRY STATUS

ADDFILE1:
        TEST    DL,0FH
        JZ      BP41K_02
ADDFILE2:
        RET
BP41K_02:
        MOV     EDX,AUX08
        MOV     AUX0F,EDX
        CALL    DREADSF
        MOV     EDX,AUX09
        MOV     CH,[EDX]

;         BEQL      0,CH,ADDFILE2       BRANCH IF ACTIVE FILE (IMPLIES OLDNAME =
;*_     NEWNAME)
;         ORI,W1    21,,      ENTRY STATUS = ENTRY DISABLED
;         TAP       ,8
;         TPA       ,F        AUXF = SECTOR ADDRESS OF SECTOR BEING UPDATED
;         B         DWRITE$F  WRITE INDEX SECTOR

        TEST    CH,0FH
        JZ      ADDFILE2
        MOV     BYTE PTR [EDX],21H
        MOV     EDX,AUX08
        MOV     AUX0F,EDX
        JMP     DWRITE?DAF

;         TITLE     ADDFILE
;*     ADDFILE: ADD A FILE TO DISK PLATTER & WRITE END-
;*              OF-FILE (EOF) SECTOR
;*
;*          ENTRY: SAME AS 'ADDIFILE' EXCEPT--
;*                 AUX7 = ADDRESS OF TRAILER BLOCK
;*                        (PROGRAM FILES ONLY)
;*
;*          RETURN: SAME AS 'ADDIFILE'
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-3
;*                              AUX0,1,C,F
;*
;         ORG       *
;ADDFILE  SB        ADDIFILE  ADD ENTRY TO INDEX
;         BEQH      0,F7,*+3  BRANCH IF DATA FILE
;         TAP       ,7        PC'S = ADDRESS OF PROGRAM TRAILER RECORD
;         B         WRTEOF    WRITE PROGRAM EOF BLOCK
;         B         WRTEOF1   WRITE DATA EOF BLOCK, NO. OF SECTORS USED = 1

ADDFILE:
        CALL    ADDIFILE
        TEST    R7,0F0H
        JZ      BP41K_03
        MOV     EDX,AUX07
        JMP     WRTEOF
BP41K_03:
        JMP     WRTEOF1

;         TITLE     INTINDX
;*     INTINDX: INITIALIZE DISK PLATTER INDEX (READ-AFTER-
;*              WRITE PERFORMED ONLY IF SPEC. IN AUXE)
;*
;*          ENTRY: PHASE = EXECUTION
;*               F4 = NO. OF INDEX SECTORS
;*               F3,2 = CATALOG END + 1 ADDRESS
;*               AUXE = PLATTER, R/W SPEC.
;*               DISK ENABLED
;*
;*          RETURN:
;*               INDEX ZEROED
;*               SECTOR 0 HAS NO. OF SECTORS
;*                            CURRENT END +1 (= NO. SCTRS)
;*                            END CAT. AREA +1
;*               I/O BUFFER ZEROED
;*               F4 = 0
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1,4
;*                              AUX0,1,F
;*
;*
;         ORG       *
;INTINDX  MVX       F3F2,PHPL
;         TPA-1     ,F
;         SB        DREADSF   READ LAST SECTOR OF CAT. AREA (TO BE SURE ITS ON
;*_     THE PLATTER)
;         MVX       F3F2,PHPL
;         TPA-1     ,F        Write sector logic added REL. 1.9.
;         SB        DWRITE$F  write it also -- to be sure it's possible
;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         SB        ZERO256   ZERO BUFFER

INTINDX:
        MOV     DX,WORD PTR R2
        MOV     AUX0F,EDX
        DEC     AUX0F
        CALL    DREADSF
        MOV     DX,WORD PTR R2
        MOV     AUX0F,EDX
        DEC     AUX0F
        CALL    DWRITE?DAF              ;MAKE SURE THAT THIS SECTOR CAN BE READ & WRITTEN

        mov     eax,0
        mov     edx,dword ptr [cpbase]
        lea     edi,[edx].@iobuffr
        mov     ecx,64
        rep     stosd

;         SB        RHASHFLG  get hash flag
;         MV        CH,F0     Put flag in F0
;         SB        RIOBUFFR  Point to I/O buffer
;         OR,W1     +,F0,     Type of hashing ==> buffer
;         OR,W1,0   +,F4,     Number of index sectors ==> buffer
;         AC,W1     +,,       Save the number of index sectors
;             to provide the next available sector

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@hashfl
        mov     ch,[edx]
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

        MOV     BYTE PTR [EDX],ch
        INC     EDX
        MOV     AL,R4
        MOV     BYTE PTR [EDX],AL
        INC     EDX
        MOV     BYTE PTR [EDX],0
        INC     EDX

;         Next availble sector ==> buffer
;         OR,W1     +,F4,        (First sector after index)
;         OR,W1     +,F3,
;         OR,W1     +,F2,     CATALOG END + 1 --> BUFFER
;         ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,F        AUXF = SECTOR ADDRESS TO WRITE TO (0)

        MOV     AL,R4
        MOV     BYTE PTR [EDX],AL
        INC     EDX

        mov     ax,word ptr r2
        xchg    ah,al
        mov     [edx],ax
        add     edx,2

        MOV     AUX0F,0

;INTINDX1 SB        DWRITE$F  WRITE INDEX SECTOR; READ-AFTER-WRITE
;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         OR,W1     +,,       ZERO BUFFER
;         BNEL      0,PL,*-1  (ONLY NEED TO ZERO 1ST 6 BYTES)
;         SC,0      F4,,F4    DECREMENT NO. OF INDEX SECTORS COUNT
;         BNR       F4,,INTINDX1        BRANCH IF MORE TO INDEX
;         SR

INTINDX1:
        CALL    DWRITE?DAF

        mov     edx,dword ptr [cpbase]
        lea     edi,[edx].@iobuffr

        mov     eax,0
        mov     ecx,40h         ;ZERO BUFFER  ?? WHY
        rep     stosd

        DEC     R4
        JNZ     INTINDX1
        RET

;         TITLE     NEWEOF
;*     NEWEOF: IF CREATING A NEW FILE,
;*             ADD NO. OF EXTRA SECTORS TO RESERVE FOR
;*             FILE TO CURRENT EOF ADDRESS & MAKE SURE
;*             NEW EOF <= END OF CATALOG AREA.
;*
;*          ENTRY: PHASE = EXECUTION
;*               AUXA = 0 IF OVERWRITING AN OLDFILE
;*                      1 IF OVERWRITING SAME FILE
;*                      2 IF CREATING NEW FILE (WITH EXTRA
;*                        SPACE)
;*                        (EXTRA SPACE IN VS -- FL.PT.)
;*                      3 IF CREATING NEW FILE (WITH NO
;*                        EXTRA SPACE SPECIFIED)
;*               DISK ENABLED
;*               AUXE = PLATTER SPECIFICATION
;*               AUXD = CURRENT EOF ADDRESS
;*
;*          RETURN (IF CREATING NEW FILE):
;*               AUXD = NEW EOF (AUXD + EXTRA SECTORS)
;*               PC'S = OLD EOF (AUXD)
;*
;*          ERROR CONDITIONS:
;*               18 = NO. OF EXTRA SECTORS <0 OR >65535
;*               86 = NEW EOF > END CAT. AREA
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-2
;*                              AUX0,C,D,F
;*
;         ORG       *
;NEWEOF   TAP       ,A
;         BFL       2,PL,NEWEOF3        BRANCH IF NOT CREATING A NEW FILE
;         SB        DREADS0   READ SECTOR 0
;         XORX      F1F0,F1F0,F1F0      NO. OF EXTRA SECTORS = 0
;         TAP       ,A
;         BNEL      2,PL,NEWEOF2        BRANCH IF NO EXTRA SECTORS SPECIFIED
;         SB        FLTBINB   CONVERT EXTRA SECTORS TO BINARY

NEWEOF:
        MOV     EDX,AUX0A
        TEST    DL,2
        JZ      NEWEOF3
        CALL    DREADS0
        MOV     WORD PTR R0,0   ;R0R1 =  NUMBER OF EXTRA SECTORS
        MOV     EDX,AUX0A
        CMP     DL,2
        JNE     NEWEOF2
        CALL    FLTBINB

;NEWEOF2  TAP       ,D        PC'S = CURRENT EOF
;         ACX,0     F1F0,PHPL,F1F0      F1,0 = CURRENT EOF + EXTRA SECTORS
;         BTL       1,SH,NEWEOF1        BRANCH IF > FFFF
;         SB        CATEND    GET END OF CAT. AREA ADDRESS
;         BLERX     F1F0,PHPL,*+2       ERROR IF EOF > END CAT. AREA

NEWEOF2:
        MOV     EDX,AUX0D
        ADD     WORD PTR R0,DX
        JC      NEWEOF1
        CALL    CATEND
        CMP     DX,WORD PTR R0
        JAE     BP41K_04

;NEWEOF1  B         ERROR#86  CATALOG END ERROR
;         MVX       F1F0,PHPL
;         XPA       ,D        AUXD = NEW EOF; PC'S = OLD EOF
;NEWEOF3  SR

NEWEOF1:
        JMP     ERROR_86
BP41K_04:
        MOV     DX,WORD PTR R0
        XCHG    EDX,AUX0D
NEWEOF3:
        RET

;         TITLE     FILELOC
;*     FILELOC: SCAN & PROCESS THE FILE LOCATION PARAMETER
;*              (FILENAME OR EXPRESSION). CALLED BY
;*              'DATASAVE DC OPEN'
;*
;*          FORMAT:  ( filename )
;*                   filename
;*                   ( expression )
;*                   expression
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = PLATTER / FILE#
;*
;*          RETURN (EXECUTION PHASE):
;*               START,CURRENT,END FILE ADDRESS SET IN THE
;*                    #n DEVICE TABLE SLOT
;*               AUXA = 0 IF FILENAME FOUND (OVERWRITING
;*                        AN OLD FILE)
;*                    = 2 IF EXPRESSION FOUND (CREATING
;*                        A NEW FILE)
;*               IF FILENAME IS FOUND,
;*                    AUX8 = SECTOR ADDRESS OF INDEX SECTR
;*                           WITH FILENAME
;*                    AUX9 = ADDRESS OF ENTRY (WHEN INDEX
;*                           SECTOR LOADED INTO I/O BUFFER
;*
;*          NOTE: IF A NEW FILE IS CREATED, THE CURRENT
;*                CATALOG END IN SECTOR 0 IS NOT UPDATED
;*                BY THIS ROUTINE.
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2,3
;*               IN EXECUTION PHASE, AUXA,C,F,8,9
;*
;         ORG       *
;FILELOC  TAP       ,TEXTPTR
;         TPA       ,3        SAVE TEXTPTR
;         SB        NXTCHLP   LOOK FOR '('
;         BNEL      0,F0,FILELOC1       BRANCH IF NF
;         SB        OLDNAME   LOOK FOR FILENAME & PROCESS IT

FILELOC:

        mov     aux03,textptr
        cmp     byte ptr [textptr],'('
        jnz     fileloc1
        inc     textptr

        CALL    OLDNAME

;         BNEL      0,F0,FILELOC4       NF, BRANCH
;         BFL       2,SL,FILELOC2       BRANCH IF NOT EXECUTION PHASE
;         TAP       ,C
;         SB        PUTFLPTR  SET FILE PTRS IN #n DEVICE TABLE SLOT

        TEST    R0,0FH
        JNZ     FILELOC4
        TEST    SL,2
        JZ      FILELOC2
        MOV     EDX,AUX0C
        CALL    PUTFLPTR

;FILELOC2 B         GETCHRP   LOOK FOR ')'
;FILELOC4 TAP       ,3
;         TPA       ,TEXTPTR  RESTORE TEXTPTR
;FILELOC1 SB        OLDNAME   LOOK FOR OLD FILENAME
;         BEQL      0,F0,FILELOC6       BRANCH IF FOUND

FILELOC2:
        cmp     byte ptr [textptr],')'
        jnz     error_11
        inc     textptr
        mov     r0,0
        ret

FILELOC4:
        MOV     TEXTPTR,aux03
FILELOC1:
        CALL    OLDNAME
        TEST    R0,0FH
        JZ      FILELOC6

;         SB        EXPR      PROCESS EXPRESSION
;         BFL       2,SL,FILELOC5       BRANCH IF NOT EXECUTION PHASE
;         SB        DREADS0   READ SECTOR 0
;         SB        FLTBIN    CONVERT NO. OF SECTORS IN FILE TO BINARY
;         BNEL      2,F2,ERR#34F        ERROR IF <1 OR >65535
;         SB        CUREND    GET CURRENT END OF CAT AREA
;         ACX,0     F1F0,PHPL,F7F6      F7,6 = END OF FILE ADDRESS

        CALL    EXPR
        TEST    SL,2
        JZ      FILELOC5
        CALL    DREADS0
        CALL    FLTBIN
        CMP     R2,2
        JNZ     ERR_34F
        CALL    CUREND
        MOV     AX,WORD PTR  R0
        ADD     AX,DX
        MOV     WORD PTR R6,AX

;         BTL       1,SH,FILELOC3       ERROR IF END OF FILE > FFFF
;         ACX,1     DD,PHPL,F5F4        F5,4 = START ADDRESS OF FILE
;         SB        CATEND    PC'S = END OF CAT. AREA ADDRESS
;         BLERX     F7F6,PHPL,*+2       ERROR IF END OF FILE > END OF CAT.

        JC      FILELOC3
        MOV     WORD PTR R4,DX
        INC     WORD PTR R4
        CALL    CATEND
        CMP     DX,WORD PTR R6
        JAE     BP41L_01

;FILELOC3 B         ERROR#86  CAT. END ERROR
;         LPI       2
;         TPA       ,A        AUXA = CREATING NEW FILE (OLD FILENAME NOT SPEC.)
;         B         PUTFLPTS  SET FILE PTRS IN #n DEVICE TABLE SLOT

FILELOC3:
        JMP     ERROR_86
BP41L_01:
        MOV     AUX0A,2
        JMP     PUTFLPTS

;FILELOC5 SR
;FILELOC6 BFL       2,SL,FILELOC5       BRANCH IF NOT EXECUTION PHASE
;         TAP       ,C
;         B         PUTFLPTR  FILEPTRS ==> #n DEVICE TABLE SLOT
;ERR#34F  B         ERROR#34  ILLEGAL VALUE

FILELOC5:
        RET
FILELOC6:
        TEST    SL,2
        JZ      FILELOC5
        MOV     EDX,AUX0C
        JMP     PUTFLPTR
ERR_34F:
        JMP     ERROR_34

;         TITLE     FILELOCS
;*     FILELOCS: PROCESS A FILE LOCATION PARAMETER.
;*               (CALLED BY 'SAVE DC')
;*
;*          FORMAT:  [ ( [ filename  ] ) ]
;*                         expression
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = FILE# / PLATTER
;*
;*          RETURN: TEXTPTR POINTS AFTER FILENAME
;*
;*                     IN EXECUTION PHASE:
;*               AUXA = PARAMETER TYPE
;*                      0 IF FILENAME FOUND (OVERWRITING
;*                           AN OLDFILE)
;*                      1 IF ()   (OVERWRITING SAME FILE)
;*                      2 IF EXPRESSION FOUND (CREATING
;*                           NEW FILE WITH EXTRA SPACE)
;*                      3 IF NULL (CREATING NEW FILE WITH
;*                           NO EXTRA SPACE)
;*
;*            IF FILENAME WAS FOUND (AUXA = 0):
;*               AUX8,F = SECTOR ADDRESS OF INDEX SECTOR
;*                        WITH FILENAME
;*               AUX9 = ADDRESS OF ENTRY WITH NAME WHEN
;*                      INDEX SECTOR LOADED IN I/O BUFFER
;*               INDEX SECTOR WITH NAME ==> I/O BUFFER
;*               AUXC = ADDRESS OF START OF FILE ADDRESS
;*                      (IN I/O BUFFER)
;*               AUXB = START ADDRESS OF FILE
;*               AUXD = END ADDRESS OF FILE
;*
;*       IF CREATING NEW FILE (AUXA = 2 OR 3):
;*            AUXB = CURRENT END OF CAT. AREA + 1 (START)
;*            AUXD = END OF CAT. AREA (END OF FILE ADDR)
;*
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX8-D,F
;*
;         ORG       *
;FILELOCS SB        NXTCHLP   LOOK FOR '('
;         BEQL      0,F0,FILELCS1       BRANCH IF FOUND
;         BFL       2,SL,FILELCS6       BRANCH IF NOT EXECUTION PHASE
;         SB        NWFLADRS  AUXB = CURRENT END CAT. AREA; AUXD = END CAT AREA
;         LPI       3         AUXA = 3 (CREATING NEW FILE, NO EXTRA SPACE)

FILELOCS:
        inc     textptr
        cmp     byte ptr [textptr-1],'('
        jz      filelcs1
        dec     textptr

        TEST    SL,2
        JZ      FILELCS6
        CALL    NWFLADRS
        MOV     EDX,3

;FILELCS3 BFL       2,SL,*+2  BRANCH IF NOT EXECUTION PHASE
;         TPA       ,A
;FILELCS6 SR

FILELCS3:
        TEST    SL,2
        JZ      FILELCS6
        MOV     AUX0A,EDX
FILELCS6:
        RET

;FILELCS1 SB        NXTCHRP   LOOK FOR ')'
;         BNEL      0,F0,FILELCS2       NF, BRANCH
;         LPI       1         AUXA = 1  (OVERWRITE SAME FILE)
;         B         FILELCS3

FILELCS1:
        cmp     byte ptr [textptr],')'
        jnz     filelcs2
        inc     textptr

        MOV     EDX,1
        JMP     FILELCS3

;FILELCS2 SB        OLDNAME   PROCESS FILENAME
;         BNEL      0,F0,FILELCS4       BRANCH IF NF
;         SB        GTFLPTRS  AUXB = START OF FILE ADDRESS; AUXD = EOF ADDRESS
;FILELCS5 B         GETCHRP   LOOK FOR ')'

FILELCS2:
        CALL    OLDNAME
        TEST    R0,0FH
        JNZ     FILELCS4
        CALL    GTFLPTRS
FILELCS5:
        cmp     byte ptr [textptr],')'
        jnz     error_11
        inc     textptr
        ret

;FILELCS4 SB        EXPR      PROCESS EXPRESSION
;         BFL       2,SL,FILELCS5       BRANCH IF NOT EXECUTION PHASE
;         LPI       2         AUXA = 2 (CREATING NEWFILE, WITH EXTRA SPACE)
;         TPA       ,A
;         SB        NWFLADRS  AUXB = CURRENT END OF CAT. AREA;
;*_     AUXD = END OF CAT. AREA
;         B         GETCHRP   LOOK FOR ')'

FILELCS4:
        CALL    EXPR
        TEST    SL,2
        JZ      FILELCS5
        MOV     AUX0A,2
        CALL    NWFLADRS

        cmp     byte ptr [textptr],')'
        jnz     error_11
        inc     textptr
        mov     r0,0
        ret

;         TITLE     NEWNAMEF
;*     NEWNAMEF: GET NEW FILENAME FROM TEXT AND SCAN FOR
;*              NAME IN INDEX. IF NAME FOUND, IT MUST BE
;*              SCRATCHED AND MUST BE OVERWRITING OLDFILE.
;*              ALSO, GET START AND END OF FILE ADDRESSES.
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = PLATTER SPEC.
;*                    AUXA = 0 IF OVERWRITING OLDFILE
;*                           1 IF OVERWRITING SAME FILE
;*                           2 OR 3 IF CREATING NEW FILE
;*
;*          RETURN (EXECUTION PHASE):
;*                  F3 = RETURN FLAG
;*                       00 IF NF
;*                       11 IF FOUND BUT FILE SCRATCHED
;*                 F2 = HASH VALUE
;*
;*                  IF FOUND (F3 = 11),
;*                       AUXF = SECTOR ADDRESS OF INDEX
;*                              SECTOR WITH FILENAME
;*                       AUXC = ADDRESS IN I/O BUFFER OF
;*                              ENTRY WITH FILENAME
;*                       I/O BUFFER CONTAINS INDEX SECTOR
;*                              WITH FOUND FILENAME
;*
;*                 IF NOT FOUND & INDEX NOT FULL (F3 = 0),
;*                      AUXF = SECTOR ADDRESS OF SECTOR
;*                             WITH UNUSED ENTRY
;*                      I/O BUFFER CONTAINS INDEX SECTOR
;*                             WITH UNUSED ENTRY
;*                      AUXC = ADDRESS OF UNUSED
;*                             ENTRY IN I/O BUFFER
;*                      CH = ENTRY STATUS (0)
;*                      CL = FILE TYPE (0)
;*
;*               IF OVERWRITING SAME FILE (AUXA = 1),
;*                    AUXB = SOF ADDRESS
;*                    AUXD = EOF ADRESS
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,F
;*               IF OVERWRITING SAME FILE (AUXA = 1),
;*                  AUXB,D  (EXECUTION PHASE ONLY)
;*
;         ORG       *
;NEWNAMEF SB        NEWNAME   PROCESS FILENAME
;         BFL       2,SL,NEWNAMF1       BRANCH IF NOT EXECUTION PHASE
;         BER       F3,,NEWNAMF1        BRANCH IF NAME NOT IN INDEX
;         TAP       ,A

NEWNAMEF:
        CALL    NEWNAME
        TEST    SL,2
        JZ      NEWNAMF1
        CMP     R3,0
        JZ      NEWNAMF1
        MOV     EDX,AUX0A

;         BNEL      1,PL,NEWNAMF1       BRANCH IF NOT OVERWRITING SAME FILE
;         TAP       ,C
;         TPA+2     ,C
;         B         GTFLPTRS  AUXB = SOF ADDRESS; AUXD = EOF ADDRESS

        CMP     DL,1
        JNE     NEWNAMF1
        MOV     EDX,AUX0C
        ADD     AUX0C,2
        JMP     GTFLPTRS

;NEWNAMF1 SR
;ERROR#87 MVI       87,F0     NO END OF FILE
;         B         ERROR

NEWNAMF1:
        RET
ERROR_87:
        MOV     R0,87H
        JMP     ERROR

;         TITLE     FILENAMP FILENAMD
;*     FILENAMP: LOOK FOR A PROGRAM IN TEXT; ERROR IF
;*               NOT FOUND.  IN EXECUTION PHASE, SEARCH
;*               FOR FILENAME IN INDEX; ERROR IF NOT FOUND
;*               OR IF SCRATCHED.
;*
;*     FILENAMD: LOOK FOR A DATA FILENAME IN TEXT; ERROR
;*            IF NOT FOUND.  IN EXECUTION PHASE, SEARCH
;*            FOR FILENAME IN INDEX; ERROR IF NOT FOUND
;*            OR IF SCRATCHED.
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = PLATTER SPEC.
;*
;*          RETURN (EXECUTION PHASE):
;*                  F3 = 10 (FILE FOUND, NOT SCRATCHED)
;*                  CH,CL = 1ST 2 BYTES OF INDEX ENTRY
;*                          (ENTRY STATUS, FILE TYPE)
;*                  F2 = HASH VALUE
;*                  AUXF = SECTOR ADDRESS OF INDEX
;*                              SECTOR WITH FILENAME
;*                  AUXC = ADDRESS IN I/O BUFFER OF
;*                              ENTRY WITH FILENAME +2
;*                  I/O BUFFER CONTAINS INDEX SECTOR
;*                              WITH FOUND FILENAME
;*                  PC'S = ADDRESS IN I/O BUFFER OF
;*                         ENTRY WITH FILENAME
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,F
;*
;FILENAMP SB        FILENAMH  GET FILENAME FROM TEXT; SEARCH FOR NAME
;*_     IN INDEX
;FILENAMS MVI       80,F0     FILE TYPE = PROGRAM
;         B         FILENAMX
;FILENAMD SB        FILENAMH  GET FILENAME FROM TEXT; SEARCH FOR NAME
;*_     IN INDEX
;FILENMDA MVI       0,F0

FILENAMP:
        CALL    FILENAMH
FILENAMS:
;
; cs-386 format
;
        mov     al,40h
;
        MOV     R0,80H
        JMP     FILENAMX
FILENAMD:
        CALL    FILENAMH
FILENMDA:
        MOV     R0,0
;
; cs-386 format
;
        mov     al,0

;FILENAMX BFL       2,SL,FILENMX1       BRANCH IF NOT EXECUTION PHASE
;FILENMXA BNEH      1,F3,ERROR#82       BRANCH IF FILE NOT FOUND
;         BNEL      0,F3,ERROR#82       BRANCH IF FILE SCRATCHED
;         TAP       ,C
;         TPA+2,R   ,C        GET FILE TYPE

FILENAMX:
        TEST    SL,2
        JZ      FILENMX1
FILENMXA:
        CMP     R3,10H
        JNZ     ERROR_82
        MOV     EDX,AUX0C
        MOV     CX,[EDX]        ;GET FILE TYPE & STATUS
        XCHG    CH,CL
        ADD     AUX0C,2

;         XOR       F0,CL,F1
;         BNEH      0,F1,ERROR#82       ERROR IF WRONG TYPE OF FILE
;FILENMX1 SR
;ERROR#82 MVI       82,F0     FILE NOT IN CATALOG
;         B         ERROR
;
; cs-386 format
;
        xor     al,cl
        test    al,0f0h
        jz      filenmx1

        MOV     AL,R0
        XOR     AL,CL
        MOV     R1,AL
        TEST    R1,0F0H
        JNZ     ERROR_82
FILENMX1:
        RET
ERROR_82:
        MOV     R0,82H
        JMP     ERROR

;         TITLE     FILENAMH
;*     FILENAMH: LOOK FOR A FILENAME IN TEXT; ERROR IF
;*               NOT FOUND.  IN EXECUTION PHASE, SEARCH
;*               FOR FILENAME IN INDEX.
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = PLATTER SPEC.
;*
;*          RETURN (EXECUTION PHASE):
;*                  F3 = RETURN FLAG
;*                       00 IF NF
;*                       01 IF NF & INDEX FULL
;*                       10 IF FOUND
;*                       11 IF FOUND BUT FILE SCRATCHED
;*                 F2 = HASH VALUE
;*
;*                  IF FOUND (F3 = 10 OR 11),
;*                       AUXF = SECTOR ADDRESS OF INDEX
;*                              SECTOR WITH FILENAME
;*                       AUXC = ADDRESS IN I/O BUFFER OF
;*                              ENTRY WITH FILENAME
;*                       I/O BUFFER CONTAINS INDEX SECTOR
;*                              WITH FOUND FILENAME
;*
;*                 IF NOT FOUND & INDEX NOT FULL (F3 = 0),
;*                      AUXF = SECTOR ADDRESS OF SECTOR
;*                             WITH UNUSED ENTRY
;*                      I/O BUFFER CONTAINS INDEX SECTOR
;*                             WITH UNUSED ENTRY
;*                      PC'S,AUXC = ADDRESS OF UNUSED
;*                             ENTRY IN I/O BUFFER
;*                      CH = ENTRY STATUS (0)
;*                      CL = FILE TYPE (0)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,F
;*
;FILENAMH SB        FILENAME  LOOK FOR FILENAME IN TEXT
;         BEQL      0,F0,*+2
;         B         ERROR#29  ERROR IF NF
;         BTL       2,SL,FINDNAMH       BRANCH IF EXECUTION PHASE
;         SR

FILENAMH:
        CALL    FILENAME
        TEST    R0,0FH
        JZ      BP41M_01
        JMP     ERROR_29
BP41M_01:
        TEST    SL,2
        JNZ     FINDNAMH
        RET

;         TITLE     FILENAME
;*     FILENAME: LOOK FOR FILENAME (LITERAL OR ALPHA-VAR)
;*               IN TEXT.  IN EXECUTION PHASE, MOVE NAME
;*               TO WORKSPACE AND PAD WITH TRAILING
;*               SPACES (UP TO 8 CHARACTERS). IF NAME IS
;*               LONGER THAN 8 CHARACTERS, ERROR RESULTS.
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN (EXECUTION PHASE):
;*               F0 <> 0 IF NAME NOT FOUND
;*               F0 = 0 IF NAME FOUND
;*                   NAME (8 BYTES, FILLED WITH TRAILING
;*                       SPACES) ==> WORKSPACE
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*
;FILENAME MVI       4,K
;         SB        ALPHA1    LOOK FOR ALPHA VAR. OR LITERAL; GET CURRENT LENGTH
;         BNEL      0,F0,FILENAM1       BRANCH IF NAME NOT FOUND
;         BFL       2,SL,FILENAM1       EXIT IF NOT EXECUTION PHASE
;         SB        RWORKSPC  POINT TO WORKSPACE

FILENAME:
        MOV     K,4
        CALL    ALPHA1
        TEST    R0,0FH
        JNZ     FILENAM1
        TEST    SL,2
        JZ      FILENAM1
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@workspc

;         TPA       ,0        AUX0 = ADDRESS OF WORKSPACE
;         SB        POPV4     GET ADDRESS & LENGTH OF NAME
;         MVI       0,F3      F3,2 = 8
;         MVI       8,F2

        mov     aux00,edx
        MOV     EDX,VSPTR
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR [R0],AX
        MOV     ECX,DWORD PTR [EDX+2]
        ADD     VSPTR,6
        MOV     EDX,ECX
        mov     word ptr r2,8

;         BLRX      F3F2,F1F0,ERR#52D   ERROR IF NAME LENGTH > 8
;         SB        ARECEVAL  NAME ==> WORKSPACE; PAD WITH TRAILING SPACES
;         MVI       0,F0      FLAG = NAME FOUND
;FILENAM1 SR
;ERR#52D  B         ERROR#52  VARIABLE OR VALUE TOO LONG
        cmp     word ptr r0,8
        ja      err_52d
        call    areceval

        MOV     R0,0
FILENAM1:
        RET
ERR_52D:
        JMP     ERROR_52

;         TITLE     FINDNAME FINDNAMH
;*     FINDNAMH: HASH FILENAME & GOTO 'FINDNAME'
;*
;*          ENTRY: PHASE = EXECUTION
;*               FILENAME IN SCRATCH AREA (1ST 8 BYTES)
;*               DISK ENABLED
;*               AUXE = PLATTER SPECIFICATION
;*
;*     FINDNAME: SCAN THE DISK PLATTER INDEX FOR A
;*               SPECIFIED FILENAME, STARTING AT THE
;*               HASHED VALUE OF THE NAME.
;*
;*          ENTRY: PHASE = EXECUTION
;*                 F0 = HASH VALUE OF THE NAME
;*                 AUXF = HASH VALUE OF NAME (SECTOR ADDR
;*                        TO START SEARCH AT)
;*                 FILENAME AT 1ST 8 BYTES OF WORKSPACE
;*                 DISK ENABLED
;*                 AUXE,LOW BYTE = PLATTER SPECIFICATION
;*                                 (SEE 'DREAD')
;*
;*          RETURN: F3 = RETURN FLAG
;*                       00 IF NF
;*                       01 IF NF & INDEX FULL
;*                       10 IF FOUND
;*                       11 IF FOUND BUT FILE SCRATCHED
;*                 F2 = HASH VALUE
;*
;*                  IF FOUND (F3 = 10 OR 11),
;*                       AUXF = SECTOR ADDRESS OF INDEX
;*                              SECTOR WITH FILENAME
;*                       AUXC = ADDRESS IN I/O BUFFER OF
;*                              ENTRY WITH FILENAME
;*                       I/O BUFFER CONTAINS INDEX SECTOR
;*                              WITH FOUND FILENAME
;*
;*                 IF NOT FOUND & INDEX NOT FULL (F3 = 0),
;*                      AUXF = SECTOR ADDRESS OF SECTOR
;*                             WITH UNUSED ENTRY
;*                      I/O BUFFER CONTAINS INDEX SECTOR
;*                             WITH UNUSED ENTRY
;*                      PC'S,AUXC = ADDRESS OF UNUSED
;*                             ENTRY IN I/O BUFFER
;*                      CH = ENTRY STATUS (0)
;*                      CL = FILE TYPE (0)
;*
;*
;*          SEARCH ALGORITHM:
;*               1. SECTOR ADDRESS = HASH VALUE
;*               2. READ SECTOR
;*               3. GET STATUS OF NEXT ENTRY
;*                  a. IF NO MORE ENTRIES, GOTO 4.
;*                  b. IF 10 OR 11 & NAME MATCHES, SEARCH
;*                     TERMINATES (NAME FOUND)
;*                  c. IF 00, SEARCH TERMINATES (NOT FOUND
;*                  d. IF 21, SAVE POINTER TO 21 ENTRY & CONTINUE
;*                  d. OTHERWISE, GOTO 3 (DISABLED ENTRY)
;*               4. DECREMENT SECTOR ADDRESS (IF LAST
;*                  SECTOR READ = 0, SECTOR ADDRESS = LAST
;*                  SECTOR IN INDEX)
;*               5. IF SECTOR ADDRESS < HASH VALUE, GOTO 1
;*                  OTHERWISE, DONE (NF & INDEX FULL)
;*               6. IF FILE NOT FOUND & A 21 WAS FOUND, SET RETURN VALUES
;*                  TO POINT TO 21 FOR POSSIBLE REUSE
;*
;*          REGISTER USE:
;*               F2 = HASH VALUE
;*               F6 = NO. OF INDEX SECTORS (SET WHEN
;*                    SECTOR 0 READ)
;*               AUXF = SECTOR ADDRESS
;*               AUXC = PTR TO I/O BUFFER
;*               F3 = RETURN FLAG (ENTRY STATUS)
;*               F5 = ENTRY COUNT
;*
;*          MODIFIED REGISTERS: ALL,AUX0,C,F
;*
;FINDNAMH SB        HASH      HASH FILENAME ==> SECTOR ADDRESS
;         MV        F2,F6     SAVE # INDEX SECTORS

FINDNAMH:
        CALL    HASH
        MOV     AL,R2
        MOV     R6,AL           ;SAVE HASH VALUE IN R6

;FINDNAME MV        F0,F2     F2 = HASH VALUE
;         LPI       X'FFFF'   INDEX SECTOR ADDR OF LAST 21 = FFFF (NONE FOUND)
;         TPS       ,         STORE IN RETURN STACK
;         TPS       ,

FINDNAME:
        MOV     AL,R0
        MOV     R2,AL
        MOV     DX,0FFFFH
        PUSH    EDX             ;INDEX POINTER ---- ADDRESS IN BUFFER -- DWORD
        PUSH    EDX             ; SECTOR ADDRESS -- WHICH SECTOR ------- WORD

;FINDNAM1 SB        DREADSF   READ NEXT INDEX SECTOR
;         TAP       ,F
;         TPA-1     ,F        AUXF = ADDRESS OF SECTOR READ
;         OR,0      -,,F5     ENTRY COUNT = 0; CARRY OFF
;         MV        PL,F1     F1 = SECTOR ADDRESS OF SECTOR READ

FINDNAM1:
        CALL    DREADSF       ; DREADSF INCREASE AUX0F BY  ONE
        MOV     EDX,AUX0F
        DEC     AUX0F
        MOV     R5,0
        DEC     EDX
        MOV     R1,DL

;         TAP       ,C        PC'S POINT TO 1ST ENTRY
;         BNR       F1,,FINDNAM2        BRANCH IF NOT SECTOR 0
;         MVI       1,F5      ENTRY COUNT = 1

        MOV     EDX,AUX0C
        CMP     R1,0
        JNZ     FINDNAM2      ;SECTOR 0 , ENTRY 1 FOR INDEX USE ITSELF!
        MOV     R5,1

;FINDNAM5 ACI       10,PL,PL
;         ACI       0,PH,PH   POINT TO NEXT ENTRY
;         SPACE

FINDNAM5:
        ADD     EDX,10H

;FINDNAM2 TPA,R     ,C        GET ENTRY STATUS & FILE TYPE
;         MV        CH,F3     F3 = ENTRY STATUS
;         BER       CH,,FINDNAM3        BRANCH IF ENTRY NOT USED (NAME NOT FOUND)
;         MV        F5,K      SAVE ENTRY COUNT
;         BNEH      2,CH,*+2  BRANCH IF ENTRY IS <> 2X
;         BEQL      1,CH,FINDNAMA       BR IF ENTRY IS 21

FINDNAM2:
        MOV     CH,[EDX]
        MOV     AUX0C,EDX
        MOV     R3,CH
        CMP     CH,0
        JZ      FINDNAM3
        MOV     AL,R5
        MOV     K,AL
        CMP     CH,21H
        JZ      FINDNAMA

;         BNEH      1,CH,FINDNAM4       BRANCH IF ENTRY DISABLED
;         MVI       8,F0
;         MVI       0,F1      F1,0 = LENGTH OF NAME (8)
;         ACX,0     F1F0,PHPL,PHPL      PC'S = ADDRESS OF NAME IN ENTRY
;         TPA       ,0        AUX0 = ADDRESS OF NAME IN ENTRY

        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,10H
        JNE     FINDNAM4

;2/21/89 ++
        xor     ecx,ecx
        mov     ecx,8           ;string length = 8
        add     edx,8           ;pt to address of file name in IOBUFFER
        mov     esi,edx         ;
        mov     edi,cpbase      ;
        lea     edi,[edi].@workspc
        repe    cmpsb           ;
        jz      findnamf        ;found the file name


;         SB        RWORKSPC  PC'S = ADDRESS OF NAME LOOKING FOR
;         MVI       0,F4
;         MVI       0FF,F7
;         SB        RELALPHC  COMPARE NAMES
;         BEQL      2,F7,FINDNAMF       BRANCH IF NAME LOOKING FOR

;2/21/89 --


;FINDNAM4 AC,1      +,K,F5    INCREMENT ENTRY COUNT
;         TAP       ,C
;         BEQH      0,F5,FINDNAM5       BRANCH IF MORE ENTRIES TO PROCESS IN SCTR
;         TAP       ,F
;         TPS       ,         SAVE PC'S

FINDNAM4:
        MOV     AL,K
        INC     AL
        MOV     R5,AL            ;R5 IS A COUNTER
        MOV     EDX,AUX0C
        TEST    R5,0F0H          ; 16 ENTRIES PER SECTOR
        JZ      FINDNAM5
        MOV     EDX,AUX0F
        PUSH    EDX

;         MV        PL,F0     F0 = SECTOR ADDRESS OF LAST SECTOR READ
;         SB        RHASHFLG  GET HASH FLAG
;         BNR       CH,,FINDNAM7        BR IF NEW HASH
;         TSP       ,         RESTORE PC'S

        MOV     R0,DL

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@hashfl
        mov     ch,[edx]

        CMP     CH,0
        JNE     FINDNAM7
        POP     EDX

;         BNR       -,F0,FINDNAM6       BRANCH IF NOT SECTOR 0; DECR. SECTOR ADDRES
;         SC,0      F6,,PL    SECTOR ADDRESS = LAST SECTOR IN INDEX
;         MVI       0,PH
;FINDNAM6 TPA       ,F
;         BNR       F2,PL,FINDNAM1      BRANCH IF SECTOR ADDRESS <> HASH VALUE

        DEC     EDX
        CMP     R0,0
        JNE     FINDNAM6
        MOV     DL,R6
        MOV     DH,0
        DEC     EDX
FINDNAM6:
        MOV     AUX0F,EDX
        CMP     DL,R2
        JNE     FINDNAM1     ;FLAG = FILENAME NF & INDEX FULL

;FINDNAMB MVI       1,F3
;         B         FINDNAM3
;FINDNAMD SR
;*        USE NEW HASH ALGORITHM

FINDNAMB:
        MOV     R3,1
        JMP     FINDNAM3
FINDNAMD:
        RET

;FINDNAM7 AI        0FF,F6,F1 F1=LAST INDEX SECTOR
;         BNR       F0,F1,FINDNAM8      BR IF NOT LAST INDEX SECTOR
;         LPI       0000      PT TO FIRST INDEX SECTOR
;         B         FINDNAM9

FINDNAM7:
        MOV     AL,R6
        DEC     AL
        MOV     R1,AL
        CMP     AL,R0
        JNE     FINDNAM8
        MOV     EDX,0
        JMP     FINDNAM9

;FINDNAM8 TAP       ,F        PT TO NEXT INDEX SECTOR
;         OR        +,,

FINDNAM8:
        MOV     EDX,AUX0F
        INC     EDX

;FINDNAM9 TPA       ,F        STORE NEXT SECTOR TO READ
;         BNR       F2,PL,FINDNAM0      BR IF SECTOR ADDRESS <> HASH VALUE
;         TSP       ,         RESTORE PCS

FINDNAM9:
        MOV     AUX0F,EDX
        CMP     DL,R2
        JNE     FINDNAM0
        POP     EDX

;         B         FINDNAMB
;FINDNAM0 TSP       ,         POP STACK- RESTORE PC'S
;         B         FINDNAM1  TRY ANOTHER SECTOR

        JMP     FINDNAMB
FINDNAM0:
        POP     EDX
        JMP     FINDNAM1

;*        SAVE POINTER TO LAST 21 FOUND FOR POSSIBLE REUSE
;*
;*        LAST ENTRY ON VS STACK - SECTOR ADDRESS WHERE LAST 21 FOUND
;*        NEXT TO LAST           - POINTER TO INDEX SLOT ENTRY
;*
;*               ON ENTRY -
;*                  PC'S POINT TO ENTRY IN INDEX SECTOR
;*                  AUX F = INDEX SECTOR ADDRESS
;*                  CHCL = ENTRY STATUS & FILE TYPE
;*
;*               ON EXIT -
;*                  VSPTR UPDATED - LAST ENTRY = SECTOR ADDRESS
;*                          NEXT TO LAST ENTRY = PTR WITHIN INDEX SECTOR
;*
;FINDNAMA MVX       PHPL,F1F0 SAVE PTR WITHIN INDEX
;         TSP       ,         POP OLD SECTOR ADDRESS
;         TSP       ,         POP OLD INDEX POINTER
;         MVX       F1F0,PHPL PUSH OLD INDEX POINTER

FINDNAMA:
        MOV     DWORD PTR A0,EDX
        POP     EDX
        POP     EDX
        MOV     EDX,DWORD PTR A0

;         TPS       ,
;         TAP       ,F        PUSH NEW SECTOR ADDRESS
;         TPS       ,
;         B         FINDNAM4

        PUSH    EDX
        MOV     EDX,AUX0F
        PUSH    EDX
        JMP     FINDNAM4

;*        NAME NOT FOUND - CHECK IF A 21 WAS FOUND AND SET UP FOR POSSIBLE REUSE
;*
;*               ON ENTRY -
;*                  PC'S POINT TO ENTRY IN INDEX SECTOR
;*                  AUX F = INDEX SECTOR ADDRESS
;*                  CHCL = ENTRY STATUS & FILE TYPE
;*
;*               ON EXIT -
;*                  AUX F = SECTOR ADDRESS OF SECTOR WITH UNUSED OR 21 ENTRY
;*                  I/O BUFFER CONTAINS INDEX SECTOR WITH UNUSED OR 21 ENTRY
;*                  PC'S, AUXC = ADDRESS OF UNUSED OR 21 ENTRY IN I/O BUFFER
;*                  CHCL = ENTRY STATUS (00) & FILE TYPE (00)
;*
;FINDNAM3 TSP       ,         POP SECTOR ADDRESS
;         MVX       PHPL,F1F0 F1F0 = SECTOR ADDRESS OF POSSIB;E 21
;         TSP       ,         POP PTR INTO INDEX ENTRY
;         MVI       X'FF',F4
;         BER       F1,F4,FINDNAMC      BR IF NO 21 FOUND

 FINDNAM3:
        POP     EDX
        MOV     WORD PTR R0,DX
        POP     EDX
        MOV     R4,0FFH
        MOV     AL,R1
        CMP     AL,R4
        JE      FINDNAMC

;* 21 FOUND UPDATE AUX F, AUX C, PC'S AND IOBUFFER
;
;         TPS       ,         PUSH INDEX PTR BACK ON STACK
;         XOR       F3,F3,F3  SET FLAG TO INDEX SLOT AVAILABLE
;         MVX       F1F0,PHPL AUX F= SECTOR
;         TPA       ,F
;         TPS       ,

        PUSH    EDX
        MOV     R3,0
        MOV     DX,WORD PTR R0
        MOV     AUX0F,EDX
        PUSH    EDX

;         SB        RIOBUFFR  PC'S POINT TO I/O BUFFER
;         XPA       ,F        AUX F = DATA, PC'S = SECTOR TO READ
;         SB        DREAD
;         TSP       ,         AUX F = SECTOR ADDRESS

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

        XCHG    EDX,AUX0F
        CALL    DREAD
        POP     EDX

;         TPA       ,F
;         TSP       ,         POP INDEX POINTER
;         TPA,R     ,C        AUX C = PTR TO ENTRY
;         B         FINDNAMD

        MOV     AUX0F,EDX
        POP     EDX
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     AUX0C,EDX
        JMP     FINDNAMD

;FINDNAMC TAP       ,C        PC'S ADDRESS OF UNUSED ENTRY
;         OR,R      F0,,      CHCL = ENTRY STATUS & FILE TYPE
;         B         FINDNAMD
;*        FILE NAME FOUND - MUST POP 21 DATA FROM VALUE STACK
;FINDNAMF TSP       ,         POP SECTOR
;         TSP       ,         POP INDEX
;         B         FINDNAMD

FINDNAMC:
        MOV     EDX,AUX0C
        MOV     CX,[EDX]
        XCHG    CH,CL
        JMP     FINDNAMD
FINDNAMF:
        POP     EDX
        POP     EDX
        JMP     FINDNAMD

;         TITLE     HASH
;*     HASH: HASHES FILENAME TO PRODUCE A SECTOR ADDRESS
;*           WITHIN CATALOG INDEX.  MAKES USE OF ORIGINAL 2200 HASH.
;*
;*     NEWHASH: HASHES FILENAME USING THE NEW HASH ALGORITHM
;*
;*          ENTRY: PHASE = EXECUTION
;*                 FILENAME LOCATED IN 1ST 8 BYTES OF
;*                    WORKSPACE
;*                 DISK ENABLED
;*                 AUXE = PLATTER SPECIFICATION
;*
;*          RETURN: AUXF = HASH VALUE (SECTOR ADDRESS <
;*                         NO. OF SECTORS IN INDEX)
;*                  PC'S = HASH VALUE
;*                  F0 = LOW BYTE OF HASH VALUE
;*
;*          OLD 2200 STYLE HASH ALGORITHM:
;*               1. XOR ALL 8-BYTES OF FILENAME
;*               2. X = 3 * XOR(FILENAME)
;*               3. Y = HIGH BYTE OF X + LOW BYTE OF X
;*               4. HASH VALUE = Y  OD (NO. OF INDEX
;*                                      SECTORS)
;*
;*               NOTE, THIS ALGORITHM ONLY HASHES TO EVERY
;*                     3RD SECTOR! BUT SINCE 2200 DOES IT
;*                     THIS WAY, 2600 IS STUCK WITH IT.
;*
;*           NEW HASH ALGORITHM:
;*               X$=HEX(00)
;*               FOR I=1 TO 8 DO
;*                   P$=Ith byte of filename
;*                   IF MOD(I,2)=1 THEN
;*                      P$=ROTATE(P$,4)      (Switch Nybbles)
;*                   X$=X$ ADD P$
;*                   ENDDO
;*                   HASH = MOD(VAL(X$),number of catalog sectors)
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-2,AUX0,C,F
;*
;HASH     SB        DREADS0   READ SECTOR 0
;         SB        RIOBUFFR  GET NO. OF INDEX SECTORS
;         BER       CL,,ERROR#85        ERROR IF NO INDEX SECTOR
;         MV        CL,F2     SAVE # INDEX SECTORS = F2
;         XOR       F0,F0,F0  HASH FLAG = 00

HASH:
        CALL    DREADS0

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        mov     cx,[edx]
        xchg    ch,cl

        CMP     CL,0
        JE      ERROR_85
        MOV     R2,CL           ;SAVE  # INDEX SECTORS IN R2
        MOV     al,0            ;FROM SB RIOBUFFER , CH=PLATTER HASH FLAG, CL= # INDEX SECTORS

;*    FROM SB RIOBUFFR,   CH = PLATTER HASH FLAG,  CL = # INDEX SECTORS
;         BNEH      0,CH,HASH1BR IF NOT 0X, = OLD HASH
;         BNEL      1,CH,HASH1BR IF NOT 01, = OLD HASH
;         AI        01,F0,F0  HASH FLAG = NEW (01)

        CMP     CH,01H          ;HASH FLAG = 01 ---- NEW HASH FUNCTION
        JNE     HASH1           ;    OTHERWISE  ---- OLD HASH FUNCTION
        mov     al,1

;HASH1    SB        RHASHFLG  WRITE HASH FLAG INTO MEMORY
;         OR,W1     F0,,
;         BNR       F0,,NEWHASH         br if new hash (=01)
;         SB        RWORKSPC  POINT TO FILENAME
;         XORX      F1F0,F1F0,F1F0      RESULT AREA (F1F0) = 0000

HASH1:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@hashfl

        MOV     [EDX],AL
        CMP     al,0
        JNE     NEWHASH

        mov     edx,dword ptr [cpbase]
        lea     esi,[edx].@workspc

        MOV     WORD PTR R0,0           ;INITIALIZE TO ZEROS FOR RESULT
        MOV     ECX,8

;         OR,R      +,,
;         XOR       CH,F0,F0  XOR 8 BYTES OF NAME
;         BNEL      8,PL,*-2
;         SPACE
;         ACX,0     F1F0,F1F0,PHPL      PHPL = 2 * XOR(FILENAME)

BP41M_03:
        lodsb
        XOR     R0,AL
        LOOP    BP41M_03

        MOV     DX,WORD PTR R0
        SHL     DX,1                   ; DX=2 *XOR(FILENAME)

;         ACX,0     F1F0,PHPL,F1F0      F1F0 = 3 * XOR(FILENAME)
;         AC,0      F0,F1,F0  F0 = F1 + F0
;HASH3    BLR       F0,F2,*+2
;         SC,1      F0,F2,F0  F0 = F0 MOD (NO. OF INDEX SECTORS)
;         BLER      F2,F0,*-1

        ADD     WORD PTR R0,DX          ;R1R0= 3*XOR(FILENAME)
        MOV     AL,R1
        ADD     R0,AL                   ;R0=R0+R1
HASH3:
        MOV     AL,R0
        MOV     AH,0
        DIV     R2                      ;AH= REMAINDER
        MOV     R0,AH                   ;AL= QUOTIENT

;         MV        F0,PL
;         MVI       0,PH
;         TPA       ,F        AUXF = HASH VALUE (SECTOR ADDRESS)
;         SR

        MOV     DL,R0
        MOV     DH,0
        MOV     AUX0F,EDX
        RET


;*        NEW HASH ALGORITHM
;NEWHASH  SB        RWORKSPC  PT TO FILENAME
;         XOR       F1,F1,F1  ZERO F1 OF RESULT AREA, F0 = MV
;NEWHASH2 OR,R      +,,       GET A BYTE OF FILENAME
;         MV        CH,F0     PUT INTO F0
;         BFL       01,PL,NEWHASH3      BR IF BYTE POS = ODD
;         SHLH      F0,F0,F0  EXCHANGE NIBBLES

 NEWHASH:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@workspc

        MOV     R1,0            ;INITIALIZE R1 FOR RESULT STORAGE
        MOV     CL,1
NEWHASH2:
        MOV     CH,[EDX]
        INC     EDX
        MOV     R0,CH
        TEST    CL,01           ; EVEN OR ODD TEST !
        JZ      NEWHASH3
        MOV     AL,R0
        ROR     AL,4
        MOV     R0,AL

;NEWHASH3 AC,0      F0,F1,F1  ADD BYTE TO TOTAL
;         BNEL      8,PL,NEWHASH2       BR IF ALL 8 BYTES HAVE NOT BEEN PROCESSED
;         MV        F1,F0     PUT SUM IN F0 TO MAKE USE OF OLD CODE
;         B         HASH3

NEWHASH3:
        MOV     AL,R0
        ADD     R1,AL
        INC     CL
        CMP     CL,9
        JNZ     NEWHASH2
        MOV     AL,R1
        MOV     R0,AL
        JMP     HASH3

;         TITLE     ZEROFIL#
;*     ZEROFIL#: ZERO START, CURRENT, AND END ADDRESSES
;*               IN THE SPECIFIED #n DEVICE TABLE SLOT.
;*
;*          ENTRY: PHASE = EXECUTION
;*                 @FILE#,byte 2 = FILE#
;*
;*          RETURN: PC'S POINTS AFTER END ADDRESS IN
;*                    #n DEVICE TABLE SLOT
;*                  F0 = 0
;*
;*          MODIFIED REGISTERS: PC'S,F0,F1,AUX0
;*
;         ORG       *
;ZEROFIL# SB        FILE#PTR  POINT TO #n DEVICE TABLE SLOT
;         TPA-2     ,0
;         XPA       ,0
;         MVI,R     6,F0

ZEROFIL_:
        CALL    FILE_PTR

        and     byte ptr [edx-2],0fh
        mov     dword ptr [edx],0
        mov     word ptr [edx+4],0
        add     edx,6
        mov      r0,0


;         ANDI,W1   0F,CH,    PLATTER SPEC. = 0 IN #n DEVICE TABLE SLOT
;         TAP       ,0
;         OR,W1     +,,       ZERO START, CURRENT, AND END ADDRESSES
;         SC,0      F0,,F0    DECREMENT COUNT


;         BNEL      0,F0,*-2  BRANCH IF MORE TO ZERO
;         SR

        RET

;         TITLE     PUTFLPTR
;*     PUTFLPTR: GET THE START AND END OF FILE ADDRESSES
;*               FROM THE SECTOR READ (I/O BUFFER) AND SET
;*               THE START, CURRENT (=START), AND END
;*               ADDRESSES IN THE SPECIFIED FILE# DEVICE
;*               TABLE SLOT.
;*
;*          ENTRY: PC'S = ADDRESS OF START ADDRESS IN I/O
;*                        BUFFER (THIS IS AN EVEN ADDRESS;
;*                        END ADDRESS FOLLOWS START)
;*                 PHASE = EXECUTION
;*                 @FILE#,byte 2 = FILE#
;*
;*          RETURN: START,CURRENT,END ==> #n DEV.TBL. SLOT
;*                    (16 BIT OF ADDRS ZEROED)
;*                  CH,CL = END ADDRESS OF FILE
;*                  PC'S = ADDRESS OF END IN DEV.TBL. SLOT
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,AUX0,F0,1
;*
;         ORG       *
;PUTFLPTR TPA       ,0        SAVE ADDRESS OF FILE PTRS IN SECTOR READ
;         SB        FILE#PTR  POINT TO FILE# DEVICE TABLE SLOT
;         XPA       ,ACTDEV
;         MV        PH,F0     F0 = DEVICE TYPE
;         XPA       ,ACTDEV
;         XPA       ,0
;         XPA+2,R   ,0        GET START ADDRESS OF FILE FROM SECTOR READ
;         OR,W1     CH,,
;         BEQL      #PHOENIX,F0,*+2     DON'T STRIP OFF 16TH BIT IF PHOENIX
;         ANDI,W1   7F,CH,
;         OR,W2     +,CL,     START ADDRESS ==> DEVICE TABLE SLOT
;         OR        +,,
;         OR,W1     CH,,
;         BEQL      #PHOENIX,F0,*+2     DON'T STRIP OFF 16TH BIT IF PHOENIX
;         ANDI,W1   7F,CH,
;         XPA+2,W2  CL,0      CURRENT ADDRESS (=START) ==> DEV.TBL. SLOT
;         XPA,R     ,0        GET END ADDRESS OF FILE FROM SECTOR READ
;         OR,W1     CH,,
;         BEQL      #PHOENIX,F0,*+2     DON'T STRIP OFF 16TH BIT IF PHOENIX
;         ANDI,W1   7F,CH,
;         SR,W2     CL        END ADDRESS ==> DEVICE TABLE SLOT

PUTFLPTR:
        mov     aux00,edx
        call    file_ptr                ;esi = source
        mov     esi,aux00               ;edx = destination
        mov     eax,actdev
        and     ah,0fh
        mov     cx,[esi]
        cmp     ah,_phoenix
        jz      putfl1
        and     cl,7fh
putfl1:
        mov     [edx],cx
        mov     [edx+2],cx

        add     edx,4
        mov     cx,[esi+2]
        cmp     ah,_phoenix
        jz      putfl2
        and     cl,7fh
putfl2:
        mov     [edx],cx
        xchg    ch,cl
        ret



;         TITLE     PUTFLPTS
;*     PUTFLPTS: PUT START, CURRENT, AND END OF FILE
;*               ADDRESSES INTO #N DEVICE TABLE SLOT.
;*
;*          ENTRY: PHASE = EXECUTION
;*                 @FILE#,byte 2  = FILE #
;*                 F5,4 = START (=CURRENT) ADDRESS
;*                 F7,6 = END ADDRESS
;*
;*          RETURN: PC'S POINT TO END ADDRESS IN #n
;*                    DEVICE TABLE SLOT
;*
;*          MODIFIED REGISTERS: PC'S,F0,1,CH,CL
;*
;         ORG       *
;PUTFLPTS SB        FILE#PTR  POINT TO #n DEVICE TABLE SLOT
;         OR,W1     +,F5,
;         OR,W1     +,F4,     START ADDRESS ==> DEVICE TABLE
;         OR,W1     +,F5,
;         OR,W1     +,F4,     CURRENT (=START) ==> DEVICE TABLE

PUTFLPTS:
        CALL    FILE_PTR
        mov     ax,word ptr r4
        xchg    ah,al
        mov     [edx],ax
        mov     [edx+2],ax

;         OR,W1     F7,,
;         SR,W2     F6        END ADDRESS ==> DEVICE TABLE

        mov     ax,word ptr r6
        xchg    ah,al
        mov     [edx+4],ax
        add     edx,4
        RET

;         TITLE     PUTCPTR
;*     PUTCPTR: PUT CURRENT SECTOR ADDRESS ==> #n DEVICE
;*            TABLE SLOT
;*
;*          ENTRY (EXECUTION PHASE):
;*               @FILE#,byte 2 = FILE#
;*               AUXF = CURRENT SECTOR ADDRESS
;*
;*          RETURN (EXECUTION PHASE):
;*               F1,0 = CURRENT SECTOR ADDRESS
;*               PC'S = ADDRESS OF CURRENT SECTOR IN
;*                      #n DEVICE TABLE SLOT
;*
;*          MODIFIED REGISTERS: PC'S,F0-1,CH,CL
;*
;         ORG       *
;PUTCPTR  BFL       2,SL,PUTCPTR1       BRANCH IF NOT EXECUTION PHASE
;         SB        FILE#PTR  POINT TO #n DEVICE TABLE SLOT
;         XPA+2     ,F

PUTCPTR:
        TEST    SL,2
        JZ      PUTCPTR1
        CALL    FILE_PTR
        XCHG    EDX,AUX0F
        ADD     AUX0F,2

;         MVX       PHPL,F1F0 F1,0 = CURRENT SECTOR ADDRESS
;         XPA       ,F        POINT TO CURRENT ADDRESS POSITION IN DEV.TBL SLOT
;         OR,W1     F1,,
;         SR,W2     F0        CURRENT SECTOR ADDRESS ==> #n DEVICE TABLE SLOT

        MOV     WORD PTR R0,DX
        XCHG    EDX,AUX0F

        mov     ax,word ptr r0
        xchg    ah,al
        mov     [edx],ax

        RET

;         TITLE     GETFLPTR GTFLPTRS
;*     GETFLPTR: GET THE START,CURRENT, & END FILE
;*               ADDRESSES FROM THE #n DEVICE TABLE SLOT
;*
;*          ENTRY (EXECUTION PHASE): @FILE#,byte 2 = FILE#
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXB = START ADDRESS OF FILE
;*               AUXD = END ADDRESS OF FILE
;*               AUCF = CURRENT ADDRESS OF FILE
;*               CH,CL = END ADDRESS OF FILE
;*               PC'S = ADDRESS OF END ADDRESS IN #n
;*                      DEVICE TABLE SLOT
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-1,AUXB,D,F
;*                              (EXECUTION PHASE ONLY)
;*
;*     GTFLPTRS: GET START & END FILE ADDRESSES FROM RAM
;*
;*          ENTRY (EXECUTION PHASE):
;*               AUXC = ADDR OF START OF FILE ADDR IN RAM
;*                      (START ADDRESS FOLLOWED BY END ADR
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXB = START OF FILE ADDRESS (16TH BIT 0)
;*               AUXD = END OF FILE ADDRESS (16TH BIT 0)
;*               CH,CL = EOF ADDRESS (16TH BIT NOT ZEROED)
;*               PC'S = ADDRESS OF EOF ADDRESS IN RAM
;*          MODIFIED REGISTERS (EXECUTION PHASE):
;*               PC'S,CH,CL,AUXB,D
;*
;GETFLPTR BFL       2,SL,GETFLPT1       BRANCH IF NOT EXECUTION PHASE
;         SB        FILE#PTR  POINT TO SPECIFIED #N DEVICE TABLE SLOT
;         TPA+2,R   ,B        GET START ADDRESS OF FILE FROM DEV.TBL SLOT
;         MVX       CHCL,PHPL
;         XPA       ,B        AUXB = START ADDRESS

GETFLPTR:
        TEST    SL,2
        JZ      GETFLPT1
        CALL    FILE_PTR

        xor     ecx,ecx
        MOV     CX,[EDX]
        XCHG    CH,CL
        mov     aux0b,ecx

;         TPA+2,R   ,F        GET CURRENT ADDRESS OF FILE FROM DEV.TBL. SLOT
;         MVX       CHCL,PHPL
;         XPA       ,F        AUXF = CURRENT ADDRESS

        MOV     CX,[EDX+2]
        XCHG    CH,CL
        MOV     AUX0F,Ecx

;         TPA,R     ,D        GET END ADDRESS OF FILE FROM DEV.TBL. SLOT
;         MVX       CHCL,PHPL
;         XPA       ,D        AUXD = END  ADDRESS

        MOV     CX,[EDX+4]
        XCHG    CH,CL
        MOV     AUX0D,EcX
        add     edx,4


;GETFLPT1 SR
;PUTCPTR1 EQU       GETFLPT1  'SR' EQUATE
;GTFLPTRS BFL       2,SL,GETFLPT1       EXIT IF NOT EXECUTION PHASE
;         TAP       ,C
;         TPA+2,R   ,B        GET START OF FILE ADDRESS
;         TAP       ,ACTDEV
;         BEQL      #PHOENIX,PH,GTFLPTS1 BRANCH IF DEVICE TYPE 'D' (PHOENIX)
;         MVX       CHCL,PHPL
;         ANDI      7F,PH,PH  STRIP OFF 16TH BIT
;         XPA       ,B        AUXB = START OF FILE ADDRESS
;         TPA,R     ,D        GET END ADDRESS
;         MVX       CHCL,PHPL PC'S = EOF ADDRESS
;         ANDI      7F,PH,PH  STRIP OFF 16TH BIT
;         XPA       ,D        AUXD = EOF ADDRESS
;         SR
;GTFLPTS1 MVX       CHCL,PHPL
;         XPA       ,B        AUXB = START OF FILE ADDRESS
;         TPA,R     ,D
;         MVX       CHCL,PHPL
;         XPA       ,D        AUXD = EOF ADDRESS
;         SR

GETFLPT1:
PUTCPTR1:
        RET
GTFLPTRS:
        TEST    SL,2
        JZ      GETFLPT1

        xor     ecx,ecx
        mov     eax,actdev
        and     ah,0fh
        MOV     EDX,AUX0C
        MOV     CX,[EDX]
        xchg    ch,cl
        cmp     ah,_phoenix
        jz      gtflpt1
        and     ch,7fh
gtflpt1:
        mov     aux0b,ecx

        mov     cx,[edx+2]
        xchg    ch,cl
        cmp     ah,_phoenix
        jz      gtflpt2
        and     ch,7fh
gtflpt2:
        mov     aux0d,ecx
        add     edx,2
        ret


;         TITLE     NWFLADRS
;*     NWFLADRS: AUXB = CURRENT END OF CAT. AREA + 1
;*               AUXD = END OF CATALOG AREA
;*
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED
;*                 AUXE = PLATTER
;*
;*          RETURN: AUXB = CURRENT END OF CAT. AREA +1
;*                  AUXD = END OF CATALOG AREA
;*                  PC'S = END OF CAT. AREA +1
;*                  AUXC = ADDRESS OF I/O BUFFER
;*                  SECTOR 0 ==> I/O BUFFER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1
;*                              AUX0,C,F,B,D
;*
;         ORG       *
;NWFLADRS SB        CURENDR   READ SECTOR 0 & GET CURRENT CAT. END ADDR
;         TPA+1     ,B        AUXB = CURRENT END ADDRESS +1
;         SB        CATEND    GET CAT. END ADDRESS
;         TPA       ,D        AUXD = CAT. END ADDRESS
;         SR

NWFLADRS:
        CALL    CURENDR
        MOV     AUX0B,EDX
        INC     AUX0B
        CALL    CATEND
        MOV     AUX0D,EDX
        RET

;         TITLE     PUTPLTTR
;*     PUTPLTTR: PUT PLATTER SPECIFICATION INTO #n DEVICE
;*               TABLE SLOT.
;*
;*          ENTRY: PHASE = EXECUTION
;*               AUXE,LOW 4-BITS = PLATTER SPEC. (0-4)
;*                  IF 0, PLATTER = 1 (F) IF DEVICE TYPE=3
;*                                  2 (R) IF DEVICE TYPE=B
;*               @FILE#,BYTE 2 = FILE#
;*               LOW 4-BITS OF 1ST BYTE OF #n DEVICE TABLE
;*                    ENTRY = DEVICE TYPE
;*
;*          RETURN: HIGH 4-BITS OF 1ST BYTE OF #n DEVICE
;*                    TABLE SLOT = PLATTER SPEC.
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1
;*
;         ORG       *
;PUTPLTTR SB        FILE#PTR  POINT TO #n DEVICE TABLE SLOT
;         OR        -,,
;         OR        -,,
;         XPA,R     ,E        GET DEVICE TYPE (CH)

PUTPLTTR:
        CALL    FILE_PTR
        SUB     EDX,2
        MOV     CH,[EDX]
        XCHG    EDX,AUX0E

;         SHLL      CH,PL,F0  F0 = pt WHERE p = PLATTER, t = DEVICE TYPE
;         XPA       ,E
;         OR,W1     F0,,      F0 ==> BEGIN OF #n DEVICE TABLE SLOT
;         BNEH      0,F0,PUTPLTR1       BRANCH IF PLATTER SPEC <> 'T'
;         ORI,W1    10,F0,    PLATTER = 'F' IF DEVICE TYPE = 3

        MOV     AH,DL
        AND     AH,0FH
        SHL     AH,4
        MOV     AL,CH
        AND     AL,0FH
        OR      AH,AL
        MOV     R0,AH
        XCHG    EDX,AUX0E
        MOV     BYTE PTR [EDX],AH
        TEST    R0,0F0H
        JNZ     PUTPLTR1
        MOV     AL,R0
        OR      AL,10H
        MOV     [EDX],AL

;         BEQL      3,F0,PUTPLTR1
;         ORI,W1    20,F0,    PLATTER = 'R' IF DEVICE TYPE = B
;         BEQL      0B,F0,PUTPLTR1
;         ORI,W1    30,F0,    PLATTER = 'T' SINCE DEVICE TYPE = 'D'
;PUTPLTR1 SR

        CMP     R0,3
        JZ      PUTPLTR1
        MOV     AL,R0
        OR      AL,20H
        MOV     [EDX],AL
        CMP     R0,0BH
        JZ      PUTPLTR1
        MOV     AL,R0
        OR      AL,30H
        MOV     [EDX],AL
PUTPLTR1:
        RET

;         TITLE     GETPLTTR
;*     GETPLTTR: GET PLATTER SPEC. FROM #n DEVICE TABLE
;*               SLOT IF EXECUTION PHASE
;*
;*          ENTRY: HIGH 4-BITS OF 1ST BYTE OF #n DEVICE
;*                    TABLE SLOT = PLATTER SPEC.
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXE,BITS0-3 = PLATTER SPEC.
;*
;*          ERROR CONDITIONS:
;*               80 = FILE NOT OPEN (PLATTER = 0)
;*
;*          MODIFIED REGISTERS (EXECUTION  PHASE):
;*               PC'S,CH,CL,F0,1,AUXE
;*
;         ORG       *
;GETPLTTR BFL       2,SL,GETPLTR1       BRANCH IF NOT EXECUTION PHASE
;         SB        FILE#PTR  POINT TO #n DEVICE TABLE SLOT
;         OR        -,,
;         OR        -,,
;         XPA,R     ,E        GET PLATTER SPEC.
;         BEQH      0,CH,ERROR#80       ERROR IF FILE NOT OPEN (PLATTER = 0)

GETPLTTR:
        TEST    SL,2
        JZ      GETPLTR1
        CALL    FILE_PTR
        SUB     EDX,2
        MOV     CH,[EDX]
        XCHG    EDX,AUX0E
        TEST    CH,0F0H
        JZ     ERROR_80

;         ANDI      0F0,PL,PL
;         BEQH      3,CH,*+2  BRANCH IF 'T' FOR DEVICE TYPE 'D'
;         SHHH      CH,PL,PL
;         XPA       ,E        PLATTER SPEC ==> AUXE
;GETPLTR1 SR
;ERROR#80 MVI       80,F0     FILE NOT OPEN
;         B         ERROR

        AND     DL,0F0H
        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,30H
        JZ      BP41O_01
        MOV     AL,CH
        SHR     AL,4
        OR      DL,AL
BP41O_01:
        XCHG    EDX,AUX0E
GETPLTR1:
        RET
ERROR_80:
        MOV     R0,80H
        JMP     ERROR

;         TITLE     CATEND
;*     CATENDR: READ SECTOR 0 & GET END OF CAT. AREA ADDR
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = PLATTER
;*
;*          RETURN: PC'S = END CAT. AREA ADDR (16TH BIT 0)
;*                  AUXC = ADDRESS OF IOBUFFER
;*                  AUXF = 1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1,AUX0,C,F
;*
;*     CATEND: GET END OF CAT. AREA ADDRESS FROM I/O BUFFR
;*
;*          ENTRY: SECTOR 0 IN I/O BUFFER
;*
;*          RETURN: PC'S = END CAT. AREA ADDR (16TH BIT 0)
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL
;*
;         ORG       *
;CATENDR  SB        DREADS0   READ SECTOR 0 FROM DISK
;         SPACE
;CATEND   SB        RIOBUFRH
;         MVI       4,PL      POINT TO 'IOBUFFER+4'
;         B         CUREND1   PC'S = END CAT. AREA ADDR

CATENDR:
        CALL    DREADS0
CATEND:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        ADD     EDX,4
        JMP     CUREND1

;         TITLE     CUREND
;*     CURENDR: READ SECTOR 0 & GET CURRENT CAT. END ADDR
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = PLATTER
;*
;*          RETURN: PC'S = CURRENT CAT. END   (16TH BIT 0)
;*                  AUXC = ADDRESS OF IOBUFFER
;*                  AUXF = 1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1,AUX0,C,F
;*
;*     CUREND: GET CURRENT CAT. END ADDRESS FROM I/O BUFFR
;*
;*    CUREND1: CHECK DEVICE TYPE (C0 OR D0) AND ADJUST END IF C0
;*             ORIGINALLY USED BY MOVE
;*
;*          ENTRY: SECTOR 0 IN I/O BUFFER
;*
;*          RETURN: PC'S = CURRENT CAT. END   (16TH BIT 0)
;*
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL
;*
;         ORG       *
;CURENDR  SB        DREADS0   READ SECTOR 0 FROM DISK
;         SPACE
;CUREND   SB        RIOBUFRH
;         MVI       2,PL      POINT TO 'IOBUFFER+2'

CURENDR:
        CALL    DREADS0
CUREND:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        ADD     EDX,2

;CUREND1  TAP,R     ,ACTDEV   GET CURRENT CAT. END ADDRESS
;         BEQL      #PHOENIX,PH,CUREND2 DON'T STRIP OFF 16TH BIT IF PHOENIX
;         ANDI      7F,CH,PH
;         OR        CL-,,PL   PC'S = CURRENT CAT. END ADDRESS
;         SR
;         SPACE

CUREND1:
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     EDX,ACTDEV
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JE      CUREND2
        AND     CH,7FH
        dec     cx
        MOV     DX,CX
        RET

;CUREND2  MVX       CHCL,PHPL
;         OR        -,,
;         SR
;ENDMOD41 EQU       *

CUREND2:
        MOV     DX,CX
        DEC     EDX
        RET

;         TITLE     SCRATCHD (SCRATCH DISK)
;*     SCRATCHD: PROCESS A 'SCRATCH DISK' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               SCRATCH DISK platter [ file#,   ]
;*                                    [disk-addr,]
;*
;*                    [LS=expression,] END=expression
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'SCRATCH'
;*
;*          DESCRIPTION:
;*               1. END SECTOR IS READ TO BE SURE SECTOR
;*                  IS ON PLATTER
;*               2. SECTOR ZERO IS WRITTEN (R/W) WITH NO.
;*                  OF INDEX SECTORS, CURRENT END (= NO.
;*                  OF INDEX SECTORS), END CAT. AREA VALUE
;*               3. ALL OTHER SECTORS OF INDEX ARE ZEROED
;*                  (WITH READ-AFTER-WRITE)
;*
;*          NOTE: 2600 PERFORMS READ-AFTER-WRITE ON ALL
;*                SECTORS WRITTEN BY 'SCRATCH DISK'.
;*                THE 2200 DOES NOT.
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               AUX3,C,E,F IN EXECUTION PHASE ONLY
;*
;         ORG       *
;SCRATCHD MVI       @DISK,F0
;         SB        CCL       LOOK FOR 'DISK'
;         BNEL      0,F0,SCRATCHF       NF, BRANCH (SCRATCH A FILE)
;         SB        NXTCHSQT  Look for a single quote
;         MVI       00,PH     Set for old type of hash
;         BNEL      0,F0,SCRATCH4       Branch if a single quote was not found
;         MVI       01,PH     Set for new type of hash

SCRATCHD:
        MOV     R0,@DISK
        CALL    CCL
        TEST    R0,0FH
        JNZ     SCRATCHF
        MOV     DH,0
        CMP     BYTE PTR [TEXTPTR],27H
        JNE     SCRATCH1X
        INC     TEXTPTR
        MOV     DH,1
SCRATCH1X:
;SCRATCH4 BNEL      2,SL,SCRATCH6
;         MV        PH,F0     Save first byte of sector zero
;         SB        RHASHFLG  READ HASH FLAG
;         OR,W1     +,F0,     .

SCRATCH4:
        CMP     SL,2
        JNE     SCRATCH6
        MOV     R0,DH
        CALL    RHASHFLG
        MOV     AL,R0
        MOV     [EDX],AL
        INC     EDX

;SCRATCH6 SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAWOFF    READ-AFTER-WRITE OFF
;         SB        DISKSELC  PROCESS #n,  OR /xyy,
;         MVI       @LS=,F0
;         SB        CCL       LOOK FOR 'LS='
;         BNEL      0,F0,SCRATCH1       NF, BRANCH

SCRATCH6:
        CALL    PLATTER
        CALL    RAWOFF
        CALL    DISKSELC
        MOV     R0,@LS?EQ
        CALL    CCL
        TEST    R0,0FH
        JNZ     SCRATCH1

;         SB        EXPR      PROCESS NO. OF INDEX SECTORS EXPRESSION
;         SB        GETCHCOM  LOOK FOR COMMA
;         BFL       2,SL,SCRATCH2       BRANCH IF NOT EXECUTION PHASE
;         SB        FLTBINA   CONVERT NO. OF INDEX SECTORS TO BINARY
;         BEQL      0,F2,ERR#34B        ERROR IF NO. OF INDEX SECTORS = 0
;         MVX       F1F0,PHPL

        CALL    EXPR
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ERROR_13
        INC     TEXTPTR
        TEST    SL,2
        JZ      SCRATCH2
        CALL    FLTBINA
        TEST    R2,0FH
        JZ      ERR_34B
        MOV     DX,WORD PTR R0

;SCRATCH5 TPA       ,3        SAVE NO. OF INDEX SECTORS
;SCRATCH2 MVI       @END,F0
;         SB        CCL       LOOK FOR 'END'
;         BEQL      0,F0,*+2  B IF FOUND
;         B         ERR#19U   .ERROR IF NOT FOUND

SCRATCH5:
        MOV     AUX03,EDX       ;AUX03 SAVE NO. OF INDEX SECTOR
SCRATCH2:
        MOV     R0,@END
        CALL    CCL
        TEST    R0,0FH
        JZ      BP41X_01
        JMP     ERR_19U

;         SB        GETCHEQL  LOOK FOR '='
;         SB        EXPR      PROCESS CATALOG END EXPRESSION
;         BFL       2,SL,SCRATCH3       EXIT IF NOT EXECUTION PHASE
;         SB        FLTBINB   COVERT CATALOG END VALUE TO BINARY
;         TAP       ,3
;         BLRX      F1F0,PHPL,ERROR#86  ERROR IF END < NO. OF INDEX SECTORS

BP41X_01:
        CMP     BYTE PTR [TEXTPTR],'='
        JNE     ERROR_12
        INC     TEXTPTR
        CALL    EXPR
        TEST    SL,2
        JZ      SCRATCH3
        CALL    FLTBINB
        MOV     EDX,AUX03
        CMP     WORD PTR R0,DX
        JB      ERROR_86

;         ACX,1     DD,F1F0,F3F2        INCREMENT END
;         MV        PL,F4     F4 = NO. OF INDEX SECTORS
;         SB        INTINDX   INITIALIZE PLATTER INDEX
;*     READ INDEX TO BE SURE WRITTEN OK (4 X's FASTER
;*          THAN READ-AFTER-WRITE
;         TAP       ,3

        MOV     AX,WORD PTR R0
        INC     AX
        MOV     WORD PTR R2,AX          ;R2R3 = END +1
        MOV     R4,DL
        CALL    INTINDX
        MOV     EDX,AUX03

;         MV        PL,F4     F4 = NO. OF INDEX SECTORS
;         ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,F
;         SB        DREADSF   READ NEXT INDEX SECTOR
;         SC,0      F4,,F4
;         BNR       F4,,*-2   BRANCH IF MORE INDEX SECTORS

        MOV     R4,DL
        MOV     EDX,0
        MOV     AUX0F,EDX
BP41X_02:
        CALL    DREADSF
        DEC     R4
        JNZ      BP41X_02

;SCRATCH3 B         ENDSDISK  DISABLE DISK; EXIT
;SCRATCH1 BFL       2,SL,SCRATCH2       BRANCH IF NOT EXECUTION PHASE
;         LPI       0018      DEFAULT NO. OF INDEX SECTORS = 24
;         B         SCRATCH5

SCRATCH3:
        JMP     ENDSDISK
SCRATCH1:
        TEST    SL,2
        JZ      SCRATCH2
        MOV     EDX,18H
        JMP     SCRATCH5

;ERROR#86 MVI       86,F0     CATALOG END ERROR
;         B         ERROR
;ERR#34B  B         ERROR#34  ILLEGAL VALUE

ERROR_86:
        MOV     R0,86H
        JMP     ERROR
ERR_34B:
        JMP     ERROR_34

;         TITLE     SCRATCHF (SCRATCH FILE)
;*     SCRATCHF: PROCESS A 'SCRATCH file' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               SCRATCH platter [file#,   ]
;*                               [disk-addr,]
;*
;*                    filename [,filename]...
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'SCRATCH'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,E,F
;*
;SCRATCHF SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSELC  PROCESS #n,  OR /xyy, SPECIFICATION
;SCRTCHF2 SB        FILENAMH  SCAN FOR FILENAME
;         BFL       2,SL,SCRTCHF1       BRANCH IF NOT EXECUTION PHASE
;         BNEH      1,F3,SCRTCHF3       ERROR IF FILENAME NOT IN INDEX
;         TAP       ,C

SCRATCHF:
        CALL    PLATTER
        CALL    DISKSELC
SCRTCHF2:
        CALL    FILENAMH
        TEST    SL,2
        JZ      SCRTCHF1
        MOV     AL,R3
        AND     AL,0F0H
        CMP     AL,10H
        JNZ     SCRTCHF3
        MOV     EDX,AUX0C

;         ORI,W1    11,,      ENTRY STATUS OF FILE = SCRATCHED (IN I/O BUFFER)
;         SB        RAWON     FLAG = READ-AFTER-WRITE
;         SB        DWRITE$F  WRITE UPDATED INDEX SECTOR

        MOV     BYTE PTR [EDX],11H       ; STATUS = 11 PRESENTS SCRATCH
        CALL    RAWON
        CALL    DWRITE?DAF

;SCRTCHF1 SB        NXTCHCOM  LOOK FOR COMMA
;         BEQL      0,F0,SCRTCHF2       BRANCH IF FOUND
;         B         ENDSDISK  DISABLE DISK, EXIT
;SCRTCHF3 B         ERROR#82  FILE NOT IN CATALOG

SCRTCHF1:
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ENDSDISK
        INC     TEXTPTR
        JMP     SCRTCHF2
SCRTCHF3:
        JMP     ERROR_82

;         TITLE     SKBSARG
;*     SKBSARG: PROCESS A 'DSKIP' OR 'DBACKSPACE'
;*              ARGUMENT
;*
;*          ARGUMENT FORMAT: expression [S]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'DSKIP' OR
;*                 'DBACKSPACE'
;*
;*          RETURN: TEXTPTR POINTS AFTER ARGUMENT
;*               IF NOT EXECUTION PHASE,
;*                    A BRANCH IF MADE TO ENDSTMT
;*               IF EXECUTION PHASE,
;*                    F7,6 = BINARY VALUE OF EXPRESSION
;*                           (0 <= VALUE < 65536)
;*                    F0 = 0 IF 'S' FOUND
;*                         1 IF 'S' NOT FOUND
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*
;         ORG       *
;SKBSARG  SB        EXPR      SCAN & PROCESS EXPRESSION
;         BFL       2,SL,SKBSARG1       BRANCH IF NOT EXECUTION PHASE
;         SB        FLTBINB   CONVERT EXPRESSION VALUE TO BINARY
;         MVX       F1F0,F7F6 F7,6 = BINARY VALUE
;         B         NXTCHS    LOOK FOR 'S'

SKBSARG:
        CALL    EXPR
        TEST    SL,2
        JZ      SKBSARG1
        CALL    FLTBINB
        MOV     AX,WORD PTR R0
        MOV     WORD PTR R6,AX
        MOV     R0,1
        CMP     BYTE PTR [TEXTPTR],'S'
        JNE     SKBSARG1X
        INC     TEXTPTR
        MOV     R0,0
SKBSARG1X:
        RET

;SKBSARG1 SB        NXTCHS    LOOK FOR 'S'
;         B         ENDSTMT   EXIT

SKBSARG1:
        MOV     R0,1
        CMP     BYTE PTR [TEXTPTR],'S'
        JNE     ENDSTMT
        INC     TEXTPTR
        MOV     R0,0
        JMP     ENDSTMT

;         TITLE     WRTEOF
;*     WRTEOF: WRITE END OF FILE BLOCK WITH NO. OF SECTORS
;*             USED IN FILE
;*
;*          ENTRY:
;*               PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = FILE#,PLATTER,R/W,ETC
;*               AUXB = START ADDRESS OF FILE
;*               AUXD = EOF SECTOR ADDRESS
;*               PC'S = SECTOR ADDRESS OF TRAILER BLOCK
;*                      OF FILE
;*               F7 = FILETYPE (80 IF PROGRAM, 00 IF DATA)
;*
;*          RETURN:
;*               EOF BLOCK IN I/O BUFFER
;*               EOF WRITTEN TO DISK
;*
;*         MODIFIED REGISTERS: PC'S,K,CH,CL,F0,F1,AUX0,1,F
;*
;*     WRTEOFA: SAME AS 'WRTEOF' EXCEPT FOR ENTRY
;*
;*          ENTRY: SAME AS 'WRTEOF' EXCEPT
;*               F2,1 = NO. OF SECTORS USED BY FILE
;*               PC'S NOT SET
;*               AUXB NOT SET
;*
;*     WRTEOF1: SAME AS 'WRTEOFA' EXCEPT NO. OF SECTORS
;*              USED IS ASSUMED TO BE 1
;*
;         ORG       *
;WRTEOF1  MVI       0,F2
;         MVI       1,F1      NO. OF SECTORS USED = 1
;         B         WRTEOFA

WRTEOF1:
        MOV     WORD PTR R1,1
        JMP     WRTEOFA

;WRTEOF   ACX,1     DD,PHPL,F2F1        F2,1 = ADDRESS OF TRAILER BLOCK +1
;         TAP       ,B        PC'S = START ADDRESS OF FILE
;         SCX,1     F2F1,PHPL,F2F1      F1,0 = NO. OF SECTORS USED IN FILE

WRTEOF:
        MOV     WORD PTR R1,DX
        INC     WORD PTR R1
        MOV     EDX,AUX0B
        SUB     WORD PTR R1,DX

;WRTEOFA  SB        RIOBUFFR  POINT TO I/O BUFFER
;         SB        ZERO256   ZERO BUFFER
;         AI        0FF,PH,PH POINT TO I/O BUFFER
;         ORI,W1    0A0,,     CONTROL BYTE = DATA EOF
;         BEQH      0,F7,*+2  BRANCH IF DATA FILE
;         ORI,W1    020,,     CONTROL BYTE = PROGRAM EOF

WRTEOFA:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     ECX,64          ;ECX = LOOP COUNT
        MOV     EDI,EDX
        MOV     EAX,0
        REP     STOSD                   ;SET DATA MEMORY TO ZERO
        MOV     BYTE PTR [EDX],0A0H
        TEST    R7,0F0H
        JZ      BP41X_03
        MOV     BYTE PTR [EDX],020H

;         TPA       ,F        AUXF = ADDRESS OF I/O BUFFER
;         OR        +,,
;         OR,W1     +,F2,     NO. OF SECTORS USED ==> I/O BUFFER
;         TAP,W1    F1,D      PC'S = END SECTOR ADDRESS OF FILE
;         B         DWRITE$   WRITE END OF FILE SECTOR (WITH NO. OF USED SECTORS

BP41X_03:
        MOV     AUX0F,EDX
        INC     EDX
        MOV     AL,R2
        MOV     BYTE PTR [EDX],AL
        INC     EDX
        MOV     AL,R1
        MOV     [EDX],AL
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@spreg6,1
        JNE     yyyyy
        test    r7,0c0h                          ;data file
        jz      yyyyy
        inc     edx
        add     edx,4
        mov     byte ptr [edx],01h              ;rep. date & time exist
        inc     edx
in_update:
        mov     byte ptr fs:[rtcaddr],0ah
        nop
        nop
        nop
        mov     al,byte ptr fs:[rtcdata]
        test    al,80h
        jnz     in_update

        mov     byte ptr fs:[rtcaddr],08h
        nop
        nop
        nop
        mov     al,byte ptr fs:[rtcdata]        ;month
        mov     ah,al
        shr     ah,4
        and     al,0fh
        add     ax,3030h
        cmp     ah,30h
        jne     p_1
        mov     ah,20h
p_1:
        mov     byte ptr [edx],ah
        mov     byte ptr [edx+1],al
        mov     byte ptr [edx+2],"-"

        mov     byte ptr fs:[rtcaddr],07h
        nop
        nop
        nop
        mov     al,byte ptr fs:[rtcdata]        ;day
        mov     ah,al
        shr     ah,4
        and     al,0fh
        add     ax,3030h
        mov     byte ptr [edx+3],ah
        mov     byte ptr [edx+4],al
        mov     byte ptr [edx+5],"-"

        mov     byte ptr fs:[rtcaddr],09h
        nop
        nop
        nop
        mov     al,byte ptr fs:[rtcdata]        ;year
        mov     ah,al
        shr     ah,4
        and     al,0fh
        add     ax,3030h
        mov     byte ptr [edx+6],ah
        mov     byte ptr [edx+7],al
        mov     byte ptr [edx+8],20h

        mov     byte ptr fs:[rtcaddr],04h
        nop
        nop
        nop
        mov     al,byte ptr fs:[rtcdata]        ;hour
        mov     ah,al
        shr     ah,4
        and     al,0fh
        add     ax,3030h
        cmp     ah,30h
        jne     p_3
        mov     ah,20h
p_3:
        mov     byte ptr [edx+9],ah
        mov     byte ptr [edx+10],al
        mov     byte ptr [edx+11],":"

        mov     byte ptr fs:[rtcaddr],02h
        nop
        nop
        nop
        mov     al,byte ptr fs:[rtcdata]        ;mintue
        mov     ah,al
        shr     ah,4
        and     al,0fh
        add     ax,3030h
        mov     byte ptr [edx+12],ah
        mov     byte ptr [edx+13],al

yyyyy:
        MOV     EDX,AUX0D
        JMP     DWRITE?DA

;*         TITLE      NEWNAME
;*     NEWNAME: GET NEW FILENAME FROM TEXT AND SCAN FOR
;*              NAME IN INDEX. IF NAME FOUND, IT MUST BE
;*              SCRATCHED AND MUST BE OVERWRITING OLDFILE.
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = PLATTER SPEC.
;*                    AUXA = 0 OR 1 IF OVERWRITINE OLDFILE
;*                           2 OR 3 IF CREATING NEW FILE
;*                 IF AUXA = 0, (OVERWRITING SPEC. FILE)
;*                    AUX8 = OLDNAME INDEX SECTOR ADDR
;*                    AUXF = NEWNAME INDEX SECTOR ADDR
;*                    AUX9 = OLDNAME INDEX ENTRY ADDR
;*                    AUXC = NEWNAME INDEX ENTRY ADDRESS
;*
;*          RETURN (EXECUTION PHASE):
;*                  F3 = RETURN FLAG
;*                       00 IF NF
;*                       11 IF FOUND BUT FILE SCRATCHED
;*                 F2 = HASH VALUE
;*
;*                  IF FOUND (F3 = 11),
;*                       AUXF = SECTOR ADDRESS OF INDEX
;*                              SECTOR WITH FILENAME
;*                       AUXC = ADDRESS IN I/O BUFFER OF
;*                              ENTRY WITH FILENAME
;*                       I/O BUFFER CONTAINS INDEX SECTOR
;*                              WITH FOUND FILENAME
;*
;*                 IF NOT FOUND & INDEX NOT FULL (F3 = 0),
;*                      AUXF = SECTOR ADDRESS OF SECTOR
;*                             WITH UNUSED ENTRY
;*                      I/O BUFFER CONTAINS INDEX SECTOR
;*                             WITH UNUSED ENTRY
;*                      AUXC = ADDRESS OF UNUSED
;*                             ENTRY IN I/O BUFFER
;*                      CH = ENTRY STATUS (0)
;*                      CL = FILE TYPE (0)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,F
;*
;NEWNAME  SB        FILENAMH  GET FILENAME FROM TEXT & SCAN FOR IT IN
;*_     DISK INDEX
;         BFL       2,SL,NEWNAME1       BRANCH IF NOT EXECUTION PHASE
;         TAP       ,A
;         BEQH      1,F3,NEWNAME2       BRANCH IF NAME FOUND IN INDEX
NEWNAME:
        CALL    FILENAMH
        TEST    SL,2
        JZ      NEWNAME1
        MOV     EDX,AUX0A
        MOV     AL,R3
        AND     AL,0F0H
        CMP     AL,10H
        JE      NEWNAME2
;         BEQL      1,PL,ERROR#82       ERROR IF OVERWRITING SAME FILE
;         BNEL      0,F3,ERROR#85       ERROR IF INDEX IS FULL
;NEWNAME1 SR
;         SPACE
        MOV     AL,DL
        AND     AL,0FH
        CMP     AL,1
        JZ      ERROR_82
        TEST    R3,0FH
        JNZ     ERROR_85
NEWNAME1:
        RET
;NEWNAME2 BTL       2,PL,ERROR#83
;         BNEL      0,PL,NEWNAME3       BRANCH IF OVERWRITING SAME FILE
;         TAP       ,8
;         MVX       PHPL,F1F0 F1,0 = OLDNAME INDEX SECTOR ADDRESS
;         TAP       ,F        PC'S = NEWNAME INDEX SECTOR ADDRESS
NEWNAME2:
        TEST    DL,2
        JNZ     ERROR_83
        TEST    DL,0FH
        JNZ     NEWNAME3
        MOV     EDX,AUX08
        MOV     WORD PTR R0,DX
        MOV     EDX,AUX0F
;
;         BNR       F0,PL,ERROR#83
;         BNR       F1,PH,ERROR#83      ERROR IF OLDNAME <> NEWNAME
;         TAP       ,9
;         MVX       PHPL,F1F0 F1,0 = OLDNAME INDEX ENTRY ADDRESS
;         TAP       ,C        PC'S = NEWNAME INDEX ENTRY ADDRESS
        CMP     DX,WORD PTR R0
        JNE     ERROR_83
        MOV     EDX,AUX09
        MOV     DWORD PTR A0,EDX
        MOV     EDX,AUX0C
;         BNR       F0,PL,ERROR#83
;         BNR       F1,PH,ERROR#83      ERROR IF OLDNAME <> NEWNAME
;NEWNAME3 BEQL      1,F3,NEWNAME1       BRANCH IF FILE SCRATCHED
;         B         ERROR#84  FILE NOT SCRATCHED
;         SPACE
        CMP     EDX,DWORD PTR A0
        JNE     ERROR_83
 NEWNAME3:
        MOV     AL,R3
        AND     AL,0FH
        CMP     AL,01H
        JE      NEWNAME1
        JMP     ERROR_84
;
;ERROR#83 MVI       83,F0     FILE ALREADY EXISTS
;         B         ERROR
;         SPACE
;ERROR#85 MVI       85,F0     INDEX FULL
;         B         ERROR
ERROR_83:
        MOV     R0,83H
        JMP     ERROR
ERROR_85:
        MOV     R0,85H
        JMP     ERROR
;
;         TITLE     OLDNAME
;*     OLDNAME: GET AN OLD FILENAME FROM TEXT.
;*              IN EXECUTION PHASE, SCAN FOR NAME IN DISK
;*              INDEX. ERROR IF NOT FOUND OR NOT SCRATCHED
;*
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 IN EXECUTION PHASE,
;*                    DISK ENABLED
;*                    AUXE = FILE# / PLATTER
;*
;*          RETURN: F0 <> 0 IF NAME NOT FOUND IN TEXT
;*                          TEXTPTR POINTS TO NEXT
;*                              NONBLANK TEXT CHARACTER
;*
;*                  F0 = 0 IF NAME FOUND
;*                         TEXTPTR POINTS AFTER FILENAME
;*
;*
;*          FOUND RETURN (EXECUTION PHASE):
;*               AUXA = 0 (FILENAME FOUND)
;*               AUX8,F = SECTOR ADDRESS OF INDEX SECTOR
;*                        WITH FILENAME
;*               AUX9 = ADDRESS OF ENTRY WITH NAME WHEN
;*                      INDEX SECTOR LOADED IN I/O BUFFER
;*               INDEX SECTOR WITH NAME ==> I/O BUFFER
;*               AUXC = ADDRESS OF START OF FILE ADDRESS
;*                      (IN I/O BUFFER)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX8,9,A,C,F
;*
;OLDNAME  SB        FILENAME  LOOK FOR FILENAME IN TEXT
;         BNEL      0,F0,OLDNAME1       NF, BRANCH
;         BFL       2,SL,OLDNAME1       BRANCH IF NOT EXECUTION PHASE
;         SB        FINDNAMH  LOOK FOR NAME IN INDEX
 OLDNAME:
        CALL    FILENAME
        TEST    R0,0FH
        JNZ     OLDNAME1
        TEST    SL,2
        JZ      OLDNAME1
        CALL    FINDNAMH
;         BNEH      1,F3,ERROR#82       ERROR IF NOT FOUND
;         BEQL      0,F3,ERROR#84       ERROR IF FILE NOT SCRATCHED
;         TAP       ,C
;         TPA+2     ,C
;         TPA       ,9        AUX9 = ADDRESS OF ENTRY (IN I/O BUFFER)
        MOV     AL,R3
        AND     AL,0F0H
        CMP     AL,10H
        JNE     ERROR_82
        TEST    R3,0FH
        JZ      ERROR_84
        MOV     EDX,AUX0C
        ADD     AUX0C,2
        MOV     AUX09,EDX
;
;         TAP       ,F
;         TPA       ,8        AUX8 = SECTOR ADDRESS OF SECTOR WITH NAME
;         ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,A        AUXA = OLD FILENAME SPECIFIED
        MOV     EDX,AUX0F
        MOV     AUX08,EDX
        MOV     EDX,0
        MOV     AUX0A,EDX
;         MVI       0,F0      FLAG = FOUND
;OLDNAME1 SR
;         SPACE
;ERROR#84 MVI       84,F0     FILE NOT SCRATCHED
;         B         ERROR
        MOV     R0,0
OLDNAME1:
        RET
ERROR_84:
        MOV     R0,84H
        JMP     ERROR

;         TITLE     LISTDCT MASK/FILENAME COMPARER
;*  MASKCOMP   -    COMPARE SOME FILENAME AGAINST A MASK TO SEE IF IT MATCHES
;*
;*  ENTRY           F0 = COUNT OF CHARACTERS IN MASK
;*                  AUX 0 = POINTER TO MASK
;*                  AUX 1 = POINTER TO FILE NAME
;*
;*  EXIT            F0 = 0 IF FILENAME AND MASK MATCH
;*                  F0 = FF IF THERE IS NO MATCH
;*
;* REGISTER USAGE   F3 - COUNT OF CHARACTERS LEFT IN FILENAME TO CHECK
;*                  F0 - (LOW HALF) - COUNT OF CHARCTERS LEFT IN MASK TO CHECK
;*                       (HIGH HALF) - CHAR "*" FOUND FLAG, 0 = NOT FOUND
;*                  F5F4 - STORAGE FOR F3 & F0 WHEN '*' IS USED
;*                  F2 - USED TO HOLD SPECIAL CHARACTERS FOR COMPARISIONS
;*                  AUX 0 - MASK POINTER
;*                  AUX 1 - FILENAME POINTER
;*                  AUX 2 - STORAGE FOR MASK POINTER WHEN '*' IS USED
;*                  AUX 3 - STORAGE FOR FILENAME POINTER WHEN '*' IS USED
;*
;* MASK RESTRICTIONS:
;*        1) ONLY ONE '*' PER MASK IS ALLOWED, MORE THAN 1 NO MATCHES TO BE MADE
;*        2) A '?' MAY NOT IMMEDIATELY FOLLOW A '*', IF SO NO MATCHES WILL BE MADE
;*        3) IN A FILENAME TRAILING BLANKS ARE IGNORED
;*        4) IN A MASK TRAILING BLANKS ARE IMPLIED
;*
;* POINTER EQUATES
;MASKPTR  EQU       0
;FILEPTR  EQU       1

MASKPTR         EQU    AUX00
FILEPTR         EQU    AUX01

;MASKCOMP EQU       *
;         BEQL      0,F0,MATCHIF MASK LENGTH = 0, ITS A MATCH
;         MVX       F5F4,PHPL SAVE F5F4
;         TPS
;         MVX       F3F2,PHPL SAVE F3F2
;         TPS
;         TAP       ,2        SAVE AUX2
;         TPS
;         TAP       ,3        SAVE AUX3
;         TPS

MASKCOMP:
        TEST    R0,0FH
        JZ      DB41A_01
        PUSH    WORD PTR R4
        PUSH    WORD PTR R2
        PUSH    AUX02
        PUSH    AUX03

;         MVI       08,F3     F3 = # OF CHAR IN FILENAME
;         ANDI      0F,F0,F0  CLEAR *-FOUND FLAG
;MASKLOOP BNEL      0,F0,MOREMASK       IF AT END OF MASK....
;         MVI       20,F2     MAKE SURE REST OF FILENAME...

        MOV     R3,08
        AND     R0,0FH
MASKLOOP:
        TEST    R0,0FH
        JNZ     MOREMASK
        MOV     R2,20H

;BLANKCHK BEQL      0,F3,MATCHIS ALL BLANKS.
;         SB        INCFILE   IF IT AIN'T, THEN UNLESS WE
;         BER       F2,CH,BLANKCHK      WE HAD A '*' WILDCARD NO MATCH
;         B         CHECK*    CHECK FOR '*'

BLANKCHK:
        TEST    R3,0FH
        JZ      MATCH
        CALL    INCFILE
        CMP     CH,R2
        JZ      BLANKCHK
        JMP     CHECK?AS

;MOREMASK BEQL      0,F3,NOMATCH        IF AT END OF FILENAME THEN NO MATCH
;         SB        INCMASK   GET NEXT MASK CHARACTER
;         SB        INCFILE   GET NEXT FILENAME CHARACTER
;         MVI       2A,F2     IF MASK CHAR NOT = '*'...

MOREMASK:
        TEST    R3,0FH
        JZ      NOMATCH
        CALL    INCMASK
        CALL    INCFILE

;         BNR       F2,K,CHECK?         THEN CHECK FOR '?'
;         BNEH      0,F0,NOMATCH        IF 2ND '*' THEN ITS NO MATCH
;         BEQL      0,F0,MATCHIF END OF MASK ITS A MATCH
;         ORI       0F0,F0,F0 TURN ON *-FOUND FLAG

        CMP     K,2AH
        JNE     CHECK?
        TEST    R0,0F0H
        JNZ     NOMATCH
        TEST    R0,0FH
        JZ      MATCH
        OR      R0,0F0H

;         MV        F0,F5     SAVE MASK COUNT
;         TAP       ,MASKPTR
;         TPA       ,2        SAVE MASK POINTER
;                             SNEAK A LOOK AT THE NEXT MASK...

        MOV     AL,R0
        MOV     R5,AL
        MOV     EDX,MASKPTR
        MOV     AUX02,EDX


;         MVI,R     3F,F2     CHAR. TO SEE IF ITS A '?'
;         BER       F2,CH,NOMATCH       IF IT IS, KILL THE USER!!!
;                                          CAUSE '*?' AIN'T ALLOWED
;SNEAKY   SB        INCMASK   GET NEXT MASK CHARACTER

        MOV     CH,[EDX]
        CMP     CH,3FH
        JZ      NOMATCH
SNEAKY:
        CALL    INCMASK

;SYNCLOOP BEQL      0,F3,NOMATCH        SCAN FILENAME FOR MASK CHAR...
;         SB        INCFILE   IF NOT FOUND THEN NO MATCH
;         BNR       CH,K,SYNCLOOP       IF NO MATCH YET KEEP LOOKING
;         MV        F3,F4     SAVE FILENAME COUNT IN CASE THIS..

SYNCLOOP:
        TEST    R3,0FH
        JZ      NOMATCH
        CALL    INCFILE
        CMP     CH,K
        JNE     SYNCLOOP
        MOV     AL,R3
        MOV     R4,AL

;         TAP       ,FILEPTR  AIN'T IT... FILENAME POINTER TOO
;         TPA       ,3
;         B         MASKLOOP  CHECK THE NEXT ONE

        MOV     EDX,FILEPTR
        MOV     AUX03,EDX
        JMP     MASKLOOP

;CHECK?   MVI       3F,F2     IF MASK CHAR. NOT = '?' THEN...
;         BNR       F2,K,CHECKCH        BRANCH TO CHECK AGAINST FILENAME
;         B         MASKLOOP  GO DO ANOTHER

CHECK?:
        CMP     K,3FH
        JNE     CHECKCH
        JMP     MASKLOOP

;CHECKCH  BER       CH,K,MASKLOOP       CHARS MATCH DO ANOTHER PAIR
;CHECK*   BNEH      0F,F0,NOMATCH       IF NOT IN A '*' WILDCARD, NO MATCH
;         TAP       ,2        RESTORE MASK POINTER AND COUNT
;         TPA       ,MASKPTR
;         MV        F5,F0
;         TAP       ,3        RESTORE FILENAME POINTER AND...

CHECKCH:
        CMP     CH,K
        JE      MASKLOOP
CHECK?AS:
        TEST    R0,0F0H
        JZ      NOMATCH
        MOV     EDX,AUX02
        MOV     MASKPTR,EDX
        MOV     AL,R5
        MOV     R0,AL
        MOV     EDX,AUX03

;         TPA       ,FILEPTR  COUNT
;         MV        F4,F3
;         B         SNEAKY    RE-SYNC '*' ON NEXT CHAR

        MOV     FILEPTR,EDX
        MOV     AL,R4
        MOV     R3,AL
        JMP     SNEAKY

;NOMATCH  MVI       0FF,F0    F0 = NOT-A-MATCH
;         B         EXITMASK
;MATCH    MVI       00,F0     F0 = IS-A-MATCH

NOMATCH:
        MOV     R0,0FFH
        JMP     EXITMASK
MATCH:
        MOV     R0,0

;EXITMASK TSP
;         TPA       ,3        RESTORE AUX 3
;         TSP
;         TPA       ,2        RESTORE AUX 2
;         TSP
;         MVX       PHPL,F3F2 RESTORE F3F2
;         TSP
;         MVX       PHPL,F5F4 RESTORE F5F4
;         SR        GO HOME

EXITMASK:
        POP     AUX03
        POP     AUX02
        POP     WORD PTR R2
        POP     WORD PTR R4
DB41A_01:
        RET

;INCFILE  TAP       ,FILEPTR  READ NEXT FILE CHARACTER INTO CH
;         TPA+1,R   ,FILEPTR  AND INCREAMENT FILENAME POINTER
;         AI        0FF,F3,F3 WHILE DECREMENTING FILENAME COUNT
;         SR

INCFILE:
        MOV     EDX,FILEPTR
        MOV     CH,[EDX]
        INC     FILEPTR
        DEC     R3
        RET

;INCMASK  TAP       ,MASKPTR  READ NEXT MASK CHARACTER INTO K
;         TPA+1,R   ,MASKPTR  INCREAMENT MASK POINTER
;         AI        0FF,F0,F0 DECREAMENT MASK COUNT
;         MV        CH,K
;         SR

INCMASK:
        MOV     EDX,MASKPTR
        MOV     CH,[EDX]
        INC     MASKPTR
        DEC     R0
        MOV     K,CH
        RET

;         TITLE     FNAMASK
;*        FNAMASK: PROCESS FILE NAME MASK OPTION
;*
;*        ENTRY: TEXTPTR POINTS AT NEXT NON-BLANK CHARACTER
;*                  SHOULD BE A ALPHANUMERIC OR LITERAL STRING
;*               IF FOUND - SET UP FILE MASK OPTION TO NON ZERO LENGTH
;*               IF NOT FOUND - INITIALIZE FILE MASK OPTION TO A LENGTH OF ZERO
;*               IN EITHER CASE - INIT FILE TYPE MASK TO ALL FILE TYPES
;*
;
;FNAMASK  MVI       X'04',K   CALL ALPHA FOR CURRENT LENGTH
;         SB        ALPHA1    PROCESS MASK IF ANY
;         BFL       2,SL,FNAMASK3       BRANCH IF NOT EXEUCTION PHASE
;         BER       F0,,FNAMASK2        BR IF ALPHA FOUND

FNAMASK:
        MOV     K,04
        CALL    ALPHA1          ;

;     ALPHA: SCAN AND PROCESS AN ALPHA VARIABLE OR
;            LITERAL STRING OR STR FUNCTION.
;            ASSUMES DEFINED LENGTH OF VARIABLE IS TO
;            BE RETURNED.
;
;          VARIABLE FORMAT:
;               SCALAR = letter [digit] $
;               VECTOR-ELEMENT = letter [digit] $ (expr)
;               ARRAY-ELEM.= letter [digit] $ (expr,expr)
;               ARRAY = letter [digit] $ ()
;
;          STR FUNCTION FORMAT:
;               STR( alpha-var [,[expr] [,expr] ] )
;
;          VALID FORMS OF LITERAL STRINGS:
;               1. "character-string"
;               2. HEX( hexdigit hexdigit ...)
;
;
;MAY WANT K-ENTRY-BIT FOR 'ERROR IF NOT FOUND'
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;
;          RETURN (FOUND): F0 = 0
;                 TEXTPTR POINTS AFTER LITERAL OR VAR.
;****------->>>>> ADDRESS AND LENGTH OF VALUE IN VS
;                    (LENGTH IN LAST)
;
;          RETURN (NOT FOUND): F0 = 1
;                 TEXTPTR POINTS TO NEXT NONBLANK CHAR.
;
;     ALPHA1:  SAME AS 'ALPHA' EXCEPT WHETHER TO RETURN
;              'CURRENT LENGTH' OF VALUE OR 'DEFINED
;              LENGTH' OF THE VARIABLE MUST BE SPECIFIED.
;
;          ENTRY: K,BIT04 = 0 IF DEFINED-LENGTH OF VARIAB
;                            IS TO BE RETURNED
;                         = 1 IF CURRENT LENGTH OF VALUE
;                            IS TO BE RETURNED
;
;          NOTE: CURRENT LENGTH OF STR(...)
;                INCLUDES TRAILING SPACES.  IF A LITERAL
;                IS FOUND, ITS ACTUAL LENGTH IS RETURNED.

        TEST    SL,2
        JZ      FNAMASK3
        CMP     R0,0
        JE      FNAMASK2

;*     NO MASK OPTION FOUND
;*        FILE TYPE MASK = ALL FILE TYPES
;*        FILE NAME MASK LENGTH = ZERO
;*        FILE NAME MASK PTR = ALL ZEROES

;FNAMASK1 LPI       X'F000'   MASK LENGTH = 00, FILE TYPE = ALL
;         MVX       PHPL,F2F1
;         SB        RWORKSPC  POINT AT WORKSPACE
;         OR,W1     +,F2,     WRITE FILE TYPE MASK
;         OR,W1     +,F1,     ZERO MASK LENGTH
;         OR,W1     +,,       ZERO FILE MASK PTR
;         OR,W1     +,,
;FNAMASK3 SR

;--------  NO MASK OPTION FOUND ---------

FNAMASK1:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        MOV     WORD PTR [EDX],00F0H    ;LENGTH = 0
        ADD     EDX,2
        MOV     DWORD PTR [EDX],0       ;MASK PTR =0
        ADD     EDX,4
FNAMASK3:
        RET

;FNAMASK2 TAP       ,16       POP VS STACK
;         TPA+2,R   ,16       CL = FILE MASK LENGTH
;         MVI       8,F0      CHECK MASK LENGTH <=8
;         BLER      CL,F0,FNAMASK4      BR IF <=8
;         B         ERROR#52  NO - ERROR P52

;-----  MASK OPTION FOUND  ------


FNAMASK2:
        MOV     EDX,AUX16
        MOV     CX,[EDX]
        ADD     AUX16,2
        CMP     CL,8
        JBE     FNAMASK4
        JMP     ERROR_52

;FNAMASK4 MVI       X'F0',F2  FILE TYPE = ALL
;         MV        CL,F1     FILE NAME MASK LENGTH
;         SB        RWORKSPC  PC'S POINT AT WORKSPACE
;         OR,W1     +,F2,     WRITE FILE TYPE MASK
;         OR,W1     +,F1,     WRITE FILE MASK LENGTH
;         TPS       ,         SAVE PTR TO FILE MASK PTR

FNAMASK4:
        MOV     BL,CL
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        MOV     BYTE PTR [EDX],0F0H
        INC     EDX
        MOV     [EDX],BL
        INC     EDX

;         TAP       ,16       POP 2ND VALUE OFF VS STACK
;         TPA+2,R   ,16
;         TSP       ,         PC'S POINT TO FILE MASK PTR
;         OR,W1     CH+,,
;         OR,W1     CL+,,
;         B         FNAMASK3  IF F0=0 THEN MASK PRESENT - RETURN

        MOV     EBX,AUX16
        MOV     ECX,[EBX]
        ADD     AUX16,4
        MOV     [EDX],ECX
        JMP     FNAMASK3

;         TITLE     FTYPMASK
;*        FTYPMASK: PROCESS FILE TYPE MASK OPTION
;*
;*        ENTRY: TEXTPTR POINTING TO NEXT NON-BLANK CHARACTER
;*
;*        MODIFIED REGISTERS: F1-0
;*
;*
;FTYPMASK XOR       F1,F1,F1  ZERO FILE TYPE FLAG
;FTYPMSK1 SB        GETCH     IS NEXT CHARACTER END OF LINE?
;*        CHECK IF HIGH NIBBLE OF CHARACTER FOUND IN CH IS P OR S

FTYPMASK:
        MOV     R1,0
FTYPMSK1:
        MOV     EDX,TEXTPTR
        MOV     CH,BYTE PTR [EDX]
        INC     TEXTPTR

;         BNEHH     C'P',CH,FTYPMSK4    HIGH NIBBLE = P OR S?
;         BNELL     C'P',CH,FTYPMSK3    BR IF NOT P
;         ORI       X'80',F1,F1         OR IN ACTIVE PROGRAM FLAG
;         B         FTYPMSK1

        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,50H                  ;ASCII 'P' = 50H
        JNE     FTYPMSK4
        TEST    CH,0FH
        JNZ     FTYPMSK3
        OR      R1,80H                  ; 'P' TYPE
        JMP     FTYPMSK1

;FTYPMSK4 BNEHH     C'D',CH,FTYPMSK2    BR IF NOT HIGH NIBBLE D
;         BNELL     C'D',CH,FTYPMSK2    NO - BRANCH
;         ORI       X'40',F1,F1         OR IN ACTIVE DATA FLAG
;         B         FTYPMSK1

FTYPMSK4:
        CMP     CH,'D'
        JNZ     FTYPMSK2
        OR      R1,40H                  ; 'D' TYPE
        JMP     FTYPMSK1

;FTYPMSK3 BNELL     C'S',CH,FTYPMSK2    BR IF NOT S
;
;         TPS       ,         SAVE PTR TO LETTER S
;         SB        GETCH     GET NEXT CHARACTER SD OR SP
;         BNEHH     C'P',CH,FTYPMSK5    CHECK IF SCRATCH PROGRAM
;         BNELL     C'P',CH,FTYPMSK8    NO - BRANCH

FTYPMSK3:
        CMP     CH,'S'
        JNE     FTYPMSK2
        PUSH    EDX                     ; 'S?' TYPE
        MOV     EDX,TEXTPTR
        MOV     CH,BYTE PTR [EDX]
        INC     TEXTPTR
        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,50H
        JNE     FTYPMSK5
        TEST    CH,0FH
        JNZ     FTYPMSK8

;         ORI       X'20',F1,F1         OR IN SCRATCH PROGRAM FLAG
;         TSP       ,         RESTORE STACK PTR
;         B         FTYPMSK1

        OR      R1,20H                  ; 'SP' TYPE
        POP     EDX
        JMP     FTYPMSK1

;FTYPMSK5 BNEHH     C'D',CH,FTYPMSK8    CHECK IF SCRATCH DATA
;         BNELL     C'D',CH,FTYPMSK8    NO - ILLEGAL CHARACTER
;         ORI       X'10',F1,F1         OR IN SCRATCH DATA FLAG
;         TSP       ,         RESTORE STACK PTR
;         B         FTYPMSK1

FTYPMSK5:
        CMP     CH,'D'
        JNE     FTYPMSK8
        OR      R1,10H                  ; 'SD' TYPE
        POP     EDX
        JMP     FTYPMSK1

;*        END OF VALID SYNTAX PROCESSING
;*                  UPDATE FILE TYPE MASK TO F1 (STORE IN PH LOCATION OF
;*                                                 MASK LENGTH)
;FTYPMSK8 TSP       ,         RESTORE PTR TO LETTER S
;FTYPMSK2 TPA       ,TEXTPTR  TEXTPTR PTS AT CR
;         BTL       2,SL,FTYPMSK6       BR IF EXECUTION PHASE
;         SR

FTYPMSK8:
        POP     EDX
FTYPMSK2:
        MOV     TEXTPTR,EDX
        TEST    SL,2
        JNZ     FTYPMSK6
        RET

;FTYPMSK6 BER       F1,,FTYPMSK7        SAVE FILE TYPE MASK, IF ANY
;*        SAVE FILE TYPE MASK
;         SB        RWORKSPC  POINT AT WORKSPACE
;         OR,W1     F1,,      SAVE NEW FILE TYPE MASK
;FTYPMSK7 SR

FTYPMSK6:
        CMP     R1,0
        JZ      FTYPMSK7
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        MOV     AL,R1
        MOV     [EDX],AL
FTYPMSK7:
        RET

;*        FTMASK: CHECK FILE TYPE AGAINST FILE TYPE MASK
;*
;*        ENTRY: F5 - FILE'S ENTRY STATUS (ACTIVE OR SCRATCHED)
;*               F4 - FILE'S TYPE (PROGRAM OR DATA)
;*
;*        RETURN: F3  = 0 THEN NO MATCH
;*                F3 <> 0 THEN MATCH
;*
;*        MODIFIED REGISTERS: F3
;*
;FTMATCH  BNEL      0,F5,FTMATCH1
;*        ACTIVE FILE, CHECK IF PROGRAM
;         BNEH      8,F4,FTMATCH2       NO - ACTIVE DATA
;*        ACTIVE PROGRAM - CHECK AGAINST FILE TYPE MASK
;         ANDI      80,F3,F3
;FTMATCH9 SR

FTMATCH:
        TEST    R5,0FH
        JNZ     FTMATCH1
;
; cs-386 format
;
        cmp     r4,40h
        jz      ftmatch386

        CMP     R4,80H
        JNE     FTMATCH2
ftmatch386:
        AND     R3,80H
FTMATCH9:
        RET

;*        ACTIVE DATA - CHECK AGAINST FILE TYPE MASK
;FTMATCH2 ANDI      40,F3,F3
;         B         FTMATCH9

FTMATCH2:
        AND     R3,40H
        JMP     FTMATCH9

;*        FILE TYPE = SCRATCHED, CHECK IF PROGRAM
;FTMATCH1 BNEH      8,F4,FTMATCH3       NO - SCRATCHED DATA
;*        SCRATCHED PROGRAM - CHECK AGAINST FILE TYPE MASK
;         ANDI      20,F3,F3
;         B         FTMATCH9

FTMATCH1:
        cmp     r4,40h
        jz      ftmatch1_x
        CMP     R4,80H
        JNE     FTMATCH3
ftmatch1_x:
        AND     R3,20H
        JMP     FTMATCH9

;*        SCRATCHED DATA - CHECK AGAINST FILE TYPE MASK
;FTMATCH3 ANDI      10,F3,F3
;         B         FTMATCH9

FTMATCH3:
        AND     R3,10H
        JMP     FTMATCH9

CODE    ENDS
        END
