;===========================================================================
;       This module was originally M_HEAD
;===========================================================================
        .LIST
        INCLUDE PREAMBLE
        
PUBLIC     _CSOS
PUBLIC     _OSREL
PUBLIC     CSVER

EXTRN      PRIME       :NEAR
EXTRN      STACK_BUFFER:NEAR

START:
           MOV      EDX,OFFSET STACK_BUFFER
           MOV      ESP,EDX
           CLD
           MOV      AUX1A,EAX           ;AUX1A = ACTDEV = BOOT DEVICE
           JMP      PRIME

;*************************************************************************
;          CS386 RELEASE HISTORY :
;
;                   'CS/386 VER. 0.01 (03/21/89 13:00:00P)'
;                   'CS/386 VER. 0.02 (03/23/89 13:00:00P)'
;                   'CS/386 VER. 0.03 (03/28/89 13:00:00P)'
;                   'CS/386 VER. 0.04 (03/28/89 13:00:00P)'
;                   'CS/386 VER. 0.05 (03/31/89 13:00:00P)'
;                   'CS/386 VER. 0.06 (04/05/89 13:00:00P)'
;                   'CS/386 VER. 0.07 (04/07/89 13:00:00P)'
;                   'CS/386 VER. 0.08 (04/26/89 13:00:00P)'
;                   'CS/386 VER. 0.09 (05/05/89 13:00:00P)'
;                   'CS/386 VER. 0.0A (05/12/89 13:00:00P)'
;                   'CS/386 VER. 0.0B (05/12/89 13:00:00P)'
;                   'CS/386 VER. 0.0C (05/19/89 13:00:00P)'
;                   'CS/386 VER. 0.0CX(05/19/89 13:00:00P)'
;                   'CS/386 VER. 0.0D (05/26/89 13:00:00P)'
;                   'CS/386 VER. 0.0E (06/02/89 13:00:00P)'
;                   'CS/386 VER. 0.0F (06/19/89 13:00:00P)'
;                   'CS/386 VER. 0.10 (06/26/89 13:00:00P)'
;                   'CS/386 VER. 0.11 (07/03/89 13:00:00P)'
;                   'CS/386 VER. 0.12 (07/10/89 13:00:00P)'
;                   'CS/386 VER. 0.13 (07/20/89 13:00:00P)'
;                   'CS/386 VER. 0.14 (07/31/89 13:00:00P)'
;                   'CS/386 VER. 0.15 (08/04/89 13:00:00P)'
;                   'CS/386 VER. 0.16 (08/07/89 13:00:00P)'
;                   'CS/386 VER. 0.17 (08/11/89 13:00:00P)'
;                   'CS/386 VER. 1.0  (08/16/89 13:00:00P)'
;                   'CS/386 VER. 1.01 (08/28/89 13:00:00P)'
;                   'CS/386 VER. 1.02 (11/02/89 13:00:00P)'
;                   'CS/386 VER. 1.03 (11/28/89 13:00:00P)'
;                   'CS/386 VER. 1.04 (12/XX/89 13:00:00P)'
;                   'CS/386 VER. 1.05 (12/27/89 13:00:00P)'
;                   'CS/386 VER. 1.06 (12/28/89 13:00:00P)'
;                   'CS/386 VER. 1.07 (01/04/90 13:00:00P)'
;                   'CS/386 VER. 1.08 (01/24/90 13:00:00P)'
;                   'CS/386 VER. 1.09 (02/09/90 13:00:00P)'
;                   'CS/386 VER. 1.0A (03/01/90 13:00:00P)'
;                   'CS/386 VER. 1.0B (03/12/90 13:00:00P)'
;                   'CS/386 VER. 1.0C (04/03/90 13:00:00P)'
;                   'CS/386 VER. 1.10 (04/19/90 13:00:00P)'
;                   'CS/386 VER. 1.11 (05/17/90 13:00:00P)'
;                   'CS/386 VER. 1.12 (06/01/90 13:00:00P)'
;                   'CS/386 VER. 1.13 (06/08/90 13:00:00P)'
;                   'CS/386 VER. 1.14 (06/14/90 13:00:00P)'
;                   'CS/386 VER. 1.15 (06/21/90 13:00:00P)'
;                   'CS/386 VER. 1.16 (08/10/90 13:00:00P)'
;                   'CS/386 VER. 1.17 (08/23/90 13:00:00P)'
;                   'CS/386 VER. 1.18 (09/12/90 13:00:00P)'
;                   'CS/386 VER. 1.19 (10/03/90 13:00:00P)'
;                   'CS/386 VER. 1.1A (10/30/90 13:00:00P)'
;                   'CS/386 VER. 1.1B (01/15/90 13:00:00P)'
;                   'CS/386 VER. 1.1C (02/04/90 13:00:00P)'
;                   'CS/386 VER. 1.1Z (11/02/91 13:00:00P)'
;
;*************************************************************************

csver       db       3096 dup (00)

public     hog_table
hog_table  db       16 dup(0)

public     close_tbl
close_tbl  db       16*8*16 dup(0)

CSVER1     DB       'CS/386 BASIC-2 RELEASE 1.30.00  (07/13/93)',00H
_OSREL     DB       "W",13H                     ;.386 RELEASE 1.3
_CSOS      DW       130

CODE       ENDS
           END
