          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC $DISCNCT
PUBLIC $INIT
PUBLIC $INITER1
PUBLIC $INITER2
PUBLIC $INITER5
PUBLIC BOOT
PUBLIC BOOTGEN
PUBLIC BRESTART
PUBLIC DDEVINIT
PUBLIC ENDTABL
PUBLIC ERR_78
PUBLIC ERROR_78
PUBLIC EXIT998A
PUBLIC EXIT999
PUBLIC FDRVRDEV
PUBLIC GETCMEM
PUBLIC GETTABL_
PUBLIC GETTABL1
PUBLIC GETTABL2
PUBLIC GETTABL3
PUBLIC GETTABL4
PUBLIC GETTABL5
PUBLIC GETTABL6
PUBLIC IDRVRDEV
PUBLIC INPUTP
PUBLIC LOADMXD
PUBLIC LOADMXE
PUBLIC MAKDRVRE
PUBLIC MOVETAB1
PUBLIC MOVETAB2
PUBLIC MOVETAB3
PUBLIC MOVETABL
PUBLIC MOVETABM
PUBLIC MXDINIT
PUBLIC MXDPOWER
PUBLIC MXDTYPE
PUBLIC MXDTYPE1
PUBLIC NAMEINIT
PUBLIC RESTART
PUBLIC SETRESET
PUBLIC SETRSETB
PUBLIC TABLERR

EXTRN _INITPSW:DWORD
EXTRN _SCREEN:DWORD
EXTRN _CURSOR:DWORD
EXTRN BASE:DWORD
EXTRN BOOTDEV:WORD
EXTRN CPBASE:DWORD
EXTRN DRVRDEV:DWORD
EXTRN DRVRSTAT:DWORD
EXTRN ENDMEMX:DWORD
EXTRN ENDPART:DWORD
EXTRN ERRORN:DWORD
EXTRN MSTRTABL:DWORD
EXTRN MXDADR:BYTE
EXTRN MXD2SADR:BYTE
EXTRN MXD3SADR:BYTE
EXTRN MXD4SADR:BYTE
EXTRN OSMOD:WORD
EXTRN PART_:BYTE
EXTRN PDFLAG:BYTE
EXTRN PSTAT:DWORD
EXTRN PTERM:DWORD
EXTRN PMODE:DWORD
EXTRN RESETPROC:DWORD
EXTRN SCRNIN:DWORD
EXTRN SYSGENFG:BYTE
EXTRN CPUID:BYTE
EXTRN TABLNAME:DWORD
EXTRN TABLSTRT:DWORD
EXTRN VPMSG1:DWORD
EXTRN VPMSG2:DWORD

EXTRN DELAY5:NEAR
EXTRN ALPHA:NEAR
EXTRN ARECEVAL:NEAR
EXTRN AVARD:NEAR
EXTRN BREAKPTP:NEAR
EXTRN BREAKPTW:NEAR
EXTRN CBSNT:NEAR
EXTRN CCL:NEAR
EXTRN CCNL:NEAR
EXTRN DREAD:NEAR
EXTRN DREADSF:NEAR
EXTRN ERROR:NEAR
EXTRN ERROR92:NEAR
EXTRN ERROR_03:NEAR
EXTRN ERROR_08:NEAR
EXTRN ERROR_10:NEAR
EXTRN ERROR_11:NEAR
EXTRN ERROR_13:NEAR
EXTRN ERROR_19:NEAR
EXTRN ERROR_23:NEAR
EXTRN ERROR_29:NEAR
EXTRN ERROR_34:NEAR
EXTRN ERROR_51:NEAR
EXTRN ERROR_82:NEAR
EXTRN ERROR_88:NEAR
EXTRN EXPR:NEAR
EXTRN ENBLCNT:NEAR
EXTRN ENBLCNTA:NEAR
EXTRN ENBLDEVA:NEAR
EXTRN ENBLDEVB:NEAR
EXTRN ENBLDEVD:NEAR
EXTRN ENBLNLLD:NEAR
EXTRN ENDSTMT:NEAR
EXTRN ENDSTIO:NEAR
EXTRN ENDDISKR:NEAR
EXTRN ERRTYPE:NEAR
EXTRN FINDNAMH:NEAR
EXTRN FILENMDA:NEAR
EXTRN FLTBINB:NEAR
EXTRN FLTBINA:NEAR
EXTRN GETTERM_:NEAR
EXTRN GTFLPTRS:NEAR
EXTRN IBSENDIB:NEAR
EXTRN INITRAMD:NEAR
EXTRN INPUT:NEAR
EXTRN LITERAL:NEAR
EXTRN MXEPSW:NEAR
EXTRN NXTCHEOS:NEAR
EXTRN OBSNT:NEAR
EXTRN OBSTROBD:NEAR
EXTRN OBSBLKNT:NEAR
EXTRN PROCST:NEAR
EXTRN PRIME3:NEAR
EXTRN RELA_B:NEAR
EXTRN SETERRP:NEAR
EXTRN SRCHDEVA:NEAR
EXTRN WAITIBS:NEAR
EXTRN WAIT16RB:NEAR
EXTRN WAITRDY:NEAR
EXTRN @@VSEND:DWORD
EXTRN @@OSEND:DWORD
extrn init_close:near

DOWNFROM  EQU       AUX01       ;disk address
DOWNINTO  EQU       AUX02       ;address of device being loaded

tgdt       label     pword
           dw        0030h
           dd        0h

ijump      label     pword
           dd        0FFE9h
           dw        034h

;         MODULE    MOD-36 SYSTEM INITIALIZATION
;*     ***************************************
;*     *                                     *
;*     *  MOD36:  SYSTEM INITIALIZATION      *
;*     *                                     *
;*     ***************************************
;*
;*
;*%STARTUP SEQUENCE:
;*BOOTSTRAP --
;*     1. System traps to BOOTSTRAP (8003) at power on.
;*     2. User enters load parameters (file & platter).
;*     3. BOOTSTRAP loads specified file.
;*     4. Control is passed to BASIC-2 OS (0003).
;*
;*PRIME --
;*     1. Disables RESET; pressing RESET will cause a branch to
;*        the BOOTSTRAP power on location.
;*     2. System checks 30ms. timer (TESTCLK).
;*     3. Control tables are initialized so that system has 1
;*        partition.
;*     4. Normal RESET operation is restored.
;*
;*RESET --
;*     1. Partition #1 is reset and READY message is displayed.
;*
;*ENTER --
;*     1. Passes control to BOOT.
;*
;*BOOT --
;*     1. Downloads any loadable MXD's.  During the downloading
;*        RESET is disabled so that pressing RESET will cause
;*        control to be passed to the BOOTSTRAP.
;*     2. Boots in @GENPART.
;*@GENPART --
;*     1. Gets configuration from user.
;*     2. Passes configuration parameters to OS via $INIT.
;*
;*$INIT --
;*     1. Configures system.
;*
;*For each partition,
;*     1. RESET.
;*     2. ENTER passes control to BOOTPRGM if program is to
;*        automatically loaded. Otherwise, ENTER issues a
;*        console input request to the MXD.
;*%REFERENCED MODULES:
;         SYMBL     BPMVP00   SYSTEM EQUATES
;         SYMBL     BPMVP01   CONTROL
;         SYMBL     BPMVP05   I/O SUBROUTINES
;         SYMBL     BPMVP10   ALPHA SUBROUTINES
;         SYMBL     BPMVP06   SUBROUTINES
;         SYMBL     BPMVP02   SYNTAX CHECKING
;         SYMBL     BPMVP07   EXPRESSIONS
;         SYMBL     JLMVP32   MVP SUBROUTINES
;         SYMBL     BPMVP40   DISK
;         SYMBL     BPMVP16
;         SYMBL     BPMVP41   DISK DC
;         SYMBL     BPMVP33   MVP ROUTINES
;         SYMBL     BPMVP12
;         SYMBL     BPMVP8D   DATA
;         SYMBL     BPMVP9D   DATA
;         SYMBL     BPMVP19
;         SYMBL     DAMVP20
;         SYMBL     SSMVP98   .MXE TC
;         SYMBL     DBMVP55   PRINTER DRIVER
;         SYMBL     BPMVP33
;         TITLE     BOOT BOOTPROG
;*BOOT: If system has not been configured, download any MXD's
;*      that need to be and then boot in @GENPART.  Otherwise,
;*      just boot in the specified program.
;*
;*     Entry: SYSGENFG indicates if system is configured.
;*
;*BOOTPROG: BOOTSTRAP PROGRAM IN.
;*          IE, ENTER A 'LOAD RUN /XYY, "PROGRAM"' STATEMENT
;*              INTO TEXT.
;*
;*     ENTRY: 'WORKSPC' CONTAINS PROGRAM NAME
;*            'BOOTDEV' CONTAINS DISK ADDRESS
;*
;*%Download all MXD's not currently loaded
BOOT:     TEST      SYSGENFG,01
          JNZ       BOOTPRGM            ;branch if system already configured
          MOV       K,@MXD1CAD
          CALL      LOADMXD             ;download 1st MXD if loadable
          CMP       MXD2SADR,0FFH       ;branch if no 2nd MXD
          JE        BOOTGEN
          CALL      LOADMXD             ;download 2nd MXD if loadable
          CMP       MXD3SADR,0FFH       ;branch if no 3rd MXD
          JE        BOOTGEN
          CALL      LOADMXD             ;download 3rd MXD if loadable
          CMP       MXD4SADR,0FFH       ;branch if no 4th MXD
          JE        BOOTGEN
          CALL      LOADMXD             ;download 4th MXD if loadable

;*%Setup for booting @GENPART
BOOTGEN:  MOV       EDX,DWORD PTR [BASEP]
          LEA       EDX,[EDX].@WORKSPC
          MOV       DWORD PTR [EDX],'NEG@'
          MOV       DWORD PTR [EDX+4],'TRAP'
          ADD       EDX,8               ;Put '@GENPART' into @WORKSPC of partition 1
;*%------------------------------------------------------------------------------
;*        The following code handles bootstrapping of the terminal disconnect
;*        program.  If the partition mode bit, PMODED, is set, the program
;*        @DISCNCT is bootstrapped into the partition.  PMODED is set by the
;*        MXD status routine MXDSTAT if the disconnect bit has been set by the
;*        MXE.
;
BOOTPRGM:
          MOV       EDX,0
          MOV       DL,PART_            ;get byte information contain active partition#
          ADD       EDX,OFFSET PMODE    ;point to the active entry
          TEST      BYTE PTR [EDX],PMODED
          JZ        BPP1                ;branch if not disconnect

          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@WORKSPC
          MOV       DWORD PTR [EDX],'SID@'
          MOV       DWORD PTR [EDX+4],'TCNC'
          ADD       EDX,8               ;program to load = "@DISCNCT"
;*%------------------------------------------------------------------------------
;*%Bootstrap in the specified BASIC program.
BPP1:
          MOV       CX,BOOTDEV
          MOV       WORD PTR R0,CX    ;F1,0 = BOOTSTRAP DISK ADDRESS
          MOV       EDX,TEXTEND

          MOV       EAX,'DAOL'          ;LOAD
          MOV       DWORD PTR [EDX],EAX
          ADD       EDX,4
          MOV       EAX,'/NUR'          ;RUN
          MOV       DWORD PTR [EDX],EAX
          ADD       EDX,4
          MOV       AL,'D'              ;/D
          MOV       [EDX],AL

          MOV       AH,R1               ;OR
          AND       AH,0FH
          CMP       AH,0DH
          JE        BOOTPRG2
          MOV       AL,'3'              ;3
          MOV       BYTE PTR [EDX],AL
          CMP       AH,03H
          JE        BOOTPRG2
          MOV       AL,'B'              ;B
          MOV       BYTE PTR [EDX],AL

BOOTPRG2: INC       EDX
          MOV       AL,R0               ;DEVICE ADDRESS (HIGH DIGIT)
          SHR       AL,4
          MOV       AH,R0               ;DEVICE ADDRESS (LOW DIGIT)
          AND       AH,0FH
          OR        AX,3030H
          MOV       [EDX],AX
          ADD       EDX,2

          MOV       AX,'",'             ;,"
          MOV       [EDX],AX
          ADD       EDX,2
          MOV       AUX00,EDX

          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@WORKSPC
          MOV       ESI,EDX
          MOV       EDX,AUX00

BOOTPRG1: MOV       EAX,[ESI]           ;PROGRAM NAME
          MOV       [EDX],EAX
          ADD       ESI,4
          MOV       EAX,[ESI]
          MOV       [EDX+4],EAX
          ADD       EDX,8

          MOV       AL,'"'      ;"
          MOV       AH,0DH      ;CR
          MOV       [EDX],AX
          INC       EDX
          MOV       TEXTEND,EDX ;SET TEXTEND
          add       edx,minbuf+minvs+0ah
          mov       dword ptr [@@vsend],edx
          mov       edx,cpbase
          lea       edx,[edx].@osbeg
          add       edx,64
          mov       dword ptr [@@osend],edx
          JMP       PROCST      ;PROCESS STATEMENT

;         TITLE     $INIT
;*
;*
;*  $INIT  -  SYSTEM GENERATION
;*
;*     GENERAL FORM (IMMEDIATE MODE):
;         TITLE     $INIT
;*          $INIT literal
;*
;*            GENERAL FORM (PROGRAM STATEMENT):
;*               $INIT (alph1,alph2,alph3,alph4,alph5[,alph6])
;*
;*            WHERE:
;*               alph1 = size of each partition
;*                    Length >= 17.
;*                    Size = binary value indicating number of
;*                           pages of memory for this partition
;*                    Byte n = size of partition n.
;*                    Byte l+1 = 00 (l = last partition).
;*               alph2 = terminal number for each partition
;*                    Length >= 16.
;*                    Terminal number = 1-16.
;*                    Byte n = terminal number for partition n.
;*                    Unused bytes must = 00.
;*               alph3 = partition modes
;*                    Length >= 16.
;*                    Mode, bit 01 = 1 iff programming disabled
;*                        , bit 02 = 1 iff program to be booted
;*                    Byte n = mode for partition n.
;*               alph4 = bootstrap program names
;*                    Length >= 128.
;*                    Nth 8 bytes = name for partition n.
;*               alph5 = device table
;*                    Length >= 99.
;*                    Device specification:
;*                       byte 1, bits 0F = device type
;*                       byte 2 = device address
;*                       byte 3 = partition number (1-16) to
;*                                which device is allocated
;*                                (0 if device for anyone)
;*                    Device specifications end with device
;*                       address = 00.
;*               alph6 = re-configuration password
;*                    Length >= 8.
;*                    1st 8 bytes are password.
;*               alpha7 = printer configurations
;*                    Length = 150 (15 10 byte entries)
;*                     for each entry...
;*                        bytes 0 - 7 = printer driver table name
;*                        byte 8 = printer device address
;*                        byte 9 = terminal number (only used if address = 04)
;*               alph8 = OS modifier (development use onlY)
;*               alph9 = CPU ID.
;*                    Length = 1 byte
;*

$INIT:
          TEST      MODE,2              ;BRANCH IF NOT IMMEDIATE EXECUTION
          JZ        $INITP

;*%IMMEDIATE MODE (RE-CONFIGURATION)
          CALL      LITERAL             ;LOOK FOR LITERAL
          CMP       R0,0
          JNE       ERROR_23            ;ERROR IF NF

          TEST      SL,2                ;BRANCH IF NOT X-PHASE
          JZ        $INIT5
          CALL      GETTERM_            ;GET TERMINAL #

          CMP       R0,01H
          JNE       $INITER5            ;BRANCH IF NOT TERMINAL #1

          mov       ax,8                ;length of re_conf password
          mov       edi,offset _initpsw ;addr   of re_conf password
          mov       r7,2                ;for result test
          mov       edx,vsptr           ;
          mov       cx,word ptr [edx]   ;get length of user password
          mov       esi,dword ptr [edx+2]   ;get addr
          add       vsptr,6             ;update vsptr
          call      rela_b

;         CALL      RELALPHB            ;COMPARE LITERAL TO PASSWORD
;2/21/89 --

          CMP       R7,2                ;ERROR IF NOT EQUAL
          JNE       $INITER5

;*%Restart system.
RESTART:  MOV       K,05
          CALL      ENBLDEVB            ;ENABLE CRT AT ADDRESS 05!
          MOV       K,03
          CALL      OBSTROBD            ;CLEAR SCREEN (SINCE BOOTSTRAP DOESN'T SEEM TO!)
          call      init_close

          lgdt      tgdt
          jmp       pword ptr ijump     ;jump to bootstrap

;*%PROGRAM STATEMENT (PASS PARAMETERS TO OS)
$INITP:
          CMP       BYTE PTR [TEXTPTR],'('
          JNE       ERROR_10            ;BRANCH IF NOT MATCH
          INC       TEXTPTR

;*%PROCESS CPU ID. PARAMETER

          CALL      ALPHA
          CMP       R0,0                ;ERROR IF NO ALPHA VAR OR LITERAL
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT X-PHASE
          JZ        $INITI
;         CALL      POPV4               ;GET ADDRESS & LENGTH OF VALUE
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       CL,[EDX]            ;GET VALUE
          MOV       CPUID,CL            ;VALUE ==> CPU ID.

;*%PROCESS PARTITION SIZE VARIABLE
$INITI:
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR

          CALL      ALPHA               ;GET ALPHA STR 1
          CMP       R0,0                ;ERROR IF NOT FOUND
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT X PHASE
          JZ        $INITA

          TEST      SYSGENFG,1          ;ERROR IF SYSTEM ALREADY CONFIGURED
          JNZ       $INITER5
;         call      popv4
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       AUX0B,EDX           ;SAVE ADDRESS OF PARTITION SIZES

          CMP       R1,0
          JNE       $INITA
          CMP       R0,22H              ;PARTMAX+1 = 11H
          JB        $INITER2            ;ERROR IF STR TOO SHORT

;*%PROCESS TERMINAL NUMBER VARIABLE
$INITA:                                 ;MUST FIND COMMA
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          CALL      ALPHA               ;GET ALPHA STR 2
          CMP       R0,0                ;ERROR IF NOT FOUND
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        $INITC

;         CALL      POPV4               ;GET ADDRESS & LENGTH OF STRING
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       AUX0E,EDX           ;SAVE ADDRESS OF TERMINAL NUMBERS
          CMP       R1,0
          JNE       $INITC
          CMP       R0,10H              ;STRING TOO SHORT, BRANCH  PARTMAX = 10H
          JB        $INITER2

;*%PROCESS MODE VARIABLE
$INITC:                                 ;MUST FIND COMMA
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          CALL      ALPHA               ;GET ALPHA STR 3
          CMP       R0,0                ;NF, ERROR
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        $INITD
;         CALL      POPV4               ;GET ADDRESS & COUNT OF STR
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       AUX0D,EDX           ;SAVE ADDRESS
          CMP       R1,0
          JNE       $INITD
          CMP       R0,10H              ;STRING TOO SHORT, BRANCH  PARTMAX = 10H
          JB        $INITER2

;*%PROCESS BOOTSTRAP NAME VARIABLE
$INITD:                                 ;MUST FIND COMMA
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          CALL      ALPHA               ;GET ALPHA STRING
          CMP       R0,0                ;NF, ERROR
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        $INITE
;         CALL      POPV4               ;GET ADDRESS & LENGTH OF STRING
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       AUX0C,EDX           ;SAVE ADDRESS
          CMP       R1,0
          JNE       $INITE
          TEST      R0,80H              ;STRING LENGTH MUST BE >=128
          JZ        $INITER2

;*%PROCESS DEVICE TABLE PARAMETER
$INITE:                                 ;MUST FIND COMMA
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
          CALL      ALPHA               ;GET ALPHA VARIABLE
          CMP       R0,0                ;NF, ERROR
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        $INITF
;         CALL      POPV4               ;GET ADDRESS & LENGTH OF STRING
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       AUX0A,EDX           ;SAVE ADDRESS
          CMP       R1,0
          JNE       $INITF
          CMP       R0,63H              ;BRANCH IF STRING TOO SHORT
          JB        $INITER2

;*%PROCESS PASSWORD PARAMETER
$INITF:   CMP       BYTE PTR [TEXTPTR],','
          JNE       $INITG              ;NF, BRANCH
          INC       TEXTPTR
          CALL      ALPHA
          CMP       R0,0                ;NF, BRANCH
          JNE       $INITF1
          TEST      SL,2                ;BRANCH IF NOT X-PHASE
          JZ        $INITF1
          MOV       EDX,OFFSET _INITPSW
          MOV       AUX0F,EDX           ;ADDRESS OF PASSWORD
;         CALL      POPV4               ;GET ADDRESS & LENGTH OF PASSWORD
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          CMP       R1,0
          JNE       $INIT15
          CMP       R0,8                ;BRANCH IF STRING TOO SHORT
          JB        $INITER2

$INIT15:  MOV       R0,DL
          ADD       R0,8
M36_02:
          MOV       CX,[EDX]
          ADD       EDX,2
          XCHG      EDX,AUX0F
          MOV       [EDX],CX
          ADD       EDX,2
          XCHG      EDX,AUX0F           ;STORE PASSWORD
          CMP       DL,R0
          JNE       M36_02

;*%PROCESS PRINTER DRIVER PARAMETER
$INITF1:  TEST      SL,XPHASE           ;branch if not xphase
          JZ        $INITF2
          MOV       AUX09,0             ;INIT AUX 9 TO 0000h

$INITF2:  CMP       BYTE PTR [TEXTPTR],','
          JNE       $INITF2X
          INC       TEXTPTR
$INITF2X:
          CALL      ALPHA               ;GET ALPHA VARIABLE
          CMP       R0,0                ;BRANCH IF NOT FOUND
          JNE       $INITG
          TEST      SL,2                ;BRANCH IF NOT X-PHASE
          JZ        $INITH
;         CALL      POPV4               ;GET ADDRESS AND LENGTH OF PASSWORD
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       AUX09,EDX           ;SAVE ADDRESS
          CMP       R1,0                ;IF HIGH 1/2 LENGTH NOT 0, BRANCH
          JNE       $INITH
                                        ;OTHERWISE LOW 1/2 MUST BE > THAN 150
          CMP       R0,096H             ;BRANCH IF STRING TOO SHORT
          JB        $INITER2
;*%LOAD SYSTEM PASSWORD TO MXE
          CALL      MXEPSW

;*%PROCESS OS MODIFIER PARAMETER
$INITH:   CMP       BYTE PTR [TEXTPTR],','
          JNE       $INITG              ;NF, BRANCH
          INC       TEXTPTR
          CALL      ALPHA
          CMP       R0,0                ;ERROR IF NO ALPHA VAR OR LITERAL
          JNE       $INITER1
          TEST      SL,2                ;BRANCH IF NOT X-PHASE
          JZ        $INITG
;         CALL      POPV4               ;GET ADDRESS & LENGTH OF VALUE
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       CX,[EDX]            ;GET VALUE
          MOV       OSMOD,CX            ;VALUE ==> OSMOD

;*%
$INITG:                                 ;MUST FIND ')'
          CMP       BYTE PTR [TEXTPTR],')'
          JNE       ERROR_11            ;BRANCH IF NOT MATCH
          INC       TEXTPTR

          TEST      SL,2                ;BRANCH IF X PHASE
          JNZ       M36_03
$INIT5:   JMP       ENDSTMT

;*%  LOAD PRINTER DRIVER TABLES
M36_03:
          PUSH      AUX0A
          PUSH      AUX0B
          PUSH      AUX0C
          PUSH      AUX0D
          PUSH      AUX0E
          PUSH      AUX0F

          MOV       PDFLAG,0
          MOV       EDX,OFFSET MSTRTABL
          MOV       ECX,30              ;INITIALIZE MASTER DRIVER TBL LIST TO 0
MSTRINIT:
          MOV       DWORD PTR [EDX],0
          ADD       EDX,4
          LOOP      MSTRINIT

          MOV       EDX,OFFSET DRVRDEV
          MOV       ECX,36              ;INITIALIZE DRIVER DEV LIST TO 0
DDEVINIT:
          MOV       WORD PTR [EDX],0
          MOV       BYTE PTR [EDX+2],0
          ADD       EDX,3
          LOOP      DDEVINIT

          MOV       EDX,OFFSET TABLNAME
          MOV       ECX,32              ;INITIALIZE DRIVER TBL NAME LIST TO 20
NAMEINIT:
          MOV       DWORD PTR [EDX],20202020H
          ADD       EDX,4
          LOOP      NAMEINIT

          CALL      PARTINIT            ;INITIALIZE DRIVER PARTITION STATUS TABLE
          CMP       AUX09,0             ;IF PRINTER DRIVER ARG.....
          JE        EXIT999             ;THEN BRANCH TO EXIT999

          MOV       EDX,OFFSET TABLSTRT
          MOV       AUX07,EDX           ;INITIALIZE CONTROL MEMORY POINTER TO START OF TABLES

          MOV       EDX,0
          MOV       AUX08,EDX           ;INITIALIZE NUMBER OF TABLES LOADED TO 0
          PUSH      EDX                 ;COUNT HOW MANY TABLES WE'VE DONE

TABLLOAD: POP       EDX                 ;COUNT HOW MANY TABLES WE'VE DONE
          INC       EDX
          PUSH      EDX                 ;IF WE'VE ALREADY DONE 15 TABLES...
          CMP       DL,10H              ;THEN LEAVE CUZ WE'RE ALL DONE!
          JNZ       M36_05
EXIT998:  POP       EDX
          JMP       EXIT999

M36_05:
          MOV       EDX,DWORD PTR [BASEP]
          LEA       EDX,[EDX].@WORKSPC
          MOV       AUX00,EDX           ;SAVE POINTER
          MOV       WORD PTR R2,8       ;F3F2 = LENGTH OF TABLE NAME
          MOV       WORD PTR R0,8       ;F1F0 = LENGTH OF TABLE NAME
          MOV       EDX,AUX09           ;RECALL POINTER TO FILENAME IN TEXT
          CALL      ARECEVAL            ;PUT FILENAME INTO WORK SPACE
          ADD       AUX09,8             ;AUX9 = AUX9 + 8

          MOV       EDX,DWORD PTR [BASEP]
          LEA       EDX,[EDX].@WORKSPC
          MOV       WORD PTR R2,0       ;AND CHECK FILENAME TO BE SURE
          MOV       R4,20H

EXIT998A: MOV       CH,BYTE PTR [EDX]
          MOV       AUX00,EDX           ;INCREMENTAND SAVE POINTER TO FILENAME IN WORKSPACE
          INC       AUX00
          INC       R3                  ;INCREMENT NUMBER CHECKED
          CMP       R4,CH               ;BRANCH IF NOT BLANK
          JNE       M36_06
          INC       R2                  ;INCREMENT NUMBER BLANK
M36_06:
          CMP       R3,8                ;BRANCH IF ALL DONE
          JE        M36_07
          MOV       EDX,AUX00           ;RECALL READ ADDRESS
          JMP       EXIT998A            ;CHECK NEXT CHARACTER
M36_07:
          CMP       R2,8                ;BRANCH IF NOT ALL BLANK
          JE        TABLLOAD            ;EXIT, ALL DONE LOADING TABLES

; DRIVERS IN CONFIGURATION - SET PDFLAG TO 1 AND LOAD TABLES

          MOV       PDFLAG,1            ;POINT TO PRINTER DRIVER FLAG
          MOV       R2,1

          CALL      GETTABL_            ;GET TABLE NUMBER, CREATE IT IF NON-EXISTANT
          XCHG      EDX,AUX08           ;RECALL TABLE NUMBER'
          CMP       DH,0F0H             ;BRANCH IF TABLE ALREADY LOADED
          JNE       MAKDRVRE
          XCHG      EDX,AUX08           ;PUT TABLE NUMBER BACK

          MOV       EDX,0
          MOV       DX,BOOTDEV          ;PUT BOOT PLATTER ADDRESS IN AUXE
          MOV       AUX0E,EDX
          CALL      ENBLDEVD            ;ENABLE DISK
          CALL      FINDNAMH            ;SEARCH CATALOG INDEX FOR FILE

          CMP       R3,10H
          JNE       ERROR_82            ;BRANCH IF SCRATCHED OR NOT FOUND
          CALL      MOVETABL            ;LOAD TABLE INTO CONTROL MEMORY
          CALL      ENDDISKR            ;RELEASE THE DISK

          MOV       EAX,AUX08           ;RECALL TABLE NUMBER
          DEC       EAX                 ; 1 --- N   ===> 0 --- (N-1)
          AND       EAX,0FFH            ;EAX = TABLE NUMBER
          SHL       EAX,3

          MOV       EDX,OFFSET MSTRTABL
          ADD       EDX,EAX             ;PC'S = ADDRESS IN MASTER DRIVER TABLE LIST

          MOV       AUX01,EDX           ;SAVE ADDRESS IN AUX07
          MOV       EAX,AUX07
          MOV       [EDX],EAX
          MOV       EDX,AUX07
          MOV       EAX,0
          MOV       AX,WORD PTR R4      ;R5R4 UNIT = CONTROL MEMORY WORD
          MOV       BX,3
          PUSH      EDX
          MUL       BX                  ;MUL PUT THE RESULT IN DX:AX
          POP       EDX
          ADD       EDX,EAX             ;PC'S = START OF ESC. TRANS. TABLE
          MOV       AUX00,EDX           ;SAVE START IN AUX0

          MOV       EDX,AUX01           ;RECALL ADDRESS IN MASTER DRIVER TABLE LIST
          ADD       EDX,4               ;PC'S = WRITE ADDRESS
          MOV       EAX,AUX00
          MOV       [EDX],EAX           ;WRITE OUT START OF ESC. TRANS. TABLE
          MOV       EDX,AUX0D           ;RECALL NEXT AVAILIBLE CONTROL MEMORY LOCATION
          MOV       AUX07,EDX           ;SAVE IN AUX 7

MAKDRVRE: MOV       EDX,AUX09           ;RECALL ADDRESS OF DEVICE ADDRESS IN TEXT
          MOV       CX,[EDX]            ;READ IN DEVICE ADDRESS FROM TEXT
          XCHG      CH,CL               ;CH =  DEVICE ADDRESS , CL = TERMINAL NUMBER
          ADD       EDX,2
          MOV       WORD PTR R0,CX      ;R0=CL= TERMIANL , R1=CH=DEVICE
          MOV       EDX,AUX08           ;RECALL TABLE NUMBER
          MOV       DH,R1
          MOV       AUX00,EDX           ;SAVE IN AUX0( DX=DEVICE ADDRESS & TABLE NUMBER)
          CALL      IDRVRDEV            ;FIND OPENING IN DRIVER DEVICE LIST
          MOV       AUX01,EDX
          MOV       AL,R0
          MOV       K,AL
;         CALL      WCM
          MOV       AL,K                ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX   ;+-WCM
          ADD       AUX09,2             ;INC AUX9 BY 2
          MOV       EDX,AUX09           ;COPY POINTER INTO PC'S
          XCHG      EDX,AUX08

          MOV       DX,0FFFFH
          MOV       K,0                 ;K,PHPL = WORD 2 OF ENTRY, TURNS DRIVER ON FOR ALL PARTITIONS
          MOV       AUX00,EDX
          MOV       EDX,AUX01
          ADD       EDX,3               ;PC'S = ADDRESS OF WORD 2 OF ENTRY
;         CALL      WCM
          MOV       AL,K                ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX   ;+-WCM

TLOAD:    JMP       TABLLOAD            ;LOAD NEXT TABLE
EXIT999:
          POP       AUX0F               ;RESTORE AUX F
          POP       AUX0E               ;RESTORE AUX E
          POP       AUX0D               ;RESTORE AUX D
          POP       AUX0C               ;RESTORE AUX C
          POP       AUX0B               ;RESTORE AUX B
          POP       AUX0A               ;RESTORE AUX A

;*%VERIFY PARTITION SIZES
$INITVPS:
RGNP12:
; ++++
;       CHECK THE EACH/TOTAL MEMORY REQUIREMENT FOR ALL PARTITION
;
;       AUX0B -- PT TO PARTITION SIZE PARAMETERS
;       WHEN EXIT TO $INIT7 -- EAX HAS THE UPPER BOUND OF MEMORY REQUIREMENT
;       FOR THE PARTITIONS NEED

        mov     eax,basep               ;get base address of partition #1
        mov     edx,aux0b               ;get the ptr of partition size para
$init22:
        xor     ecx,ecx
        mov     cx,[edx]                ;get the part size in # of page
        or      cx,cx                   ;chk if end of entries
        jz      $init7                  ;br, if zero
        xchg    ch,cl
        add     edx,2                   ;pt to next entry
        cmp     cx,minpart              ;chk for minimum requirement (# of pages)
        jb      $initer4                ;br, if part too small

        shl     ecx,8                   ;make size in byte
        add     eax,ecx                 ;count the current end
        cmp     eax,endmemx             ;chk with system limits
        jbe     $init22                 ;br, if not exceed the limit

$initer4:
        jmp     error_34                ;report illegal value

;
;       SET UP PSTAT/BASE TABLE CONTAINS AND BOOTSTRAP NAMES
;
;       EBX --- PT AT PSTAT     EDX --- PT AT BASE
;       EAX --- USED FOR CURRENT PART STARTING ADDRESS
;       ESI --- PT AT PARTITION SIZE PARAMETERS
;       ECX --- FOR CALCULATING INDIVIDUAL PART SIZE

$init7:
        push    ebx
        push    esi

        mov     endpart,eax             ;save the ending address that needed
        mov     eax,basep               ;get the base address of partition #1
        mov     ebx,offset pstat        ;get the starting address of PSTAT tab
        mov     aux00,ebx               ;save it in AUX00
        mov     edx,offset base         ;get the starting address of BASE tab
        mov     aux01,edx               ;save it in AUX01
        mov     esi,aux0b               ;get the address of part size specification

$init20:
        cmp     word ptr [esi],0        ;are we reach the end?
        je      $init21                 ;br, yes
        mov     byte ptr [ebx],pstatict ;mark current part as i/o completed
                                        ;cause OS to process this part!
        mov     dword ptr [edx],eax     ;save base address of this part in PBASE
        inc     ebx                     ;pt to next entry of PSTAT
        add     edx,4                   ;pt to next entry of PBASE

;       push    eax                     ;save eax / esi for a while
;       push    esi                     ;
;       lea     eax,[eax].@workspc      ;
;       mov     esi,aux0c               ;get the ptr of name string (8bytes/part)
;       mov     ecx,dword ptr [esi]     ;
;       mov     dword ptr [eax],ecx     ;copy the name string into @WORKSPC
;       add     eax,4                   ;
;       add     esi,4                   ;
;       mov     ecx,dword ptr [esi]     ;
;       mov     dword ptr [eax],ecx     ;
;       add     esi,4                   ;
;       mov     aux0c,esi               ;
;       pop     esi                     ;
;       pop     eax                     ;

        xor     ecx,ecx                 ;
        mov     cx,word ptr [esi]       ;get part size ( in # of page )
        xchg    ch,cl
;       cmp     cl,0                    ;check is it the end ?
;       je      $init21                 ;br, yes
        add     esi,2
        shl     ecx,8                   ;make it in byte
        add     ecx,eax                 ;
        dec     ecx                     ;ECX has the ending byte of current part
        lea     eax,[eax].@partend      ;
        mov     dword ptr [eax],ecx     ;save the ending pt in part infor
        inc     ecx                     ;ECX has the staring pt of next part
        mov     eax,ecx                 ;
        jmp     $init20                 ;
$init21:
        mov     byte ptr [ebx],pstatetb ;
        pop     esi
        pop     ebx
; ----
          MOV       AL,R3       ;###!!! doesn't make any sense ?????
          MOV       R4,AL
          CALL      INITRAMD    ;initialize ramdisk

;** SET UP PTERM TABLE ....     12/29/88
;       Logic:  Get the term# from $INIT specification, init PTERM entry as
;               detached/released, if the term# > maxterm# allow then get next.
;               Write the board#&term# into entry.
;               Search if there any other entry has attached this term#, if yes
;               then mark this part to detached.  Also chk for board exist.
;
        mov     edx,offset pterm        ;
        mov     ebx,aux0e               ;
$init2:
        mov     cl,byte ptr [ebx]       ;get the term# spec
        mov     byte ptr [edx],ptermd+ptermrls  ;init as no terminal assigned
        cmp     cl,0                    ;chk unused entry
        je      $init13                 ;br, yes
        cmp     cl,maxterm_             ;chk if illegal term# spec
        ja      $init13                 ;go get next one
        dec     cl                      ;
        mov     ch,cl
        shl     ch,4
        or      cl,ch
        mov     al,cl                   ;
        and     al,0c3h                 ;extract board# & terminal#
        mov     byte ptr [edx],al       ;
        mov     ecx,edx                 ;ecx has current pterm entry ptr
        sub     ecx,offset pterm        ;ecx has current entry #
        jz      $init14                 ;skip if this the first one
        push    edx                     ;save a bit
        mov     edx,offset pterm        ;chk from begining
$init18:
        cmp     al,byte ptr [edx]       ;if someone already own this term#
        je      $init17                 ;yes
        inc     edx                     ;pt to next entry
        loop    $init18
        pop     edx                     ;restore current table ptr
$init14:
                        ;chk if MXD present ?
        xor     ecx,ecx                 ;
        mov     cl,al                   ;
        shr     ecx,6                   ;make ecx as an index
        mov     eax,offset mxdadr       ;
        cmp     byte ptr [eax+ecx],0ffh ;is it exist ?
        jne     $init13
        or      byte ptr [edx],ptermd   ;mark as detached

$init13:
        inc     edx                     ;pt to next pterm entry
        inc     ebx                     ;pt to next term spec
        cmp     edx,offset pterm+16     ;are we complete the whole table?
        jb      $init2                  ;no, go get next one
        jmp     $init11                 ;

$init17:
        pop     edx                     ;restore current table ptr
        or      byte ptr [edx],ptermd   ;mark as detached
        jmp     $init13                 ;
$init11:

;--

;*%SET UP PMODE TABLE
;*     NOTE:
;*          1. ASSUMES PMODE ENDS AT 'xxxF'.
;*
          MOV       EDX,OFFSET PMODE-1
$INIT4:   INC       EDX
          XCHG      EDX,AUX0D
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          XCHG      EDX,AUX0D           ;GET NEXT PROGRAMMABILITY BYTE
          MOV       BYTE PTR [EDX],CH   ;MODE ==> PMODE TABLE
          CMP       EDX,OFFSET PMODE+0FH;BRANCH IF MORE ENTRIES
          JNE       $INIT4

;*%PROCESS DEVICE TABLE
          mov       esi,offset mdevtbl  ;get MDT starting pt
          mov       ebx,aux0a           ;get starting pt of dev paramters
$init9:
          mov       ch,[ebx]            ;get the dev type byte
          mov       r1,ch               ;F1 low 4 bit = device type
          and       r1,0fh              ;F1 high nibble = file status must be masked out
          mov       ch,[ebx+1]          ;get dev addr
          mov       k,ch                ;K = device addr
          cmp       ch,0                ;br, if end of dev paramters
          je        $init10             ;
          mov       ch,[ebx+2]          ;get part# that device allocated to
          add       ebx,3               ;advance to next entry
          mov       r2,ch               ;part#
          dec       r2                  ;F2 should be (0h - Fh)
          and       r2,0fh
          cmp       ch,0                ;br, if dev not assigned to anyone
          je        m36_13              ;
          or        r2,devexcl+devopen  ;
m36_13:
          cmp       r1,_phoenix         ;br, if type = Phoenix
          je        m36_14              ;
          cmp       r1,3                ;br, if type = disk
          je        m36_14              ;
          cmp       r1,0bh              ;br, if type <> disk
          jne       $init12             ;
m36_14:
          or        r2,devtdisk         ;mark disk type
          and       k,07fh              ;
          cmp       k,40h               ;br, if addr = RAM DISK
          je        m36_15              ;
          and       k,3fh               ;if disk, change addr to primary address
m36_15:
          cmp       r1,_phoenix         ;if device type = 'D', strip off platter bits
          jne       $init12
          and       k,30h               ;

$INIT12:  TEST      K,08
          JNZ       $INIT24
          TEST      K,0FH
          JZ        $INIT24
          TEST      K,030H               ;BRANCH IF MXD ADDRESS
          JZ        $INIT9

$INIT24: ;CALL      SRCHDEVA            ;LOOK FOR DEVICE IN MDT
         ;CMP       CH,0                ;BRANCH IF ALREADY IN MDT
         ;JNE       $INIT9
          mov       al,k                ;dev addr
          mov       [esi],al            ;device addr --> MDT
          mov       al,r2               ;dev type/status
          mov       [esi+1],al          ;dev type/status --> MDT
          add       esi,2               ;
          cmp       esi,mdevtble        ;br, if not end of table
          jne       $init9

;*%DONE
;*  MUST SET FLAG TO DISABLE FURTHER SYSGENS
$INIT10:
        mov     esi,offset base
$init11x:
        mov     eax,dword ptr [esi]
        cmp     eax,0
        je      $init12x
        lea     eax,[eax].@workspc      ;
        mov     edi,aux0c               ;get the ptr of name string 8bytes/part)
        mov     ecx,dword ptr [edi]     ;
        mov     dword ptr [eax],ecx     ;copy the name string into @WORKSPC
        add     eax,4                   ;
        add     edi,4                   ;
        mov     ecx,dword ptr [edi]     ;
        mov     dword ptr [eax],ecx     ;
        add     edi,4                   ;
        mov     aux0c,edi               ;
        add     esi,4
        jmp     $init11x
$init12x:

          OR        SYSGENFG,01

;*  NOW PERFORM MASTER INITIALIZATION FOR EACH PARTITION
          mov       edx,cpbase
          mov       cx,word ptr [edx].@devdisk
          xchg      ch,cl
          mov       bootdev,cx          ;bootdev = default disk addr for part #1
;******** CALL      SLCTBK_1            ;select 1st bank
          JMP       PRIME3

;*  ERROR BRANCHES
$INITER1: JMP       ERROR_29            ;MISSING ALPHA VARIABLE
$INITER2: JMP       ERROR_51            ;VARIABLE OR VALUE TOO SHORT
$INITER3: JMP       ERROR_19            ;MISSING REQUIRED WORD
$INITER5: JMP       ERROR_08            ;STATEMENT NOT LEGAL HERE

;         TITLE     LOADMXD
;*LOADMXD: Download MXD microprogram if it's loadable.
;*     ENTRY: K = MXD control address
;*
;*     RETURN: K = MXD TYPE
;*
;*      MODIFIED REGISTERS: ALL, AUX0-2,B-F
;*
LOADMXD:
          MOV       DX,0
          MOV       DL,K                ;get device control addr
          CALL      ENBLDEVA            ;enable MXD control address
          CALL      MXDTYPE             ;determine type of MXD
          TEST      R2,80H              ;branch if MXD not to be loaded (type 00)
          JZ        LOADMXD4
          MOV       EDX,OFFSET LOADMXE
          CALL      SETERRP             ;if error, branch to LOADMXE

          MOV       EDX,BASEP
          LEA       EDX,[EDX].@WORKSPC
                                        ;filename ==> @WORKSPC
          MOV       DWORD PTR [EDX],'EXM@'
          MOV       DWORD PTR [EDX+4],'   0'
          ADD       EDX,8

          MOV       ECX,0
          MOV       CX,BOOTDEV
          MOV       DOWNFROM,ECX        ;disk address = bootstrap disk address
          MOV       EDX,ACTDEV
          MOV       DOWNINTO,EDX        ;MXD address

          AND       SL,0FFH-PHASE
          OR        SL,XPHASE           ;pretend X-phase for disk subroutines
          CALL      DOWNLOAD            ;load MXD
          AND       SL,0FFH-PHASE       ;entry phase
LOADMXD4: JMP       ENBLNLLD            ;disable all devices

;*%----------------- error during download --------------------------------------
;*     Entry: F0 = error code
;*            WORKSPAC contains filename
;*            DOWNINTO contains address of device being loaded
;*            DOWNFROM contains address of device loading from
;*
LOADMXE:
          CALL      MXDLOADD            ;end of downloading command
          MOV       EDX,OFFSET ERRORN
          CALL      SETERRP             ;restore normal error processing
          MOV       AL,R0
          MOV       R7,AL               ;save error code
          MOV       K,05
          CALL      ENBLDEVB            ;enable CRT in VP mode

          MOV       EDX,OFFSET VPMSG1
          MOV       WORD PTR R0,7       ;length of message
          CALL      OBSBLKNT            ;CR 'Error '
          CALL      ERRTYPE             ;get type of error
          MOV       AL,K
          CALL      OBSNT               ;error type

          MOV       AL,R7
          SHR       AL,4
          OR        AL,30H
          CALL      OBSNT               ;1st digit

          MOV       AL,R7
          AND       AL,0FH
          OR        AL,30H
          CALL      OBSNT               ;2nd digit

          MOV       EDX,OFFSET VPMSG2
          MOV       WORD PTR R0,1DH
          CALL      OBSBLKNT            ;' loading terminal controller.' CR

;* If RESET pressed, jump to start of BOOTSTRAP
ERROR_MXE:
          MOV       K,05
          CALL      ENBLDEVB            ;ENABLE CRT AT ADDRESS 05!
          MOV       K,03
          CALL      OBSTROBD            ;CLEAR SCREEN (SINCE BOOTSTRAP DOESN'T SEEM TO!)
ERROR_MXE1:
          TEST      BYTE PTR FS:[CPUST+1],01H
          JZ        ERROR_MXE1

          lgdt      tgdt
          jmp       pword ptr ijump     ;jump to bootstrap

;         TITLE     DOWNLOAD
;*DOWNLOAD: downloads the specified device controller with data from a specified
;*        data file on disk.  This routine is used for loading MXE's and could be
;*        possibly be used for other loadable devices.
;*
;*        This implementation loads from a BASIC-2 PROM format file.  Only records
;*        of type 1 are loaded; all other records in the file are ignored.  A
;*        record in the PROM format is as follows:
;*
;*                  byte 1-2    record header (hex(8081))
;*
;*                  byte 3      SOV (hex(82))
;*                  byte 4      record type (1 if data to load)
;*                  byte 5      LRC
;*
;*                  byte 6      SOV (hex(83))
;*                  byte 7-8    data address (to store data at in device controller)
;*                  byte 9      number of bytes of data
;*
;*                  byte 10     SOV  (hex(BC))
;*                  byte 11-70  data (up to 60 bytes)
;
;*                  byte 71     SOV  (hex(BC))
;*                  byte 72-131 data (up to 60 bytes)
;
;*                  byte 132    SOV  (hex(BC))
;*                  byte133-192 data (up to 60 bytes)
;
;*                  byte 193    SOV  (hex(BC))
;*                  byte194-253 data (up to 60 bytes)
;
;*                  byte 254    EOR  (hex(FD))
;*
;*          The data from each type 1 sector is sent with the following protocol:
;*
;*                  Device enabled
;*                  CBS      &DWNLOAD
;*                  OBS      high byte of data address
;*                  OBS      low byte of data address
;*                  OBS      number of bytes of data
;*                  OBS's    data bytes
;*
;*          After all data has been sent (ie, EOF), the following command is
;*          sent indicating that the loading is complete:
;*
;*                  CBS     &LOADED
;*
;*     Entry:
;*          Phase = execution (although VS not used).
;*          Filename in 1st 8 bytes of WORKSPAC.
;*          DOWNFROM = AUX register containing disk address.
;*          DOWNINTO = AUX register containing address of
;*                     device to load.
;*
;*     Return:
;*          F0 = 00 if download complete.
;*               error code if cannot download (most likely
;*                     this is a disk error code).
;*
;*     Modified registers: all, AUX 0-2,B-F
;*
;
DOWNLOAD:
          MOV       EDX,DOWNFROM
          CALL      ENBLDEVD            ;enable disk

          MOV       EDX,0
          MOV       AUX0E,EDX           ;platter = 'T'
          CALL      FINDNAMH            ;look for file in index
          CALL      FILENMDA            ;error if file not found
          CALL      GTFLPTRS            ;AUXB = start of file address; AUXD = end of file
          MOV       EDX,AUX0D
          MOV       AUX0F,EDX           ;AUXF = EOF address
          CALL      DREADSF             ;read EOF sector
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CL,BYTE PTR [EDX+1]

          ADD       EDX,2
          MOV       CH,BYTE PTR [EDX]
          XCHG      CH,CL
          MOV       WORD PTR R6,CX      ;F7,6 = no. of sectors used in file
          MOV       EDX,AUX0B
          MOV       AUX0F,EDX           ;AUXF = start address of file
          ADD       WORD PTR R6,DX      ;F7,6 = address of last sector +1

;*%----------------- next sector of file ----------------------------------------
DOWNLD1:  MOV       EDX,AUX0F
          CMP       WORD PTR R6,DX      ;branch if no more sectors to load
          JBE       DOWNLD2
          MOV       EDX,DOWNFROM
          CALL      ENBLDEVD            ;enable disk
          CALL      DREADSF             ;read next sector of file

;*%----------------- check sector type ------------------------------------------
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          CMP       CH,0A0H             ;branch if trailer record (EOF)
          JE        DOWNLD21
          ADD       EDX,3
          MOV       R0,1                ;get type of sector
          MOV       CH,BYTE PTR [EDX]
          CMP       CH,R0               ;branch if not type 1
          JNE       DOWNLD1

;*%----------------- download sector --------------------------------------------
          MOV       EDX,DOWNINTO
          CALL      ENBLDEVA            ;Enable device to be loaded
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          ADD       EDX,6
          MOV       CX,[EDX]
          XCHG      CH,CL
          ADD       EDX,2
          MOV       WORD PTR R4,CX      ;F5F4 data address
          MOV       CH,BYTE PTR [EDX]
          MOV       R3,CH               ;number of bytes of data
          ADD       EDX,2               ;get addr of block of characters
          JMP       DOWNLD4

DOWNLD3:  MOV       AL,?amDWNLOAD
          CALL      CBSNT               ;download command
          MOV       R0,3CH
          CMP       R3,3CH              ;F1,0 = no. of bytes to output
          JAE       M36_17
          MOV       AL,R3
          MOV       R0,AL               ;(min. of 60 and remaining bytes)
M36_17:
          MOV       R1,0
          MOV       AL,R5
          CALL      OBSNT               ;high byte of data address
          MOV       AL,R4
          CALL      OBSNT               ;low byte of data address
          MOV       AX,WORD PTR R0
          ADD       WORD PTR R4,AX      ;increment data address
          MOV       AL,R3
          CALL      OBSNT               ;number of bytes

DOWNLD35: MOV       R0,3CH
          CMP       R3,3CH              ;F1,0 = no. of bytes to output
          JAE       M36_18
          MOV       AL,R3
          MOV       R0,AL               ;(mim. of 60 and remaining bytes
M36_18:
          MOV       R1,0
          MOV       AL,R0
          SUB       R3,AL               ;decrement # of bytes left
          CALL      OBSBLKNT            ;data bytes
          CMP       R3,0                ;b if more data bytes are left
          JE        DOWNLD1
          INC       EDX                 ;skip 1 control byte
          JMP       DOWNLD35

DOWNLD4:  CMP       R3,0                ;branch if more to output
          JNE       DOWNLD3
          JMP       DOWNLD1
;*%----------------- end of download --------------------------------------------
DOWNLD21: MOV       R0,0                ;flag = download complete
DOWNLD2:  MOV       EDX,DOWNINTO        ;Enable device to be loaded
          CALL      ENBLDEVA
          JMP       MXDLOADD            ;send download complete signal

;         TITLE     MXDINIT
;*MXDINIT: POWER ON INITIALIZE MXD
;*
;*     ENTRY: K = MXD CONTROL ADDRESS
;*            PC'S = ADDRESS TO SAVE MXD STATUS ADDRESS AT
;*
;*     RETURN: IF MXD EXITS (READY AT CONTROL ADDRESS),
;*               POWER ON INITIALIZE MXD
;*               MXD STATUS ADDRESS SAVED
;*
;*             IF MXD NONEXISTENT (BUSY AT CONTROL ADDRESS),
;*               SAVED STATUS ADDRESS = FF
;*
;*      MODIFIED REGISTERS: PC'S INCREMENTED, F0,K
;*
MXDINIT:  MOV       AL,K
          AND       AL,0C0H
          MOV       R0,AL
          OR        R0,@MXDSADR         ;F0 = MXD STATUS ADDRESS
          CALL      ENBLDEVB            ;ENABLE MXD CONTROL ADDRESS
          CALL      WAIT16RB
          TEST      BYTE PTR FS:[CPUST],08H
          JZ        MXDINIT1            ;ASSUME MXD DOESN'T EXIST IF NOT READY

;*MXD EXISTS (READY)
          MOV       AL,R0               ;SAVE STATUS ADDRESS
          MOV       BYTE PTR [EDX],AL
          INC       EDX
          JMP       MXDPOWER            ;POWER ON INITIALIZE MXD

;*MXD NOT EXISTS
MXDINIT1: MOV       AL,0FFH             ;Status address = x'FF';Increment PCs
          MOV       BYTE PTR [EDX],AL
          INC       EDX
          RET

;         TITLE     MXDPOWER
;*  MXDPOWER:  restart the MXD at the power on location.  Diagnostics are run,
;*        buffers and devices are initialized, CRT's are cleared, and the
;*        operation mode is VP.
;
;*        Sequence: MXD control address enabled
;*                  CBS     &POWER
;*                  OBS     &NULL
;
;*        Entry:  MXD enabled at the control address
;
;*        Modified registers: K
;
MXDPOWER: MOV       AL,?amPOWER
          CALL      CBSNT               ;POWER ON INITIALIZE MXD
          MOV       AL,0
          JMP       OBSNT               ;OBSTROBE NULL

;         TITLE     MXDTYPE
;*  MXDTYPE:  determine the type of MXD controller.
;
;*     type-request sequence:
;*
;*          MXD control address enabled
;*          CBS     &TYPE
;*          OBS     &NULL
;*          WR
;*          IBS     type
;*          IBS
;*           .
;*           .      future expansion
;*           .
;*          IBS
;*          IBS ENDI  terminator
;*
;*     MXD types (1st byte of type request response):
;
;*          no response -- PROM MXD (doesn't support type cmnd)
;*          bit01 = 1 iff triple controller with no clock
;*          bit02 = 1 iff MXD has a time-of-day clock
;*          bit04 = 1 iff MXD has a battery backup for clock
;*          bit80 = 1 iff controller needs to be downloaded
;
;*          The MXD does not respond to this command (thus, has type 01).
;*          The triple controller responds with 01 (no clock) or 03 (clock).
;*
;*        Entry: MXD enabled at the control address
;*        Return: F2 = type
;*        Modified registers: K,F2
;*

MXDTYPE:  MOV       AL,?amTYPE
          CALL      CBSNT               ;request controller type
          MOV       AL,0
          CALL      OBSNT               ;filler to make MXD busy
M36_19:
          TEST      BYTE PTR FS:[CPUST],08h
          JZ        M36_19              ;I/O NOT READY = MXD is not ready
          CALL      WAITIBS             ;wait up to 15ms. for a type response
          TEST      BYTE PTR FS:[CPUST],CPB
          JZ        MXDTYPE1            ;branch if no response (MXD type)
          MOV       AL,K
          MOV       R2,AL               ;save MXD type
          JMP       IBSENDIB            ;get (& ignore) the rest of type message

MXDTYPE1: MOV       R2,1                ;MXD implied response
;@3?pd0MXDT:
;         OR        SH,CPB              ;don't allow input (added rel 3.0)
          RET

;         TITLE     MXDLOADD
;*  MXDLOADD:  tell the MXD that downloading is complete.  The MXD then
;*        branches to the downloaded code.  In the case of normal operations
;*        the operation mode is changed to MVP.
;
;*        Sequence: MXD control address enabled
;*                  CBS     &LOADED
;*                  OBS     &NULL
;
;*        Entry:  MXD enabled at the control address
;
;*        Modified registers: K
;
MXDLOADD: MOV       AL,?amLOADED
          CALL      CBSNT               ;POWER ON INITIALIZE MXD
          MOV       AL,0
          JMP       OBSNT               ;OBSTROBE NULL

;         TITLE     SETRESET
;*SETRESET: change RESET trap location to branch to the
;*          specified location.
;*
;*     Entry: PC's = address RESET should branch to.
;*
;*     WARNING: if the RESET trap does not branch to the RESET
;*              routine, the control memory checksums will not
;*              be correct.
;*
;*SETRSETB: if RESET pressed, jump to begin of BOOTSTRAP.
;*
SETRSETB: MOV       EDX,OFFSET RESTART   ;if RESET, jump to begin of BOOTSTRAP
SETRESET: MOV       DWORD PTR [RESETPROC],EDX
          RET
BRESTART: JMP       RESTART

;         TITLE     $DISCONNECT
;
;*        Format:  $DISCONNECT ON [expression]
;*                             OFF
;
;*        $DISCONNECT OFF disables disconnect detection; this is the default
;*        state of the machine.  $DISCONNECT ON enables disconnect detection.
;*        If an expression is specified, the value is the time in seconds after
;*        which the MXE will force a disconnection of the terminal.  If no
;*        expression is specified, there will be no forced disconnection.
;
;*        The operating system is informed of disconnections iff disconnect has
;*        been enabled (by $DISCONNECT ON).  Disconnections caused by timeout,
;*        modem disconnection, or terminal power off are indistinguishable.
;*        Disconnect information is passed to the OS when a status request is
;*        done by the OS at the MXE status address.
;
;*        Upon detection of a disconnect, all partitions assigned to that terminal
;*        are forced by the OS to run a program called @DISCONNECT.  The process
;*        is functionally equivalent to typing RESET followed by LOAD RUN
;*        "@DISCONNECT".
;
;*        $DISCONNECT ON command sequence:
;
;*                  Enable MXE control address and select terminal.
;*                  CBS     &DISCNON
;*                  OBS     high byte of forced disconnect time
;*                  OBS     low byte of forced disconnect time
;
;*        $DISCONNECT OFF command sequence:
;
;*                  Enable MXE control address and select terminal.
;*                  CBS     &DISCNOF
;
;*%----------------- ON or OFF? -------------------------------------------------
$DISCNCT: MOV       R0,@ON
          CALL      CCL                 ;look for ON
          TEST      R0,0FH              ;branch if found
          JZ        $DISCNON
          MOV       R0,@OFF
          CALL      CCL                 ;look for OFF
          TEST      R0,0FH              ;branch if found
          JZ        $DISCNOF
          JMP       ERROR_19            ;nf, error

;*%----------------- OFF --------------------------------------------------------
$DISCNOF: TEST      SL,XPHASE           ;branch if not execution phase
          JZ        $DISCN2
          CALL      ENBLCNT             ;enable control address and select terminal
          MOV       AL,?amDISCNOF
          CALL      CBSNT               ;disconnect off command
$DISCN2:  JMP       ENDSTIO             ;done

;*%----------------- ON ---------------------------------------------------------
$DISCNON: CALL      NXTCHEOS            ;look for end of statement character
          CMP       R0,0                ;branch if found
          JE        $DISCN4
          CALL      EXPR                ;process expression
          TEST      SL,XPHASE           ;branch if not execution phase
          JZ        $DISCN5
          CALL      FLTBINB             ;convert to binary
          MOV       DX,WORD PTR R0
          INC       DX                  ;8/9/89
          JNC       $DISCN6             ;8/9/89
          JMP       ERROR_34            ;error if value is FFFF

$DISCN4:  TEST      SL,XPHASE           ;branch if not execution phase
          JZ        $DISCN5
          MOV       WORD PTR R0,0FFFFH  ;value = FFFF

$DISCN6:  CALL      ENBLCNT             ;enable control address and select terminial
          MOV       AL,?amDISCNON
          CALL      CBSNT               ;disconnect on command
          MOV       AL,R1
          CALL      OBSNT               ;high byte of disconnect time
          MOV       AL,R0
          CALL      OBSNT               ;low byte of disconnect time
$DISCN5:  JMP       ENDSTIO             ;done

;         TITLE     INPUTSCR
;*INPUTSCR:  process an INPUT SCREEN statement.
;
;*        Format:  INPUT SCREEN alpha-variable
;
;*        Entry:   TEXTPTR points after SCREEN
;
;*        Control structures:  SCRNIN, PMODE (PMODESI)
;
;INPUTP   EQU       *
;*%----------------- look for 'SCREEN' ------------------------------------------
INPUTP:
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EDX].@spreg8,0
          MOV       EDX,OFFSET _SCREEN
          CALL      CCNL                ;look for 'SCREEN'
          TEST      R0,0FH              ;branch if found
          JZ        INPUTSCR
          MOV       EDX,OFFSET _CURSOR
          CALL      CCNL                ;look for 'CURSOR'
          TEST      R0,0FH              ;branch if found
          JZ        INPUTCUR
          JMP       INPUT               ;nf, must be INPUT
INPUTCUR:
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EDX].@spreg8,1
INPUTSCR:
;*%----------------- process alpha-variable -------------------------------------
          CALL      AVARD               ;look for alpha-variable
          TEST      R0,0FH
          JZ        M36_20
          JMP       ERROR_29            ;Missing Alpha-Variable
M36_20:
;         MOV       EDX,DWORD PTR [CPBASE]
;         CMP       BYTE PTR [EDX].@spreg8,1
;         JE        M36_77
;
;         cmp       byte ptr [textptr],','
;         jne       m36_88
;         inc       textptr
;         call      expr
;         cmp       byte ptr [textptr],','
;         jne       error_13
;         inc       textptr
;         call      expr
;         cmp       byte ptr [textptr],','
;         jne       error_13
;         inc       textptr
;         call      expr
;         cmp       byte ptr [textptr],','
;         jne       error_13
;         inc       textptr
;         call      expr
;         JMP       M36_77
;
;M36_88:  MOV       BYTE PTR [EDX].@SPREG8,2
m36_77:
          TEST      SL,XPHASE           ;branch if not execution phase
          JZ        INPUTS9

;*        In execution phase, the length and address of variable are now in Value Stack
;*%----------------- released partition logic -----------------------------------
;
          CALL      GETTERM_            ;get terminal # for this partition
          CMP       R0,0                ;branch if a terminal is assigned
          JNE       INPUTS47

;*     Check for a terminal that may have requested a partition for screen input.
;*     This is indicated by the SCRNINR bit in the SCRNIN entries.  If there is
;*     such a terminal, assign it to this partition.
;
          MOV       EDX,OFFSET SCRNIN
INPUTS40: MOV       CH,BYTE PTR [EDX]
          INC       EDX                 ;get next entry from SCRNIN table
          TEST      CH,20H              ;branch if terminal waiting for partition
          JNZ       INPUTS41            ;scrninr = 20h
          CMP       EDX,OFFSET SCRNIN+16;branch if more entries
          JNZ       INPUTS40
          JMP       INPUTS42            ;branch if none waiting

INPUTS41: DEC       EDX                 ;Point back to SCRNIN entry for waiting terminal
          MOV       AL,CH
          AND       AL,0FFH-SCRNINR     ;Clear remote screen dump request
          MOV       BYTE PTR [EDX],AL
          MOV       R0,DL
          AND       R0,03H
          CMP       EDX,OFFSET SCRNIN+4 ;F0 = terminal address
          JB        M36_22
          OR        R0,40H
M36_21:
          CMP       EDX,OFFSET SCRNIN+8
          JB        M36_22
          OR        R0,80H
M36_21A:
          CMP       EDX,OFFSET SCRNIN+12
          JB        M36_22
          OR        R0,0C0H
M36_22:
          MOV       EDX,0
          MOV       DL,PART_            ;get partition number
          ADD       EDX,OFFSET PTERM    ;point at PTERM entry for this partition
          MOV       AL,R0               ;assign terminal to this partition
          OR        AL,PTERMD
          MOV       BYTE PTR [EDX],AL
          JMP       INPUTS44

;*        Make partition available for terminal operator invoked screen dumps
;*        by setting the PMODE bit PMODESI.  This bit is cleared when a terminal
;*        is attached for screen input and by CLEAR, RESET, and LOAD RUN.
;
INPUTS42: MOV       EDX,0
          MOV       DL,PART_            ;get partition number
          ADD       EDX,OFFSET PMODE    ;point at PMODE entry for this partition
          OR        BYTE PTR [EDX],PMODESI ;turn on PMODESI (available for screen input)

;*        Breakpoint until a request for screen input is received.  The request
;*        is received in MXDSTAT during breakpoint processing.  A partition waiting
;*        for screen input will then be woken up by setting the PSTATICT bit
;*        and the terminal will be assigned to this partition.
;
          CALL      BREAKPTW            ;wait for screen input request
;
;*        Partition is no longer available for screen input requests.
;
          AND       BYTE PTR [EDX],0FFH-PMODESI  ;turn off PMODESI

;
;*        Enable the MXD control address and select terminal without checking
;*        for attachment (since terminal is now assigned but not attached).
;
INPUTS44: CALL      ENBLCNTA            ;enable control address and select terminal
          JMP       INPUTS11

;*%----------------- assigned partition logic -----------------------------------
;*        Enable the MXD control address.  If the partition is in background
;*        (ie, terminal not attached), the partition will wait until the terminal
;*        is available.
;
INPUTS47: CALL      ENBLCNT             ;enable control address
          JMP       INPUTS11

;*%----------------- check for screen input in progress -------------------------
;*     If a screen input is already in progress for this terminal, wait until
;*     it's done before proceding.  This is possible since the forground partition
;*     and the background partition assigned for screen input can both initiate
;*     screen input (yuck!).  The following simple logic loops breakpointing and
;*     rechecking the in progress condition until prior screen input completes.
;*     This is felt to be sufficient since concurrent screen inputs are highly
;*     unlikely.  One could use a structure similar to $OPEN and $CLOSE to
;*     elimite the loop if warranted.
INPUTS10: CALL      BREAKPTP            ;program priority breakpoint
INPUTS11: CALL      GETTERM_            ;get terminal #
          MOV       EDX,0
          MOV       DL,R0
          ADD       EDX,OFFSET SCRNIN-1
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX00,EDX           ;get screen input status for this terminal
          TEST      CH,SCRNINP          ;branch if input  in progress
          JNZ       INPUTS10            ;scrninp = 10h

;*%----------------- initiate screen input --------------------------------------
;*        Send the initiate screen input command to the MXE.  &SCRNIN is used for
;*        program generated screen input; &SCRNINR is used for keyboard requested
;*        screen input.  The system distinguishes these cases by checking for
;*        terminal attachment; program requests are from foreground partitions and
;*        keyboard requests are from background partitions.
;*
;*        This logic times out waiting for a
;*        response from the controller since the MXD will NOT respond.  If the
;*        controller or terminal cannot do a screen input, an error is reported.

          MOV       EDX,DWORD PTR [CPBASE]
          CMP       BYTE PTR [EDX].@spreg8,1
          jne       m36_xx
          mov       al,29h
          CALL      CBSNT               ;screen input command
          NOP
          NOP
          MOV       AL,2
          CALL      OBSNT               ;Type of cursor position get
          jmp       m36_yy
m36_xx:
          MOV       EDX,0
          MOV       DL,PART_
          ADD       EDX,OFFSET PTERM
          MOV       K,2BH               ;requested screen input ?amSCRNINR = 2BH
          TEST      BYTE PTR [EDX],20H  ;PTERMD = 20H
          JNZ       M36_23              ;branch if background partition
          MOV       K,29H               ;non-requested screen input ?amSCRNIN=29H
M36_23:
          MOV       BX,0000H
          MOV       CX,184FH

;         MOV       EAX,DWORD PTR [CPBASE]
;         CMP       BYTE PTR [EAX].@SPREG8,2
;         JE        M36_99

;         call      fltbina
;         mov       cl,r0
;         push      cx
;         call      fltbina
;         pop       cx
;         mov       ch,r0
;         push      cx
;         call      fltbina
;         mov       bl,r0
;         push      bx
;         call      fltbina
;         pop       bx
;         mov       bh,r0
;         pop       cx
;
;         cmp       bh,18h
;         ja        error_34
;         cmp       ch,4fh
;         ja        error_34
;
;         cmp       bl,18h
;         ja        error_34
;
;         cmp       ch,bh
;         jb        error_34
;
;         cmp       cl,4fh
;         ja        error_34
;
;         cmp       cl,bl
;         jb        error_34

M36_99:
          MOV       AL,K
          CALL      CBSNT               ;screen input command
          NOP
          NOP
          MOV       AL,01H
          CALL      OBSNT               ;Type of remote screen dump
          NOP
          NOP
          MOV       AL,BH
          CALL      OBSNT               ;starting row of screen dump
          NOP
          NOP
          MOV       AL,BL
          CALL      OBSNT               ;starting column of screen dump
          NOP
          NOP
          MOV       AL,CH
          CALL      OBSNT               ;ending row of screen dump
          NOP
          NOP
          MOV       AL,CL
          CALL      OBSNT               ;ending column of screen dump
m36_yy:
          CALL      WAITIBS             ;wait up to 15ms. for response from controller
          TEST      BYTE PTR FS:[CPUST],2  ;branch if no response
          JZ        INPUTS2
          INC       EDX
          CMP       K,0                 ;branch if terminal supports screen input
          JNE       INPUTS3
INPUTS2: ;OR        SH,CPB              ;no need to set CPB
          JMP       ERROR_08            ;Statement Not Legal Here

;*%----------------- enable screen suck address ---------------------------------
INPUTS3:  MOV       EDX,ACTDEV          ;Bits 00C0 give MXE base address
          AND       DL,0F0H             ;MXE base adr
          OR        DL,@MXDDADR         ;PHPL = screen suck data input address
          CALL      ENBLDEVA

;*%----------------- set screen input in progress -------------------------------
;*     Set the screen input in progress information in the SCRNIN table entry.
;
;*        (The input screen request bit, SCRNINR, must be preserved.)
;
;         LPI,R     PART#     get part#
;         TAP       ,0        point at SCRNIN entry
;         MV,R      CH,F0     get SCRNIN entry
;         SHHL      F0,CH,F0
;         ORI,W1    SCRNINP,F0,         in progress by this partition

          MOV       CH,PART_            ;get part#
          MOV       EDX,AUX00           ;point at SCRNIN entry
          MOV       R0,CH               ;get SCRNIN entry
          MOV       CH,BYTE PTR [EDX]
          MOV       AL,CH
          AND       AL,0F0H
          AND       R0,0FH
          OR        R0,AL
          OR        R0,SCRNINP          ;in progress by this partition
          MOV       AL,R0
          MOV       BYTE PTR [EDX],AL
;
;*        Get the receiver variable parameters.
;
;         call      popv4
          MOV       EDX,VSPTR
          MOV       AX,WORD PTR [EDX]
          MOV       WORD PTR [R0],AX
          MOV       ECX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          MOV       EDX,ECX
          MOV       EAX,0
          MOV       AX,WORD PTR R0
          MOV       DWORD PTR A0,EDX
          ADD       DWORD PTR A0,EAX    ;end+1 address of variable
          MOV       AUX00,EDX           ;beginning address of variable

;*        Check if character is ready for input.  If not ready within 1ms., the
;*        partition breakpoints until one is ready.  The partition is woken up
;*        by setting PSTATICT by MXDSTAT when the MXE indicates that there is
;*        a screen input character available.
;
INPUTS5:  TEST      BYTE PTR FS:[CPUST],08   ;branch if ready
          JNZ       INPUTS4
          CALL      WAITRDY                  ;wait up to 1ms. for ready
          TEST      BYTE PTR FS:[CPUST],08   ;branch if ready
          JNZ       INPUTS4

          CALL      BREAKPTW                 ;breakpoint until character available
          JMP       INPUTS5

;
;*        Get next character of screen data.  This should be sent by MXE immediately.
;*        An error will result if character not received within 15ms.
;
INPUTS4:  MOV       AX,WORD PTR FS:[CPUST]  ;Turn off ENDI
          CALL      WAITIBS                 ;wait up to 15ms. for character
          TEST      BYTE PTR FS:[CPUST],CPB ;branch if character rec'd
          JNZ       INPUTS45

         ;OR        SH,CPB              ;don't allow input
          CALL      SCRNINPO            ;turn off screen input in progress
          CALL      ENBLCNTA            ;enable control address
          MOV       AL,2AH              ;?amSCRNINT = 2AH
          CALL      CBSNT               ;abort screen input
          JMP       ERROR92             ;timeout error

INPUTS45: TEST      BYTE PTR FS:[CPUST],4   ;branch if end of screen input
          JNZ       INPUTS6
;
;*        Store character in alpha-variable.  If full, ignore the character.
;
          MOV       EDX,AUX00
          CMP       DWORD PTR A0,EDX    ;branch if variable full
          JE        INPUTS5
          MOV       AL,K                ;put character into variable
          MOV       BYTE PTR [EDX],AL
          MOV       AUX00,EDX
          INC       AUX00
          JMP       INPUTS5

;
;*        End of screen data.
;
INPUTS6:  MOV       AX,WORD PTR FS:[CPUST]  ;turn off ENDI

;
;*     Pad variable with trailing blanks.
;
          MOV       EDX,AUX00
INPUTS7:  CMP       DWORD PTR A0,EDX
          JE        INPUTS90            ;branch if end of variable
          MOV       BYTE PTR [EDX],20H  ;put space into variable
          INC       EDX
          JMP       INPUTS7
INPUTS90: CALL      SCRNINPO            ;turn off screen input in progress
INPUTS9:  JMP       ENDSTIO             ;end of statement

;         TITLE     SCRNINPO
;*  SCRNINPO:  turn off 'screen input in progress'
;
;*        Set the SCRNINP bit in the SCRNIN entry for this terminal to 0.
;
;*        Modified registers: PC's,CHCL,F0
;
SCRNINPO: CALL      GETTERM_            ;get terminal number
          CMP       R0,0                ;branch if no terminal
          JZ        SCRNINP1
          MOV       EDX,0
          MOV       DL,R0
          ADD       EDX,OFFSET SCRNIN-1
          AND       BYTE PTR [EDX],0E0H ;SCRNINP= 10H turn off SCRNINP
SCRNINP1: RET


;* MOVETABL          LOADS PRINTER DRIVER TABLES FROM DISK TO CONTROL MEMORY
;*
;* ENTRY:    I/0 BUFFER CONTAINS INDEX SECTOR WITH ENTRY OF "FILENAME"
;*           AUX C = ADDRESS OF "FILENAME" ENTRY IN I/O BUFFER
;*           AUX E, LOW BYTE = PLATTER ADDRESS
;*           AUX 7 = ADDRESS OF NEXT AVAILIBLE WORD OF CONTROL MEMORY (BYTE ORINTED)
;*
;* RETURN:   AUX D = ADDRESS OF NEXT AVAILIBLE WORD OF CONTROL MEMORY (BYTE ORINTED)
;*           F5F4 = DISPLACEMENT TO START OF ESC. TRANS. TABLE FROM ADDRESS IN AUX 7 (CONTROL MEMORY WORD)
;*
;* MODIFIES REGISTERS: AUX C-F, AUX 0, F0 - F7, K, CHCL, PHPL, SH
;*
MOVETABL: PUSH      AUX0B               ;SAVE AUX B
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          MOV       AUX0F,EDX           ;AUX F POINTS TO I/O BUFFER
          OR        SL,10H              ;SET STATUS TO FIRST SECTOR THIS MAP

          MOV       EDX,AUX0C           ;RECALL ADDRESS OF INDEX ENTRY
          ADD       EDX,2               ;PC'S POINT TO STARTING SECTOR ADDRESS
          MOV       CX,[EDX]
          XCHG      CH,CL
          ADD       EDX,2               ;READ STARTING SECTOR ADDRESS
          MOV       WORD PTR R0,CX      ;F1F0 = STARTING SECTOR ADDRESS

          XCHG      EDX,AUX07           ;PUT ADDRESS OF NEXT AVAILIBLE WORD OF CONTROL MEMORY IN AUXE
          MOV       AUX0D,EDX           ;AUX0D= NEXT AVAIL WORD OF CONTROL MEMORY
          PUSH      EDX
          MOV       DX,WORD PTR R0
          MOV       AUX07,EDX           ;AUX07 = SECTOR ADDRESS

MOVETAB1: CALL      DREAD               ;READ SECTOR
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          MOV       CH,BYTE PTR [EDX]   ;READ SECTOR TYPE
          CMP       CH,6AH              ;BRANCH IF NOT PRINTER DRIVER...
          JNE       ERROR_88
M36_26:
          MOV       AUX0C,EDX           ;STORE ADDRESS WITHIN I/O BUFFER IN AUXC
          ADD       AUX0C,2

          TEST      SL,10H              ;BRANCH IF NOT FIRST SECTOR
          JZ        MOVETABM
          MOV       EDX,AUX0C           ;POINT PC'S TO LENGTH OF CHAR. TRANS. TABLE
          MOV       CX,[EDX]            ;READ IT
          XCHG      CH,CL
          ADD       AUX0C,2
          MOV       WORD PTR R4,CX      ;F5F4 = LENGTH OF CHAR. TRANS. TABLE

          MOV       EDX,AUX0C           ;READ LENGTH OF ESC. TRANS. TABLE
          MOV       CX,[EDX]
          XCHG      CH,CL
          ADD       AUX0C,2
          MOV       WORD PTR R6,CX      ;F7F6 = LENGTH OF ESC. TRANS. TABLE

          MOV       AX,WORD PTR R4
          ADD       WORD PTR R6,AX      ;F7F6 = NUMBER OF CONTROL MEMORY WORDS TO MOVE
          AND       SL,0EFH             ;TURN OFF FIRST SECTOR FLAG
          MOV       R3,52H
          JMP       GETCMEM

MOVETABM: MOV       R3,53H              ;F2 = MAX # OF CONTROL MEMORY WORDS PER SECTOR
GETCMEM:  MOV       EDX,AUX0C           ;RECALL I/O READ ADDRESS
          MOV       CH,BYTE PTR [EDX]
          INC       EDX                 ;READ K BYTE
          MOV       K,CH
          MOV       CX,[EDX]
          XCHG      CH,CL
          ADD       EDX,2               ;SAVE K AND READ PH BYTE
                                        ;SAVE PH AND READ PL BYTE
          MOV       WORD PTR R0,CX      ;SAVE PL

          MOV       AUX0C,EDX           ;SAVE I/O READ ADDRESS
          MOV       DX,WORD PTR R0      ;PC'S = PHPL BYTES
          MOV       AUX00,EDX           ;SAVE IN AUX 0
          MOV       EDX,AUX0D           ;RECALL CONTROL MEMORY WRITE ADDRESS
          ADD       AUX0D,3
;         CALL      WCM                 ;WRITE TABLE WORD
          MOV       AL,K                ;+- WCM
          MOV       [EDX+2],AL
          MOV       EAX,AUX00
          MOV       WORD PTR [EDX],AX   ;+-WCM

          DEC       WORD PTR R6         ;DECREMENT TOTAL # OF WORDS TO MOVE
          JZ        ENDTABL             ;BRANCH IF DONE

          DEC       R3                  ;DECREMENT # WORDS THIS SECTOR
          JE        MOVETAB2            ;BRANCH IF DONE THIS SECTOR

          MOV       EDX,AUX0D           ;RECALL CURRENT LOCATION IN CONTROL MEM.
          CMP       EDX,OFFSET TABLSTRT + 3*2048 ;BRANCH IF OUT OF CONTROL MEM.
          JAE        ERROR_03           ;BRANCH IF OUT OF CONTROL MEM.

          JMP       GETCMEM             ;DO NEXT WORD
          MOV       EDX,AUX07
          INC       EDX
          MOV       AUX07,EDX

MOVETAB2:;TEST      SH,40H              ;BRANCH IF PARITY STILL GOOD
         ;JZ        BRPARGD
         ;JMP       VERCERR             ;GET HELP!!!!!!!!!!!

BRPARGD:
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR
          XCHG      EDX,AUX0F
          JMP       MOVETAB1

MOVETAB3: XCHG      EDX,AUX07           ;DECREMENT SECTOR NUMBER
          DEC       EDX
          XCHG      EDX,AUX07
          JMP       MOVETAB1            ;AND RETRY IT

ENDTABL:  POP       AUX07
          POP       AUX0B               ;RESTORE AUX B
          RET                           ;RETURN

ERROR_78: MOV       R0,78H              ;SEND BACK AND X78 ERROR MESSAGE
          JMP       ERROR               ;INDICATING PRINTER DRIVER TABLE FAULT

;******************************************************************************
;* GETTABL#       GET THE NUMBER OF THE TABLE TO BE LOADED BY FINDING THE LOCATION
;*                OF THE TABLES FILENAME IN THE LIST OF TABLE NAMES.  RETURN THE TABLE
;*                TABLE NUMBER IF FOUND,  RETURN THE TABLE NUMBER AND INSERT THE NAME INTO THE
;*                LIST IF NOT FOUND.  IF LIST FULL AND NAME NOT FOUND, AND ERROR RESULTS
;*
;* ENTRY       TABLE NAME IN FIRST 8 LOCATIONS OF THE WORKSPACE
;*
;* RETURN      AUX 8, LOW HALF = TABLE NUMBER
;*             AUX 8, HIGH HALF = HEX (F0) IF NAME WAS INSERTED INTO LIST
;*
;* REGISTERS MODIFIED  F0 - F7, PHPL, CHCL, K, AUX 0 - AUX 3, AUX 8
;*
;GETTABL# MVI       00,F6
;         MVI       04,F7
;         XORX      F4F3,F4F3,F4F3
;
GETTABL_: MOV       R6,0                        ;8 BYTE FOR NAME
          MOV       WORD PTR R3,0

GETTABL1: MOV       EDX,OFFSET TABLNAME ;POINT TO NAME LIST
          MOV       EAX,0
          MOV       AL,R6
          SHL       EAX,3
          ADD       EDX,EAX
          MOV       AUX01,EDX           ;SAVE ADDRESS OF NAME(N)
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@WORKSPC  ;point to work space
          MOV       AUX02,EDX           ;SAVE ADDRESS OF WORK SPACE

GETTABL2: MOV       EDX,AUX01
          ADD       AUX01,2
          MOV       CX,[EDX]            ;READ 2 CHARACTERS OF NAME(N)
          MOV       AUX03,ECX           ;SAVE THEM IN AUX 3

          MOV       EDX,AUX02           ;READ 2 CHARACTERS FROM FILENAME
          MOV       CX,[EDX]
          ADD       EDX,2               ;IN WORKSPACE
          MOV       WORD PTR R0,CX      ;F1F0 = THE 2 CHARACTERS
          MOV       AUX02,EDX   ;SAVE ADDRESS OF NEXT CHARACTER

          ADD       R4,2                ;INCREMENT # OF CHARACTERS CHECKED
          MOV       EDX,AUX03           ;RECALL THE 2 CHARACTERS READ FROM THE LIST
          CMP       DX,WORD PTR R0      ;BRANCH IF CHARACTERS DONT MATCH
          JNE       GETTABL3
          CMP       R4,08H              ;BRANCH IF STILL CHECKING SAME NAME
          JNE       GETTABL2

          INC       R6
          MOV       DL,R6
          MOV       DH,00               ;PHPL = 00 AND TABLE NUMBER
          MOV       AUX08,EDX           ;NAME FOUND, RETURN TABLE NUMBER
          RET

GETTABL3:
          MOV       R4,00               ;CHECK TO SEE IF LIST ENTRY IS BLANK
          MOV       R5,20H              ;F5 = CODE FOR A SPACE
          MOV       EDX,OFFSET TABLNAME
          MOV       EAX,0
          MOV       AL,R6
          SHL       EAX,3
          ADD       EDX,EAX             ;PHPL = ADDRESS OF ENTRY

GETTABL4: MOV       AUX01,EDX           ;SAVE ADDRESS
          ADD       AUX01,2
          MOV       CX,[EDX]            ;READ 2 CHARACTERS
          ADD       R4,2                ;INCREMENT # CHECKED
          CMP       CH,R5               ;BRANCH IF CHARACTER NOT A BLANK
          JNE       GETTABL5
          CMP       CL,R5               ;BRANCH IF CHARACTER NOT A BLANK
          JNE       GETTABL5
          CMP       R4,08H              ;BRANCH IF ALL CHARACTERS CHECKED
          JZ        M36_30
          MOV       EDX,AUX01           ;RECALL ADDRESS WITHIN ENTRY
          JMP       GETTABL4            ;CHECK NEXT 2 CHARACTERS
M36_30:
          MOV       EDX,OFFSET TABLNAME ;POINT TO NAME LIST
          MOV       EAX,0
          MOV       AL,R6
          SHL       EAX,3
          ADD       EDX,EAX             ;PHPL = ADDRESS OF LIST ENTRY FOR THIS NAME
          MOV       AUX01,EDX           ;SAVE ADDRESS
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@WORKSPC  ;point to work space
          MOV       AUX02,EDX           ;SAVE POINTER
          MOV       R3,0

GETTABL6: MOV       CX,[EDX]
          ADD       AUX02,2             ;READ 2 CHARACTERS OF NAME
          MOV       EDX,AUX01           ;RECALL WRITE ADDRESS
          MOV       [EDX],CX            ;WRITE THE CHARACTERS
          ADD       R3,2                ;INCREMENT NUMBER OF CHARACTERS MOVED
          ADD       AUX01,2             ;INCREMENT WRITE ADDRESS
          MOV       EDX,AUX02
          TEST      R3,08H              ;BRANCH IF NOT DONE
          JZ        GETTABL6

          INC       R6
          MOV       DL,R6
          MOV       DH,0F0H             ;PHPL = TABLE NUMBER AND "WAS ADDED" FLAG
          MOV       AUX08,EDX           ;SAVE IN AUX 8
          RET

GETTABL5: INC       R6                  ;INCREMENT TABLE NUMBER
          TEST      R6,08H              ;BRANCH IF AT END OF TABLE
          JZ        GETTABL1            ;CHECK NEXT ENTRY
          JMP       ERROR_78

;*******************************************************************************
;* IDRVRDEV       SEARCH DRIVER DEVICE TABLE FOR AN OPENING.  PL HOLDS ADDRESS
;*                 THAT YOU WILL BE TRYING TO ADD. ERRORS; 1) ADDRESS ALREADY IN
;*                 TABLE, AND 2) TABLE FULL.
;*
;*  ENTRY: PL HOLDS ADDRESS THAT WILL BE ADDED, F0 = TERMINAL NUMBER
;*
;* RETURN: PC'S = ADDRESS OF OPEN ENTRY
;*
;* REGISTERS MODIFIED: F3, F7, F2, PHPL, AUX B
;*
IDRVRDEV: MOV       R7,DH               ;F7 = ADDRESS
          MOV       EDX,OFFSET DRVRDEV

IDRVRDV1:
          MOV       AUX0B,EDX           ;INCREMENT AND SAVE ADDRESS
          ADD       AUX0B,6
;         CALL      RCM                 ;READ ENTRY
          MOV       AL,[EDX+2]          ;+- RCM
          MOV       K,AL
          MOV       AX,WORD PTR [EDX]
          CMP       R7,AH               ;BRANCH IF FOUND
          JE        TABLERR
          CMP       EDX,OFFSET DRVRDEV+90  ;BRANCH IF BEYOND LIST
          JAE       ERR_78
          CMP       AX,0                ;BRANCH IF BLANK
          JE        FDRVRDEV

IDRVR1:   MOV       EDX,AUX0B           ;RECALL ADDRESS
          JMP       IDRVRDV1

FDRVRDEV: SUB       AUX0B,6             ;RECALL ADDRESS
                                        ;STORE REAL ADDRESS
          MOV       EDX,AUX0B           ;RECALL IT
          RET                           ;WAVE BYE-BYE

TABLERR:  CMP       R7,04               ;BRANCH IF NOT A TERMINAL PRINTER
          JNE       ERR_78
          AND       K,0FH               ;K = TERMINAL NUMBER THIS ENTRY
          CMP       K,0F0H              ;BRANCH IF TERMINAL ALREADY IN TABLE
          JE        ERR_78
          JMP       IDRVR1              ;CHECK NEXT ENTRY
ERR_78:   JMP       ERROR_78            ;WRONG SUCKER, YOUR DEAD.

;*********************************************************************************
;* PARTINIT            INITIALIZES PARTITION STATUS TABLE
;*
;* ENTRY: NONE, I DON'T NEED THE OUTSIDE WORLD
;* RETURN: NOTHING, WHY SHOULD I SHARE?
;* MODIFIED REGISTERS: SOME
;*
;         THE GOLDEN TURKEY - (NOBODY SHOULD CODE AFTER 9PM)

PARTINIT:
          MOV       ECX,14              ;SET UP AND SAVE STATUS WORD 1 ,2 ,3
          MOV       EDX,OFFSET DRVRSTAT
PRTINITA:
          MOV       DWORD PTR [EDX],00420020H
          MOV       DWORD PTR [EDX+4],42000000H
          MOV       BYTE PTR [EDX+8],26H
          ADD       EDX,9
          LOOP      PRTINITA
          RET

code      ends
          end
