;===========================================================================
;
;
;           G   I   O
;
;
;===========================================================================
;           This module was originally M26
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    $IF
PUBLIC    $STMT
PUBLIC    ATOMERR
PUBLIC    COMMAND
extrn     delay1ms  :near       ;Anita for 33M cpu
PUBLIC    DELAY10T
PUBLIC    GIO
PUBLIC    GIOC12
PUBLIC    GIOC1B
PUBLIC    GIOC40
PUBLIC    GIOC80
PUBLIC    GIOCC0
PUBLIC    GIOCS20
PUBLIC    REGLOAD
PUBLIC    REGLOADB
PUBLIC    REGLOADC
PUBLIC    REGSAVE
PUBLIC    STATUS
PUBLIC    STATCNT
PUBLIC    STROBE
PUBLIC    STROBEK
PUBLIC    TIMEOUT
PUBLIC    TRAN
PUBLIC    WAITINK
PUBLIC    WAITIND
;----- TSAI -----
PUBLIC    GIO456
public    bbb
public    gend
public    gioc70
public    gioc80
public    gioc90
public    gioca0
public    giocb0
public    giocc0
;----- TSAII ----

EXTRN     $ALERT    :NEAR
EXTRN     $BREAK    :NEAR
EXTRN     $CLOSE    :NEAR
EXTRN     $COPY     :NEAR
EXTRN     $SCREEN   :NEAR
EXTRN     $MOVE     :NEAR
EXTRN     $ROTATE   :NEAR
EXTRN     $CLEAR    :NEAR
EXTRN     $SCSI     :NEAR
EXTRN     $DISCNCT  :NEAR
EXTRN     $INIT     :NEAR
EXTRN     $MSG      :NEAR
EXTRN     $OPEN     :NEAR
EXTRN     $PACK     :NEAR
EXTRN     $PSTAT    :NEAR
EXTRN     $UNPACK   :NEAR
EXTRN     ALPHIN    :NEAR
EXTRN     ALPHINL   :NEAR
EXTRN     BADDRESS  :NEAR
EXTRN     BREAKPTD  :NEAR
EXTRN     BREAKPTG  :NEAR
EXTRN     CBSNR     :NEAR
EXTRN     CBSNT     :NEAR
EXTRN     CBSTROBE  :NEAR
EXTRN     CCJB      :NEAR
EXTRN     CCL       :NEAR
EXTRN     CHKDVRB   :NEAR
EXTRN     DELAY5    :NEAR
EXTRN     DELAY10   :NEAR
EXTRN     DEVICEG   :NEAR
EXTRN     DEVSPECT  :NEAR
EXTRN     ENBLCNT   :NEAR
EXTRN     ENBLDEVG  :NEAR
EXTRN     ENBLNULL  :NEAR
EXTRN     ENDDISK   :NEAR
EXTRN     FREEDISK  :NEAR
EXTRN     ENDSTMTZ  :NEAR
EXTRN     ERROR     :NEAR
EXTRN     ERROR92   :NEAR
EXTRN     ERROR_10  :NEAR
EXTRN     ERROR_11  :NEAR
EXTRN     ERROR_13  :NEAR
EXTRN     ERROR_19  :NEAR
EXTRN     ERROR_29  :NEAR
EXTRN     ERROR_48  :NEAR
EXTRN     FORMAT    :NEAR
EXTRN     GOTO      :NEAR
EXTRN     HEXPAIR   :NEAR
EXTRN     LETRDIGT  :NEAR
EXTRN     NXTCHEOS  :NEAR
EXTRN     OBSTROBE  :NEAR
EXTRN     PTERM     :NEAR
EXTRN     REMCO     :NEAR
EXTRN     REMNULL   :NEAR
EXTRN     RLSTERM   :NEAR
EXTRN     SCANCHA   :NEAR
EXTRN     SRCHDEVA  :NEAR
EXTRN     WAITIBSE  :NEAR
EXTRN     WAITIBSF  :NEAR
EXTRN     WAITRDYB  :NEAR
EXTRN     _$LST     :NEAR

EXTRN     CPBASE    :DWORD
EXTRN     PART_     :BYTE
;------ TSAI -------
EXTRN     CMDBUADR  :DWORD
EXTRN     TOMXF     :BYTE
EXTRN     DRVRMAIN  :NEAR
EXTRN     BREAKPTT  :NEAR
EXTRN     BREAKPTC  :NEAR
EXTRN     WAITCMD   :NEAR
EXTRN     MXFGIOTBL :NEAR
;------- TSAII -----

;+$$$$
extrn     print_addr:near
extrn     part_addr :near
extrn     disk_addr :near
extrn     command_addr:near
extrn     breakpta  :near
;-$$$$
;------------------------------------------------------------------------------;
;                                                                              ;
;         MODULE    MOD-26 $GIO                                                ;
;                                                                              ;
;------------------------------------------------------------------------------;


; $STMT:  BEGIN SCANNING OF A $ STATEMENT AFTER THE
;   SYMBOL $.
;
; ENTRY PHASE:  MODIFIES ALL REGS, AUX 0,1,2
;
; RESOLUTION PHASE:  MODIFIES ALL REGS, AUX 0,1,2
;
; EXECUTION PHASE:  ALL, 0-? (NOT MORE THAN F)


$STMT:    MOV       EDX,OFFSET _$LST  ;POINT AT $ ATOM LIST
          CALL      CCJB              ;SEARCH FOR ATOMS
          JMP       $IF
          JMP       GIO
          JMP       TRAN
          JMP       $PACK
          JMP       $UNPACK
          JMP       FORMAT
          JMP       $BREAK
          JMP       $OPEN
          JMP       $CLOSE
          JMP       RLSTERM
          JMP       $PSTAT
          JMP       $MSG
          JMP       $INIT
          JMP       $ALERT
          JMP       $DISCNCT
          JMP       $COPY
          JMP       $SCREEN
          JMP       $MOVE
          JMP       $ROTATE
          JMP       $CLEAR
          JMP       $SCSI

$STMT_19: JMP       ERROR_19          ;ERROR -- ILLEGAL VERB
$IF:      MOV       R0,@ON
          CALL      CCL
          MOV       DL,0
          TEST      R0,0FH
          JZ        $IFX
          MOV       DL,8              ;PL= 00 IF '$IF ON', 08 IF '$IF OFF'
$IFX:     TEST      SL,2
          JZ        $IFY
          MOV       AUX0F,EDX         ;SAVE ON/OFF FLAG IF X-PHASE
$IFY:     TEST      R0,0FH
          JZ        $IF3
          MOV       R0,@OFF
          CALL      CCL
          TEST      R0,0FH            ;ERROR IF NOT $IF ON NOR $IF OFF
          JNZ       $STMT_19

;  COMMENTS:
;   1.  /001, /004, /005  BUSY IF TERMINAL NOT ATTACHED
;   2.  IF  $OPEN, $CLOSE USED FOR TERMINAL PRINTER,
;       THEN $IFON SHOULD REFLECT THAT, NOT TERMINAL ATTACHED.

$IF3:     CALL      DEVSPECT          ;GET DEVICE ADDRESS (DEFAULT=TAPE); MXD OK
          TEST      SL,2              ;SKIP IF NOT X PHASE
          JZ        $IF5
          MOV       EDX,AUX0F
          MOV       R7,DL             ;F7 = ON/OFF FLAG
          MOV       AL,K
          MOV       R0,AL             ;F0 = DEVICE ADDRESS
          CALL      BADDRESS          ;ILLEGAL ADDRESSES: 41-47,81-87,C1-C7,02,03,06,07
          TEST      K,0F0H            ;BRANCH IF NOT ADDRESS '0X'
          JNZ       $IF6
          TEST      K,8               ;BRANCH IF '08' (NONMXD)
          JNZ       $IF6
          TEST      K,0FH             ;BRANCH IF '00'
          JZ        $IF10
          MOVZX     EAX,BYTE PTR [PART_]
          MOV       EDX,OFFSET PTERM
          ADD       EDX,EAX
          MOV       K,0
          MOV       CH,BYTE PTR [EDX];GET CURRENT PTERM ENTRY
          TEST      CH,PTERMD        ;BRANCH IF TERMINAL NOT ATTACHED (BUSY)
          JNZ       $IF9             ;PTERMD = 20H
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,1             ;BRANCH IF /004 OR /005 (READY)
          JNE       $IF10

; DEVICE 01 (MXD KEYBOARD)
;

;-------- TSAI -----
$IF7:
          CMP       CMDBUADR,0
          JZ        $IF77               ;BR,if MXD
;--------- TSAI,04-09-91 -------------
;         CALL      WAITCMD
;         MOV       GS:[EBX].cmd_cbs,04
;         MOV       GS:[EBX].cmd_abs,06
;         MOV       GS:[EBX].cmd_sts,0FH ;start command
;         CALL      WAITCMD
;         MOV       AL,00H
;         CMP       GS:[EBX].cmd_sts,0F0H   ;if anything in KB buffer
;         JNE       $IFZ1                   ;nothing in KB buffer
;         MOV       AL,BYTE PTR GS:[EBX].cmd_parm  ;get the char
;         MOV       AL,0FFH
;         JMP       $IFZ1
;--------- TSAII,04-09-91 -------------

          MOV       EBX,CMDBUADR        ;dword offset
          MOV       AL,GS:[EBX].sts_byte;get stataus of this port
          TEST      AL,01H
          MOV       AL,0
          JZ        $IFZ1               ;BR,if KB buf empty,and return 00
;         MOV       AL,GS:[EBX].key_buf ;KB buf not empty,retun the key
          MOV       AL,0FFH
          JMP       $IFZ1               ;value in key buf
$IF77:
;-------- TSAII ----------
;$IF7:
          CALL      ENBLCNT                  ;ENABLE MXD CONTROL ADDRESS
          MOV       AL,?amIFONKBD
          CALL      CBSNT                    ;IF ON COMMAND ==> MXD
          MOV       BYTE PTR FS:[CPURDY],AL  ;ALLOW INPUT
$IFZ:     TEST      BYTE PTR FS:[CPUST],02   ;CPU STATUS
          JZ        $IFZ                     ;WAIT FOR RESPONSE FROM MXD
          MOV       AL,BYTE PTR FS:[IBGET]
$IFZ1:              ;---TSAI
          MOV       K,AL
          INC       EDX
          CMP       K,0
          JE        $IF9

; NON-MXD DEVICE
;

$IF10:    MOV       K,8         ;DEVICE = READY
$IF9:     MOV       AL,K
          XOR       R7,AL
          JMP       $IF8

$IF6:     CMP       K,40H       ;IS DEVICE 340? - NO JUMP
          JE        $IF10       ;YES - DEVICE READY

; CHECK READY/BUSY
;

$IF11:    CALL      CHKDVRB     ;GET DEVICE READY/BUSY
          MOV       AL,R0
          XOR       R7,AL
$IF8:     TEST      R7,8        ;SKIP IF DEVICE READY MATCHES
          JZ        REMNULL     ;ENABLE NULL, SLIDE OVER LINE NUMBER

$IF4:     CALL      ENBLNULL    ;ENABLE NULL DEVICE
$IF5:     JMP       GOTO        ;GOTO SPECIFIED LINE NUMBER (IF X PHASE)


; TRAN:  EXECUTE A TRANSLATE INSTRUCTION.
;
;  GENERAL FORM:
;      **************************************************
;      *  [$]TRAN( alph1, alph2 ) [xx] [R]
;      *
;      **************************************************
;
;       where:  alph1 is the buffer to be translated
;               alph2 is the table or list
;               xx is the optional mask
;               R says to use list rather than table.
;
;   DIFFERENCES FROM 2200:
;  1. alph2 may be a literal
;  2.  If R is used (replace form), alph2
;     no longer needs to terminate in two blanks.  The
;     length is used also, to terminate the search for
;     each character code.
;
;   REGISTER USAGE:  F7 is used for a flag to indicate
;      the presence of the R parameter.  F6 is the mask
;      represented by the two hex digits(default = FF).
;      AUX 0 contains the address of the buffer(arg1),
;      and F3F2 points at the end+1.  AUX B contains the
;      address of the table/list(arg2), and AUX C
;      contains the length.

TRAN:     CMP       BYTE PTR [TEXTPTR],'('  ;GET LEFT PARENTHESIS
          JNE       ERROR_10
          INC       TEXTPTR
          CALL      ALPHIN                  ;GET ALPHA BUFFER
          TEST      R0,0FH                  ;NF, ERROR
          JNZ       GIO_29
          CMP       BYTE PTR [TEXTPTR],','  ;GET A COMMMA
          JNE       ERROR_13
          INC       TEXTPTR
          CALL      ALPHINL                 ;GET TRANSLATE TABLE/LIST
          TEST      R0,0FH                  ;NF, ERROR
          JNZ       GIO_29
          CMP       BYTE PTR [TEXTPTR],')'  ;GET RIGHT PARENTHESIS
          JNE       ERROR_11
          INC       TEXTPTR
          MOV       R7,0                    ;FLAG = 00
          MOV       R6,0FFH                 ;DEFAULT MASK = FF
          CMP       BYTE PTR [TEXTPTR],'R'  ;CHECK FOR AN 'R'
          JNE       TRAN_X                  ;BR, IF NOT AN 'R'
          INC       TEXTPTR
          JMP       TRAN06
TRAN_X:   CALL      NXTCHEOS                ;CHECK FOR CR/COLON
          CMP       R0,0                    ;SKIP IF END OF STATEMENT
          JE        TRAN10
          CALL      HEXPAIR                 ;GET PAIR OF HEX DIGITS (MASK)
          MOV       AL,R0
          MOV       R6,AL                   ;SAVE MASK IN F6
          CMP       BYTE PTR [TEXTPTR],'R'  ;CHECK FOR AN 'R'
          JNE       TRAN10                  ;SKIP IF NOT
          INC       TEXTPTR

;  EXECUTION PHASE - PROCESS THE ACTUAL TRANSLATE
;

TRAN06:   OR        R7,1                    ;FLAG THE R PARAMETER
TRAN10:   TEST      SL,2                    ;EXIT IF ENTRY/RESOLUTION PHASE
          JZ        TRAN99
          MOV       EDX,VSPTR
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       AUX0B,EDX               ;AUX B = ADDRESS OF TABLE/LIST
          MOV       DWORD PTR [A4],EDX
          ADD       DWORD PTR [A4],EAX      ;F5F4 = END+1 ADDRESS (TABLE/LIST)
          MOV       EDX,EAX
          MOV       AUX0C,EDX               ;AUX C = LENGTH OF TABLE/LIST
          MOV       EDX,VSPTR
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       AUX00,EDX               ;AUX 0 = ADDRESS OF BUFFER
          MOV       DWORD PTR [A2],EDX
          ADD       DWORD PTR [A2],EAX      ;F3F2 = END+1 OF BUFFER
          TEST      R7,1                    ;SKIP IF REPLACE FORM OF THE TRANSLATE
          JNZ       TRAN50

          MOV       EDX,AUX0B
          MOV       DWORD PTR [A0],EDX      ;F1F0 = TABLE START ADDRESS
          MOV       EDX,AUX0C               ;TABLE LENGTH
          MOV       R5,0FFH
          CMP       EDX,255                 ;SKIP IF > 255
          JA        TRAN13
          MOV       R5,DL
          DEC       R5                      ;F5 = LENGTH-1
          CMP       R7,DL
          JE        TRAN_Y

TRAN13:   OR        R7,80H                  ;F7 = FLAG FOR NON-ZERO LENGTH
TRAN_Y:   MOV       EDX,AUX00               ;PC'S POINT AT BEGIN OF BUFFER
          JMP       TRAN20

TRAN15:   INC       EDX
TRAN20:   CMP       DWORD PTR [A2],EDX
          JBE       TRAN99                  ;EXIT IF END OF BUFFER
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX00,EDX               ;READ CHARACTER TO BE TRANSLATED
          MOV       AL,R6
          AND       AL,CH
          MOV       K,AL
          MOV       BYTE PTR [EDX],AL       ;MASK IT
          TEST      R7,80H                  ;LOOP IF TABLE LENGTH = 0
          JZ        TRAN15
          MOV       AL,R5
          CMP       AL,K                    ;LOOP IF BEYOND TABLE END
          JB        TRAN15
          MOV       EDX,DWORD PTR [A0]
          MOVZX     EAX,K
          ADD       EDX,EAX
          MOV       CH,BYTE PTR [EDX]
          MOV       EDX,AUX00               ;READ RESULTANT CHARACTER FROM TABLE
          MOV       BYTE PTR [EDX],CH
          INC       EDX
          JMP       TRAN20                  ;LOOP TILL END OF BUFFER

;  REPLACE FORM OF TRANSLATE - R PARAMETER INCLUDED
;

TRAN50:   MOV       K,20H
TRAN60:   CMP       DWORD PTR [A2],EDX
          JBE       TRAN99
          MOV       CH,BYTE PTR [EDX]
          MOV       AUX00,EDX
          MOV       AL,R6
          AND       AL,CH
          MOV       R0,AL
          MOV       BYTE PTR [EDX],AL
          MOV       EDX,AUX0B

TRAN62:   CMP       DWORD PTR [A4],EDX
          JBE       TRAN65                  ;SKIP IF END OF LIST/REPLACE TABL
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          MOV       R1,CH
          MOV       CH,BYTE PTR [EDX]
          INC       EDX                     ;CH= OLD, F1=NEW;  NEXT PAIR FROM LIST
          CMP       CH,R0                   ;JUMP IF EQUAL TO BASE CHARACTER
          JE        TRAN68

TRAN63:   CMP       R1,CH
          JNE       TRAN62
          CMP       CH,K                    ;LOOP IF NOT BOTH BLANK
          JNE       TRAN62
TRAN65:   MOV       AL,R0                   ;CHARACTER REMAINS UNCHANGED
          MOV       R1,AL
TRAN68:   MOV       EDX,AUX00
          MOV       AL,R1
          MOV       BYTE PTR [EDX],AL       ;WRITE 'TRANSLATED' CHARACTER
          INC       EDX
          JMP       TRAN60                  ;LOOP BACK

TRAN99:   JMP       ENDSTMTZ


;  $GIO:  GENERALIZED GIO STATEMENT
;     SYNTAX:
;  $GIO [A/N] [ #N ] (ARG1[,ARG2])[ARG3 [;ARG3..]]
;             [/XXX]
;   A/N - ANY ALPHA OR NUMERIC CHARACTERS, OR BLANKS
;   #N, /XXX - DEVICE ADDRESS, OPTIONAL, DEFAULT=TAPE
;   ARG1 - HEX DIGITS, LITERAL, OR ALPHA.  ALPHA MAY HAVE
;          OPTIONAL ARRAY MODIFIER.  THIS DEFINES COMMAND
;          SEQUENCE.
;   ARG2 - OPTIONAL ALPHA WITH OPTIONAL ARRAY MODIFIER.
;          THIS CONTAINS REGISTERS 1-15, MUST CONTAIN AT
;          LEAST 10 BYTES (OR ERROR 97)
;   ARG3 - OPTIONAL BUFFER FOR DATA OPERATIONS.  MORE
;          THAN ONE BUFFER MAY BE DEFINED, SEPARATED BY
;          SEMICOLONS.
;
;*********************************************************
;  ENTRY:  TEXTPOINTER POINTS AFTER VERB GIO.
;
;  MODIFIED REGISTERS:
;      IN ENTRY/RESOLUTION PHASE,  ALL, AUX 0-2
;      IN EXECUTION PHASE,  ALL, AUX 0-F
;
;  REGISTER USAGE:
;     AUX 4 - 8 BIT FINE TUNED DELAY # (default -XX0A)
;     AUX 5 - DELAY/TIMEOUT COUNT
;     AUX 6 - TEXTPOINTER TO FIRST ARG3
;     AUX 7 - CURRENT TEXTPOINTER(AFTER PRESENT BUFFER)
;     AUX 8 - START ADDRESS OF ARG3 (BUFFER BEGIN)
;     AUX 9 - CURRENT ADDR OF ARG3 (BUFFER POINTER)
;     AUX A - REMAINING LEN OF ARG3 (BUFFER COUNT)
;     AUX B - START OF ARG2, REGISTERS
;     AUX C - PL= LENGTH OF ARG2, NUMBER OF REGISTERS
;             PH, BIT 01 = SUPER TIMEOUT FLAG
;             PH  BITS F0 = IOB LATCH (FOR DISK OPS)
;  NOTE:  ALL OBS'S WITH WR, TO A DISK, WILL RESTORE THE
;     IOB'S.  THE IOB'S ARE UNDEFINED AT ANY OTHER TIME

STIME    EQU       01H                      ;SUPER TIMEOUT FLAG

;     AUX D - START OF ARG1, OR TEXTPOINTER IF HEX
;     AUX E - CURRENT  ARG1,  "    "        "   "
;     AUX F - END+1 OF ARG1,  ZERO IF HEX
;        F7 - HIGH BYTE OF COMMAND   WX
;        F6 - LOW BYTE OF COMMAND    YZ
;        F5 - FLAGS:
;               80 - (DEVICE IS DISK)
;               40 - DEVICE IS MXD (04, OR 05)
;               20 - DEVICE IS MXD KEYBOARD (01)
;               10 - ARG3 IS FULL (BUFFER FULL CONDITION)
;               08 - ARG3 HAS BEEN SET UP AT LEAST ONCE
;               04 - FINE TUNED DELAY IS ON
;               02 - TIMEOUT IS ON  (AND DELAY IS OFF)
;               01 - DELAY IS ON    (AND TIMEOUT IS OFF)

ADISKH   EQU       08H                      ;DISK (IF WE SUPPORT IT LATER)
ACRTH    EQU       04H                      ;MXD CRT OR PRINTER
AKBDH    EQU       02H                      ;MXD   KEYBOARD
BUFFULL  EQU       10H                      ;BUFFER FULL BIT
BUFFULLH EQU       01H                      ;(HIGH BIT)
BUFPRES  EQU       08H                      ;BUFFER PRESENT (ARG3 IS SET UP)

;        F4 - STATUS BYTE, SAME AS REG 8 OF ARG2
;        F3 - USED IN DATA OPERATIONS FOR LRC
;
;   ERR S10 - MISSING LEFT PARENTHESIS
;   ERR S11 - MISSING RIGHT PARENTHESIS
;   ERR S13 - MISSING COMMA
;   ERR S17 - MISSING HEX DIGIT
;   ERR S19 - MISSING REQUIRED WORD  (GIO)
;   ERR S29 - MISSING ALPHA VARIABLE
;   ERR P46 - ILLEGAL ATOM
;   ERR P47 - NO ARG 3 CURRENTLY DEFINED, MISSING BFR VAR
;   ERR P48 - ILLEGAL DEVICE SPECIFICATION
;   ERR P51 - ARG2 TOO SHORT ( <10 BYTES)
; NOTES:
; 1. IBS & CBS RESTRICTED.
; 2. WR REQUIRED (ERROR) AT MXD ADDRESSES 4,7
; 3. OBS,CBS RESTRICTED AT MXD KEYBOARD ADDRESS
; 4. IBS ??
; 5. 71,73 SPECIAL.
; 6. 0100 + 8000 SERIES COMMANDS FOR WAIT/READY BEFORE CPB
; 7. C3XX WAITREADY BEFORE EACH CPB
; 8. 1010,1020 NOW LEGAL AT MXD KBD ADDRESS (NO TIMEOUT)

GIO:
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
;         CALL      DELAY10T
GIOA:
          CALL      LETRDIGT                ;SKIP PAST A LETTER/DIGIT
          CMP       R0,0                    ;LOOP BACK AS LONG AS LETTERS AND DIGITS ARE FOUND
          JE        GIOA
          CALL      DEVICEG                 ;GET DEVICE ADDRESS (DEFAULT = TAPE); MXD @ 4,5 OK

          NOP
          NOP
          MOV       BL,BYTE PTR FS:[IBGET]
          MOV       EAX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EAX].@SPREG2,BL

;-------- TSAI --------
          CMP       TOMXF,0
          JE        GIOB                    ;BR,if not MXF protocol
          TEST      SL,02H                  ;BR,if not execution phase
          JZ        GIO000
          CALL      ENMXFGIO                ;enable MXF GIO protocol
GIOB:
;--------- TSAII ------

;+$$$$
          test      sl,2
          jz        gio_2
          test      k,0fh
          jnz       gio_1
          call      enable_disk
          jmp       gio_2
gio_1:
          cmp       k,15h
          jb        gio_2
          cmp       k,17h
          ja        gio_2
          call      enable_printer
gio_2:
;-$$$$

          TEST      SL,2                    ;SKIP IF NOT X PHASE
          JZ        GIO000
          MOV       DH,R1
          OR        DH,04H                  ;04 = FINE TUNED DELAY, 10 = DISK, 08 = MXD 4/5
          MOV       DL,0
          MOV       AUX07,EDX               ;AUX 7 IS TEMP STORAGE FOR F5F4

GIO000:   CMP       BYTE PTR [TEXTPTR],'('  ;GET LEFT PARENTHESIS
          JNE       ERROR_10
          INC       TEXTPTR
          CALL      ALPHINL
          TEST      R0,0FH                  ;SKIP IF ALPHA ARRAY OR LITERAL FOUND
          JZ        GIO1
          TEST      SL,2                    ;SKIP IF NOT X PHASE
          JZ        GIO0

;  HEX DIGITS FOR ARG1
;

          MOV       EDX,TEXTPTR
          MOV       AUX0D,EDX               ;AUX D POINTS AT THE FIRST HEX DIGIT OF ARG1
          MOV       AUX0E,EDX               ;AUX E POINTS AT THE CURRENT HEX DIGIT OF ARG1
          MOV       AUX0F,0                 ;AUX F IS ZERO FOR HEX ARG1

GIO0:     CALL      HEXPAIR
          CALL      HEXPAIR                 ;GET 2 PAIRS OF HEXDIGITS
          CMP       BYTE PTR [TEXTPTR],','
          JNE       GIOX                    ;BR, IF NOT COMMA
          INC       TEXTPTR
          JMP       GIO2

GIOX:     MOV       AL,BYTE PTR [TEXTPTR]
          AND       AL,0F0H
          CMP       AL,20H
          JNE       GIO0                    ;LOOP IF NOT '2X' (RIGHT PAREN)

          JMP       GIO21                   ;GO GET THE RIGHT PARENTHESIS  (ARG2 OMITTED)

;  ALPHA OR LITERAL FOR ARG1
;

GIO1:     TEST      SL,2                    ;SKIP IF NOT X PHASE
          JZ        GIO19
          MOV       EDX,VSPTR
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       AUX0D,EDX               ;SAVE BEGIN ADDRESS IN AUX D
          MOV       AUX0E,EDX               ;SAVE CURRENT ADDRESS IN AUX E
          ADD       EDX,EAX
          MOV       AUX0F,EDX               ;SAVE END+1  IN AUX F
GIO19:    CMP       BYTE PTR [TEXTPTR],','  ;CHECK FOR A COMMA
          JNE       GIO21
          INC       TEXTPTR
GIO2:     CALL      ALPHIN                  ;GET ARG2
          TEST      R0,0FH                  ;NF, ERROR 29
          JNZ       GIO_29
          CMP       BYTE PTR [TEXTPTR],')'  ;GET RIGHT PARENTHESIS
          JNE       ERROR_11
          INC       TEXTPTR
          TEST      SL,2                    ;SKIP IF NOT X PHASE
          JZ        GIO3
          MOV       EDX,VSPTR               ;GET POINTERS TO ARG 2
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          MOV       K,0FFH
          CMP       DWORD PTR [A0],255      ;IF GREATER THAN 255, CALL IT 255
          JA        GIO25
          MOV       AX,A0
          MOV       K,AL
          CMP       DWORD PTR [A0],10
          JAE       GIO25                   ;CHECK LENGTH OF ARG2 (MUST BE GREATER THAN TEN

GIO_51:   MOV       R0,51H                  ;ERROR 51, ARG2 <TEN BYTES
          JMP       ERROR

GIO21:    CMP       BYTE PTR [TEXTPTR],')'  ;GET RIGHT PARENTHESIS
          JNE       ERROR_11
          INC       TEXTPTR
          TEST      SL,2                    ;SKIP IF NOT X PHASE
          JZ        GIO3
          MOV       K,10H                   ;LENGTH = 16 ( K )
          MOV       EDX,DWORD PTR [CPBASE]  ;POINT TO IOBUFFER
          LEA       EDX,[EDX].@IOBUFFR
GIOY:     MOV       DWORD PTR [EDX],0       ;INITIALIZE TO ZERO
          MOV       DWORD PTR [EDX+4],0
          MOV       DWORD PTR [EDX+8],0
          MOV       DWORD PTR [EDX+12],0
                                            ;POINT TO SUBSTITUTED 'ARG 2'
GIO25:    MOV       AUX0B,EDX               ;AUX B IS ADDRESS OF ARG2-1
          DEC       AUX0B
          MOVZX     EDX,K
          MOV       AUX0C,EDX               ;AUX C IS LENGTH OF ARG2 (0A TO FF)
          MOV       EDX,TEXTPTR
          MOV       AUX06,EDX               ;SAVE POINTER TO FIRST ARG3 BUFFER

GIO3:     CALL      ALPHIN
          TEST      SL,2                    ;SKIP IF X PHASE
          JNZ       GIO4
          TEST      R0,0FH                  ;EXIT IF NOT FOUND
          JNZ       TRAN99

GIO32:    CMP       BYTE PTR [TEXTPTR],';'  ;CHECK FOR SEMICOLON
          JNE       TRAN99                  ;EXIT IF NOT FOUND
          INC       TEXTPTR
          CALL      ALPHIN
          TEST      R0,0FH                  ;LOOP IF FOUND
          JZ        GIO32

GIO_29:   JMP       ERROR_29                ;ERROR 29, MISSING ALPHA VARIABLE

;   EXECUTION PHASE
;

;  F5 LOW = 04, FINE TUNED DELAY FLAG (04 BIT)
;  F4 = 00,  STATUS BYTE

GIO4:     MOV       EDX,7
          MOV       AUX04,EDX               ;DEFAULT DELAY IS FINE, 50 MICROSECONDS
          MOV       EDX,AUX07               ;RECALL TEMP FLAG SAVED EARLIER
          MOV       WORD PTR [R4],DX        ;F5 HIGH = ENABLED DEVICE FLAGS (E0 BITS)
          TEST      R0,0FH                  ;SKIP IF ARG 3 NOT FOUND
          JNZ       GIO6

GIO5:     MOV       EDX,TEXTPTR
          MOV       AUX07,EDX               ;AUX 7 POINTS AFTER CURRENT BUFFER NAME(IN TEXT)
          OR        R5,BUFPRES              ;INDICATE PRESENCE OF ARG3 (08)
          MOV       EDX,VSPTR               ;POP POINTERS TO (NEW) ARG3 BUFFER
          MOV       EAX,DWORD PTR [EDX]
          MOV       DWORD PTR [A0],EAX
          MOV       EDX,DWORD PTR [EDX+4]
          ADD       VSPTR,8
          JMP       GIO7

GIO6:     MOV       DWORD PTR [A0],0
          XOR       EDX,EDX

GIO7:     MOV       AUX09,EDX               ;SAVE CURRENT ADDRESS OF ARG3 IN AUX 9
          MOV       AUX08,EDX
          MOV       EDX,DWORD PTR [A0]
          MOV       AUX0A,EDX               ;SAVE LENGTH OF ARG 3 IN AUX A
          AND       R5,0FFH-BUFFULL         ;TURN OFF BUFFER FULL BIT
          CMP       EDX,0
          JNE       GIOZ
          OR        R5,BUFFULL              ;TURN ON BUFFER FULL BIT IF LENGTH=0
GIOZ:     MOV       EDX,AUX0B
          ADD       EDX,9                   ;PC'S POINT AT REG 9 OF ARG 2
          MOV       WORD PTR [EDX],0
          INC       EDX                     ;ZERO THE (2 BYTE) COUNT IN REGS 9,10

ATOMEND:  CALL      STATUS                  ;SAVE STATUS BYTE
ATOM:     CALL      BREAKPTG                ;CHECK FOR END OF 30 MS TIMESLICE
          CALL      COMMAND                 ;GET  NEXT TWO BYTE COMMAND
          TEST      R7,80H                  ;SKIP IF W>7
          JNZ       GIOC80
          TEST      R7,40H                  ;SKIP IF W>3
          JNZ       GIOC40
          MOV       AL,R7
          AND       AL,0F0H
          CMP       AL,10H
          JE        GIOC10                  ;CONTROL COMMANDS 1
          CMP       AL,20H
          JE        GIOC20                  ;CONTROL COMMANDS 2
          CMP       AL,30H
          JE        ATOMERR                 ;3XXX - FUTURE EXPANSION

;    SAVE IMMEDIATE  0XYY

;    LOAD REGISTER X WITH THE IMMEDIATE DATA YY

GIOC00:   MOV       AL,R6
          MOV       K,AL
          MOV       AL,R7
          AND       AL,0FH
          MOV       R0,AL
          CALL      REGSAVE                 ;SAVE IMMEDIATE DATA IN REG X
          JMP       ATOM

;  CONTROL COMMANDS 1
;

GIOC10:   TEST      R7,8                    ;SKIP IF >7
          JNZ       GIOC18
          TEST      R7,4                    ;SKIP IF >3
          JNZ       GIOC14
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,1
          JE        GIOC11                  ;11XX COPY REG
          CMP       AL,2
          JE        GIOC12                  ;12XX TIMEOUT/DELAY
          CMP       AL,3
          JE        GIOC13                  ;13XX FINE TUNED DELAY

;   1000 - SET CC TRUE
;

          CMP       R6,0                    ;1000 SET CC=TRUE
          JE        SETCC
          TEST      R6,0FH                  ;10XY IS ERROR FOR Y<>0
          JNZ       ATOMERR
          TEST      R6,40H
          JNZ       ATOMERR
          TEST      R6,80H
          JNZ       ATOMERR                 ;10X0 IS ERROR FOR X>3

;   READY COMMANDS

;     1010 - SET CC  IF READY
;     1020 - WAIT FOR READY (WITH POSSIBLE TIMEOUT)

          MOV       AL,R6
          AND       AL,0F0H
          CMP       AL,20H                  ;SKIP IF 1020 - WAIT FOR READY
          JE        GIOC102
          CALL      CHKRDY                  ;K = READY/BUSY
          MOV       AL,R6
          AND       AL,20H
          MOV       R0,AL                   ;F0= 00 IF 1010,  20 IF 1030
          TEST      K,8                     ;SKIP IF NOT READY
          JZ        GIOC17
          XOR       R0,20H                  ;COMPLEMENT BIT IF DEVICE READY
          JMP       GIOC17                  ;JUMP IF F0 IS NON-ZERO

;   1020- WAIT/READY (WITH TIMEOUT)
;

GIOC102:  CALL      WAITR                   ;WAIT FOR READY WITH TIMEOUT
          JMP       ATOM                    ;CONTINUE TO NEXT MICRO-COMMAND IF NO TIMEOUT

GIO_48:   MOV       R0,48H                  ;ERR P48;  ILLEGAL DEVICE SPECIFICATION
          JMP       ATERRC

;   11YZ - COPY REG Y TO REG Z
;

GIOC11:   CALL      LREGIND                 ;LOAD INDIRECT (FROM Y)
          MOV       AL,R2
          MOV       K,AL
          CALL      REGSIND                 ;SAVE INDIRECT (IN Z)
          JMP       ATOM

;   12YZ - TIMEOUT/DELAY
;   1200 - TURN OFF TIMEOUT AND DELAY
;   12Y1 - TURN ON (COARSE) DELAY
;   12Y2 - TURN ON TIMEOUT
;   12Y3 - SUPER TIMEOUT (UNDOCUMENTED)
;      Y AND Y+1 ARE A REGISTER PAIR

GIOC12:   TEST      R6,8
          JNZ       ATOMERR
          TEST      R6,4                    ;Z MUST BE LESS THAN 4
          JNZ       ATOMERR
          MOV       EDX,AUX0C
          AND       DH,0FFH-STIME           ;TURN OFF SUPER TIMEOUT
          MOV       AL,R6
          AND       AL,0FH
          CMP       AL,3
          JNE       GIOC121                 ;SKIP IF NOT 12Y3
          OR        DH,STIME                ;TURN ON SUPER TIMEOUT
          DEC       R6                      ;CHANGE 3 TO 2
GIOC121:  MOV       AUX0C,EDX               ;SAVE SUPER TIMEOUT FLAG
          AND       R5,0FFH-03              ;TURN OFF TIMEOUT/DELAY
          TEST      R6,0FH                  ;12Y0 IS TURN OFF COMMAND
          JZ        ATOM
          CALL      REGLOADC                ;GET REGISTER PAIR (F3F2)
          CMP       R3,0
          JNE       GIOXY
          MOV       AL,R3
          CMP       AL,R2
          JE        ATOM                   ;IF COUNT=0, TURN OFF TIMEOUT/DELAY
GIOXY:    MOV       DX,WORD PTR [R2]
          MOV       AUX05,EDX              ;AUX 5 = TIMEOUT/DELAY COUNT
          AND       R6,0FH                 ;F6 = 01 OR 02
          MOV       AL,R6
          OR        R5,AL                  ;TURN ON DELAY/TIMEOUT
          JMP       ATOM

;   13XX - FINE TUNED DELAY

;     XX IS THE DELAY VALUE (5 MICROSECONDS PER COUNT)

GIOC13:   AND       R5,0FFH-04             ;TURN OFF FINE TUNED DELAY
          MOV       EDX,AUX04
          MOV       DL,0FDH
          ADD       DL,R6
          JNC       ATOM                   ;DONE IF DELAY <3 (15 US)
          MOV       AUX04,EDX              ;SAVE DELAY COUNT-3
          OR        R5,4                   ;ACTIVATE FINE TUNED DELAY
          JMP       ATOM

GIOC14:   TEST      R7,2                   ;SKIP IF 16.. OR 17..
          JNZ       GIOC16

;   14YZ, 15YZ -- COMPARE REGS

;   14YZ - COMPARE REG Y TO REG Z, IF UNEQUAL SET THE
;      COMPARE ERROR (BIT 08).
;   15YZ - SAME, THEN SET CC IF COMPARE ERROR BIT IS ON.

          CALL      LREGIND                ;LOAD INDIRECT
          MOV       AL,R2
          MOV       R3,AL
          MOV       AL,R6
          AND       AL,0FH
          MOV       R0,AL
          CALL      REGLOAD
          MOV       AL,R3
          CMP       AL,R2
          JE        GIOC145                ;BRANCH IF EQUAL
          OR        R4,08H                 ;TURN ON COMPARE ERROR (08)
GIOC145:  TEST      R7,1                   ;DONE IF NOT 15YZ
          JZ        ATOMEND
          TEST      R4,8                   ;IF NOT COMPARE ERROR, OKAY
          JZ        ATOMEND

;    SET CC=TRUE, BECAUSE OF COMPARE ERROR
;

          JMP       SETCC

;    16XX, 17XX - CHECK STATUS BITS

;    16XX - SET CC IF ANY ARE OFF
;    17XX - SET CC IF ANY ARE ON

GIOC16:   MOV       AL,R4
          MOV       R0,AL
          TEST      R7,1
          JNZ       GIOXZ
          XOR       R0,0FFH                ;COMPLEMENT STATUS BYTE IF 16XX
GIOXZ:    MOV       AL,R6
          AND       R0,AL                  ;MASK WITH IMMEDIATE FIELD
GIOC17:   CMP       R0,0                   ;CC=TRUE IF ANY BITS ARE ON
          JNE       SETCC
          JMP       ATOM                   ;GET NEXT ATOM

;   18XX, 1AX0 - SET UP NEW ARG3 BUFFER

;   18XX - SET UP THE XX'TH BUFFER
;   1AX0 - (X<>0) - SET UP THE BUFFER REFERENCED BY REG X

GIOC18:   TEST      R7,4                   ;SKIP FOR  1CXX-1FXX
          JNZ       GIOC1C
          TEST      R7,1                   ;SKIP FOR 19XX,1BXX
          JNZ       GIOC19
          TEST      R7,2
          JZ        GIOYX
          TEST      R6,0F0H                ;SKIP IF 1A0X - SET UP 'NEXT' BUFFER
          JZ        GIOC185

GIOYX:    CALL      LREG                   ;GET INDIR OR IMMED COUNT (0-255)
          MOV       EDX,AUX06
          MOV       TEXTPTR,EDX
          CMP       R2,0                   ;SKIP IF ZERO
          JE        GIOC183
GIOC182:  MOV       R0,';'
          CALL      SCANCHA                ;SCAN FOR SEMICOLON SEPARATOR
          TEST      R0,0FH                 ;ERROR IF NO SEMICOLON
          JNZ       GIO_47
          DEC       R2                     ;DECREMENT SPECIFIED COUNT
          JNZ       GIOC182                ;LOOP TILL ZERO

GIOC183:  MOV       DX,WORD PTR [R4]
          PUSH      EDX                    ;SAVE F5F4 IN STACK
          CALL      ALPHIN                 ;GET NEW BUFFER
          POP       EDX
          MOV       WORD PTR [R4],DX       ;RESTORE F5F4
          TEST      R0,0FH                 ;IF ALPHA VAR IS FOUND, GO SETUP THE POINTERS
          JZ        GIO5

GIO_47:   MOV       R0,47H
          JMP       ATERRC                 ;ERROR 47 IF NOT ENOUGH ARG3'S

;   1A00 - GET NEXT BUFFER

;   19YZ - INCREMENT/DECREMENT
;   19YZ - Y REPRESENTS A REGISTER OR REGISTER PAIR

GIOC185:  MOV       EDX,AUX07
          MOV       TEXTPTR,EDX            ;POINT TEXTPTR AFTER LAST SET UP ARG3 BUFFER
          CMP       BYTE PTR [TEXTPTR],';' ;LOOK FOR SEMICOLON
          JNE       SETCC                  ;SET CC=TRUE  IF NO MORE BUFFERS
          INC       TEXTPTR                ;IF FOUND, GET NEXT BUFFER
          JMP       GIOC183

;    IF Z<4 THEN A SINGLE REGISTER IS USED,
;       IF Z>=4, THEN A REGISTER PAIR IS USED:
;  Z = 0 OR 4 - INCREMENT BY 1
;  Z = 1 OR 5 - INCREMENT BY 2
;  Z = 2 OR 6 - DECREMENT BY 2
;  Z = 3 OR 7 - DECREMENT BY 1

GIOC19:   TEST      R7,2                   ;1BXX - ONE BYTE <--> ARG3
          JNZ       GIOC1B
          TEST      R6,8                   ;Z>7 IS ILLEGAL
          JNZ       ATOMERR
          CALL      LREGIND                ;READ HIGH ORDER BYTE
          MOV       AL,R6
          AND       AL,04
          MOV       R3,AL                  ;(SAVE 0004 BIT 1:2 BYTE FLAG)
          MOV       R7,0FFH
          OR        R6,0FCH
          TEST      R6,2                   ;SKIP IF NEGATIVE INCREMENT
          JNZ       GIOC191
          AND       R6,1                   ;ADJUST IF POSITIVE
          INC       R6
          MOV       R7,0

;   F7F6 = 2 BYTE INCREMENT (2'S COMPLEMENT IF NEG)
;

GIOC191:  TEST      R3,4                   ;SKIP IF ONE BYTE INCREMENT/DECREMENT
          JZ        GIOC195
          CALL      REGLOADB               ;READ LOW ORDER BYTE
          MOV       AX,WORD PTR [R6]
          ADD       AL,R2
          MOV       K,AL
          ADC       AH,R3
          MOV       R2,AH                  ;ADD F7F6 TO REG PAIR
          CALL      REGSAVE                ;SAVE LOW ORDER BYTE
          DEC       R0
          MOV       WORD PTR [R6],0        ;ZERO THE INCREMENT
GIOC195:  MOV       AL,R6                  ;INCREMENT (IF ONE BYTE)
          ADD       AL,R2
          MOV       K,AL
          CALL      REGSAVE                ;SAVE IT BACK
          JMP       ATOM                   ;GO GET NEXT COMMAND

;   1BXX - ONE BYTE <--> ARG3

;   1BX1 - WRITE ONE BYTE FROM BUFFER TO REGISTER X
;   1BX2 - READ ONE BYTE INTO BUFFER FROM REGISTER X
;     IN EACH CASE, INCREMENT DATA COUNT FIRST; BRANCH
;     OR TERMINATE IF BUFFER ALREADY DONE

GIOC1B:   TEST      R5,BUFPRES             ;ERROR IF NO ARG3
          JZ        GIO_47
          TEST      R5,BUFFULL             ;SET CC=TRUE  IF 'BUFFER FULL'
          JNZ       SETCC
          MOV       EDX,AUX0A
          MOV       AUX0A,EDX
          DEC       AUX0A
          MOV       EDX,AUX09
          MOV       AUX08,EDX              ;SAVE PRESENT BUFFER POINTER

          MOV       AL,R6
          AND       AL,0FH
          CMP       AL,1                   ;SKIP IF NOT 1BX1
          JNE       GIOC1920

;  1BX1 - ONE BYTE BUFFER --> REG X

          MOV       CH,BYTE PTR [EDX]
          MOV       AUX09,EDX              ;READ DATA BYTE
          INC       AUX09
          MOV       AL,R6
          SHR       AL,4
          MOV       R0,AL
          MOV       K,CH
          CALL      REGSAVE                ;SAVE IN REG X
          JMP       DATAEND

;  1BX2 - ONE BYTE  REG X --> BUFFER
;

GIOC1920: MOV       AL,R6
          AND       AL,0FH
          CMP       AL,2
          JNE       ATOMERR
          CALL      LREGIND                ;FETCH REG X
          MOV       EDX,AUX09
          MOV       AL,R2
          MOV       BYTE PTR [EDX],AL
          MOV       AUX09,EDX              ;WRITE INTO BUFFER
          INC       AUX09
          JMP       DATAEND

;   COMPARE REGISTERS (SET CC)

;   1CYZ - SET CC IF REG Y = REG Z
;   1DYZ - SET CC IF REG PAIR Y,Y+1 = REG PAIR Z,Z+1
;   1EYZ - SET CC IF REG Y > REG Z
;   1FYZ - SET CC IF REG PAIR Y,Y+1 > REG PAIR Z,Z+1

GIOC1C:   CALL      REGLOADC               ;GET REGISTER PAIR Y,Y+1
          MOV       DX,WORD PTR [R2]
          PUSH      EDX

          MOV       AL,R6
          MOV       AH,AL
          SHL       AH,4
          SHR       AL,4
          OR        AH,AL
          MOV       R6,AH                  ;SWAP Y AND Z POINTER VALUES

          CALL      REGLOADC               ;GET REGISTER PAIR X,X+1
          POP       EDX

;  Y IS IN PH, Y+1 IN PL;  Z IS IN F3, Z+1 IN F2

          TEST      R7,2                   ;SKIP IF 1EYZ OR 1FYZ
          JNZ       GIOC1E
          CMP       R3,DH                  ;CC= FALSE IF HIGH BYTES NOT EQUAL
          JNE       ATOM
          TEST      R7,1                   ;CC= TRUE IF 1CYZ (SINGLE BYTE COMPARE)
          JZ        SETCC
          CMP       R2,DL                  ;CC= FALSE IF LOW BYTE NOT EQUAL
          JNE       ATOM
          JMP       SETCC                  ;CC= TRUE IF BOTH BYTES EQUAL

GIOC1E:   CMP       R3,DH                  ;CC = TRUE IF Y>Z
          JB        SETCC
          TEST      R7,1                   ;CC = FALSE IF 1EYZ (SINGLE BYTE COMPARE)
          JZ        ATOM
          CMP       WORD PTR [R2],DX       ;CC = TRUE IF Y,Y+1 > Z,Z+1
          JB        SETCC
          JMP       ATOM                   ;CC = FALSE IF Y,Y+1 <= Z,Z+1

;   2XXX - EXPANSION POSSIBLE
;

GIOC20:   TEST      R7,0FH                 ;2XXX - FUTURE EXPANSION
          JNZ       ATOMERR
          MOV       AL,R7
          CMP       AL,R6
          JNE       ATOMERR

;-------- TSAI -------
GEND:
          CMP       TOMXF,0                ;if not MXF protocol
          JE        GEND1                  ;
          TEST      SL,02
          JZ        GEND1                  ;BR,if not execution phase
;         CALL      DIMXFGIO               ;disable MXF GIO protocol
          MOV       EBX,CMDBUADR
;-------- test,1-24-91 ----
;g2:
;        TEST    GS:[EBX].gcpust,RB      ;wait until device ready
;        JZ      G2                      ;skip if ready
;-------- test,1-24-91 -----
          MOV       GS:[EBX].gdis,0FFH
          MOVZX     EBX,PART_
          MOV       BYTE PTR [EBX+OFFSET MXFGIOTBL],0 ;no more GIO this
GEND1:                                                ;partition
;-------- TSAII -------
          TEST      R5,ADISKH*10H          ;SKIP IF NOT DISK
          JZ        GENDX
          call      disable_disk
          CALL      FREEDISK               ;DISABLE DISK, UNHOG IF APPROPRIATE
;+$$$$
GENDX:
;-$$$$
          JMP       REMCO                  ;ENABLE NULL, IGNORE REST OF STMT

GIOC40:   MOV       AL,R7
          AND       AL,0F0H
          CMP       AL,70H
          JE        GIOC70                 ;ADDRESS COMMANDS  7

;    4XYZ,5XYZ,6XYZ - SINGLE OUTPUT

;    4XYZ - SINGLE OUTPUT STROBE
;    5XYZ - SINGLE OUTPUT STROBE WITH ACKNOWLEDGE
;    6XYZ - SINGLE OUTPUT STROBE WITH ECHO

;   OUTPUT STROBE WITH ACKNOWLEDGE (5XYZ, 6XYZ)
GIO456:                                   ;---TSAI
          CALL      LREG                  ;GET IMMEDIATE OR INDIRECT DATA
          CALL      STROBE                ;STROBE IT OUT
          MOV       AL,R7
          AND       AL,0F0H
          CMP       AL,40H
          JE        ATOM                  ;DONE IF 4XYZ
          CALL      WAITINK               ;CPB, WAIT IBS
          TEST      R7,2
          JZ        GIOYY
          CALL      REGSIND               ;SAVE IN REG Z (IF INDIRECT)
GIOYY:    TEST      R7,20H                ;DONE IF 5XYZ
          JZ        ATOM

;   OUTPUT STROBE WITH ECHO (6XYZ)

          JMP       GIOC805

;   ADDRESS STROBE (7XYZ)

GIOC70:   TEST      R7,8                  ;78XX-7FXX NOT DEFINED
          JNZ       ATOMERR
          TEST      R7,4                  ;SKIP IF 74-77
          JNZ       GIOC74
          CALL      LREG                  ;GET IMMEDIATE OR INDIRECT DATA
          MOV       AL,R2
          MOV       K,AL
          TEST      R7,1
          JNZ       GIOC72
          CALL      DELAY10
;+$$$$
          call      disk_iob
;-$$$$
          MOV       AL,K
          MOV       BYTE PTR FS:[IOBS],AL
          CALL      DELAY10

          MOV       EDX,AUX0C
          MOV       AH,DH
          MOV       AL,R2
          SHL       AH,4
          SHR       AL,4
          OR        AH,AL
          MOV       R2,AH

          MOV       AL,AH
          SHR       AH,4
          SHL       AL,4
          OR        AL,AH

          MOV       DH,AL                 ;COPY HIGH PART OF IOB'S TO AUX C
          MOV       AUX0C,EDX             ;SAVE AUX C
          JMP       ATOM

GIOC72:   TEST      R5,ADISKH*10H         ;SKIP IF PREVIOUS DEVICE NOT DISK
          JZ        GIOC721
          MOV       DL,K
          MOV       DH,R1                 ;K & F1 ARE TRASHED BY 'ENDDISK'...

          call      disable_disk

          PUSH      EDX                   ;AND ARE NEEDED BY 'ENBLDEVG'
          CALL      FREEDISK              ;DISABLE DISK AND UNHOG IF APPROPRIATE
          POP       EDX
          MOV       K,DL                  ;RESTORE K & F1
          MOV       R1,DH
;+$$$$
;-$$$$

GIOC721:  MOV       EDX,ACTDEV
          CMP       DH,TCDEV              ;B IF NOT TC TCDEVH = 00H, TCDEVL = 0AH
          JNE       GIOC723

          JMP       ERROR_48              ;ERROR IF TC
GIOC723:  MOV       DH,0                  ;.71YZ,73Y0 - ENABLE DEVICE ADDRESS
          MOV       DL,K
;-------- TSAI ------
          CMP       TOMXF,0               ;if in MXF GIO protocol
          JE        GIOC725
;         CALL      DIMXFGIO              ;disable current protocol
          MOVZX     EBX,PART_
;-------- TSAI,10-03-91 ------
          CMP       BYTE PTR [EBX+MXFGIOTBL],0 ;br,if previous not a MXF GIO
          JE        GIOC725                    ;command,ex GIO/000
          MOV       BYTE PTR [EBX+MXFGIOTBL],0 ;
          MOV       EBX,CMDBUADR               ;
          MOV       GS:[EBX].gdis,0FFH         ;disable current ABS
;-------- TSAI,10-03-91 ------
GIOC725:
;-------- TSAII ------
;+$$$$
          call      disable_disk
;-$$$$

          CALL      ENBLDEVG              ;ENABLE CHANGE ACTDEV TO NEWLY ENABLED ADDRESS

;+$$$$
          test      k,0fh
          jnz       gio_8
          call      enable_disk
          jmp       gio_9
gio_8:
          cmp       k,15h
          jb        gio_9
          cmp       k,17h
          ja        gio_9
          call      enable_printer
gio_9:
;-$$$$

;--------- TSAI -------
          CMP       TOMXF,0
          JE        GIOC724               ;BR,if not MXF protocol
          CALL      ENMXFGIO              ;enable new MXF GIO protocol
GIOC724:
;--------- TSAII ------
          AND       R5,1FH
          MOV       AL,R1
          OR        R5,AL                 ;SET UP F5 WITH NEW DISK AND MXD FLAGS
          JMP       ATOM

;  STATUS REQUEST STROBE  (760Z)
;

GIOC74:   TEST      R7,1                  ;SKIP FOR 75,77
          JNZ       GIOC75
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,6                  ;74XX - FUTURE EXPANSION
          JNE       ATOMERR
          MOV       K,30H                 ;(DEFAULT = 30 FOR 80 COLUMN MVP)
          TEST      R5,ACRTH*10H          ;SKIP IF MXD CRT OR LOCAL PRINTER
          JNZ       GIO740

          MOV       EAX,DWORD PTR [CPBASE]
          MOV       AL,BYTE PTR [EAX].@SPREG2
          MOV       K,AL                  ;STATUS REQUEST STROBE

          CALL      DELAY10
GIO740:   CALL      REGSIND               ;STORE STATUS BYTE INDIRECTLY
          JMP       ATOM

;   DELAY IMMEDIATE (75XX, 77Y0)
;

GIOC75:   CALL      LREG                  ;GET IMMEDIATE OR INDIRECT COUNT
GIOC751:  CMP       R2,0                  ;EXIT IF ZERO
          JE        ATOM
                                          ;Anita for 33M cpu
;          MOV       DX,0570H
;GIOYZ:    DEC       DX
;          CMP       DX,0
;          JNE       GIOYZ                 ;DELAY 1 MS
          call      delay1ms
                                          ;Anita
          CALL      BREAKPTG              ;CHECK FOR END OF TURN
          DEC       R2                    ;DECREMENT COUNT BY 1
          JMP       GIOC751               ;LOOP BACK

;  SINGLE INPUT

GIOC80:
          MOV       AH,R7
          AND       AH,0F0H
          CMP       AH,90H
          JE        GIOC90                ;9 INPUT WITH ECHO
          CMP       AH,80H
          JNE       GIOC905               ;SKIP IF DATA OPERATION (AXXX - FXXX)

;    8XXX - SINGLE INPUT STROBE

;    860X - SINGLE INPUT, NO CHECK FOR ENDI
;    862X - SINGLE INPUT, CHECK FOR ENDI
;    80XX, 82XY -  INPUT WITH VERIFY
;    88XX, 8AXY -  INPUT, VERIFY, BRANCH IF VFY ERROR
;    + 0100 - WAIT/READY BEFORE INPUT (TO AVOID I92)
;    8EXX, 8FXX -  UNDEFINED, BUT DON'T GIVE ERRORS ANYMORE.

          MOV       AL,R7
          AND       AL,06H
          CMP       AL,6
          JE        GIOC802
          TEST      R7,4                  ;84,85,8C,8D,8E,8F - FUTURE EXPANSION
          JNZ       ATOMERR
GIOC802:  TEST      R7,1                  ;DON'T WAIT FOR READY UNLESS 0100 BIT
          JZ        GIOC803
          TEST      R5,AKBDH*10H          ;SKIP IF MXD KEYBOARD
          JNZ       GIOC803
          CALL      WAITR                 ;WAIT FOR READY (87XX, 81XX,83XX,89XX,8BXX)
GIOC803:  CALL      WAITINK               ;ACCEPT IBS
          TEST      SH,4                  ;SKIP IF NOT ENDI
          JZ        GIOC804
          AND       SH,0FBH
          MOV       AX,WORD PTR FS:[CPUST];TURN OFF ENDI
          MOV       AL,R6
          AND       AL,0F0H
          CMP       AL,20H
          JNE       GIOC804               ;SKIP IF NOT 862X
          MOV       AL,R7
          AND       AL,06H
          CMP       AL,6
          JE        GIOC810

GIOC804:  TEST      R7,2
          JZ        GIOZX
          CALL      REGSIND               ;SAVE INDIRECT IN REG Z
GIOZX:    MOV       AL,R7                 ;DONE IF 860X
          AND       AL,06H
          CMP       AL,6
          JE        ATOM
          MOV       AL,K
          MOV       R1,AL
          CALL      LREG                  ;GET INDIRECT OR IMMEDIATE
GIOC805:  MOV       AL,R2
          CMP       AL,K
          JE        GIOC807
          OR        R4,04H                ;TURN ON ECHO ERROR
GIOC807:  TEST      R7,8                  ;NO JUMP IF 80XX,82XX
          JZ        ATOMEND
          TEST      R4,4
          JZ        ATOMEND
          JMP       SETCC                 ;SET CC= TRUE,   ECHO ERROR

GIOC810:  OR        R4,20H                ;TURN ON ENDI FLAG IN STATUS BYTE
          MOV       R0,6
          CALL      REGSAVE               ;SAVE ENDI CHARACTER IN REG 6
          JMP       ATOMEND               ;SAVE STATUS BYTE, GET NEXT COMMAND

;    9X0Z - INPUT STROBE WITH ECHO
;

GIOC90:   CALL      WAITINK               ;ACCEPT IBS
          CALL      REGSIND               ;SAVE IN REG Z
          CALL      STROBEK               ;STROBE THE ECHO
          JMP       ATOMEND               ;SAVE STATUS, GET NEXT ATOM

;     DATA AND BRANCH OPERATIONS, AXXX-FXXX
;

GIOC905:  MOV       R3,0                  ;ZERO LRC
          MOV       AL,R7
          AND       AL,0F0H
          CMP       AL,0A0H
          JE        GIOCA0                ;A0XX - DATA OUTPUT, NO ECHO
          CMP       AL,0B0H
          JE        GIOCB0                ;B0XX - DATA OUTPUT WITH OPTIONS
          CMP       AL,0C0H
          JE        GIOCC0                ;C0XX - DATA INPUT
          CMP       AL,0D0H
          JE        ATOM                  ;IGNORE ANY DXXX, BECAUSE CC= FALSE
          CMP       AL,0E0H
          JE        GIOCE                 ;EXXX - BRANCH, BECAUSE  CC= FALSE
ATOMERR:  MOV       R0,46H                ;ERROR 46, ILLEGAL ATOM
ATERRC:   MOV       EDX,AUX0F
          CMP       EDX,0                 ;SKIP IF ARG 1 NOT HEX
          JNE       GIOZY
          CALL      COM8                  ;SWAP TEXT POINTER WITH HEX POINTER
GIOZY:    JMP       ERROR                 ;STOP WITH ERROR

;    AXXX - DATA OUTPUT, NO ECHO
;

GIOCA0:   TEST      R5,BUFPRES            ;ERR 47 IF NO ARG3 AVAILABLE
          JZ        GIO_47
          TEST      R7,8                  ;A8..-AF.. - FUTURE EXPANSION
          JNZ       ATOMERR
          MOV       AL,R7
          AND       AL,03H
          CMP       AL,3                  ;A3,A7 - FUTURE EXPANSION
          JE        ATOMERR
          TEST      R6,0F0H               ;Y<>0 - FUTURE EXPANSION
          JNZ       ATOMERR
          TEST      R5,BUFFULLH*10H       ;EXIT IF 'BUFFER FULL'
          JNZ       GIOCA26
          MOV       EDX,AUX09             ;PC'S = ADDRESS OF FIRST BYTE OF BUFFER
          TEST      R7,1                  ;SLOW LOOP IF NO WAIT FOR READY
          JNZ       GIOCA06
          TEST      R5,0E0H
          JZ        GIOZZ
          JMP       GIOCA06               ;SLOW LOOP IF MXD (OR DISK??)
GIOZZ:    MOV       AL,R7
          AND       AL,0FH
          CMP       AL,2
          JE        GIOCA23               ;A20L = 25 MICROSECOND OPTION (2200 COMPAT)
          CMP       AL,6
          JE        GIOCA06               ;A60L - CALCULATE LRC ONLY
          TEST      R5,7
          JZ        GIOCA23               ;FAST OPTION OF NO DELAY OR TIMEOUT SPEC
          JMP       GIOCA06

;   A00L - (WR, DATAOUT/OBS)  REPEAT, LEND
;   A10L - (    DATAOUT/OBS)  REPEAT, LEND
;   A40L - (WR, DATAOUT/CBS)  REPEAT, LEND
;   A50L - (    DATAOUT/CBS)  REPEAT, LEND
;   A60L -  SCAN DATA BUFFER, CALCULATE LRC

GIOCA03:  MOV       AUX0A,EDX             ;DECREMENT COUNT
          DEC       AUX0A
          XOR       R3,CH                 ;CALCULATE LRC
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,6
          JE        GIOCA05               ;IF A6XX, NO STROBE
          MOV       R2,CH
          CALL      STROBE                ;STROBE OUT THE DATA
GIOCA05:  MOV       EDX,AUX09
GIOCA06:  MOV       CH,BYTE PTR [EDX]     ;READ DATA BYTE
          MOV       AUX09,EDX
          INC       AUX09
          MOV       EDX,AUX0A
          CMP       DX,0                  ;LOOP IF COUNT>0000
          JNE       GIOCA03
          MOV       EDX,AUX09
          JMP       GIOCA25               ;EXIT , COUNT = 0000

;  FAST OUTPUT LOOP:

;     A20L - 23 MICROSECOND LOOP
;       A00L - WITHOUT ANY DELAY OR TIMEOUT SPEC
;       A40L - WITHOUT ANY DELAY OR TIMEOUT SPEC
;              9 MICROSECOND LOOP

GIOCA20:  XCHG      EDX,AUX0A
          DEC       AUX0A
          XOR       R3,CH                 ;CALCULATE LRC
          CALL      BREAKPTG              ;CHECK FOR END OF 30 MS TIMESLICE
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,2                  ;SKIP IF NOT A20L
          JNE       GIOCA210

;   NOTE - A2XX DELIBERATELY IS CODED SLOW
;     36.67 CYCLES = APPROX 22 MICROSECONDS
;
          CALL      DELAY17C              ;DELAY 17 CYCLES
          CALL      DELAY10
          MOV       AUX00,EDX             ;SAVE PC'S
;         CALL      WAITRDYB              ;WAIT FOR READY
          CALL      GWAITRDY              ;--- TSAI
          MOV       EDX,AUX00             ;RESTORE PC'S
          CALL      DELAY5C               ;DELAY ANOTHER 4 MICROSECONDS (6.33 CYCLES)
                                          ;  (TO COMPENSATE FOR HARDWARE MISTAKES)
          JMP       GIOCA22

GIOCA210: TEST      R7,4                  ;SKIP IF OBS IS SPECIFIED
          JZ        GIOCA212
          MOV       AUX00,EDX             ;SAVE PC'S
;         CALL      WAITRDYB              ;WAIT FOR READY
          CALL      GWAITRDY              ;--- TSAI
          MOV       EDX,AUX00             ;RESTORE PC'S

          MOV       K,CH
;+$$$$
          call      disk_cbs
;-$$$$
          MOV       BYTE PTR FS:[CBS],CH  ;STROBE CBS
          CALL      DELAY10
          JMP       GIOCA23
GIOCA212: MOV       AUX00,EDX             ;SAVE PC'S
;         CALL      WAITRDYB              ;WAIT FOR READY
          CALL      GWAITRDY              ;--- TSAI
          MOV       EDX,AUX00             ;RESTORE PC'S
GIOCA22:
          MOV       K,CH
;$$$$
          call      disk_obs
;-$$$$
          MOV       BYTE PTR FS:[OBS],CH  ;STROBE OBS
          CALL      DELAY10
GIOCA23:  MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX0A
          INC       AUX0A
          CMP       DX,0                  ;LOOP IF COUNT IS >0
          JNE       GIOCA20
          XCHG      EDX,AUX0A             ;SAVE FINAL COUNT
GIOCA25:  MOV       AUX09,EDX             ;AND FINAL ADDRESS
          DEC       AUX09

;    LRC END OPERATIONS -
;     Z = 0  NONE
;     Z = 4  SAVE LRC (IN REG 5)
;     Z = 2,3,6,7 - SEND LRC WITH OBS/CBS; THEN SAVE LRC

GIOCA26:  TEST      R6,0FH                ;IF Z=0, GOTO NEXT ATOM
          JZ        DATAEND
          TEST      R6,3                  ;IF Z=4, NO STROBE
          JZ        GIOCA27
          MOV       AL,R3
          MOV       R2,AL                 ;F2 = LRC
          MOV       AL,R6
          MOV       R7,AL
          CALL      STROBE                ;STROBE OUT THE LRC
          JMP       GIOCA28
GIOCA27:  CALL      DELAY5
          MOV       AL,R3
          MOV       K,AL
GIOCA28:  MOV       R0,5
          CALL      REGSAVE               ;SAVE THE LRC IN REG 5

;  DATAEND:  SAVE COUNT AND STATUS, GET NEXT COMMAND
;
;   DATA OUTPUT WITH
;           REQUEST, ECHO, OR JUST VERIFY
;

DATAEND:  CALL      DELAY5                ;DELAY 5 MICROSECONDS
          CALL      STATCNT               ;SAVE LENGTH (OF BUFFER USED)
          JMP       ATOMEND

GIOCB0:   TEST      R5,BUFPRES            ;BRANCH IF ARG 3 IS AVAILABLE
          JNZ       GIOCB60
          JMP       GIO_47                ;ERR 47 IF NO ARG3

;  GROUP A- DATA OUTPUT WITH ACKNOWLEDGE
;     B0TL, B1TL,  B4TL, B5TL   where T=0,2
;  (WR, DATAOUT/OBS, W5, CPB, IBS, CHECKT) REPEAT, LEND
;  (    DATAOUT/OBS, W5, CPB, IBS, CHECKT) REPEAT, LEND
;  (WR, DATAOUT/CBS, W5, CPB, IBS, CHECKT) REPEAT, LEND
;  (    DATAOUT/CBS, W5, CPB, IBS, CHECKT) REPEAT, LEND
;  GROUP B- DATA OUTPUT WITH ECHO
;     B2TL, B3TL, B6TL, B7TL   where T= 0,1,2,3
;  (WR, DATAOUT/OBS, W5, CPB, IBS, VERIFY, CHECKT ) ...
;  (    DATAOUT/OBS, W5, CPB, IBS, VERIFY, CHECKT ) ...
;  (WR, DATAOUT/CBS, W5, CPB, IBS, VERIFY, CHECKT ) ...
;  (    DATAOUT/CBS, W5, CPB, IBS, VERIFY, CHECKT ) ...
;  GROUP C- REQUESTED DATA OUTPUT
;  B80L    (CPB IBS        WR DATAOUT/OBS) REPEAT SAVEL
;  B90L    (CPB IBS           DATAOUT/OBS) REPEAT SAVEL
;  B82L    (CPB IBS CHECKT WR DATAOUT/OBS) REPEAT SAVEL
;  B92L    (CPB IBS CHECKT    DATAOUT/OBS) REPEAT SAVEL
;  BC0L    (CPB IBS        WR DATAOUT/CBS) REPEAT SAVEL
;  BD0L    (CPB IBS           DATAOUT/CBS) REPEAT SAVEL
;  BC2L    (CPB IBS CHECKT WR DATAOUT/CBS) REPEAT SAVEL
;  BD2L    (CPB IBS CHECKT    DATAOUT/CBS) REPEAT SAVEL
;  GROUP D- DATA VERIFY
;  BAT0   (CPB IBS VERIFY CHECKT) REPEAT  (T=8,9,A,B)

GIOCB05:  MOV       AUX0A,EDX             ;DECREMENT COUNT
          DEC       AUX0A
          TEST      R7,8                  ;SKIP IF X= 0-7
          JZ        GIOCB10
          CALL      WAITINK               ;WAIT FOR INPUT
          TEST      SH,4                  ;SKIP IF NOT ENDI
          JZ        GIOCB10
          TEST      R6,20H                ;EXIT IF ENDI SPECIFIED AS TERMINATOR
          JNZ       GIOCB41
          AND       SH,0FBH
          MOV       AX,WORD PTR FS:[CPUST];TURN OFF ENDI
GIOCB10:  MOV       EDX,AUX09
          MOV       CH,BYTE PTR [EDX]     ;GET CHAR FROM BUFFER
          MOV       AUX09,EDX
          INC       AUX09
          XOR       R3,CH                 ;CALCULATE LRC
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,0AH                ;SKIP IF BAXX
          JE        GIOCB38
          MOV       R2,CH
          CALL      STROBE
          TEST      R7,8                  ;SKIP IF X>7
          JNZ       GIOCB40
          CALL      DELAY5                ;DELAY 5 MICROSECONDS
          CALL      WAITINK
          TEST      SH,4                  ;CHECK FOR ENDI
          JZ        GIOCB36
          AND       SH,0FBH
          MOV       AX,WORD PTR FS:[CPUST];TURN OFF ENDI
          TEST      R6,20H                ;SKIP IF ENDI NOT A SPEC TERM CONDITION
          JZ        GIOCB36
          MOV       EDX,AUX09
          MOV       AUX09,EDX             ;ADJUST ADDRESS BY -1
          DEC       AUX09
GIOCB41:  MOV       EDX,AUX0A
          MOV       AUX0A,EDX             ;ADJUST COUNT, NOT TO INCLUDE ENDI
          INC       AUX0A
          OR        R4,20H                ;MARK ENDI IN STATUS BYTE
          MOV       R0,6
          CALL      REGSAVE               ;SAVE ENDI IN REG 6
          JMP       SETCC                 ;SET CC=TRUE,  ENDI

GIOCB36:  TEST      R7,2
          JZ        GIOCB40
GIOCB38:  CMP       CH,K                  ;SKIP IF GOOD ECHO
          JE        GIOCB40
          OR        R4,04H                ;TURN ON ECHO ERROR
GIOCB40:  TEST      R4,4
          JZ        GIOCB60
          TEST      R6,10H                ;SET CC=TRUE,  ECHO ERROR
          JNZ       SETCC

GIOCB60:  MOV       EDX,AUX0A
          CMP       DX,0                  ;LOOP IF COUNT>0
          JNE       GIOCB05

;   COUNT SATISFIED
;
          JMP       GIOCA26               ;LRC ENDING SAME AS AXXX

;    CXYZ - DATA INPUT

;    F7(l) = X - TYPE AND ORDER OF INPUT/OUTPUT STROBES
;    F6(h) = Y - TERMINATION CONDITION(S)
;    F6(l) = Z - LRC OPERATION
;
;     (10 BIT OF F5 IS USED TO INDICATE BUFFER FULL)
;
;   C6TL  (CPB IBS CHECKT1 SAVEDATA CHECKT2) REPEAT,LEND
;   C3TL  SAME AS C6TL, EXCEPT WAIT FOR READY BEFORE CPB
;   C7TL  SAME AS C6TL, EXCEPT DELAY 40us BEFORE CPB
;   C22L  (CPB IBS (no timeout/delay) CHECK ENDI,SAVEDATA)
;                                        REPEAT, LEND
;  GROUP B- DATA INPUT WITH REQUEST STROBE
;   C8TL-CFTL
;  GROUP C - DATA INPUT WITH ECHO
;   C0TL, C1TL, C4TL, C5TL

GIOCC0:   TEST      R5,BUFPRES            ;ERR 47 IF NO ARG3 AVAILABLE
          JZ        GIO_47
          TEST      R6,8                  ;Z>7 IS ILLEGAL COMMAND
          JNZ       ATOMERR
          MOV       AL,R7                 ;ERR IF CA,CB,CE,CF
          AND       AL,0AH
          CMP       AL,0AH
          JE        ATOMERR
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,2
          JNE       GIOCC00               ;SKIP IF NOT C2YZ
          TEST      R5,AKBDH*10H          ;SKIP IF MXD KEYBOARD
          JNZ       GIOCC00
          MOV       EDX,AUX0A             ;PC'S = COUNT
          MOV       AL,R6
          AND       AL,0F0H
          CMP       AL,20H
          JE        GIOCS20               ;FAST OPTION = C22Z
GIOCC00:  TEST      R5,BUFFULL            ;SKIP IF BUFFER FULL
          JNZ       GIOCC05
          MOV       EDX,AUX0A
          CMP       DX,0
          JNE       GIOCC06               ;IF COUNT>0, OKAY
          OR        R5,BUFFULL            ;FLAG BUFFER FULL
GIOCC05:  TEST      R6,40H                ;EXIT IF COUNT TERMINATION IS SPECIFIE
          JNZ       GIOCC86
GIOCC06:  TEST      R7,8                  ;SKIP IF X>7
          JNZ       GIOCC08
          TEST      R7,1                  ;SKIP IF 0,4, 2,6
          JZ        GIOCC07
          MOV       AL,R7
          AND       AL,0FH
          CMP       AL,3
          JNE       GIOCC065              ;SKIP IF NOT 3
          TEST      R5,AKBDH*10H          ;SKIP IF MXD KEYBOARD
          JNZ       GIOCC065
          CALL      WAITR                 ;WAIT FOR READY (BEFORE SETTING CPB) C3TL
GIOCC065: MOV       AL,R7
          AND       AL,0FH
          CMP       AL,7
          JNE       GIOCC07
          CALL      DELAY35C
          CALL      DELAY35C              ;DELAY 40 MICROSECONDS FOR C7TL
          CALL      DELAY10
GIOCC07:  CALL      WAITINK               ;WAIT FOR IBS
          TEST      SH,4                  ;SKIP IF NOT ENDI
          JZ        GIOCC10
          AND       SH,0FBH
          MOV       AX,WORD PTR FS:[CPUST];TURN OFF ENDI
          TEST      R6,20H                ;EXIT IF ENDI IS A TERM CONDITION
          JNZ       GIOCC83
GIOCC10:  TEST      R7,2                  ;SKIP IF C6YZ (OR C2YZ ?)
          JNZ       GIOCC40
GIOCC08:  TEST      R7,2                  ;SKIP IF X=0,1,4,5,8,9,C,D
          JZ        GIOCC11
          TEST      R5,AKBDH*10H          ;ERROR IF MXD (NO ECHOING ALLOWED)
          JNZ       GIO_48
          PUSH      EBX
          MOV       EBX,DWORD PTR [CPBASE]
          CMP       BYTE PTR [EBX].@GIO_FLAG,0
          JNE       AA1
          MOV       BYTE PTR FS:[CPURDY],AL  ;TURN OFF CPB (ALLOW INPUT) A,B,E,F
AA1:      POP       EBX

GIOCC11:  CALL      STROBEK
          CALL      DELAY5                ;STROBE OUT THE REQUEST/ECHO, WAIT 5
GIOCC20:  TEST      R7,8                  ;SKIP IF X<8 (WE ALREADY GOT IBS)
          JZ        GIOCC40
          TEST      R7,2                  ;SKIP IF ALREADY TURNED OFF CPB BEFORE STROBE
          JNZ       GIOCC25
          CALL      WAITINK               ;WAIT FOR STROBE
          JMP       GIOCC26
GIOCC25:  CALL      WAITIN                ;WAIT FOR IBS
GIOCC26:
          TEST      SH,4                  ;CHECK FOR ENDI BIT
          JZ        GIOCC40
          AND       SH,0FBH
          MOV       AX,WORD PTR FS:[CPUST];TURN OFF ENDI
          TEST      R6,20H                ;SKIP IF ENDI IS SPEC TERM CONDITION
          JNZ       GIOCC83
GIOCC40:  TEST      R6,10H
          JZ        GIOCC50
          MOV       R0,1
          CALL      REGLOAD               ;GET SPEC CHAR FROM REG 1
          MOV       AL,R2
          CMP       AL,K                  ;EXIT IF EQUAL TO SPECIAL CHARACTER
          JE        GIOCC80
GIOCC50:  MOV       AL,K
          XOR       R3,AL                 ;CALCULATE LRC
          MOV       EDX,AUX09
          TEST      R5,BUFFULL            ;SKIP IF BUFFER FULL
          JNZ       GIOCC55
          MOV       AL,K
          MOV       BYTE PTR [EDX],AL     ;WRITE K INTO BUFFER
          MOV       AUX09,EDX
          INC       AUX09
          JMP       GIOCC60

GIOCC55:  MOV       AUX09,EDX             ;INCREMENT BUFFER PTR(NO WRITE, BEYOND BFR)
          INC       AUX09
          OR        R4,1                  ;MARK BUFFER OVERFLOW

GIOCC60:  MOV       EDX,AUX0A
          MOV       AUX0A,EDX             ;DECREMENT COUNT
          DEC       AUX0A
          TEST      R6,0F0H               ;IF Y>0, DON'T CHECK SPEC CHAR; LOOP BACK
          JNZ       GIOCC00
          MOV       R0,1
          CALL      REGLOAD
          MOV       AL,R2
          CMP       AL,K                  ;LOOP IF NOT SPEC CHAR MATCH
          JNE       GIOCC00

;  SPECIAL CHARACTER FOUND
;

GIOCC80:  TEST      R6,60H                ;END IF SP CHAR WAS ONLY TERM CONDIT
          JZ        GIOCC90
          OR        R4,40H
          JMP       GIOCC90               ;END DATA SEQUENCE

;   EXIT BECAUSE OF ENDI
;

GIOCS40:  MOV       AUX0A,EDX             ;SAVE FINAL COUNT
          AND       SH,0FBH
;   ENDI FOUND

GIOCC83:  MOV       R0,6
          CALL      REGSAVE               ;SAVE ENDI IN REG 6
          TEST      R6,50H                ;END IF ENDI WAS ONLY TERM CONDITION
          JZ        GIOCC90
          OR        R4,20H                ;MARK ENDI TERMINATION
          JMP       GIOCC90

;   COUNT SATISFIED

GIOCC86:  TEST      R6,30H                ;SKIP IF COUNT WAS ONLY TERM SPECIFIED
          JZ        GIOCC90
          OR        R4,80H                ;FLAG COUNT SATISFIED

;     LRC END OPERATION

;   L=0   NONE
;   L=1   CALCULATE LRC OF INPUT DATA, SAVE IN REG 5
;   L=2   SAME AS 1, THEN COMPARE WITH REG 6 (ENDI). IF
;       UNEQUAL, SET THE LRC ERROR BIT (02) IN REG 8.

GIOCC90:  TEST      R6,3                  ;EXIT IF Z=0
          JZ        DATAEND
          MOV       AL,R3
          MOV       K,AL
          MOV       R0,5

;   FAST OPTION

          CALL      REGSAVE              ;SAVE LRC IN REG 5
          TEST      R6,2                 ;EXIT IF Z<>2
          JZ        DATAEND
          MOV       R0,6
          CALL      REGLOAD              ;LOAD ENDI (REG 6)
          MOV       AL,R3
          CMP       AL,R2                ;OKAY IF LRC = ENDI
          JE        DATAEND
          OR        R4,02H               ;INDICATE BAD LRC
          JMP       DATAEND

GIOCS10:  OR        R4,01H               ;MARK OVERFLOW
          XCHG      EDX,AUX09            ;RECALL COUNT
          INC       AUX09

GIOCS20:  MOV       AUX00,EDX            ;SAVE PC'S
          CALL      WAITIBSE             ;WAIT FOR IBS
GIOCS20A:;TEST      BYTE PTR FS:[CPUST],1
         ;JZ        GIOCS20A
          AND       SH,0FBH
          MOV       AL,BYTE PTR FS:[CPUST]
          OR        SH,AL
          AND       SH,0DFH
          CALL      BREAKPTG             ;CHECK IF END OF 30 MS TIMESLICE
          MOV       EDX,AUX00            ;RESTORE PC'S
          TEST      SH,4                 ;EXIT IF ENDI
          JNZ       GIOCS40
          MOV       AL,K
          XOR       R3,AL                ;CALCULATE LRC
          DEC       DX
          XCHG      EDX,AUX09            ;DECREMENT COUNT
          TEST      R5,BUFFULL           ;IF BUFFER FULL, LOOP BACK
          JNZ       GIOCS10
          MOV       AL,K
          MOV       BYTE PTR [EDX],AL    ;WRITE INTO BUFFER, INCREMENT ADDRESS
          XCHG      EDX,AUX09
          INC       AUX09
GIOCS30:  CMP       DX,0                 ;LOOP IF GREATER THAN ZERO
          JNE       GIOCS20
          OR        R5,BUFFULL           ;INDICATE BUFFER FULL
          JMP       GIOCS20              ;LOOP TILL ENDI FOUND

;  SET CONDITION CODE (CC) TO TRUE

;  EXXX COMMAND RECOGNIZED WITH CC = FALSE

SETCC:    CALL      STATUS              ;SAVE NEW STATUS CODE
          CALL      STATCNT             ;SAVE COUNT (IF ANY)
          CALL      COMMAND             ;GET NEXT MICROCOMMAND
          MOV       AL,R7
          AND       AL,0F0H
          CMP       AL,0E0H
          JE        ATOM                ;SKIP IF EXXX CODE
          CMP       AL,0D0H
          JNE       GEND                ;EXIT FROM GIO IF NEITHER DXXX NOR EXXX

;    DXXX COMMAND RECOGNIZED WITH CC = TRUE
;

GIOCE:    AND       R7,0FH              ;F7F6 = NEW COMMAND ADDRESS
          MOV       EDX,AUX0F
          CMP       EDX,0               ;SKIP IF NOT  HEX
          JNE       GIOCE2
          MOV       EDX,AUX0D
          MOV       AUX0E,EDX
          MOV       DX,WORD PTR [R6]
          JMP       GIOCE8

GIOCE2:   MOV       EDX,AUX0D
          XOR       EAX,EAX
          MOV       AX,WORD PTR [R6]
          ADD       EDX,EAX
          JC        GEND                ;EXIT IF OVERFLOW
          ADD       EDX,EAX
          JC        GEND                ;EXIT IF OVERFLOW
          MOV       AUX0E,EDX           ;NEW ARG 1 POINTER = BEGIN + TWICE THE DISPLACEMENT
          JMP       ATOM

GIOCE5:   MOV       AUX03,EDX
          DEC       AUX03
          CALL      COMMAND             ;SKIP OVER NEXT COMMAND
          MOV       EDX,AUX03
GIOCE8:   CMP       DX,0                ;LOOP TILL COUNT REACHES ZERO
          JNE       GIOCE5
          JMP       ATOM                ;CONTINUE EXECUTION AT NEW LOCATION

;  STATUS:  SAVE STATUS CODE FROM F4 INTO BYTE8 OF ARG2.
;
;   ENTRY:
;   RETURN:  ENDI IS TURNED OFF, BYTE 8 OF ARG2 IS THE
;      CURRENT STATUS.
;
;   MODIFIED REGISTERS:  PC'S

STATUS:
          MOV       AX,WORD PTR FS:[CPUST]  ;TURN OFF ENDI AND CARRY
          AND       SH,0FBH
          MOV       EDX,AUX0B
          ADD       EDX,8
          MOV       AL,R4
          MOV       BYTE PTR [EDX],AL   ;WRITE STATUS BYTE INTO REG 8
          RET

;   STATCNT:  CALCULATE ARG3 COUNT, AND STORE IN REGS 9,10
;      OF ARG 2.
;   ENTRY:  BEGIN ADDRESS OF ARG3 IS IN AUX 8, CURRENT IS
;     IN AUX 9.

STATCNT:  TEST      R5,BUFPRES          ;RETURN IF NO ARG3
          JZ        REGR
          MOV       EDX,AUX0A
          CMP       DX,0
          JNE       STATCNT2
          OR        R5,BUFFULL          ;IF COUNT IS 0, TURN ON BUFFER FULL BIT

STATCNT2: MOV       EDX,AUX09           ;CURRENT POINTER
          MOV       DWORD PTR [A2],EDX
          XCHG      EDX,AUX08           ;BEGINNING POINTER
          SUB       DWORD PTR [A2],EDX  ;CURRENT - BEGINNING = USED
          MOV       EAX,DWORD PTR [A2]
          MOV       WORD PTR [R2],AX
          MOV       EDX,AUX0B
          ADD       EDX,09H             ;PC'S POINT AT 'REG 9'
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          ADD       CX,WORD PTR [R2]    ;NEW COUNT = OLD + USED
          XCHG      CH,CL
          MOV       WORD PTR [EDX],CX
          RET

;  REGSAVE:  SAVE VALUE IN ARG 2 'REG'.
;
;   ENTRY:  K= VALUE TO BE SAVED.  F0 = REGISTER NUMBER.
;     IF F0=0, NO SAVE.  IF F0 IS TOO LARGE FOR DEFINED
;     VARIABLE, NO SAVE.
;
;   MODIFIED REGISTERS:  PC'S  (AND F4 IF F0=8)
;

REGSIND:  MOV       AL,R6               ;F0 = REG 'Z'
          AND       AL,0FH
          MOV       R0,AL
REGSAVE:  CMP       R0,0                ;IF ZERO, RETURN
          JE        REGR
          MOV       AL,R0
          AND       AL,0FH
          CMP       AL,8
          JNE       REGSAVEX
          MOV       AL,K
          MOV       R4,AL               ;IF REG 8, CHANGE OUR COPY TOO
REGSAVEX: MOV       EDX,AUX0C
          CMP       R0,DL
          JBE       REGSV
REGR:     RET                           ;RETURN IF NOT WITHIN RANGE

REGSV:    MOV       EDX,AUX0B
          XOR       EAX,EAX
          MOV       AL,R0
          ADD       EDX,EAX
          MOV       AL,K
          MOV       BYTE PTR [EDX],AL
          RET                           ;SAVE K IN SPECIFIED REGISTER, RETURN


;   REGLOAD:  LOAD SPECIFIED REGISTER INTO F2.
;
;   ENTRY:  F0 = REGISTER NUMBER.
;
;   RETURN:  F2= VALUE FROM REGISTER. F2=0 IF F0=0.
;       F2 = 0 ALSO IF F0 IS LARGER THAN SIZE OF ARG2.
;
;   MODIFIED REGISTERS:  PC'S, CHCL, F2
;
;   ALTERNATE ENTRIES:
;     LREG - LOAD IMMEDIATE OR INDIRECT REGISTER INTO F2.
;     LREGIND - LOAD INDIRECT (HIGH HALF OF F6) INTO F2.
;   REGLOADC - GET INDIRECTLY SPECIFIED REGISTER PAIR
;       INTO F3F2.
;   REGLOADB - GET SECOND REGISTER OF PAIR.

LREG:     TEST      R7,2                ;SKIP IF INDIRECT
          JNZ       LREGIND
          MOV       AL,R6
          MOV       R2,AL               ;COPY IMMEDIATE VALUE TO F2
          RET

LREGIND:  MOV       AL,R6
          SHR       AL,4
          MOV       R0,AL               ;F0 = INDIRECT REGISTER SPECIFIED
REGLOAD:  MOV       R2,0
          CMP       R0,0                ;IF ZERO, RETURN
          JE        REGR
          MOV       EDX,AUX0C
          CMP       R0,DL
          JBE       REGLOADX
          RET                           ;RETURN IF OUT OF RANGE

REGLOADX: MOV       EDX,AUX0B
          XOR       EAX,EAX
          MOV       AL,R0
          ADD       EDX,EAX
          MOV       CH,BYTE PTR [EDX]
          MOV       R2,CH               ;F2=VALUE FROM REGISTER
          RET                           ;RETURN

REGLOADC: CALL      LREGIND
REGLOADB: MOV       AL,R2               ;MOVE VALUE FROM F2 TO F3
          MOV       R3,AL
          INC       R0                  ;INCREMENT REGISTER NUMBER
          JMP       REGLOAD             ;GET SECOND REGISTER OF PAIR

;  STROBE:  STROBE  A BYTE WITH CBS/OBS
;
;  ENTRY:  LOW HALF OF F7 DETERMINE TYPE OF STROBE AS
;     FOLLOWS:
;          0,2,8,A - WR, OBS
;          1,3,9,B -     OBS
;          4,6,C,E - WR, CBS
;          5,7,D,F -     CBS
;    DATA TO BE STROBED IS IN F2.
;  ALTERNATE ENTRY:  STROBEK:  DATA IS ALREADY IN K
;      (COPIES IT TO F2 AND GOES TO STROBE)

STROBEK:  MOV       AL,K
          MOV       R2,AL
STROBE:   TEST      R5,AKBDH*10H        ;ERROR IF STROBE TO MXD KEYBOARD
          JNZ       GIO_48
          CALL      BREAKPTG            ;CHECK IF END OF 30 MS TIMESLICE
          TEST      R5,7                ;SKIP IF NO TIMEOUT OR DELAY
          JZ        STROBE60

;   FINE DELAY
;

STROBE01: TEST      R5,4
          JZ        STROBE08
          MOV       EDX,AUX04
          MOV       AL,DL
          DEC       DL
          CMP       AL,0
          JE        STROBE08
STROBE02: CALL      DELAY4C             ;DELAY 4.33 CYCLES
          CALL      BREAKPTG            ;CHECK FOR END OF 30 MS TIMESLICE
          MOV       AL,DL
          DEC       DL
          CMP       AL,0
          JNE       STROBE02

;  COARSE DELAY
;

STROBE08: TEST      R5,1
          JZ        STROBE1
          MOV       EDX,AUX05           ;GET DELAY COUNT
          MOV       WORD PTR [R0],DX
                                        ;Anita for 33M cpu
          MOV       DX,35H*4
          JMP       STROBEX
STROBE09: MOV       DX,35H*4           ;50 MICROSECONDS COUNT
STROBEX:  MOV       AX,DX
          DEC       DX
          CMP       AX,0
          JNE       STROBEX
;strobe09:
;          call      delay50us
                                        ;Anita
          CALL      BREAKPTG            ;CHECK FOR END OF 30 MS TIMESLICE
          DEC       WORD PTR [R0]       ;DECREMENT COUNT BY 1
          JNE       STROBE09            ;LOOP TILL COUNT=0000

;   TIME OUT
;

STROBE1:  TEST      R7,1                ;SKIP IF NO WAIT FOR READY
          JNZ       STROBE80
          TEST      R5,2                ;SKIP IF TIMEOUT NOT SPECIFIED
          JZ        STROBE3
          CALL      TIMEOUT             ;WAIT FOR READY, WITH TIMEOUT
STROBE3:  MOV       AL,R2
          MOV       K,AL
          TEST      R5,ADISKH*10H       ;SKIP IF DISK
          JNZ       STROBE30

          TEST      R7,4                ;SKIP IF CBS
          JNZ       STROBEY
;-------- TSAI -----------
bbb:
          CMP       TOMXF,0
          JE        STROBE4             ;BR,if not MXF controller
;         MOV       EBX,CMDBUADR
GIOOBS:
          TEST    BYTE PTR FS:[CPUST],10H ;IF 30MS. ELAPSED,SH HIGH NIBBLE
          JZ      GIOOBS1
          CALL    BREAKPTT
GIOOBS1:
;       TEST    GS:[EBX].gcpust,RB        ;device ready ?
;       JNZ     GIOOBS2                   ;BR,if yes
GIOOBS2:
;       TEST    ACTDEV,8000H              ;??????
;       JNZ     DRVRMAIN                  ;BRANCH IF PRINTER DRIVER
        CALL    GWAITRDA
        AND     GS:[EBX].gcpust,0FFH-RB   ;set device busy
        MOV     AL,K
        MOV     EBX,CMDBUADR
        MOV     GS:[EBX].gdata,AL         ;send OBS
        OR      GS:[EBX].gtype,GIO_OBS    ;tell MXF the data to be send is OBS
        CALL    DELAY10t
        CALL    DELAY50us
        RET
STROBE4:
;-------- TSAII ------

          push      eax
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        strobe4_xx
          mov       al,k
          push      eax
          call      pwaitrdy
          pop       eax
          mov       k,al
          mov       eax,dword ptr [cpbase]
          mov       eax,dword ptr [eax].@gio_addr
          push      ebx
          CALL      DELAY10X
          mov       bl,k
          mov       byte ptr gs:[eax].@g_data,bl
          pop       ebx
          mov       byte ptr gs:[eax].@g_strobe,obs_strobe
          pop       eax
          jmp       strobe4_yy
strobe4_xx:
          pop       eax
          CALL      OBSTROBE            ;SEND OBS STROBE
strobe4_yy:
          CALL      DELAY10
          RET

STROBEY:  TEST      R5,ACRTH*10H        ;ERROR IF CBS TO MXD  CRT OR LOCAL PRINTER
          JNZ       GIO_48
;-------- TSAI -------
;         CMP       CMDBUADR,0
;         JE        STROBE5
;         MOV       EBX,CMDBUADR
;  same as CBSTROBE,except to be called by GIO function
;GIOCBS:
;        TEST    BYTE PTR FS:[CPUST],10H
;        JZ      GIOCBS1
;        CALL    BREAKPTT                  ;breakpoint if 30 ms elapsed
;GIOCBS1:
;        TEST    BYTE PTR GS:[EBX].gdevrdy ;wait until i/o ready
;        JNZ     GIOCBS2
;        CALL    GWAITRDA                 ;wait UP TO 1MS. FOR READY, THEN
                                         ;break
;* DELAY SINCE PRINTER GOES READY TOO SOON! DELAY LENGTH??
;-------- TSAII -------
          push      eax
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        strobe5_xx
          mov       al,k
          push      eax
          call      pwaitrdy
          pop       eax
          mov       k,al
          mov       eax,dword ptr [cpbase]
          mov       eax,dword ptr [eax].@gio_addr
          push      ebx
          CALL      DELAY10X
          mov       bl,k
          mov       byte ptr gs:[eax].@g_data,bl
          pop       ebx
          mov       byte ptr gs:[eax].@g_strobe,cbs_strobe
          pop       eax
          jmp       strobe5_yy
strobe5_xx:
          pop       eax
          CALL      CBSTROBE            ;SEND CBS STROBE
strobe5_yy:
          CALL      DELAY10
          RET

;   DISK LOGIC
;

STROBE30: CALL      WAITR                ;WAIT FOR READY
          TEST      R7,4                 ;SKIP IF OBS
          JZ        STROBE70
STROBE31: MOV       AL,K
          call      disk_cbs
          CALL      CBSNR                ;STROBE OUT CBS
          CALL      DELAY10
          mov       k,80h
          MOV       AL,80H
          call      disk_cbs
          CALL      CBSNR                ;HOG DISK (Changed Rel 1.9 to separate
                                         ;hog strobe, rather than ORing on 80bit)
          CALL      DELAY10
          MOV       EDX,ACTDEV
          MOV       K,DL                 ;K= DISK ADDRESS
          MOV       AL,DH
          AND       AL,0FH
          CMP       AL,_PHOENIX
          JNE       STROBEZ
          AND       K,0F0H               ;IF PHOENIX, STRIP OFF PLATTER BITS
STROBEZ:  CALL      SRCHDEVA
          CMP       CH,0
          JE        GIO_48
          TEST      R2,80H               ;SKIP IF CBS OF 80-FF
          JNZ       STROBE35

;   CBS,  80 BIT OFF  (UNHOG)
;
          TEST      CL,DEVOPEN           ;EXIT IF NOT OPEN
          JZ        TIMR
          SUB       EDX,OFFSET MDEVTBL
          ADD       EDX,OFFSET MDEVTBX   ;MDEVDISP = OFFSET MDEVTBL - OFFSET MDEVTBLX
          MOV       CH,BYTE PTR [EDX]    ;READ SECONDARY FLAGS FOR DISK ENTRY
          MOV       AL,CH
          OR        AL,DHOGADR           ;TURN ON THE 'BY ADDRESS' FLAG
          MOV       BYTE PTR [EDX],AL
          RET                            ;NOTE,  ENDDISK WILL CLOSE THIS DISK

;    UNLESS ADDRESS IS HOG ADDRESS

;    CBS OF 80
;

STROBE35: MOV       AL,CL                ;OPEN DISK
          OR        AL,DEVOPEN
          MOV       BYTE PTR [EDX],AL
          SUB       EDX,OFFSET MDEVTBL
          ADD       EDX,OFFSET MDEVTBX   ;MDEVDISP = OFFSET MDEVTBL - OFFSET MDEVTBLX
          MOV       CH,BYTE PTR [EDX]    ;READ SECONDARY FLAGS FOR DISK ENTRY
          MOV       AL,CH
          AND       AL,0FFH-DHOGADR      ;TURN OFF THE 'BY ADDRESS' FLAG
          MOV       BYTE PTR [EDX],AL
          RET

;   DISK OBS
;

STROBE60: TEST      R7,1
          JNZ       STROBE01
          JMP       STROBE3

STROBE70: MOV       EDX,AUX0C
          MOV       AL,DH
          AND       AL,0F0H
          MOV       K,AL                ;RECALL HIGH PART OF IOB'S
                                        ;LATCH IOB'S  (IN CASE BREAKPOINT OCCURRED SINCE LAST)
          CALL      DELAY10
          call      disk_iob
          MOV       BYTE PTR FS:[IOBS],AL
          CALL      DELAY10

;   NO WAIT FOR READY
;

STROBE80: TEST      R5,ACRTH*10H        ;IF MXD,  ERROR 48
          JNZ       GIO_48
          MOV       AL,R2
          MOV       K,AL
          TEST      R7,4                ;SKIP IF CBS
          JNZ       STROBE85
          MOV       AL,K
          call      disk_obs
          MOV       BYTE PTR FS:[OBS],AL ;STROBE OBS
          CALL      DELAY10
          RET

STROBE85: TEST      R5,ADISKH*10H       ;SKIP IF CBS TO DISK
          JNZ       STROBE31
          MOV       AL,K
          call      disk_cbs
          MOV       BYTE PTR FS:[CBS],AL
          CALL      DELAY10
TIMR:     RET                           ;RETURN

;   CHECK READY -   SET K, BIT 08, IF SO
;

CHKRDY:   MOV       AL,SH
          MOV       K,AL
          AND       K,08H               ;SET REAL DEVICE READY/BUSY
          TEST      R5,AKBDH*10H        ;RETURN IF NOT MXD KEYBOARD
          JZ        TIMR
;-------- TSAI 10-03-91 ---------
          CMP       TOMXF,0             ;BR,if not MXF protocol
          JZ        CHKRDY_2            ;BR,IF MXD

          MOV       EBX,CMDBUADR        ;dword offset
          MOV       AL,GS:[EBX].sts_byte;get stataus of this port
          TEST      AL,01H
          MOV       AL,0
          JZ        CHKRDY_3            ;BR,if KB buf empty,and return 00
          MOV       AL,0FFH
          JMP       CHKRDY_3            ;value in key buf

;         MOV       EBX,CMDBUADR
;         MOV       AL,?amIFONKBD
;         CALL      GCBSNT              ;SEND IF ON REQUEST TO MXD
;         CALL      DELAY10
;         AND       GS:[EBX].gcpust,0FFH-ENDI    ;clear ENDI
;         AND       GS:[EBX].gcpust,0FFH-CPB     ;set CPU ready
;         CALL      GWAITRDA
;         OR        GS:[EBX].gtype,GIO_IBS
;CHKRDY_4:
;         TEST      GS:[EBX].gcpust,CPB     ;wait for IBS
;         JZ        CHKRDY_4
;         MOV       AL,BYTE PTR GS:[EBX].gdata
;         MOV       GS:[EBX].gtype,0       ;clear data type byte
;         JMP       CHKRDY_3
 CHKRDY_2:
;-------- 10-03-91,TSAI---------
          MOV       AL,?amIFONKBD
          CALL      CBSNT               ;SEND IF ON REQUEST TO MXD
          CALL      DELAY10
          MOV       BYTE PTR FS:[CPURDY],AL     ;allow input
CHKRDY_1:
          TEST      BYTE PTR FS:[CPUST],2
          JZ        CHKRDY_1            ;WAIT FOR IBS
          MOV       AL,BYTE PTR FS:[IBGET]
CHKRDY_3:           ;---TSAI
          MOV       K,AL
          INC       EDX
          CMP       K,0                 ;EXIT IF KBD BUFFER EMPTY
          JE        CHKRDYY             ;EXIT IF KBD BUFFER EMPTY
          MOV       K,08                ;SET K = 08 IF NOT EMPTY
CHKRDYY:  RET


; WAITINK:   WAIT FOR INPUT WITH TIME OUT OPTION.
;    RETURN:  DATA IS IN K.
;    MODIFIED REGISTERS:  PC'S, K, F1F0, (F5,F4)
;

WAITINK:
          TEST      R5,AKBDH*10H        ;SKIP IF MXD KEYBOARD ADDRESS
          JNZ       WAITIND
          TEST      R5,ACRTH*10H        ;ERROR IF MXD CRT
          JNZ       GIO_48
          PUSH      EBX
          MOV       EBX,DWORD PTR [CPBASE]
          CMP       BYTE PTR [EBX].@GIO_FLAG,0
          JNE       AA2
          MOV       BYTE PTR FS:[CPURDY],AL  ;TURN OFF CPB, WAIT FOR INPUT
AA2:      POP       EBX
                                        ;NOTE:    SHOULD CHECK FOR DISK EVENTUALLY
WAITIN:   TEST      R5,2                ;SKIP IF TIMEOUT
          JNZ       TIMEOUTI
          CALL      WAITIBSF            ;WAIT FOR INPUT (1 MS TIMEOUT WITH ERROR)
WAITINA: ;TEST      BYTE PTR FS:[CPUST],1
         ;JZ        WAITINA
          AND       SH,0FBH
          MOV       AL,BYTE PTR FS:[CPUST]
          OR        SH,AL
          AND       SH,0DFH
          JMP       BREAKPTG            ;CHECK FOR END OF 30 MS TIMESLICE

;  INPUT FROM MXD
;

WAITIND2: CALL      BREAKPTD            ;SAVE ALL REGS,  LR BREAKPOINT
WAITIND:  TEST      R5,2                ;TIMEOUT IS ILLEGAL FOR MXD KEYBOARD
          JNZ       GIO_48
;-------- TSAI -----
          CMP       TOMXF,0             ;BR,if IBS is not from MXF
          JZ        WAITIND_3           ;(ie,from MXD)
          MOV       EBX,CMDBUADR
          MOV       AL,?amKEYINVP
          CALL      GCBSNT                       ;SEND KEYIN COMMAND
          AND       GS:[EBX].gcpust,0FFH-ENDI    ;clear ENDI
          AND       GS:[EBX].gcpust,0FFH-CPB     ;set CPU ready
          CALL      GWAITRDA
          and       GS:[EBX].gcpust,0FFH-RB      ;set device busy
          OR        GS:[EBX].gtype,GIO_IBS
WIND_1:                                          ;MXF must set CPB to avoid
                                                 ;overrun
          TEST      GS:[EBX].gcpust,CPB          ;wait IBS,ie wait CPU busy
          JZ        WIND_1                       ;br,if not
WIND_1A:
;         MOV       GS:[EBX].gtype,0             ;clear data type byte
          AND       SH,0FBH                      ;save cpu status in sh
          MOV       AL,GS:[EBX].gcpust           ;get ENDI flag
          AND       AL,ENDI                      ;mask ENDI bit only
          OR        SH,AL

          MOV       AL,GS:[EBX].gdata             ;get IBS
          MOV       K,AL
          INC       EDX
          CMP       K,0                           ;SKIP IF NO CHARACTER IN MXD
          JE        WAITIND2

;         AND       BYTE PTR GS:[EBX+15A1H],0FBH;intbyte in MXF
                                            ;--TSAI,03-05-92
;         AND       GS:[EBX].gcpust,0FFH-ENDI    ;clear ENDI
          AND       GS:[EBX].gcpust,0FFH-CPB     ;set CPU ready
          CALL      GWAITRDA
          and       GS:[EBX].gcpust,0FFH-RB      ;set device busy
          OR        GS:[EBX].gtype,GIO_IBS
WIND_2:
          TEST      GS:[EBX].gcpust,CPB          ;wait IBS
          JZ        WIND_2                       ;
WIND_3:
;         MOV       GS:[EBX].gtype,0             ;clear data type byte
          MOV       AL,BYTE PTR GS:[EBX].gdata   ;get IBS
          MOV       K,AL
          AND       SH,0FBH
          MOV       AL,GS:[EBX].gcpust           ;get ENDI flag
          AND       AL,ENDI                      ;mask ENDI bit only
          OR        SH,AL
          JMP       BREAKPTG
WAITIND_3:
;--------- TSAII ---------------
          MOV       AL,?amKEYINVP
          CALL      CBSNT               ;SEND KEYIN COMMAND
          CALL      DELAY10
          MOV       BYTE PTR FS:[CPURDY],AL     ;allow input
WAITIND_1:
          TEST      BYTE PTR FS:[CPUST],02
          JZ        WAITIND_1                   ;WAIT FOR IBS
WAITIND_1A:
;         TEST      BYTE PTR FS:[CPUST],1
;         JZ        WAITIND_1A
          AND       SH,0FBH                     ;save cpu status in sh
          MOV       AL,BYTE PTR FS:[CPUST]
          OR        SH,AL
          AND       SH,0DFH

          MOV       AL,BYTE PTR FS:[IBGET]
          MOV       K,AL
          INC       EDX
          CMP       K,0                         ;SKIP IF NO CHARACTER IN MXD
          JE        WAITIND2
          PUSH      EBX
          MOV       EBX,DWORD PTR [CPBASE]
          CMP       BYTE PTR [EBX].@GIO_FLAG,0
          JNE       AA3
          MOV       BYTE PTR FS:[CPURDY],AL     ;allow input
AA3:      POP       EBX
WAITIND_2:
          TEST      BYTE PTR FS:[CPUST],02
          JZ        WAITIND_2                   ;WAIT FOR IBS
TIMEB:
          MOV       AL,BYTE PTR FS:[IBGET]
TIMEB2:
          MOV       K,AL
TIMEBX: ; TEST      BYTE PTR FS:[CPUST],1
        ; JZ        TIMEBX
          AND       SH,0FBH
          MOV       AL,BYTE PTR FS:[CPUST]
          OR        SH,AL
          AND       SH,0DFH
          JMP       BREAKPTG         ;CHECK FOR END OF 30 MS TIMESLICE, RETURN

;    TIMEOUT SUBROUTINE
;  TIMEOUTI - CALLED FROM WAITIN, WAIT FOR CPB
;

TIMEOUTI: MOV       EDX,AUX05
          MOV       WORD PTR [R0],DX ;F1F0 = TIMEOUT COUNT
          MOV       EDX,AUX0C        ;GET SUPER TIMEOUT FLAG
          TEST      DH,STIME         ;SKIP IF NOT SUPER TIMEOUT SPEC
          JZ        TIMI07
          CMP       R1,0             ;SKIP IF < 256 MS SPEC
          JE        TIMI02
          MOV       R0,0FFH          ;TRUNCATE TO 255 MS (WITH I92 IF REACHED)
          JMP       TIMI02
TIMI07:   CMP       R1,0
          JNE       TIMI01
          TEST      R0,0F0H
          JZ        TIMI02
          MOV       R1,0FFH         ;FLAG TIMEOUT> 15 MS
TIMI01:   MOV       R0,0FH          ;TRUNCATE TIMEOUT TO 15 MS
TIMI02:   MOV       EDX,4A0H*4
;+-
;         MOV       R0,0FFH
;+-
;-------- TSAI ------
;         JMP       TIMI06
          CMP       TOMXF,0              ;
          JE        TIMI06X               ;BR,if not MXF protocol
          MOV       EBX,CMDBUADR
TIMI09:   MOV       EDX,660H*4
TIMI10:   TEST      GS:[EBX].gcpust,CPB  ;IBS RCD, CHECK 30 MS AND
          JNE       WIND_3               ;RETURN
          DEC       EDX
          CMP       EDX,0
          JNE       TIMI10          ;LOOP FOR 1 MS
          DEC       R0              ;DECREMENT COUNT (1 MILLISECOND)
          JNZ       TIMI09          ;LOOP IF NOT ZERO
          JMP       TIME08          ;time out occurs
;------- TSAII ----------
;TIMI05:   MOV       EDX,660H           ;Anita for 33M cpu
timi05:   mov       edx,660h*4           ;Anita for 33M cpu
TIMI06:   TEST      BYTE PTR FS:[CPUST],2  ;SKIP IF IBS RCD, CHECK 30 MS AND RETURN
          JNZ       TIMEB
          TEST      BYTE PTR FS:[CPUST],2  ;SKIP IF IBS RCD, CHECK 30 MS AND RETURN
          JNZ       TIMEB
          DEC       EDX
          CMP       EDX,0
          JNE       TIMI06          ;LOOP FOR 1 MS
          DEC       R0              ;DECREMENT COUNT (1 MILLISECOND)
          JNZ       TIMI05          ;LOOP IF NOT ZERO

TIME08:                             ;--- TSAI
                                    ;DISALLOW INPUT
          OR        R4,10H          ;INDICATE TIMEOUT
          CMP       R1,0            ;IF < 15 MS, SET CC = TRUE, GET NEXT ATOM
          JE        SETCC
          JMP       ERROR92         ;TIMEOUT ERROR IF > 15 MS

;+$$$$
timi05x:  mov       edx,660h*4           ;Anita for 33M cpu
          mov       ebx,dword ptr [cpbase]
          jmp       timi06y
TIMI06X:  mov       ebx,dword ptr [cpbase]
          cmp       byte ptr [ebx].@gio_flag,0
          je        timi06
          call      disk_ibs
timi06y:
          mov       ebx,dword ptr [ebx].@gio_addr
timi06p:
          cmp       byte ptr gs:[ebx].@g_cpb,0
          jnz       timebz
          cmp       byte ptr gs:[ebx].@g_cpb,0
          jnz       timebz
          cmp       byte ptr gs:[ebx].@g_cpb,0
          jnz       timebz
          dec       edx
          jnz       timi06p         ;LOOP FOR 1 MS
          dec       r0              ;DECREMENT COUNT (1 MILLISECOND)
          jnz       timi05x         ;LOOP IF NOT ZERO

          or        r4,10h          ;INDICATE TIMEOUT
          cmp       r1,0            ;IF < 15 MS, SET CC = TRUE, GET NEXT ATOM
          je        setcc
          jmp       error92         ;TIMEOUT ERROR IF > 15 MS
timebz:
          mov       al,byte ptr gs:[ebx].@g_data
          mov       k,al
          jmp       timebx
;-$$$$


;TIMEOUTI: MOV       EDX,AUX05
;          MOV       WORD PTR [R0],DX ;F1F0 = TIMEOUT COUNT
;          MOV       EDX,AUX0C        ;GET SUPER TIMEOUT FLAG
;          TEST      DH,STIME         ;SKIP IF NOT SUPER TIMEOUT SPEC
;          JZ        TIMI07
;          CMP       R1,0             ;SKIP IF < 256 MS SPEC
;          JE        TIMI02
;          MOV       R0,0FFH          ;TRUNCATE TO 255 MS (WITH I92 IF REACHED)
;          JMP       TIMI02
;TIMI07:   CMP       R1,0
;          JNE       TIMI01
;          TEST      R0,0F0H
;          JZ        TIMI02
;          MOV       R1,0FFH         ;FLAG TIMEOUT> 15 MS
;TIMI01:   MOV       R0,0FH          ;TRUNCATE TIMEOUT TO 15 MS
;TIMI02:   MOV       EDX,4A0H
;          JMP       TIMI06
;TIMI05:   MOV       EDX,660H
;TIMI06:   TEST      BYTE PTR FS:[CPUST],2  ;SKIP IF IBS RCD, CHECK 30 MS AND RETURN
;          JNZ       TIMEB
;          TEST      BYTE PTR FS:[CPUST],2  ;SKIP IF IBS RCD, CHECK 30 MS AND RETURN
;          JNZ       TIMEB
;          DEC       EDX
;          CMP       EDX,0
;          JNE       TIMI06          ;LOOP FOR 1 MS
;          DEC       R0              ;DECREMENT COUNT (1 MILLISECOND)
;          JNZ       TIMI05          ;LOOP IF NOT ZERO
;
;                                    ;DISALLOW INPUT
;          OR        R4,10H          ;INDICATE TIMEOUT
;          CMP       R1,0            ;IF < 15 MS, SET CC = TRUE, GET NEXT ATOM
;          JE        SETCC
;          JMP       ERROR92         ;TIMEOUT ERROR IF > 15 MS

; WAIT FOR READY   MAYBE WITH TIMEOUT
;

QWAITR2:  JMP       WAITR2
WAITR:    TEST      R5,AKBDH*10H    ;SKIP IF NOT MXD KEYBOARD
          JZ        QWAITR2
          TEST      R5,2            ;ERROR 48 IF TIMEOUT AT MXD KEYBOARD
          JNZ       GIO_48
WAITR1:   CALL      CHKRDY          ;CHECK KEYBOARD READY
          TEST      K,8             ;RETURN IF KEYBOARD IS READY
          JNZ       TIMR
          CALL      BREAKPTG        ;DELAY 1 MS (CHECK FOR 30 MS TIMESLICE)
          JMP       WAITR1          ;LOOP BACK TILL KEYBOARD IS READY

WAITR2:   TEST      R5,2            ;SKIP IF TIMEOUT SPECIFIED
          JNZ       TIMEOUT
;         JMP       WAITRDYB        ;WAIT FOR READY (BREAKPOINT), THEN RETURN
          JMP       GWAITRDY        ;---- TSAI
;   TIMEOUT SUBROUTINE
; TIMEOUT  - CALLED FROM STROBE, WAIT FOR RB
;

TIMEOUT:  MOV       EDX,AUX05
          MOV       WORD PTR [R0],DX     ;F1F0 = TIMEOUT COUNT
          MOV       EDX,260H*4
;-------- TSAI ------
;         JMP       TIME06
          CMP       TOMXF,0              ;if not MXF protocol
          JE        TIME06X
          MOV       EBX,CMDBUADR
TIME09:   MOV       EDX,2F0H*4
TIME10:   TEST      GS:[EBX].gcpust,CPB   ;br,IF IBS RCD, CHECK 30 MS AND
          JNE       TIMER                    ;RETURN
          DEC       DX                                       ;  2
          CMP       DX,0                                     ;  2
          JNE       TIME10               ;LOOP FOR 1 MS      ;  7

          CALL      BREAKPTG             ;CHECK FOR END OF 30 MS TIME SLICE
          DEC       WORD PTR [R0]        ;DECREMENT COUNT (1 MILLISECOND)
          CMP       WORD PTR [R0],0
          JNE       TIME09               ;LOOP IF NOT ZERO
          OR        R4,10H               ;INDICATE TIMEOUT
          JMP       SETCC                ;SET CC = TRUE, GET NEXT ATOM
;--------- TSAII -------
;TIME05:   MOV       EDX,2F0H           ;Anita for 33M cpu
time05:   mov       edx,660h*4           ;Anita for 33M cpu
TIME06:   TEST      BYTE PTR FS:[CPUST],8;RETURN IF READY    ;  5
          JNZ       TIMER                                    ;  3
          TEST      BYTE PTR FS:[CPUST],8;RETURN IF READY    ;  5
          JNZ       TIMER                                    ;  3
          DEC       DX                                       ;  2
          CMP       DX,0                                     ;  2
          JNE       TIME06               ;LOOP FOR 1 MS      ;  7

          CALL      BREAKPTG             ;CHECK FOR END OF 30 MS TIME SLICE
          DEC       WORD PTR [R0]        ;DECREMENT COUNT (1 MILLISECOND)
          CMP       WORD PTR [R0],0
          JNE       TIME05               ;LOOP IF NOT ZERO
          OR        R4,10H               ;INDICATE TIMEOUT
          JMP       SETCC                ;SET CC = TRUE, GET NEXT ATOM

;+$$$$
time05x:  mov       edx,660h*4
time06x:  mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        time06
          mov       eax,dword ptr [eax].@gio_addr
time06y:
          cmp       byte ptr gs:[eax].@g_rb,0
          je        timer
          dec       dx
          jnz       time06y

          call      breakptg             ;CHECK FOR END OF 30 MS TIME SLICE
          dec       word ptr [r0]        ;DECREMENT COUNT (1 MILLISECOND)
          jnz       time05x              ;LOOP IF NOT ZERO
          or        r4,10h               ;INDICATE TIMEOUT
          jmp       setcc                ;SET CC = TRUE, GET NEXT ATOM

;  NOTE,  THESE COULD BE CLEANED UP TO SAVE A FEW INSTRUCTIONS
; ////////////////////////////////////////////////////////////
;   DELAYS
;

DELAY35C: CALL      DELAY10     ;DELAY 35.33 CYCLES (20 US)
          JMP       DELAY10

DELAY17C: JMP       DELAY10     ;DELAY 16.67 CYCLES (10 US)

DELAY5C:  JMP       DELAY5      ;DELAY 5.33 CYCLES
DELAY4C:  JMP       DELAY5      ;DELAY 4.33  CYCLES
TIMER:    RET                   ;RETURN INSTRUCTION

;     COMMAND
; ENTRY: 80 BIT OF F5 INDICATES WHETHER ARG1 IS HEX.
;    AUX E POINTS AT THE NEXT COMMAND, AND (IF NOT HEX)
;    AUX F CONTAINS END+1 ADDRESS.
;
; RETURN:  AUX E,F HAVE BEEN UPDATED.  F7F6 CONTAIN NEW
;    COMMAND.
; MODIFIED REGISTERS:  PC'S, CHCL, F1F0, F7F6, AUX E,F


COMMAND:
          MOV       AX,WORD PTR FS:[CPUST]   ;TURN OFF ENDI
          AND       SH,0FBH
          MOV       EDX,AUX0F
          CMP       EDX,0                    ;SKIP IF NOT HEX ARG 1
          JNE       COMM7

;  ARG 1 IS HEX
;

COMM4:    CALL      COM8                     ;SWAP TEXT POINTER WITH HEX POINTER
          MOV       CH,BYTE PTR [TEXTPTR]    ;GET NEXT (NONBLANK) CHARACTER
          INC       TEXTPTR
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,20H
          JE        COMM5                    ;SKIP IF COMMA OR RIGHT PAREN
          DEC       TEXTPTR                  ;RESTORE TEXPTR TO THE CHARACTER
          CALL      HEXPAIR
          MOV       AL,R0
          MOV       R7,AL                    ;F7 = HIGH ORDER BYTE OF COMMAND
          CALL      HEXPAIR
          MOV       AL,R0
          MOV       R6,AL                    ;F6 = LOW ORDER BYTE OF COMMAND
COM8:     MOV       EDX,AUX0E
          XCHG      EDX,TEXTPTR
          MOV       AUX0E,EDX                ;SWAP TEXT POINTER WITH HEX POINTER
          RET

COMM5:    CALL      COM8                     ;SWITCH TEXTPOINTER WITH HEX POINTER
QCOMM5:   JMP       GEND                     ;NORMAL TERMINATION OF THE GIO STATEMENT

;  ARG1 IS ALPHA
;

COMM7:    DEC       EDX
          MOV       DWORD PTR [A6],EDX
          MOV       EDX,AUX0E
          CMP       DWORD PTR [A6],EDX
          JBE       QCOMM5                ;IF AT END OF ARG1, EXIT
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          MOV       R7,CH                 ;F7 = HIGH BYTE OF COMMAND
          MOV       CH,BYTE PTR [EDX]
          INC       EDX
          MOV       R6,CH                 ;F6 = LOW BYTE OF COMMAND
          MOV       AUX0E,EDX             ;SAVE INCREMENTED ADDRESS
          RET                             ;RETURN

;+ANDY
DELAY10T:
          CALL      DELAY10
          CALL      DELAY10
          CALL      DELAY10
          CALL      DELAY10
          CALL      DELAY10
delay50us:                                      ;Anita for 33M cpu
          CALL      DELAY10
          CALL      DELAY10
          CALL      DELAY10
          CALL      DELAY10
          CALL      DELAY10
          RET
;-ANDY

;-------- TSAI --------
;************* WAITRDYB version of GIO ***********
;
GWAITRDY:
        CMP     TOMXF,0                 ;BR,if not MXF protocol
        JNE     GWAITRDA                ;

;+$$$$
        JMP     DWAITRDY                ;BR to original routine if not MXF
;-$$$$

GWAITRDA:
        MOV     EBX,CMDBUADR
GWAITB3:
        MOV     EAX,03E8H               ;1 MS
GWAITB2:
        TEST    GS:[EBX].gcpust,RB      ;wait until device ready
        JNZ     GWAITY2                 ;skip if ready
        DEC     EAX
        JNZ     GWAITB2
        CALL    BREAKPTC                ;break til device ready
        MOV     EBX,CMDBUADR
        JMP     GWAITB3
GWAITY2:
        RET

;+$$$$
dwaitrdy:
        mov     eax,dword ptr cpbase
        cmp     byte ptr [eax].@gio_flag,0
        je      waitrdyb
        mov     eax,dword ptr [eax].@gio_addr
        mov     ebx,03e8h
dwaitrdy2:
        cmp     byte ptr gs:[eax].@g_rb,0
        je      dwaitrdy1
        dec     ebx
        jnz     dwaitrdy2
        movzx   ebx,part_
        shl     ebx,2
        add     ebx,offset part_addr
        mov     dword ptr [ebx],eax
        call    breakpta
dwaitrdy1:
        ret
;-$$$$

pwaitrdy:
        mov     eax,dword ptr cpbase
;       cmp     byte ptr [eax].@gio_flag,0
;       je      waitrdyb
        mov     eax,dword ptr [eax].@gio_addr
        mov     ebx,03e8h
pwaitrdy2:
        cmp     byte ptr gs:[eax].@g_rb,0
        je      pwaitrdy1
        dec     ebx
        jnz     pwaitrdy2
        movzx   ebx,part_
        shl     ebx,2
        add     ebx,offset part_addr
        mov     dword ptr [ebx],eax
        call    breakpta
pwaitrdy1:
        ret


;**********************************************
;*  TIMEOUT -- 1MS. WITHOUT READY
;       MOV     EAX,ACTDEV
;       CMP     AH,TCDEV
;       JZ      WAITRDB6                ;branch if TC
;
;       MOV     BL,AL
;       AND     BL,38H
;       JNZ     GWAIT5
;       AND     AL,0FH
;       CMP     AL,7
;       JE      GWAIT3                  ;skip if crt (07,47,87,c7)
;       CMP     AL,4
;       JE      GWAIT4                  ;skip if local printer (04,44,84,c4)
;
;GWAIT5:
;       CALL    BREAKPTA                ;waiting for i/o, save all regs
;       JMP     GWAITRDA
;
;GWAIT3:
;
;       PUSH    EDX
;       CALL    ENBLCNTM                ;enable control address of MXD

;       MOV     EDX,ACTDEV
;       MOV     DH,K
;       MOV     K,DL
;       AND     K,0F8H
;       OR      K,@MXDCADR      ;K = CONTROL ADDRESS
;
;       MOV     AL,K            ;ENABLE ADDRESS
;       OR      AL,10H          ;notify  MXF that this is a GIO command
;       MOV     BYTE PTR GS:[EBX].gabs,AL
;       MOV     ACTIOBS,EAX     ;ACTBIOS = ENABLED DEVICE ADDRESS
;
;       MOV     AL,?AMCRTREQ            ;0DH
;       CALL    GCBSNT                  ;crt buffer empty request
;
;       MOV     K,DH                    ;restore K
;       POP     EDX
;       CALL    BREAKPTC                ;waiting for crt buffer empty, save all
;       JMP     GWAITRDA

;GWAIT4:
;       PUSH    EDX
;       AND     AUX1A,0FFFF7FFFH
;       CALL    ENBLCNTM                ;enable control address of MXD
;       MOV     EDX,ACTDEV
;       MOV     DH,K
;       MOV     K,DL
;       AND     K,0F8H
;       OR      K,@MXDCADR      ;K = CONTROL ADDRESS
;
;       MOV     AL,K            ;ENABLE ADDRESS
;       OR      AL,10H          ;notify MXF that this is a GIO command
;       MOV     BYTE PTR GS:[EBX],gabs,AL
;       MOV     ACTIOBS,EAX     ;ACTBIOS = ENABLED DEVICE ADDRESS
;
;       MOV     AL,?AMPRTREQ
;       CALL    GCBSNT                   ;printer buffer empty request

;       MOV     K,DH                    ;restore K
;       POP     EDX
;       CALL    BREAKPTB                ;waiting for printer buffer empty, save


;       PUSH    WORD PTR [R0]           ;SAVE F1F0
;       MOV     WORD PTR [TEMPSAVE],CX  ;SAVE CX
;       MOV     CH,BYTE PTR [PDFLAG]    ;GET PRINTER DRIVER FLAG
;       TEST    CH,0FH
;       JZ      GWAIT2                  ;PRINTER DRIVERS NOT USED BYPASS LOGIC
;       CALL    SDRVRDE1                ;PUTTING TABLE # IN F1
;
;GWAIT2:
;       MOV     CX,WORD PTR [TEMPSAVE]  ;RESTORE CHCL
;       POP     WORD PTR [R0]           ;RESTORE F1F0
;       JMP     GWAITRDA                ;LOOP BACK AND WAIT AGAIN FOR READY

;****************************
;   CBSNT   version for GIO
;****************************
GCBSNT:
        MOV     EBX,CMDBUADR
        PUSH    ECX
        MOV     ECX,20H
        LOOP    $
        POP     ECX
        TEST    BYTE PTR GS:[EBX].gcpust,RB ;WAIT UNTIL DEVICE READY (NO
        JZ      GCBSNT                      ;TIME OUT)
        AND     GS:[EBX].gcpust,0FFH-RB     ;set device busy
        MOV     BYTE PTR GS:[EBX].gdata,AL
        OR      GS:[EBX].gtype,GIO_CBS      ;tell MXF this is a CBS
        RET
;------ TSAII ------

;------ TSAI --------
;*************************************************************************
;    this procedure enable the MXF into GIO mode
;    the GIO commands talk with the old hardware bus directly,but there
;    are no such hardware signals(ex,ABS,CBS,IBS,OBS..) in MXF,so MXF
;    must simulate these signal.When MXF is in GIO mode,it is huged
;    by the partition that enables it,MXF cannot service other partitions
;    which attach to the other ports of this MXF controller.
;*************************************************************************
ENMXFGIO:
          MOV       EAX,ACTDEV              ;device address
          AND       AL,0FH                  ;
          CMP       R1,20H                  ;keyboard ?(call ENBLDEVG will
          JNE       GIOD                    ;return R1 value)
          MOV       AL,06H                  ;if device is KB change adr to 06
GIOD:
          OR        AL,10H                  ;notify MXF this is a GIO command

PUBLIC    ENMXFGIOA
ENMXFGIOA:                                  ;called by M32.ASM
;         MOV       MXFGIO,AL
;         MOV       EBX,CMDBUADR           ;
GIOE:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        GIOE
          PUSH      AX
          CALL      WAITCMD
          POP       AX

          MOV       GS:[EBX].gtype,0        ;clear type of signal byte
          MOV       GS:[EBX].gcpust,CPB     ;set CPU busy,device busy
          MOV       GS:[EBX].cmd_abs,AL         ;put ABS in command mem
          MOV       GS:[EBX].gdata,AL       ;
          MOV       GS:[EBX].cmd_sts,0FH   ;start command

          MOV       AL,GS:[EBX].cmd_abs
          MOVZX     EBX,PART_
          MOV       [EBX+OFFSET MXFGIOTBL],AL  ;save current ABS doing GIO
                                               ;in table
          RET
;-------- TSAII -------

;---------TSAI --------
;*************************************************************************
;    this procedure disable the GIO mode of MXF.it is called when GIO
;    command is completed or the partition which enables the MXF GIO
;    mode is doing a BREAKPOINT check,if not doing so
;    the other partitions which attached to the other ports
;    of this MXF controller will not  gain service from MXF,and the
;    status of partitions(ex,SHIFT RESET,line request complete) cannot be
;    updated
;*************************************************************************
;+$$$$
public    enable_disk
public    enable_printer

enable_disk:
          push      eax
          push      ebx
          movzx     eax,k
          shr       eax,2
          add       eax,offset disk_addr
          cmp       dword ptr [eax],0
          je        enable_ret

          mov       eax,dword ptr [eax]
          movzx     ebx,part_
          shl       ebx,2
          add       ebx,offset command_addr
          add       eax,dword ptr [ebx]
enable_disk_y:
;          cmp       byte ptr gs:[eax].@g_rb,0
;          jne       enable_disk_y
          mov       byte ptr gs:[eax].@g_code,0fh
          mov       byte ptr gs:[eax].@g_error,0
          mov       bl,k
          mov       byte ptr gs:[eax].@g_abs,bl
          mov       byte ptr gs:[eax].@g_rcb,80h

          mov       ebx,dword ptr [cpbase]
          mov       byte ptr [ebx].@gio_flag,1
          mov       dword ptr [ebx].@gio_addr,eax
          pop       ebx
          pop       eax
          ret

enable_printer:
          push      eax
          push      ebx
          movzx     eax,k
          sub       eax,15h
          shl       eax,2
          add       eax,offset print_addr
          cmp       dword ptr [eax],0
          je        enable_ret

          mov       eax,dword ptr [eax]
          and       eax,0ffff0000h
          movzx     ebx,part_
          shl       ebx,2
          add       ebx,offset command_addr
          add       eax,dword ptr [ebx]

          mov       byte ptr gs:[eax].@g_code,0fh
          mov       byte ptr gs:[eax].@g_error,0
          mov       bl,k
          mov       byte ptr gs:[eax].@g_abs,bl
          mov       byte ptr gs:[eax].@g_rcb,80h

          mov       ebx,dword ptr [cpbase]
          mov       byte ptr [ebx].@gio_flag,1
          mov       dword ptr [ebx].@gio_addr,eax
enable_ret:
          pop       ebx
          pop       eax
          ret

public    disable_disk

disable_disk:
          push      eax
          push      ebx
          mov       eax,dword ptr [cpbase]
          cmp       eax,0
          je        disable_disk_ret
          cmp       byte ptr [eax].@gio_flag,0
          je        disable_disk_ret
          mov       eax,dword ptr [eax].@gio_addr
          mov       byte ptr gs:[eax].@g_rb,1

;          mov       ebx,03e8h
;disable_disk_3:
;          cmp       byte ptr gs:[eax].@g_rb,0
;          je        disable_disk_2
;          dec       ebx
;          jnz       disable_disk_3
;          movzx     ebx,part_
;          shl       ebx,2
;          add       ebx,offset part_addr
;          mov       dword ptr [ebx],eax
;          push      eax
;          call      breakpta
;          pop       eax
disable_disk_2:
          mov       byte ptr gs:[eax].@g_strobe,disable_s
          mov       eax,dword ptr [cpbase]
          mov       byte ptr [eax].@gio_flag,0
          mov       dword ptr [eax].@gio_addr,0
          call      delay10x
disable_disk_ret:
          pop       ebx
          pop       eax
          ret

public    disk_obs
public    disk_iob
public    disk_cbs
public    disk_ibs

disk_obs:
          push      eax
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        disk_strobe_end
          mov       eax,dword ptr [eax].@gio_addr
          push      ebx
          CALL      DELAY10X
          mov       bl,k
          mov       byte ptr gs:[eax].@g_data,bl
          pop       ebx
          mov       byte ptr gs:[eax].@g_strobe,obs_strobe
          pop       eax
          ret
disk_cbs:
          push      eax
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        disk_strobe_end
          mov       eax,dword ptr [eax].@gio_addr
          push      ebx
          CALL      DELAY10X
          mov       bl,k
          mov       byte ptr gs:[eax].@g_data,bl
          pop       ebx
          mov       byte ptr gs:[eax].@g_strobe,cbs_strobe
          pop       eax
          ret
disk_ibs:
          push      eax
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        disk_strobe_end
          CALL      DELAY10X
          mov       eax,dword ptr [eax].@gio_addr
disk_ibs_x:
          cmp       byte ptr gs:[eax].@g_rb,0
          jne       disk_ibs_x
          mov       byte ptr gs:[eax].@g_cpb,0
          mov       byte ptr gs:[eax].@g_strobe,ibs_strobe
          pop       eax
          ret
disk_iob:
          push      eax
          mov       eax,dword ptr [cpbase]
          cmp       byte ptr [eax].@gio_flag,0
          je        disk_strobe_end
          mov       eax,dword ptr [eax].@gio_addr
          push      ebx
          CALL      DELAY10X
          mov       bl,k
          mov       byte ptr gs:[eax].@g_data,bl
          pop       ebx
          mov       byte ptr gs:[eax].@g_strobe,iob_strobe
          pop       eax
          ret
disk_strobe_end:
          pop       eax
          ret

public    delay10x
DELAY10X:
        CALL    DELAY5X
DELAY5X:
        CALL    DELAY2?PD6X
DELAY2?PD6X:                     ;DELAY 2.6 USEC
        CALL    DELAY1X
DELAY1X:
                                ;Anita Lin for 33M cpu
        push    ecx
        mov     ecx,250H
delay1_lopX:
        push    eax
        pop     eax
        dec     ecx
        jnz     delay1_lopX
        pop     ecx
;       push    ecx
;       mov     ecx,25
;delay1_lop:
;       loop    delay1_lop
;       pop     ecx
        RET


;-$$$$
CODE      ENDS
          END
