;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M43
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST


;*COMMAND EQUATES:
?AMREAD    EQU       00H      ; READ SECTOR
?AMEXTEND  EQU       20H      ; EXTENDED COMMAND (NEXT BYTE HAS COMMAND CODE)
?AMEXTENDH EQU       2H       ; (HIGH 4BITS)
?AMWRITE   EQU       40H      ; WRITE SECTOR
?AMCOMPARE EQU       80H      ; COMPARE SECTOR

?AMCOPY    EQU       01H      ; COPY SECTORS
?AMVERIFY  EQU       12H      ; VERIFY SECTORS
?AMMSWRTB  EQU       10H      ; BEGIN OF MULTI-SECTOR WRITE
?AMMSWRTE  EQU       11H      ; END OF MULTI-SECTOR WRITE
?AMFORMAT  EQU       02H      ; FORMAT PLATTER
?AMSTATUS  EQU       16H      ; DEVICE STATUS

PUBLIC       COPY
PUBLIC       $COPY
PUBLIC       FORMATD
PUBLIC       LIMITS
PUBLIC       MOVE
PUBLIC       SETDEVLD
PUBLIC       VERIFY
PUBLIC       VERIFYE
PUBLIC       DREAD4S
PUBLIC       DWRITENS

EXTRN  part_            :byte
EXTRN  plat             :byte
EXTRN  rqstdev          :byte
EXTRN  rqstplat         :byte
EXTRN  finddev          :NEAR
EXTRN  devspec          :NEAR
EXTRN  breakptw         :NEAR
EXTRN  wrthex           :NEAR
EXTRN  wakeupp          :NEAR

EXTRN  @@VSEND          :NEAR
EXTRN  ADDIFILE         :NEAR
EXTRN  AKN              :NEAR
EXTRN  AKN1             :NEAR
EXTRN  AKNBPT           :NEAR
EXTRN  CCNL             :NEAR
EXTRN  AVARD            :NEAR
EXTRN  CATEND           :NEAR
EXTRN  CCL              :NEAR
EXTRN  CCLTO            :NEAR
EXTRN  CMNDINIT         :NEAR
EXTRN  CPBASE           :DWORD
EXTRN  CURENDR          :NEAR
EXTRN  DISKADRD         :NEAR
EXTRN  DISKCMDA         :NEAR
EXTRN  DISKCMDC         :NEAR
EXTRN  DISKCMND         :NEAR
EXTRN  DISKSEL          :NEAR
EXTRN  DISKSELC         :NEAR
EXTRN  DISKSELCC        :NEAR
EXTRN  DREAD            :NEAR
EXTRN  DREADS0          :NEAR
EXTRN  DREADSF          :NEAR
EXTRN  DWRITE           :NEAR
EXTRN  DWRITE?DAF       :NEAR
EXTRN  ENBLCO           :NEAR
EXTRN  ENBLDEVD         :NEAR
EXTRN  ENDDISK          :NEAR
EXTRN  ENDDISKR         :NEAR
EXTRN  FREEDISK         :NEAR
EXTRN  ENDSDISK         :NEAR
EXTRN  ENDSTMT          :NEAR
EXTRN  ERROR            :NEAR
EXTRN  ERROR_02         :NEAR
EXTRN  ERROR_10         :NEAR
EXTRN  ERROR_11         :NEAR
EXTRN  ERROR_12         :NEAR
EXTRN  ERROR_13         :NEAR
EXTRN  ERROR_19         :NEAR
EXTRN  ERROR_29         :NEAR
EXTRN  ERROR_32         :NEAR
EXTRN  ERROR_34         :NEAR
EXTRN  ERROR_57         :NEAR
EXTRN  ERROR_81         :NEAR
EXTRN  ERROR_82         :NEAR
EXTRN  ERROR_83         :NEAR
EXTRN  ERROR_85         :NEAR
EXTRN  ERROR_86         :NEAR
EXTRN  ERROR_93         :NEAR
EXTRN  ERROR_94         :NEAR
EXTRN  ERR_34B          :NEAR
EXTRN  ERR_92           :NEAR
EXTRN  EXPR             :NEAR
EXTRN  FILELOCS         :NEAR
EXTRN  FILENAME         :NEAR
EXTRN  FILE_A           :NEAR
EXTRN  FILE_E           :NEAR
EXTRN  FINDNAMH         :NEAR
EXTRN  FLTBIN           :NEAR
EXTRN  FLTBIN_H1        :NEAR
EXTRN  FLTBIN_H2        :NEAR
EXTRN  FLTBINA          :NEAR
EXTRN  FLTBINB          :NEAR
EXTRN  FRMTDRAM         :NEAR
EXTRN  GETFLPTR         :NEAR
EXTRN  GTFLPTRS         :NEAR
EXTRN  HPION            :NEAR
EXTRN  INTINDX          :NEAR
EXTRN  IOBUFTXT         :NEAR
EXTRN  MSWRTBEG         :NEAR
EXTRN  MSWRTEND         :NEAR
EXTRN  NEWEOF           :NEAR
EXTRN  NEWNAMEF         :NEAR
EXTRN  NXTCHEOS         :NEAR
EXTRN  OBSDISK          :NEAR
EXTRN  PLATTER          :NEAR
EXTRN  PRNTCR           :NEAR
EXTRN  RAWOFF           :NEAR
EXTRN  RAWON            :NEAR
EXTRN  RECEV            :NEAR
EXTRN  RECEVPC          :NEAR
EXTRN  RHASHFLG         :NEAR
EXTRN  TWRITESP         :NEAR
EXTRN  VARR             :NEAR
EXTRN  VRFYMSG          :BYTE
EXTRN  WAITIBS          :NEAR
EXTRN  WRTSTRCM         :NEAR
EXTRN  WRTVALA          :NEAR
EXTRN  $DWRTVAL32       :NEAR
extrn  srchdev          :near
extrn  wakeupa          :near
extrn  enblnlldh        :near
extrn  breakptt         :near
extrn  cbsnr            :near
extrn  stack_buffer     :near
extrn  _repeat          :near

extrn  error_16         :near
extrn  enter1           :near
extrn  enterf           :near
extrn  procst           :near
extrn  @@osend          :dword
extrn  r_buffer         :near
extrn  breakptg         :near
extrn  _scsilst         :near
extrn  _scsiclst        :near
extrn  _scsitlst        :near
extrn  ccjb             :near

; -------------- 22c11-2 ------------------
extrn  disk_addr        :near
extrn  buffer_addr      :near
extrn  command_addr     :near
extrn  part_addr        :near
extrn  print_addr       :near
extrn  new_error        :near
extrn  breakpta         :near
extrn  traced_new       :near
extrn  devaddr          :near
extrn  B_ABS            :BYTE
; ------------- 22c11-2 -------------------

;         MODULE    MOD-43 DISK (MISC.STMTS.)
;         TITLE     DISK (MISC.STMT.)
;*     *****************************
;*     *                           *
;*     *  MOD43: MISC. DISK STMTS  *
;*     *                           *
;*     *****************************
;*
;*     LIMITS: PROCESS A 'LIMITS' STATEMENT
;*
;*          STMT FORMAT:
;*
;*            1. LIMITS platter [file#,] s,e,c
;*
;*          2. LIMITS platter [file#,] filename, s,e,u[,t]
;*
;*               where: s,e,c,u,t = numeric variables
;*                      s = start address
;*                      e = end address
;*                      c = current address
;*                      u = no. of sectors used
;*                      t = file status
;*                          2 if data file
;*                          1 if program
;*                          0 if file not found
;*                         -1 if scratched program
;*                         -2 if scratched data file
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'LIMITS'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXA-F
;*

LIMITS:
        CALL    PLATTER         ;PROCESS PLATTER SPEC.
        CALL    FILE_A          ;LOOK FOR FILE#
        TEST    R0,0FH
        JNZ     BP43_01         ;BRANCH IF NF
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ERROR_13        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
BP43_01:
        CALL    FILENAME        ;LOOK FOR A FILENAME
        TEST    R0,0FH
        JZ      LIMITS1         ;BR IF FOUND

;*     LIMITS FROM DEVICE TABLE (FORM 1.)

        CALL    GETFLPTR        ;GET START,END AND CURRENT SECTOR ADDRESS FROM DEV. TABLE
        CALL    LMTSVLST        ;PROCESS VARIABLE LIST
        JMP     ENDSTMT

;*     LIMITS FROM DISK PLATTER (FORM 2.)

LIMITS1:
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ERROR_13        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        TEST    SL,2
        JZ      LIMITS2         ;BR IF NOT EXECUTION PHASE
        CALL    FILE_E          ;ENABLE DISK
        CALL    FINDNAMH        ;FIND FILE NAME IN INDEX
        TEST    R3,10H          ;F3 = 00,01 ---- NF
        JZ      LIMITS3         ;     10,11 ----  F     BR IF NOT FOUND
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     EAX,AUX0F
        MOV     DWORD PTR [EDX].@HASH_SEC,EAX
        MOV     EDX,AUX0C       ; AUX0C = ADDRESS OF I/O BUFFER OF ENTRY WITH FILENAME
        MOV     CL,[EDX+1]      ; READ FILE TYPE/STATUS
        ADD     AUX0C,2
        MOV     AH,R3           ; R3 = 11,FILE SCRATCH
        AND     AH,1            ; AH=0 IF NOT SCRATCH,1 IF SCRATCH
        MOV     AL,1
        mov     bl,cl
        and     bl,0f0h
        CMP     BL,80H          ; 80 -- PROGRAM, 10 -- DATA
        JZ      BP43_02

;
; cs-386 format
;
        cmp     bl,40h
        jz      bp43_02

        MOV     AL,2            ; AL=1 IF PROGRAM,2 IF DATA FILE
BP43_02:
        MOV     AUX0A,EAX       ;AUX0A ---- FILE TYPE/STATUS INFORMATION
        CALL    GTFLPTRS        ;AUXB=SOF ADDRESS; AUX0D =EOF ADDRESS
        MOV     EDX,AUX0D
        MOV     AUX0F,EDX       ;AUX0F =EOF ADDRESS
        CALL    DREADSF         ;READ EOF SECTOR
        MOV     EAX,DWORD PTR [CPBASE]
        LEA     EDX,[EAX].@IOBUFFR
        CMP     BYTE PTR [EAX].@HASHFL,02H
        JE      LIMITS_X
        XOR     ECX,ECX
        MOV     CH,[EDX+1]
        MOV     CL,[EDX+2]
        JMP     LIMITS_Y
LIMITS_X:
        MOVZX   ECX,BYTE PTR [EDX+3]
        SHL     ECX,16
        MOV     CH,BYTE PTR [EDX+1]
        MOV     CL,BYTE PTR [EDX+2]
LIMITS_Y:
        MOV     AUX0F,ECX       ;AUX0F --- NO. SECTOR USED
LIMITS2:
        CALL    LMTSVLST        ;PROCESS VARIABLE LIST

        CMP     BYTE PTR [TEXTPTR],','
        JNE     LIMITS5         ;BRANCH IF COMMA NF
        INC     TEXTPTR
        CALL    VARR            ;LOOK FOR NUMERIC RECEIVER VARIABLE
        TEST    SL,2
        JZ      LIMITS4
;       CALL    PUSH0V8         ; FLOATING POINT ZERO ==> VS
        MOV     EAX,VSPTR
        MOV     DWORD PTR [EAX-8],0
        MOV     DWORD PTR [EAX-4],0
        SUB     VSPTR,8

        CMP     EAX,DWORD PTR [@@VSEND]
        JB      ERROR_02
                                        ;****  SET FLOATING POINTS NUMBER ( SIGN & VALUE)
        MOV     EBX,AUX0A               ;--------------------------------------------
        MOV     EDX,VSPTR               ;| EXP      |   ML    |           |   MM    |
        CMP     BH,01H                  ;--------------------------------------------
        JNZ     BP43_03                 ;0        15 16     31 32       47 48      63
        NEG     BL                      ;  +1 = 0000 0000 0000 0000
        MOV     BYTE PTR [EDX+3],0FFH   ;  -1 = 0000 FFFF FFFF FFFF
        MOV     DWORD PTR [EDX+4],0FFFFFFFFH
BP43_03:
        MOV     [EDX+2],BL
        CALL    RECEV
LIMITS4:

        CMP     BYTE PTR [TEXTPTR],','
        JNE     LIMITS4Y        ;BRANCH IF COMMA NF
        INC     TEXTPTR
        CALL    VARR            ;LOOK FOR NUMERIC RECEIVER VARIABLE
        TEST    SL,2
        JZ      LIMITS4X
;       CALL    PUSH0V8         ; FLOATING POINT ZERO ==> VS
        MOV     EAX,VSPTR
        mov     edx,dword ptr [cpbase]
        MOV     EDX,DWORD PTR [EDX].@HASH_SEC
        MOV     WORD PTR [EAX-8],0
        MOV     DWORD PTR [EAX-6],EDX
        MOV     WORD PTR [EAX-2],0
        SUB     VSPTR,8

        CMP     EAX,DWORD PTR [@@VSEND]
        JB      ERROR_02

        CALL    RECEV
LIMITS4X:

        CMP     BYTE PTR [TEXTPTR],','
        JNE     LIMITS4Y        ;BRANCH IF COMMA NF
        INC     TEXTPTR
        CALL    VARR            ;LOOK FOR NUMERIC RECEIVER VARIABLE
        TEST    SL,2
        JZ      LIMITS4Y
;       CALL    PUSH0V8         ; FLOATING POINT ZERO ==> VS
        MOV     EAX,VSPTR
        mov     edx,dword ptr [cpbase]
        MOVZX   EDX,BYTE PTR [EDX].@HASHFL
        MOV     WORD PTR [EAX-8],0
        MOV     DWORD PTR [EAX-6],EDX
        MOV     WORD PTR [EAX-2],0
        SUB     VSPTR,8

        CMP     EAX,DWORD PTR [@@VSEND]
        JB      ERROR_02

        CALL    RECEV
LIMITS4Y:

        JMP     ENDSDISK
LIMITS3:
        MOV     EDX,0
        MOV     AUX0A,EDX       ; FLAG = FILE NOT FOUND
        MOV     AUX0B,EDX       ; SOF ADDRESS
        MOV     AUX0D,EDX       ; EOF ADDRESS
        MOV     AUX0F,EDX       ; NO. OF SECTOR USED =0
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     DWORD PTR [EDX].@HASH_SEC,0
        JMP     LIMITS2
LIMITS5:
        TEST    SL,2
        JZ      LIMITS4Y
        MOV     EDX,AUX0A
        CMP     EDX,0            ;BR IF FILE FOUND
        JA      LIMITS4Y
        JMP     ERROR_82

;         TITLE     LMTSVLST
;*     LMTSVLST: PROCESS LIMITS VARIABLE LIST (START, END,
;*               CURRENT OR USED RECEIVER VARIABLES)
;*
;*          LIST FORMAT: s,e,c (or u)
;*
;*               where: s,e,c,u = numeric variables
;*                      s = start address
;*                      e = end address
;*                      c = current address
;*                      u = no. of sectors used
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*             IN EXECUTION PHASE,
;*                 AUXB = SOF ADDRESS
;*                 AUXD = EOF ADDRESS
;*                 AUXF = CURRENT ADDRESS (OR NO. OF
;*                        SECTORS USED)
;*
;*          RETURN: TEXTPTR POINTS AFTER LIST
;*               IN EXECUTION PHASE,
;*                  s = AUXB (SOF ADDRESS)
;*                  e = AUXD (EOF ADDRESS)
;*                  c (or u) = AUXF
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*
LMTSVLST:
        CALL    VARR            ;LOOK FOR START ADDRESS VARIABLE
        MOV     EDX,AUX0B       ;EDX= SOF
        CALL    RECEVPC         ;SOF ==> VARIABLE
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ERROR_13        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        CALL    VARR            ;LOOK FOR EOF ADDRESS VARIABLE
        MOV     EDX,AUX0D       ;EDX = EOF
        CALL    RECEVPC         ;EOF ==> VARIBALE
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ERROR_13        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        CALL    VARR            ;LOOK FOR CURRENT ADDRESS VARIABLE
        MOV     EDX,AUX0F       ;EDX= COF
        JMP     RECEVPC

; END LIMIT COMMAND


;         TITLE     VERIFY
;*     VERIFY: PROCESS A 'VERIFY' STATEMENT
;*
;*          STMT FORMAT:
;*
;*       VERIFY platter [file#,][(expr,expr)][num-variabl]
;*                       disk-addr,
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'VERIFY'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXA-F,9
;*
;*     REL 1.7 MODIFIED 5/10/79 -- IF DRIVE DOES NOT SUPPORT
;*          PHOENIX TYPE VERIFY, USE DIABLO SEQUENCE
;*
VERIFY:
        CALL    PLATTER         ;PROCESS PLATTER SPEC.
        CALL    DISKSELC        ;PROCESS #N OR /XYY PARAMETER
        CALL    SCTRANGE        ;PROCESS SECTOR ADDRESS RANGE
        CALL    NXTCHEOS        ;LOOK FOR EOS CHAR(END OF STATEMENT)
        MOV     R7,0
        TEST    R0,0FH
        JZ      BP43_04
        CALL    VARR
        MOV     R7,1            ;R7 =0 IF NO RECEIVER , 1 RECEIVER SPEC.
BP43_04:
        TEST    SL,2
        JZ      VERIFY1
        OR      MODE,0100H      ;VERIFY MODE ON
        CALL    HPION           ;HIGH PRIORITY I/O ON

; -------------- 22c11-2 -----------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dverify
; -------------- 22c11-2 ------------------

        MOV     EDX,AUX0F
        MOV     AUX09,EDX
        INC     AUX09           ;AUX09 -- LOOP COUNTER
VERIFY22:
        CALL    CMNDINIT
VERIFY2:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      VERIFY30        ;BR IF  PHOENIX DISK

;* ------- old-type disk verify (actually read sectors) ------------

VERIFY21:
        CALL    DREADSF         ;VERIFY BY ACTUALLY READING THE SECTOR
;* ------- check if more sectors to be verified --------------------
        MOV     EDX,AUX09
        MOV     AUX0F,EDX       ;AUX0F = AUX0F+1
        MOV     EBX,EDX         ;BX = READING SECTOR +1
        INC     AUX09           ;AUX09= NEXT SECTOR TO VERIFY + 1
        MOV     EDX,AUX0D       ;EDX = END SECTOR RANGE
        CMP     EBX,0            ;DONE IF NEXT SECTOR =0 (WRAP AROUND)
        JZ      VERIFY23
        CMP     EBX,EDX
        JBE     VERIFY21        ;BR IF MORE SECTORS TO VERIFY
;* ------- verify complete ----------------
VERIFY23:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        TEST    R7,0FH          ;BR IF NO RECEIVER
        JZ      VERIFY5
        MOV     EDX,0
VERIFY3:
        CALL    RECEVPC         ;RECEIVER = EDX
VERIFY5:
        AND     MODE,0FFFFFEFFH         ;VERIFY MODE OFF
VERIFY1:
        JMP     ENDSDISK
;* ------- Phoenix-type verify ---------------

VERIFY30:
        MOV     EDX,0    ;RETRY COUNT = 16 MAX.
VERIFY25:
        INC     EDX
        PUSH    EDX
        CALL    CMNDINIT        ;INITIALIZE DISK
        MOV     EDX,AUX0F       ;STARTING SECTOR ADDRESS
        MOV     R0,?AMEXTEND    ;EXTENDED COMMAND
        MOV     R2,?AMVERIFY    ;COMMAND = VERIFY
        CALL    DISKCMND        ;/COMMAND/PLATTER/SECTOR ADDRESS ==> DISK
        CMP     R0,0
        JZ      VERIFY6         ;BR IF COMMAND OK
;
        cmp     k,60h           ;ECHO = 60h indicates extended command reject
        jnz     retry_6
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     verife1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     B_ABS,al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     verif1ef

verife1e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
verif1ef:
        mov     edx,actdev
        call    enbldevd
        jmp     verify30
;
retry_6:
        POP     EDX
        CMP     EDX,10H
        JNZ     RETRYVRF        ;IF COMMAND ERROR & RETRY COUNT < 16 THEN BRANCH
        JMP     ERROR_94
RETRYVRF:
        TEST    R0,0F0H
        JZ      VERIFY25
        TEST    R0,0FH          ;BR IF ECHO ERROR
        JZ      VERIFY25
        JMP     VERIFY21        ;BR IF DPU VERIFY NOT SUPPORT
VERIFY6:
        POP     EDX             ;GET THE RETRY COUNT
        CALL    AKN             ;ACKNOWLEDGEMENT OF VALID(START) SECTOR ADDRESS
        MOV     EDX,AUX0D       ;END SECTOR ADDRESS
        CALL    DISKCMDA        ;END ADDRESS ==> DISK
        CALL    AKN             ;ACKNOWLEDGEMENT OF VALID(END)SECTOR ADDRESS
        MOV     K,0
        CALL    OBSDISK         ;START VERIFY
        CALL    AKNBPT          ;WAIT IBS --- BREAKPOINT IF NOT READY WITHIN 1/4 MS.
        MOVZX   EDX,K
        SHL     EDX,16
        CALL    WAITIBS         ;FOR SET RECEIVER,THE HIGH BYTE SECTOR ADDRESS IS IGNORED IN ANKBPT
        TEST    BYTE PTR FS:[CPUST],CPB
        JZ      ERR_92A
        MOV     DH,K            ;2ND ADDRESS
        CALL    WAITIBS
        TEST    BYTE PTR FS:[CPUST],CPB
        JZ      ERR_92A
        MOV     DL,K            ;3RD ADDRESS
        MOV     AUX09,EDX
        INC     AUX09           ;AUX09 = ADDRESS OF LAST SECTRO VERIFYED + 1
        CALL    AKN1            ;READ ACKNOWLEDGE
        JMP     VERIFY23        ;NO ERROR
ERR_92A:
        JMP     ERR_92

; --------------------- 22c11-2 --------------
new_dverify:
        push    edx
        mov     edx,aux0f
        mov     r0,20h
        mov     r2,12h
        call    traced_new
        mov     aux0f,edx
        pop     edx

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],05h
        mov     edx,actdev
        and     dx,0fffh
        mov     word ptr gs:[edi+3],dx
        mov     edx,aux0e
        and     edx,0fh
        shl     edx,12
        or      word ptr gs:[edi+3],dx
        mov     edx,aux0f
        mov     byte ptr gs:[edi+6],dh
        mov     byte ptr gs:[edi+7],dl
        shr     edx,16
        mov     byte ptr gs:[edi+5],dl

        mov     edx,aux0d
        mov     byte ptr gs:[edi+9],dh
        mov     byte ptr gs:[edi+0ah],dl
        shr     edx,16
        mov     byte ptr gs:[edi+8],dl

        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        movzx   edx,word ptr gs:[edi+3]
        mov     actdev,edx
        movzx   dx,byte ptr gs:[edi+0bh]
        shl     edx,16
        mov     dh,byte ptr gs:[edi+0ch]
        mov     dl,byte ptr gs:[edi+0dh]
        mov     aux09,edx
        inc     aux09
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        jmp     verify23
; --------------- 22c11-2 ---------------

;*     VERIFY ERROR
;*
;*          ENTRY: FROM 'DISKERR'
;*                 F0 = ERROR CODE
;*                 AUX9 = SECTOR ADDRESS + 1 OF BAD SECTOR
;*                 F7 = 0 IF NO RECEIVER VARIABLE
;*                      1 IF RECEIVER VARIABLE
;*

VERIFYE:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@ERRF
        MOV     AL,R0
        MOV     [EDX],AL        ;ERROR CODE ==> ERR
        MOV     EDX,AUX09       ;EDX = BAD SECTOR ADDRESS + 1
        CMP     R7,1
        JZ      VERIFY3         ;BR IF RECEIVER SPECIFIED
        MOV     EDX,ACTDEV
        MOV     AUX0A,EDX       ;SAVE DISK ADDRESS
        CALL    ENDDISK         ;CLOSE DISK IF NOT HOGGED
        CALL    ENBLCO          ; ENABLE CO DEVICE
@3?PD0MH:
        MOV     EDX,OFFSET VRFYMSG
        CALL    WRTSTRCM        ;OUTPUT "ERROR IN SECTOR"
        CALL    TWRITESP        ;OUTPUT SPACE
        MOV     EDX,AUX09
        DEC     EDX
        MOV     DWORD PTR A0,EDX;R1,0 = BAD SECTOR ADDRESS
        CALL    $DWRTVAL32      ;WRITE R1,0
        CALL    PRNTCR          ;WRITE 'CR'
        TEST    SH,20H          ;BRANCH IF NOT HALT/STEPe
        JNZ     VERIFY5
        MOV     EDX,AUX0A       ;EDX=DISK TYPE & ADDRESS
        CALL    ENBLDEVD        ;ENABLE DISK
;* ------- check if more sectors to be verified ---------
        MOV     EDX,AUX09
        MOV     AUX0F,EDX
        MOV     EBX,EDX
        MOV     AUX09,EDX
        INC     AUX09
        MOV     EDX,AUX0D
        CMP     EBX,0
        JZ      VERIFY23
        CMP     EBX,EDX
        JA      VERIFY23
        MOV     ESP,OFFSET STACK_BUFFER

; -------------- 22c11-2 -----------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dverify
; -------------- 22c11-2 ------------------

        JMP     VERIFY2

;   END VERIFY COMMAND

;* -----------  testplat ---------------*
;The following changes are for platter hog
;Because copy from the same device but different platters
;e.g. copy t/d21 to t/d22
;OS allow platter p21 and mark the MDT table 20 devoip
;But platter p22 is hogged by another partition ,OS wait platter p22
;At this time , other partition can't unhog p22 due to MDT table 20 has been marked
;We must certify that device d20, platter p21 p22 are all available
;*

test_plat:
        test    sl,2
        jz      real_beg
        jmp     real_beg1
;make sure that device & platters are available

;* device not available
copyplat:
        mov     textptr,aux05
        mov     dl,part_           ;POINT TO REQUESTED DEVICE TABLE (SAME PAGE)
        and     edx,0ffh           ;DEVICE ADDRES ==> RQSTDEV
        add     edx,offset rqstdev ;WAIT UNTIL DEVICE AVAILABLE
        mov     [edx],ch
        jmp     copyplat_3

;* platter not available
copyplat_2:
        mov     textptr,aux05
        mov     dl,part_           ;POINT TO REQUESTED DEVICE TABLE (SAME PAGE)
        and     edx,0ffh           ;DEVICE ADDRES ==> RQSTDEV
        add     edx,offset rqstplat;WAIT UNTIL DEVICE AVAILABLE
        mov     al,r0
        mov     [edx],al
copyplat_3:
        call    breakptw

real_beg1:
        mov     aux05,textptr           ;save textptr (point to platter)
        call    platter                 ;skip   platter
        call    diskselcc               ;look for /taa,#n
        and     dx,0fffh
        cmp     dh,03h                  ;310 --> d11
        jnz     copyplat_4              ;d10 --> d10
        cmp     dl,40h                  ;b10 --> d10
        jnz     copyplat_5              ;340 --> x
        mov     ebx,cpbase
        mov     [ebx].@soudev,dx
        jmp     copyplat_1
copyplat_5:
        inc    dl
copyplat_4:
        mov     word ptr r0,dx
        mov     bx,word ptr r0
        mov     edx,cpbase
        mov     [edx].@soudev,bx
        push    word ptr r0
        and     r0,0f0h
        call    finddev                 ;look whether the device is used
        pop     word ptr r0
        test    r3,PARTBIT              ;br if device is used by other,u64
        jnz     copyplat                ;partition
        mov     ebx,0
        mov     bl,r0                   ;get the platter hog byte
        add     ebx,offset plat
        test    byte ptr [ebx],80h
        jz      copyplat_1              ;br if platter not hog
        mov     al,byte ptr [ebx]
        and     al,PARTBIT              ;u64
        cmp     al,part_
        jnz     copyplat_2              ;br if platter is used by other partition
copyplat_1:

        mov     sl,01h
        call    filename
        call    sctrange        ;PROCESS START-END ADDR SPECIFICATION
        mov     sl,02h
        call    cclto

        CMP     BYTE PTR [EBP],"'"      ;index format 1 indicator ?  ^A13T
        JNE     COPYPLATH1              ;Jump if not                 ^A13T
        INC     EBP                     ;else skip over it           ^A13T
        JMP     COPYPLATH2              ;                            ^A13T

COPYPLATH1:                             ;                            ^A13T
        CMP     BYTE PTR [EBP],"&"      ;index format 2 indicator ?  ^A13T
        JNE     COPYPLATH2              ;Jump if not                 ^A13T
        INC     EBP                     ;else skip over it           ^A13T

COPYPLATH2:                             ;                            ^A13T
        call    platter                 ;skip   platter
        call    diskselcc               ;look for /taa,#n
        and     dx,0fffh
        cmp     dh,03h                  ;310 --> d11
        jnz     copyplat_4x             ;d10 --> d10
        cmp     dl,40h                  ;b10 --> d10
        jnz     copyplat_5x             ;340 --> x
        mov     ebx,cpbase
        mov     [ebx].@desdev,dx
        jmp     copyplat_6
copyplat_5x:
        inc    dl
copyplat_4x:
        mov     word ptr r0,dx
        mov     bx,word ptr r0
        mov     edx,cpbase
        mov     [edx].@desdev,bx
        push    word ptr r0
        and     r0,0f0h
        call    finddev                 ;look whether the device is used
        pop     word ptr r0
        test    r3,PARTBIT          ;u64;br if device is used by other
        jnz     copyplat
        mov     ebx,0
        mov     bl,r0                   ;get the platter hog byte
        add     ebx,offset plat
        test    byte ptr [ebx],80h
        jz      copyplat_6              ;br if platter not hog
        mov     al,byte ptr [ebx]
        and     al,PARTBIT
        cmp     al,part_
        jnz     copyplat_2              ;br if platter is used by other partition
copyplat_6:
        mov     textptr,aux05           ;restore
        mov     ebx,cpbase
        mov     bx,[ebx].@soudev
        cmp     bx,340h
        jz      copyplat_10
        and     ebx,0ffh
        add     ebx,offset plat
        mov     al,part_
        or      al,80h
        mov     ah,[ebx]
        or      al,ah
        mov     [ebx],al
copyplat_10:
        mov     ebx,cpbase
        mov     bx,[ebx].@desdev
        cmp     bx,340h
        jz      real_beg
        and     ebx,0ffh
        add     ebx,offset plat
        mov     al,part_
        or      al,80h
        mov     ah,[ebx]
        or      al,ah
        mov     [ebx],al
real_beg:
        ret


;         TITLE     COPY
;*     COPY: PROCESS A 'COPY' STATEMENT
;*
;*          2600 FORMAT:
;*
;*             COPY platter [file#,] [(expr,expr)] TO
;*                           disk-addr,
;*
;*               platter [file#,] [(expression)]
;*                        disk-addr,
;*
;*          2200 FORMAT:
;*
;*             COPY [file#, ] FR [(expr,expr)]
;*                 disk-addr, RF
;*
;*          ENTRY: TEXTPTR POINTS TO AFTER 'COPY'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX3,4,5,C-F
;*
;*          NOTE: READ AND WRITE TO DISK CURRENTLY HANG
;*                IF DISK DOESN'T RECOGNIZE READ/WRITE
;*                COMMAND -- 2200 ONLY PERMITS 2 RETRIES.
;*                ALSO, 2200 DOES NOT RETRY IF LRC ERROR!
;*                SHOULD RETRY (N TIMES) IN EITHER CASE
;*                ==> SINGLE READ/WRITE ROUTINE.
;*
;*               COPY COULD READ AS MANY SECTORS AS WOULD
;*               FIT IN MEMORY BEFORE WRITING. MIGHT
;*               IMPROVE MULTI-PLEXED COPYING OR MIGHT
;*               INCREASE TRACK MOVEMENT.
;*
;*               SHOULD END (SOURCE & DESTINATION) SECTORS
;*               BE READ BEFORE COPY TO ENSURE COPY WILL
;*               WORK? DOESN'T DO MUCH! SAVE CODE BY NOT
;*               DOING IT.
;
;* RELEASE 2.1:  both disks hogged for entire copy operation.
;
;* THERE ARE TWO COPY FORMAT --- 2200 & 2600

COPY:
        mov     eax,dword ptr [cpbase]
        MOV     BYTE PTR [EAX].@MOVEFLAG,1      ;set the move/copy flag ^A08T
        mov     dword ptr [eax].@toptr,0
        CALL    RAWOFF          ;READ-AFTER-WRITE OFF
        CALL    FRRF            ;PROCESS 'RF' OR 'FR'
        TEST    R0,0FH
        JZ      COPY22F2
        CMP     BYTE PTR [TEXTPTR],'/'
        JE      M43_T1
        CMP     BYTE PTR [TEXTPTR],'#'
        JNE     M43_T2
M43_T1:
        INC     TEXTPTR
        JMP     COPY22F1
M43_T2:

;*-------- 2600 FORMAT ----------

        call    test_plat
        CALL    PLATTER         ;PROCESS 'FROM' PLATTER SPECIFICATION
        CALL    DISKSELC        ;PROCESS 'FROM' #n, OR /xyz, PLATTER
        TEST    SL,2
        JZ      COPY1

; -------------- 22c11-2 -----------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dcopy1
; -------------- 22c11-2 -----------------

        CALL    CMNDINIT        ;DEVICE TYPE = 'D' IFF PHOENIX

; -------------- 22c11-2 --------------
new_dcopy1:
; -------------- 22c11-2 --------------

        MOV     EDX,AUX0E
        MOV     AUX05,EDX       ;AUX05 ----  'FROM' PLATTER SPEC.
        MOV     EDX,ACTDEV
        MOV     AUX04,EDX       ;AUX04 ----  'FROM' DEVICE TYPE & ADDRESS

COPY1:
        CALL    SCTRANGE        ;PROCESS START-END ADDR SPECIFICATION
        CALL    CCLTO           ;LOOK FOR 'TO'
        CALL    PLATTER         ;AUX0E --- 'TO' PLATTER SPEC.
        CALL    DISKSELC        ;PROCESS 'TO' #n, OR /xyz, PLATTER
        CALL    SCTRTO          ;PROCESS 'TO' START ADDR
        TEST    SL,2
        JZ      MVCPYEND

COPY3:

; ---------------- 22c11-2 ---------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dcopy2
; ---------------- 22c11-2 ---------------

        CALL    CMNDINIT        ;DEVICE TYPE = 'D' IFF PHOENIX

; ----------------- 22c11-2 -------------
new_dcopy2:
; ----------------- 22c11-2 -------------

        CALL    HPION           ;HIGH PRIORITY I/O ON
        CALL    COPYS           ;COPY SECTOR
COPY2:
        JMP     MVCPYEND        ;DISABLE DISK, EXIT

;*--------   2200 FORMAT:  -------------
COPY22F1:
        MOV     TEXTPTR,EDX     ;DECREMENT TEXTPTR
        CALL    DISKSELC        ;PROCESS #n, OR /xyz, PLATTER
        CALL    FRRF            ;PROCESS 'FR' OR 'RF'
        CMP     R0,0
        JZ      COPY22F3
        JMP     ERROR_19
COPY22F3:
        TEST    SL,2
        JZ      COPY22F4
        MOV     EDX,ACTDEV
        MOV     AUX04,EDX
        CALL    COPYX           ;SETUP AUXS TO ACTIVATE FROM DISK

; ---------------- 22c11-2 ------------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dcopy3
; --------------- 22c11-2 ------------------

        CALL    CMNDINIT        ;TRANSFER FROM DISK ADDR

; --------------- 22c11-2 ------------------
new_dcopy3:
; --------------- 22c11-2 ------------------

COPY22F4:
        CALL    SCTRANGE
        TEST    SL,2
        JZ      MVCPYEND_X
        MOV     EDX,AUX0F
        MOV     AUX03,EDX
        CALL    COPYX

; ---------------- 22c11-2 ------------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dcopy4
; --------------- 22c11-2 ------------------

        CALL    CMNDINIT        ;DEVICE TYPE = 'D' IFF PHOENIX

; --------------- 22c11-2 ------------------
new_dcopy4:
; --------------- 22c11-2 ------------------

        CALL    HPION           ;HIGH PRIORITY I/O ON
        CALL    COPYS           ;COPY SECTOR
        TEST    SL,2
        JZ      MVCPYEND_X
        CALL    ENDDISK
        CALL    COPYXA
MVCPYEND_X:
        JMP     ENDSDISK

COPY22F2:
        CALL    DISKADRD        ;ENABLE DEFAULT DISK
        JMP     COPY22F3

;         TITLE     FRRF
;*     FRRF: SCAN & PROCESS 'FR' OR 'RF' PARAMETER
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN:
;*               F0 = 0 IF FOUND
;*                    TEXTPTR POINTS AFTER 'RF' OR 'FR'
;*                    IN EXECUTION PHASE,
;*                         AUX5 = FROM PLATTER
;*                         AUXE = TO PLATTER
;*               F0 <> 0 IF NOT FOUND
;*                    TEXTPTR POINTS AT NEXT NONBLANK
;*                         TEXT CHARACTER
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,AUX0
;*               IN EXECUTION PHASE, AUX5,E
;*
FRRF:
        CMP     BYTE PTR [TEXTPTR],'F'
        MOV     AUX00,TEXTPTR
        JNE     FRRF1
        INC     TEXTPTR
        CMP     BYTE PTR [TEXTPTR],'R'
        JNE     FRRF2
        INC     TEXTPTR
        MOV     R0,0

        TEST    SL,2
        JZ      FRRF3
        MOV     AUX05,1         ;'FROM' PLATTER = FIXED (F)
        MOV     AUX0E,2         ;'TO' PLATTER = REMOVABLE (R)
FRRF3:
        RET

FRRF1:
        CMP     BYTE PTR [TEXTPTR],'R'
        MOV     AUX00,TEXTPTR
        JNE     FRRF2
        INC     TEXTPTR
        CMP     BYTE PTR [TEXTPTR],'F'
        JNE     FRRF2
        INC     TEXTPTR
        MOV     R0,0

        TEST    SL,2
        JZ      FRRF3
        MOV     AUX05,2         ;'FROM' PLATTER = REMOVABLE (R)
        MOV     AUX0E,1         ;'TO' PLATTER = FIXED (F)
        RET

FRRF2:
        MOV     R0,1
        MOV     EDX,AUX00
        MOV     TEXTPTR,EDX     ;RESTORE TEXTPTR
        RET

;         TITLE     COPYS
;*     COPYS: COPY A GROUP OF SEQUENTIAL SECTORS FROM
;*            ONE DISK PLATTER TO ANOTHER
;*
;*          ENTRY: PHASE = EXECUTION
;*               AUXF = 'FROM' START SECTOR ADDRESS
;*               AUXD = 'FROM' END SECTOR ADDRESS
;*               AUX5 = 'FROM' PLATTER SPECIFICATION
;*               AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*
;*               AUX3 = 'TO' START SECTOR ADDRESS
;*               AUXE = 'TO' PLATTER SPECIFICATION
;*               ACTDEV = 'TO' DEVICE TYPE & ADDRESS
;*
;*          RETURN:
;*               AUXF = 'FROM' END ADDRESS +1
;*               AUXD = 'FROM' END ADDRESS
;*               F7,6 = 'FROM' END ADDRESS
;*               AUXE = 'FROM' PLATTER SPEC.
;*               ACTDEV = 'FROM' DEVICE TYPE & ADDRESS
;*
;*               AUX3 = 'TO' SECTOR ADDRESS OF LAST
;*                      SECTOR COPIED +1
;*               AUX4 = 'TO' DEVICE TYPE & ADDRESS
;*               AUX5 = 'TO' PLATTER SPECIFICATION
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-3,6,7
;*                              AUX0,1,3,4,5,C,E,F
;*
COPYS:
        MOV     EDX,AUX0D
        MOV     DWORD PTR A6,EDX  ;F7,6 = END SECTOR ADDR FOR COPY
        MOV     EDX,AUX0F       ;AFTER EXCHANGE : AUX3 = 'FROM' START SECTOR ADDRESS
        XCHG    EDX,AUX03       ;                 AUXF = 'TO' START SECTOR ADDRESS
        MOV     AUX0F,EDX       ;SUBROUTINE COPYXB WILL EXCHANGE ALL INFORMATION BETWEEN 'FROM' AND 'TO'

        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JNZ     COPYS1          ;BRANCH IF 'TO' DISK NOT PHOENIX
        AND     DL,30H          ;F0 = PRIMARY ADDR OF 'TO' DISK

        MOV     EAX,AUX04
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JNZ     COPYS1          ;BRANCH IF 'FROM' DISK NOT PHOENIX
        AND     AL,30H
        CMP     AL,DL
        JNZ     COPYS1          ;BRANCH IF DIFFERENT PHOENIX UNIT

; -------------- 22c11-2 ----------------
        mov     edx,aux04
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dcopy5
; -------------- 22c11-2 -----------------


;*PHOENIX COPY -- 'TO' & 'FROM' SAME DISK PROCESSOR
;
COPYSP:
        CALL    COPYXB          ;ENABLE 'FROM' DEVICE
copysp1x:
        MOV     EDX,0           ; EDX = RETRY COUNT --- 16 MAX.
COPYSP1:
        INC     EDX
        PUSH    EDX
BP43A_01:
        CALL    CMNDINIT
        MOV     EDX,AUX0F
        MOV     R0,?AMEXTEND    ;EXTENDED COMMAND
        MOV     R2,?AMCOPY      ;COMMAND = COPY
        CALL    DISKCMND        ;COMMAND/PLATTER/SECTOR ADDRESS ==> DISK
        CMP     R0,0
        JZ      COPYSP2
;
        cmp     k,60h           ;ECHO = 60h indicates extended command reject
        jnz     retry_7         ;
                                ;if denied , no partitions interfere this device
                                ;for example, copy t/d21,(xx,yy)tot/d22,(zz)
                                ;when d21 or d22 is denied,you can't delete the mark
                                ;in the MDT for another partition issue $open!/d21
;
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     copye1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     B_ABS,al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     copy1ef

copye1e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
copy1ef:
        mov     edx,actdev
        call    enbldevd
        jmp     copysp1x
;
;
retry_7:
        POP     EDX
        CMP     EDX,10H
        JNZ     RETRYCPY
        JMP     ERROR_94

RETRYCPY:
        TEST    R0,0F0H
        JZ      COPYSP1         ;BRANCH IF ECHO ERROR
        TEST    R0,0FH
        JZ      COPYSP1
        MOV     R2,4
        CALL    IOBUFTXT        ;make sure at least a 1K buffer
        JMP     COPYS11         ;BRANCH IF DPU COPY NOT SUPPORTED
        CALL    IOBUFTXT
        JMP     COPYS11

COPYSP2:
        CALL    AKN             ;ACKNOWLEDGEMENT OF VALID SECTOR ADDRESS
        MOV     EDX,AUX0D
        CALL    DISKCMDA        ;'FROM' END ADDRESS ==> DISK
        CMP     R0,0
        JZ      COPYSP2A
        POP     EDX
        CMP     EDX,10H         ;BRANCH IF < 16 RETRIES
        JNZ     COPYSP1
        JMP     ERROR_94

COPYSP2A:
        CALL    AKN
        CALL    COPYXB          ;ENABLE 'TO' DEVICE
        MOV     R0,0
        MOV     EDX,AUX0F
        CALL    DISKCMND        ;'TO' PLATTER/SECTOR ADDRESS ==> DISK
        CMP     R0,0
        JZ      COPYSP2B        ;BRANCH IF NO ECHO ERROR
;
        cmp     k,60h           ;ECHO = 60h indicates extended command reject
        jnz     retry_8
;
        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     copye2e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     B_ABS,al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     copy2ef

copye2e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
copy2ef:
        jmp     copysp
;
retry_8:
;
        POP     EDX
        CMP     EDX,10H
        JNZ     COPYSP2C
        JMP     ERROR_94

COPYSP2C:
        INC     EDX
        PUSH    EDX
        CALL    COPYXB
        JMP     BP43A_01

COPYSP2B:
        POP     EDX             ;CLEAN STACK
        CALL    AKN
        MOV     K,0
        CALL    OBSDISK         ;START COPYING
        CALL    AKN1            ;COPY ACKNOWLEDGEMENT

; ------------------ 22c11-2 ------------
new_dcopy6:
; ------------------ 22c11-2 ------------

        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        CALL    COPYXB          ;SWITCH PTRS

        MOV     EBX,DWORD PTR A6
        MOV     EDX,EBX
        ADD     EDX,1
        XCHG    EDX,AUX0F       ;AUXF = END SECTOR ADDR +1
        MOV     EAX,EDX
        SUB     EBX,EAX
        MOV     EDX,AUX03       ;# SECTOR COPIED -1
        ADD     EDX,EBX
        ADD     EDX,1
        MOV     AUX03,EDX       ;AUX4 = 'TO' ADDR OF LAST SECTOR COPIED +1
        RET

; --------------------- 22c11-2 ------------------
new_dcopy5:
        push    edx
        mov     edx,aux0f
        mov     r0,20h
        mov     r2,01h
        call    traced_new
        mov     aux0f,edx
        pop     edx

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        call    copyxb
        mov     edx,actdev
        and     dx,0fffh
        mov     word ptr gs:[edi+3],dx
        mov     edx,aux0e
        and     edx,0fh
        shl     edx,12
        or      word ptr gs:[edi+3],dx
        mov     edx,aux0f
        mov     byte ptr gs:[edi+6],dh
        mov     byte ptr gs:[edi+7],dl
        shr     edx,16
        mov     byte ptr gs:[edi+5],dl
        mov     edx,aux0d
        mov     byte ptr gs:[edi+9],dh
        mov     byte ptr gs:[edi+0ah],dl
        shr     edx,16
        mov     byte ptr gs:[edi+8],dl

        call    copyxb
        mov     edx,actdev
        and     dx,0fffh
        mov     word ptr gs:[edi+0bh],dx
        mov     edx,aux0e
        and     edx,0fh
        shl     edx,12
        or      word ptr gs:[edi+0bh],dx
        mov     edx,aux0f
        mov     byte ptr gs:[edi+0eh],dh
        mov     byte ptr gs:[edi+0fh],dl
        shr     edx,16
        mov     byte ptr gs:[edi+0dh],dl

        mov     byte ptr gs:[edi+1],04h
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi

        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        jmp     new_dcopy6
; ----------------- 22c11-2 -----------------

;
;*COPY -- NOT ON A SINGLE PHOENIX UNIT
;
COPYS1:
        CALL    COPYX           ;SETUP 'FROM' DEVICE INFORMATION
COPYS11:
        MOV     EDX,AUX0F       ;PC'S = 'FORM' SECTOR ADDR
        CMP     DWORD PTR A6,EDX
        JB      COPYS2
        CALL    DREAD4S         ;READ UP TO 4 SECTOR 'FROM' DEVICE
        CALL    COPYX           ;SETUP 'TO' DEVICE INFORMATION

        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      COPYS3          ;BRANCH IF PHOENIX WRITING TO
        CALL    DWRITENS        ;WRITE SECTORS THAT WERE READ TO 'TO' DEVICE
        JMP     COPYS1

COPYS2:
        RET

;*WRITING TO PHOENIX
COPYS3:
        CALL    MSWRTBEG        ;BEGIN MULTI-SECTOR WRITE
        CALL    DWRITENS        ;WRITE SECTORS
        CALL    MSWRTEND        ;END MULTI-SECTOR WRITE
        JMP     COPYS1

;         TITLE     COPYX COPYXA
;*     COPYX: EXCHANGE 'FROM' AND 'TO' DEVICE INFORMATION
;*
;*          ENTRY: EXECUTION PHASE
;*               ACTDEV,AUX4 = 'FROM' & 'TO' DEVICE ADDR
;*               AUX5,AUXE = 'FROM' & 'TO' PLATTER SPEC.
;*               AUXF,AUX3 = 'FROM' & 'TO' CURRENT SECTOR
;*                           ADDRESSES
;*
;*          RETURN:
;*               ACTDEV,AUX4 EXCHANGED
;*               AUX5,AUXE EXCHANGED
;*               AUXF,AUX3 EXCHANGED
;*               NEW ACTDEV ENABLED
;*               AUXC = ADDRESS OF I/O BUFFER (>=1K)
;*               F1 = # OF PAGES OF BUFFERING
;*
;*          MODIFIED REGISTERS: PC'S,K,F0-2,AUX3,4,5,C,E,F
;*
;*     COPYXA: EXCHANGE 'FROM' AND 'TO' DEVICE INFORMATION
;*
;*          ENTRY: EXECUTION PHASE
;*               ACTDEV,AUX4 = 'FROM' & 'TO' DEVICE ADDR
;*               AUX5,AUXE = 'FROM' & 'TO' PLATTER SPEC.
;*
;*          RETURN:
;*               ACTDEV,AUX4 EXCHANGED
;*               AUX5,AUXE EXCHANGED
;*               NEW ACTDEV ENABLED
;*
;*          MODIFIED REGISTERS: PC'S,K,AUX4,5,E
;*
;*     COPYXB: EXCHANGE 'FROM' AND 'TO' DEVICE INFORMATION
;*
;*          ENTRY: EXECUTION PHASE
;*               ACTDEV,AUX4 = 'FROM' & 'TO' DEVICE ADDR
;*               AUX5,AUXE = 'FROM' & 'TO' PLATTER SPEC.
;*               AUXF,AUX3 = 'FROM' & 'TO' CURRENT SECTOR
;*
;*          RETURN:
;*               ACTDEV,AUX4 EXCHANGED
;*               AUX5,AUXE EXCHANGED
;*               AUXF,AUX3 EXCHANGED
;*               NEW ACTDEV ENABLED
;*
;*          MODIFIED REGISTERS: F0,1,CH,CL,PC'S,K,
;*                              AUX0,3,4,5,E,F
;*
;
;*Release 2.1:  disk being disabled is not released.
;
COPYX:
        MOV     R2,4
        CALL    IOBUFTXT        ;MAKE SURE 1K BUFFER AVAIABLE; AUXC POINT TO BUFFR
COPYXB:
        MOV     EDX,AUX0F
        XCHG    EDX,AUX03       ;AUX3 = AUXF; AUXF = AUX3
        MOV     AUX0F,EDX
COPYXA:
        MOV     EDX,ACTDEV
        XCHG    EDX,AUX04       ;AUX4 = ACTDEV; ACTDEV = AUX4
COPYXA1:
        CALL    ENBLDEVD
        MOV     EDX,AUX05
        XCHG    EDX,AUX0E       ;AUX5 = AUXE; AUXE = AUX5
        MOV     AUX05,EDX
        RET

;         TITLE     MOVEEND
;*     MOVEEND: PROCESS A 'MOVEEND' STATEMENT
;*
;*          FORMAT:
;*
;*               MOVE END platter [ file#[,]] = expression
;*                                disk-addr[,]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'END'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,E,F
;*
MOVEEND:
        CALL    PLATTER
        CALL    DISKSEL         ;PROCESS #n[,] or /xyy[,] PARAMETER
        CMP     BYTE PTR [TEXTPTR],'='
        JNE     ERROR_12        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        CALL    EXPR
        TEST    SL,2
        JZ      MOVEEND1

        CALL    FLTBIN    ;CONVERT EXPR VALUE TO BINARY (NEW CAT. END) ^A10T
        MOV     EBX,DWORD PTR [A0]
        MOV     AUX0F,EBX       ;AUX0F = NEW CAT. END
        INC     EBX             ;BX = NEW CAT. END + 1
        PUSH    EBX             ;AVOID ALTERED BY CALLED SUBROUTINE

        CALL    DREADSF         ;READ NEW CAT. END (TO BE SURE LEGAL PLATTER ADDR)
        MOV     EDX,AUX0C       ;AUX0C = PTR TO DATA TO BE WRITTEN
        XCHG    EDX,AUX0F
        DEC     EDX             ;PC'S SECTOR TO BE WRITTEN
        CALL    DWRITE          ;WRITE A SECTOR (VALID SECTOR ADDRESS CHECK)

        CALL    CURENDR         ;DX = CURRENT CAT. END
        POP     EBX             ;BX = NEW CAT. END
        CMP     EBX,EDX
        JBE     MOVEEND2
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        CMP     BYTE PTR [EDX],02H
        JE      MOVEND_X                  ;jump if 3 byte format
        
        CMP     EBX,0FFFFH                                            ; ^A10T
        JA      ERROR_34                  ;error if new end > 2 bytes   ^A10T
        MOV     BYTE PTR [EDX+4],BH
        MOV     BYTE PTR [EDX+5],BL      ;NEW END ==> I/O BUFFER
        JMP     MOVEND_Y

MOVEND_X:
        CMP     EBX,0FFFFFFH                                          ; ^A10T
        JA      ERROR_34                  ;error if new end > 3 bytes   ^A10T
        MOV     BYTE PTR [EDX+7],BH
        MOV     BYTE PTR [EDX+8],BL
        SHR     EBX,16
        MOV     BYTE PTR [EDX+6],BL
MOVEND_Y:
        CALL    RAWON           ;FLAG = READ-AFTER-WRITE
        MOV     AUX0F,0
        CALL    DWRITE?DAF

MOVEEND1:
        JMP     ENDSDISK
MOVEEND2:
        JMP     ERROR_86        ;CATALOG END ERROR

E_34X:  MOV     R0,34H
        JMP     ERROR

;         TITLE     NEXTFILE
;*     NEXTFILE: GET NEXT FILE ENTRY FROM DISK INDEX
;*               (SCRATCHED OR ACTIVE)
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = PLATTER SPEC.
;*               AUX6 = SECTOR ADDRESS OF CURRENT INDEX
;*                      SECTOR
;*               AUX7,LOW BYTE = ENTRY NO. OF NEXT ENTRY
;*                               IN CURRENT INDEX SECTOR
;*                   ,HIGHBYTE = NO. OF INDEX SECTORS
;*
;*               THUS, WHEN ENTERING FOR 1ST TIME:
;*                    AUX6 = 0
;*                    AUX7 = nn01 (nn = NO. OF INDEX SCTR)
;*
;*          RETURN: F0 = 1 IF NO MORE FILENAMES IN INDEX
;*
;*               F0 = 0 IF FILENAME FOUND
;*                    AUXB = START ADDRESS OF FILE
;*                    AUXD = END ADDRESS OF FILE
;*                    F6 = FILE STATUS
;*                         10 IF ACTIVE
;*                         11 IF SCRATCHED
;*                    F7 = FILE TYPE
;*                         00 IF DATA FILE
;*                         80 IF PROGRAM
;*                    AUX6 INCREMENTED IF NECESSARY
;*                    AUX7,LOW BYTE = ENTRY NO. OF NEXT
;*                         ENTRY (OR 16 )
;*
;*                    WORKSPACE CONTAINS FILENAME.
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1,6,7
;*                              AUX0,B,C,D,F,6,7
;*
NEXTFIL3:
        MOV     EDX,AUX07
        TEST    DL,0F0H
        JZ      NEXTFIL4        ;BRANCH IF MORE ENTRIES IN CURRENT INDEX SECTOR

;   THE PARAMETER PASSING IS POOR :
;
;               AUX7,LOW   BYTE = ENTRY NO. OF NEXT ENTRY
;                                 IN CURRENT INDEX SECTOR
;                   ,HIGH  BYTE = NO. OF INDEX SECTORS
NEXTFILE:
        MOV     EDX,AUX07
        TEST    DL,0F0H
        JZ      NEXTFIL1        ;BRANCH IF MORE ENTRIES IN CURRENT INDEX SECTOR
        MOV     DL,0            ;RESET TNE ENTRY NO. = 0
        MOV     AUX07,EDX
        MOV     EBX,EDX           ;BL = NO. OF INDEX SECTOR
        SHR     EBX,16

        MOV     EDX,AUX06
        INC     EDX
        CMP     BX,DX
        JBE     NEXTFIL2        ;BRANCH IF NO MORE INDEX SECTOR
        MOV     AUX06,EDX

NEXTFIL1:
        MOV     EDX,AUX06
        MOV     AUX0F,EDX
        CALL    DREADSF         ;READ INDEX SECTOR
        MOV     EDX,AUX07

NEXTFIL4:
        MOV     AUX07,EDX
        INC     AUX07
        MOVZX   EAX,DL
        SHL     EAX,4           ;EAX = 16 * ENTRY NO.
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        CMP     AUX06,0
        JNE     NEXTFILE_X
        MOV     EBX,AUX07
        MOV     BH,BYTE PTR [EDX]
        MOV     AUX07,EBX
NEXTFILE_X:
        ADD     EDX,EAX         ;THE ASSUMPTION THAT I/O BUFFER ORIGIN IS XX00 IS WRONG IN CS-386
        MOV     CX,[EDX]        ;  FILE STATUS (F6) = 10 IF ACTIVE, 11 IF SCRATCH
        XCHG    CH,CL
        MOV     AUX0C,EDX
        ADD     AUX0C,2
        MOV     AL,CH
        AND     AL,0F0H
        CMP     AL,10H
        JNZ     NEXTFIL3
        MOV     R6,CH
        MOV     R7,CL

        MOV     EDX,DWORD PTR [CPBASE]
        MOV     EBX,AUX07
        MOV     BYTE PTR [EDX].@HASHFL,BH
        LEA     EDI,[EDX].@WORKSPC
        CALL    GTFLPTRS        ;GET START, END ADDR OF FILE
        MOV     EDX,AUX0C
        ADD     EDX,6
        MOV     ESI,EDX
        MOV     ECX,8
        REP     MOVSB

        MOV     R0,0            ;FLAG = FOUND
        RET

NEXTFIL2:
        MOV     R0,1            ;FLAG = NO MORE IN INDEX
        RET

;         TITLE     SCTRANGE
;*     SCTRANGE: PROCESS SECTOR RANGE PARAMETER
;*
;*          FORMAT: [(start-addr-expr, end-addr-expr)]
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*                 DISK ENABLED
;*                 AUXE = PLATTER
;*
;*          RETURN: TEXTPTR POINTS AFTER SECTOR-RANGE SPEC
;*               IN EXECUTION PHASE,
;*                  AUXF = START-ADDRESS (DEFAULT = 0)
;*                  AUXD = END-ADDRESS (DEFAULT = CURRENT
;*                            END OF CATALOG AREA)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXC,D,F
;*
;*     SCTRANGA: GET DEFAULT SECTOR RANGE (0 TO CURRENT
;*               END OF CATALOG AREA)
;*
;*          RETURN (EXECUTION PHASE):
;*               AUXF = 0 (START ADDRESS)
;*               AUXD = CURRENT END OF CATALOG AREA
;*                      (END ADDRESS)
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,1
;*                              AUX0,C,D,F
;*
SCTRANGE:
        CMP     BYTE PTR [TEXTPTR],'('
        JNE     SCTRANGA
        INC     TEXTPTR
        CALL    EXPR
        CMP     BYTE PTR [TEXTPTR],','
        JNE     ERROR_13        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        CALL    EXPR
        CMP     BYTE PTR [TEXTPTR],')'
        JNE     ERROR_11        ;BRANCH IF NOT MATCH
        INC     TEXTPTR

        TEST    SL,2
        JZ      SCTRANG2
        CALL    FLTBIN_H2
        MOV     EBX,DWORD PTR [A0]
        MOV     AUX0D,EBX       ;AUX0D -- END ADDRESS

        CALL    FLTBIN_H2
        MOV     EDX,DWORD PTR [A0]
        MOV     AUX0F,EDX       ;AUX0F -- START ADDRESS

        MOV     EBX,AUX0D
        CMP     EBX,EDX
        JB      BP43C_01
SCTRANG2:
        RET

BP43C_01:
        JMP     ERROR_32

E_34Y:  MOV     R0,34H
        JMP     ERROR

SCTRANGA:
        TEST    SL,2
        JZ      SCTRANG2
        CALL    CURENDR
        MOV     AUX0D,EDX
        MOV     AUX0F,0
        RET

;         TITLE     SCTRTO
;*     SCTRTO: PROCESS DESTINATION SECTOR ADDR PARAMETER
;*
;*          FORMAT: [(expression)]
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER SECTOR PARAMETER
;*               IN EXECUTION PHASE,
;*                  PC'S & AUX3 = SECTOR ADDRESS
;*                                (DEFAULT = AUXF)
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX3
;*
SCTRTO:
        CMP     BYTE PTR [TEXTPTR],'('
        JNE     SCTRTO1
        INC     TEXTPTR
        CALL    EXPR
        CMP     BYTE PTR [TEXTPTR],')'
        JNE     ERROR_11        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        TEST    SL,2
        JZ      SCTRTO2
        CALL    FLTBIN_H2
        MOV     EDX,DWORD PTR A0

SCTRTO3:
        MOV     AUX03,EDX
SCTRTO2:
        RET
SCTRTO1:
        MOV     EDX,AUX0F
        TEST    SL,2
        JNZ     SCTRTO3
        RET

;         TITLE     SETDEVLD
;*     SETDEVLD: DEVLOAD = ACTDEV
;*
;*          MODIFIED REGISTERS: PC'S,F0,1,CH,CL
;*
SETDEVLD:
        MOV     EBX,ACTDEV      ;ACTDEV    |1 |2 |3 |4 |
;       CALL    RDEVLOAD        ;EBX       |4 |3 |2 |1 |
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVLOAD
        MOV     [EDX],BH        ;R0R1      |1 |2 |
        MOV     [EDX+1],BL      ;MOV [EDX],BX <>  OR,W1 F1,, & OR,W2 F0,
        RET

;         TITLE     $FORMAT DISK
;*FORMATD:  FORMAT DISK STATEMENT
;*
;*     SYNTAX: $FORMAT DISK platter [/xyy]
;*                                  [#n  ]
;*
;*     THIS STATEMENT FORMATS A DISK PLATTER (CURRENTLY, ONLY
;*          2260C & 2280)
;*
FORMATD:
        CALL    PLATTER
        CALL    DISKSEL
        TEST    SL,2
        JZ      FORMATD2
formatd4:
        MOV     ECX,0           ;INITIALIZE RETRY COUNT
FORMATD3:
        INC     ECX
        PUSH    ECX

@3?PD0G:
        MOV     EDX,ACTDEV
        CMP     DL,40H
        JNZ     FORMATP1
        JMP     FRMTDRAM

FORMATP1:

; ------------------ 22c11-2 --------------
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dformat
; ----------------- 22c11-2 ---------------

        CALL    CMNDINIT
        MOV     R0,?AMEXTEND
        MOV     R2,?AMFORMAT
        CALL    DISKCMDC
        CMP     R0,0
        JZ      FORMATD1
;
        cmp     k,60h           ;ECHO = 60h indicates extended command reject
        jnz     retry_5

        mov     eax,actdev
        and     al,0f0h
        mov     k,al
        call    srchdev

        test    cl,devopen
        jnz     formte1e

        and     byte ptr [edx],0ffh-devuse
        mov     eax,actdev
        and     al,030h
        mov     byte ptr fs:[_abs],al
        mov     B_ABS,al
        mov     al,0
        call    cbsnr                           ;unhog device
        call    enblnlldh                       ;disable disk
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        mov     eax,actdev
        and     al,030h
        mov     r0,al
        call    wakeupa
        jmp     formt1ef

formte1e:
        and     byte ptr [edx],0ffh-devoip
        pop     eax
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,1
        call    breakptt
formt1ef:
        mov     edx,actdev
        call    enbldevd
        jmp     formatd4
;
retry_5:
        TEST    R0,0F0H
        JZ      FORMAT3A
        TEST    R0,0FH
        JZ      FORMAT3A
        JMP     ERROR_93
FORMAT3A:
        POP     ECX
        CMP     ECX,10H
        JNZ     FORMATD3
        JMP     ERROR_94

FORMATD1:
        POP     ECX
        MOV     K,0
        CALL    OBSDISK
        CALL    AKN1
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
FORMATD2:
        JMP     ENDSDISK

; -------------------- 22c11-2 ---------------
new_dformat:
        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],07h
        mov     edx,actdev
        and     dx,0fffh
        mov     word ptr gs:[edi+3],dx
        mov     edx,aux0e
        and     edx,0fh
        shl     edx,12
        or      word ptr gs:[edi+3],dx
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        movzx   edx,word ptr gs:[edi+3]
        mov     actdev,edx
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
        jmp     endsdisk
; ------------------ 22c11-2 --------------


;         TITLE     DREAD4S
;*     DREAD4S: READ UP TO 64 SEQUENTIAL SECTORS FROM DISK.
;*              WILL READ 64 SECTORS EXCEPT WHEN END SECTOR
;*              IS ENCOUNTERED -- CANNOT READ BEYOND END
;*              SECTOR, OR NOT THAT MUCH MEMORY AVAILABLE.
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXE = PLATTER SPEC.
;*               AUXC = ADDRESS OF I/O BUFFER (1K BYTES)
;*               AUXF = SECTOR ADDRESS OF 1ST SECTOR
;*                      TO READ
;*               F7,6 = END SECTOR ADDRESS (CANNOT READ
;*                      BEYOND THIS SECTOR)
;*               F1 = NO. OF PAGES OF MEMORY AVAILABLE FOR BUFS
;*
;*          RETURN: AUXF = SECTOR ADDRESS +1 OF LAST
;*                         SECTOR READ
;*                  F3 = NO. OF SECTORS READ
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,3,K
;*                              AUX0,C,F
;*
DREAD4S:

; ---------------- 22c11-2 ----------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dread4s
; ---------------- 22c11-2 ----------------

        MOV     BL,40H
        CMP     BL,R1
        JBE     BP43B_01
        MOV     BL,R1           ;BL = 64 IF #PAGES > 64
BP43B_01:                       ;     #PAGES IF #PAGES < 64
        MOV     R3,0            ; COUNT --- INCREASE ONE

DREAD4S1:
        MOV     EDX,AUX0C
        ADD     EDX,100H
        XCHG    EDX,AUX0C
        XCHG    EDX,AUX0F

        CMP     DWORD PTR A6,EDX
        JB      DREAD4S2
        PUSH    EBX
        CALL    DREAD
        POP     EBX
        ADD     R3,1
        CMP     R3,BL
        JB      DREAD4S1
        RET

DREAD4S2:
        MOV     AUX0F,EDX
        RET

; --------------- 22c11-2 -----------------
new_dread4s:
        MOVZX   EBX,WORD PTR GS:[EDX+BUFFER_SIZE]
        MOVZX   AX,R1
        CMP     BX,AX
        JBE     BP43B_01x
        MOV     BX,AX           ;BL = 64 IF #PAGES > 64
BP43B_01x:                      ;     #PAGES IF #PAGES < 64
        MOV     R3,0            ; COUNT --- INCREASE ONE

        PUSH    EDX

        mov     edx,aux0f
        CMP     DWORD PTR A6,EDX
        JB      NEW_DREAD4S2

        mov     eax,dword ptr [a6]
        sub     eax,edx
        inc     eax
        cmp     eax,ebx
        ja      new_dread4s9
        mov     ebx,eax

new_dread4s9:
        POP     EDX
        push    ebx

        push    edx
        mov     edx,aux0f
        mov     r0,0            ;read
        call    traced_new
        pop     edx

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],01h
        mov     eax,actdev
        and     ax,0fffh
        mov     word ptr gs:[edi+3],ax
        mov     eax,aux0e
        and     eax,0fh
        shl     eax,12
        or      word ptr gs:[edi+3],ax
        mov     eax,aux0f
        mov     byte ptr gs:[edi+6],ah
        mov     byte ptr gs:[edi+7],al
        shr     eax,16
        mov     byte ptr gs:[edi+5],al
        pop     ebx
        mov     word ptr gs:[edi+8],bx
        push    ebx
        mov     byte ptr gs:[edi+0ah],0
        mov     dword ptr gs:[edi+10h],edx   ;save edx
        mov     edx,aux0f
        mov     dword ptr gs:[edi+14h],edx   ;save aux0f
        mov     edx,aux0c
        mov     dword ptr gs:[edi+18h],edx   ;save aux0c
        mov     byte ptr gs:[edi],80h
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        push    edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        movzx   edx,word ptr gs:[edi+3]
        mov     actdev,edx
        mov     edx,dword ptr gs:[edi+18h]
        mov     aux0c,edx
        mov     edx,dword ptr gs:[edi+14h]
        mov     aux0f,edx
        mov     edx,dword ptr gs:[edi+10h]
        movzx   esi,part_
        shl     esi,2
        add     esi,offset buffer_addr
        mov     esi,dword ptr [esi]
        add     esi,edx

        mov     edi,aux0c
        pop     ebx
        movzx   ecx,bl
        shl     ecx,6

        push    ds
        push    gs
        pop     ds
        rep     movsd
        pop     ds
        add     aux0f,ebx
        mov     r3,bl
        mov     eax,cpbase
        mov     byte ptr [eax].@hogflg,0

new_dread4s2:
        ret
; ------------------- 22c11-2 -----------------


;         TITLE     MOVE
;*     MOVE: PROCESS A 'MOVE' STATEMENT
;*
;*          2600 FORMAT:
;*
;*     1. MOVE platter [ file#,] TO platter [ file#, ]  [LS=expr,] [END=expr]]
;*                     [disk-addr,]         [disk-addr,] [END=expr]
;*
;*     2. MOVE platter [ file#, ] filename TO platter
;*                     [disk-addr,]
;*
;*               [ file#,] [(expression)]
;*               disk-addr,   filename
;*
;*          2200 FORMAT:
;*
;*               MOVE [ file#, ] FR
;*                    disk-addr, RF
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'MOVE'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX3-F
;*
MOVE:
        mov     eax,dword ptr [cpbase]
        mov     dword ptr [eax].@toptr,0
        MOV     R0,@END
        CALL    CCL
        TEST    R0,0FH
        JNZ     BP43B_02
        JMP     MOVEEND

BP43B_02:
        CALL    HPION
        CALL    RAWOFF

        CALL    FRRF
        TEST    R0,0FH
        JZ      MOVE22F2
        CMP     BYTE PTR [TEXTPTR],'/'
        JE      M43_T3
        CMP     BYTE PTR [TEXTPTR],'#'
        JNE     M43_T4
M43_T3:
        INC     TEXTPTR
        JMP     COPY22F1
M43_T4:

;*     2600 FORMAT
;*
        call    test_plat

        CALL    PLATTER
        CALL    DISKSELC
        TEST    SL,2
        JZ      MOVE1

; ------------- 22c11-2 ---------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dmove1
; ------------- 22c11-2 ----------------

        CALL    CMNDINIT

; -------------- 22c11-2 -----------------
new_dmove1:
; -------------- 22c11-2 -----------------

        MOV     EDX,AUX0E
        MOV     AUX05,EDX       ;AUX05 -- 'FROM' PLATTER SPEC.
        MOV     EDX,ACTDEV
        MOV     AUX04,EDX       ;AUX04 -- 'FROM' DEVICE TYPE/ADDRESS
        MOV     AUX06,TEXTPTR   ;AUX06 -- TEXT PTR

        CALL    DREADS0
        MOV     EDX,DWORD PTR [CPBASE]
        mov     al,byte ptr [edx].@iobuffr
        mov     byte ptr [edx].@hashfl,al
        LEA     EDX,[EDX].@IOBUFFR
        MOVZX   ECX,BYTE PTR [EDX]
        MOV     AL,CL
        SHL     ECX,16
        CMP     AL,02H
        JE      M43_X1
        MOVZX   CX,BYTE PTR [EDX+1]

        JMP     M43_X2
M43_X1:
        MOV     CH,BYTE PTR [EDX+1]
        MOV     CL,BYTE PTR [EDX+2]
M43_X2:
        MOV     AUX07,ECX       ;AUX07(03) -- HASH FLAG & # INDEX SECTORS
        MOV     AUX03,ECX
        CMP     AL,02H
        JE      M43_X3

        XOR     ECX,ECX
        MOV     CH,BYTE PTR [EDX+4]    ;2 byte END CAT AREA          ^A09T
        MOV     CL,BYTE PTR [EDX+5]                                ; ^A09T
        JMP     M43_X4
M43_X3:
        MOVZX   ECX,BYTE PTR [EDX+6]   ;3 byte END CAT AREA          ^A09T  
        SHL     ECX,16
        MOV     CH,BYTE PTR [EDX+7]                                ; ^A09T
        MOV     CL,BYTE PTR [EDX+8]                                ; ^A09T
M43_X4:
        MOV     EDX,ACTDEV
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JE      M43_X5
        CMP     dl,40h
        JE      M43_X5
        AND     ECX,7FFFH
        DEC     ECX
        MOV     EDX,ECX
        JMP     M43_X6

M43_X5:
        MOV     EDX,ECX
        DEC     EDX

M43_X6:
        INC     EDX
        MOV     AUX08,EDX       ;AUX08 -- CURRENT END + 1

MOVE1:
        CALL    FILENAME
        CMP     R0,0
        JZ      MOVEF

;
; IF FILE FOUND , FALL THROUGH FOLLOWING SUBROUTINE
;
;*     MOVE ENTIRE CATALOG AREA
;*
;*          PLATTER MOVE ALGORITHM:
;*               1. SET UP INDEX ON 'TO' PLATTER (SAME
;*                  SIZE AS 'FROM' PLATTER)
;*               2. FOR EACH ACTIVE FILE ON 'FROM' PLATTER
;*                 A. FIND LOCATION FOR ENTRY IN 'TO'
;*                    PLATTER INDEX.
;*                 B. ADD FILE ENTRY TO 'TO' INDEX
;*                 C. COPY FILE FROM 'FROM' TO 'TO' PLATTR
;*
        CALL    CCLTO
        MOV     EDX,CPBASE              ;address CPBASE              ^A13T
        CMP     BYTE PTR [EBP],"'"      ;index format 1 indicator ?  ^A13T
        JNE     MOVEH1                  ;Jump if not                 ^A13T
        INC     EBP                            ;skip over it         ^A13T
        MOV     BYTE PTR [EDX].@HASHFL,01H     ;Hash flag = 1        ^A13T
        JMP     MOVEH2                         ;                     ^A13T

MOVEH1:                                 ;                            ^A13T
        CMP     BYTE PTR [EBP],"&"      ;index format 2 indicator ?  ^A13T
        JNE     MOVEH2                  ;Jump if not                 ^A13T
        INC     EBP                            ;skip over it         ^A13T
        MOV     BYTE PTR [EDX].@HASHFL,02H     ;Hash flag = 2        ^A13T

MOVEH2:                                        ;                     ^A13T
        MOV     AL,BYTE PTR [EDX].@HASHFL      ;Hash flag -> AUX03+2 ^A13T
        MOV     BYTE PTR AUX03+2,AL            ;                     ^A13T

        CALL    PLATTER
        CALL    DISKSELC

;*        CHECK IF INDEX SIZE SPECIFIED OR TAKE OLD INDEX SIZE
        MOV     R0,@LS?EQ
        CALL    CCL
        TEST    R0,0FH
        JNZ     MOVE6
        CALL    EXPR

        TEST    SL,2
        JZ      MOVE8
        CALL    FLTBIN_H1
        CMP     DWORD PTR [A0],0
        JE      MERR_34B

        MOV     EDX,CPBASE
        MOVZX   EDX,BYTE PTR [EDX].@HASHFL
        cmp     dl,02h
        je      move8x
        MOV     BYTE PTR [EDX].@HASHFL,01h
        mov     dl,01h
move8x:
        SHL     EDX,16
        MOV     DX,A0
        MOV     AUX03,EDX       ; AUX03 -- HASH FALG & NO. OF INDEX

MOVE8:
        CMP     BYTE PTR [TEXTPTR],','
        JNE     MOVE5
        INC     TEXTPTR

MOVE6:
        MOV     R0,@END
        CALL    CCL
        TEST    R0,0FH
        JNZ     MOVE5
        CMP     BYTE PTR [TEXTPTR],'='
        JNE     ERROR_12        ;BRANCH IF NOT MATCH
        INC     TEXTPTR
        CALL    EXPR
        TEST    SL,2
        JZ      MVCPYEND

;*        CREATE SPECIFIED INDEX


        CALL    FLTBIN_H2

        MOV     EAX,CPBASE
        MOV     BL,BYTE PTR [EAX].@HASHFL
        cmp     bl,02h
        je      move8y
        MOV     BYTE PTR [EAX].@HASHFL,01h
        mov     bl,01h
move8y:
        MOV     EDX,AUX03

        MOV     EAX,EDX
        SHR     EAX,16
        MOVZX   AX,BL
        SHL     EAX,16
        MOV     AX,DX
        MOV     EDX,EAX

        MOV     AUX03,EDX
        AND     EDX,0FFFFH      ;MASK THE HASH FLAG OUT
        CMP     DWORD PTR A0,EDX  ;R1R0 PAIR -- RETURN BINARY VALUE OF SUBROUTINE FLTBINB
        JB      MOVE7
        MOV     EDX,DWORD PTR A0
        INC     EDX
        MOV     AUX08,EDX       ;AUX08 -- END = ? CATALOG END
        JMP     MOVE5

;*        ERROR IF NO. OF INDEX SECTORS=0
;
MERR_34B:
        JMP     ERR_34B

;*        ERROR IF END<NO. OF INDEX SECTORS
;
MOVE7:
        JMP     ERROR_86

;*        USE OLD INDEX
;
MOVE5:
        TEST    SL,2
        JZ      MVCPYEND
MOVE2:

; ---------------- 22c11-2 -------------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dmove0
; ---------------- 22c11-2 -------------------

        CALL    CMNDINIT

; ----------------- 22c11-2 -------------------
new_dmove0:
; ----------------- 22c11-2 -------------------

;*
;*     THE FOLLOWING REGISTERS ARE NOW SET UP:
;*          AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*          AUX5 = 'FROM' PLATTER SPEC.
;*          ACTDEV = 'TO' DEVICE TYPE & ADDRESS
;*          AUXE = 'TO' PLATTER SPEC.
;*
        MOV     EDX,AUX03
        MOV     DWORD PTR A2,EDX
        MOV     AX,A3
        MOV     A4,AX

MOVE4:
        CALL    RHASHFLG
        MOV     AX,A4
        MOV     [EDX],AL
        MOV     EDX,AUX07
        SHL     EDX,16
        MOV     DX,01H
        MOV     AUX07,EDX       ; DH = # INDEX SECTOR; DL = ENTRY COUNT --- SAVE IN AUX07 FOR LATER USE

        MOV     EDX,0
        MOV     AUX06,EDX
        MOV     AX,A2
        MOV     A4,AX

        MOV     EDX,AUX08
        MOV     DWORD PTR A2,EDX
        CALL    INTINDX
        MOV     EDX,AUX0F
        MOV     AUX03,EDX
        CALL    COPYXA

;*     THE FOLLOWING REGISTERS ARE NOW SET UP
;*          ACTDEV = 'FROM' DEVICE TYPE & ADDRESS
;*          AUXE = 'FROM' PLATTER SPEC.
;*          AUX6 = CURRENT INDEX SECTOR ADDRESS
;*          AUX7,HIGH BYTE = NO. OF INDEX SECTORS
;*              ,LOW BYTE = NEXT ENTRY NO. (0-15)
;*
;*          AUX4 = 'TO' DEVICE TYPE & ADDRESS
;*          AUX5 = 'TO' PLATTER SPECIFICATION
;*          AUX3 = 'TO' CURRENT SECTOR ADDRESS
;*
;
;*RELEASE 2.1:  both disks now hogged for the entire move operation.
;
MOVE3:
        CALL    NEXTFILE
        TEST    R0,0FH
        JNZ     MVCPYEND
        test    r6,0fh
        JNZ     MOVE3
        mov     al,r7
        and     al,0f0h
        CMP     AL,80H
        JZ      BP43B_03
;
; cs-386 format
;
        cmp     al,40h
        jz      bp43b_03
;
        TEST    R7,0F0H
        JNZ     MOVE3

;*        CHECK THAT CATALOG END WILL NOT BE EXCEEDED
BP43B_03:                       ;SEE SUBROUTINE "NEXTFILE" IN BPMVP43C.ASM
        MOV     EBX,AUX0D
        SUB     EBX,AUX0B
        SUB     EBX,1
        ADD     EBX,AUX03
        CMP     EBX,AUX08
        JB      BP43B_04

        mov     edx,cpbase
        mov     ax,word ptr [edx].@soudev
        and     eax,0ffh
        cmp     ax,40h
        je      n_need5
        add     eax,offset plat
        mov     byte ptr [eax],00h              ;unhog plat
n_need5:
        mov     ax,word ptr [edx].@desdev
        and     eax,0ffh
        cmp     ax,40h
        je      n_need6
        add     eax,offset plat
        mov     byte ptr [eax],00h              ;unhog plat
n_need6:
        JMP     ERROR_81

BP43B_04:
        CALL    COPYXA
        MOVZX   EDX,R7
        MOV     AUX0A,EDX       ;BYTE PTR AUX0A = FILE TYPE
        MOV     EDX,AUX0B
        MOV     AUX0F,EDX       ;AUX0F = 'FROM' START ADDRESS

        CALL    COPYS
        MOV     EBX,AUX0D               ;ORIGIN SECTOR 2 -- 4
        SUB     EBX,AUX0B               ;BX=1
        SUB     EBX,1                   ;DEST  SECTOR  5 -- 7


        MOV     EDX,AUX03       ;AFTER CALLING SUBROUITNE "COPYS", AUX03 = "TO" END SECTOR + 1
        MOV     AUX0D,EDX
        DEC     AUX0D           ;AUX0D = "TO" EOF
        SUB     EDX,EBX
        SUB     EDX,1
        MOV     AUX0B,EDX
        DEC     AUX0B           ;AUX0B = "TO" SOF

        CALL    COPYXA
        CALL    FINDNAMH
        TEST    R3,0F0H
        JZ      BP43B_05
        JMP     ERROR_83
BP43B_05:
        test    r3,0fh
        jnz     error_85
        MOV     EDX,AUX0A
        MOV     AUX0A,3         ;FOR ADDIFILE -- CREATE A NEW FILE

        MOV     R7,DL
        CALL    ADDIFILE
        CALL    COPYXA
        JMP     MOVE3

;*     2200 FORMAT
;
;*
MOVE22F1:
        MOV     TEXTPTR,EDX
        CALL    DISKSELC
        CALL    FRRF
        CMP     R0,0
        JZ      MOVE22F3
        JMP     ERROR_19
MOVE22F3:
        TEST    SL,2
        JZ      MVCPYEND
        MOV     EDX,ACTDEV
        MOV     AUX04,EDX

; --------------- 22c11-2 ---------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dmove2
; --------------- 22c11-2 -----------------

        CALL    CMNDINIT

; --------------- 22c11-2 -----------------
new_dmove2:
; --------------- 22c11-2 -----------------

        CALL    COPYXA
        CALL    DREADS0
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     BL,BYTE PTR [EDX]
        CMP     BL,02H
        JE      MOVE2A_X
        MOVZX   CX,BYTE PTR [EDX+1]
        JMP     MOVE2A_Y
MOVE2A_X:
        MOV     CH,BYTE PTR [EDX+1]
        MOV     CL,BYTE PTR [EDX+2]
MOVE2A_Y:
        MOV     A2,CX

MOVE2A:
        CALL    RHASHFLG
        MOV     [EDX],BL        ;SAVE HASH GLAG
        MOVZX   EDX,R7
        SHL     EDX,16
        MOV     DX,01H
        MOV     AUX07,EDX       ;AUX07 -- SAME AS 2600 FORMAT

        MOV     EDX,0
        MOV     AUX06,EDX
        MOV     AX,A2
        MOV     A4,AX
        CALL    CATEND
        INC     EDX
        MOV     AUX08,EDX
        MOV     DWORD PTR A2,EDX

        CALL    COPYXA
        CALL    INTINDX
        MOV     EDX,AUX0F
        MOV     AUX03,EDX
        CALL    COPYXA
        JMP     MOVE3

MOVE22F2:
        CALL    DISKADRD
        JMP     MOVE22F3
;
;
;*     MOVE (APPEND) ONE FILE
;*
;*          ENTRY (EXECUTION PHASE):
;*               AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*               AUX5 = 'FROM' PLATTER SPEC.
;*               AUX6 = ADDRESS OF FILENAME IN TEXT LINE
;*               FILENAME ==> SCRATCH AREA (1ST 8 BYTES)
;*
;*          ALGORITHM:
;*               1. GET NAME OF FILE TO MOVE ('FILENAME')
;*               2. GET LIMITS OF FILE TO MOVE ('FINDNAMH'
;*                  (ERROR IF NF OR SCRATCHED)
;*               3. GET LIMITS OF WHERE FILE IS TO BE
;*                  MOVED TO
;*               4. ERROR IF FILE TOO LARGE FOR DESTINATIO
;*               5. MOVE FILE ('COPYS')
;*               6. WRITE EOF BLOCK ('DWRITE$')
;*               7. ADD FILENAME TO INDEX ('ADDIFILE')
;*
MOVEF:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@moveflag,1
        CALL    CCLTO
        CALL    PLATTER
        CALL    DISKSELC
        CALL    FILELOCS
        TEST    SL,2
        JZ      MVCPYEND

; --------------- 22c11-2 -----------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dmove3
; --------------- 22c11-2 -----------------

        CALL    CMNDINIT

; --------------- 22c11-2 ---------------
new_dmove3:
; --------------- 22c11-2 ----------------

        MOV     EDX,AUX06       ;EXCHANGE  TEXTPTR,AUX06 ONLY
        XCHG    EDX,TEXTPTR
        MOV     AUX06,EDX
        CALL    NEWNAMEF
        MOV     EDX,AUX0B
        MOV     AUX03,EDX       ;AUX03 = 'TO' SOF
        MOV     EDX,AUX0D
        MOV     AUX02,EDX       ;AUX02 = 'TO' EOF

        CALL    COPYXA
        CALL    FINDNAMH
        CMP     R3,10H
        JZ      BP43B_06
;
        mov     edx,cpbase
        mov     ax,word ptr [edx].@soudev
        and     eax,0ffh
        cmp     ax,40h
        je      n_need1
        add     eax,offset plat
        mov     byte ptr [eax],00h              ;unhog plat
n_need1:
        mov     ax,word ptr [edx].@desdev
        and     eax,0ffh
        cmp     ax,40h
        je      n_need2
        add     eax,offset plat
        mov     byte ptr [eax],00h              ;unhog plat
n_need2:
;
        JMP     ERROR_82

BP43B_06:
        MOV     TEXTPTR,AUX06   ;RESTORE TEXTPTR
        MOV     EDX,AUX0C
        MOV     CX,[EDX]
        XCHG    CH,CL
        ADD     AUX0C,2
        MOV     AUX06,ECX       ;SAVE FILE TYPE & STATUS
        CALL    GTFLPTRS        ;AUXB = 'FROM' SOF
                                ;AUXD = 'FROM' EOF
        MOV     EBX,AUX0D
        SUB     EBX,AUX0B
        SUB     EBX,1
        ADD     EBX,AUX03
        CMP     EBX,AUX02
        JB      BP43B_11

        mov     edx,cpbase
        mov     ax,word ptr [edx].@soudev
        and     eax,0ffh
        cmp     ax,40h
        je      n_need3
        add     eax,offset plat
        mov     byte ptr [eax],00h              ;unhog plat
n_need3:
        mov     ax,word ptr [edx].@desdev
        and     eax,0ffh
        cmp     ax,40h
        je      n_need4
        add     eax,offset plat
        mov     byte ptr [eax],00h              ;unhog plat
n_need4:
        JMP     ERROR_81

BP43B_11:
        CALL    COPYXA
        DEC     AUX0D

;*     THE FOLLOWING REGISTERS ARE NOW SET UP:
;*
;*          AUX4 = 'FROM' DEVICE TYPE & ADDRESS
;*          AUX5 = 'FROM' PLATTER
;*          AUXB = 'FROM' SOF ADDRESS
;*          AUXD = 'FROM' EOF ADDRESS -1
;*
;*          ACTDEV = 'TO' DEVICE TYPE & ADDRESS
;*          AUXE = 'TO' PLATTER
;*          AUX3 = 'TO' SOF ADDRESS
;*          AUX2 = 'TO' EOF ADDRESS (OLD)
;*
        MOV     EDX,AUX03
        XCHG    EDX,AUX0B
        MOV     AUX0F,EDX
        CALL    COPYS

        CALL    COPYXB
        MOV     EDX,AUX0F
        MOV     AUX0D,EDX
        MOV     EDX,AUX0A

;*_     FILE & CHECK EOF <= END CAT. AREA
        TEST    DL,2
        JNZ     BP43B_07
        MOV     EDX,AUX02
        MOV     AUX0D,EDX

BP43B_07:
        CALL    NEWEOF
        CALL    COPYXB
        CALL    DREADSF
        CALL    COPYXB
        MOV     EDX,AUX0D
        MOV     AUX0F,EDX

        CALL    DWRITE?DAF
        CALL    FINDNAMH
        MOV     EDX,AUX06
        MOV     R7,DL
        CALL    ADDIFILE

MVCPYEND:
        TEST    SL,2
        JZ      MVCPYEN1
        MOV     EAX,DWORD PTR [CPBASE]
        MOV     BYTE PTR [EAX].@MOVEFLAG,0
        CALL    ENDDISK
        CALL    COPYXA

        mov     ebx,cpbase
        mov     bx,[ebx].@soudev        ;we make some
        cmp     bx,340h
        jz      mvcpyend_1
        mov     r0,bl
        and     ebx,0ffh
        add     ebx,offset plat
        mov     byte ptr [ebx],0
        call    wakeupp
mvcpyend_1:
        mov     ebx,cpbase
        mov     bx,[ebx].@desdev        ;we make some
        cmp     bx,340h
        jz      mvcpyen1
        mov     r0,bl
        and     ebx,0ffh
        add     ebx,offset plat
        mov     byte ptr [ebx],0
        call    wakeupp

MVCPYEN1:
        JMP     ENDSDISK

;         TITLE     DWRITENS
;*     DWRITENS: WRITE N SEQUENTIAL SECTORS TO DISK WHERE
;*               DATA TO WRITE IS LOCATED SEQUENTIALLY IN
;*               I/O BUFFER. READ-AFTER-WRITE IS NOT
;*               PERFORMED.
;*
;*          ENTRY: PHASE = EXECUTION
;*               DISK ENABLED
;*               AUXC = ADDRESS OF I/O BUFFER
;*               AUXF = SECTOR ADDRESS OF 1ST SECTOR TO
;*                      WRITE
;*               AUXE = PLATTER SPECIFICATION
;*               F3 = NO. OF SECTORS TO WRITE
;*
;*          RETURN: AUXF = SECTOR ADDRESS +1 OF LAST
;*                         SECTOR WRITTEN
;*                  F3 = 0
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,3,K
;*                              AUX0,C,F
;*
DWRITENS:

; ------------- 22c11-2 ---------------
        mov     edx,actdev
        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        jne     new_dwritens
; ------------- 22c11-2 ---------------

        MOV     EDX,AUX0C
        ADD     EDX,100H
        XCHG    EDX,AUX0C
        XCHG    EDX,AUX0F
        CALL    DWRITE
        DEC     R3
        JNZ     DWRITENS
        RET

; ------------------ 22c11-2 --------------
new_dwritens:
        push    edx
        mov     edx,aux0f
        mov     r0,40h
        call    traced_new
        pop     edx

        MOVZX   EBX,WORD PTR GS:[EDX+BUFFER_SIZE]
        MOVZX   EAX,R3
        CMP     EBX,EAX
        JAE     NEW_DWRITENS3
        sub     eax,ebx
        mov     r3,al

        movzx   edi,part_
        shl     edi,2
        add     edi,offset buffer_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     esi,aux0c
        mov     ecx,ebx
        shl     ecx,6
        push    es
        push    gs
        pop     es
        rep     movsd
        pop     es

        push    edx
        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],02h
        mov     edx,actdev
        and     dx,0fffh
        mov     word ptr gs:[edi+3],dx
        mov     edx,aux0e
        and     edx,0fh
        shl     edx,12
        or      word ptr gs:[edi+3],dx
        mov     edx,aux0f
        mov     byte ptr gs:[edi+6],dh
        mov     byte ptr gs:[edi+7],dl
        shr     edx,16
        mov     byte ptr gs:[edi+5],dl
        mov     eax,ebx
        mov     word ptr gs:[edi+8],ax
        mov     byte ptr gs:[edi+0ah],0
        mov     byte ptr gs:[edi],80h
        movzx   eax,r3
        push    eax
        push    aux0c
        push    ebx
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        pop     ebx
        pop     aux0c
        pop     eax
        mov     r3,al
        pop     edx
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
        movzx   eax,word ptr gs:[edi+3]
        mov     actdev,eax
        add     aux0f,ebx
        shl     ebx,8
        add     aux0c,ebx
        jmp     new_dwritens

NEW_DWRITENS3:
        movzx   edi,part_
        shl     edi,2
        add     edi,offset buffer_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     esi,aux0c
        movzx   ecx,r3
        shl     ecx,6
        push    es
        push    gs
        pop     es
        rep     movsd
        pop     es

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],02h
        mov     edx,actdev
        and     dx,0fffh
        mov     word ptr gs:[edi+3],dx
        mov     edx,aux0e
        and     edx,0fh
        shl     edx,12
        or      word ptr gs:[edi+3],dx
        mov     edx,aux0f
        mov     byte ptr gs:[edi+6],dh
        mov     byte ptr gs:[edi+7],dl
        shr     edx,16
        mov     byte ptr gs:[edi+5],dl
        movzx   ax,r3
        mov     word ptr gs:[edi+8],ax
        mov     byte ptr gs:[edi+0ah],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
        movzx   edx,word ptr gs:[edi+3]
        mov     actdev,edx
        movzx   eax,r3
        add     aux0f,eax
        ret
; ------------------ 22c11-2 --------------


$copy:
        call    avard                   ;scan and process an alpha variable
        test    r0,0fh
        jz      $copy1                  ;f, branch
        mov     r0,29h
        jmp     error                   ;missing alpha variable
$copy1: cmp     byte ptr [textptr],'('
        jne     error_10                ;missing ( letter
        inc     textptr
        call    expr                    ;scan and evaluate start position
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        call    expr                    ;scan and evaluate field length
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        call    expr                    ;scan and evaluate skip length
        cmp     byte ptr [textptr],')'
        jne     error_11                ;missing ) letter
        inc     textptr
        call    cclto                   ;look for TO

        call    avard                   ;scan and process an alpha variable
        test    r0,0fh
        jz      $copy2                  ;f, branch
        mov     r0,29h
        jmp     error                   ;missing alpha variable
$copy2: cmp     byte ptr [textptr],'('
        jne     error_10                ;missing ( letter
        inc     textptr
        call    expr                    ;scan and evaluate start position
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        call    expr                    ;scan and field length
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        call    expr                    ;scan and evaluate skip length
        cmp     byte ptr [textptr],')'
        jne     error_11                ;missing ) letter
        inc     textptr

        test    sl,2
        jz      $copy99

        push    aux0c

        mov     aux0c,1                 ;default repeaet = 1
$copy99:
        mov     edx,offset _repeat
        call    ccnl
        test    r0,0fh
        jnz     $copy5                  ;missing keyword
        call    expr

        test    sl,2
        jz      $copy5

        push    aux01
        push    aux02
        push    aux03
        push    aux04
        push    aux05
        push    aux06
        push    aux07
        push    aux08
        push    aux09
        push    aux0b

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,2
        jne     error_34
        mov     eax,dword ptr [a0]
        mov     aux0c,eax               ;repeaet count
$copy5:
        test    sl,2
        jz      $copy4                  ;branch if not execution phase

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,0                    ;xxx-07/11
        je      $copy91
        cmp     r2,2
        jne     error_34
$copy91:
        mov     eax,dword ptr [a0]
        mov     aux09,eax               ;skip length of reciever

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,2
        jne     error_34
        mov     eax,dword ptr [a0]
        mov     aux0b,eax               ;field length of reciever

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,2
        jne     error_34
        mov     eax,dword ptr [a0]
        mov     aux08,eax               ;start position of reciever
        mov     eax,vsptr
        mov     ebx,dword ptr [eax]
        mov     aux07,ebx               ;define length of reciever
        mov     ebx,dword ptr [eax+4]
        mov     aux06,ebx               ;address of reciever
        add     vsptr,8

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,0
        je      $copy92
        cmp     r2,2
        jne     error_34
$copy92:
        mov     eax,dword ptr [a0]
        mov     aux05,eax               ;skip length of sender

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,2
        jne     error_34
        mov     eax,dword ptr [a0]
        mov     aux04,eax               ;field length of sender

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,2
        jne     error_34
        mov     eax,dword ptr [a0]
        mov     aux03,eax               ;start position of sender

        mov     eax,vsptr
        mov     ebx,dword ptr [eax]
        mov     aux02,ebx               ;define length of sender
        mov     ebx,dword ptr [eax+4]
        mov     aux01,ebx               ;address of sender
        add     vsptr,8

        mov     eax,aux01
        add     eax,aux02               ;limit of sender

        mov     esi,aux01
        add     esi,aux03               ;start of sender
        dec     esi

        mov     ebx,aux06
        add     ebx,aux07               ;limit of reciever

        mov     edi,aux06
        add     edi,aux08               ;start of reciever
        dec     edi

$copy3:
;       call    breakptg

        dec     aux0c

        mov     edx,eax
        sub     edx,esi
        cmp     edx,aux04
        jb      error_34

        mov     edx,ebx
        sub     edx,edi
        cmp     edx,aux0b
        jb      error_34

        mov     ecx,aux04
        cmp     ecx,aux0b                       ;sender field < reciever
        jb      $copy6
        mov     edx,aux04
        sub     edx,aux0b
        mov     ecx,aux0b
        rep     movsb
        add     esi,edx
        jmp     $copy7
$copy6:
        mov     edx,aux0b
        sub     edx,ecx
        rep     movsb
        add     edi,edx
$copy7:
        mov     edx,eax
        sub     edx,esi
        cmp     aux0c,0
        je      $copy93
        cmp     edx,aux05
        jb      error_34
$copy93:
        add     esi,aux05

        mov     edx,ebx
        sub     edx,edi
        cmp     aux0c,0
        je      $copy94
        cmp     edx,aux09
        jb      error_34
$copy94:
        add     edi,aux09

        cmp     aux0c,0
        jne     $copy3

        pop     aux0b
        pop     aux09
        pop     aux08
        pop     aux07
        pop     aux06
        pop     aux05
        pop     aux04
        pop     aux03
        pop     aux02
        pop     aux01
        pop     aux0c

$copy4: jmp     endstmt


; ----- utl ----
public  $move
$move:
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [textptr],"!"
        jne     $move7
        inc     textptr
        mov     byte ptr [eax].@form,1
        jmp     $move8
$move7:
        cmp     byte ptr [textptr],"&"
        jne     error_16
        inc     textptr
        mov     byte ptr [eax].@form,2
$move8:
        call    platter
        call    diskselc
        test    sl,2
        jz      $move1
        mov     eax,dword ptr [cpbase]
        mov     edx,actdev
        mov     dword ptr [eax].@from_dev,edx
$move1:
        call    filename
        cmp     r0,0
        jz      $movef

        call    cclto
        call    platter
        call    diskselc
        test    sl,2
        jz      $move18
        mov     eax,dword ptr [cpbase]
        mov     edx,actdev
        mov     dword ptr [eax].@to_dev,edx
$move18:
        call    filename
        cmp     r0,0
        jnz     $move19
        test    sl,2
        jz      endstmt
        call    file_status
        jmp     $move20
$move19:
        test    sl,2
        jz      endstmt
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@f_flag,0
$move20:
        mov     edx,dword ptr [eax].@from_dev
        call    enbldevd
        call    dreads0
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@iobuffr
        lea     edi,[eax].@m_buffer
        cmp     byte ptr [esi],02
        jne     $move9
        xor     ebx,ebx
        mov     bh,byte ptr [esi+1]
        mov     bl,byte ptr [esi+2]
        jmp     $move10
$move9:
        movzx   ebx,byte ptr [esi+1]
$move10:
        mov     dword ptr [eax].@sector_end,ebx
        mov     dword ptr [eax].@sector_start,0
        mov     dword ptr [eax].@entry_no,1
        mov     ecx,64
        rep     movsd
$move11:
        call    set_filename
        jc      $move12
        call    $move_file
        jmp     $move11

$move12:
        call    enddiskr
        call    write_trial
        jmp     enterf

$movef:
        test    sl,2
        jz      $move2
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@workspc
        lea     edi,[eax].@from_file
        mov     ecx,2
        rep     movsd
$move2:
        call    cclto
        call    platter
        call    diskselc
        test    sl,2
        jz      $move28
        mov     eax,dword ptr [cpbase]
        mov     edx,actdev
        mov     dword ptr [eax].@to_dev,edx
$move28:
        call    filename
        cmp     r0,0
        jnz     $move29
        test    sl,2
        jz      endstmt
        call    file_status
        jmp     $move30
$move29:
        test    sl,2
        jz      endstmt
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@f_flag,0
$move30:
        call    $move_file
        call    write_trial
        jmp     enterf


$move_file:
        mov     eax,cpbase
        mov     dl,byte ptr [eax].@form
        mov     byte ptr [eax].@type,dl
        pop     edx
        mov     dword ptr [eax].@back_addr,edx
        mov     edx,dword ptr [eax].@from_dev
        mov     esi,offset program2
        add     esi,8
        mov     bl,dl
        and     bl,0f0h
        shr     bl,4
        or      bl,30h
        mov     byte ptr [esi+1],bl
        mov     bl,dl
        and     bl,0fh
        or      bl,30h
        cmp     bl,39h
        jbe     $move_file1
        add     bl,07h
$move_file1:
        mov     byte ptr [esi+2],bl
        mov     bl,dh
        and     bl,0fh
        or      bl,30h
        cmp     bl,39h
        jbe     $move_file2
        add     bl,07h
$move_file2:
        mov     byte ptr [esi],bl
        lea     edx,[eax].@from_file
        mov     ecx,dword ptr [edx]
        mov     dword ptr [esi+5],ecx
        mov     ecx,dword ptr [edx+4]
        mov     dword ptr [esi+9],ecx
        mov     edx,dword ptr [eax].@to_dev
        mov     esi,offset program3
        add     esi,8
        mov     bl,dl
        and     bl,0f0h
        shr     bl,4
        or      bl,30h
        mov     byte ptr [esi+1],bl
        mov     bl,dl
        and     bl,0fh
        or      bl,30h
        cmp     bl,39h
        jbe     $move_file3
        add     bl,07h
$move_file3:
        mov     byte ptr [esi+2],bl
        mov     bl,dh
        and     bl,0fh
        or      bl,30h
        cmp     bl,39h
        jbe     $move_file4
        add     bl,07h
$move_file4:
        mov     byte ptr [esi],bl
        lea     edx,[eax].@from_file
        mov     ecx,dword ptr [edx]
        mov     dword ptr [esi+5],ecx
        mov     ecx,dword ptr [edx+4]
        mov     dword ptr [esi+9],ecx

        mov     edx,textends
        add     edx,5
        mov     esi,offset program1
        mov     edi,edx
        movzx   ecx,byte ptr [esi]
        add     edx,ecx
        dec     edx
        inc     esi
        rep     movsb
        mov     textend,edx
        add     edx,minbuf+minvs+0ah
        mov     dword ptr [@@vsend],edx
        mov     edx,cpbase
        mov     ecx,offset ret1
        mov     dword ptr [edx].@ret_addr,ecx
        lea     edx,[edx].@osbeg
        add     edx,64
        mov     dword ptr [@@osend],edx
        mov     sl,0
        jmp     procst

ret1:
        call    enddiskr
        mov     edx,textends
        add     edx,5
        mov     esi,offset program2
        mov     edi,edx
        movzx   ecx,byte ptr [esi]
        add     edx,ecx
        dec     edx
        inc     esi
        rep     movsb
        mov     textend,edx
        add     edx,minbuf+minvs+0ah
        mov     dword ptr [@@vsend],edx
        mov     edx,cpbase
        mov     ecx,offset ret2
        mov     dword ptr [edx].@ret_addr,ecx
        lea     edx,[edx].@osbeg
        add     edx,64
        mov     dword ptr [@@osend],edx
        mov     sl,0
        jmp     procst

ret2:
        call    enddiskr
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@errf,0
        jne     ret3
        mov     edx,textends
        add     edx,5
        mov     esi,offset program3
        mov     edi,edx
        movzx   ecx,byte ptr [esi]
        add     edx,ecx
        dec     edx
        inc     esi
        rep     movsb
        mov     textend,edx
        add     edx,minbuf+minvs+0ah
        mov     dword ptr [@@vsend],edx
        mov     edx,cpbase
        mov     ecx,offset ret3
        mov     dword ptr [edx].@ret_addr,ecx
        lea     edx,[edx].@osbeg
        add     edx,64
        mov     dword ptr [@@osend],edx
        mov     sl,0
        mov     eax,dword ptr [cpbase]
        mov     edx,counts
        mov     dword ptr [eax].@mode,edx
        and     dh,0fh
        cmp     byte ptr [eax].@type,1
        jne     $move_file5
        or      dh,10h
$move_file5:
        mov     counts,edx
        jmp     procst

ret3:
        call    enddiskr
        mov     eax,cpbase
        cmp     byte ptr [eax].@errf,0
        jne     display_err

ret4:
        mov     edx,textends
        add     edx,5
        mov     esi,offset program4
        mov     edi,edx
        movzx   ecx,byte ptr [esi]
        add     edx,ecx
        dec     edx
        inc     esi
        rep     movsb
        mov     textend,edx
        add     edx,minbuf+minvs+0ah
        mov     dword ptr [@@vsend],edx
        mov     edx,cpbase
        mov     ecx,offset ret5
        mov     dword ptr [edx].@ret_addr,ecx
        lea     edx,[edx].@osbeg
        add     edx,64
        mov     dword ptr [@@osend],edx
        mov     sl,0
        jmp     procst

ret5:
        mov     eax,dword ptr [cpbase]
        mov     edx,dword ptr [eax].@mode
        mov     counts,edx
        mov     byte ptr [eax].@type,0
        mov     byte ptr [eax].@errf,0
        call    enddiskr
        mov     eax,dword ptr [cpbase]
        mov     eax,dword ptr [eax].@back_addr
        jmp     eax

display_err:
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@f_flag,1
        je      display_errx
        mov     al,byte ptr [eax].@errf
        cmp     al,05h
        je      display_err1
        cmp     al,83h
        je      display_err2
        cmp     al,85h
        je      display_err3
        cmp     al,86h
        je      display_err4
        cmp     al,06h
        je      display_err5
        cmp     al,01h
        je      display_err6

        mov     edx,offset message
        mov     edi,offset message
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd

        mov     ah,al
        shr     ah,4
        or      ah,30h
        and     al,0fh
        or      al,30h
        mov     byte ptr [edx+18],ah
        mov     byte ptr [edx+19],al
        call    enblco
        mov     edx,offset display_out
        call    wrtstrcm
        jmp     ret4

display_err1:
        mov     edx,offset message1
        mov     edi,offset message1
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd

        mov     eax,dword ptr [eax].@spreg1
        mov     bl,byte ptr [eax]
        shr     bl,4
        or      bl,30h
        mov     byte ptr [edx+23],bl

        mov     bl,byte ptr [eax]
        and     bl,0fh
        or      bl,30h
        mov     byte ptr [edx+24],bl

        mov     bl,byte ptr [eax+1]
        shr     bl,4
        or      bl,30h
        mov     byte ptr [edx+25],bl

        mov     bl,byte ptr [eax+1]
        and     bl,0fh
        or      bl,30h
        mov     byte ptr [edx+26],bl

        call    enblco
        mov     edx,offset display_out1
        call    wrtstrcm
        jmp     ret4

display_err2:
        mov     edi,offset message2
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        call    enblco
        mov     edx,offset display_out2
        call    wrtstrcm
        jmp     ret4

display_err3:
        mov     edi,offset message2
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        call    enblco
        mov     edx,offset display_out3
        call    wrtstrcm
        jmp     ret4

display_err4:
        mov     edi,offset message2
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        call    enblco
        mov     edx,offset display_out4
        call    wrtstrcm
        jmp     ret4

display_err5:
        mov     mode,0
        mov     edi,offset message5
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        call    enblco
        mov     edx,offset display_out5
        call    wrtstrcm
        jmp     ret4

display_err6:
        mov     edi,offset message6
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        call    enblco
        mov     edx,offset display_out6
        call    wrtstrcm
        jmp     ret4

program1 db     08,'CLEAR P',0dh
program2 db     22,'LOAD T/D??,"????????"',0dh
program3 db     22,'SAVE T/D??,"????????"',0dh
program4 db     08,'CLEAR P',0dH

message  db     "????????",4 dup(20h),"ERROR(??)",0dh
display_out     db  22
                dd  offset message

message1 db     "????????",4 dup(20h),"ERROR(05)",2 dup(20h),"????",2 dup(20h),"Line Too Long",0dh
display_out1    db  43
                dd  offset message1

message2 db     "????????",4 dup(20h),"ERROR(83)",2 dup(20h),"File Already Exists",0dh
display_out2    db  43
                dd  offset message2

message3 db     "????????",4 dup(20h),"ERROR(85)",2 dup(20h),"Index Full",0dh
display_out3    db  34
                dd  offset message3

message4 db     "????????",4 dup(20h),"ERROR(86)",2 dup(20h),"Catalog End Error",0dh
display_out4    db  41
                dd  offset message4

message5 db     "????????",4 dup(20h),"ERROR(06)",2 dup(20h),"Program Protected",0dh
display_out5    db  41
                dd  offset message5

message6 db     "????????",4 dup(20h),"ERROR(01)",2 dup(20h),"Not Enough Memory",0dh
display_out6    db  41
                dd  offset message6

set_filename:
        mov     eax,dword ptr [cpbase]
set5:
        cmp     dword ptr [eax].@entry_no,16
        ja      set1
        lea     esi,[eax].@m_buffer
        mov     ecx,dword ptr [eax].@entry_no
        shl     ecx,4
        add     esi,ecx
        cmp     byte ptr [esi],10h
        jne     set2
        cmp     byte ptr [esi+1],80h
        jne     set3
        jmp     set4
set3:
        cmp     byte ptr [esi+1],40h
        jne     set2
        jmp     set4
set2:   inc     dword ptr [eax].@entry_no
        jmp     set5
set1:
        inc     dword ptr [eax].@sector_start
        mov     edx,dword ptr [eax].@sector_start
        cmp     edx,dword ptr [eax].@sector_end
        je      set6
        mov     edx,dword ptr [eax].@from_dev
        call    enbldevd
        mov     eax,dword ptr [cpbase]
        mov     edx,dword ptr [eax].@sector_start
        mov     aux0f,edx
        call    dreadsf
        mov     eax,dword ptr [cpbase]
        mov     dword ptr [eax].@entry_no,0
        lea     esi,[eax].@iobuffr
        lea     edi,[eax].@m_buffer
        mov     ecx,64
        rep     movsd
        jmp     set5
set6:   stc
        ret
set4:
        inc     dword ptr [eax].@entry_no
        add     esi,8
        lea     edi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        clc
        ret

file_status:
        mov     eax,dword ptr [cpbase]
        mov     dword ptr [eax].@f_entry_no,0
        lea     edi,[eax].@f_buffer
        mov     ecx,40h
        mov     eax,0
        rep     stosd
        mov     eax,dword ptr [cpbase]
        mov     edx,dword ptr [eax].@to_dev
        call    enbldevd
        call    findnamh
        cmp     r3,10h
        je      file_s1
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@f_flag,0
        ret
file_s1:
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@f_flag,1
        mov     edx,aux0c
        cmp     r2,02h
        jne     file_s2
        movzx   ebx,byte ptr [edx+2]
        shl     ebx,16
        mov     bh,byte ptr [edx+3]
        mov     bl,byte ptr [edx+4]
        mov     dword ptr [eax].@start_sec,ebx
        mov     dword ptr [eax].@current_sec,ebx
        movzx   ebx,byte ptr [edx+5]
        shl     ebx,16
        mov     bh,byte ptr [edx+6]
        mov     bl,byte ptr [edx+7]
        mov     dword ptr [eax].@end_sec,ebx
        jmp     file_s3
file_s2:
        xor     ebx,ebx
        mov     bh,byte ptr [edx+2]
        mov     bl,byte ptr [edx+3]
        mov     dword ptr [eax].@start_sec,ebx
        mov     dword ptr [eax].@current_sec,ebx
        xor     ebx,ebx
        mov     bh,byte ptr [edx+4]
        mov     bl,byte ptr [edx+5]
        mov     dword ptr [eax].@end_sec,ebx
file_s3:
        ret

display_errx:
        mov     mode,0
        mov     eax,dword ptr [cpbase]
        mov     ecx,dword ptr [eax].@current_sec
        cmp     ecx,dword ptr [eax].@end_sec
        je      ret4

        cmp     dword ptr [eax].@f_entry_no,16
        ja      display_errx7

        lea     edi,[eax].@f_buffer
        mov     ecx,dword ptr [eax].@f_entry_no
        shl     ecx,4
        add     edi,ecx
        lea     esi,[eax].@from_file
        mov     ecx,2
        rep     movsd
        mov     cl,byte ptr [eax].@errf
        mov     ch,cl
        shr     ch,4
        or      ch,30h
        mov     byte ptr [edi],ch
        and     cl,0fh
        or      cl,30h
        mov     byte ptr [edi+1],cl
        cmp     byte ptr [eax].@errf,05h
        jne     display_errx8
        mov     byte ptr [edi+2],30h
        mov     byte ptr [edi+3],30h
        mov     ecx,dword ptr [eax].@spreg1
        mov     bl,byte ptr [ecx]
        shr     bl,4
        or      bl,30h
        mov     byte ptr [edi+4],bl

        mov     bl,byte ptr [ecx]
        and     bl,0fh
        or      bl,30h
        mov     byte ptr [edi+5],bl

        mov     bl,byte ptr [ecx+1]
        shr     bl,4
        or      bl,30h
        mov     byte ptr [edi+6],bl

        mov     bl,byte ptr [ecx+1]
        and     bl,0fh
        or      bl,30h
        mov     byte ptr [edi+7],bl
        jmp     display_errx9

display_errx8:
        mov     dword ptr [edi+2],20202020h
        mov     word ptr [edi+6],2020h

display_errx9:
        inc     dword ptr [eax].@f_entry_no
        jmp     ret4

display_errx7:
        mov     edx,dword ptr [eax].@to_dev
        call    enbldevd

        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@f_buffer
        lea     edi,[eax].@iobuffr
        mov     ecx,40h
        rep     movsd

        mov     edx,dword ptr [eax].@current_sec
        mov     aux0f,edx
        call    dwrite?daf

        mov     eax,dword ptr [cpbase]
        inc     dword ptr [eax].@current_sec
        mov     dword ptr [eax].@f_entry_no,0
        lea     edi,[eax].@f_buffer
        mov     ecx,40h
        mov     eax,0
        rep     stosd
        jmp     ret4

write_trial:
        mov     eax,dword ptr [cpbase]
        cmp     dword ptr [eax].@f_entry_no,0
        je      write_trial_1
        lea     esi,[eax].@f_buffer
        lea     edi,[eax].@iobuffr
        mov     ecx,40h
        rep     movsd

        mov     edx,dword ptr [eax].@current_sec
        inc     dword ptr [eax].@current_sec
        mov     aux0f,edx

        mov     edx,dword ptr [eax].@to_dev
        call    enbldevd

        call    dwrite?daf

write_trial_1:
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@f_flag,1
        jne     write_trial_3
        mov     edx,dword ptr [eax].@current_sec
        cmp     edx,dword ptr [eax].@end_sec
        jne     write_trial_2
        lea     edi,[eax].@f_buffer
        mov     ecx,40h
        mov     eax,0
        rep     stosd

        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@f_buffer
        mov     byte ptr [esi],0a0h
        mov     edx,dword ptr [eax].@current_sec
        mov     ebx,dword ptr [eax].@start_sec
        sub     edx,ebx
        inc     edx
        mov     byte ptr [esi+1],dh
        mov     byte ptr [esi+2],dl
        shr     edx,16
        mov     byte ptr [esi+3],dl
        lea     edi,[eax].@iobuffr
        mov     ecx,40h
        rep     movsd
        mov     edx,dword ptr [eax].@end_sec
        mov     aux0f,edx

        mov     edx,dword ptr [eax].@to_dev
        call    enbldevd
        call    dwrite?daf
        ret

write_trial_2:
        lea     edi,[eax].@f_buffer
        mov     ecx,40h
        mov     eax,0
        rep     stosd
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@f_buffer
        mov     byte ptr [esi],0a0h
        lea     edi,[eax].@iobuffr
        mov     ecx,40h
        rep     movsd
        mov     edx,dword ptr [eax].@current_sec
        mov     aux0f,edx

        mov     edx,dword ptr [eax].@to_dev
        call    enbldevd
        call    dwrite?daf

        mov     eax,dword ptr [cpbase]
        lea     edi,[eax].@f_buffer
        mov     ecx,40h
        mov     eax,0
        rep     stosd
        mov     eax,dword ptr [cpbase]
        lea     esi,[eax].@f_buffer
        mov     byte ptr [esi],0a0h
        mov     edx,dword ptr [eax].@current_sec
        mov     ebx,dword ptr [eax].@start_sec
        sub     edx,ebx
        inc     edx
        mov     byte ptr [esi+1],dh
        mov     byte ptr [esi+2],dl
        shr     edx,16
        mov     byte ptr [esi+3],dl
        lea     edi,[eax].@iobuffr
        mov     ecx,40h
        rep     movsd
        mov     edx,dword ptr [eax].@end_sec
        mov     aux0f,edx

        mov     edx,dword ptr [eax].@to_dev
        call    enbldevd
        call    dwrite?daf
write_trial_3:
        ret

;----- utl ----


public  $rotate
$rotate:
        cmp     byte ptr [textptr],'('
        jne     error_10                ;missing ( lettler
        inc     textptr
        call    avard                   ;scan and process an alpha variable
        test    r0,0fh
        jz      $rotate1                ;f, branch
        mov     r0,29h
        jmp     error                   ;missing alpha variable

$rotate1:
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        call    expr                    ;scan and evaluate field length
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        call    expr                    ;scan and evaluate skip length
        cmp     byte ptr [textptr],','
        jne     error_13                ;missing , letter
        inc     textptr
        mov     cl,0
        cmp     byte ptr [textptr],'-'
        jne     $rotate11
        mov     cl,1
        inc     textptr
$rotate11:
        mov     eax,cpbase
        mov     byte ptr [eax].@ok,cl
        call    expr                    ;scan and evaluate skip length
        cmp     byte ptr [textptr],')'
        jne     error_11                ;missing ) letter
        inc     textptr

        test    sl,2
        jz      $rotate4

        push    aux00
        push    aux01
        push    aux02
        push    aux03
        push    aux04

        call    fltbin                  ;convert fl.pt to binary
        cmp     r2,0
        je      $rotate31
        cmp     r2,2
        jne     error_34
$rotate31:
        mov     eax,dword ptr [a0]
        mov     aux04,eax               ;rotate length

        call    fltbin                  ;convert fl.pt to binary
;       cmp     r2,0
;       je      $rotate32
        cmp     r2,2
        jne     error_34
$rotate32:
        mov     eax,dword ptr [a0]
        dec     eax
        mov     aux03,eax               ;ending address of ahpha variable

        call    fltbin                  ;convert fl.pt to binary
;       cmp     r2,0
;       je      $rotate33
        cmp     r2,2
        jne     error_34
$rotate33:
        mov     eax,dword ptr [a0]
        dec     eax
        mov     aux02,eax               ;starting address of alpha variable

        mov     eax,vsptr
        mov     ebx,dword ptr [eax]
        mov     aux01,ebx               ;define length of reciever
        mov     ebx,dword ptr [eax+4]
        mov     aux00,ebx               ;address of reciever
        add     vsptr,8

        cmp     aux04,4096
        ja      error_34

        mov     eax,aux03
        cmp     eax,aux01
        ja      error_34

        cmp     eax,aux02
        jb      error_34

        sub     eax,aux02
        cmp     eax,aux04
        jb      error_34

;       call    breakptg                        ;check 30ms

        mov     eax,cpbase
        cmp     byte ptr [eax].@ok,0
        jne     $rotate34
        mov     esi,aux00
        add     esi,aux02
        mov     ecx,aux04
        mov     edi,offset r_buffer
        rep     movsb

        mov     edi,aux00
        add     edi,aux02
        mov     ecx,aux03
        sub     ecx,aux02
        inc     ecx
        sub     ecx,aux04
        rep     movsb

        mov     esi,offset r_buffer
        mov     ecx,aux04
        rep     movsb
        jmp     $rotate35

$rotate34:
        mov     esi,aux00
        mov     eax,aux03
        sub     eax,aux04
        inc     eax
        add     esi,eax
        mov     edi,offset r_buffer
        mov     ecx,aux04
        rep     movsb

        sub     esi,aux04
        dec     esi
        mov     ecx,esi
        sub     ecx,aux00
        inc     ecx
        sub     ecx,aux02

        mov     edi,aux00
        add     edi,aux03

        std
        rep     movsb
        cld

        mov     esi,offset r_buffer
        mov     edi,aux00
        add     edi,aux02
        mov     ecx,aux04
        rep     movsb

$rotate35:
        pop     aux04
        pop     aux03
        pop     aux02
        pop     aux01
        pop     aux00

$rotate4:
        jmp     endstmt

public  $clear
$clear:
        CALL    DEVADDR
        test    sl,2
        jz      $clear_ret
        CMP     R0,15H
        JB      $CLEAR_RET
        CMP     R0,18H
        JA      $CLEAR_RET
        movzx   eax,R0
        and     eax,0ffh
        sub     eax,15h
        shl     eax,2
        add     eax,offset print_addr
        cmp     dword ptr [eax],0
        je      $CLEAR_RET
        mov     eax,dword ptr [eax]
        and     eax,0f00000h
        mov     ch,part_
        mov     byte ptr gs:[eax+PRT_RESET],ch
$clear_ret:
        jmp     endstmt

public  $scsi
public  $scsi_read
public  $scsi_write
public  $scsi_inquery
public  $scsi_config
public  $scsi_format
public  $scsi_id

$scsi:
        MOV     EDX,OFFSET _SCSILST
        CALL    CCJB
        JMP     $SCSI_READ
        JMP     $SCSI_WRITE
        JMP     $SCSI_INQUERY
        JMP     $SCSI_CONFIG
        JMP     $SCSI_FORMAT
        JMP     $SCSI_CACHE
        JMP     $SCSI_TAPE
        JMP     $SCSI_ID
        JMP     ERROR_19

$scsi_read:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsi_read2
        call    fltbina
        cmp     dword ptr [a0],7
        ja      error_34
        mov     eax,dword ptr [a0]
$scsi_read2:
        push    eax
        call    avard
        pop     eax
        test    r0,0fh
        jnz     error_29

        test    sl,xphase
        jz      $scsi_read1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],17h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi+3],al
        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        movzx   esi,part_
        shl     esi,2
        add     esi,offset buffer_addr
        mov     esi,dword ptr [esi]
        add     esi,edx
        mov     edi,vsptr
        mov     ecx,dword ptr [edi]
        mov     edi,dword ptr [edi+4]
        cmp     ecx,512
        jbe     $scsi_read3
        mov     ecx,512
$scsi_read3:
        push    ds
        push    gs
        pop     ds
        rep     movsb
        pop     ds
        add     vsptr,8
$scsi_read1:
        jmp     endsdisk

$scsi_write:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsi_write2
        call    fltbina
        cmp     dword ptr [a0],7
        ja      error_34
        mov     eax,dword ptr [a0]
$scsi_write2:
        push    eax
        call    avard
        pop     eax
        test    r0,0fh
        jnz     error_29

        test    sl,xphase
        jz      $scsi_write1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset buffer_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     esi,vsptr
        mov     ecx,dword ptr [esi]
        mov     esi,dword ptr [esi+4]
        cmp     ecx,512
        jbe     $scsi_write3
        mov     ecx,512
$scsi_write3:
        push    es
        push    gs
        pop     es
        rep     movsb
        pop     es
        add     vsptr,8

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     byte ptr gs:[edi+1],18h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi+3],al
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsi_write1:
        jmp     endsdisk

$scsi_inquery:
        call    platter
        call    disksel
        test    sl,xphase
        jz      $scsi_inquery1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],15h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsi_inquery1:
        jmp     endsdisk

$scsi_config:
        call    platter
        call    disksel

        call    avard
        test    r0,0fh
        jnz     error_29

        test    sl,xphase
        jz      $scsi_config1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],16h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        movzx   esi,part_
        shl     esi,2
        add     esi,offset buffer_addr
        mov     esi,dword ptr [esi]
        add     esi,edx
        mov     edi,vsptr
        mov     ecx,dword ptr [edi]
        mov     edi,dword ptr [edi+4]
        cmp     ecx,768
        jbe     $scsi_config3
        mov     ecx,768
$scsi_config3:
        push    ds
        push    gs
        pop     ds
        rep     movsb
        pop     ds
        add     vsptr,8
$scsi_config1:
        jmp     endsdisk

$scsi_format:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsi_format2
        call    fltbina
        cmp     dword ptr [a0],7
        ja      error_34
        mov     eax,dword ptr [a0]
$scsi_format2:
        test    sl,xphase
        jz      $scsi_format1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],19h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi+3],al
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsi_format1:
        jmp     endsdisk

$scsi_cache:
        mov     edx,offset _scsiclst
        call    ccjb
        jmp     $scsicache_enable
        jmp     $scsicache_disable
        jmp     error_19

$scsicache_enable:
        call    platter
        call    disksel
        test    sl,xphase
        jz      $scsi_enable

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1ah
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsi_enable:
        jmp     endsdisk

$scsicache_disable:
        call    platter
        call    disksel
        test    sl,xphase
        jz      $scsi_disable

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1bh
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsi_disable:
        jmp     endsdisk

$scsi_id:
        call    platter
        call    disksel

        call    avard
        test    r0,0fh
        jnz     error_29

        test    sl,xphase
        jz      $scsi_id1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],29h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        movzx   esi,part_
        shl     esi,2
        add     esi,offset buffer_addr
        mov     esi,dword ptr [esi]
        add     esi,edx
        mov     edi,vsptr
        mov     ecx,dword ptr [edi]
        mov     edi,dword ptr [edi+4]
        cmp     ecx,3
        jbe     $scsi_id3
        mov     ecx,3
$scsi_id3:
        push    ds
        push    gs
        pop     ds
        rep     movsb
        pop     ds
        add     vsptr,8
$scsi_id1:
        jmp     endsdisk

PUBLIC  $SCSI_TAPE
PUBLIC  $SCSITAPE_READ
PUBLIC  $SCSITAPE_WRITE
PUBLIC  $SCSITAPE_REWIND
PUBLIC  $SCSITAPE_ERASE
PUBLIC  $SCSITAPE_RETENSION
PUBLIC  $SCSITAPE_BACKUP
PUBLIC  $SCSITAPE_LOCATE
PUBLIC  $SCSITAPE_WRITEMARK
PUBLIC  $SCSITAPE_READMARK
PUBLIC  $SCSITAPE_RESTORE
PUBLIC  $SCSITAPE_ENDDATA

$SCSI_TAPE:
        MOV     EDX,OFFSET _SCSITLST
        CALL    CCJB
        JMP     $SCSITAPE_READ
        JMP     $SCSITAPE_WRITE
        JMP     $SCSITAPE_REWIND
        JMP     $SCSITAPE_ERASE
        JMP     $SCSITAPE_RETENSION
        JMP     $SCSITAPE_BACKUP
        JMP     $SCSITAPE_LOCATE
        JMP     $SCSITAPE_WRITEMARK
        JMP     $SCSITAPE_READMARK
        JMP     $SCSITAPE_RESTORE
        JMP     $SCSITAPE_ENDDATA
        JMP     ERROR_19

$SCSITAPE_READ:
        call    platter
        call    disksel

        call    avard
        test    r0,0fh
        jnz     error_29

        test    sl,xphase
        jz      $scsitape_read1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

$scsitape_read3:
        movzx   eax,word ptr gs:[edx+buffer_size]
        mov     ebx,eax
        and     al,0feh
        shl     eax,8
        mov     edi,vsptr
        mov     ecx,dword ptr [edi]
        cmp     ecx,eax
        jbe     $scsitape_read2

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1fh
        mov     byte ptr gs:[edi+2],0
        mov     word ptr gs:[edi+8],bx
        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi

        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        movzx   esi,part_
        shl     esi,2
        add     esi,offset buffer_addr
        mov     esi,dword ptr [esi]
        add     esi,edx
        mov     edi,vsptr
        mov     edi,dword ptr [edi+4]
        movzx   ecx,word ptr gs:[edx+buffer_size]
        shl     ecx,6
        push    ecx
        push    ds
        push    gs
        pop     ds
        rep     movsd
        pop     ds
        pop     ecx
        shl     ecx,2
        mov     esi,vsptr
        sub     dword ptr [esi],ecx
        add     dword ptr [esi+4],ecx
        jmp     $scsitape_read3

$scsitape_read2:
        mov     ebx,ecx
        shr     ebx,8
        test    ecx,0ffh
        je      $scsitape_read4
        inc     ebx
$scsitape_read4:
        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1fh
        mov     byte ptr gs:[edi+2],0
        mov     word ptr gs:[edi+8],bx
        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

        movzx   esi,part_
        shl     esi,2
        add     esi,offset buffer_addr
        mov     esi,dword ptr [esi]
        add     esi,edx
        mov     edi,vsptr
        mov     ecx,dword ptr [edi]
        mov     edi,dword ptr [edi+4]
        push    ds
        push    gs
        pop     ds
        rep     movsb
        pop     ds
        add     vsptr,8

$scsitape_read1:
        jmp     endsdisk

$SCSITAPE_WRITE:
        call    platter
        call    disksel

        call    avard
        test    r0,0fh
        jnz     error_29

        test    sl,xphase
        jz      $scsitape_write1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

$scsitape_write3:
        movzx   eax,word ptr gs:[edx+buffer_size]
        mov     ebx,eax
        and     al,0feh
        shl     eax,8
        mov     edi,vsptr
        mov     ecx,dword ptr [edi]
        cmp     ecx,eax
        jbe     $scsitape_write2

        movzx   edi,part_
        shl     edi,2
        add     edi,offset buffer_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     esi,vsptr
        mov     ecx,ebx
        mov     esi,dword ptr [esi+4]
        shl     ecx,6
        push    es
        push    gs
        pop     es
        rep     movsd
        pop     es

        mov     esi,vsptr
        mov     ecx,ebx
        shl     ecx,8
        sub     dword ptr [esi],ecx
        add     dword ptr [esi+4],ecx

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     byte ptr gs:[edi+1],20h
        mov     byte ptr gs:[edi+2],0
        mov     word ptr gs:[edi+8],bx
        mov     byte ptr gs:[edi],80h
        push    edx
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        pop     edx
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
        jmp     $scsitape_write3

$scsitape_write2:
        mov     ebx,ecx
        shr     ebx,8
        test    ecx,0ffh
        je      $scsitape_write4
        inc     ebx
$scsitape_write4:
        movzx   edi,part_
        shl     edi,2
        add     edi,offset buffer_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     esi,vsptr
        mov     ecx,dword ptr [esi]
        mov     esi,dword ptr [esi+4]
        push    es
        push    gs
        pop     es
        rep     movsb
        pop     es

        add     vsptr,8

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx
        mov     byte ptr gs:[edi+1],20h
        mov     byte ptr gs:[edi+2],0
        mov     word ptr gs:[edi+8],bx
        mov     byte ptr gs:[edi],80h
        push    edx
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        pop     edx
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_write1:
        jmp     endsdisk

$SCSITAPE_REWIND:
        call    platter
        call    disksel
        test    sl,xphase
        jz      $scsiTAPE_REWIND1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1ch
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsiTAPE_REWIND1:
        jmp     endsdisk

$SCSITAPE_ERASE:
        call    platter
        call    disksel
        test    sl,xphase
        jz      $scsiTAPE_ERASE1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1dh
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsiTAPE_ERASE1:
        jmp     endsdisk

$SCSITAPE_RETENSION:
        call    platter
        call    disksel
        test    sl,xphase
        jz      $scsiTAPE_RETENSION1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],1eh
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi],80h
        push    edi
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error
$scsiTAPE_RETENSION1:
        jmp     endsdisk


$SCSITAPE_LOCATE:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsitape_locate2
        call    fltbinb
        cmp     dword ptr [a0],0ffffffh
        ja      error_34
        mov     eax,dword ptr [a0]
$scsitape_locate2:
        test    sl,xphase
        jz      $scsitape_locate1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],22h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi+6],ah
        mov     byte ptr gs:[edi+7],al
        shr     eax,16
        mov     byte ptr gs:[edi+5],al

        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_locate1:
        jmp     endsdisk


$SCSITAPE_writemark:
        call    platter
        call    disksel

        test    sl,xphase
        jz      $scsitape_writemark1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],23h
        mov     byte ptr gs:[edi+2],0

        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_writemark1:
        jmp     endsdisk


$SCSITAPE_readmark:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsitape_readmark2
        call    fltbinb
        cmp     dword ptr [a0],0ffffffh
        ja      error_34
        mov     eax,dword ptr [a0]
$scsitape_readmark2:
        test    sl,xphase
        jz      $scsitape_readmark1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],24h
        mov     byte ptr gs:[edi+2],0
        mov     byte ptr gs:[edi+6],ah
        mov     byte ptr gs:[edi+7],al
        shr     eax,16
        mov     byte ptr gs:[edi+5],al

        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_readmark1:
        jmp     endsdisk

$SCSITAPE_ENDDATA:
        call    platter
        call    disksel

        test    sl,xphase
        jz      $scsitape_ENDDATA1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],28h
        mov     byte ptr gs:[edi+2],0

        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_ENDDATA1:
        jmp     endsdisk


$scsitape_backup:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],','
        jne     error_12
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsitape_backup2
        call    fltbinb
        cmp     dword ptr [a0],0ffffffh
        ja      error_34
        mov     eax,dword ptr [a0]
        push    eax
        call    fltbinb
        cmp     dword ptr [a0],0ffffffh
        ja      error_34
        mov     eax,dword ptr [a0]
        pop     ebx
$scsitape_backup2:
        test    sl,xphase
        jz      $scsitape_backup1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],21h
        mov     byte ptr gs:[edi+2],0
        mov     ecx,actdev
        mov     word ptr gs:[edi+3],cx
        mov     byte ptr gs:[edi+6],ah
        mov     byte ptr gs:[edi+7],al
        shr     eax,16
        mov     byte ptr gs:[edi+5],al
        mov     byte ptr gs:[edi+9],bh
        mov     byte ptr gs:[edi+10],bl
        shr     ebx,16
        mov     byte ptr gs:[edi+8],bl

        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_backup1:
        jmp     endsdisk


$scsitape_restore:
        call    platter
        call    disksel

        cmp     byte ptr [textptr],'('
        jne     error_10
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],','
        jne     error_12
        inc     textptr
        call    expr
        cmp     byte ptr [textptr],')'
        jne     error_11
        inc     textptr
        test    sl,2
        jz      $scsitape_restore2
        call    fltbinb
        cmp     dword ptr [a0],0ffffffh
        ja      error_34
        mov     eax,dword ptr [a0]
        push    eax
        call    fltbinb
        cmp     dword ptr [a0],0ffffffh
        ja      error_34
        mov     eax,dword ptr [a0]
        pop     ebx
$scsitape_restore2:
        test    sl,xphase
        jz      $scsitape_restore1

        mov     edx,actdev
        cmp     dl,40h
        jz      error_94

        and     edx,0f0h
        shr     edx,2
        add     edx,offset disk_addr
        mov     edx,dword ptr [edx]
        cmp     edx,0
        je      error_94

        movzx   edi,part_
        shl     edi,2
        add     edi,offset command_addr
        mov     edi,dword ptr [edi]
        add     edi,edx

        mov     byte ptr gs:[edi+1],27h
        mov     byte ptr gs:[edi+2],0
        mov     ecx,actdev
        mov     word ptr gs:[edi+3],cx
        mov     byte ptr gs:[edi+6],ah
        mov     byte ptr gs:[edi+7],al
        shr     eax,16
        mov     byte ptr gs:[edi+5],al
        mov     byte ptr gs:[edi+9],bh
        mov     byte ptr gs:[edi+10],bl
        shr     ebx,16
        mov     byte ptr gs:[edi+8],bl

        mov     byte ptr gs:[edi],80h
        push    edi
        push    edx
        movzx   eax,part_
        shl     eax,2
        add     eax,offset part_addr
        mov     dword ptr [eax],edi
        call    breakpta
        pop     edx
        pop     edi
        cmp     byte ptr gs:[edi+2],0
        jne     new_error

$scsitape_restore1:
        jmp     endsdisk

CODE    ENDS
        END
