;============================================================================
;
;       D E V I C E   C O N T R O L   S U B R O U T I N E S 
;
;============================================================================
;         This module was originally M05
;============================================================================
          .XLIST
          INCLUDE PREAMBLE
          .LIST

PUBLIC    ACKDISCT
PUBLIC    A$TRACE
PUBLIC    ATCOL0E
PUBLIC    BADDRESS
PUBLIC    CBSNR
PUBLIC    CBSNT
PUBLIC    CBSTROBE
PUBLIC    CHKDVRB
PUBLIC    CNSLMSG
PUBLIC    CPRNTCR
PUBLIC    CPRNTCRX
PUBLIC    CPRNTCRZ
PUBLIC    DELAY10
PUBLIC    DELAY2?PD6
PUBLIC    DELAY5
PUBLIC    DEVICEG
PUBLIC    DEVICET
PUBLIC    DEVSPEC
PUBLIC    DEVSPECT
PUBLIC    DISABLE
PUBLIC    DISPATTR
PUBLIC    ENBLCNT
PUBLIC    ENBLCNT3
PUBLIC    ENBLCNTA
PUBLIC    ENBLCO
PUBLIC    ENBLDEVA
PUBLIC    ENBLDEVB
PUBLIC    ENBLDEVD
PUBLIC    ENBLDEVG
PUBLIC    ENBLDEVI
PUBLIC    ENBLDEVO
PUBLIC    ENBLLIST
PUBLIC    ENBLNLLD
PUBLIC    ENBLNLLDH
PUBLIC    ENBLNULL
PUBLIC    ENBLSCO
PUBLIC    ERROR92
PUBLIC    FILE_A
PUBLIC    FILE_A5
PUBLIC    FILE_ADR
PUBLIC    FILE_B
PUBLIC    FILE_PTR
PUBLIC    IBSENDIB
PUBLIC    OBSBLK
PUBLIC    OBSBLKNT
PUBLIC    OBSCMPRS
PUBLIC    OBSCMPSP
PUBLIC    OBSN09
PUBLIC    OBSNR
PUBLIC    OBSNT
PUBLIC    OBSNTC
PUBLIC    OBSTROBD
PUBLIC    OBSTROBE
PUBLIC    PRINTV
PUBLIC    PRINTVA
PUBLIC    PRNTCR
PUBLIC    RESETDSK
PUBLIC    SDRVRDEV
PUBLIC    SRCHPLT
PUBLIC    TRACELIN
PUBLIC    TRACELNA
PUBLIC    TRACELNB
PUBLIC    TRACEVAR
PUBLIC    TRACEVRA
PUBLIC    TWRIT2SP
PUBLIC    TWRIT3SP
PUBLIC    TWRIT4SP
PUBLIC    TWRIT6SP
PUBLIC    TWRITCOL
PUBLIC    TWRITE
PUBLIC    TWRITE0C
PUBLIC    TWRITE0F
PUBLIC    TWRITE3X
PUBLIC    TWRITEP
PUBLIC    TWRITESP
PUBLIC    TWRITNSP
PUBLIC    TWRITEMN
PUBLIC    TWRT30SP
PUBLIC    WAIT16RB
PUBLIC    WAIT50RB
PUBLIC    WAIT50RBx
PUBLIC    WAITIBS
PUBLIC    WAITIBSE
PUBLIC    WAITIBSF
PUBLIC    WAITRDY
PUBLIC    WAITRDYB
PUBLIC    WORDLENA
PUBLIC    WRT@
PUBLIC    WRT@ORSP
PUBLIC    WRTBLK
PUBLIC    WRTBLKB
PUBLIC    WRTDADDR
PUBLIC    WRTDADRF
PUBLIC    WRTHEX
PUBLIC    WRTHEXB
PUBLIC    WRTHEXCH
PUBLIC    WRTHEXS
PUBLIC    WRTLINE_
PUBLIC    WRTLIN_2
PUBLIC    WRTLIN_4
PUBLIC    WRTNIB
PUBLIC    WRTVAL
PUBLIC    WRTVAL16
PUBLIC    WRTVAL8
PUBLIC    WRTVALA
PUBLIC    WRTVNAME
PUBLIC    WRTVNAMF
PUBLIC    WRTWORD
PUBLIC    WRTWORDF
PUBLIC    enbldvx7


EXTRN     ACCEPTLR    :NEAR
EXTRN     BINDEC      :NEAR
EXTRN     BREAKPTD    :NEAR
EXTRN     BREAKPTT    :NEAR
EXTRN     BREAKPTW    :NEAR
EXTRN     BREAKPTA    :NEAR
EXTRN     BREAKPTB    :NEAR
EXTRN     BREAKPTC    :NEAR
EXTRN     BREAKPTK    :NEAR
EXTRN     CHARTABL    :NEAR
EXTRN     CPBASE      :NEAR
EXTRN     DISPSTAR    :NEAR
EXTRN     DEV?AMTERM  :NEAR
EXTRN     DEVADDRS    :NEAR
EXTRN     DRVRMAIN    :NEAR
EXTRN     ENTERF      :NEAR
EXTRN     ERROR       :NEAR
EXTRN     ERR_00      :NEAR
EXTRN     ERROR_01    :NEAR
EXTRN     ERROR_34    :NEAR
EXTRN     ERROR_48    :NEAR
EXTRN     ERROR_52    :NEAR
EXTRN     ESCTABL     :NEAR
EXTRN     FLTBINA     :NEAR
EXTRN     GETDRDEV    :NEAR
EXTRN     GETTERM_    :NEAR
EXTRN     INTEGER     :NEAR
EXTRN     LITERAL     :NEAR
EXTRN     MDEVDISP    :DWORD
EXTRN     MXD2SADR    :BYTE
EXTRN     MXD3SADR    :BYTE
EXTRN     MXD4SADR    :BYTE
EXTRN     MATDSPLA    :NEAR
EXTRN     MSTRTABL    :NEAR
EXTRN     ORG0100     :NEAR
EXTRN     OBSECHO     :NEAR
EXTRN     PART_       :BYTE
EXTRN     PDFLAG      :BYTE
EXTRN     PMODE       :BYTE
EXTRN     PTERM       :BYTE
EXTRN     QUERYLR     :NEAR
EXTRN     RFILE_      :NEAR
EXTRN     RPARTEND    :NEAR
EXTRN     RQSTDEV     :BYTE
EXTRN     RQSTPLAT    :BYTE
EXTRN     RQSTLINE    :NEAR
EXTRN     SRCHDEV     :NEAR
EXTRN     SRCHDEVA    :NEAR
EXTRN     SRCHDEVP    :NEAR
EXTRN     TEMPSAVE    :BYTE
EXTRN     TCGIO       :NEAR
EXTRN     TRACDSBL    :NEAR
EXTRN     TRNSFMSG    :NEAR
EXTRN     VAR         :NEAR
EXTRN     WAITRDB6    :NEAR
EXTRN     WAKEUP      :NEAR
EXTRN     WAKEUPA     :NEAR
EXTRN     WAKEUPP     :NEAR
EXTRN     WRTSTRCM    :NEAR
EXTRN     _DEVCO      :NEAR
EXTRN     $CLOSED     :NEAR
EXTRN     PLAT        :NEAR
EXTRN     CMNDPLAT    :NEAR
EXTRN     ENDDISK     :NEAR
EXTRN     PLAT_S      :NEAR
EXTRN     hog_table   :NEAR

;         TITLE     CPRNTCR/PRINTCR
;*     PRNTCR: OUTPUT A CR WITH AN OBS STROBE.
;*
;*     CPRNTCR: OUTPUT A CR WITH AN OBS STROBE IF NOT
;*              AT BEGIN OF LINE (IE, CHARCNT = 0).
;*
;*     CPRNTCRX:  OUTPUT A CR IF NOT AT BEGIN OF LINE,
;*              OR IF DEVICE TYPE 4, OR IF LINE WIDTH=0.
;*
;*          DESCRIPTION:
;*               CR IS OUPUT WITH AN OBS STROBE.
;*             IF A PAUSE IS SELECTED, PAUSE OCCURS
;*             IMMEDIATELY AFTER 'CR' IS STROBED.
;*               DEVICE TYPE DETERMINES
;*               WHETHER LF, NULL, OR NOTHING IS STROBED
;*               AFTER CR.
;*                    DEVICE TYPE 2: 00 STROBED AFTER CR
;*                                7: NOTHING STROBED
;*                        OTHERWISE: LF STROBED AFTER CR
;*             IF DISPLAY IN STEPS SELECTED AND NUMBER
;*             OF LINES OUTPUT = LL-1, A BRANCH IS MADE
;*             TO 'ENTER'.  PRESSING A CR ON KEYBOARD
;*             WILL CAUSE A SUBROUTINE RETURN BACK TO
;*             ROUTINE THAT CALLED 'TWRITE' (OR 'PRNTCR').
;*         (LL IS GENERALLY 15 OR 24, FROM SELECT LINES)
;*
;*          MODIFIED REGISTERS: F1,K
;*                   CHCL - ONLY IF LISTS OR LISTD MODE
;*
CPRNTCRX:
        MOV     EAX,ACTDEV
        AND     AH,0FH
        CMP     AH,4
        JZ      PRNTCR                  ;SKIP IF DEVICE TYPE 4
CPRNTCRZ:
        MOV     EAX,CHARCNT
        CMP     AH,0
        JZ      PRNTCR                  ;SKIP IF LINE WIDTH = 0
CPRNTCR:
        MOV     EAX,CHARCNT
        CMP     AL,0
        JZ      PRNTCR1                 ;RETURN IF AT BEGIN OF LINE
PRNTCR:
        MOV     K,0DH                   ;STROBE (OBS) CR
        CALL    OBSTROBE
PRNTCRA:
        PUSH    EDX
        MOV     EDX,COUNTS
        TEST    DH,0FH                  ;BRANCH IF NO SELECT P
        JZ      PRNTCR5
        MOV     K,DH                    ;DELAY COUNT ==> K
        AND     K,0FH
        MOV     EDX,ACTDEV
        AND     DL,38H
        JNZ     PRNTCR5                 ;BRANCH IF NOT MXD
        OR      K,?AMSELECTP
        CALL    CBSTROBE                ;SELECT P COMMAND ==> MXD
PRNTCR5:
        MOV     BYTE PTR CHARCNT,0      ;CHARCNT = 0
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,7                    ;
        JZ      PRNTCR2                 ;BRANCH IF DEVICE TYPE = 7 (NOTHING STROBE)
        MOV     K,0AH
        CMP     DH,2                    ;STROEB LF AFTER CR IF DEVICE TYPE =
        JNE     BP5B_01
        MOV     K,0                     ;OTHERWISE STROBE 00 AFTER CR FOR DEVICE TYPE 2
BP5B_01:
        CALL    OBSTROBE                ;STROBE LF OR 0

;*   IF LIST D mode bit is on, and the line width is
;*      defined to at least 5, then follow the
;*      carriage return with 4 spaces.
PRNTCR2:
        TEST    MODE,1000H              ;skip if not 'LIST D' mode
        JZ      PRNTCR28
        AND     MODE,0EFFFH             ;turn off 'LIST D' mode
        CALL    PRNTCR27
        OR      MODE,1000H              ;turn 'LIST D' mode back on

        MOV     EDX,CHARCNT
        CMP     DH,6
        JB      PRNTCR11                ;branch if defined width < 6
        CALL    TWRIT3SP
        CALL    TWRIT3SP                ;output 6 space
PRNTCR11:
        POP     EDX
PRNTCR1:
        RET

PRNTCR27:
        PUSH    EDX
PRNTCR28:
        TEST    MODE,4000H
        JZ      PRNTCR11                ;EXIT IF NOT IN DISPLAY-STEP MODE
        INC     COUNTS                  ;INCREMENT LINE COUNT
        MOV     AL,BYTE PTR COUNTS
        MOV     R1,AL                   ;F1 = NO. OF LINE COUNT
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@LINES
        MOV     CH,BYTE PTR [EDX]
        CMP     R1,CH
        JB      PRNTCR11                ;BRANCH IF NO. OF LINES < SELECTED MAX.

;*   LIST S - WAIT FOR CARRIAGE RETURN
        CALL    ENBLCO
        MOV     K,':'
        CALL    TWRITE

;* THE FOLLOWING LOGIC IS NEW FOR 2236 (REPLACES 2226 LOGIC) --
PRNTCR42:
        PUSH    DWORD PTR R4
        PUSH    DWORD PTR R0
        MOV     WORD PTR R6,LRLEN       ;max size = 400 bytes
        MOV     R3,0                    ;not edit, not underline

;* LINE REQUEST
        CALL    RQSTLINE                ;ENABLE CONTROL ADDRESS, SELECT TERMINAL, LINE REQ

;* END OF LINE REQUEST
        MOV     AL,?AMENDLRT
        CALL    CBSNT                   ;END LINE REQUEST

;* BREAKPOINT -- UNTIL LINE REQUEST COMPLETE
PRNTCR43:
        CALL    BREAKPTD

;*
;*  ALL REGISTERS WERE SAVED AND RESTORED;
;*  ADDRESS 06 AS BEEN ENABLED BY BREAKPT LOGIC
;* QUERY LINE REQUEST
        MOV     R5,0                    ;CI MODE
        CALL    QUERYLR                 ;GET LR TERMINATOR

;*QUERYLR: GET LINE REQUEST TERMINATOR FROM MXD
;*
;*     RETURN:
;*          F3 = TERMINAL CHARACTER (00 = NOT TERMINATED)
;*                                  (FF = RECALL)
;*                                  (ELSE, TERMINATION CHAR.)
;*          F2 = TERMINAL STATUS (BIT 04 = 1 IFF TERMINATOR
;*               WITH ENDI -- IE, SF)
;*
;*     MODIFIED REGISTERS: K,F2,F3
;*
        TEST    R2,20H
        JNZ     PRNTCR45                ;BRANCH IF HALT ON
        TEST    R2,4
        JNZ     PRNTCR45                ;BRANCH IF ENDI ON
        CMP     R3,0
        JZ      PRNTCR43                ;BRANCH IF LR NOT COMPLETE
        CMP     R3,0FFH
        JZ      PRNTCR45                ;BRANCH IF RECALL
        CMP     R3,0FEH
        JZ      PRNTCR45                ;BRANCH IF STMT#

;* ACCEPT LINE REQUEST
PRNTCR44:
        CALL    ACCEPTLR                ;GET DATA COUNT FROM MXD
        MOV     AX,WORD PTR FS:[CPUST]  ;ENDI OFF
        MOV     BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
BP5B_02:
        TEST    BYTE PTR FS:[CPUST],2
        JZ      BP5B_02
        MOV     AL,BYTE PTR FS:[IBGET]
        MOV     K,AL
        TEST    BYTE PTR FS:[CPUST],04H
        JNZ     PRNTCR54                ;BRANCH IF 'CR' ONLY
PRNTCR45:
        JMP     ENTERF

;*  CARRIAGE RETURN PRESSED,  CONTINUE LISTS
PRNTCR54:
        MOV     AX,WORD PTR FS:[CPUST]  ;ENDI OFF
PRNTCR55:
        MOV     BYTE PTR COUNTS,1
        POP     DWORD PTR R0
        POP     DWORD PTR R4
        CALL    ENBLLIST                ;RE-ENABLE LIST DEVICE
        POP     EDX                     ;RESTORE PC'S AND EXIT
        RET

;* LISTSOFF
LISTSOFF:
        AND     MODE,0A7FCH             ;0A7 = LIST OFF, 0FC = IMMEDIATE MODE OFF
        AND     SL,EPHASE               ;PHASE = ENTRY
        RET

;         TITLE     ENBLDEVX
;*ENBLDEVX: ENABLE DEVICE IF --
;*               1. DEFINED IN MASTER DEVICE TABLE (MDT).
;*               2. NOT OPEN BY SOME OTHER PARTITION.
;*               3. NOT MXD DEVICE ADDRESS (IE, BITS 38 OFF)
;*                  OR DISK.
;*
;*          ERR#48 IF NOT DEFINED OR IF MXD ADDRESS OR DISK.
;*
;*          BREAKPOINT & SLEEP UNTIL DEVICE BECOMES AVAILABLE
;*               IF OPEN BY ANOTHER PARTITION.
;*
;*     ENTRY: K = DEVICE ADDRESS
;*
;*     MODIFIED REGISTERS: NONE
;*
ENBLDEVX:
        TEST    K,8
        JNZ     ENBLDVX1
        TEST    K,30H
        JZ      ENBLDVX9                ;BRANCH IF MXD DEVICE ADDRESS OR 00

ENBLDVX1:
        PUSH    EDX
;AAA    PUSH    DWORD PTR A0
        PUSH    WORD PTR R0
        PUSH    CX
        CALL    ENBLDVXA
        TEST    CL,DEVTDISK
        JNZ     ERR_48D

;
;*Set ACTIOBS logic added in Rel. 1.9.
ENBLDVX3:
        MOV     DL,K
        MOV     BYTE PTR FS:[_ABS],DL
        call    delay5
        MOV     ACTIOBS,EDX

ENBLDVX2:
        POP     CX
        MOV     BYTE PTR [TEMPSAVE],CH
        MOV     BYTE PTR [TEMPSAVE+1],CL
        POP     WORD PTR R0
;AAA    POP     DWORD PTR A0
        POP     EDX
        RET

ENBLDVX9:
        TEST    K,0FH
        JNZ     ERR_48D
        TEST    K,0F0H
        JNZ     ENBLDVX1
        JMP     ENBLDEVB

;         TITLE     ENBLDVXA
;*ENBLDVXA: WAIT FOR DEVICE TO BECOME AVAILABLE.
;*
;*          IF DEVICE IS OPENED BY SOME OTHER PARTITION,
;*          BREAKPOINT & WAIT FOR DEVICE.
;*
;*          ERR#48 IF NOT DEFINED OR IF MXD ADDRESS.
;*
;*     ENTRY: K = DEVICE ADDRESS
;*
;*     RETURN:
;*          CH = DEVICE ADDRESS
;*          CL = MDT DEVICE STATUS
;*          PC'S POINT TO MDT DEVICE STATUS
;*          F1 = CURRENT PART#
;*
;*     MODIFIED REGISTERS: PC'S,CHCL,F1F0
;
;  **  modify for sloving platter hog problem  **
;
;  *  Proc. ENBLDEVD will call ENBLDVXA to check
;  *
;  *   (1) MDT table if this device is in status DEVUSE (DEVOPEN + DEVOIP)
;  *
;  *   (2) PSTAT table if this platter is hoged by another partition
;  *
;  *  if the above conditions occur, call  BREAKPTW ( the related stmt.
;  *                                 will clear the status )  then back
;  *
;
;*
;* BREAKPOINT & WAIT UNTIL DEVICE BECOMES AVAILABLE
ENBLDVX6:
        TEST    CL,DEVEXCL
        JNZ     ERR_48D
;        MOV     EDX,0
;        MOV     DL,R1
;        ADD     EDX,OFFSET RQSTDEV
;        MOV     [EDX],CH
;        INC     EDX
;        jmp     enbldvx8
enbldvx7:
;        mov     ecx,actdev
;        mov     edx,0
;        mov     dl,r1
;        add     edx,offset rqstplat
;        mov     [edx],cl
;        inc     edx
;enbldvx8:
;        CALL    BREAKPTW

        CALL    BREAKPTT
ENBLDVXA:
ENBLDVX4:
;       call    srchplt         ;see if the platter is hoged ?
;       test    al,0fh
;       jnz     enbldvx5

        MOV     CH,PART_
        MOV     R1,CH
        CALL    SRCHDEV
        CMP     CH,0
        JZ      ERR_48D
        TEST    CL,DEVUSE
        JZ      ENBLDVX5
        MOV     AL,CL
        AND     AL,0FH
        MOV     R0,AL
        CMP     AL,R1
        JNZ     ENBLDVX6

; *  modify by W.R. TSENG for platter hog  *
;

ENBLDVX5:
        call    srchplt         ;see if the platter is hoged ?
        cmp     al,0ffh
        je      enbldvx7
        MOV     AH,CL
        OR      AH,DEVOIP
        MOV     R0,AH           ;R0 HIGH NIBBLE & R1 LOW NIBBLE IS WRITTEN
        AND     AH,0F0H
        MOV     AL,R1
        AND     AL,0FH
        OR      AH,AL
        MOV     [EDX],AH

;------ correction to get proper RETURN CHCL values ----------------------------
;   (Patched by Jerry and Bruce for rel 3.3)
        DEC     EDX
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        INC     EDX             ;get MDT entry
;-------------------------------------------------------------------------------
        RET

;         TITLE     ENBLDEVD
;*  ENBLDEVD:  enable the specified disk.
;*
;*        This routine waits (breakpts) until the specified disk is not in use by another
;*        partition.  ERROR 48 results if the device is not flagged in the
;*        Master Device Table (MDT) as a disk.  If the 80-bit of the disk address
;*        is on, the open and hog-by-address bits are set in the MDT entry.  If
;*        the 80-bit is off and the hog-by-address bit is on, the open and
;*        hog-by-address bits are turned off.  In all cases, the operation-in-progress
;*        bit in the MDT is set.  If the disk is not Ramdisk, the disk unit is
;*        hogged by a CBS hog.
;*
;*        Note, the operation-in-progress and CBS hog are cleared at the end of
;*        the disk statement by FREEDEVS (ie, ENBLNULL).
;*
;@3.0ENBD EQU       *
;*        Prior to Release 3.0, the address unhog logic in this routine was done
;*        in ENDDISK.  The ENDDISK routine has been eliminated.
;*
;*        Entry:    PC's = device address (xtaa), t=device type, aa=device addr
;*
;*        Return:   device enabled
;*                  ACTDEV = device type & address (xtaa)
;*                  K = device address
;*                  disk hogged by CBS
;*                  operation-in-progress bit set in MDT entry
;*                  A0(=1) = device already hogged by current partition
;*
;*        Modified registers: K
;*

@3?PD0ENBD:
ENBLDEVD:
        MOV     ACTDEV,EDX
        MOV     K,DL
        MOV     AH,DH
        AND     AH,0FH
        CMP     AH,_PHOENIX
        JNZ     BP5Y_01
        AND     K,0F0H
BP5Y_01:
        PUSH    EDX
;AAA    PUSH    DWORD PTR A0
        PUSH    WORD PTR R0
        PUSH    CX

;* ----------------- wait for disk to become available --------------------------
        CALL    ENBLDVXA

BP5Y_02_X:
        TEST    CL,DEVTDISK
        JNZ     BP5Y_02
        JMP     ERROR_48
BP5Y_02:
        TEST    K,80H
        JZ      ENBLDVD0

;* ----------------- 80-bit of disk address is on -------------------------------
;*        Set open bit in MDT entry.  If not already open by CBS or $OPEN, set
;*        hogged-by-address bit in MDT entry.
;*
        MOV     [EDX],CL
        OR      BYTE PTR [EDX],DEVOPEN
        SUB     EDX,MDEVDISP
        TEST    CL,DEVOPEN
        JZ      ENBLDVD2
        TEST    BYTE PTR [EDX+1],DHOGADR
        JZ      ENBLDVD1
ENBLDVD2:
        MOV     AL,[EDX+1]
        OR      AL,DHOGADR
        MOV     [EDX],AL
        JMP     ENBLDVD1

;* ----------------- 80-bit of disk address if off ------------------------------
;*        If hogged by address, clear the hogged-by-address bit in the MDT and
;*        if not an exclusive device, clear the open bit in the MDT entry.
;*
ENBLDVD0:
        TEST    CL,DEVOPEN
        JZ      ENBLDVD1
        SUB     EDX,MDEVDISP
        TEST    BYTE PTR [EDX],DHOGADR
        JZ      ENBLDVD1
        AND     BYTE PTR [EDX],0FFH-DHOGADR
        ADD     EDX,MDEVDISP
        TEST    BYTE PTR [EDX],DEVEXCL
        JNZ     ENBLDVD1
        AND     BYTE PTR [EDX],0FFH-DEVOPEN

;* ----------------- CBS hog the disk -------------------------------------------
@3?PD0DE:
ENBLDVD1:
        CMP     K,40H
        JZ      ENBLDVP2
ENBLDVP1:
;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],0feh
;       pop     eax

        CALL    ENBLDEVB
;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],01h
;       pop     eax

        MOV     AL,K
        MOV     R0,AL
        MOV     AL,_DISKHOG
        CALL    CBSNR
        MOV     AL,R0
        MOV     K,AL
ENBLDVP2:
        JMP     ENBLDVX2

;         TITLE     DEVICEI DEVICET
;*  DEVICEG: SCAN STATEMENT LINE FOR  #N[,] OR /XYY[,] &
;*            ENABLE DEVICE. IF THERE IS NO SPECIFICATION,
;*            DEFAULT ADDRESS = CURRENT SELECT TAPE ADDRESS.
;*            BOTH MXD & NON-MXD ADDRESSES ARE ALLOWED.
;*     CALLED BY: $GIO
;*
;*     Additional return info. if device specification found (added Rel. 1.9):
;*          F5F4 = device specification
;*
;*  DEVICET: SAME AS 'DEVICETG' EXCEPT MXD ADDRESSES ILLEGAL.
;*
;*  ENTRY:  TEXPTR POINTS TO NEXT TEXT CHARACTER.
;*
;*  RETURN:  TEXTPTR IS INCREMENTED PAST THE ADDRESS.  IN
;*     IN EXECUTION PHASE ONLY:
;*          DEVICE ENABLED.
;*          ACTDEV = DEVICE TYPE & ADDRESS
;*          K = DEVICE ADDRESS
;*     IN ALL PHASES:
;*          F0 = 0 IF COMMA FOUND AFTER DEVICE SPEC.
;*               1 IF COMMA NOT FOUND AFTER DEVICE SPEC.
;*               2 IF DEFAULT (NO SPECIFICATION)
;*
;*  MODIFIED REGISTERS:  ALL, AUX 0-3, AUXE IF X-PHASE
;*
DEVICEG:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVTAPE
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
DEVICE:
        MOV     DX,CX
        MOV     AUX03,EDX
        CALL    DEVSPEC
        TEST    R1,0F0H
        JNZ     DEVICE2
        TEST    SL,2
        JZ      DEVICE1
        MOV     DX,WORD PTR R0
        MOV     WORD PTR R4,DX
        CALL    ENBLDEVG

DEVICE1:
        CMP     BYTE PTR [TEXTPTR],','
        JE      DEVICE1A
        MOV     R0,1
        RET
DEVICE1A:
        INC     TEXTPTR
        MOV     R0,0
        RET
DEVICE2:
        TEST    SL,2
        JZ      DEVICE3
        MOV     EDX,AUX03
        CALL    ENBLDEVG
DEVICE3:
        MOV     R0,2
        RET

DEVICET:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVTAPE
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     DX,CX
        MOV     AUX03,EDX
        CALL    DEVSPEC
        TEST    R1,0F0H
        JNZ     DEVICE21
        TEST    SL,2
        JZ      DEVICE11
        MOV     DX,WORD PTR R0
        CALL    ENBLDEVI

DEVICE11:
        CMP     BYTE PTR [TEXTPTR],','
        JE      DEVICE1A
        MOV     R0,1
        RET
DEVICE21:
        TEST    SL,2
        JZ      DEVICE3
        MOV     EDX,AUX03
        CALL    ENBLDEVI
DEVICE31:
        JMP     DEVICE3

;         TITLE     DEVSPEC
;*DEVSPEC: LOOK FOR #N OR /XYY IN TEXT
;*
;*     ENTRY: TEXTPTR POINTS AT NEXT TEXT CHARACTER
;*
;*     RETURN:
;*          F1,BITS F0 = 0 IF FOUND
;*               IN EXECUTION PHASE,
;*                    F1,BITS 0F = DEVICE TYPE
;*                    F0 = DEVICE ADDRESS
;*
;*          F1,BITS F0 <> 0 IF NOT FOUND
;*
;*     MODIFIED REGISTERS: ALL,AUX0,1,2
;*
DEVSPEC:
        CALL    FILE_A
        TEST    R0,0FH
        JNZ     DEVSPEC1
        TEST    SL,2
        JZ      DEVSPEC2
        CALL    FILE_ADR
        MOV     WORD PTR R0,CX
DEVSPEC2:
        AND     R1,0FH
        RET
DEVSPEC1:
        JMP     DEVADDRS

;         TITLE     DEVSPECT
;*DEVSPECT: GET DEVICE SPECIFICATION; DEFAULT = TAPE.
;*          DEVICE IS NOT ENABLED.
;*
;*     FORMAT:  #N[,] OR /XYY[,]
;*
;*     RETURN: K = DEVICE ADDRESS
;*
;*     MODIFIED REGISTERS: ALL,AUX0,1,2
;*          AUXE IN X-PHASE
;*

DEVSPCT2:
        JMP     DEVSPCT1
DEVSPECT:
        CALL    DEVSPEC
        TEST    R1,0F0H
        JNZ     DEVSPCT2
        MOV     AL,R0
        MOV     K,AL
        CMP     R1,_PHOENIX
        JNZ     BP5Y_03
        AND     K,0F0H
BP5Y_03:
        CMP     BYTE PTR [TEXTPTR],','
        JE      DEVICE1A
        MOV     R0,1
        RET

DEVSPCT1:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVTAPE
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     K,CL
SR@05:
        RET

;         TITLE     DISABLE ENBLNLLD
;*     DISABLE: INITIALIZE STATUS REGISTERS
;*              DISABLE ALL DEVICES (IE, ENABLE 00)
;*
;*          MODIFIED REGISTERS: SL,SH,K,PC'S
;*
;*     ENBLNLLD: DISABLE ALL DEVICES (IE, ENABLE 00)
;*
;*          MODIFIED REGISTERS: K,PC'S
;*
DISABLE:
        AND     SL,EPHASE
ENBLNLLD:
        MOV     BYTE PTR FS:[_ABS],0
        call    delay5
        MOV     ACTDEV,0
        MOV     ACTIOBS,0
ENBLNLLD2:
        TEST    BYTE PTR FS:[CPUST],01H
        JZ      ENBLNLLD2
        RET
ENBLNLLDH:
        MOV     BYTE PTR FS:[_ABS],0
        call    delay5
ENBLNLLD2H:
        TEST    BYTE PTR FS:[CPUST],01H
        JZ      ENBLNLLD2H
        RET

;         TITLE     FREEDEVS (ENBLNULL)
;*  FREEDEVS:  release all devices currently in use by the current partition.
;*
;*        This routine scans the Master Device Table (MDT) for all devices
;*        in use by this partition (ie, Operation In Progress bit on) but that
;*        are not open or exclusively assigned to this partition.  These
;*        devices are released by turning off the OIP bit in the MDT entries.
;*        If the device is a disk, a CBS unhog is issued to the device in order
;*        to free the disk multiplexer.  If there is a partition waiting for the
;*        released device, that partition is awoken.
;*        The routine also disables all devices by enabling device address /000.
;*
;@3.0RLDV EQU       *
;*        The disk logic was added to this routine in Rel. 3.0.  Formerly, the
;*        CBS unhog was issued by ENDDISK.   ENDDISK has been eliminated -- the
;*        CBS logic being done here and the unhog by address being done in
;*        ENBLDEVD.  The new logic is more straightforward and, also, corrects
;*        a bug with MOVE and COPY.  The bug was that if an error occured during
;*        MOVE or COPY, only one disk (source or destination) would be released.
;*
;*        This routine was formerly known as ENBLNULL.
;*
;*        Entry:    none
;*        Return:   none
;*
;*        Modified registers:  K,PC'S,CH,CL,F0-F3
;*
ENBLNULL:
FREEDEVS:
        mov     edx,actdev
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hhh,dl
        CALL    ENBLNLLD        ;DISABLE ALL DEVICES by enabling device 00

;* ----------------- terminal printer logic -------------------------------------
;*        If there is a terminal printer in use by this partition which is not
;*        open or exclusively assigned, then turn off operation-in-progress (OIP)
;*        bit in MDT entry and release the terminal to a partition that may be
;*        waiting for it.
;*
        CALL    SRCHDEVP
        CMP     CH,0
        JZ      ENBLNLL2        ; SEE THE DEFINITION OF DEVUSE,DEVOPEN,DEVEXCLUSIVE
        MOV     AL,CL
        AND     AL,0F0h
        CMP     AL,DEVOIP
        JNZ     ENBLNLL2
        MOV     K,CL
        AND     K,0FH
        MOV     CH,PART_
        CMP     CH,K
        JNZ     ENBLNLL2
        MOV     R0,@MXDPADR
        CALL    $CLOSED

;* ----------------- other devices ----------------------------------------------
;*        For each device in use by this partition which is not open or exclusively
;*        assigned, turn off OIP and wake up partition waiting for device (if any).
;*
ENBLNLL2:
        MOV     CH,PART_
        MOV     K,CH
        OR      K,DEVOIP
        MOV     EDX,OFFSET MDEVTBL

ENBLNLL1:
        MOV     CX,[EDX]
        XCHG    CH,CL
        ADD     EDX,2
        CMP     CH,0
        JZ      ENBLNLL9
        MOV     AL,CL
        AND     AL,7FH
        MOV     R0,AL
        CMP     AL,K
        JNZ     ENBLNLL1
        MOV     R0,CH
        MOV     [EDX-1],CL
        AND     BYTE PTR [EDX-1],0FFH-DEVOIP
        PUSH    EDX

        TEST    CL,DEVTDISK
        JZ      ENBLNLL3
        MOV     AL,R0
        MOV     K,AL
;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],0ffh
;       pop     eax
        CALL    ENBLDEVB
;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],00h
;       pop     eax
        MOV     AL,0
        CALL    CBSNR
        CALL    ENBLNLLD
        MOV     CH,PART_
        MOV     K,CH
        OR      K,DEVOIP
        push    ecx
        push    edx
        mov     eax,offset rqstdev
        mov     edx,offset rqstdev+10h
enblnull3x:
        cmp     edx,eax
        je      enblnull3z
        mov     ch,byte ptr [eax]
        inc     eax
        cmp     ch,r0
        je      enblnull3y
        jmp     enblnull3x
enblnull3z:
        pop     edx
        pop     ecx
        mov     eax,dword ptr [cpbase]
        mov     al,byte ptr [eax].@hhh
        mov     r0,al
        call    wakeupp
        pop     edx
        jmp     enblnll1
enblnull3y:
        pop     edx
        pop     ecx
        CALL    WAKEUP
        POP     EDX
        JMP     ENBLNLL1

ENBLNLL3:
        CALL    WAKEUP
        POP     EDX
        JMP     ENBLNLL1
ENBLNLL9:
        RET

;         TITLE     DELAY10 DELAY5
;*     DELAY10: DELAY 10 USEC.
;*            (ACTUALLY 10.4 USEC. INCLUDING 'SB DELAY10')
;*     DELAY5:  DELAY 5 USEC.
;*            (ACTUALLY 5.2 USEC. INCLUDING 'SB DELAY5')
;*
;*          MODIFIED REGISTERS: NONE
;*
DELAY10:
        CALL    DELAY5          ;10 + m
DELAY5:
        CALL    DELAY2?PD6      ;11+26+15      ;10 + m
DELAY2?PD6:                     ;10 + m
        CALL    DELAY1          ;11+15         ;10 + m
DELAY1:
        PUSH    EAX             ;2
        POP     EAX             ;2
        RET                     ;10 + m

;*     DELAY1MS: DELAY 1MS.
;*
;*          MODIFIED REGISTERS: PC'S
;*
DELAY1MS:
        MOV     EBX,053H        ;DELAY FOR 1MS.

;*     DELAY: DELAY 11.8 USEC. + REFRESH
;*            (11.8 ;* 25.9/25.3 INCLUDING REFRESH = 12.08)
;*
DELAY:
        CALL    DELAY10
        DEC     EBX
        JNZ     DELAY
        RET

;*DELAYB: DELAY FOR N MS.; I/O LEVEL BREAKPOINT EVERY 30MS.
;*
;*     ENTRY: F0 = NO. OF MS. TO DELAY FOR
;*
;*     MODIFIED REGISTERS: PC'S,F0
;*
DELAYB:
        CALL    DELAY1MS        ;DELAY 1MS.
        CALL    BREAKPTK        ;BREAKPOINT (I/O LEVEL PIORITY) IF 30MS. UP
        DEC     R0              ;DEVREMENT DELAY COUNT
        JNZ     DELAYB          ;BRANCH IF MORE TO DELAY
        RET

;     FILE#A: SCAN & PROCESS A FILE NUMBER SPECIFICATION
;
;             The maximum file# was increased from #15 to #255 in Rel 3.1.
;             Also, the file# is now returned in @FILE#, no longer AUXE,bits8-11
;
;          FILE# FORMAT:  # integer
;                           numeric-var
;
;               where:  0 <= file# <= 255
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;
;          RETURN: F0 = 0 if file# found
;                    TEXTPTR points after file#
;                    In Resolution phase,
;                       @FILE#,byte 2 = max(@FILE#,byte 2 , # integer)
;                    IN Execution phase,
;                       @FILE#,byte 2 = file#
;
;                 F0 <> 0 if file# not found
;                    TEXTPTR points to next nonblank text character
;                    In Execution phase,
;                       @FILE#,byte 2 = 0 (default #n)
;
;          MODIFIED REGISTERS: ALL,AUX0,1,2
;
;     FILE#B: SAME AS 'FILE#A' EXCEPT '#' ALREADY SCANNED
;             (THUS, NO NOT FOUND RETURN)
;

FILE_A:
        CMP     BYTE PTR [TEXTPTR],'#'  ;LOOK FOR '#'
        JNE     FILE_A1                 ;NF, BRANCH
        INC     TEXTPTR

;  ------- # integer ---------
;

FILE_B:
        CALL    INTEGER                 ;LOOK FOR INTEGER
        TEST    R0,0FH
        JNZ     FILE_A2                 ;BRANCH IF NF
        MOV     AX,WORD PTR [R1]
        MOV     WORD PTR [R0],AX        ;R1,R0 = INTEGER
        CMP     AX,255
        JBE     FILE_XX1

FILE_A6:
        JMP     ERROR_34                ;ERROR IF FILE # > 255

FILE_XX1:
        TEST    SL,XPHASE
        JNZ     FILE_A3                 ;BR, IF EXECUTION PHASE
;       TEST    SL,RPHASE
;       JZ      FILE_A4                 ;BR, IF NOT RESOLUTION PHASE
;       MOV     EDX,DWORD PTR [CPBASE]
;       LEA     EDX,[EDX].@FILE_
;       CMP     AL,BYTE PTR [EDX+1]     ;FILE# = MAX(@FILE#,FILE#)
;       JBE     FILE_A4
;       MOV     BYTE PTR [EDX+1],AL
        JMP     FILE_A4

;  ------- # variable -----------
;

FILE_A2:
        MOV     K,0
        CALL    VAR                     ;SCAN & PROCESS NUMERIC VARIABLE
        TEST    SL,XPHASE
        JZ      FILE_A4                 ;BR, IF NOT EXECUTION PHASE
        CALL    FLTBINA                 ;CONVERT VALUE TO BINARY
        MOV     AL,R0


;  ------- found return ---------
;

FILE_A3:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@FILE_

FILE_A7:
        MOV     BYTE PTR [EDX+1],AL     ;@file# = file#

FILE_A4:
        MOV     R0,0                    ;FLAG = FILE# FOUND
        RET


;  ------- not found return ---------
;

FILE_A1:
        TEST    SL,XPHASE
        JZ      FILE_A5                 ;BR, IF NOT EXECUTION PHASE
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@FILE_
        MOV     BYTE PTR [EDX+1],0      ;@FILE# = 0 (DEFAULT VALUE)

FILE_A5:
        MOV     R0,1                    ;FLAG = FILE# NOT FOUND
        RET


;     FILE#PTR: POINT TO THE SPECIFIED DEVICE TABLE #N SLOT
;
;          ENTRY: @FILE#,byte 2  = FILE#
;
;          RETURN: PC'S = pointer to 3rd byte of #n device table entry
;                  CARRY OFF
;
;          MODIFIED REGISTERS: PC'S,F0-1,CH,CL
;

FILE_PTR:
        CALL    FILE_ADR        ;POINT TO #N
        ADD     EDX,2
        RET


; FILE#ADR:  point to specified file# entry in the device table and return
;            the device address
;
;        Entry: @FILE#,byte 2 = file# (0-255)
;               Execution phase
;
;        Return: PHPL = address of file# entry in Device Table
;                CHCL = device address (1st 2 bytes of entry)
;
;        Modified registers: CHCL,PHPL,F0-1
;

FILE_ADR:
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     CX,WORD PTR [EDX].@FILE_
        XCHG    CH,CL                   ;CH = MAX FILE#, CL = FILE#

; ------- 0 <= file# <= 255 -------------
;
;  File# entries #0 - #255 are located in the Primary Device Table.
;  #0 - #255 entries always exist.
;

        MOVZX   EAX,CL
        SHL     EAX,3                   ;EACH ENTRY IS 8 BYTES
        LEA     EDX,[EDX].@DEVDISK      ;POINT TO # 0
        ADD     EDX,EAX                 ;POINT TO #N IN DEVICE TABLE
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL                   ;CHCL = DEVICE ADDRESS
        RET

; BADDRESS: CHECK FOR ILLEGAL DEVICE ADDRESS.
;
;      ILLEGAL ADDRESSES: 02,03,06,07, 41-47, 81-87, C1-C7
;
;      ENTRY: F0 = DEVICE ADDRESS
;
;      MODIFIED REGISTERS: NONE
;

BADDRESS:
        TEST    R0,8            ;BRANCH IF XXXX 1XXXX
        JNZ     BADDRES1
        TEST    R0,30H          ;BRANCH IF XX00 0XXX
        JZ      BP5D_03

BADDRES1:
        RET

; ADDRESS IS XX00 0XXX
;

BP5D_03:
        TEST    R0,0FH
        JZ      BADDRES1                ;BR, IF 00, 40, 80, C0
        TEST    R0,0C0H
        JZ      BP5D_04                 ;BR, IF 0000 0XXX
BP5D_05:
        JMP     ERROR_48

; ADDRESS IS 0000 0XXX
;

BP5D_04:
        TEST    R0,2
        JNZ     BP5D_05                 ;ADDRESS 02, 03, 06, 07
        RET


;         TITLE     WRTBLKC
;*WRTBLKC: OUTPUT (OBS) A BLOCK OF CHARACTERS STORED IN CONTROL
;*         MEMORY.
;*
;*         DATA IS STORED 3 CHARACTERS / INSTRUCTION.
;*         AFTER RCM:
;*               K,BITS 7F = 1ST CHARACTER
;*               PH        = 2ND CHARACTER
;*               PL        = 3RD CHARACTER
;*
;*     ENTRY:
;*          OUTPUT DEVICE ENABLED
;*          F0 = NO. OF CHARACTERS TO OUTPUT (>0)
;*          PC'S = ADDRESS OF DATA
;*
;*     MODIFIED REGISTERS: PC'S,K,F0,1,AUX0
;*
;WRTBLKC1 TAP       ,0        GET DATA ADDRESS
;WRTBLKC  TPA+1     ,0        SAVE INCREMENTED ADDRESS
;         SB        RCM       GET NEXT 3 BYTES
;         ANDI      7F,K,K    STRIP OFF PARITY BIT
;         SB        TWRITE    OUTPUT 1ST CHARACTER OF SET
;         AI        0FF,F0,F0 DECREMENT COUNT
;         BER       F0,,WRTBLKC2        BRANCH IF NO MORE TO OUTPUT
;         MV        PH,K
;         SB        TWRITE    OUTPUT 2ND CHARACTER
;         AI        0FF,F0,F0 DECREMENT COUNT
;         BER       F0,,WRTBLKC2        BRANCH IF NO MORE TO OUTPUT
;         MV        PL,K
;         SB        TWRITE    OUTPUT 3RD CHARACTER
;         AI        0FF,F0,F0 DECREMENT COUNT
;         BNR       F0,,WRTBLKC1        BRANCH IF MORE TO OUTPUT
;WRTBLKC2 SR

WRTBLKC1:
        MOV     EDX,AUX00
WRTBLKC:
        MOV     AUX00,EDX
        ADD     AUX00,3
        MOV     AL,[EDX+2]              ;+- RCM
        MOV     K,AL
        MOV     AX,WORD PTR [EDX]
        MOV     DX,AX                   ;+- RCM
        AND     K,7FH
        CALL    TWRITE
        DEC     R0
        JZ      WRTBLKC2
        MOV     K,DH
        CALL    TWRITE
        DEC     R0
        JZ      WRTBLKC2
        MOV     K,DL
        CALL    TWRITE
        DEC     R0
        JNZ     WRTBLKC1
WRTBLKC2:
        RET

;         TITLE     RESETDSK
;
;*RESETDSK: Reset all disks that are --
;*               1. Not in use (operation in progress, open, exclusive) by any other partition.
;*
;*          If in use by current partition, delay 1/4 sec. for write to
;*          finish -- at least for Diablo (BLAH!).
;*
;*     MODIFIED REGISTERS: PC'S,K,F0-2,CH,CL
;*
;*     Correction in Rel 2.0 + Mod .1:
;*          Resets disk even if open now.
;*          Resets exclusive disks properly.
;*          Does not delay 1/4 sec. unless operation in progress.
;
RESETDSK:
        MOV     CH,PART_
        MOV     R1,CH
        call    close_open
        MOV     EDX,OFFSET MDEVTBL

RESETDS3:
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     R0,0
        ADD     EDX,2
        CMP     CH,0
        JZ      RESETDSR
        TEST    CL,DEVTDISK
        JZ      RESETDS3
        TEST    CL,DEVUSE
        JZ      RESETDS5

        MOV     AL,CL
        AND     AL,0FH
        CMP     AL,R1
        JNZ     RESETDS3
        TEST    CL,DEVOIP
        JZ      RESETDS5
        CALL    DELAYB

RESETDS5:
        PUSH    EDX
        MOV     K,CH
        CALL    ENBLDEVB
        CALL    RSETDISK
        POP     EDX
        JMP     RESETDS3

RSETDISK:
        MOV     AL,_DISKRST
        CALL    CBSNR
        CALL    ENBLNLLD
        JMP     DELAY1MS
RESETDSR:
        call    clear_open
        RET


;         TITLE     ENBLCNT
;*  ENBLCNT:  ENABLE CONTROL ADDRESS OF MXD, AND
;*       SELECT TERMINAL FOR CURRENT PARTITION.
;*
;*          ENTRY: PART# = PARTITION NUMBER OF CURRENT PART.
;*
;*          RETURN: ACTDEV = CONTROL ADDRESS
;*                  CH,BITS C0 = MXD BOARD ADDRESS
;*                    ,BITS 07 = TERMINAL ADDRESS
;*
;*          MODIFIED REGISTERS: K,PC'S,CH,CL,F0
;*
;* TERMINAL NOT AVAILABLE (ATTACHED TO ANOTHER PARTITION)
ENBLCNT4:
        MOV     EDX,0
        MOV     DL,PART_
        ADD     EDX,OFFSET PTERM
        MOV     AL,K
        OR      AL,PTERMD+PTERMW        ;ENTRY = WAITING FOR TERMINAL
        MOV     [EDX],AL
        CALL    BREAKPTW                ;BREAKPOINT IF NO TERMINAL

;* MAKE SURE TERMINAL ATTACHED TO CURRENT PARTITION
ENBLCNT:
        MOV     EDX,0
        MOV     DL,PART_
        ADD     EDX,OFFSET PTERM
        MOV     CH,[EDX]
        TEST    CH,PTERMD
        JZ      ENBLCNT3        ;BRANCH IF TERMINAL ATTACHED

;* TERMINAL DETACHED, IS IT AVAILABLE?
        MOV     AL,CH                   ;
        AND     AL,0FFH-PTERMD-PTERMW   ;  PTERM  DB  16DUP(?)
        MOV     K,AL                    ;
        MOV     AL,CH                   ;  E.G.  15 --> 16 --> 1 --> 2   ETC.
        AND     AL,0FH
        test    AL,PTERMRLS             ;mll
        Jnz     ENBLCNT4                ;mll
        MOV     DWORD PTR A0,EDX
        INC     EDX
        JMP     ENBLCNT5
ENBLCNT2:
        MOV     CH,[EDX]
        INC     EDX
        CMP     CH,K
        JZ      ENBLCNT4        ;BRANCH IF 'THIS TERMINAL ATTACHED'
ENBLCNT5:
        CMP     EDX,OFFSET PTERM +16
        JNZ     BP5C_01         ;BRANCH IF NOT END OF TABLE
        MOV     EDX,OFFSET PTERM
BP5C_01:
        CMP     DWORD PTR A0,EDX
        JNZ     ENBLCNT2
        MOV     DWORD PTR A0,EDX
        MOV     AL,K
        AND     AL,0F0H
        CMP     AL,0
        JE      ENBLCNT1        ;BRANCH IF 1ST MXD (MUST EXIST)
        MOV     CH,MXD2SADR
        CMP     AL,40H
        JE      ENBLCNT6        ;BRANCH IF 2ND MXD
        MOV     CH,MXD3SADR
        CMP     AL,80H
        JE      ENBLCNT6        ;BRANCH IF 3RD MXD
        MOV     CH,MXD4SADR     ;4TH MXD
;* MAKE SURE MXD EXISTS
ENBLCNT6:
        CMP     CH,0FFH
        JE      ENBLCNT4        ;BRANCH IF MXD DOESN'T EXIST
        MOV     EDX,DWORD PTR A0

;* TERMINAL AVAILABLE (NOT ATTACHED TO ANYONE)
ENBLCNT1:
        MOV     AL,K            ;ATTACH TERMINAL TO CURRENT PARTITION
        MOV     [EDX],AL
        MOV     CH,K            ;CH,BITS C7 = TERMINAL ADDRESS

;* ENABLE CONTROL ADDRESS & SELECT TERMINAL
;*     CH,BITS C0 = MXD BOARD ADDRESS
;*       ,BITS 07 = TERMINAL ADDRESS
ENBLCNT3:
        MOV     EDX,ACTDEV
        MOV     DL,CH
        AND     DL,0C0H         ;PL = MXD CONTROL ADDRESS
        OR      DL,@MXDCADR
        CALL    ENBLDEVA        ;ENABLE CONTROL ADDRESS OF PROPER MXD
        MOV     AL,?AMSELTERM
        CALL    CBSNT           ;SEND 'SELECT TERMINAL' COMMAND
        MOV     AL,CH
        AND     AL,07H
        CALL    OBSNT           ;SEND TERMINAL NUMBER (0-7), EXIT
        MOV     AL,NULL
        JMP     OBSNT           ;SEND NULL AS COMPLETION OF TERMINAL SELECTION

;* ENBLCNTP
;*ENBLCNTP: SAME AS 'ENBLCNT' EXCEPT IF DEVICE IS TERMINAL
;*          PRINTER (/004), NO CHECK IS MADE FOR TERMINAL
;*          ATTACHMENT.
;*
;*     ENTRY: F1 = DEVICE ADDRESS
;*            PART# = PARTITION NUMBER OF CURRENT PART.
;*
ENBLCNTP:
        CMP     R1,@MXDPADR
        JNZ     ENBLCNT         ;BRANCH IF NOT TERMINAL PRNTR
ENBLCNTA:
        MOV     EDX,0
        MOV     DL,PART_
        ADD     EDX,OFFSET PTERM
        MOV     CH,[EDX]
        MOV     AL,CH
        AND     AL,0FH
        TEST    AL,PTERMRLS
        JZ      ENBLCNT3        ;BRANCH IF PARTITION NOT RELEASED
        OR      CH,PTERMD+PTERMW;ENTRY = WAITING FOR TERMINAL
        MOV     [EDX],CH
        CALL    BREAKPTW        ;BREAKPOINT IF NO TERMINAL
        JMP     ENBLCNTP

;         TITLE     ENBLCNTM
;*ENBLCNTM: ENABLE MXD CONTROL ADDRESS, DON'T SELECT TERMINAL
;*
;*     ENTRY: ACTDEV = MXD ADDRESS
;*
;*     RETURN: PH = MXD ADDRESS
;*
;*     MODIFIED REGISTERS: PC'S,K
;*
ENBLCNTM:
        MOV     EDX,ACTDEV
        MOV     DH,K
        MOV     K,DL
        AND     K,0F8H
        OR      K,@MXDCADR      ;K = CONTROL ADDRESS
        JMP     ENBLDEVB

;         TITLE     ACKDISCT
;* ACKDISCT: Send acknowledgement of disconnect to MXE when last
;*           partition has successfully loaded disconnect utility program.
;*
;*        ENTRY: Disconnect bit (PMODED) for current partition already cleared.
;*               Partition still attached to MXE port.
;*
;*        MODIFIED REGISTERS: F1F0,PHPL,CHCL,K,ACTDEV
;*
ACKDISCT:
        CALL    GETTERM_
        MOV     R0,CH
        AND     R0,PTERMADR
        MOV     EDX,OFFSET PMODE

;*  Search for other partitions with Disconnect in progress
ACKDIS1:
        MOV     CH,[EDX]
        INC     EDX
        TEST    CH,PMODED       ;Branch if Disconnect not in progress
        JZ      ACKDIS2
        PUSH    EDX
        SUB     EDX,OFFSET PMODE
        ADD     EDX,OFFSET PTERM
        MOV     CH,[EDX-1]
        POP     EDX
        MOV     AL,CH
        AND     AL,PTERMADR
        MOV     R1,AL
        CMP     AL,R0
        JNZ     ACKDIS2         ;BRANCH IF NOT THE SAME TERMINAL
        RET                     ;Return if another disconnect in progress.
 ACKDIS2:
        CMP     EDX,OFFSET PMODE +16
        JNZ     ACKDIS1         ;REPEAT IF MORE PARTITION TO CHECK

;*  No other partitions processing disconnect for this port
        CALL    ENBLCNTA
        CALL    ENBLCNTA        ;Enable control adr, select terminal
        MOV     AL,?AMDISACK    ;Send disconnect acknowledgement to MXE
        CALL    CBSNT
        CALL    ENBLNULL        ;DISABLE MXE
        RET

;        TITLE     ENBLDEV ENBLDEVI
;*    ENBLDEV: ENABLE THE SPECIFIED NON-MXD DEVICE.
;*
;*              ERR#48 IF DEVICE NOT IN MASTER DEVICE TABLE OR
;*                     IF MXD DEVICE ADDRESS.
;*              BREAKPOINT & SLEEP UNTIL DEVICE AVAILABLE IF
;*                     OPEN BY ANOTHER PARTITION.
;*
;*          ENTRY: PC'S POINT TO DEVICE TABLE ENTRY OF
;*                 DEVICE TO ENABLE.
;*
;*          RETURN: DEVICE ENABLED
;*                  ACTDEV = DEVICE TYPE (BITS 8-11) &
;*                           DEVICE ADDRESS (BITS 0-7)
;*                  CH,CL = DEVICE TYPE & ADDRESS
;*                  K = DEVICE ADDRESS
;*                  PC'S POINT TO DEVICE TABLE AFTER
;*                       DEVICE ADDRESS
;*
;*          MODIFIED REGISTERS: CH,CL,K,PC'S
;*
;*     ENBLDEVI: ENABLE THE SPECIFIED NON-MXD DEVICE.
;*
;*              ERR#48 IF DEVICE NOT IN MASTER DEVICE TABLE OR
;*                     IF MXD DEVICE ADDRESS.
;*              BREAKPOINT & SLEEP UNTIL DEVICE AVAILABLE IF
;*                     OPEN BY ANOTHER PARTITION.
;*
;*          ENTRY: PC'S = DEVICE TYPE (BITS 8-11) & DEVICE
;*                        ADDRESS (BITS 0-7)
;*
;*          RETURN: DEVICE ENABLED
;*                  ACTDEV = DEVICE TYPE & ADDRESS
;*                  K = DEVICE ADDRESS
;*
;*          MODIFIED REGISTERS: K
;*
ENBLDEV:
        MOV     CX,[EDX]        ;CH,CL = DEVICE TYPE AND ADDRESS
        XCHG    CH,CL
        MOV     ACTDEV,ECX      ;ACTDEV = DEVICE TYPE & ADDRESS
        ADD     EDX,2
        MOV     K,CL            ;K = DEVICE ADDRESS
        JMP     ENBLDEVX        ;ENABLE DEVICE

ENBLDEVI:
        MOV     ACTDEV,EDX      ;ACTDEV = DEVICE TYPE & ADDRESS
        MOV     K,DL            ;K = DEVICE ADDRESS
        JMP     ENBLDEVX        ;ENABLE DEVICE

;         TITLE     ENBLDEVG
;*ENBLDEVG: ENABLE SPECIFIED DEVICE.
;*          ANY DEVICE LEGAL EXCEPT DISK.
;*
;*     CALLED BY: $GIO, PLOT
;*
;*     ENTRY: PC'S = DEVICE TYPE (BITS 8-11) & DEVICE ADDRESS
;*                   (BITS 0-7)
;*
;*     RETURN: DEVICE ENABLED
;*             ACTDEV = DEVICE TYPE & ADDRESS
;*             K = DEVICE ADDRESS
;*             F1 = 80 IF DISK ADDRESS
;*                  40 IF MXD OUTPUT ADDRESS (04,05)
;*                  20 IF MXD KBD (01)
;*                  00 IF OTHER
;*
;*     MODIFIED REGISTERS: PC'S,CH,CL,F1,F0,K
;*
ENBLDEVG:
        CMP     DH,TCDEV
        JNZ     ENBLDVG0        ;BRANCH IF NOT TC
        JMP     TCGIO

ENBLDVG0:
        TEST    DL,38H
        JZ      ENBLDVG2        ;BRANCH IF MXD ADDR

;* NON-MXD DEVICE
ENBLDVG1:
        MOV     ACTDEV,EDX      ;ACTDEV = DEVICE TYPE & ADDRESS
        MOV     K,DL            ;K = DEVICE ADDRESS
        MOV     AL,DH
        AND     AL,0FH
        CMP     AL,_PHOENIX
        JNZ     BP5Z_01
        AND     K,0F0H          ;IF PHOENIX DISK, STRIP OFF PLATTER BITS
BP5Z_01:
        CALL    ENBLDVXA
        MOV     R1,0            ;F1 = 0 IF NOT DISK, 80 IF DISK
        TEST    CL,DEVTDISK
        JZ      ENBLDEVB        ;BRANCH IF  NOT DISK
        MOV     EDX,ACTDEV
        MOV     R1,80H          ;FLAG = DISK
        JMP     ENBLDEVD        ;ENABLE DISK

;* MXD DEVICE
ENBLDVG2:
        TEST    DL,0FH
        JZ      ENBLDVG3        ;BRANCH IF ADDR = XX00 0000
        TEST    DL,0C0H
        JNZ     ERROR_48        ;ILLEGAL DEVICE
        TEST    DL,2
        JNZ     ERROR_48        ;ERROR IF 02,03,06 OR 07

        MOV     ACTDEV,EDX      ;ACTDEV = DEVICE TYPE & ADDRESS
        MOV     AL,DL
        AND     AL,0FH
        CMP     AL,4
        JNE     ENBLDVG4        ;BRANCH IF NOT TERMINAL PRINTER
        MOV     K,DL
        CALL    ENBLDVXA        ;WAIT FOR DEVICE
        MOV     EDX,ACTDEV

ENBLDVG4:
        MOV     R1,DL           ;SAVE ADDRESS
        CALL    ENBLCNTP        ;ENABLE CONTROL ADDRESS
        MOV     EDX,ACTDEV
        AND     DL,0C0H
        OR      DL,R1           ;PL = DEVICE ADDRESS
        MOV     R1,40H          ;F1 = MXD CRT OR LOCAL PRTR FLAG
        MOV     AL,DL
        AND     AL,0FH
        CMP     AL,1
        JNZ     ENBLDEVA        ;ENABLE DEVICE (IF NOT KEYBOARD)
        MOV     R1,20H          ;F1 = MXD KEYBOARD FLAG
        RET

;*  ADDRESS = XX00 0000
ENBLDVG3:
        TEST    DL,0F0H
        JNZ     ENBLDVG1        ;BRANCH IF 40,80,C0
        MOV     R1,0
;*  FALL THROUGH TO ENBLDEVA

;         TITLE     ENBLDEVA ENBLDEVB
;*     ENBLDEVA: ENABLE THE SPECIFIED DEVICE (ABS STROBE).
;*
;*               ANY DEVICE ADDRESS IS LEGAL (NO CHECK IS MADE
;*               OF THE ADDRESS OR THE STATUS OF THE DEVICE).
;*               EXCEPT IF MXD ADDRESS 05, TRANSLATED TO 07.
;*
;*          ENTRY: PC'S = DEVICE TYPE (BITS 8-11) & DEVICE
;*                        ADDRESS (BITS 0-7)
;*
;*          RETURN: DEVICE ENABLED
;*                  ACTDEV = DEVICE TYPE & ADDRESS
;*                  K = DEVICE ADDRESS
;*
;*          MODIFIED REGISTERS: K
;*
;*     ENBLDEVB: ENABLE THE SPECIFIED DEVICE (ABS STROBE).
;*
;*               ANY DEVICE ADDRESS IS LEGAL (NO CHECK IS MADE
;*               OF THE ADDRESS OR THE STATUS OF THE DEVICE).
;*
;*          ENTRY: K = DEVICE ADDRESS
;*
;*          MODIFIED REGISTERS: NONE
;*
;*                  ACTDEV = DEVICE TYPE & ADDRESS
;*                  K = DEVICE ADDRESS
;*
;*          MODIFIED REGISTERS: K
;*
ENBLDEVA:
        MOV     AL,DL
        AND     AL,0FH
        CMP     AL,5
        JNZ     ENBLDVA1        ;BRANCH IF ADDRESS <> X5
        TEST    DL,30H
        JNZ     ENBLDVA1
        OR      DL,7            ;TRANSLATE MXD ADDR TO 07 OR 05

ENBLDVA1:
        MOV     ACTDEV,EDX      ;ACTDEV = DEVICE TYPE & ADDRESS
        MOV     K,DL            ;K = DEVICE ADDRESS
ENBLDEVB:
        MOV     AL,K            ;ENABLE ADDRESS
        MOV     BYTE PTR FS:[_ABS],AL
        call    delay5

;*Set ACTIOBS logic added in Rel. 1.9.
        MOV     ACTIOBS,EAX     ;ACTBIOS = ENABLED DEVICE ADDRESS
        RET
;       JMP     DELAY2?PD6

;         TITLE     ENBLDEVO ENBLCO --LIST
;*     ENBLDEVO: ENABLE SPECIFIED PRINT-TYPE DEVICE & SET
;*               LINE WIDTH (HIGH 8 BITS OF CHARCNT).
;*
;*               THE ONLY LEGAL MXD ADDRESSES ARE 04,05; ERR#48
;*                    IF SOME OTHER MXD ADDRESS.
;*
;*               IF NOT MXD ADDRESS,
;*                    ERR#48 IF DEVICE NOT DEFINED IN MDT.
;*                    BREAKPOINT & SLEEP UNTIL DEVICE AVAILABLE
;*                       IF OPEN BY ANOTHER PARTITION.
;*          ENTRY: PC'S POINT TO DEVICE TALBE ENTRY OF
;*                 DEVICE TO ENABLE.
;*
;*          RETURN: DEVICE ENABLED
;*                  ACTDEV = DEVICE TYPE & ADDRESS
;*                  K = DEVICE ADDRESS
;*                  CHARCNT (HIGH 8 BITS) = LINE WIDTH
;*
;*          MODIFIED REGISTERS: PC'S,K,CH,CL
;*
;*     ENBLCO: ENABLE TERMINAL CRT DEVICE VIA ENBLDEVO LOGIC.
;*     ENBLSCO: ENABLE SELECTED CONSOLE OUTPUT DEVICE.
;*     ENBLLIST: ENABLE LIST DEVICE VIA ENBLDEVO LOGIC.
;*
;*          ENTRY: NONE
;*
;*          RETURN: SAME AS 'ENBLDEVO'
;*
;*          MODIFIED REGISTERS: PC'S,K,CH,CL
;*
ENBLLIST:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVLIST
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL           ;GET 'LIST' DEVICE ADDRESS
        JMP     ENBLDVO1        ;ENABLE LIST DEVICE
ENBLSCO:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVCO
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL           ;GET SELECTED 'CO' DEVICE ADDRESS
        JMP     ENBLDVO1

ENBLCO:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVCO
ENBLDEVO:
        MOV     CX,[EDX]
        XCHG    CH,CL
ENBLDVO1:
ENBLDVO2:
        TEST    CL,38H
        JZ      ENBLDVO4        ;BRANCH IF MXD DEVICE ADDR

;* NOT AN MXD DEVICE
ENBLDVO6:
        CALL    ENBLDEV         ;ENABLE DEVICE
        PUSH    EDX
        CALL    SDRVRDEV        ;IS PRINTER DRIVER TO BE USED?
        POP     EDX
ENBLDVO5:
        MOV     CH,[EDX]
        MOV     BYTE PTR [CHARCNT+1],CH ;SET LINE WIDTH (HIGH 8 BITS OF CHARCNT)
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVPRNT
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL           ;CL = PRINT DEVICE ADDR
        CMP     CL,K
        JNZ     ENBLDVO7        ;BRANCH IF ACTIVE DEVICE <> PRINT DEVICE
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@PRNTCNT
        MOV     BYTE PTR [EDX],0        ;PRNTCNT = 0
        RET

;* MXD DEVICE ADDRESS
ENBLDVO4:
        MOV     AL,CL
        AND     AL,0FH
        CMP     AL,4
        JZ      BP5Z_03
        CMP     AL,5
        JNZ     ENBLDVO3        ;BRANCH IF NOT TERMINAL CRT OR PRINT ADDR
BP5Z_03:
        ADD     EDX,2
        PUSH    EDX
;AAA    PUSH    DWORD PTR A0
        PUSH    WORD PTR R0

        MOV     DX,CX
        MOV     ACTDEV,EDX      ;ACTDEV = DEVICE TYPE & ADDR
        CMP     DL,@MXDPADR
        JNZ     ENBLDVO8        ;BRANCH IF NOT TERMINAL PRINTER
        MOV     K,DL            ;K = ADDR OF TERMINAL PRINTER
        CALL    ENBLDVXA        ;WAIT FOR DEVICE TO BECOME AVAILABLE
        MOV     EDX,ACTDEV

ENBLDVO8:
        MOV     R1,DL           ;F1 = DEVICE ADDR
        CALL    ENBLCNTP        ;ENABLE CONTROL ADDRESS & SELECT TERMINAL
        MOV     EDX,ACTDEV
        AND     DL,0C0H
        OR      DL,R1           ;PL = DEVICE ADDR OR'ED WITH MXD ADDR
        CALL    ENBLDEVA        ;ENABLE ORIGINALLY SPECIFIED ADDRESS
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVPRNT
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        CMP     CL,R1
        JNZ     BP5Z_04
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@PRNTCNT
        MOV     BYTE PTR [EDX],0        ;PRNTCNT = 0  if device = print device
BP5Z_04:
        CALL    SDRVRDEV        ;IS PRINTER DRIVER TO BE USED?

        POP     WORD PTR R0
;AAA    POP     DWORD PTR A0
        POP     EDX
        MOV     CH,[EDX]
        MOV     BYTE PTR [CHARCNT+1],CH ;SET LINE WIDTH
ENBLDVO7:
        RET
ENBLDVO3:
        TEST    CL,0FH          ;BRANCH IF 00
        JZ      ENBLDVO6
ERR_48D:
        JMP     ERROR_48        ;ILLEGAL DEVICE SPECIFICATION

;******************************************************************************
;*
;* SDRVRDEV   -   SEARCH THE DRIVER DEVICE LIST AND TURN ON THE DRIVER IF ONE
;*                EXISTS FOR THE DEVICE AND IT IS ENABLED FOR THE CURRENT
;*                PARTITION (OR TERMINAL IF A TERMINAL PRINTER)
;*
;* ENTRY: ACTDEV HOLDS CURRENT DEVICE ADDRESS
;* EXIT: 80 BIT OF ACTDEV TURNED ON IF DRIVER ENABLED, ELSE ITS TURNED OFF
;* REGISTERS MODIFIED: NONE; AUX0, K, PHPL, F0-F2, CHCL ARE USED BUT RESTORED
;*
SDRVRDEV:
        MOV     CH,BYTE PTR [PDFLAG]
        CMP     CH,0
        JNE     SELPRNT
        RET

SELPRNT:
        XCHG    EDX,ACTDEV
        MOV     AL,DL
        AND     AL,0FH
        CMP     AL,7
        JNE     SELPRNT1
        TEST    DL,30H
        JZ      SELPRNT2
SELPRNT1:
        CMP     DL,0
        JNE     SELPRNT3
SELPRNT2:
        XCHG    EDX,ACTDEV
        RET
SELPRNT3:
        XCHG    EDX,ACTDEV

SDRVRDE1:
        PUSH    EDX
        PUSH    AUX00
        PUSH    DWORD PTR A0
        PUSH    DWORD PTR A2
        PUSH    DWORD PTR R0
        MOV     DL,K
        PUSH    DX

;*  IF CURRENT DEVICE AND PREVIOUS DRIVER ARE THE SAME, THEN EXIT

        MOV     EDX,OFFSET DEV?AMTERM ;GET PREVIOUS DEVICE AND TERMINAL ADDR
                                      ;***** SR,RCM RETURN THE OUTPUT IN K,DH,DL (TOTAL 24 BITS)
        MOV     AL,[EDX+2]            ;+- RCM
        MOV     K,AL
        MOV     AX,WORD PTR [EDX]
        MOV     WORD PTR R1,AX        ;+- RCM

        MOV     EDX,ACTDEV
        MOV     AL,DL
        AND     AL,3FH
        MOV     R0,AL           ;F0 = CURRENT DEVICE ADDR
        CMP     R1,AL
        JNZ     DRVRNOTS        ;BRANCH IF NOT SAME DEVICE ADDR
;       MOV     R1,4
;       CMP     R1,AL
        CMP     AL,4
        JNZ     SDRVCHEK        ;BRANCH IF SAME NON-TERMINAL DEVICE

        MOV     EDX,0
        MOV     DL,PART_
        ADD     EDX,OFFSET PTERM
        MOV     CH,[EDX]        ;GET CURRENT TERMINAL ADDR
        AND     CH,0DFH         ;MASK DEATTCH
        CMP     R2,CH
        JZ      SDRVCHEK        ;BRANCH IF SAME TERMINAL ADDR

;*  SEARCH DRIVER DEVICE LIST FOR DEVICE
DRVRNOTS:                       ;SEARCH DRIVER DEVICE LIST
        CALL    GETDRDEV        ;**** A2A1 POINT TO THE BIT MAP PF ADDRESS
        CMP     DWORD PTR A1,0  ;**** DX  ADDRESS & NUMBER
        JZ      DRDEVNF         ;EXIT IF DRIVER NOT IN LIST
DRVRNOT1:
        PUSH    EDX
        PUSH    DWORD PTR A1

;*  CREATE A 2 BYTE MASK W/ BIT FOR THIS PARTITION TURNED ON
        MOV     DL,PART_        ;DL = PART #
        MOV     WORD PTR R0,0
        STC
DRVBMAP1:
        RCL     WORD PTR R0,1
        MOV     AL,DL
        DEC     DL
        CMP     AL,0
        JNZ     DRVBMAP1        ;LOOP TILL DONE

;* IF CURRENT PARTITION NOT TURNED ON IN BIT MAP THEN EXIT
        POP     EDX             ;DWORD PTR A1  IS POPED
        MOV     AL,[EDX+2]      ;+- RCM
        MOV     K,AL
        MOV     AX,WORD PTR [EDX]
        AND     WORD PTR R0,AX  ;+- RCM
        POP     EDX             ;RECALL TERMINAL ADDR AND DRIVER #
        MOV     K,0FFH

        CMP     WORD PTR R0,0
        JNZ     DRVRYES         ;SET DRIVER USE FLAG
        MOV     K,0

;*  SAVE CURRENT DEVICE AND TERMINAL ADDRESSES FOR NEXT TIME
DRVRYES:
        MOV     WORD PTR R0,DX  ;F1 = TERMINAL ADDR, F0 = DRIVER #
        MOV     EDX,ACTDEV      ;RECALL CURRENT DEVICE
        MOV     DH,R1
        MOV     AL,K
        MOV     R1,AL
        MOV     AUX00,EDX
        MOV     EDX,OFFSET DEV?AMTERM
                                ;SAVE CURRENT DEVICE AND TERMINAL ADDRESSES
        MOV     AL,K            ;+- WCM
        MOV     [EDX+2],AL
        MOV     EAX,AUX00
        MOV     WORD PTR [EDX],AX   ;+-WCM
        CMP     R1,0
        JZ      DRDEVNF         ;BRANCH IF DRIVER DISABLED

;*  SAVE ADDRESSES OF CURRENT ESCAPE AND CHARACTER TRANSLATION TABLES
        MOV     EDX,0
        MOV     DL,R0           ;F0 = DRIVER # REMEMBER ?
        DEC     DL
        SHL     EDX,3
        ADD     EDX,OFFSET MSTRTABL
        MOV     DWORD PTR A0,EDX
        MOV     EAX,[EDX]       ;READ IN ADDR OF CHAR TABLE

        MOV     EDX,OFFSET CHARTABL
        MOV     [EDX],EAX       ;SAVE CHARACTER TABLE ADDR
        MOV     EDX,DWORD PTR A0
        ADD     EDX,4
        MOV     EAX,[EDX]
        MOV     EDX,OFFSET ESCTABL
        MOV     [EDX],EAX       ;SAVE ESCAPE TABLE ADDR

;*  TURN ON THE DRIVER
DRDEVON:
        MOV     EDX,ACTDEV
        OR      DH,80H          ;set 'ON' flag
        JMP     DRVRSET

;*  TURN DRIVER OFF
DRDEVNF:
        MOV     EDX,ACTDEV
        AND     DH,7FH

;*  SAVE THE DRIVER FLAG, RESTORE ALL REGISTERS AND GO HOME
DRVRSET:
        MOV     ACTDEV,EDX
;       MOV     CX,WORD PTR TEMPSAVE

        POP     DX
        MOV     K,DL
        POP     DWORD PTR R0
        POP     DWORD PTR A2
        POP     DWORD PTR A0
        POP     AUX00
        POP     EDX
        RET

;*  SINCE THE DEVICE IS THE SAME AS LAST TIME, SEE IF IT SHOULD BE TURNED ON
;SDRVCHEK MVI       0,F1
;         BER       F1,K,DRDEVNF
;         B         DRDEVON

SDRVCHEK:
        CMP     K,0
        JZ      DRDEVNF
        JMP     DRDEVON

;         TITLE     OBSTROBE OBSTROBN
;*     OBSTROBE: OUTPUT THE CHARACTER IN K WITH AN OBS
;*               STROBE.
;*
;*     OBSSP: OUTPUT A SPACE WITH AN OBS STROBE
;*
;*          MODIFIED REGISTERS: K
;*
;*     OBSNT: waits until device Ready (with no timeout) and then strobes out character
;*
;*  4/8/84  ROUTINE PATCHED TO CHECK IF GENERALIZED PRINTER DRIVER SHOULD BE USED.
;*  PATCH MADE BY DAVID BARRETT
;*
;*     Above routines check for the GPD flag and call GPD if flag is on.
;*     Routines below do not check for GPD.  This routine is used when it is
;*     known that output is not going to GPD (eg, when talking at control address
;*     to the MXD).
;*
;*     OBSNTC: same as OBSNT, except no GPD check
;*
;*     OBSNR: OUTPUT CHARACTER IN K WITH OBS STROBE WITH
;*            NO WAIT FOR READY.

OBSSP:
        MOV     K,20H
OBSTROBE:
        TEST    BYTE PTR FS:[CPUST],10H ;***** IF 30MS. ELAPSED   --- SH HIGH NIBBLE
        JZ      OBSTROBD
        CALL    BREAKPTT
OBSTROBD:
        PUSH    EDX
        TEST    BYTE PTR FS:[CPUST],8
        JNZ     OBSTR9
        CALL    WAITRDYB
OBSTR9:
        TEST    ACTDEV,8000H
        JZ      OBSTR7
        POP     EDX
        JMP     DRVRMAIN                ;BRANCH IF PRINTER DRIVER
OBSTR7:
        POP     EDX
        CALL    DELAY5                  ;delay for printer ready
                                        ;test for 2273-1 band printer : w.r. tseng
;       call    delay5                  ;delay for printer ready
        MOV     AL,K
        JMP     OBSNR

;
;       OBSNT   ,OBSNR
;
OBSNT:
        TEST    BYTE PTR FS:[CPUST],8   ;WAIT UNTIL DEVICE READY (NO TIMEOUT)
        JZ      OBSNT

        TEST    ACTDEV,8000H
        JNZ     DRVRMAIN                ;BRANCH IF PRINTER DRIVER
        CALL    DELAY5                  ;delay for printer ready
                                        ;test for 2273-1 band printer : w.r. tseng
;       call    delay5                  ;delay for printer ready

OBSNR:
        MOV     BYTE PTR FS:[OBS],AL    ;STROBE CHARACTER
        JMP     DELAY5
;
;       OBSNTC
;
OBSNTC:
        TEST    BYTE PTR FS:[CPUST],8   ;WAIT FOR DEVICE READY
        JZ      OBSNTC
        JMP     OBSNR


;         TITLE     CBSTROBE
;*     CBSTROBE: OUTPUT THE CHARACTER IN K WITH A CBS WITH WAIT
;*               WAIT FOR READY (TIMEOUT IF NOT READY WITHIN
;*               1MS.)
;*
;*    CBSNT: OUTPUT CHARACTER IN K WITH CBS STROBE (NO TIMEOUT)
;*
;*     CBSNR: OUTPUT CHARACTER IN K WITH CBS STROBE WITH
;*            NO WAIT FOR READY AND NO TIMEOUT.

CBSTROBE:
        TEST    BYTE PTR FS:[CPUST],10H
        JZ      CBSTROBD
        CALL    BREAKPTT                ;breakpoint if 30 ms elapsed
CBSTROBD:
        TEST    BYTE PTR FS:[CPUST],8   ;wait until i/o ready
        JNZ     CBSN9
        PUSH    EDX
        CALL    WAITRDYB                ;WAIT UP TO 1MS. FOR READY, THEN BREAKPOINT

;* DELAY SINCE PRINTER GOES READY TOO SOON! DELAY LENGTH??
CBSTR8:
        POP     EDX
CBSN9:
        MOV     AL,K
CBSTR9:                                 ;xxx-07/10
        CALL    DELAY5
CBSNR:
        MOV     BYTE PTR FS:[CBS],AL
        JMP     DELAY5

CBSNT:
        TEST    BYTE PTR FS:[CPUST],8   ;WAIT UNTIL DEVICE READY (NO TIMEOUT)
        JZ      CBSNT
        JMP     CBSTR9

;         TITLE     OBSTROBN
;*     OBSTROBN: OUTPUT THE CHARACTER IN K WITH AN OBS
;*               STROBE N TIMES.
;*
;*          ENTRY: F0 = N (NO. OF TIMES TO STROBE CHAR.)
;*                        ( 0 <= N < 256 )
;*                 K = CHARACTER TO STROBE
;*
;*          RETURN: F0 = 0
;*
;*          MODIFIED REGISTERS: F0
;*
OBSTROBN:
        CMP     R0,0
        JZ      CURLER          ;BRANCH IF COUNT = 0
        CALL    OBSTROBE        ;OUTPUT CHARACTER
        DEC     R0              ;DECREMENT COUNT
        JNZ     OBSTROBN        ;BRANCH IF MORE TO OUTPUT
CURLER:
        RET

;         TITLE     OBSBLK
;*     OBSBLK: OUTPUT A BLOCK OF CHARACTERS WITH OBS
;*             STROBES. NO EXTRA CHARACTER IS INSERTED
;*             AFTER CARRIAGE RETURNS & NO CHECK IS MADE
;*             OF LINE WIDTH.
;*
;*          ENTRY:
;*               PC'S = ADDRESS OF BLOCK OF CHARACTERS
;*               F1,0 = NO. OF CHARACTERS TO OUTPUT
;*               DEVICE ENABLED
;*
;*          RETURN:
;*               K = LAST CHARACTER OUTPUT
;*               CH = LAST CHARACTER OUTPUT
;*               PC'S = ADDRESS OF LAST CHARACTER +1
;*
;*          MODIFIED REGISTERS: K,CH,CL,PC'S,F1F0
;*
OBSBLK:
        MOV     ECX,0
        MOV     CX,WORD PTR R0  ;F1,0 = COUNT
OBSBLK1:
        MOV     AL,[EDX]        ;GET CHARACTER TO OUTPUT
        INC     EDX
        MOV     K,AL            ;STORE IN K
        CALL    OBSTROBE
        LOOP    OBSBLK1         ;LOOP UNTILL ALL OUTPUT
        MOV     CH,K            ;SAVE LAST CHARACTER IN K
        RET

;         TITLE     OBSN09
;*     OBSN09: OUTPUT N CURSOR RIGHT CHARACTERS (09) VIA
;*             OBS STROBES
;*
;*          ENTRY: PL = N (NO. OF STROBES)
;*
;*          RETURN: K = 09
;*                  F0 = 0
;*
;*          MODIFIED REGISTERS: K,F0
;*
OBSN09:
        MOV     R0,DL           ;F0 = NO. OF STROBES
        MOV     K,09            ;K = CURSOR RIGHT
        JMP     OBSTROBN        ;OUTPUT CHARACTERS

;         TITLE     CURSOR UP & DOWN
;*  CURSORUP:  MOVE CURSOR UP IF NOT DEVICE TYPE 2 OR 7
;*
;*  ENTRY:
;*  RETURN:
;*  MODIFIED REGS:  PC'S, K
;*
CURSORUP:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,2            ;EXIT IF DEVICE TYPE 7 OR 2
        JZ      CURLER
        CMP     DH,7
        JZ      CURLER
CURS3:
        MOV     K,0CH           ;STROBE OUT A REVERSE LINE FEED, EXIT
        JMP     OBSTROBE

;*  CURSORDN:  MOVE CURSOR DOWN IF NOT DEVICE TYPE 2 OR 7
;*
;*  ENTRY:
;*  RETURN:
;*  MODIFIED REGS:  PC'S, K
;*
CURSORDN:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,2            ;EXIT IF DEVICE TYPE 7 OR 2
        JZ      CURLER
        CMP     DH,7
        JZ      CURLER
CURS5:
        MOV     K,0AH           ;STROBE OUT A LINE FEED, EXIT
        JMP     OBSTROBE

;         TITLE     OBSCMPRS
;*OBSCMPRS: CHARACTER IN F1 IS TO BE STROBED (OBS) F0 TIMES.
;*          IF THE DEVICE IS MXD, THE DATA IS COMPRESSED.
;*
;*OBSCMPSP: SAME EXCEPT CHARACTER TO BE OUTPUT IS A SPACE.
;*
;*     COMPRESSION FORMAT:     CBS     COUNT
;*                             OBSNT   CHARACTER
;*
;*          WHERE: 4 <= COUNT <= 80
;*
;*     ENTRY: F0 = COUNT (0-255)
;*            F1 = CHARACTER ( <> HEX(FB) )
;*            ACTDEV = DEVICE ADDRESS
;*
;*     RETURN: K = CHARACTER
;*
;*     MODIFIED REGISTERS: F0,K,PC'S
;*
OBSCMPSP:
        MOV     R1,20H          ;output = ' '
OBSCMPRS:
        MOV     EDX,ACTDEV
        TEST    DL,38h
        JZ      OBSCMPR2        ;branch if mxd address

;* SENT DATA UNCOMPRESSED
OBSCMPR1:
        MOV     AL,R1
        MOV     K,AL            ;K = char.
        JMP     OBSTROBN        ;strobe char F0 times

;* SET COMPRESSED DATA
OBSCMPR2:
        MOV     K,50H
        CMP     R0,50H
        JAE     BP5O_05         ;if k >80 let k= min (80,remaining of char)
        MOV     AL,R0
        MOV     K,AL
        MOV     R0,0
        JMP     BP5O_06
BP5O_05:
        SUB     R0,50H
BP5O_06:
        CMP     K,4
        JBE     OBSCMPR3        ;don't compress if count <= 4
        CALL    CBSTROBE        ;send compression count
        MOV     AL,R1
        CALL    OBSNT           ;send compress char
        CMP     R0,0
        JNZ     OBSCMPR2        ;branch if more to send
        RET

OBSCMPR3:
        MOV     AL,K
        MOV     R0,AL           ;F0 = count
        JMP     OBSCMPR1

;         TITLE     OBSBLKNT
;*     OBSBLKNT: output a block of characters with OBS
;*             strobes. No extra character is inserted
;*             after carriage returns & no check is made
;*             of line width.  No timeout or clock check is
;*             made.
;*
;*          ENTRY:
;*               PC'S = address of block of characters
;*               F1,0 = no. of characters to output
;*               device enabled
;*
;*          RETURN:
;*               K = last character output
;*               CH = last character output
;*               PC'S = address of last character +1
;*
;*          MODIFIED REGISTERS: K,CH,CL,PC'S,F1F0
;*
OBSBLKNT:
        MOV     ECX,0
        MOV     CX, WORD PTR R0 ;F1,0 = COUNT
OBSBLKN1:
        MOV     AL,[EDX]        ;GET CHARACTER
        INC     EDX
        CALL    OBSNT
        LOOP    OBSBLKN1        ;BRANCH IF MORE
        MOV     CH,AL
        MOV     CH,K            ;STORE LAST CHARACTER IN K
OBSBLKN2:
        RET

;         FILE = BPMVP5I ,08/29/1986
;         TITLE     WAITIBS
;*WAITIBS: WAIT UP TO 15MS. FOR IBS.
;*
;*     RETURN: CPB (SH,BIT02) = 0 IF NO IBS
;*
;*                            = 1 IF IBS (K = DATA)
;*
;*     NOTE: IF NO IBS, CPB MUST BE TURNED OFF.
;*
;*     MODIFIED REGISTERS: SH,K
;*
;*WAITIBSE: SAME AS 'WAITIBS' EXCEPT IF NO IBS FOR 15MS, ERR
;*
;*WAITIBST: SAME AS 'WAITIBS' EXCEPT IF NO IBS FOR 15MS, TIM
;*          (SET CPB' READY, CBP BUSY, IF CHARACTER NOT REC'D
;*          WITHIN 15MS, BREAKPOINT & THEN RETRY WAITIBST)
;*
WAITIBS:
        MOV     BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
        MOV     ECX,03A98H              ;03A98H = 15000 US. = 15 MS.
WAITIBS1:
        TEST    BYTE PTR FS:[CPUST],2
        JNZ     WAITIBS1A
        DEC     ECX
        JNZ     WAITIBS1
        JMP     WAITIBS2
WAITIBS1A:
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        MOV     AL,FS:[IBGET]
        MOV     K,AL
WAITIBS2:
        RET

WAITIBSE:
        MOV     BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
WAITIBSF:
        MOV     ECX,03A98H              ;03A98H = 15000 US. = 15 MS.
WAITIBSF1:
        TEST    BYTE PTR FS:[CPUST],2
        JNZ     WAITIBSFA
        DEC     ECX
        JNZ     WAITIBSF1
        JMP     ERROR92
WAITIBSFA:
        MOV     AL,FS:[IBGET]
        MOV     K,AL
        RET

ERROR92:
        MOV     R0,92H
        AND     MODE,07FFFH             ;LOAD MODE OFF
        JMP     ERROR

;         TITLE
;*IBSENDI: receive and store a stream of input strobes. The
;*         buffer size determines the number of characters that
;*         can be received. The stream is terminated by an
;*         additional byte with ENDI on.
;*
;*     FIX! --
;*             Routine should be optimized (eg, more in-line).
;*
;*     Entry:
;*          Device enabled.
;*          PC's = buffer address
;*          F1F0 = address of end of buffer + 1
;*
;*     Return:
;*          Characters received are in buffer.
;*          PC's = address of next buffer location
;*          K = termination byte
;*
;*     Modified registers: PC'S,CH,CL,K,SH
;*
;*IBSENDIB: save IBSENDI stream in the IOBUFFER. A maximum of
;*          256 characters can be received.
;*
;*     Modified registers: PC'S,CH,CL,K,SH,F0-1
;*
IBSENDIB:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     EBX,EDX
        ADD     EBX,100H        ;ebx point to i/o buffer +256
        JMP     IBSENDI
IBSENDI1:
        MOV     AL,K
        MOV     [EDX],AL        ;store char. in i/o buffer
        INC     EDX
IBSENDI:
        CALL    WAITIBSE
        CMP     EBX,EDX
        JBE     IBSENDI4        ;branch if buffer full
        TEST    WORD PTR FS:[CPUST],04H ;ENDI ON ?
        JZ      IBSENDI1
IBSENDI3:
        RET
IBSENDI4:
        TEST    WORD PTR FS:[CPUST],04H ;ENDI ON ?
        JNZ     IBSENDI3        ;branch if terminator received
        JMP     ERROR_52        ;value too long

;         TITLE     WAITRDYB
;*WAITRDYB: WAIT UP TO 1MS. FOR DEVICE READY.  IF STILL NOT
;*          READY, BREAKPOINT.  IF A TERMINAL PRINTER, CHECK PDFLAG TO SEE IF
;*          DRIVERS ARE PRESENT IN CONFIGURATION AND IF SO CALL THE SELECT DRIVER
;*          SUBROUTINE.  IF NOT, BYPASS THE SELECT DRIVER DEVICE SUBROUTINE.
;*
;*     ENTRY: DEVICE ENABLED
;*            ACTDEV = DEVICE TYPE & ADDRESS
;*
;*     MODIFIED REGISTERS: PC'S
;*
WAITRDYB:
        MOV     EAX,03E8H               ;1 MS
WAITRDB2:
        TEST    BYTE PTR FS:[CPUST],8   ;wait until device ready
        JNZ     WAITRDY2                ;skip if ready
        DEC     EAX
        JNZ     WAITRDB2

;*  TIMEOUT -- 1MS. WITHOUT READY
        MOV     EAX,ACTDEV
        CMP     AH,TCDEV
        JZ      WAITRDB6                ;branch if TC

WAITRDB7:
        MOV     BL,AL
        AND     BL,38H
        JNZ     WAITRDB5
        AND     AL,0FH
        CMP     AL,7
        JE      WAITRDB3                ;skip if crt (07,47,87,c7)
        CMP     AL,4
        JE      WAITRDB4                ;skip if local printer (04,44,84,c4)

WAITRDB5:
        CALL    BREAKPTA                ;waiting for i/o, save all regs
        JMP     WAITRDYB

WAITRDB3:
        PUSH    EDX
        CALL    ENBLCNTM                ;enable control address of MXD
        MOV     AL,?AMCRTREQ            ;
        CALL    CBSNT                   ;crt buffer empty request
        MOV     K,DH                    ;restore K
        POP     EDX
        CALL    BREAKPTC                ;waiting for crt buffer empty, save all regs
        JMP     WAITRDYB

WAITRDB4:
        PUSH    EDX
        AND     AUX1A,0FFFF7FFFH
        CALL    ENBLCNTM                ;enable control address of MXD
        MOV     AL,?AMPRTREQ
        CALL    CBSNT                   ;printer buffer empty request
        MOV     K,DH                    ;restore K
        POP     EDX
        CALL    BREAKPTB                ;waiting for printer buffer empty, save all

        PUSH    WORD PTR [R0]           ;SAVE F1F0
        MOV     WORD PTR [TEMPSAVE],CX  ;SAVE CX
        MOV     CH,BYTE PTR [PDFLAG]    ;GET PRINTER DRIVER FLAG
        TEST    CH,0FH
        JZ      WAITRDBX                ;PRINTER DRIVERS NOT USED BYPASS LOGIC
        CALL    SDRVRDE1                ;PUTTING TABLE # IN F1

WAITRDBX:
        MOV     CX,WORD PTR [TEMPSAVE]  ;RESTORE CHCL
        POP     WORD PTR [R0]           ;RESTORE F1F0
        JMP     WAITRDYB                ;LOOP BACK AND WAIT AGAIN FOR READY

;         TITLE     CHKDVRB
;*CHKDVRB: CHECK DEVICE READY/BUSY.   DEVICE 'BUSY' IF OPEN BY
;*         ANOTHER PARTITION.  NON-MXD DEVICES ONLY.
;*
;*     ENTRY: K = DEVICE ADDRESS
;*
;*     RETURN: F0 = 08 IF DEVICE READY
;*                  00 IF DEVICE BUSY
;*
;*     ERROR#48 IF DEVICE NOT IN MDT.
;*
;*     MODIFIED REGISTERS: PC'S,CH,CL,F0
;*
CHKDVRB:
        CALL    SRCHDEVA        ;FIND DEVICE (K) IN MDT
        CMP     CH,0
        JNZ     BP5R_02
        JMP     ERROR_48        ;ERROR IF NOT FOUND
BP5R_02:
        TEST    CL,DEVUSE       ;BRANCH IF DEVICE NOT OPEN OR O.I.P
        JZ      CHKDVRB1
        AND     CL,0FH          ;F0 = PART# OF PARTITION USING DEVICE
        MOV     CH,PART_
        CMP     CH,CL
        JNZ     CHKDVRB2        ;BRANCH IF DEVICE IN USE BY ANOTHER PART.
CHKDVRB1:
        MOV     AL,K
        MOV     FS:[_ABS],AL    ;ENABLE DEVICE
        CALL    DELAY5
        MOV     AL,BYTE PTR FS:[CPUST]
        AND     AL,08H
        MOV     R0,AL           ;F0 = DEVICE RB BIT
        RET
CHKDVRB2:
        MOV     R0,0            ;DEVICE = BUSY SINCE OPEN BY ANOTHER PART.
        RET

;         TITLE     WAITRDY
;*WAITRDY:  WAIT UP TO  1MS. FOR DEVICE READY
;*WAIT16RB: wait up to 16ms. for device Ready
;*WAIT50RB: wait up to 50ms. for device Ready
;*
;*     RETURN: RB (SH,BIT08) = 1 IF DEVICE READY
;*                             0 IF DEVICE STILL BUSY
;*
;*     MODIFIED REGISTERS: PC'S
;*
WAIT50RBx:
        MOV     EAX,300000H     ;50 MS. COUNT
        JMP     WAITRDY1
WAIT50RB:
        MOV     EAX,6FFFFH      ;50 MS. COUNT
        JMP     WAITRDY1
WAIT16RB:
        MOV     EAX,3E80H       ;16 MS. COUNT
        JMP     WAITRDY1
WAITRDY:
        MOV     EAX,03E8H       ;1 MS. COUNT
WAITRDY1:
        TEST    BYTE PTR FS:[CPUST],8
        JNZ     WAITRDY2
        DEC     EAX             ;DECREMENT COUNT
        JNZ     WAITRDY1        ;BRANCH IF < 1 MS.
WAITRDY2:
        RET

;     WRTLINE#: OUTPUT THE SPECIFIED LINE NO. (2 PACKED
;               DECIMAL BYTES). LEADING ZEROES ARE NOT
;               OUTPUT.
;
;     WRTLIN#4: SAME AS 'WRTLINE#' EXCEPT OUTPUT LEADING
;               ZEROES.
;
;          ENTRY: F3,2 = PACKED DECIMAL LINE NO.
;
;          MODIFIED REGISTERS: K,F1
;

WRTLINE_: MOV       AL,R3
          AND       AL,0F0H
          CMP       AL,0
          JNE       WRTLIN_4            ;BRANCH IF 1ST DIGIT <> 0
          MOV       AL,R3
          AND       AL,0FH
          CMP       AL,0
          JNE       WRTLIN_3            ;BRANCH IF 2ND DIGIT <> 0
          MOV       AL,R2
          AND       AL,0F0H
          CMP       AL,0
          JNE       WRTLIN_2            ;BRANCH IF 3RD DIGIT <> 0
          JMP       WRTLIN_1

WRTLIN_4: MOV       AL,R3
          SHR       AL,4
          MOV       K,AL
          CALL      TWRITE3X            ;OUTPUT 1ST DIGIT
WRTLIN_3: MOV       AL,R3
          AND       AL,0FH
          MOV       K,AL
          CALL      TWRITE3X            ;OUTPUT 2ND DIGIT
WRTLIN_2: MOV       AL,R2
          SHR       AL,4
          MOV       K,AL
          CALL      TWRITE3X            ;OUTPUT 3RD DIGIT
WRTLIN_1: MOV       AL,R2
          AND       AL,0FH
          MOV       K,AL
          JMP       TWRITE3X            ;OUTPUT 4TH DIGIT


;     WORDLEN: GET THE LENGTH AND ADDRESS OF SPECIFIED
;              TEXT WORD.
;
;          ENTRY: CH = TEXT ATOM OF WORD
;
;          RETURN: CH,F0 = LENGTH OF WORD
;                  PC'S,AUX0 = ADDRESS OF WORD IN RAM
;
;          MODIFIED REGISTERS: CH,CL,PC'S,F0
;
;     WORDLENA: SAME EXCEPT FOR ENTRY
;
;          ENTRY: F0 = 2 * ATOM
;

WORDLEN:  MOV       AL,CH
          SUB       AL,80H
          MOV       R0,AL
WORDLENA: MOV       AL,R0               ;PC'S = ADDRESS OF ATOM ENTRY IN TABLE
          MOV       EBX,0
          MOV       BL,AL
          SHL       EBX,3
          MOV       EDX,OFFSET ORG0100
          ADD       EDX,EBX             ;(PC'S = 0100 + 8 * CH)
          MOV       EDX,DWORD PTR [EDX] ;EDX = ATOM ENTRY
          AND       EDX,0FFFFFFFH       ;PC'S = ADDRESS OF UNATOMIZED WORD
          MOV       CH,BYTE PTR [EDX]  ;CH = LENGTH OF WORD
          XCHG      EDX,AUX00          ;CH = LENGTH OF WORD
          INC       AUX00
          XCHG      EDX,AUX00          ;PC'S = ADDRESS OF WORD
          MOV       R0,CH              ;F0 = LENGTH OF WORD
          RET

;     PRINTV: PRINT VALUE. VALUE IS PRINTED ON CURRENT
;             LINE IF ENOUGH ROOM. OTHERWISE, 'CR' IS
;             PRINTED BEFORE VALUE.
;
;          ENTRY: F1F0 = LENGTH OF VALUE
;                 PC'S = ADDRESS OF VALUE
;
;          MODIFIED REGISTERS: CH,CL,PC'S,F0-3,AUX2,K
;
;     PRINTVA: SAME AS 'PRINTV' EXCEPT FOR ENTRY
;
;          ENTRY: F0 = LENGTH OF VALUE
;                 PC'S = ADDRESS OF VALUE
;
PRINTVA:  MOV       R1,0                 ;HIGH BYTE OF COUNT = 0

PRINTV:   MOV       EAX,0
          MOV       AX,WORD PTR [R0]
          ADD       EAX,EDX
          MOV       DWORD PTR [A2],EAX   ;F3,2 = ADDRESS OF END OF VALUE +1
          XCHG      EDX,CHARCNT
          CMP       DH,0
          JE        PRINTV1              ;BRANCH IF LINE WIDTH = 0
          CMP       R1,0
          JNE       PRINTV2              ;BRANCH IF LENGTH OF VALUE > 255
          MOV       AL,R0
          ADD       AL,DL
          MOV       R1,AL                ;F1 = CHARCNT + LENGTH OF VALUE
          JC        PRINTV2
          CMP       R1,DH
          JBE       PRINTV1              ;BRANCH IF VALUE FITS ON CURRENT LINE
PRINTV2:  XCHG      EDX,CHARCNT
          MOV       AUX02,EDX            ;SAVE PTR TO VALUE
          CALL      PRNTCR               ;PRINT CR IF VALUE DOESN'T FIT ON CURRENT LINE
          MOV       EDX,AUX02            ;RESTORE PTR TO VALUE
          JMP       WRTBLKB              ;PRINT VALUE

PRINTV1:  XCHG      EDX,CHARCNT
          JMP       WRTBLKB              ;PRINT VALUE

;     TWRITE: OUTPUT A CHARACTER WITH AN OBS STROBE
;             (CRT, PRINTER, ETC.)
;
;          DESCRIPTION:
;               CHARACTER IS OUPUT WITH AN OBS STROBE. IF
;               CHARACTER <> 0X AND LINE WIDTH <> 0,
;               CHARCNT (NO. OF CHARACTERS ON LINE) IS
;               INCREMENTED.  IF CHARCNT = LINE WIDTH, CR
;               IS OUTPUT.
;
;               IF CHARACTER = CR, DEVICE TYPE DETERMINES
;               WHETHER LF, NULL, OR NOTHING IS STROBED
;               AFTER CR.
;                    DEVICE TYPE 0: LF STROBED AFTER CR
;                                7: NOTHING STROBED
;                        OTHERWISE: 00 STROBED AFTER CR
;               IF A PAUSE IS SELECTED, PAUSE OCCURS
;               AFTER 'CRXX' STROBED.
;               IF DISPLAY IN STEPS SELECTED AND NUMBER
;               OF LINES OUPUT = 15, A BRANCH IS MADE TO
;               'ENTER'.  PC'S ARE SAVED IN AUX2.
;               PRESSING A CR ON KEYBOARD WILL
;               CAUSE A SUBROUTINE RETURN BACK TO ROUTINE
;               THAT CALLED 'TWRITE' (OR 'PRNTCR').
;
;          ENTRY: K = CHARACTER TO OUTPUT
;
;          MODIFIED REGISTERS: F1
;               K (IF CHAR.= CR OR IF AUTOMATIC CR (EOL))
;               CH,CL (ONLY IF LISTS OR LISTD)
;
;     TWRITESP: OUTPUT A SPACE WITH AN OBS STROBE.
;     TWRIT2SP: OUTPUT 2 SPACES WITH OBS STROBES.
;     TWRIT3SP: OUTPUT 3 SPACES WITH OBS STROBES.
;     TWRIT4SP: OUTPUT 4 SPACES WITH OBS STROBES.
;     TWRIT6SP: output 6 spaces with obs strobes
;
;          ENTRY: NOTHING
;
;          MODIFIED REGISTERS: F1
;                              K = SPACE (20)
;                              CH,CL (ONLY IF LISTS OR D)
;
;     TWRITE3X: OR CONTENTS OF K WITH 30 AND OUTPUT
;               RESULTANT CHARACTER.
;
;          ENTRY: K SET TO DESIRED VALUE.
;
;          MODIFIED REGISTERS: F1
;                              K OR'ED WITH 30
;                              CH,CL (ONLY IF LISTS OR D)
;
;     TWRITEP: SAME AS 'TWRITE' EXCEPT IF CHAR. = 00-0F,
;              '.' IS OUTPUT INSTEAD OF CHARACTER.
;
;          MODIFIED REGISTERS: F1,K
;               CH,CL (ONLY IF LISTS OR D)
;
;     TWRITE0C: OUTPUT HEX(0C)
;

TWRITEP:  MOV       AL,K
          AND       AL,0F0H
          CMP       AL,0
          JNE       TWRITE6             ;BRANCH IF NOT 00-0F
          MOV       K,'.'               ;OUTPUT '.' IF CHARACTER = 00-0F
TWRITE6:  JMP       TWRITE              ;OUTPUT CHARACTER

TWRITE3X: OR        K,30H               ;OR K WITH 30
          JMP       TWRITE

TWRITE0C: MOV       K,0CH
          JMP       TWRITE

TWRIT6SP: CALL      TWRIT2SP            ;output 2 spaces
TWRIT4SP: CALL      TWRITESP            ;OUTPUT A SPACE
TWRIT3SP: CALL      TWRITESP            ;OUTPUT A SPACE
TWRIT2SP: CALL      TWRITESP            ;OUTPUT A SPACE
TWRITESP: MOV       K,20H

TWRITE:   MOV       EAX,DWORD PTR [CPBASE]
          CMP       BYTE PTR [EAX].@ESCFLAG,1
          JNE       TWRITEESC
          CALL      OBSTROBE            ;STROBE (OBS) CHARACTER IN K
          JMP       TWRITE4
TWRITEESC:
          CALL      OBSTROBE            ;STROBE (OBS) CHARACTER IN K
          TEST      K,0F0H
          JZ        TWRITE1             ;BRANCH IF CHARACTER = 0X
          XCHG      EDX,ACTDEV
          MOV       AL,DH
          AND       AL,0FH
          CMP       AL,4
          JE        TWRITE5             ;BRANCH IF DEVICE TYPE = 4
          XCHG      EDX,ACTDEV
          nop
          nop
          nop
          nop
          nop
          nop
          XCHG      EDX,CHARCNT
          MOV       R1,DH               ;F1 = LINE WIDTH
          CMP       R1,0
          JE        TWRITE2             ;BRANCH IF LINE WIDTH = 0
          INC       DL                  ;INCREMENT CHARCNT
          CMP       R1,DL
          JBE       TWRITE3             ;BRANCH IF CHARCNT <= LINE WIDTH
TWRITE2:  XCHG      EDX,CHARCNT
TWRITE4:  RET

TWRITE3:  XCHG      EDX,CHARCNT
          JMP       PRNTCR              ;PRINT CR

TWRITE1:  CMP       K,0DH
          JNE       TWRITE4             ;BRANCH IF NOT CR
          JMP       PRNTCRA

TWRITE5:  XCHG      EDX,ACTDEV
          RET


;  TWRT30SP:  output 30 spaces
;
;        Entry:    none
;
;        Modified registers:  F0-1,K,CHCL
;
;  TWRITNSP:  output n spaces
;
;        Entry:    F0 = number of spaces  (0-255)
;
;        Modified registers: K,F0-1,CHCL

TWRT30SP: MOV       R0,01EH
; ------------------------------------------------------------------------------
TWRITNS1: DEC       R0               ;decrement number
          CALL      TWRITESP         ;' '
TWRITNSP: CMP       R0,0
          JNE       TWRITNS1
          RET
; ----------------- output character -------------------------------------------

TWRITEQT: MOV       K,'"'
          JMP       TWRITE           ;output '"'

TWRITELT: MOV       K,'<'
          JMP       TWRITE           ;output '<'

TWRITEMN: MOV       K,'-'
          JMP       TWRITE           ;output '-'

TWRITCOL: MOV       K,':'
          JMP       TWRITE           ;output ':'

; DISPATTR: Set terminal display attributes but don't enable them.
;
; ENTRY: F0 = xy, where x and y are used in the following selection sequence:
;
;                 hex( 02 04 0x 0y 0F )
;
;                  x = 2 for bright              y = 2 for reverse
;                      4 for blink                   4 for underline
;                      6 for bright, blink           6 for reverse, underline
;
; REGISTERS MODIFIED: K,F1

;  TWRITE0F:  output hex(0F)

DISPATTR: MOV       K,02H
          CALL      TWRITE             ;start escape sequence

          MOV       K,04H
          CALL      TWRITE             ;specifying attribute

          MOV       AL,R0
          SHR       AL,4
          MOV       K,AL
          CALL      TWRITE             ;send 0x

          MOV       AL,R0
          AND       AL,0FH
          MOV       K,AL
          CALL      TWRITE             ;send 0y

TWRITE0F: MOV       K,0FH
          CALL      TWRITE             ;terminate sequence and exit
          RET

;  TAB16A:  space to the next column that is a multiple of 16
;  TAB16:   same, except don't move if already at a multiple of 16
;
;        Entry:    CHARCNT contains current cursor position
;                  Output device enabled
;
;        Modified registers:  K,PHPL,CHCL,F1
;

TAB16A:   CALL      TWRITESP          ;output space
TAB16:    MOV       EDX,CHARCNT
          CMP       DL,0
          JNE       TAB16A
          RET

;  ATCOL:  space to the specified column
;
;        Entry:    F0 = column (0-255)
;                  Output device enabled
;                  Current column <= column to space to (no checking done)
;
;        Modified registers:  K,CHCL,F0-1
;

ATCOL0E:  MOV       R0,0EH           ;space to column 14

ATCOL:    XCHG      EDX,CHARCNT
          SUB       R0,DL            ;number of spaces to output
          XCHG      EDX,CHARCNT
          CALL      TWRITNSP         ;output spaces
          RET

;     WRTBLK: OUTPUT A BLOCK OF CHARACTERS STORED IN
;             RAM VIA OBS STROBES
;
;          ENTRY: OUTPUT DEVICE ENABLED
;                 F0 = NO. OF CHARACTERS TO OUTPUT
;                      (0 < NO. < 256)
;                 PC'S = ADDRESS OF CHARACTER BLOCK
;
;          RETURN: PC'S POINT AFTER BLOCK OF CHARACTERS
;
;          MODIFIED REGISTERS: PC'S,F0,K,F1
;
;     WRTWORD: OUTPUT THE SPECIFIED TEXT WORD. WORD IS
;              SPECIFIED BY IT'S TEXT ATOM.
;
;          ENTRY: CH = TEXT ATOM OF WORD TO OUTPUT
;
;          MODIFIED REGISTERS: CH,CL,PC'S,F0,F1,K
;
;

WRTWORD:  CALL      WORDLEN            ;GET LENGTH OF WORD

WRTBLK:   MOV       CH,BYTE PTR [EDX]  ;CH = NEXT CHARCTER TO OUTPUT
          MOV       K,CH
          CALL      TWRITE             ;OUT PUT CHARACTER
          DEC       R0                 ;DECREMENT COUNT
          INC       EDX                ;INC. PC'S AND BRANCH IF MORE CHAR.
          CMP       R0,0
          JNE       WRTBLK
WRTBLKR:  RET

;     WRTBLKB: OUTPUT (OBS) A BLOCK OF CHARACTERS WITH
;              'TWRITE' LOGIC
;
;          ENTRY: PC'S = ADDRESS OF BLOCK OF CHARACTERS
;               F3,2 = ADDRESS OF END OF BLOCK +1
;
;          RETURN: PC'S = ADDR OF LAST CHAR. IN BLOCK+1
;                  CH = LAST CHARACTER IN BLOCK
;
;          MODIFIED REGISTERS: PC'S,K,F1,CH,CL
;

WRTBLKB:  CMP       DWORD PTR [A2],EDX      ;BR, IF ADDRESS >= LIMIT
          JBE       WRTBLKR
          MOV       CH,BYTE PTR [EDX]       ;GET NEXT CHARCTER
          INC       EDX
          MOV       K,CH                    ;K = CHARACTER
          CALL      TWRITE                  ;OUTPUT CHARACTER
          JMP       WRTBLKB

;  WRTBLKP:  output a string of characters, but translate unprintables to '.'
;
;                  Characters 00-0F translated to '.'
;
;        Entry:    output device enabled
;                  F0 = no. of characters
;                  PHPL = address of string
;
;        Return:   PHPL points after string
;
;        Modified registers:  CHCL,PHPL,F0,K,F1
;

WRTBLKP:  MOV       CH,BYTE PTR [EDX]   ;get next character, dec. count
          DEC       R0                  ;get next character, dec. count
          MOV       K,CH
          CALL      TWRITEP             ;output character
          INC       EDX
          CMP       R0,0                ;branch if more characters
          JNE       WRTBLKP
          RET

;  WRTWORDF:  display word whose atom is F0
;
;        Entry:  F0 = atom of word to display
;
;        Modified registers:  CHCL,K,F0-1,PHPL
;

WRTWORDF: SUB       R0,80H            ;double atom
          CALL      WORDLENA          ;get length of word
          CALL      WRTBLK            ;display word
          RET

;  WRTDADDR:  display device address
;
;        Entry:    CHCL = device address  (for WRTDADDR)
;                  F3F2 = device address  (for WRTDADRF)
;
;        Modified registers:  CHCL,K,F1-3
;                                    F2-3 not modified for WRTDADRF
;

WRTDADDR: MOV       WORD PTR [R2],CX  ;device address
WRTDADRF: MOV       K,'/'
          CALL      TWRITE            ;'/'
          MOV       AL,R3
          AND       AL,0FH
          CALL      WRTHEXCH          ;'x' device type
          MOV       AL,R2
          SHR       AL,4
          CALL      WRTHEXCH          ;'y' high digit of address
          MOV       AL,R2
          AND       AL,0FH
          CALL      WRTHEXCH          ;'y' low digit of address
          RET

;     CNSLMSG: SCAN TEXT FOR CONSOLE MESSAGE (LITERAL)
;              AND PRINT THE MESSAGE TO THE
;              CURRENTLY ENABLED DEVICE.
;
;          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;                 OUPUT DEVICE ENABLED.
;
;          RETURN: F0 = 0 IF MESSAGE FOUND. TEXTPTR
;                         POINTS AFTER MESSAGE.
;                  F0 = 1 IF MESSAGE NOT FOUND. TEXTPTR
;                         POINTS TO NEXT NONBLANK TEXT
;                         CHARACTER.
;
;          MODIFIED REGISTERS: CH,CL,PC'S,F0-3,
;               IN EXECUTION PHASE, K,AUX2
;

CNSLMSG:  CALL      LITERAL             ;SCAN & PROCESS LITERAL
          TEST      R0,0FH              ;NF, EXIT
          JNZ       CNSLMSG1
          TEST      SL,2                ;BRANCH IF NOT EXECUTION PHASE
          JZ        CNSLMSG1
          MOV       EDX,VSPTR           ;GET ADDRESS & LENGTH OF LITERAL
          MOV       CX,WORD PTR [EDX]
          MOV       WORD PTR [R0],CX
          MOV       EDX,DWORD PTR [EDX+2]
          ADD       VSPTR,6
          CALL      PRINTV              ;PRINT MESSAGE
          MOV       R0,0                ;FLAG = FOUND
CNSLMSG1: RET

;     TRACEVAR: PRINT VARIABLE NAME FOLLOWED BY '_' IF
;               TRACE MODE AND EXECUTION PHASE
;
;          PRINT FORMAT:
;               NUMERIC SCALAR:  N=, N1=
;               NUMERIC ARRAY:   N()=, M1()=
;               ALPHA SCALAR:    A$=, A5$=
;               ALPHA ARRAY:     A$()=, A2$()=
;
;          ENTRY: F3 = VARIABLE NAME LETTER
;                 F2, HIGH 4 BITS = NAME DIGIT OR 'F'
;                     LOW 4 BITS  = VARIABLE ATOM
;                                   (0 IF NUMERIC SCALAR)
;                                   (1 IF ALPHA SCALAR)
;                                   (2 IF NUMERIC VECTOR)
;                                   (3 IF ALPHA VECTOR)
;                                   (6 IF NUMERIC MATRIX)
;                                   (7 IF ALPHA MATRIX)
;
;          MODIFIED REGISTERS: K,PC'S,F0,F1
;
;     TRACEVRA: PRINT VARIABLE NAME AND '_' IF K(BIT1)=1
;               (IE, RECEIVER VARIABLE), EXECUTION PHASE,
;               AND TRACE MODE.
;
;          MODIFIED REGISTERS: PC'S,F0,1,7
;

TRACEVRA: TEST      K,2                 ;BRANCH IF NOT RECEIVER
          JZ        TRACEVRR
          MOV       AL,K
          MOV       R7,AL               ;SAVE K
          CALL      TRACEVAR            ;PRINT VARIABLE NAME IF TRACE MODE, EXECUTION PHAS
          MOV       AL,R7
          MOV       K,AL                ;RESTORE K
TRACEVRR: RET

TRACEVAR: TEST      MODE,0002H
          JNZ       TRACEVRR            ;DON'T TRACE IF IMMEDIATE MODE
          TEST      MODE,0004H
          JZ        TRACEVRR            ;BRANCH IF NOT TRACE MODE
          TEST      SL,2
          JZ        TRACEVRR            ;BRANCH IF NOT EXECUTION PHASE
          CALL      WRTVNAME            ;OUTPUT VARIABLE NAME

          MOV       K,'<'               ;output '<'
          CALL      TWRITE
          MOV       K,'-'               ;output '-'
          CALL      TWRITE
          JMP       TWRITESP            ;output space

;     WRTVNAME: PRINT VARIABLE NAME and trailing space
;     WRTVNAMF: same, except no trailing space
;
;          PRINT FORMAT:
;               NUMERIC SCALAR:  N, N1
;               NUMERIC ARRAY:   N(, M1(
;               ALPHA SCALAR:    A$, A5$
;               ALPHA ARRAY:     A$(, A2$(
;
;          ENTRY: F3 = VARIABLE NAME LETTER
;                 F2, HIGH 4 BITS = NAME DIGIT OR 'F'
;                     LOW 4 BITS  = VARIABLE ATOM
;                                   (0 IF NUMERIC SCALAR)
;                                   (1 IF ALPHA SCALAR)
;                                   (2 IF NUMERIC VECTOR)
;                                   (3 IF ALPHA VECTOR)
;                                   (6 IF NUMERIC MATRIX)
;                                   (7 IF ALPHA MATRIX)
;
;          MODIFIED REGISTERS: K,PC'S,F0,F1
;

WRTVNAME: CALL      WRTVNAMF          ;output variable name
          CALL      TWRITESP          ;output a space
          RET

WRTVNAMF: TEST      R2,8              ;BRANCH IF NOT GLOBAL VARIABLE
          JZ        WRTVNAM2
          MOV       K,'@'
          CALL      TWRITE            ;OUTPUT '@'
WRTVNAM2: MOV       AL,R3
          MOV       K,AL
          CALL      TWRITE            ;OUTPUT 'NAME LETTER'
          MOV       AL,R2             ;BRANCH IF NO NAME DIGIT
          AND       AL,0F0H
          CMP       AL,0F0H
          JE        WRTVNAM3
          MOV       AL,R2
          SHR       AL,4
          ADD       AL,30H
          CMP       AL,39H
          JBE       XXX
          ADD       AL,7
XXX:      MOV       K,AL
          CALL      TWRITE3X          ;OUTPUT 'NAME DIGIT'
WRTVNAM3: TEST      R2,1
          JZ        WRTVNAM4
          MOV       K,'$'
          CALL      TWRITE            ;OUTPUT '$' IF ALPHA VARIABLE
WRTVNAM4: TEST      R2,6
          JZ        WRTVNAM1
          MOV       K,'('
          CALL      TWRITE            ;OUTPUT '('
          RET

WRTVNAM1: RET


; A$TRACE:  output an alpha value in ascii and in hex.
;
;           Alpha length is truncated to 16.  The value is output in ascii
;           enclosed in quotes.  The value is then output in hex, up to the
;           end of the line.
;
;        Entry:    output device enabled
;                  F1F0 = alpha length
;                  PHPL = address of alpha value
;
;        Return:   none
;
;        Modified registers: PHPL,CHCL,K,F0-3,K,AUX0
;
;

A$TRACE:  MOV       AUX00,EDX           ;save address
          CMP       WORD PTR [R0],16
          JB        A$TRACEX
          MOV       WORD PTR [R0],16    ;F1,0 = 16 IF LENGTH >= 16
A$TRACEX: MOV       AX,WORD PTR [R0]
          MOV       WORD PTR [R2],AX    ;save length

          CALL      TWRITEQT            ;output quote
          MOV       AX,WORD PTR [R2]
          MOV       WORD PTR [R0],AX
          CALL      WRTBLKP             ;output value in ASCII
          CALL      TWRITEQT            ;output quote

          CALL      TWRITESP            ;output space

          MOV       EDX,CHARCNT
          MOV       R0,DH
          INC       R0

          SUB       R0,DL               ;# chars remaining on line

          MOV       R1,30H
          TEST      R2,0FH              ;branch if length = 16
          JZ        A$TR21

A$TR2:    MOV       AL,R2               ;# chars needed to print value
          SHL       AL,1
          ADD       AL,R2
          MOV       R1,AL

A$TR21:   MOV       AL,R1
          CMP       AL,R0               ;branch if enough room for value
          JBE       A$TR3
          DEC       R2                  ;decrement value length
          JMP       A$TR2

A$TR3:    MOV       AX,WORD PTR [R2]    ;length of value
          MOV       WORD PTR [R0],AX
          MOV       EDX,AUX00           ;address of value
          CALL      WRTHEXS             ;output value in hex
          RET


;     TRACELIN: PRINT 'TRANSFER TO XXXX' MESSAGE IF TRACE
;               WHERE 'XXXX' = SPECIFIED LINE NUMBER.
;
;          ENTRY: F3,2 = LINE NUMBER TO PRINT
;
;          MODIFIED REGISTERS: K,PC'S,F0-4,CH,CL
;
;
;     TRACELNA: SAME AS 'TRACELIN' EXCEPT FOR ENTRY
;
;          ENTRY: TEXTLPTR POINTS TO LINE WHOSE LINE
;                 NUMBER IS TO BE PRINTED.
;
;          MODIFIED REGISTERS: PC'S,K,F0-4,CH,CL
;
;     TRACELNB: SAME AS 'TRACELIN' EXCEPT FOR ENTRY
;               (PRINTS LINE# OF NEXT STATEMENT)
;
;          ENTRY: IF TEXTPTR POINTS AT A 'CR', TEXTLPTR
;                 POINTS AT THREAD TO LINE WHOSE LINE# IS
;                 IS TO BE PRINTED.  OTHERWISE, TEXTLTR
;                 POINTS TO THE LINE WHOSE LINE# IS TO
;                 PRINTED.
;
;          NOTE: THIS ROUTINE IS CALLED BY 'NEXT' AND
;                'RETURN'
;

TRACELIN: TEST      MODE,0008H
          JZ        TRACELN2            ;BRANCH IF NOT TRACE MODE
TRACELNA: TEST      MODE,0008H
          JZ        TRACELN2            ;BRANCH IF NOT TRACE MODE
TRACELN3: MOV       EDX,TEXTLPTR
TRACELN4: XCHG      EDX,AUX00
          ADD       AUX00,4
          XCHG      EDX,AUX00
          MOV       CX,WORD PTR [EDX]   ;CH,CL = LINE NUMBER
          XCHG      CH,CL
          MOV       WORD PTR [R2],CX    ;F3,2 = LINE NUMBER

TRACELN1: TEST      MODE,0002H
          JNZ       TRACELN2            ;DON'T TRACE IF IMMEDIATE EXECUTION
          MOV       AL,R2
          MOV       R4,AL               ;save register
          MOV       EDX,OFFSET TRNSFMSG
          CALL      WRTSTRCM            ;output 'TRANSFER TO'
          CALL      TWRITESP            ;output space
          MOV       AL,R4
          MOV       R2,AL               ;restore register
          CALL      WRT@                ;OUTPUT '@' IF GLOBAL TEXT LINE
          CALL      WRTLINE_            ;PRINT 'LINE NUMBER'
          CALL      PRNTCR              ;PRINT 'CR'
          JMP       TRACDSBL            ;disable trace (enable null device)

TRACELNB: TEST      MODE,0008H
          JZ        TRACELN2            ;BRANCH IF NOT TRACE MODE
          CMP       BYTE PTR [TEXTPTR],0DH  ;LOOK FOR 'CR'
          JNE       TRACELN3            ;NF, BRANCH (PRINT LINE# OF CURRENT LINE)
          MOV       EDX,TEXTLPTR
          MOV       ECX,DWORD PTR [EDX]
          MOV       EDX,ECX             ;PC'S = ADDRESS OF NEXT LINE
          CMP       EDX,0               ;B, IF NOT END OF PROGRAM (THREAD = 0)
          JNE       TRACELN4

TRACELN2: RET                           ;IF END OF PROGRAM, DON'T PRINT ANYTHING

;     WRTVAL: CONVERT A 2-BYTE BINARY VALUE TO DECIMAL
;             AND PRINT RESULT. LEADING ZEROES WILL BE
;             BE PRINTED (TOTAL OF 5 DIGITS)
;
;          ENTRY: CH,CL = BINARY VALUE
;                 OUTPUT DEVICE ENABLED
;
;          RETURN: F4-2 = DECIMAL VALUE (RIGHT JUSTIFIED,
;                         WITH LEADING ZEROES)
;
;          MODIFIED REGISTERS: F0-5,K
;
;     WRTVALA: SAME AS 'WRTVAL' EXCEPT FOR ENTRY
;
;          ENTRY: F1,0 = BINARY VALUE
;                 OUTPUT DEVICE ENABLED
;

WRTVAL:   MOV       WORD PTR [R0],CX     ;F1,0 = BINARY VALUE
WRTVALA:  CALL      BINDEC               ;CONVERT BINARY VALUE TO DECIMAL
          MOV       AL,R4
          OR        AL,30H
          MOV       K,AL
          CALL      TWRITE               ;PRINT HIGH DIGIT OF VALUE
          JMP       WRTLIN_4             ;PRINT LOW 4 DIGITS OF VALUE

;===============================================================================
;  WRTVAL8:  output in decimal a 1-byte binary value
;  WRTVAL16: output in decimal a 2-byte binary value
;
;                  Leading zeroes are not output.
;
;        Entry:    F0 = value (WRTVAL8)
;                  F1F0 = value (WRTVAL16)
;
;        Modified registers: K,PHPL,CHCL,F0-5
;

WRTVAL8:  MOV       R1,0

WRTVAL16: CALL      BINDEC              ;F4-2 = packed decimal number
          TEST      R4,0FH              ;branch if 5th digit 0
          JZ        WRTVAL99
          MOV       AL,R4
          OR        AL,30H
          MOV       K,AL
          CALL      TWRITE              ;write high digit
          CALL      WRTLIN_4            ;output remaining digits
          RET

WRTVAL99: CALL      WRTLINE_            ;output number
          RET

;  WRTNIB:  convert the 4-bit binary value to decimal and display
;
;        Entry:    F0 = 0x where x = binary value
;
;        Modified registers:  F0-1,K,CHCL

WRTNIB:   ADD       R0,7
          TEST      R0,10H
          JNZ       WRTNIB1
          ADD       R0,0FAH
WRTNIB1:  MOV       AL,R0
          SHR       AL,4
          MOV       K,AL
          CALL      TWRITE3X               ;high digit
          MOV       AL,R0
          AND       AL,0FH
          MOV       K,AL
          CALL      TWRITE3X               ;low digit
          RET

;     WRTHEX: OUTPUT (OBS) A STRING OF CHARACTERS IN
;             HEXADECIMAL NOTATION.
;
;          ENTRY: F1,0 = NO. OF CHARACTERS
;                 PC'S = ADDRESS OF CHARACTER STRING
;
;          RETURN: (F3,2),PC'S,AUX0 POINT TO END OF
;                                   STRING +1
;
;          MODIFIED REGISTERS: F1-3,PC'S,K,CH,CL,AUX0
;
;     WRTHEXCH: OUTPUT (OBS) A 4-BIT VALUE IN HEXADECIMAL
;               NOTATION.
;
;          ENTRY: K = 0X WHERE X = VALUE TO OUTPUT
;
;          MODIFIED REGISTERS: K,F1
;

WRTHEX:   XOR       EAX,EAX
          MOV       AX,WORD PTR [R0]
          MOV       DWORD PTR [A2],EDX
          ADD       DWORD PTR [A2],EAX       ;F3,2 = ADDRESS OF END OF STRING+1
WRTHEX1:  MOV       CH,BYTE PTR [EDX]        ;GET NEXT CHARACTER; INCREMENT POINTER
          MOV       AUX00,EDX
          INC       AUX00
          MOV       AL,CH                    ;K = 0X WHERE X = HIGH 4-BITS OF CHARACTER
          SHR       AL,4
          CALL      WRTHEXCH                 ;OUTPUT HIGH-ORDER HEX DIGIT
          MOV       AL,CH                    ;K = 0X WHERE X = LOW 4-BITS OF CHARACTER
          AND       AL,0FH
          CALL      WRTHEXCH                 ;OUTPUT LOW-ORDER HEX DIGIT
          MOV       EDX,AUX00                ;PC'S POINT TO NEXT CHARACTER
          CMP       DWORD PTR [A2],EDX       ;BRANCH IF MORE CHARACTERS
          JNE       WRTHEX1
          RET

WRTHEXCH: ADD       AL,30H
          CMP       AL,3AH                   ;BRANCH IF 0-9
          JB        WRTHEXCH1
          ADD       AL,7                     ;CONVERT A-F TO ASCII
WRTHEXCH1:
          MOV       K,AL
          JMP       TWRITE                   ;OUTPUT CHARACTER

;     WRTHEXS: output a string of bytes in hex with spaces between bytes
;
;          Entry: F1F0 = number of bytes
;                 PHPL = address of string
;
;          Modified registers: F0-3,K,CHCL,PHPL
;

WRTHEXS:  XOR       EAX,EAX
          MOV       AX,WORD PTR [R0]
          MOV       DWORD PTR [A2],EDX
          ADD       DWORD PTR [A2],EAX     ;F3,2 = ADDRESS OF END OF STRING+1
          JMP       WRTHEXS2

WRTHEXS1: CALL      TWRITESP               ;output space

WRTHEXS2: MOV       CH,BYTE PTR [EDX]      ;get next byte
          INC       EDX
          MOV       R0,CH
          CALL      WRTHEXB                ;output byte in hex
          CMP       DWORD PTR [A2],EDX     ;BRANCH IF MORE CHARACTERS
          JNE       WRTHEXS1
          RET

;===============================================================================
;     WRTHEXB: output a byte in hex (2 hex digits)
;
;          Entry: F0 = byte
;
;          Modified registers: K,F1,CHCL
;

WRTHEXB:  MOV       AL,R0
          SHR       AL,4
          ADD       AL,30H
          CMP       AL,3AH
          JB        WRTHEXB1
          ADD       AL,7
WRTHEXB1: MOV       K,AL
          CALL      TWRITE          ;output high hex digit

          MOV       AL,R0
          AND       AL,0FH
          ADD       AL,30H
          CMP       AL,3AH
          JB        WRTHEXB2
          ADD       AL,7
WRTHEXB2: MOV       K,AL
          CALL      TWRITE          ;output low hex digit
          RET

; WRT@: OUTPUT '@' IF IBASE POINTING TO GLOBAL TEXT
;
; WRT@ORSP: SAME EXCEPT IF NOT POINTING TO GLOBAL, OUPUT ' '.
;
;      MODIFIED REGISTERS: PC'S,K,F1,CH,CL
;

WRT@:     MOV       EDX,DWORD PTR [CPBASE]      ;EDX = XPBASE
          MOV       ECX,DWORD PTR [EDX].@IBASE  ;ECX = IBASE
          CMP       EDX,ECX                     ;RETURN IF IBASE NOT POINTING TO GLOBAL
          JNE       WRT@1
          JMP       FILE_A5

WRT@1:    MOV       K,'@'
          JMP       TWRITE                      ;OUTPUT '@'

WRT@ORSP: MOV       EDX,DWORD PTR [CPBASE]      ;EDX = CPBASE
          MOV       ECX,DWORD PTR [EDX].@IBASE  ;ECX = IBASE
          CMP       EDX,ECX                     ;BRANCH IF IBASE POINTS TO GLOBAL
          JNE       WRT@1
          JMP       TWRITESP                    ;OUTPUT SPACE

;               TITLE  srchplt
;
; srchplt : search PLAT  table to see if platter hoged by another partition
;
;   entry :  actdev = taa ( t = device type , aa = device address)
;
;   return:  al = 0ff if this platter is hogged by another partition
;
;   modified registers:  eax
;            (x)                    (x)
;   bx0 --->     d10   d20    d30      d50  d60  d70
;   3x0 --->     d11   d21    d31      d51  d61  d71
;                 .     .      .        .    .    .
;                 .     .      .        .    .    .
;                d1f   d2f    d3f      d5f  d6f  d7f

srchplt:
        mov     a0,0              ;assume not hogged                    ^A00C
        mov     eax,actdev
        and     ah,0fh
        cmp     ah,0dh
        jz      srchplt_1
        cmp     ah,0bh
        jz      srchplt_1
        cmp     ah,03h
        jnz     srchplt_3
        cmp     al,40h
        jz      srchplt_3
        inc     al
srchplt_1:
        and     eax,0ffh
        add     eax,offset plat   ;eax = point to the corresponding PLAT entry
        mov     al,byte ptr [eax]
        
        test    al,80h
        jz      srchplt_3         ;br if this platter is not hoged

        mov     a0,1              ;hog by itself

        and     al,3fh
        cmp     al,part_          ;
        jz      srchplt_3         ;br if current partition = partition issued platter hog
        mov     al,0ffh
        ret
srchplt_3:
        mov     ax,a0
        ret

; close_open: close device that be opened by platter hogged in same partition
;
;   bx0 --->     d10   d20    d30      d50  d60  d70
;   3x0 --->     d11   d21    d31      d51  d61  d71
;                 .     .      .        .    .    .
;                 .     .      .        .    .    .
;                d1f   d2f    d3f      d5f  d6f  d7f

public  close_open
close_open:
        push    ecx
        push    esi
        push    eax

        mov     ecx,30h
        mov     esi,offset plat
        add     esi,10h
close_open2:
        lodsb
        test    al,40h
        jz      close_open1
        and     al,3fh
        cmp     al,part_
        jne     close_open1
        mov     eax,esi
        dec     eax
        sub     eax,offset plat
        mov     r0,al
        movzx   eax,part_
        add     eax,offset plat+40h
        push    ebx
        mov     bl,r0
        mov     byte ptr [eax],bl
        pop     ebx
        push    esi
        push    ecx
        call    $closeplat
        call    close_mdevtbl
        movzx   ecx,part_
        add     ecx,offset plat+40h
        mov     byte ptr [ecx],0
        pop     ecx
        pop     esi
close_open1:
        loop    close_open2

        mov     ecx,30h
        mov     esi,offset plat
        add     esi,50h
close_open4:
        lodsb
        test    al,40h
        jz      close_open3
        and     al,3fh
        cmp     al,part_
        jne     close_open3
        mov     eax,esi
        dec     eax
        sub     eax,offset plat
        mov     r0,al
        movzx   eax,part_
        add     eax,offset plat+40h
        push    ebx
        mov     bl,r0
        mov     byte ptr [eax],bl
        pop     ebx
        push    esi
        push    ecx
        call    $closeplat
        call    close_mdevtbl
        movzx   ecx,part_
        add     ecx,offset plat+40h
        mov     byte ptr [ecx],0
        pop     ecx
        pop     esi
close_open3:
        loop    close_open4

        pop     eax
        pop     esi
        pop     ecx
        ret

public  clear_open
clear_open:
        push    eax
        push    ecx
        push    esi
        movzx   eax,part_
        add     eax,offset plat
        mov     byte ptr [eax],0
        mov     ecx,30h
        mov     esi,offset plat+10h
clear_open2:
        lodsb
        and     al,7fh
        cmp     al,part_
        jne     clear_open1
        mov     byte ptr [esi-1],0
clear_open1:
        loop    clear_open2

        movzx   eax,part_
        add     eax,offset plat+40h
        mov     byte ptr [eax],0
        mov     ecx,30h
        mov     esi,offset plat+50h
clear_open4:
        lodsb
        and     al,7fh
        cmp     al,part_
        jne     clear_open3
        mov     byte ptr [esi-1],0
clear_open3:
        loop    clear_open4
        pop     esi
        pop     ecx
        pop     eax
        ret

close_mdevtbl:
        push    eax
        push    ecx
        mov     eax,offset MDEVTBL
clear_open6:
        mov     cx,word ptr [eax]
        xchg    ch,cl
        add     eax,2
        cmp     ch,0
        je      clear_open5
        test    cl,DEVTDISK
        jz      clear_open6

        and     cl,0fh
        cmp     cl,part_
        jnz     clear_open6
        mov     byte ptr [eax-1],8fh
        jmp     clear_open6
clear_open5:
        pop     ecx
        pop     eax
        ret

close_openy:
        push    ecx
        push    esi
        push    eax

        mov     ecx,30h
        mov     esi,offset plat
        add     esi,10h
close_open2y:
        lodsb
        test    al,40h
        jz      close_open1y
        and     al,3fh
        cmp     al,part_
        jne     close_open1y
        mov     eax,esi
        dec     eax
        sub     eax,offset plat
        mov     r0,al
        movzx   eax,part_
        add     eax,offset plat+40h
        push    ebx
        mov     bl,r0
        mov     byte ptr [eax],bl
        pop     ebx
        push    esi
        push    ecx
        call    $closeplat_aaa
        call    close_mdevtbl
        movzx   ecx,part_
        add     ecx,offset plat+40h
        mov     byte ptr [ecx],0
        pop     ecx
        pop     esi
close_open1y:
        loop    close_open2y

        mov     ecx,30h
        mov     esi,offset plat
        add     esi,50h
close_open4y:
        lodsb
        test    al,40h
        jz      close_open3y
        and     al,3fh
        cmp     al,part_
        jne     close_open3y
        mov     eax,esi
        dec     eax
        sub     eax,offset plat
        mov     r0,al
        movzx   eax,part_
        add     eax,offset plat+40h
        push    ebx
        mov     bl,r0
        mov     byte ptr [eax],bl
        pop     ebx
        push    esi
        push    ecx
        call    $closeplat_aaa
        call    close_mdevtbl
        movzx   ecx,part_
        add     ecx,offset plat+40h
        mov     byte ptr [ecx],0
        pop     ecx
        pop     esi
close_open3y:
        loop    close_open4y

        pop     eax
        pop     esi
        pop     ecx
        ret


public  init_close

init_close:
        mov     ecx,16
init_close_1:
        mov     part_,cl
        dec     byte ptr part_
        push    ecx
        call    close_openy
        pop     ecx
        loop    init_close_1
        ret

public  close_openx
close_openx:
        push    ecx
        push    esi
        push    eax

        mov     ecx,30h
        mov     esi,offset plat
        add     esi,10h
close_openx2:
        lodsb
        test    al,40h
        jz      close_openx1
        and     al,3fh
        cmp     al,part_
        jne     close_openx1
        mov     eax,esi
        dec     eax

        push    edi
        push    ebx
        mov     bl,part_

        push    ecx
        push    eax
        movzx   ecx,bl
        inc     ecx
        mov     eax,16*8
        push    edx
        mul     ecx
        pop     edx
        mov     ecx,eax
        pop     eax
        mov     edi,eax
        add     edi,ecx
        mov     dword ptr [temp_dw],edi
        cmp     byte ptr [eax+ecx],bl
        pop     ecx

        pop     ebx
        pop     edi
        jne     close_openx1

        sub     eax,offset plat
        mov     r0,al
        movzx   eax,part_
        add     eax,offset plat+40h
        push    ebx
        mov     bl,r0
        mov     byte ptr [eax],bl
        pop     ebx

        push    dword ptr [temp_dw]
        push    esi
        push    ecx
        and     r0,0f0h
        call    $closed
        movzx   ecx,part_
        add     ecx,offset plat+40h
        mov     byte ptr [ecx],0
        pop     ecx
        pop     esi
        pop     eax
;       mov     byte ptr [eax],0ffh
;       cmp     byte ptr [eax],0ffh
;       jne     x1111
close_openx1:
        loop    close_openx2_a
        jmp     close_yyy

close_openx2_a:
        jmp     close_openx2

x1111:
        jmp     $


close_yyy:
        mov     ecx,30h
        mov     esi,offset plat
        add     esi,50h
close_openx4:
        lodsb
        test    al,40h
        jz      close_openx3
        and     al,3fh
        cmp     al,part_
        jne     close_openx3
        mov     eax,esi
        dec     eax

        push    edi
        push    ebx
        mov     bl,part_

        push    ecx
        push    eax
        movzx   ecx,bl
        inc     ecx
        mov     eax,16*8
        push    edx
        mul     ecx
        pop     edx
        mov     ecx,eax
        pop     eax
        mov     edi,eax
        add     edi,ecx
        mov     dword ptr [temp_dw],edi
        cmp     byte ptr [eax+ecx],bl
        pop     ecx

        pop     ebx
        pop     edi
        jne     close_openx3

        sub     eax,offset plat
        mov     r0,al
        movzx   eax,part_
        add     eax,offset plat+40h
        push    ebx
        mov     bl,r0
        mov     byte ptr [eax],bl
        pop     ebx
        push    dword ptr [temp_dw]
        push    esi
        push    ecx
        and     r0,0f0h
        call    $closed
        movzx   ecx,part_
        add     ecx,offset plat+40h
        mov     byte ptr [ecx],0
        pop     ecx
        pop     esi
        pop     eax
;       mov     byte ptr [eax],0ffh
;       cmp     byte ptr [eax],0ffh
;       jne     x2222
close_openx3:
        loop    close_openx4_a

        pop     eax
        pop     esi
        pop     ecx
        ret

x2222:
        jmp     $

close_openx4_a:
        jmp     close_openx4

temp_dw dd      0

public  clear_80
clear_80:
        push    esi
        push    eax
        push    ecx
        mov     esi,offset plat_s
        movzx   ecx,part_
        mov     eax,16*8
        push    edx
        mul     ecx
        pop     edx
        add     esi,eax
        mov     ecx,80h
clear_802:
        lodsb
        cmp     al,part_
        jne     clear_801
        mov     byte ptr [esi-1],0ffh
clear_801:
        loop    clear_802
        pop     ecx
        pop     eax
        pop     esi
        ret

$closeplat:
        PUSH    WORD PTR R0
        mov     al,r0
        and     al,0f0h
        mov     k,al

;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],0feh
;       pop     eax
        CALL    ENBLDEVB
;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],01h
;       pop     eax

        MOV     AL,_DISKHOG        ;***
        CALL    CBSNR              ;***

$closeplat_again:
        CALL    WAIT50RB                ;WAIT UP TO 16MS FOR READY
        TEST    BYTE PTR FS:[CPUST],08H ;BRANCH IF READY
        JNZ     $closeplat_go           ;DISABLE DISK
        mov     eax,dword ptr cpbase
        cmp     byte ptr [eax].@rst_flag,1
        JNE     $closeplat_again

        call    wait50rbx
        TEST    BYTE PTR FS:[CPUST],08H ;BRANCH IF READY
        JNZ     $closeplat_go           ;DISABLE DISK

;       call    wait50rbx
;       TEST    BYTE PTR FS:[CPUST],08H ;BRANCH IF READY
;       JNZ     $closeplat_go           ;DISABLE DISK

        mov     eax,dword ptr cpbase
        mov     byte ptr [eax].@rst_flag,0

        jmp     err_00

;       pop     word ptr r0
        jmp     $closeplat_ret1

$closeplat_go:
        CALL    CMNDPLAT
        MOV     BYTE PTR FS:[IOBS],40H
        pop     word ptr r0

        push    word ptr r0
        TEST    R0,0FH
        JZ      REMOVE_2
        AND     R0,0FH
        SUB     R0,1
        JMP     REMOVE_3
REMOVE_2:
        MOV     R0,10H
REMOVE_3:
        OR      R0,20H
        CALL    OBSECHO
        CMP     R0,0
        JNZ     ERR_94E
        MOV     R0,41H
        CALL    OBSECHO
        mov     eax,dword ptr [cpbase]
        MOV     byte ptr [eax].@HOGFLG,0
        CMP     R0,41H
        POP     WORD PTR R0
        JNZ     err_94f               ;+- ANDY
        push    word ptr [r0]

        mov     al,r0

        mov     ebx,0
        mov     bl,al
        add     ebx,offset plat
        mov     byte ptr [ebx],0        ;clear platter hog bit & partition #

$closeplat_ret1:
        call    enddisk
        call    enblnull
        pop     word ptr [r0]
;       call    wakeupp

        push    word ptr [r0]
        call    wakeupp
        pop     word ptr [r0]
        and     r0,0f0h
        and     r0,0b0h
        push    word ptr [r0]
        call    wakeupa
        pop     word ptr [r0]
        or      r0,40h
        call    wakeupa

$closeplat_ret:
        ret


err_94e:
err_94f:
        mov     r0,94h
        jmp     error


$closeplat_aaa:
        PUSH    WORD PTR R0
        mov     al,r0
        and     al,0f0h
        mov     k,al

;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],0feh
;       pop     eax
        CALL    ENBLDEVB
;       push    eax
;       movzx   eax,part_
;       add     eax,offset hog_table
;       mov     byte ptr [eax],01h
;       pop     eax

        MOV     AL,_DISKHOG        ;***
        CALL    CBSNR              ;***

$closeplat_again_aaa:
        CALL    WAIT50RB                ;WAIT UP TO 16MS FOR READY
        TEST    BYTE PTR FS:[CPUST],08H ;BRANCH IF READY
        JNZ     $closeplat_go_aaa           ;DISABLE DISK
        mov     eax,dword ptr cpbase
        cmp     byte ptr [eax].@rst_flag,1
        JNE     $closeplat_again

        CALL    WAIT50RBx               ;WAIT UP TO 16MS FOR READY
        TEST    BYTE PTR FS:[CPUST],08H ;BRANCH IF READY
        JNZ     $closeplat_go_aaa           ;DISABLE DISK

;       CALL    WAIT50RBx               ;WAIT UP TO 16MS FOR READY
;       TEST    BYTE PTR FS:[CPUST],08H ;BRANCH IF READY
;       JNZ     $closeplat_go_aaa           ;DISABLE DISK

        mov     eax,dword ptr cpbase
        mov     byte ptr [eax].@rst_flag,0

        jmp     err_00

;       pop     word ptr r0
        jmp     $closeplat_ret1_aaa

$closeplat_go_aaa:
        CALL    CMNDPLAT
        MOV     BYTE PTR FS:[IOBS],40H
        pop     word ptr r0

        push    word ptr r0
        TEST    R0,0FH
        JZ      REMOVE_2_aaa
        AND     R0,0FH
        SUB     R0,1
        JMP     REMOVE_3_aaa
REMOVE_2_aaa:
        MOV     R0,10H
REMOVE_3_aaa:
        OR      R0,20H
        CALL    OBSECHO
        CMP     R0,0
        JNZ     ERR_94E
        MOV     R0,41H
        CALL    OBSECHO
        mov     eax,dword ptr [cpbase]
        MOV     byte ptr [eax].@HOGFLG,0
        CMP     R0,41H
        POP     WORD PTR R0
        JNZ     err_94f               ;+- ANDY
        push    word ptr [r0]

        mov     al,r0

        mov     ebx,0
        mov     bl,al
        add     ebx,offset plat
        mov     byte ptr [ebx],0        ;clear platter hog bit & partition #

$closeplat_ret1_aaa:
        call    enddisk
        call    enblnull
        pop     word ptr [r0]

$closeplat_ret_aaa:
        ret


CODE    ENDS
        END

