;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M32
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST
PUBLIC    ATCHPART
PUBLIC    BREAKP14
PUBLIC    BREAKP19
PUBLIC    BREAKPT0
PUBLIC    BREAKPT10
PUBLIC    BREAKPTA
PUBLIC    BREAKPTB
PUBLIC    BREAKPTC
PUBLIC    BREAKPTD
PUBLIC    BREAKPTI
PUBLIC    BREAKPTJ
PUBLIC    BREAKPTK
PUBLIC    BREAKPTG
PUBLIC    BREAKPTP
PUBLIC    BREAKPTR
PUBLIC    BREAKPTT
PUBLIC    BREAKPTL
PUBLIC    BREAKPTQ
PUBLIC    BREAKPTW
PUBLIC    BREAKPT9
PUBLIC    BREAKP11
PUBLIC    BRPT14A
PUBLIC    BREAKP15
PUBLIC    BRPT17A
PUBLIC    FRESET
PUBLIC    GETTERM_
PUBLIC    GETTERMA
PUBLIC    GETTERM1
PUBLIC    HPIOF
PUBLIC    HPIOF1
PUBLIC    HPION
PUBLIC    HPION1
PUBLIC    HPION2
PUBLIC    IRTEXTBG
PUBLIC    LDAUXEND
PUBLIC    LDREG10
PUBLIC    LDREG3
PUBLIC    LDREG6
PUBLIC    LOADREGA
PUBLIC    LOADREGS
PUBLIC    LOADSTK
PUBLIC    MVSCRTCH
PUBLIC    MVSCRTCH1
PUBLIC    MXDSTA70
PUBLIC    MXDSTAT8
PUBLIC    NMIOCHK
PUBLIC    R@TEMP
PUBLIC    R@TEMP3
PUBLIC    R@TEMP6
PUBLIC    RDEFNADR
PUBLIC    RDOFLAG
PUBLIC    RFILE_
PUBLIC    RHASHFLG
PUBLIC    RPARTEND
PUBLIC    RPARTNDA
PUBLIC    RSTOP_
PUBLIC    RTRDISK
PUBLIC    SAVEREGA
PUBLIC    SAVEREGS
PUBLIC    SAVEREGX
PUBLIC    SAVSTACK
PUBLIC    TAPIMOD1
PUBLIC    TAPIMODE
PUBLIC    TSTAT2ND
PUBLIC    TSTATCSI
PUBLIC    TSTATRSI
PUBLIC    TSTATSI
PUBLIC    XRTEXTBG
PUBLIC    BREAKPTM
public    breakp13  ;----tsai
public    mxdstat6  ;----tsai
public    mxdsta86  ;----tsai
public    mm8

EXTRN   stack_buffer:NEAR
EXTRN   BASE       :NEAR
EXTRN   CBSNT      :NEAR
;EXTRN   CLKOFF     :NEAR
;EXTRN   CLKON      :NEAR
EXTRN   CPBASE     :DWORD
EXTRN   DELAY5     :NEAR
EXTRN   ENBLNULL   :NEAR
EXTRN   ENBLTC     :NEAR
EXTRN   HPIOFLG    :BYTE
EXTRN   IOBDEV     :NEAR
EXTRN   IOPART_    :BYTE
EXTRN   IOXCNT     :WORD
EXTRN   IPOLL      :NEAR
EXTRN   MATHNRND   :NEAR
EXTRN   MATHPAGE   :NEAR
EXTRN   MXD2SADR   :BYTE
EXTRN   MXD3SADR   :BYTE
EXTRN   MXD4SADR   :BYTE
EXTRN   MXDADR     :BYTE
EXTRN   MXESTA     :NEAR
EXTRN   MXESTA6    :NEAR
EXTRN   MVSCRBUF   :NEAR
EXTRN   NXTRLSPT   :BYTE
EXTRN   OBSNTC     :NEAR
EXTRN   OBSNR      :NEAR
EXTRN   OSMOD      :NEAR
EXTRN   PART_      :BYTE
EXTRN   PBANK      :NEAR
EXTRN   PBREAK     :NEAR
EXTRN   PBRKSTD    :DWORD
EXTRN   PMODE      :NEAR
EXTRN   PROG_      :BYTE
EXTRN   PSTAT      :NEAR
EXTRN   PSTATLD    :DWORD
EXTRN   PTERM      :NEAR
EXTRN   RESET      :NEAR
EXTRN   SCRNIN     :NEAR
;------- u64 ------
EXTRN   TEMPSAVE   :WORD
EXTRN   TEMPSAVE1  :WORD
EXTRN   TEMPSAVE2  :WORD
EXTRN   TEMPSAVE3  :WORD
EXTRN TEMADRTBL  :NEAR
EXTRN TERMNUM    :BYTE
;------- u64e ------
EXTRN   CPUSLICE   :DWORD

EXTRN     PART_T  :BYTE
EXTRN     SAVESEED:NEAR
EXTRN     SCRATCH :NEAR
EXTRN     @@OSEND :DWORD
EXTRN     @@VSEND :DWORD
EXTRN     @@VARTHD:DWORD

EXTRN     SDRVRDEV:NEAR

;------ TSAI ----
EXTRN     MXF:WORD
EXTRN     CMDBUADR:DWORD
EXTRN     COM_BASE:DWORD
EXTRN     MXFTBL  :DWORD
EXTRN     GEN_STORE:DWORD
EXTRN     PARTNO   :DWORD
EXTRN     ENMXFGIOA:NEAR
;EXTRN     DIMXFGIO :NEAR
EXTRN   TOMXF      :BYTE
EXTRN   TOMXFTBL   :NEAR
EXTRN   MXFGIOTBL  :NEAR
extrn   ct         :word
extrn   ct1        :word
;------ TSAII ----

;22c11_s
extrn     disk_addr  :near
extrn     part_addr  :near
extrn     print_addr :near
extrn     chk_printer_x:near
extrn     B_ABS      :byte
; 22c11_e

;MVSCRTCH: COPY THE SPECIFIED NO. OF BYTES FROM 'SCRATCH' AREA
;          TO THE 'IOBUFFER' IN CURRENT PARTITION.
;MVSCRTCH1: COPY THE SPECIFIED NO. OF BYTES FROM 'SCRATCH' AREA
;          TO THE 'MVSCRBUF' IN ANY PARTITION.
;          ( JUST DO'T WANT TO DESTORE THE IOBUFFER )
;
;     ENTRY: F0 = NO. OF BYTES TO COPY
;
;     RETURN: PC'S = ADDRESS OF IOBUFFER
;
;     MODIFIED REGISTERS: PC'S,CH,CL,AUX0
;
;     NOTE: SCRATCH & IOBUFFER MUST START AT 'XX00'
;

MVSCRTCH: MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDI,[EDX].@IOBUFFR          ;POINT TO IOBUFFER
          MOV       EDX,EDI
MVSCRLOOP:
          MOV       ESI,OFFSET SCRATCH          ;POINT TO SCRATCH AREA
          MOVZX     ECX,R0
          REP       MOVSB
          RET
MVSCRTCH1:
          MOV       EDX,OFFSET MVSCRBUF
          MOV       EDI,EDX
          JMP       MVSCRLOOP

;  LPI SUBROUTINES - LOAD PH,PL WITH EQUATES TO SYSTEM
;                    POINTERS RELATIVE TO THE CURRENT
;                    PARTITION.
;
;                    CPBASE = BASE ADDRESS OF THE CURRENT
;                             PARTITION.
;
;

RDEFNADR: MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DEFNADR
          MOV       ECX,DWORD PTR [EDX]
          RET

RTRDISK:  MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TRDISK
          MOV       CH,BYTE PTR [EDX]
          RET

RHASHFLG: MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@HASHFL
          MOV       CH,BYTE PTR [EDX]
          RET

R@TEMP:   MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TRDSKW
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          RET

R@TEMP6:  MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TRDSKW
          ADD       EDX,6
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          RET

R@TEMP3:  MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TRDSKW
          ADD       EDX,3
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          RET

XRTEXTBG: MOV       EDX,DWORD PTR [CPBASE]    ;GET BASE OF CURRENT PARTITION
          MOV       EDX,DWORD PTR [EDX].@XBASE;POINT TO @XBASE
          LEA       EDX,[EDX].@TEXTBEG
          MOV       ECX,DWORD PTR [EDX]
          RET

IRTEXTBG: MOV       EDX,DWORD PTR [CPBASE]     ;GET BASE OF CURRENT PARTITION
          MOV       EDX,DWORD PTR [EDX].@IBASE ;POINT TO @IBASE
          LEA       EDX,[EDX].@TEXTBEG         ;GET @IBASE OR @XBASE
          MOV       ECX,DWORD PTR [EDX]
          RET

RDOFLAG:  MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@DOFLAG
          MOV       CH,BYTE PTR [EDX]       ;point to DOFLAG
          RET                               ;get DOFLAG

RSTOP_:   MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@STOP_
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          RET

; ======= RFILE#================================================================

RFILE_:   MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@FILE_
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          RET

; ======= RPARTEND =============================================================

RPARTEND: MOV       EDX,DWORD PTR [CPBASE]
RPARTNDA: LEA       EDX,[EDX].@PARTEND
          MOV       CH,BYTE PTR [EDX]
          RET


;GETTERM#: CALCULATE THE TERMINAL NUMBER OF CURRENT PARTITION
;          FROM THE TERMINAL ADDRESS
;
;     MODIFIED REGISTERS: PC'S,CH,CL,F0
;
;     RETURN: F0 = TERMINAL #  (01-10 OR 00)
;             CH = PTERM ENTRY
;             PC'S = ADDRESS OF PTERM ENTRY
;
;     ENTRY: TEXTPTR POINTS AT NEXT TEXT CHARACTER
;

GETTERM_: MOVZX     EDX,BYTE PTR [PART_]
          ADD       EDX,OFFSET PTERM
          MOV       CH,BYTE PTR [EDX]     ;GET  PTERM ENTRY
          MOV       CL,BYTE PTR [EDX+PARTMAX]  ;GET XPTERM ENTRY,u64
          MOV       R0,0
          TEST      CH,PTERMRLS           ;BRANCH IF RELEASED PARTITION
          JNZ       GETTERM1

;-------- tsai, 12-27-91 --------
GETTERMD:
          MOV       R0,1                  ;from TERM#1
          AND       CL,0CFH               ;mask desired bits
          PUSH      ESI                   ;search term adr table
          MOV       ESI,OFFSET TEMADRTBL
GETTERMA:
          CMP       CL,BYTE PTR [ESI]     ;
          JE        GETTERMC              ;
          MOV       AL,R0                 ;
          CMP       AL,TERMNUM            ;end of table
          JE        GETTERMB
          INC       R0
          INC       ESI                   ;next
          JMP       GETTERMA
GETTERMB:
          MOV       R0,0
GETTERMC:
          POP       ESI
;-------- TSAI,12-27-91 --------

;-------- u64 -------
;GETTERMA:
;         MOV       R0,CL
;         AND       R0,0FH                ;GET PORT NO ON THIS MXF CARD
;         SHR       CL,02H
;         AND       CL,30H                ;GET MXF NO
;         OR        R0,CL                 ;R0 IS NOW TERMINAL NO
;GETTERMY: INC       R0                    ;INCREMENT ADDRESS ==> TERMINAL #
;--------- u64e ------
GETTERM1: RET


;  TAPIMODE:  get MODE (AUXxx) of partition pointed to by IBASE
;
;        If IBASE = current partition, get MODE AUX directly.
;
;        If IBASE <> current partition, get AUX from register save area
;                  of partition pointed to by IBASE.
;
;        Return:  PHPL = MODE
;
;        Modified registers:  CHCL,PHPL,F1
;

TAPIMODE: MOV       EDX,DWORD PTR [CPBASE]
          MOV       EAX,DWORD PTR [EDX].@IBASE  ;IBASE
          CMP       EDX,EAX                     ;IBASE = CURRENT PARTITION
          JE        TAPIMOD1
          MOV       EDX,DWORD PTR [EAX].@REGMODE
          RET
TAPIMOD1: MOV       EDX,MODE
          RET


;        FILE = JLMVP32 ,10/03/1986
;        MODULE    MOD-32 MVP SUBROUTINES

@RESET   EQU       @SAVESH+2 ;RELATIVE ADDRESS OF RESET FLAG IN SAVE REG. AREA
                             ;00 = NO RESET (SET AT BEGIN OF BREAKPOINT)
                             ;01 = RESET (SET BY MXDSTAT)

;         TITLE     BREAKPT (I/O TASK ENTRY)
;*        The following entry points are for I/O task breakpointing.  I/O task
;*        breakpoints have priority over program breakpoints.
;*
;*        For all entries, except BREAKPTJ, all registers are saved.
;
;*   BREAKPTA --    non-MXD I/O breakpoint
;
;*        The standard entry point used when waiting for a device (other than
;*        the MXD) to become ready.  For output from OBSTROBE and CBSTROBE,
;*        BREAKPTA is called if the device is busy for more than 1ms.  BREAKPTA
;*        is also used for disk I/O breakpointing.
;
;*        BREAKPTJ is a lower level version of BREAKPTA where F0 specifies the
;*        number of registers to be saved.
;
;*        PSTAT is set to non-MXD I/O breakpoint and IOBDEV is set the device
;*        address (from ACTDEV) of the device waiting for.
;
;*   BREAKPTB --    MXD printer breakpoint
;
;*        This breakpoint is used when the MXD is not ready (busy for at least
;*        1 ms.) to receive output for the terminal printer.  This occurs when
;*        the MXD print buffer is full.
;
;*   BREAKPTC --    MXD CRT breakpoint
;
;*        This breakpoint is used when the MXD is not ready (busy for at least
;*        1ms.) to receive output for the CRT.  This occurs when the MXD CRT
;*        buffer if full.
;
;*   BREAKPTD --    MXD line request breakpoint
;
;*        Used after a line request command is issued to the MXD.  The partition
;*        breakpoints until the line request is complete (ie, data is ready to
;*        be input or some other termination of the line request has occured).
;
;*   BREAKPTW --    waiting for resource
;
;*        This breakpoint is used when execution of a paritition cannot procede
;*        because a necessary resource is not available (ie, in use by another
;*        task).  For example, BREAKPTW is used by $OPEN when another paritition
;*        has the requested device, by ENBLCNT when there is no terminal attached
;*        to this partition, and by ENBLDVXA when the desired device is in use.
;
;*        PSTAT is set to inactive for the breakpointing partition.  This partition
;*        is, then, not polled by BREAKPT.  The routine managing the requested
;*        resource must awaken the inactive (ie, waiting) partition when the
;*        resource is free.  For example,  in the case of a breakpoint for $OPEN,
;*        the $CLOSE routine must awaken the waiting partition.  A partition is
;*        awakened by setting PSTAT to I/O complete.
;         EJECT
;*%------------------ BREAKPTW --------------------------------------------------

BREAKPTW:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         MOV       R1,0                 ;INACTIVE PART (WAITING FOR TERM OR DEV)
         JMP       BREAKPTI             ;

;*%----------------- BREAKPTB ---------------------------------------------------
BREAKPTB:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         MOV       R1,PSTATPT           ;PRINT TIMEOUT BREAKPOINT
         JMP       BREAKPTI

;*%----------------- BREAKPTC ---------------------------------------------------
BREAKPTC:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         MOV       R1,PSTATCOT          ;CO TIMEOUT BREAKPOINT
         JMP       BREAKPTI

;-------- TSAI ------------
;*%----------------- BREAKPTM ----------------------
BREAKPTM:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         MOV       R1,PSTATRSD          ;remote screen dump breakpoint
         JMP       BREAKPTI
;------- TSAII --------

;*%----------------- BREAKPTD ---------------------------------------------------
BREAKPTD:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         MOV       R1,PSTATLR           ;LINE REQUEST BREAKPOINT
         JMP       BREAKPTI

;*%----------------- BREAKPTA BREAKPTJ ------------------------------------------
BREAKPTA:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS

BREAKPTJ:
         MOV       R1,PSTATIBT          ;F1 = NON-MXD I/O BRPT
         MOV       AX,WORD PTR ACTDEV   ;
         AND       AH,0FH               ;1/11/89
         CMP       AH,_PHOENIX          ;
         JNE       MOD32_01             ;
         AND       AL,0F0H              ;IF DEVICE TYPE = 'D', STRIP OFF PLATTER BITS
MOD32_01:
         MOV       K,AL                 ;
         MOVZX     EDX,PART_
         ADD       EDX,OFFSET IOBDEV    ;
         MOV       BYTE PTR [EDX],AL    ;DEVICE ADDR -> IOB DEVICE TABLE
         JMP       BREAKPTI
;
;         TITLE     BREAKPT (PROGRAM TASK ENTRY)
;*        The following entry points are for program task breakpointing.  Program
;*        task breakpoints are secondary to that of I/O.
;
;*   BREAKPTP, BREAKPTG --    program breakpoint if 30ms has elapsed
;
;*        Generally, BREAKPTP or BREAKPTG is used during program execution or
;*        resolution to allow task switching if 30ms. has elapsed.  For example,
;*        BREAKPTP is used between statement execution in ENDSTMT to allow task
;*        switching.
;
;*   BREAKPTR, BREAKPTT --    program breakpoint regardless of 30ms clock
;*        BREAKPTR or BREAKPTT is used when a task switch is desired regardless of the
;*        30ms. timer.  For example, BREAKPTR is used by $BREAK, T-KEYIN (with
;*        no character), and high priority I/O checking in order to give up the
;*        remainder of the current timeslice.
;
;*   BREAKPTQ --    lower level program breakpoint entry where F0 specifies registers to save
;*        BREAKPTQ is used when it is desired to control more
;*        precisely which registers will be saved.  In all cases, SH, SL and
;*        the top levels of the SR-stack are saved.
;
;*   BREAKPTK, BREAKPTL --    program breakpoint with I/O level priority
;
;*        These entry points are used when a program must breakpoint but I/O
;*        priority is desired.  For example, BREAKPTK is used when checksumming
;*        memory and by DELAYNMS.  BREAKPTK breakpoints if 30ms. has elapsed;
;*        BREAKPTL breakpoints regardless of the 30ms timer.
;*------------------------------------------------------------------------------
;*        entry     check 30ms?        registers saved
;*        -----     -----------        ----------------
;*        BREAKPTP      yes               SH,SL,aux10-1F
;*        BREAKPTG      yes               all
;*        BREAKPTR      no                SH,SL,aux10-1F
;*        BREAKPTT      no                all
;*        BREAKPTQ      no                specified by F0
;*        BREAKPTK      yes               all
;*        BREAKPTL      no                all
;
;*-------------------------------------------------------------------------------
;*        A program task entry to BREAKPT sets the PSTAT byte for the current
;*        partition to indicate a 'program breakpoint' (or I/O completion for
;*        BREAKPTK and L).  BREAKPT then
;*        polls for program breakpoints after checking for I/O activity.
;         EJECT
;*%----------------- BREAKPTK BREAKPTL ------------------------------------------

BREAKPTK:
         TEST      BYTE PTR FS:[CPUST],10H
         JNZ       BREAKPTL             ;RETURN IF < 30MS.  ELAPSED
         RET
BREAKPTL:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         MOV       R1,PSTATICT          ;PRGM BRKPT WITH I/O LEVEL PRIORITY
         JMP       BREAKPTI             ;

;*%----------------- BREAKPTG BREAKPTT ------------------------------------------
BREAKPTG:
         TEST      BYTE PTR FS:[CPUST],10H
         JNZ       BREAKPTT             ;RETURN IF < 30MS.  ELAPSED
         RET                            ;
BREAKPTT:
         PUSH      EDX                  ;SAVE PC'S
         PUSH      WORD PTR R0          ;SAVE F0,1
         PUSH      DWORD PTR A0         ;u64
         PUSH      ECX                  ;SAVE CHCL
         MOV       AL,K
         PUSH      AX                   ;SAVE K
         MOV       R0,SAVALL            ;SAVE ALL REGS
         JMP       BREAKPTQ             ;

;*%----------------- BREAKPTP BREAKPTR BREAKPTQ ---------------------------------
BREAKPTP:
         TEST      BYTE PTR FS:[CPUST],10H
         JNZ       BREAKPTR             ;RETURN IF < 30MS.  ELAPSED
         RET                            ;
BREAKPTR:
         MOV       R0,SAV10             ;FLAG = SAVE SH,SL & AUX10-1F
BREAKPTQ:
         MOVZX     EDX,PART_             ;GET CURRENT PART#
         ADD       EDX,OFFSET PSTAT     ;PT TO CURRENT PART STATUS TABLE
         MOV       BYTE PTR [EDX],PSTATPBT      ;STATUS = PGRM BRKPT
         JMP       BREAKPT              ;

;         CONT      JLMVP32H
;         FILE = JLMVP32H,12/15/1986
;         TITLE     BREAKPT (POLL)
;*BREAKPT: task switch
;
;*        BREAKPT is called during task processing in order to allow task
;*        switching to occur.  It is the responsibility of each task to ensure
;*        that its nominal 30ms. timeslice is not exceeded.
;
;*        Breakpoint polls the PSTAT table to determine what task should be
;*        invoked.  See module 00 for a description of PSTAT and the other
;*        task control tables (eg, IOBDEV, RQSTDEV, PBREAK).
;*%------- breakpoint polling ---------------------------------------------------
;*Priority LEVEL 1  - I/O
;*
;*     THE MXD STATUS IS OBTAINED:
;*        1. RESET CAUSES THE PSTATPB TO BE SET & THE
;*               RETURN ADDRESS TO BE SET TO 'RESET'.
;*        2. HALT/STEP IS RECORDED IN EACH PARTITION.
;*        3. I/O COMPLETIONS ARE LOGGED IN PSTAT.
;*
;*     THE STATUS BYTE OF EACH PARTITION IS CHECKED FOR
;*     I/O ACTIVITY, STARTING AT PARTITION FOLLOWING THE
;*     LAST PARTITION BREAKPOINTED (PART# +1). IF THERE IS
;*     I/O ACTIVITY IN A PARTITION, A BREAKPOINT RETURN IS
;*     PERFORMED. IF THERE IS NO I/O ACTIVITY IN ANY
;*     PARTITION, PROGRAM ACTIVITY IS CHECKED FOR.
;*
;*PRIORITY LEVEL 2 -- PROGRAM
;*
;*     IF THERE IS NO I/O ACTIVITY, THE STATUS BYTE OF
;*     EACH PARTITION IS CHECKED FOR PROGRAM ACTIVITY,
;*     STARTING AT PARTITION FOLLOWING THE LAST PROGRAM
;*     THAT WAS PROCESSED (PROG# +1). IF THERE IS AN
;*     ACTIVE PROGRAM, A BREAKPOINT RETURN IS PERFORMED.
;*     IF THERE IS NO PROGRAM ACTIVITY, I/O ACTIVITY
;*     IS CHECKED FOR.
;*%----------------- entry points -----------------------------------------------
;*   BREAKPTI --    set the partition status and then BREAKPT
;*
;*     ENTRY: F0 = SAVE REGISTER FLAG
;*            F1 = TYPE OF BREAKPOINT (PSTATLR, PSTATCOT,
;*                 PSTATPT, ETC)
;
;*   BREAKPT --     task switching
;*
;*     ENTRY: F0 = SAVE REGISTER FLAG
;*               'SAV03'  -- SAVE SH,SL & AUX03-1F
;*               'SAV06'  -- SAVE SH,SL & AUX06-1F
;*               'SAV0A'  -- save SH,SL & AUX0A-1F
;*               'SAV0C'  -- save SH,SL & AUX0C-1F
;*               'SAV10'  -- save SH,SL & AUX10-1F
;*               'SAVALL' -- save all registers & AUX10-1F
;*                           PC's,CH,CL,K must be saved prior to BREAKPT entry.
;*
;*            SL must point to bank containing current user partition.  Also,
;*               the region contained that partition must be selected.
;*
;*     !!!!!!!! R.Droz suggests F1F0 should be saved/restored at begin/end of
;*              BREAKPT so as to eliminate the several places that do it in the
;*              middle of BREAKPT !!!!!!!!!!!!
;
;*        Modified registers: PC's,CH,CL,K,F1
;         EJECT
;*%----------------- set partition status ---------------------------------------
BREAKPTI:
         MOVZX     EDX,PART_             ;GET CURRENT PART#
         ADD       EDX,OFFSET PSTAT     ;PT TO CURRENT PART STATUS
         MOV       AL,R1                ;F1 = STATUS
         MOV       BYTE PTR [EDX],AL    ;

;*%----------------- save SH,SL and clear RESET flag in SAVEREG area ------------
BREAKPT:
         MOV       EDX,CPBASE           ;
         LEA       EDX,[EDX].@SAVESH    ;PT TO CURRENT PART REGSAVE AREA
         MOV       AX,WORD PTR SH       ;GET CURRENT SL AND SH
         MOV       WORD PTR [EDX],AX    ;SAVE SH,SL
         MOV       BYTE PTR [EDX+2],0   ;ZERO RESET FLAG

;------- TSAI,12/02/90 ------
         MOVZX     EBX,PART_
         CMP       BYTE PTR [EBX+OFFSET MXFGIOTBL],0 ;is this partition doing
                                                     ;MXF GIO
         JE        BRPT5                ;skip,if part not in MXF GIO mode
;        CALL      DIMXFGIO             ;disable MXF GIO mode
         MOV       EBX,CMDBUADR           ;
;-------- test,1-24-91 ----
;g3:
;       TEST    GS:[EBX].gcpust,RB      ;wait until device ready
;       JZ      G3                      ;skip if ready
;-------- test,1-24-91 -----
;        OR        GS:[EBX].gtype,GIO_DISABLE
         MOV       GS:[EBX].gdis,0FFH ;tell MXF that GIO protocol is ended
BRPT5:
;------- TSAII 12/02/90 ------

;*
;@3.0RGNK EQU       *
;*  From this point on in BREAKPT, it CANNOT be assumed that the bank selected is
;*  the bank containing the interrupted partition.  It is ok to select another
;*  memory bank without restoring the current partition's bank.  If current bank
;*  is needed, get bank setting from SAVEREG area of CPBASE partition.
;*
;*  Before Rel 3.0, SL needed to be restored if it was changed.  The new method
;*  reduces the number of bank and region selections that need to be done and is
;*  hopefully simpler.
;*%----------------- turn off /0FD clock (development use only) -----------------

;         MOV       CX,WORD PTR OSMOD    ;
;         TEST      CH,OSMODCLK          ;BR, IF CLOCK NOT SPECIFIED
;         JZ        MOD32_02
;         CALL      CLKOFF               ;CPU CLOCK OFF (/0FD)
;MOD32_02:

;*%----------------- check for I/O priority overload ----------------------------
;*        I/O is allowed a maximum of 3 out of 4 timeslices.

         MOV       CX,IOXCNT            ;
         CMP       CH,CL                ;BR, IF MUST SKIP I/O LEVEL PROCESSING
         JBE       BREAKPT5
         INC       CL                   ;INCREMENT I/O LEVEL EXECUTION COUNT
         MOV       IOXCNT,CX            ;UPDATE

;*%----------------- get MXD status ---------------------------------------------

BREAKPT0:
         MOV       AL,@MXDSADR
         CALL      MXDSTAT              ;GET 1ST MXD STATUS
         CMP       BYTE PTR MXD2SADR,0FFH;BR, IF NOT 2ND MXD
         JE        BREAKPT1
         MOV       AL,MXD2SADR
         CALL      MXDSTATC             ;GET & PROCESS MXD STATUS
         CMP       BYTE PTR MXD3SADR,0FFH;BR, IF NOT 3RD MXD
         JE        BREAKPT1
         MOV       AL,MXD3SADR
         CALL      MXDSTATC             ;GET & PROCESS MXD STATUS
         CMP       BYTE PTR MXD4SADR,0FFH;BR, IF NOT 4TH MXD
         JE        BREAKPT1
         MOV       AL,MXD4SADR
         CALL      MXDSTATC             ;GET & PROCESS MXD STATUS

;*%================= check for I/O activity =====================================

breakpt1:
        xor     eax,eax
        mov     al,iopart_              ;get part# of last i/o part
        inc     al                      ;start from next part#
        mov     bl,al                   ;bl hold the end-chk pt
        mov     edx,offset pstat        ;
        jmp     breakpt2_1              ;

breakpt2_0:
        mov     eax,0                   ;
        jmp     breakpt2                ;start chking again

breakpt2_2:
        inc     eax                     ;pt to next entry

breakpt2:

        cmp     al,bl                   ;have we check all?
        je      breakpt5                ;br, yes

breakpt2_1:

        test    byte ptr [edx+eax],pstatetb     ;is this end-of-tab entry ?
        jnz     breakpt2_0                      ;br, yes
        test    byte ptr [edx+eax],30h          ;chk for active i/o
        jz      breakpt2_2                      ;br, if no
        test    byte ptr [edx+eax],pstatict     ;chk for mxd i/o completion
        jnz     breakpt10_0                     ;al has part#
        mov     ch,byte ptr iobdev[eax]         ;get device addr

;****   modified by W.R. TSENG for PLATTER HOG programming ****
        mov     k,ch
        mov     r1,ch
        test    r1,0fh
        jnz     search_0                        ;br if not disk address (e.g. 7C)
;
        and     r1,0ffh-40h                     ;50 -> 10; 60 -> 20; 70 -> 30
search_0:
        push    eax
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@hogflg,0
        pop     eax
        jz      normal_1
        mov     edi,offset mdevtbl
search_1:
        mov     cx,[edi]
        xchg    ch,cl
        MOV     CL,BYTE PTR [EDI-MDEVSIZE] ;u64
        cmp     ch,r1
        jz     search_2
        add     edi,2
        jmp     search_1
search_2:
        and     cl,PARTBIT              ;u64,PART# currently use this device
        cmp     al,cl
        jnz     breakpt2_2
normal_1:
;
; ****  modification end  ****
;
; 22c11_s
        test    k,0fh
        jnz     normal_x              ;br, if not disk address
        movzx   esi,byte ptr k
        shr     esi,2
        add     esi,offset disk_addr
        cmp     dword ptr [esi],0
        jz      normal_x
        movzx   esi,al
        and     esi,PARTBIT
        shl     esi,2
        add     esi,offset part_addr
        mov     esi,dword ptr [esi]
        cmp     byte ptr gs:[esi],00h
        jne     breakpt2_2                      ;not ready
        jmp     breakpt10
normal_x:
        cmp     k,15h
        jb      normal_y
        cmp     k,18h
        ja      normal_y
        push    eax
        movzx   eax,byte ptr k
        sub     eax,15h
        shl     eax,2
        add     eax,offset print_addr
        cmp     dword ptr [eax],0
        pop     eax
        je      normal_y

        mov     esi,dword ptr [cpbase]
        cmp     byte ptr [esi].@gio_flag,0
        je      normal_q
        movzx   esi,al
        shl     esi,2
        add     esi,offset part_addr
        mov     esi,dword ptr [esi]
        cmp     byte ptr gs:[esi],00h
        jne     breakpt2_2                      ;not ready
        jmp     breakpt10

normal_q:
        call    chk_printer_x
        jnc     breakpt2_2                      ;not ready
        jmp     breakpt10
normal_y:
; 22c11_e

        mov     ch,k
        mov     byte ptr fs:[_abs],ch           ;enable addr
        mov     B_ABS,ch
        call    delay5
        test    byte ptr fs:[cpust],08h         ;chk for ready/busy
        jz      breakpt2_2                      ;al has part#

breakpt10:
breakpt10_0:
        mov     byte ptr iobdev[eax],0          ;clear address in IOBDEV
        and     al,PARTBIT                      ;u64
        mov     iopart_,al                      ;set io part#
        mov     r1,al                           ;R1 has part# to be return to
        jmp     breakpt9                        ;br, device ready

;*%----------------- generate next random number --------------------------------
;*        Generates the next binary random number (stored in SAVESEED).
;*        A random number is generated whenever BREAKPOINT polls for program
;*        (ie, non-I/O) activity.  Thus, if the system is idling, random numbers
;*        will be generated until some task becomes active.  This is sufficient
;*        to randomize RND.

breakpt5:
rndgen:
        call    mathnrnd                        ;

breakp51:
        mov     byte ptr ioxcnt,0               ;reset i/o level execution count
        xor     eax,eax                         ;
        mov     al,prog_                        ;
        inc     al                              ;start form next part#
        mov     bl,al                           ;BL hold end-chk pt
        mov     edx,offset pstat                ;
        jmp     breakpt6                        ;

breakp16:
        cmp     byte ptr pbreak[eax],0ffh       ;chk if break forever
        je      mod32_03                        ;br, if yes
        dec     byte ptr pbreak[eax]            ;decreament break value
mod32_03:
        push    eax                             ;save part# for a bit
        push    eax
        mov     eax,dword ptr cpbase
        inc     dword ptr [eax].@timeslice
        pop     eax
        inc     dword ptr cpuslice
        push    ebx                             ;end-chk pt for a bit
        shl     eax,2                           ;
        mov     edx,dword ptr base[eax]         ;get base addr
        mov     ch,byte ptr [edx].@istatus      ;
        and     ch,0fh                          ;
        mov     cl,istact                       ;
        or      cl,istchk                       ;
        cmp     ch,cl                           ;pool interrupt iff istact and
                                                ; (not istub) and (not istginh)
        je      mod32_04                        ;
        cmp     ch,istact                       ;
        jne     breakp19                        ;

mod32_04:
        mov     ch,byte ptr [edx].@istatus
        call    ipoll                           ;chk for pending interrupts
        test    r1,1                            ;br, if no interrupt pending
        jz      breakp19
        pop     ebx                             ;
        pop     eax                             ;
        mov     byte ptr pbreak[eax],0          ;clear $break value
        jmp     breakp21_0                      ;

breakp19:
        pop     ebx
        pop     eax
        jmp     breakpt6_1                      ;

breakpt6_0:
        mov     eax,0                           ;reset part#
        jmp     breakpt6_2                      ;chk next part

breakpt6_1:
        inc     eax                             ;pt to next part

breakpt6_2:
        cmp     al,bl                           ;are we gone through
        je      breakpt0                        ;br, if yes

breakpt6:
        test    byte ptr pstat[eax],pstatetb    ;chk if end of table
        jnz     breakpt6_0                      ;br, if yes
        test    byte ptr pstat[eax],pstatpbt    ;chk if prog not active
        jz      breakpt6_1                      ;br, if not
        cmp     byte ptr pbreak[eax],0          ;chk if user break active
        jne     breakp16                        ;br, if yes

breakp21_0:
        mov     r1,al                           ;F1 = part# of active prog
        mov     prog_,al                        ;

;*%----------------- return to partition 'F1' -----------------------------------
;         CONT      JLMVP32I
;         FILE = JLMVP32I,02/25/1987
;         TITLE     BREAKPT (RETURN)
;*%================= breakpoint return to partition F1 ==========================
;*NOTE: MUST BE CERTAIN THAT CANNOT GET BREAKPOINT DURING THE
;*      FOLLOWING LOGIC SINCE BREAKPOINT LOGIC IS NOT
;*      RECURSIVE.
;*
BREAKPT9:
;*%----------------- clear status byte, PSTAT, for partition to return to -------
         MOVZX     EBX,R1                ;GET PARTITION # TO RETURN TO
         mov       byte ptr pstat[ebx],0   ;clear status byte
         mov       byte ptr pbreak[ebx],0  ;clear $break value

;*%----------------- check if partition to return to is current partition -------
         MOV       AL,PART_             ;GET CURRENT PART#
         MOV       PART_,BL             ;SAVE NEXT PART#
         CMP       BL,AL                ;
         JNE       BREAKP13             ;BR, IF NEXT PART <> CURRENT
;*%----------------- current partition is the one to return to ------------------
;*        Get RESET flag, restore SL and SH.
;*        Registers do not need to be swapped since current partition is the
;*        one to return to.
;*
;@3.0RGNM:
         MOV       EDX,CPBASE           ;GET BASE OF CURRENT PART
         LEA       EDX,[EDX].@SAVESH
         MOV       AX,WORD PTR [EDX]    ;
;        AND       AL,0EFH              ;DON'T TRIGGER CLK
         MOV       SH,AL                ;RESTORE SH,SL
         MOV       SL,AH                ;
         MOV       CH,byte ptr [edx+2]  ;GET RESET FLAG
         MOV       R1,CH                ;F1 = RESET FLAG
         JMP       BREAKP15
;*%----------------- current partition is not one to return to ------------------
;*        Save current partition's registers
;*

BREAKP13:
;-------- TSAI --------
 ;--- 12/01/90 ----
         MOVZX    EBX,AL               ;AL=old partition #
         MOV      AL,TOMXF
         MOV      [EBX+OFFSET TOMXFTBL],AL ;save old TOMXF

         MOVZX     EBX,PART_           ;get new TOMXF table
         MOV       AL,[EBX+OFFSET TOMXFTBL]
         MOV       TOMXF,AL
  ;---- 12/01/90 ---

         MOVZX     EAX,PART_
         ADD       EAX,OFFSET PTERM
         MOV       AL,[EAX+PARTMAX]    ;GET TERMINAL NO
         MOVZX     EDX,AL
         SHR       AL,06               ;MXF or MXD card no
         MOV       CMDBUADR,0
         MOV       AH,0
         BT        MXF,AX
         JNC       BRK13               ;BR,if NOT MXF
         SHL       AL,04
         AND       DL,0FH
         OR        DL,AL               ;TERM#,00xx00xxxx --> 00xxxxxx
         SHL       EDX,02              ;dword offset
         MOV       EAX,[EDX+OFFSET MXFTBL];cmd buffer adr
         MOV       CMDBUADR,EAX        ;IF MXF,SAVE CMD BUFFER ADDRESS
BRK13:
;--------- TSAII ------
         CALL      SAVEREGS             ;SAVE REGS (F0 SPECIFIES WHICH REGS)
         mov       edx,cpbase
         lea       edx,[edx].@sysptr    ;
         mov       eax,@@osend
         mov       [edx],eax
         add       edx,4
         mov       eax,@@vsend
         mov       [edx],eax
         add       edx,4
         mov       eax,@@varthd
         mov       [edx],eax
         mov       esp,offset stack_buffer

;*        Set pointers to partition to return to
;*
         MOVZX     EDX,PART_             ;GET PART# TO RETURN TO
         MOV       PART_T,DL
         SHL       EDX,2
         ADD       EDX,OFFSET BASE      ;PT TO PART BASE TABLE ENTRY
         MOV       EBX,DWORD PTR [EDX]  ;GET BASE ADDRESS FOR PART#
         MOV       CPBASE,EBX           ;SAVE IT IN CURRENT BASE
;*
;*        Restore registers for partition to return to
;*
         mov       edx,cpbase
         lea       edx,[edx].@sysptr    ;
         mov       eax,[edx]
         mov       @@osend,eax
         add       edx,4
         mov       eax,[edx]
         mov       @@vsend,eax
         add       edx,4
         mov       eax,[edx]
         mov       @@varthd,eax

         CALL      LOADREGS             ;RESTORE REGS


;*%----------------- check for RESET of partition to return to ------------------
BREAKP15:
         CMP       R1,0                 ;BR, IF NOT 'RESET'
         JE        BREAKP12             ;
         PUSH      OFFSET RESET         ;RETURN ADDRESS = 'RESET'
         MOV       R0,SAV10             ;FLAG = NOT SAVE ALL

;%----------------- turn on /0FD clock (for development use only) --------------
BREAKP12:
;         MOV       CH,BYTE PTR OSMOD    ;
;         TEST      CH,20H               ;OSMODCLK = 20H
;         JZ        BREAKP17             ;BR, IF CLOCK NOT SPECIFIED
;         TEST      CH,10H               ;OSMODCL1 = 10H
;         JZ        BREAKP18             ;BR, IF TIME TOTAL EXECUTION
;         MOV       CH,BYTE PTR OSMOD+1  ;GET THE PARTITION# TO TIME
;         AND       CH,0FH
;         CMP       CH,PART_             ;TURN CLOCK ON ONLY IF PART TO TIME
;         JNE       BREAKP17             ;
;BREAKP18:
;         CALL      CLKON                ;CPU CLOCK ON (TEMP DEV. TOOL)

;*%----------------- enable ACTDEV for partition to return to -------------------
BREAKP17:
         MOV       EDX,ACTDEV           ;
;*     IF MXD, SELECT TERMINAL #
;*
         CMP       DH,0AH               ;CHK DEVICE TYPE (TCDEVH=0, TCDEVL=A)
         JNE       BRPT17A              ;BR, IF NOT TC
         CALL      ENBLTC               ;ENABLE TC PORT
         JMP       BRPT14A              ;
BRPT17A:
         TEST      DL,0FH               ;BR, IF DEVICE ADDRESS = X0
         JZ        BREAKP14             ;

         mov       r1,dl                ;
         test      dl,0FFH-PTERMADR     ;br, if not mxd addr,u64
         jnz       breakp14             ;
;------- tsai,11-26-91 --------
         MOV       EDX,0
         MOV       DL,PART_
         ADD       EDX,OFFSET PTERM     ;EDX PT TO ENTRY IN PTERM
         MOV       DL,BYTE PTR [EDX]    ;GET PTERM ENTRY
;        and       dl,0f0h              ;take the board addr
         and       dl,0c0h
;-------- tsaii,11-26-91 -------
         or        dl,@mxdcadr          ;mxd control addr
;-------- TSAI -------
         CMP       CMDBUADR,0           ;need not select TERM if MXF
         JNE       BRPT1
;-------- TSAI --------
         mov       byte ptr fs:[_abs],dl;select it
         mov       B_ABS,dl
         call      delay5

;*Assume that IOB's same as device address (since MXD logic).
         MOV       AL,?amSELTERM        ;
         CALL      CBSNT                ;SELECT TERMINAL COMMAND

;*GET TERMINAL NUMBER
         MOV       EDX,0
         MOV       DL,PART_
         ADD       EDX,OFFSET PTERM     ;EDX PT TO ENTRY IN PTERM
         MOV       CH,BYTE PTR [EDX]    ;GET PTERM ENTRY
;------- KHAN -------
         MOV       CL,BYTE PTR [EDX+PARTMAX]
         AND       CL,0FH               ;CL = TERMINAL #
;------- KHANN ------
         MOV       AL,CL                ;
         CALL      OBSNTC               ;SEND TERMINAL # TO MXD
         MOV       AL,NULL              ;
         CALL      OBSNTC               ;SEND COMPLETION OF SELECT TERMINAL
MOD32_06:
         TEST      BYTE PTR FS:[CPUST],08H ;WAIT FOR READY (CHECK SH 08H BIT)
         JZ        MOD32_06             ;WAIT UNTIL READY
BRPT1:                                  ;----TSAI
         MOV       EDX,ACTDEV           ;
         MOV       AL,DL                ;
         AND       AL,0FH               ;
         CMP       AL,05H               ;
         JNE       BREAKP14             ;BR, IF ADDR <> 05
         TEST      DL,10H               ;
         JNZ       BREAKP14             ;
         TEST      DL,20H               ;
         JNZ       BREAKP14             ;
         OR        DL,07                ;IF MXD ADDR = 05 THEN -> 07
;*
;*        Enable ACTDEV
;*
BREAKP14:
         MOV       K,DL                 ;
         AND       DH,0FH               ;1/11/89
         CMP       DH,_PHOENIX          ;
         JNE       MOD32_07             ;BR, IF DEVICE TYPE <> 'D'
         AND       K,0F0H               ;TYPE = 'D', STRIP OFF PLATTER BITS
MOD32_07:
         MOV       AL,K
;------- TSAI -------
         CMP       TOMXF,1              ;if signal to MXF
         JE        BRPT3
;-------- TSAII ------
         MOV       BYTE PTR FS:[_ABS],AL;
         mov       B_ABS,al
BRPT14A:
         CALL      DELAY5               ;5 USEC BEFORE NEXT CIO OR CHANGE TO K
BRPT3:                                  ;----TSAI

; added for multi-printer driver problem  06/23/91 in USA
         CALL      SDRVRDEV        ;IS PRINTER DRIVER TO BE USED?
; added for multi-printer driver problem  06/23/91 in USA

;*%----------------- restore ACTIOBS --------------------------------------------
         MOV       EDX,ACTIOBS          ;
         MOV       K,DL                 ;
         MOV       BYTE PTR FS:[IOBS],DL;RESTORE PARTITION'S CURRENT IOB'S

;*%----------------- clear interupts polled bit ---------------------------------
         MOV       EDX,CPBASE           ;GET CURRENT BASE
         MOV       CH,BYTE PTR [EDX].@ISTATUS
         AND       CH,0F7H              ;CLEAR INTERRUPT POLL BIT
         MOV       BYTE PTR [EDX].@ISTATUS,CH

;%----------------- restore working registers ----------------------------------
         CMP       R0,SAVALL            ;BR, IF NOT 'SAVE ALL REGS'
         JNE       BREAKP11             ;
         POP       AX                   ;RESTORE K
         MOV       K,AL
         POP       ECX                  ;        CH,CL
         POP       DWORD PTR A0         ;u64
         POP       WORD PTR R0          ;        F0,F1
         POP       EDX                  ;        PC'S
;%----------------- return to process partition --------------------------------
BREAKP11:
         MOV       AL,0FFh              ;RESET 30 MS CLOCK
         MOV       BYTE PTR FS:[TIMSET],AL

         push      eax
         mov       eax,dword ptr [cpbase]
         inc       dword ptr [eax].@timeslice
         pop       eax
         inc       dword ptr cpuslice

;------- TSAI,12/02/90 -----
         MOVZX     EBX,PART_
         MOV       AL,[EBX+OFFSET MXFGIOTBL]
         CMP       AL,0
         JE        BRPT6                ;SKIP,if the PART to be return
         CALL      ENMXFGIOA
BRPT6:                                  ;not go into MXF GIO mode
;------ TSAII,12/02/90 -----
         RET

;         TITLE     NMIOCHK
;*NMIOCHK: CHECK PENDING NON-MXD I/O DEVICES FOR 'READY'
;*         (SIMILAR LOGIC EXISTS IN 'BREAKPOINT')
;*
;*     RETURN: F1 = 0 IF ALL DEVICES BUSY
;*                = 1 IF ANY DEVICE READY
;*
;*     MODIFIED REGISTERS: PC'S,F0,CH,CL,K,F1-3
;*
NMIOCHK:
         MOV       EDX,OFFSET PSTAT     ;PT TO PSTAT TABLE
         MOV       R1,0                 ;
NMIOCHK1:
         INC       EDX                  ;
         TEST      BYTE PTR [EDX],PSTATETB ;BR, IF END OF TABLE  (BIT 80H)
         JNZ       NMIOCHK2             ;
         TEST      BYTE PTR [EDX],PSTATIBT ;BIT 20H -- NON-MXD I/O BRPT
         JZ        NMIOCHK1             ;BR, IF NO NON-MXD I/O PENDING
         SUB       EDX,OFFSET PSTAT     ;EDX (DL) = PART#
         MOV       AL,DL
         ADD       EDX,OFFSET IOBDEV    ;EDX PT TO I/O BRPT DEVICE TABLE
         MOV       CH,BYTE PTR [EDX]    ;GET ADDRESS OF PENDING DEVICE

;****   modified by W.R. TSENG for PLATTER HOG programming ****

        mov     k,ch
        mov     r1,ch
        test    r1,0fh
        jnz     search_0nmi                     ;br if not disk address (e.g. 7C)
;
        and     r1,0ffh-40h                     ;50 -> 10; 60 -> 20; 70 -> 30
search_0nmi:
        push    eax
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@hogflg,0
        pop     eax
        jz      normal_1nmi
        mov     edi,offset mdevtbl
search_1nmi:
        mov     cx,[edi]
        xchg    ch,cl
        MOV     CL,BYTE PTR [EDI-MDEVSIZE]   ;u64
        cmp     ch,r1
        jz      search_2nmi
        add     edi,2
        jmp     search_1nmi
search_2nmi:
        and     cl,PARTBIT              ;PART# currently use this device,u64
        cmp     al,cl
        jnz     nmiochk1
normal_1nmi:
;
; ****  modification end  ****
         MOV       BYTE PTR FS:[_ABS],CH;ENABLE PENDING DEVICE
         mov       B_ABS,ch
         CALL      DELAY5               ;DELAY FOR RB
         TEST      BYTE PTR FS:[CPUST],08H ;CHK FOR DEV READY/BUSY
         JZ        NMIOCHK1             ;BR, IF DEVICE BUSY
         MOV       R1,1                 ;FLAG DEVICE READY
NMIOCHK2:
         mov       r0,0
         CALL      DELAY5               ;
         JMP       ENBLNULL             ;ENABLE NULL DEVICE

;         TITLE     HPION HPIOF
;*HPION: HIGH PRIORITY I/O OPERATION IN PROGRESS.
;*
;*     PARTITIION'S MODE BYTE & GLOBAL HPIOFLG SET TO HIGH
;*          PRIORITY I/O IN PROGRESS.
;*
;*     MODIFIED REGISTERS: PC'S,CHCL
;*
;*HPIOF: HIGH PRIORITY I/O OPERATION COMPLETE.
;*
;*     PARTITIONS'S MODE BYTE SET TO HIGH PRIORITY DONE;
;*          HPIOFLG TURNED OFF IF NO OTHER HIGH PRIORITY
;*          OPERATIONS ARE IN PROGRESS.
;*
;*     MODIFIED REGISTERS: PC'S,CHCL,AUX0
;*
HPION:
         MOV       EDX,0                ;
         MOV       DL,PART_             ;
         ADD       EDX,OFFSET PMODE     ;EDX PT TO ENTRY IN PMODE TABLE
                                        ;PMODE -- PART OPERATION MODE TABLE
         OR        BYTE PTR [EDX],PMODEI;SET MODE BYTE TO HIGH PRIORITY I/O
                                        ;PMODEI = 10H
HPION2:
         MOV       HPIOFLG,1            ;GLOBAL HIGH PRIORITY I/O FLAG ON
HPION1:
         RET
HPIOF:
         MOV       EDX,0                ;
         MOV       DL,PART_             ;
         ADD       EDX,OFFSET PMODE     ;EDX PT TO ENTRY IN PMODE TABLE
         AND       BYTE PTR [EDX],0EFH  ;MODE = HIGH PRIORITY I/O OFF
         MOV       HPIOFLG,0            ;GLABAL HIGH PRIORITY I/O OFF

         MOV       EDX,OFFSET PMODE     ;
         MOV       EBX,OFFSET PSTAT     ;
HPIOF1:
         TEST      BYTE PTR [EBX],PSTATETB      ;BR, IF END OF TABLE
         JNZ       HPION1               ;
         INC       EBX                  ;PT TO NEXT PSTAT ENTRY
         TEST      BYTE PTR [EDX],PMODEI;BR, IF HIGH PRIORITY I/O ON
         JNZ       HPION2
         INC       EDX                  ;PT TO NEXT PMODE ENTRY
         JMP       HPIOF1


;****************************************************************
;The following structure is used for indirect offset calculation
;of REGSAV area in each partition information block...
;

REG_SAV  STRUC

FLAG@@   DW        0                   ;2
F2@@     DB        6 DUP(0)            ;8
AUX00@@  DD        0                   ;12
K@@      DW        0                   ;14
ECX@@    DD        0                   ;18
F1F0@@   DW        0                   ;20
PC@@     DD        0                   ;24
BRPT@@   DD        0                   ;28
STK@@    DD        20 DUP(0)           ;80
AUX01@@  DD        0                   ;84
         DD        0                   ;88
AUX03@@  DD        0                   ;92
         DD        0                   ;96
         DD        0                   ;100
AUX06@@  DD        0                   ;104
         DD        0                   ;108
         DD        0                   ;112
         DD        0                   ;116
AUX0A@@  DD        0                   ;120
         DD        0                   ;124
AUX0C@@  DD        0                   ;128
         DD        0                   ;132
         DD        0                   ;136
         DD        0                   ;140
AUX10@@  DD        10 DUP(0)           ;180
AUX1A@@  DD        6 DUP(0)            ;204
SHSL@@   DW        0                   ;206
RESETF@@ DW        0                   ;208
A0@@     DW        8 DUP(0)            ;224
KX@@     DW        1 DUP(0)            ;226
EBP@@    DD        1 DUP(0)            ;230
AUX20@@  DD        1 DUP(0)            ;234

REG_SAV  ENDS

;         TITLE     LOADREGS
;*
;*  LOADREGS:   RESTORE REGISTERS FROM THE REGISTER SAVE AREA
;*              OF THE CURRENT PARTITION. THE REGISTERS THAT
;*              ARE RESTORED ARE DEPENDENT UPON A FLAG FOUND
;*              IN THE FIRST BYTE OF THE REGISTER SAVE AREA
;*              AS WAS SET UP IN SAVEREGS.
;*
;*              RETURN:  FLAG FOUND IN F0.
;*
;*
LOADREGS:
         POP       EAX                  ;GET CALLING ROTINE RETURN ADDR
         MOV       DWORD PTR MATHPAGE,EAX
         MOV       DWORD PTR MATHPAGE+4,ESI
         MOV       DWORD PTR MATHPAGE+8,EDI

         MOV       EDX,CPBASE           ;GET CURRENT BASE
         LEA       EDX,[EDX].FLAG@@
         MOV       CH,[EDX]             ;GET SAVE FLAG FROM SAVEREGS AREA
         MOV       R0,CH                ;SAVE IN F0
         CMP       CH,0                 ;BR, IF LAOD ALL REGS
         JE        LOADREGA             ;
         CMP       CH,1                 ;LOAD REGS 10 - 1F
         JE        LDREG10              ;
         CMP       CH,3                 ;LOAD REGS 06 - 1F
         JE        LDREG6               ;
         CMP       CH,4                 ;LOAD REGS 03 - 1F
         JE        LDREG3               ;

         LEA       ESI,[EDX].AUX0A@@    ;SET UP SOURCE POSITION
         MOV       EDI,OFFSET AUX0A     ;       TARGET
         MOV       ECX,22               ;       TOTAL COUNT
         JMP       LDAUX

LOADREGA:
         MOV       EDX,CPBASE           ;GET CURRENT BASE
         MOV       ESI,CPBASE           ;GET CURRENT BASE
         LEA       ESI,[ESI].F2@@       ;RESTORE F2 - F7
         MOV       EDI,OFFSET R2
         MOV       ECX,3                ;TOTAL 6 BYTES
         REP MOVSW                      ;

         LODSD                          ;
         MOV       AUX00,EAX            ;RESTORE AUX00

         LEA       ESI,[EDX].AUX01@@    ;
         MOV       ECX,22               ;TOTAL 15 LEVELS (PC, BRPT, TOP 13)
LOADSTK:
         SUB       ESI,4                ;
         MOV       EAX,DWORD PTR [ESI]  ;
         PUSH      EAX                  ;RESTORE IN STACK
         LOOP      LOADSTK

         MOV       AX,WORD PTR [EDX].F1F0@@
         PUSH      AX                   ;RESTORE F0,F1
         MOV       ECX,DWORD PTR [EDX].ECX@@
         PUSH      ECX                  ;RESTORE CHCL
         MOV       AX,WORD PTR [EDX].K@@
         PUSH      AX                   ;RESTORE K&0

         MOV       EDI,OFFSET AUX01     ;RESTORE AUX REGS
         MOV       ECX,31               ;TOTAL 31 REGS
         LEA       ESI,[EDX].AUX01@@    ;
LDAUX:
         REP MOVSD
         MOV       TEXTPTR,DWORD PTR [EDX].EBP@@
         MOV       EAX,DWORD PTR [EDX].AUX20@@
         MOV       AUX20,EAX
         LODSW                          ;GET SH,SL
         MOV       WORD PTR SH,AX       ;RESTORE
         LODSW                          ;GET RESET FLAG
         MOV       R1,AL                ;F1 = RESET FLAG
         CMP       R0,SAVALL            ;
         JE        LDAUXEND             ;
         MOV       EDX,CPBASE           ;
         MOV       EAX,DWORD PTR [EDX].BRPT@@
         PUSH      EAX                  ;RESTORE BREAKPOINT RETURN ADDR
LDAUXEND:
         mov       edi,offset a0        ;esi pt to a0-a7 save area already!
         mov       ecx,9                ;
         rep       movsw                ;

         PUSH      DWORD PTR MATHPAGE   ;RESTORE RETURN ADDRESS
         MOV       ESI,DWORD PTR MATHPAGE+4
         MOV       EDI,DWORD PTR MATHPAGE+8
         RET

LDREG6:
         MOV       EDI,OFFSET AUX06     ;RESTORE AUX REGS 06 - 1F
         MOV       ECX,26               ;TOTAL 26 REGS
         LEA       ESI,[EDX].AUX06@@    ;
         JMP       LDAUX
LDREG10:
         MOV       EDI,OFFSET AUX10     ;RESTORE AUX REGS 10 - 1F
         MOV       ECX,16               ;TOTAL 16 REGS
         LEA       ESI,[EDX].AUX10@@    ;
         JMP       LDAUX
LDREG3:
         MOV       EDI,OFFSET AUX03     ;RESTORE AUX REGS 03 - 1F
         MOV       ECX,29               ;TOTAL 29 REGS
         LEA       ESI,[EDX].AUX03@@    ;
         JMP       LDAUX

;         TITLE     SAVEREGS
;*
;*  SAVEREGS:   SAVE REGISTERS OF THE CURRENT PARTITION IN
;*              REGISTER SAVE AREA OF THAT PARTITION (STAR
;*              CPBASE+@SAVEREG).  THE REGISTERS SAVED ARE
;*              DEPENDENT UPON THE VALUE OF F0 SET ON ENTR
;*                  F0=0  -  SAVES FLAG, F2-7, THE TOP 15
;*                           LEVELS OF THE STACK, AUX 0-1F
;*                  F0=1  -  SAVES FLAG, AUX 10-1F, SH,SL.
;*                  F0=2  -  SAVES FLAG, AUX 0A-1F, SH,SL.
;*                  F0=3  -  SAVES FLAG, AUX 06-1F, SH,SL.
;*                  F0=4  -  SAVES FLAG, AUX 03-1F, SH,SL.
;*
;*              SH,SL SHOULD BE SAVED AND RESET FLAG SHOULD BE
;*              ZEROED IN SAVE REG AREA BEFORE CALLING
;*              'SAVEREGS'.
;*
;*                IN ALL CASES THE BREAKPOINT RETURN
;*                  ADDRESS (FOUND IN THE TOP LEVEL OF THE
;*                  STACK IF F0<>0, OR IN THE 5TH LEVEL IF
;*                  F0 = 0) IS SAVED AT THE RELATIVE
;*                  LOCATION @BREAKPT IN THE CURRENT
;*                  PARTITION.
;*
;*  SAVEREGX:   SAME AS 'SAVEREGS' EXCEPT SH,SL ARE SAVED AND
;*              THE RESET FLAG IN SAVE AREA IS ZEROED.
;*
;*                THE FINAL SAVE MAP IS AS FOLLOWS:
;*   CPBASE +  --------------------
;*   @SAVEREG  !  FLAG   !  NULL  !
;*             --------------------
;*             !   F2    !   F3   !
;*             --------------------
;*             !   F4    !   F5   !
;*             --------------------
;*             !   F6    !   F7   !
;*             --------------------
;*             !       AUX 0      !
;*             --------------------    ---
;*             !   K     !  NULL  !      !
;*             --------------------      !
;*             !   CH    !   CL   !      !
;*             --------------------      !  FOUND IN THE
;*             !   F1    !   F0   !      !  TOP 4 STACK
;*             --------------------      !  LEVELS.
;*             !   PH    !   PL   !      !
;*             --------------------    ---
;*             !  BREAKPT RETURN  !
;*             --------------------
;*             !      NEXT 10     !
;*             !    STACK LEVELS  !
;*             !     (20 BYTES)   !
;*             --------------------
;*             !       AUX 1      !
;*             !        TO        !
;*             !       AUX 1F     !
;*             !     (62 BYTES)   !
;*             --------------------
;*             !    SH   !   SL   !
;*             --------------------
;*             ! RESET FLG. !     !
;*             --------------------
;*
;*             ROUTINE RETURNS WITH ORIGINAL FLAG IN K.
;*
;*
SAVEREGX:
         MOV       EDX,CPBASE           ;GET CURRENT BASE
         LEA       EDX,[EDX].SHSL@@     ;PT TO SH,SL SAVE POSITION
         MOV       AX,WORD PTR SH       ;GET SH,SL

         ;*** CAREFUL ABOUT SH SHOULD GET IT FROM OTHER WHERE!!

         MOV       WORD PTR [EDX],AX    ;SAVE IT
         MOV       WORD PTR [EDX+2],0   ;RESET FLAG = 0

SAVEREGS:
         MOV       AL,R0
         MOV       K,AL
         POP       EAX                  ;GET THE CALLING ROUTINE RETURN ADDR
         MOV       DWORD PTR MATHPAGE,EAX
         MOV       DWORD PTR MATHPAGE+4,ESI
         MOV       DWORD PTR MATHPAGE+8,EDI
                                        ;SAVE ESI,EDI FOR STRING OPERATION
                                        ;
         MOV       EDX,CPBASE           ;GET CURRENT BASE
         MOV       CL,R0                ;GET THE SAVE FLAG (HOW TO SAVE REGS)
         MOV       BYTE PTR [EDX].FLAG@@,CL     ;SAVE FLAG IN
         CMP       CL,0                 ;BR, IF SAVE ALL SPECIFIED
         JE        SAVEREGA             ;

         ;*** If SAVEREGS not come from BREAKP13, there are no K,CHCL,PC etc
         ;    save in stack, so the top of stack should be the return BRPT

         POP       EAX                  ;GET THE BRPT ADDR FROM STACK
         LEA       EDX,[EDX].BRPT@@     ;EDX PT TO BRPT ADDR POSITION
         MOV       DWORD PTR [EDX],EAX  ;SAVE BRPT IN

         CMP       CL,1                 ;BR, IF SAVE 10-1F
         JE        SAVREG10             ;
         CMP       CL,3                 ;BR, IF SAVE 06-1F
         JE        SAVREG6              ;
         CMP       CL,4                 ;BR, IF SAVE 03-1F
         JE        SAVREG3              ;

         MOV       ESI,OFFSET AUX0A     ;SAVE 0A - 1F
         MOV       EDI,CPBASE           ;
         LEA       EDI,[EDI].AUX0A@@    ;
         MOV       ECX,22               ;
         JMP       SAVAUX               ;

SAVEREGA:
         MOV       ESI,OFFSET R2        ;SAVE F2-F7
         MOV       EDI,CPBASE           ;
         LEA       EDI,[EDI].F2@@       ;
         MOV       ECX,3                ;6 BYTES TOTAL
         REP MOVSW

         MOV       EAX,AUX00            ;SAVE AUX00
         STOSD

         POP       AX                   ;GET K & 0 FROM STACK
         STOSW                          ;SAVE K & 0

         POP       EAX                  ;GET CH,CL
         STOSD                          ;SAVE CH, CL

         POP       AX                   ;GET F1,F0
         STOSW                          ;SAVE F1,F0

         POP       EAX                  ;GET PC'S
         STOSD                          ;SAVE PC'S

         POP       EAX                  ;GET BRPT
         STOSD                          ;SAVE BREAKPOINT

         MOV       ECX,20               ;GET TOP 13 LEVEL OF STACK
SAVSTACK:
         POP       EAX                  ;GET ENTRY IN STACK
         STOSD                          ;SAVE IT
         LOOP      SAVSTACK             ;LOOP 13 TIME

         ;*** Possible error might happen, if stack haven't been use to that
         ;    level (13 for instant).

         MOV       ESI,OFFSET AUX01     ;GET THE STARTING SOURCE POSITION
         MOV       ECX,31               ;TOTAL 31 AUX REGS
SAVAUX:
         REP       MOVSD                ;SAVE IN
         MOV       EDX,CPBASE
         MOV       DWORD PTR [EDX].EBP@@,TEXTPTR
         PUSH      EAX
         MOV       EAX,AUX20
         MOV       DWORD PTR [EDX].AUX20@@,EAX
         POP       EAX

         mov       esi,offset a0        ;
         add       edi,4                ;pt to a0-a7 save area
         mov       ecx,9                ;
         rep       movsw                ;

         PUSH      DWORD PTR MATHPAGE   ;PUT RETURN ADDR BACK TO STACK
         MOV       ESI,DWORD PTR MATHPAGE+4
         MOV       EDI,DWORD PTR MATHPAGE+8
         RET                            ;RESTORE ESI, EDI

SAVREG6:
         MOV       ESI,OFFSET AUX06     ;SAVE 06 - 1F
         MOV       EDI,CPBASE           ;
         LEA       EDI,[EDI].AUX06@@    ;
         MOV       ECX,26               ;
         JMP       SAVAUX               ;

SAVREG10:
         MOV       ESI,OFFSET AUX10     ;SAVE 10 - 1F
         MOV       EDI,CPBASE           ;
         LEA       EDI,[EDI].AUX10@@    ;
         MOV       ECX,16               ;
         JMP       SAVAUX               ;

SAVREG3:
         MOV       ESI,OFFSET AUX03     ;SAVE 03 - 1F
         MOV       EDI,CPBASE           ;
         LEA       EDI,[EDI].AUX03@@    ;
         MOV       ECX,29               ;
         JMP       SAVAUX               ;

;         CONT      JLMVP32A
;         FILE = JLMVP32A,07/29/1987
;         TITLE     MXDSTAT
;*MXDSTAT: GET & PROCESS MXD STATUS --
;*
;*     1. RESET PROCESSING:
;*          A. BREAKPOINT RETURN ADDRESS = ADDRESS OF RESET
;*             ROUTINE.
;*          B. I/O COMPLETION (PSTATIOC) SET FOR THIS PARTITION
;*
;*     2. Disconnect Terminal processing
;*          a. RESET all partitions assigned to this terminal
;*          b. Set bootstrap (PMODEB) and disconnect (PMODED) bits so that
;*             the disconnect program will be LOAD RUNed.
;*
;*     3. HALT/STEP PROCESSING:
;*          A. HALT/STEP BIT IN SH IN SAVE REG AREA.
;*
;*     4. POWER OFF PROCESSING: (NONE, PRESENTLY)
;*
;*     5. TERMINAL STATUS PROCESSING:
;*          A. PSTATPB, PSTATCOT, PSTATLR ANDED WITH TERMINAL
;*             STATUS BYTE. IF RESULT IS NONZERO, PSTATIOC SET.
;*
;*     MXD STATUS FORMAT:
;*
;*          BYTE 1 -- RESET
;*               BIT 01,02,04,08 are terminal 0,1,2,3 respectively.
;
;*          byte 1 -- connected terminal
;*               bit 10,20,40,80 are terminal 0,1,2,3 respectively.
;
;*          BYTE 2 -- HALT/STEP
;*               BIT 01,02,04,08 are terminal 0,1,2,3 respectively.
;
;*          byte 2 -- disconnected terminal
;*               bit 10,20,40,80 are terminal 0,1, ,3 respectively.
;
;*          byte 3 -- clock tick
;*                  Count of number of seconds that have ticked off.
;
;*          BYTE 4 -- TERMINAL 0 STATUS
;*               bit 80 -- TSTAT2ND (a 2nd terminal status byte follows)
;*               bit 10 --
;*               bit 08 -- TSTATSI (address 03 is ready with a screen input character)
;*               BIT 04 -- PSTATLR (LINE REQUEST COMPLETE)
;*               BIT 02 -- PSTATCOT (CO BUFFER BECAME EMPTY)
;*               BIT 01 -- PSTATPT (PRINT BUFFER BECAME EMPTY)
;*          BYTE 5 -- TERMINAL 1 STATUS
;*          BYTE 6 -- TERMINAL 2 STATUS
;*          BYTE 7 -- TERMINAL 3 STATUS
;*
;*     ENTRY: MXD ENABLED
;*
;*     MODIFIED REGISTERS: PC'S,CH,CL,K,F1
;@3.0RGNN EQU       *         bank modification allowed in REL 3.0
;*                         SL (and selected bank)
;*
;         EJECT
;*     The following changes to MXDSTAT are for screen input.  The following
;*     changes have been made to terminal status bytes.  (7/30/82)
;
;*        bit 08 of terminal status byte is 1 if address 03 is ready (ie,
;*                  a screen input character is available)
TSTATSI  EQU       08H

;*        bit 80 of terminal status byte indicates there is a 2nd terminal status byte
TSTAT2ND EQU       80H

;*        bit 01 of the 2nd status byte is 1 if the terminal is requesting a
;*                  screen dump
TSTATRSI EQU       01H

;*        bit 02 of the 2nd status byte is 1 if the terminal is requesting a
;*                  cancelations of screen input
TSTATCSI EQU       02H
;         EJECT
;*%----------------- check if MXD status has changed ----------------------------

MXDSTATC:
;        MOV       K,CH                 ;K = MXD STATUS ADDR
MXDSTAT:
;        MOV       AL,K                 ;AL = MXD STATUS ADDR
;-------- TSAI -----------
         MOVZX     EBX,AL
         SHR       BL,06                ;MXF or MXD card no
         BT        MXF,BX
         MOV       COM_BASE,0
         JNC       MXD1                 ;BR,IF MXD
         AND       AL,0C0H
         MOV       MXDADR,AL            ;

         MOV       EAX,EBX
         SHL       EBX,06               ;comman mem offset of 1'st port of MXF
         MOV       EBX,[EBX+OFFSET MXFTBL]
         MOV       COM_BASE,EBX         ;comm mem adr of 1'st port of MXF
         SHL       EAX,02               ;dword offset into GEN_STORE table
         MOV       EBX,[EAX+OFFSET GEN_STORE]
         MOV       AX,GS:[EBX].reset_byte
         MOV       TEMPSAVE,AX
         MOV       GS:[EBX].reset_byte,0         ;clear it after read

         MOV       AX,GS:[EBX].connect_byte
         MOV       TEMPSAVE1,AX
         MOV       GS:[EBX].connect_byte,0       ;clear it after read

         MOV       AX,GS:[EBX].halt_step_byte
         MOV       TEMPSAVE2,AX
         MOV       GS:[EBX].halt_step_byte,0     ;clear it after read

         MOV       AX,GS:[EBX].disconnect_byte
         MOV       TEMPSAVE3,AX
         MOV       GS:[EBX].disconnect_byte,0    ;clear it after read
         JMP       MXDSTAT6
MXD1:
;------- TSAII --------------
         MOV       BYTE PTR FS:[_ABS],AL;ENABLE MXD
         mov       B_ABS,al
$D32_1:
;        TEST      BYTE PTR FS:[CPUST],1
;        JZ        $D32_1
         call      delay5
         TEST      BYTE PTR FS:[CPUST],08H ;CHECK SH 08 BIT FOR DEVICE R/B
         JZ        MXDSTA13             ;BR, IF DEVICE BUSY
         AND       AL,0C0H              ;
         MOV       MXDADR,AL            ;MXD ADDRESS --> MXDADDR

;*%================= get the RESET/connect and HALT/disconnect status bytes ====-
;@3.0RGNX EQU       *
;*  These bytes used to be processed immediately.  Now, however, the processing
;*  is delayed until all the other status bytes have been taken in and processed.
;*  This change was necessary for VLSI-2 since in order to process these bytes,
;*  the associated partition needed to be accessed.  This might involve changing
;*  the current bank by strobing BSR, which would upset getting status from the
;*  MXE.
;*
         MOV       AX,WORD PTR FS:[CPUST]  ;TAKE OUT ENDI
         MOV       BYTE PTR FS:[CPURDY],0  ;ALLOW INPUT FROM MXD
MOD32_08:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_08                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
;------- u64 ------
         XOR       BX,BX
         MOV       BL,AL                   ;
         AND       BL,0FH                  ;GET RESET STATUS
         MOV       TEMPSAVE,BX             ;EXTEND TO ONE WORD LENGTH
         XOR       BX,BX
         MOV       BL,AL                   ;GET CONNECT STATUS
         SHR       BL,04H                  ;EXTEND TO ONE WORD LENGTH
         MOV       TEMPSAVE1 ,BX           ;
;        MOV       TEMPSAVE,AL             ;SAVE IT IN TEMPSAVE
;------- u64e ------

         MOV       AX,WORD PTR FS:[CPUST]  ;TAKE OUT ENDI
         MOV       BYTE PTR FS:[CPURDY],0  ;ALLOW INPUT FROM MXD
MOD32_09:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_09                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
;------- u64 -------
         XOR       BX,BX
         MOV       BL,AL                   ;
         AND       BL,0FH                  ;GET HALT/STEP STATUS
         MOV       TEMPSAVE2,BX            ;EXTEND TO ONE WORD LENGTH
         XOR       BX,BX
         MOV       BL,AL                   ;GET DISCONECT STATUS
         SHR       BL,04H                  ;EXTEND TO ONE WORD LENGTH
         MOV       TEMPSAVE3,BX            ;
;        MOV       TEMPSAVE+1,AL           ;SAVE IT IN TEMPSAVE+1
;------- u64E ------

;*%======= check the clock ======================================================
MXDSTAT4:
         MOV       BYTE PTR FS:[CPURDY],0  ;ALLOW INPUT FROM MXD
MOD32_10:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_10                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
;        TEST      AL,80H                  ;TEST IF INVALID
;        JZ        MXDSTAT6                ;BR, IF INVALID
;MXDSTAT3:
;         DEC       K                    ;DECREMENT COUNT
;         CMP       K,80H
;         JBE       MXDSTAT6             ;BR, IF ZERO SECONDS
;         CALL      UPCLK                ;UPDATE THE CLOCK
;         JMP       MXDSTAT3             ;LOOP BACK
;**
;         and       al,7fh
;         call      upclk

;*%================= process terminal status bytes ==============================
MXDSTAT6:
         MOV       CH,MXDADR            ;GET MXD ADDRESS
         MOV       CL,CH                ;F1 = 1ST TERMINAL ADDRESS
         MOV       A1,CX                ;u64,R1,R2 FROM 0 BEGIN
;        MOV       R1,CH                ;F1 = 1ST TERMINAL ADDRESS

;*GET PSTAT ENTRY CORRESPONDING TO THIS TERMINAL
;*
;---------- TSAI -----------
;read terminal status byte
MXDSTAT7:
         CMP       COM_BASE,0
         JE        MXD9                 ;BR,if MXD

         MOV       EDX,COM_BASE
;        CMP       GS:[EDX].cmd_sts,0FH
;        JE        MXD65

;        MOV       GS:[EDX].cmd_cbs,1FH
;        MOV       GS:[EDX].cmd_abs,06
;        MOV       GS:[EDX].cmd_sts,0FH      ;start command
MX7:
;        CMP       GS:[EDX].cmd_sts,0FH
;        JE        MX7

         MOV       AL,BYTE PTR GS:[EDX].curnt_sts
         mov       ch,byte ptr gs:[edx+15cdh]
         or        al,ch
;        or        al,byte ptr gs:[edx+15ceh]

;------- tsai,06-24-91 -------
         mov       k,al
mx2:
         mov       ah,0ffh
         xor       ah,al

         or        ah,08h
         and       byte ptr gs:[edx].curnt_sts,ah;clear it after read
;        cmp       ch,02h
;        jne       mx5
;        mov       byte ptr gs:[edx+15cdh],0
mx5:
         CMP       K,0
;------- tsai,06-24-91 -------

         JE        MXD65
         MOV       EDX,OFFSET PTERM
         JMP       MXDSTA71
;MXDSTAT7:
MXD9:
;-------- TSAII -------------
         MOV       BYTE PTR FS:[CPURDY],0 ;ALLOW INPUT FROM MXD
         MOV       EDX,OFFSET PTERM     ;PT TO BEG OF PTERM TABLE
MXDSTA71:
;------- u64 -------
;        MOV       CH,BYTE PTR [EDX]    ;GET PTERM ENTRY
;        CMP       CH,R1
         MOV       CL,BYTE PTR [EDX]    ;GET PTERM ENTRY
         MOV       CH,BYTE PTR [EDX+PARTMAX];GET XPTERM ENTRY
         CMP       CX,A1
;------- u64e ------
         JE        MXDSTA72             ;BR, IF CURRENT TERMINAL (ATTACHED)
         INC       EDX                  ;INCREMENT PT
;        CMP       EDX,OFFSET PTERM+PARTMAX;u64,THE ENDING OF PTERM TABLE
         CMP       EDX,PARTNO   ;---TSAI
         JNE       MXDSTA71             ;BR, IF MORE ENTRIES TO CHECK

;*TERMINAL NOT ATTACHED TO ANY PARTITION (IGNORE STATUS BYTE)
;*
;-------- TSAI ------
         CMP       COM_BASE,0
         JNE       MXDSTA74            ;BR,if MXF
;-------- TSAII -----
MOD32_11:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_11                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
         MOV       K,AL
         TEST      BYTE PTR FS:[CPUST],ENDI;CHK IF ENDI?
         JZ        MXDSTA74             ;BR, IF NOT ENDI
         JMP       MXDSTAT8             ;BR, IF EARLY ENDI (END OF STATUS)

;*TERMINAL ATTACHED TO PARTITION
;*
MXDSTA72:
         SUB       EDX,OFFSET PTERM     ;EDX (DL) = PART#
         ADD       EDX,OFFSET PSTAT     ;EDX PT TO CORRESP. PSTAT ENTRY
         MOV       CH,BYTE PTR [EDX]    ;GET PSTAT ENTRY

;------- TSAI ------
         CMP       COM_BASE,0
         JNE       MXD8                 ;BR,IF MXF
;------- TSAII -----
MOD32_12:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_12                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
         MOV       K,AL
         TEST      BYTE PTR FS:[CPUST],ENDI;CHK IF ENDI?
         JNZ       MXDSTAT8             ;BR, IF ENDI (PREMATURE END OF STATUS!)
MXD8:    ;--- TSAI

;------- TSAI,03-04-92 ----
         test      k,04h
         je        mm8
         test      ch,04
         jne       mm8
         nop
mm8:
;        MOV       AH,K
;        XOR       AH,0FFH
;        MOV       AL,CH
;        XOR       AL,0FFH
;        OR        AH,AL
;        MOV       EBX,COM_BASE
;        and       byte ptr gs:[EBX].curnt_sts,ah;clear it after read
;------- TSAI,03-04-92 ----

         TEST      CH,PSTATPBT          ;CHK IF PROGRAM BRPT (PSTATPBT = 40H)
         JZ        MOD32_13             ;BR, NO
         TEST      K,PSTATLR            ;IF PRGM BRPT & LINE REQ REC'D, I/O COMPLE
         JNZ       MXDSTA77             ;BR,
MOD32_13:
         MOV       AL,K                 ;
         AND       AL,CH                ;AND PSTAT WITH TERMINAL STATUS
         TEST      AL,07H               ;BR, IF NO I/O COMPLETION
;        TEST      AL,0FH               ;BR, IF NO I/O COMPLETION
         JZ        MOD32_14             ;
MXDSTA77:
                   ;*** EDX SHOULD PT TO ENTRY IN PSTAT TABLE
         OR        CH,PSTATICT          ;MXD IO COMP (PSTATICT=10H)
         MOV       BYTE PTR [EDX],CH    ;
MOD32_14:
;-------- TSAI ---------
         CMP      COM_BASE,0
         JE       MXDSTA74              ;BR,if not MXF

;        TEST     CH,08H                ;BR,if not RSD
;        JZ       MXDSTA99
;        TEST     K,10H                 ;BR,IF RSD not complete
;        JNZ      MXDSTA101
;MXDSTA99:
         TEST     CH,PSTATCOT           ;if cmd buf not available breakpoint
         JZ       MXDSTA74             ;BR,if not
         MOV      EBX,COM_BASE
         CMP      BYTE PTR GS:[EBX].cmd_sts,0FH
         JE       MXDSTA74
;        JNE      MXDSTA101             ;BR,if still unavailable
;-------- TSAI,12-08-90 -------

;        CMP      BYTE PTR [EDX+MXFGIOTBL],0
;        JE       MXDSTA74                  ;BR if MXF not in GIO mode
;        TEST     BYTE PTR [EBX].gcpust,RB  ;if device already ready
;        JZ       MXDSTA74                  ;br,if still busy
MXDSTA101:
         OR       CH,PSTATICT
         MOV      BYTE PTR [EDX],CH
;-------- TSAI,12-08-90 -------
;--------- TSAII --------
;*%TERMINAL PRINTER LOGIC -------------------------------------

MXDSTA74:
         TEST      K,PSTATPT            ;BR, IF NOT PRINT BUFR DONE
         JZ        MXDSTA73             ;
         CALL      MXESTA               ;CHK IF IT IS TC PORT
         TEST      CH,TCPORT            ;TCPORT = BIT 80H
         JZ        MXESTA74             ;BR, IF NOT TC PORT
         CALL      MXESTA6              ;WAKE UP PART WAITING TC BUFFR EMPTY
         JMP       MXDSTA73             ;
MXESTA74:
;        OR        R1,PTERMD            ;BIT 20H,TERMINAL DETACH FROM THIS PART
         OR        BYTE PTR A1,PTERMD
         MOV       EDX,OFFSET PTERM     ;
         MOV       EBX,OFFSET PSTAT     ;TO READ PSTAT ENTRY
MXDSTA75:
;------- u64 ------
;        MOV       CH,BYTE PTR [EDX]
         MOV       CL,BYTE PTR [EDX]    ;u64
         MOV       CH,BYTE PTR [EDX+PARTMAX];
         CMP       CX,A1                ;BR, IF NOT DETACHED TERMINAL
;------- u64e -----
         JNE       MXDSTA76             ;
         TEST      BYTE PTR [EBX],PSTATPT ;BR, IF PART NOT WAITING FOR PRINT BUFR
         JZ        MXDSTA76
         OR        BYTE PTR [EBX],PSTATICT
MXDSTA76:
         INC       EBX
         INC       EDX
;        CMP       EDX,OFFSET PTERM+PARTMAX;u64
         CMP       EDX,PARTNO   ;---U64
         JNE       MXDSTA75             ;BR, IF MORE PTERM ENTRIES
;        AND       R1,0DFH              ;DETACHED BIT OFF
         AND       BYTE PTR A1,0DFH     ;u64
;*%END OF TERMINAL PRINTER LOGIC-------------------------------
MXDSTA73:
MXDSTA70:
;*%----------------- screen input character? ------------------------------------
;*     Check for a screen input character (ie, address 03 is ready).  If so,
;*     activate the partition waiting for the screen input character from this
;*     terminal; the partition number is stored in the SCRNIN table.  If there
;*     is no such partition waiting, ignore this condition.

         TEST      K,TSTATSI            ;BIT 08H IN TERMINAL STATUS BYTE
         JZ        MXDSTA78             ;BR, IF SCREEN INPUT NOT READY

;------- u64 --------
;        MOV       BL,BYTE PTR [A1+1]   ;get TERM#
;        MOV       BH,BL                ;
;        AND       BL,PTERMNO           ;in board TERM#
;        AND       BH,PTERMXF           ;
;        SHR       BH,02H               ;shr MXD bord # 2 bit right
;        OR        BL,BH                ;reassemble to form BX=TERM#
;        MOV       BH,0                 ;
;------- TSAI,12-27-91 -----
         MOV       EBX,0
         MOV       BL,R0                ;temporary save r0 in bl
         MOV       CL,BYTE PTR [A1+1]   ;get terminal adr
         CALL      GETTERMD             ;get terminal no
         XCHG      BL,R0
;------- TSAII,12-27-91 -----
         XOR       EAX,EAX              ;
         dec       bl                   ;zero base
         ADD       EBX,OFFSET SCRNIN    ;EBX PT TO THE ENTRY IN SCRN INPUT TAB
         MOV       AL,BYTE PTR [EBX]    ;GET ENTRY
         TEST      AL,SCRNINP           ;CHECK IF SCRN INPUT NOT IN PROGRESS
         JZ        MXDSTA79             ;
         AND       AL,3FH               ;AL = PARTITION #
;-------- u64e --------
         ADD       EAX,OFFSET PSTAT     ;EAX PT TO ENTRY OF PSTAT
         OR        BYTE PTR [EAX],PSTATICT  ;ACTIVATE PARTITION WAITING FOR
         mov       ebx,com_base
;        and       byte ptr gs:[ebx+15ceH],0f7h ;SCRN INPUT
         and       byte ptr gs:[ebx].curnt_sts,0f7h
         inc       ct1
MXDSTA79:
;*%----------------- 2ndary terminal status byte? -------------------------------
;*     Process the 2ndary status byte if there is one.

MXDSTA78:
         TEST      K,TSTAT2ND           ;CHK 2ND TERMINAL STATUS BYTE
         JZ        MXDSTA64             ;BR, IF NO
         PUSH      EDX                  ;SAVE PC'S
;-------- TSAI --------
         CMP       COM_BASE,0
         JE        MXD10                ;BR,IF MXD
         MOV       EDX,COM_BASE
         MOV       AL,BYTE PTR GS:[EDX+1].curnt_sts
         MOV       BYTE PTR GS:[EDX+1].curnt_sts,0
;        MOV       AL,BYTE PTR GS:[EDX+15ceh]
;        MOV       BYTE PTR GS:[EDX+15ceh],0

         MOV       K,AL                 ;get second status byte from MXF
         JMP       MXD11
MXD10:
;------- TSAII ---------

;*     Get the 2ndary terminal status byte.
         MOV       BYTE PTR FS:[CPURDY],0 ;ALLOW INPUT OF BYTE
MOD32_15:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_15                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
         MOV       K,AL
         TEST      BYTE PTR FS:[CPUST],ENDI;CHK IF ENDI?
         JNZ       MXDSTAT8             ;BR, IF ENDI (END OF STATUS STRING)
MXD11:   ;---- TSAI
;*%----------------- screen input request? --------------------------------------
         TEST      K,TSTATRSI           ;CHK IF REQ FOR SCRN INPUT
         JZ        MXDSTA60             ;BR, IF NO

;*     Find a partition waiting for a screen input request.  This in indicated
;*     by the PMODESI bit in PMODE.

         MOV       EDX,OFFSET PMODE     ;
MXDSTA62:
         TEST      BYTE PTR [EDX],PMODESI       ;BR, IF PART IS WAITING FOR REQS
         JNZ       MXDSTA61             ;
         INC       EDX                  ;
         CMP       EDX,OFFSET PMODE+PARTMAX;u64,CHK END OF TABLE?
;        CMP       EDX,PARTNO
         JNE       MXDSTA62             ;BR, IF MORE ENTRIES


;*     No partitions are available for screen input.  Set the request bit in
;*     the SCRNIN entry for this terminal.  When INPUT SCREEN is processed for
;*     a partition with no terminal, it will check for terminals that have
;*     requested a screen input partition.
;------- u64 -----------
;        XOR       EDX,EDX              ;
;        MOV       DL,BYTE PTR [A1+1]   ;
;        MOV       DH,DL                ;
;        AND       DL,PTERMNO           ;BIT 0FH TERMINAL NO
;        AND       DH,PTERMXF           ;BIT 0C0H MXF BOARD NO
;        SHR       DH,02H
;        OR        DL,DH                ;DL=TERM #
;        XOR       DH,DH                ;
;------- TSAI,12-27-91 -----
         MOV       EDX,0
         MOV       DL,R0                ;temporary save r0 in DL
         MOV       CL,BYTE PTR [A1+1]   ;get terminal adr
         CALL      GETTERMD             ;get terminal no
         XCHG      DL,R0
;------- TSAII,12-27-91 -----
;------- u64e -----------
         dec       dl                   ;zero base
         ADD       EDX,OFFSET SCRNIN    ;EDX PT TO ENTRY IN SCRNIN TABLE
         OR        BYTE PTR [EDX],SCRNINR       ;SET REQUEST BIT
         JMP       MXDSTA60             ;

;*     A partition is available for screen input.  Assign the terminal to this
;*     partition and activate the partition by setting its PSTAT entry to
;*     PSTATICT.

MXDSTA61:
         SUB       EDX,OFFSET PMODE     ;EDX (DL) = PART#
         MOV       EBX,EDX              ;
         ADD       EDX,OFFSET PTERM     ;EDX PT TO PTERM TABLE ENTRY
;        MOV       AL,R1                ;AL = TERMINAL #
         MOV       AL,BYTE PTR A1       ;u64
         OR        AL,PTERMD            ;
         MOV       BYTE PTR [EDX],AL    ;ASSIGN TERMINAL TO PARTITION
         ADD       EBX,OFFSET PSTAT     ;EBX PT TO ENTRY IN PSTAT TABLE
         OR        BYTE PTR [EBX],PSTATICT      ;WAKE UP PARTITION

;*%----------------- cancel request for screen input? ---------------------------
MXDSTA60:          ;TSTATCSI - BIT 02 IN 2ND STATUS BYTE, IF THE TERMINAL IS
                   ;           REQUESTING CANCEL SCRN INPUT
         TEST      K,TSTATCSI           ;BR, IF NO CANCEL REQ
         JZ        MXDSTA63             ;
         XOR       EDX,EDX              ;
;------- u64 --------
;        MOV       DL,BYTE PTR [A1+1]   ;
;        MOV       DH,DL                ;
;        AND       DL,PTERMNO           ;BIT 0FH TERMINAL NO
;        AND       DH,PTERMXF          ;BIT 0C0H MXF BOARD NO
;        SHR       DH,02H
;        OR        DL,DH
;        XOR       DH,DH                ;
;------- TSAI,12-27-91 -----
         MOV       EDX,0
         MOV       DL,R0                ;temporary save r0 in bl
         MOV       CL,BYTE PTR [A1+1]   ;get terminal adr
         CALL      GETTERMD             ;get terminal no
         XCHG      DL,R0
;------- TSAII,12-27-91 -----
         dec       dl
         ADD       EDX,OFFSET SCRNIN    ;EDX PT TO ENTRY IN SCRNIN TABLE
         AND       BYTE PTR [EDX],0FFH-SCRNINR ;TURN OFF REQUEST BIT
;------- e64e --------
;*%------------------------------------------------------------------------------
MXDSTA63:
         POP       EDX                  ;RESTORE PC'S
;*%------------------------------------------------------------------------------
MXDSTA64:
;------- u64 ---------
;------- TSAI ---------
         CMP       COM_BASE,0           ;BR,IF MXD
         JE        MXD64                ;
MXD65:
         ADD       COM_BASE,1C00H       ;comm mem adr of next MXF
MXD64:                                  ;
;------- TSAII -----
         INC       BYTE PTR A1          ;
         AND       BYTE PTR A1,0C7H     ;
         INC       BYTE PTR [A1+1]      ;
         MOV       AL,BYTE PTR [A1+1]
         AND       AL,1FH
         CMP       AL,16                ;BR, IF MORE TERMINAL STATUS BYTES
;------- u64e --------
         JNE       MXDSTAT7             ;

;-------- TSAI ----
         CMP       COM_BASE,0
         JNE       MXD12                ;BR,IF MXF
;-------- TSAII-----

;*%GET ENDI CHARACTER (END OF STATUS)

MXDSTAT9:
         MOV       BYTE PTR FS:[CPURDY],0  ;ALLOW INPUT OF BYTE
MOD32_16:
         TEST      BYTE PTR FS:[CPUST],CPB ;WAIT FOR RESET/CONNECT STATUS BYTE
         JZ        MOD32_16                ;WAIT UNTIL RECVD
         MOV       AL,BYTE PTR FS:[IBGET]  ;RECVD INPUT FROM IBS, CHAR IN AL
         MOV       K,AL
         TEST      BYTE PTR FS:[CPUST],ENDI;CHK IF ENDI?
         JZ        MXDSTAT9             ;BR, IF NOT ENDI (LATE END OF STATUS!)
MXDSTAT8:
         MOV       AX,WORD PTR FS:[CPUST] ;TURN OFF ENDI
MXD12:   ;---- TSAI
;*%======= process RESET's ======================================================
;------- u64 ------
         MOV       CX,TEMPSAVE
;        MOV       K,CL                 ;RESET/CONNECT STATUS BYTE
;        TEST      CL,0FH               ;BR, IF NO RESET'S
         CMP       CX,00H
         JE        MXDSTA96             ;BR,IF NO RESET'S
;        PUSH      ECX                  ;SAVE RESET STATUS
;        SHL       CL,4                 ;PUT RESET BITS IN HIGH NIBBLE
;        MOV       R1,CL                ;F1 HIGH 4-BIT = RESET STATUS
         MOV       AL,MXDADR            ;GET MXD ADDRESS
         AND       AL,0C0H              ;AL = TERMINAL ADDRESS
         OR        AL,10H               ;     BIT C0H - MXD ADDR (00,40,80,C0)
;------- u64e ------------

                                        ;     (CURRENT 0,1,2,3; MAKE 4 TO DECRE)
;*%----------------- find next terminal which RESET -----------------------------
MXDSTAT1:
                                        ;AL = K (TERMINAL ADDRESS)
         DEC       AL                   ;DEC TERMINAL ADDRESS TO NEXT ONE
;-------- u64 -----
         CMP       CX,0                 ;CL = F1 (HIGH 4 BITS) RESET STATUS
         JE        MXDSTA96             ;BR, IF NO MORE RESET'S
         SHL       CX,1                 ;CHK BIT BY BIT
         JNC       MXDSTAT1             ;BR, IF NOT RESET
         MOV       AH,AL
         AND       AH,PTERMAD           ;BIT 0C7H
;-------- u64e -----
;*%----------------- if terminal is attached to a partition, RESET that partition ---

         MOV       EDX,OFFSET PTERM     ;EDX PT TO BEG OF PTERM TABLE
MXDSTA11:
;------- u64 --------
         MOV       BL,BYTE PTR [EDX+PARTMAX]
         MOV       BH,BYTE PTR [EDX]
         CMP       AX,BX
;        CMP       AL,BYTE PTR [EDX]    ;CHK IF CURRENT TERMINAL (ATTACHED)
         JZ        MXDSTA12             ;BR,if terminal attach
         INC       EDX                  ;PT TO NEXT PTERM ENTRY
;        CMP       EDX,OFFSET PTERM+PARTMAX;BR, IF MORE ENTRIES TO CHK,u64
         CMP       EDX,PARTNO           ;--- TSAI,u64
         JNE       MXDSTA11             ;
;*%----------------- if terminal not attached, RESET lowest assigned partition --
         OR        AH,PTERMD            ;AL = DETACHED TERMINAL
         MOV       EDX,OFFSET PTERM     ;
MXDSTA15:
         MOV       BL,BYTE PTR [EDX+PARTMAX]
         MOV       BH,BYTE PTR [EDX]
         CMP       AX,BX
;        CMP       AL,BYTE PTR [EDX]    ;BR, IF IS TERMINAL LOOKING FOR
         JE        MXDSTA14             ;
         INC       EDX                  ;PT TO NEXT ENTRY
 ;       CMP       EDX,OFFSET PTERM+PARTMAX;u64
         CMP       EDX,PARTNO           ;--- TSAI,u64
         JNE       MXDSTA15             ;BR, IF MORE TO CHK
;-------- u64e --------
;*%----------------- if no partitions are assigned, assign one if available -------
         AND       AL,0FFH-PTERMD       ;DETACHED BIT OFF
         MOV       K,AL                 ;
         CALL      ATCHPART             ;ATTACH A RELEASED PARTITION, IF ANY
         JMP       MXDSTAT1             ;
;*%----------------- RESET partition --------------------------------------------

MXDSTA14:
         AND       AL,0FFH-PTERMD       ;DETACHED BIT OFF
         MOV       K,AL                 ;

MXDSTA12:
         SUB       EDX,OFFSET PTERM     ;EDX (DL) = PART#
         MOV       BYTE PTR [EDX+OFFSET MXFGIOTBL],0 ;--TSAI,clear MXF GIO
         ADD       EDX,OFFSET PSTAT     ;EDX PT TO PSTAT TABLE ENTRY
         CALL      FRESET               ;FORCE RESET FOR CURRNET PARTITION
         JMP       MXDSTAT1             ;

;*%================= process terminal connects ===============================
;*        entry: K,bitsF0 = connect bits for terminals

MXDSTA96:
;        POP       ECX                  ;u64,RESTORE K
         MOV       CX,TEMPSAVE1
         MOV       K,CL                 ;

MXDSTA90:
;        TEST      CL,0F0H              ;BR, IF NO CONNECTS (HIGH NIBBLE = 0)
         CMP       CX,0                 ;u64,BR if no connects
         JZ        MXDSTA95             ;
;        AND       CL,0F0H              ;CL, BITS 0F0H = CONNECTS
         MOV       R1,CL                ;F1  BITS 0F0H = CONNECTS
         MOV       AL,MXDADR            ;GET MXD ADDRS
         AND       AL,0C0H              ;AL = TERMINAL ADDRESS
         OR        AL,10H               ;u64, BIT C0H - MXD ADDR (00,40,80,C0)
                                        ;     BIT 07H - TERMINAL# IN BOARD
                                        ;     (CURRENT 0,1,2,3; MAKE 4 TO DECRE)

         mov       dl,r0
         push      edx
MXDSTA91:
         DEC       AL                   ;DEC TERMINAL ADDRESS TO NEXT ONE
         CMP       CX,0             ;u64,CL = F1 (HIGH 4 BITS) RESET STATUS
         JE        MXDSTA92             ;BR, IF NO MORE RESET'S
         SHL       CX,1             ;u64,CHK BIT BY BIT
         JNC       MXDSTA91             ;BR, IF NOT CONNECT
;------- u64 -------
         MOV       AH,AL                ;
         AND       AH,PTERMAD           ;0C7H
;------- U64e ------
         MOV       EDX,OFFSET PTERM     ;EDX PT TO BEG OF PTERM TABLE
;------- u64 -------
MXDSTA93:
;        MOV       AH,BYTE PTR [EDX]    ;GET PTERM ENTRY
;        AND       AH,PTERMADR+PTERMRLS ;PTERMADR - 0C7H TERMINAL ADDRS
         MOV       BH,BYTE PTR [EDX]    ;GET PTERM ENTRY
         AND       BH,PTERMAD +PTERMRLS ;PTERMADR - 0C7H TERMINAL ADDRS
         MOV       BL,BYTE PTR [EDX+PARTMAX]
;        MOV       R0,AH                ;PTERMRLS - 008H PART RELEASE (NO TERM)
         MOV       R0,BH                ;PTERMRLS - 008H PART RELEASE (NO TERM)
;        CMP       AL,AH                ;CHK IF CURRENT TERMINAL
         CMP       AX,BX                ;CHK IF CURRENT TERMINAL
         JE        MXDSTA91             ;BR, IF FOUND
         INC       EDX                  ;PT TO NEXT PTERM ENTRY
         CMP       EDX,OFFSET PTERM+PARTMAX;BR, IF MORE ENTRIES TO CHK,u64
         CMP       EDX,PARTNO           ;--- TSAI,u64
         JNE       MXDSTA93             ;


;*        The terminal K is to be connected to a partition if there is a released
;*        partition available and waiting for a terminal.

         MOV       K,AL                 ;K = TERMINAL #
         CALL      ATCHPART             ;ATTACH PARTITION IF ONE AVAILABLE
         JMP       MXDSTA91             ;
;------- u64e -----------
MXDSTA92:
         pop       edx
         mov       r0,dl
MXDSTA95:

;*%================= process HALT/STEP's ========================================
MXDSTAT2:
;------- u64 ------
;        MOV       CL,TEMPSAVE+1        ;GET HALT/DISCONNECT BYTE
         MOV       CX,TEMPSAVE2
;        TEST      CL,0FH               ;BR, IF NO HALT/DISCONNECT
         CMP       CX,00H
         JE        MXDSTA86             ;
         OR        SH,HALT
;        PUSH      ECX                  ;SAVE HALT/DISCONNECT BYTE
;        SHL       CL,4                 ;PUT HALT/STEP BITS IN HIGH NIBBLE
         MOV       R1,CL                ;F1 HIGH 4-BIT = HALT/STEP STATUS
         MOV       AL,MXDADR            ;GET MXD ADDRESS
         AND       AL,0C0H              ;AL = TERMINAL ADDRESS
         OR        AL,10H               ;     BIT C0H - MXD ADDR (00,40,80,C0)
;------- u64e ------                    ;     BIT 0FH - TERMINAL# IN BOARD
                                        ;     (CURRENT 0,1,2,3; MAKE 4 TO DECRE)


;*%----------------- find next terminal which HALTed ----------------------------
MXDSTA20:
         DEC       AL                   ;DEC TERMINAL ADDRESS TO NEXT ONE
;        CMP       CL,0                 ;CL = F1 (HIGH 4 BITS) RESET STATUS
         CMP       CX,00H
         JE        MXDSTA86             ;BR, IF NO MORE HALT/STEP'S
;        SHL       CL,1                 ;CHK BIT BY BIT
         SHL       CX,1
         JNC       MXDSTA20             ;BR, IF NOT HALT/STEP
;------- KHAN ----
         MOV       AH,AL
         AND       AH,PTERMAD           ;BIT 0C7H
;*%----------------- if terminal is attached to a partition, HALT that partition--
         MOV       EDX,OFFSET PTERM     ;EDX PT TO BEG OF PTERM TABLE
MXDSTA21:
         MOV       BL,BYTE PTR [EDX+PARTMAX];CHK IF CURRENT TERMINAL(ATTACHED)
         MOV       BH,BYTE PTR [EDX]
         CMP       AX,BX
         JE        MXDSTA22             ;BR, IF FOUND
         INC       EDX                  ;PT TO NEXT PTERM ENTRY
;        CMP       EDX,OFFSET PTERM+PARTMAX;BR, IF MORE ENTRIES TO CHK,u64
         CMP       EDX,PARTNO           ;--- TSAI,u64
         JNE       MXDSTA21             ;
;*%----------------- if terminal not attached, HALT lowest assigned partition----
;        OR        AL,PTERMD            ;AL = DETACHED TERMINAL
         OR        AH,PTERMD            ;AL = DETACHED TERMINAL
         MOV       EDX,OFFSET PTERM     ;
MXDSTA16:
         MOV       BL,BYTE PTR [EDX+PARTMAX]
         MOV       BH,BYTE PTR [EDX]
         CMP       AX,BX
;        CMP       AL,BYTE PTR [EDX]    ;BR, IF IS TERMINAL LOOKIN G FOR
         JE        MXDSTA17             ;
         INC       EDX                  ;PT TO NEXT ENTRY
;        CMP       EDX,OFFSET PTERM+PARTMAX;PT to next entry,u64
         CMP       EDX,PARTNO           ;--- TSAI,u64
         JNE       MXDSTA16             ;BR, IF MORE TO CHK

         AND       AL,0FFH-PTERMD       ;DETACHED BIT OFF
         MOV       K,AL                 ;
         JMP       MXDSTA20
;-------- u64e ----------
;*%----------------- HALT partition ---------------------------------------------
MXDSTA17:
         AND       AL,0FFH-PTERMD       ;DETACHED BIT OFF

MXDSTA22:
         SUB       EDX,OFFSET PTERM     ;EDX (DL) = PART#
         ADD       EDX,OFFSET PSTAT     ;EDX PT TO ENTRY IN PSTAT
         TEST      BYTE PTR [EDX],PSTATLR       ;IF LINE REQS?
         JZ        MOD32_18             ;BR, IF NO
         OR        BYTE PTR [EDX],PSTATICT      ;SET I/O COMPL
MOD32_18:
         SUB       EDX,OFFSET PSTAT     ;EDX (DL) = PART#
         SHL       EDX,2
         ADD       EDX,OFFSET BASE      ;EDX PT TO BASE TABLE
         MOV       EDX,DWORD PTR [EDX]  ;GET BASE ADDR OF PART# TO HALT
;@3.0RGNO:
         LEA       EDX,[EDX].@SAVESH    ;EDX PT TO SAVE AREA FOR SH
         OR        BYTE PTR [EDX],20H   ;SET HALT/STEP ON IN SH
         JMP       MXDSTA20

;*%================= process terminal disconnects ===============================
;*        entry: K,bitsF0 = disconnect bits for terminals

MXDSTA86:
;        POP       ECX                  ;RESTORE HAL/DISCONNECT BYTE IN CL
         MOV       CX,TEMPSAVE3
MXDSTA80:
;        TEST      CL,0F0H              ;BR, IF NO DISCONNECTS
         CMP       CX,00H
         JZ        MXDSTA85             ;
;        AND       CL,0F0H              ;CL, BITS 0F0H = DISCONNECTS
         MOV       R1,CL                ;F1  BITS 0F0H = DISCONNECTS
;------- KHAN -------
         MOV       AL,MXDADR            ;GET MXD ADDRS
         AND       AL,0C0H              ;AL = TERMINAL ADDRESS
         OR        AL,10H               ;     BIT C0H - MXD ADDR (00,40,80,C0)
;------- KHANN --------                 ;     BIT 07H - TERMINAL# IN BOARD
                                        ;(CURRENT 0,1,..F; MAKE 16 TO DECRE)
MXDSTA81:                               ;AL = K (TERMINAL ADDRESS)
         DEC       AL                   ;DEC TERMINAL ADDRESS TO NEXT ONE
;        CMP       CL,0                 ;CL = F1 (HIGH 4 BITS) DISCONS STATUS
         CMP       CX,00H
         JE        MXDSTA82             ;BR, IF NO MORE DISCONS'S
;        SHL       CL,1                 ;CHK BIT BY BIT
         SHL       CX,1
         JNC       MXDSTA81             ;BR, IF NOT DISCONNECT
;------- KAHN
         MOV       AH,AL                ;
         AND       AH,PTERMAD           ;0C7H
;------- KHANN
         MOV       EDX,OFFSET PTERM     ;EDX PT TO BEG OF PTERM TABLE
;------- u64e ----------
;------- u64 -----------
MXDSTA83:
         MOV       BH,BYTE PTR [EDX]    ;GET PTERM ENTRY
         AND       BH,PTERMAD+PTERMRLS  ;PTERMAD  - 0C7H TERMINAL ADDRS
         MOV       BL,BYTE PTR [EDX+PARTMAX]
;        MOV       AH,BYTE PTR [EDX]    ;GET PTERM ENTRY
         INC       EDX                  ;PT TO NEXT PTERM ENTRY
;        AND       AH,PTERMADR+PTERMRLS ;PTERMADR - 0C7H TERMINAL ADDRS
                                        ;PTERMRLS - 008H PART RELEASE (NO TERM)
;        CMP       AL,AH                ;CHK IF CURRENT TERMINAL
         CMP       AX,BX
         JE        MXDSTA84             ;BR, IF FOUND
MXDSTA87:
;        CMP       EDX,OFFSET PTERM+PARTMAX;BR, IF MORE ENTRIES TO CHK
         CMP       EDX,PARTNO           ;--- TSAI,u64
         JNE       MXDSTA83             ;
         JMP       MXDSTA81

;*        Partition (PL,bits0F) is to be disconnected.  A RESET is forced and
;*        the bootstrap program and disconnect bits are set in PMODE.
;*
;------- u64e -------
MXDSTA84:
         PUSH      EDX                  ;SAVE PC'S
         SUB       EDX,OFFSET PTERM+1   ;EDX (DL) = PART#
         MOV       EBX,EDX              ;
         ADD       EBX,OFFSET PMODE     ;EBX PT TO ENTRY IN PMODE TABLE
         OR        BYTE PTR [EBX],PMODEB+PMODED ;TUNR ON BOOTSTRAP AND DISCONNS
         ADD       EDX,OFFSET PSTAT     ;EDX PT TO ENTRY IN PSTAT
         CALL      FRESET               ;FORCE A RESET FOR THIS PART#
         POP       EDX                  ;RESTORE PC'S
         JMP       MXDSTA87             ;


MXDSTA82:
MXDSTA85:
MXDSTA13:
         RET

;         TITLE     ATCHPART
;*ATCHPART:  if a partition is available (ie, released and waiting for a terminal),
;*        assign the partition to the
;*        specified terminal and wake up that partition.  This assumes that the
;*        terminal is not already assigned to a partition.
;*
;*        Entry: K = terminal (format as in PTERM)
;*
;*        Modified registers: PC's,CHCL
;*
ATCHPART:
         PUSH      AX
         PUSH      CX
;*%----------------- check for illegal terminal number --------------------------

         ;** K BIT C0H -> MXD BOARD ADDRESS, BIT 07H -> IN-BOARD TERMINAL #

         MOV       AL,K                 ;GET TERMINAL
         MOV       AH,AL                ;MAKE A COPY
;------- u64 ------
;------- TSAI,12-27-91 -----
         MOV       EAX,0
         push      word ptr [r0]        ;temporary save r0
         MOV       CL,K                 ;get terminal adr
         CALL      GETTERMD             ;get terminal no
         mov       AL,R0
         pop       word ptr [r0]
;------- TSAII,12-27-91 -----
;        AND       AH,PTERMXF
;        AND       AL,PTERMNO
;        SHR       AH,02H
;        OR        AL,AH
;;       AND       AH,0C0H
;;       SHR       AH,4                 ;SFT MXD BOARD ADDRESS INTO LOW NIBBLE
;;       AND       AL,03H               ;AL = IN-BOARD TERMINAL #
;;       OR        AL,AH                ;AL = BIT 0CH -> BOARD ADDR
;------- u64e ------
                                        ;   = BIT 03H -> TERMINAL#
         MOV       AH,MAXTERM_          ;AH = MAX TERMINAL ALLOWED

         ;** AL --> F0, AH --> F1
         CMP       AH,AL                ;BR, IF TERMINAL# > MAX ALLOWED
         JB        ATCHPRT3             ;

;*%----------------- look for a released partition waiting for a terminal--------
         XOR       EBX,EBX              ;
         MOV       BL,NXTRLSPT          ;GET PART# TO START CHECKING AT
         ADD       EBX,OFFSET PTERM     ;
         MOV       EDX,EBX              ;EBX = START CHKING PT
ATCHPRT0:
         MOV       CH,BYTE PTR [EDX]    ;GET ENTRY IN PTERM
         INC       EDX                  ;
         CMP       CH,0FFH
         JE        ATCHPRT3
         TEST      CH,PTERMRLS          ;BIT 08H
         JNZ       ATCHPRT1             ;BR, IF RELEASED PARTITION
ATCHPRT2:
         CMP       EDX,OFFSET PTERM+PARTMAX;u64,CHK IF END OF TABLE
;        CMP       EDX,PARTNO ;u64,----TSAI
         JNE       MOD32_19             ;NO,
         MOV       EDX,OFFSET PTERM     ;
MOD32_19:
         CMP       EDX,EBX              ;BR, IF MORE ENTRIES TO CHK
         JNE       ATCHPRT0             ;BR, IF MORE TO CHK
         JMP       ATCHPRT3

ATCHPRT1:
         TEST      CH,PTERMW            ;BIT 10H  WAITING FOR TERMINAL
         JZ        ATCHPRT2             ;BR, IF PART NOT WAIT FOR TERMINAL

;*%----------------- attach terminal to partition and wake up partition ---------
         DEC       EDX                  ;PT BACK TO PTERM ENTRY
         MOV       CL,K                 ;GET ENTRY K
;------- KHAN ----
;        MOV       BYTE PTR [EDX],CL    ;
         MOV       BYTE PTR [EDX+PARTMAX],CL    ;XPTERM ENTRY
         AND       CL,PTERMAD           ;0C7H   ;PTERM ENTRY
         MOV       BYTE PTR [EDX],CL
;------- KHANN ----
         SUB       EDX,OFFSET PTERM
         MOV       CL,DL                ;CL = PART#
         ADD       EDX, OFFSET PSTAT    ;EDX PT TO ENTRY IN PSTAT
         MOV       AL,PSTATICT          ;WAKE UP PARTITION (I/O COMPL)
         MOV       BYTE PTR [EDX],AL
         CMP       CL,PARTMAX-1         ;u64,OVER MAX PART#
         JAE       MOD32_20             ;BR, IF NO
         INC       CL                   ;NEXT PART#
MOD32_20:
         MOV       NXTRLSPT,CL          ;NXTRLSPT = PART# OF NEXT PART
;*%------------------------------------------------------------------------------
ATCHPRT3:
         POP       CX
         POP       AX
         RET

;         TITLE     FRESET
;*FRESET:  force a RESET of the specified partition
;
;*        Entry:  PC's point at PSTAT entry for partition to RESET
;
;*        Modified registers: PC's,CHCL,SL
;*
;@3.0RGNP EQU       *         SL modification added in Rel 3.0
;*                            SL (& selected bank)
;*
FRESET:

        test     byte ptr [edx],20h
        jz       freset_1

        push    eax
        push    edi
        push    ebx
        push    ecx

        mov     eax,edx
        sub     eax,offset pstat
        mov     ebx,actdev
        and     bl,040h
        mov     edi,offset mdevtbl
fsearch_1:
        mov     cx,[edi-MDEVSIZE]       ;u64
        xchg    ch,cl
        cmp     ch,bl
        jz      fsearch_2
        add     edi,2
        jmp     fsearch_1
fsearch_2:
        and     cl,PARTBIT              ;u64
        cmp     al,cl
        jnz     freset_2
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@hogflg,0
freset_2:

        pop     ecx
        pop     ebx
        pop     edi
        pop     eax

freset_1:
         MOV       BYTE PTR [EDX],PSTATICT      ;GET OS ATTENTION
                                        ;BY MAKE STATUS = I/O COMPL
         SUB       EDX,OFFSET PSTAT     ;EDX (DL) = PART#
         shl       edx,2
         ADD       EDX,OFFSET BASE      ;EDX PT TO ENTRY IN BASE TABLE
         MOV       EDX,DWORD PTR [EDX]  ;GET BASE OF THIS PARTITION
         MOV       BYTE PTR [EDX].RESETF@@,1    ;FLAG = RESET
         MOV       WORD PTR [EDX].AUX1A@@,0     ;ACTDEV = 00
                                        ;FOR DISK DON'T ENABLE DISK DURING RESET
         RET


CODE      ENDS
          END

