;===========================================================================
;
;
;
;===========================================================================
;           This module was originally M35
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC    ACCEPTLR
PUBLIC    DEATOM7E
PUBLIC    DISPSTAR
PUBLIC    ERROR_52
PUBLIC    KEYIN
PUBLIC    LINPUT
PUBLIC    PUTLINF
PUBLIC    READL
PUBLIC    READL24
PUBLIC    RECALL
PUBLIC    RECLINE
PUBLIC    RQSTLINE
PUBLIC    RQSTLINA
PUBLIC    QUERYLR
;-------- TSAI ------
public    readl223
public    readl009
PUBLIC    RECLINEM
PUBLIC    RQSTLINM
PUBLIC    RQSTLINN
PUBLIC    QUERYLRM
PUBLIC    READLINB
PUBLIC    RECALL
PUBLIC    KEYFUNC
PUBLIC    RD86
public    putchar
public    linp23
PUBLIC    DEATOM
PUBLIC    PUTSCAN
PUBLIC    KEYIN15
;-------- TSAII -----

EXTRN     ENBLCNT :NEAR
EXTRN     ENBLNLLD:NEAR
EXTRN     ERROR   :NEAR
EXTRN     ERROR_04:NEAR
EXTRN     ERROR_05:NEAR
EXTRN     ERROR_13:NEAR
EXTRN     PROCST  :NEAR
EXTRN     TWRITE  :NEAR
EXTRN     DELAY10 :NEAR
EXTRN     DELAY5  :NEAR
EXTRN     OBSTROBE:NEAR
EXTRN     AVARD   :NEAR
EXTRN     AVARR   :NEAR
EXTRN     BREAKPTD:NEAR
EXTRN     BREAKPTI:NEAR
EXTRN     BREAKPTJ:NEAR
EXTRN     BREAKPTR:NEAR
EXTRN     BREAKPTT:NEAR
EXTRN     CBSNT   :NEAR
EXTRN     DEVSPEC :NEAR
EXTRN     ENBLCO  :NEAR
EXTRN     ENBLDEVI:NEAR
EXTRN     ENBLNULL:NEAR
EXTRN     ENDSTIO :NEAR
EXTRN     ENDSTMT :NEAR
EXTRN     ERROR_02:NEAR
EXTRN     ERROR_29:NEAR
EXTRN     ERROR_48:NEAR
EXTRN     FINDDFA@:NEAR
EXTRN     FINDST  :NEAR
EXTRN     GETINPT2:NEAR
EXTRN     GOTO    :NEAR
EXTRN     INPUT1  :NEAR
EXTRN     INPUT6  :NEAR
EXTRN     INPUTSUB:NEAR
EXTRN     LISTTA  :NEAR
EXTRN     MVSCRTCH:NEAR
EXTRN     MVSCRTCH1:NEAR
EXTRN     NXTINPT :NEAR
EXTRN     NXTLOW  :NEAR
EXTRN     OBSN09  :NEAR
EXTRN     OBSNT   :NEAR
EXTRN     PART_   :BYTE
EXTRN     PTERM   :BYTE
EXTRN     REMNULL :NEAR
EXTRN     RPARTEND:NEAR
EXTRN     SCRATCH :NEAR
EXTRN     SAVESTKS:NEAR
EXTRN     STEP    :NEAR
EXTRN     SWITCH  :NEAR
EXTRN     TRLINE_ :NEAR
EXTRN     TRLINE_A:NEAR
EXTRN     TWRITESP:NEAR
EXTRN     TEMPSAVE:NEAR
EXTRN     VARR    :NEAR
EXTRN     VVFMTA  :NEAR
EXTRN     WAITIBSE:NEAR
EXTRN     WORDLENA:NEAR

EXTRN     @@VSEND :DWORD
EXTRN     @@OSEND :DWORD
EXTRN     CPBASE  :DWORD
;----- TSAI -------
EXTRN     CMDBUADR :DWORD               ;--- TSAI
EXTRN     OBSMXF  :NEAR                 ;--- TSAI
EXTRN     WAITCMD :NEAR                 ;--- TSAI
;----- TSAII ------
;         FILE = DAMVP35 ,12/16/1986
;         MODULE    MOD-35 MXD INPUT
;*          REFERENCED MODULES:
;*
;         SYMBL     BPMVP00   SYSTEM EQUATES
;         SYMBL     BPMVP05   I/O SUBROUTINES
;         SYMBL     BPMVP02   SYNTAX CHECKING
;         SYMBL     BPMVP04   GENERAL STATEMENTS
;         SYMBL     BPMVP10   ALPHA
;         SYMBL     BPMVP12   STATEMENTS
;         SYMBL     BPMVP06   SUBROUTINES
;         SYMBL     BPMVP03   COMMANDS
;         SYMBL     JLMVP32   MVP SUBROUTINES
;         SYMBL     BPMVP01   CONTROL, ENDSTMT
;         SYMBL     BPMVP07   EXPRESSION ANALYSIS
;         SYMBL     BPMVP08   STMTS
;         SYMBL     DAMVP27   LIST
;         SYMBL     DAMVP23   RENUMBER
;         SYMBL     BPMVP16
;         TITLE     READLINE
;*     READLINE: GET AN INPUT LINE FROM KEYBOARD OR OTHER
;*             DEVICE.
;*
;*     ENTRY: I/O BUFFER IS LOCATED FROM XXXX TO YYYY.
;*         ADDRESS XXXX IS IN AUX IBUFBEG,TEXTEND,AND F7F6
;*         ADDRESS YYYY IS IN AUX IBUFEND. YYYY IS AT
;*         LEAST 20 LARGER THAN XXXX.  THE HIGH ORDER
;*         4 BITS OF F5 ARE SET AS SPECIFIED BELOW.
;*
;*         F4=00, EXCEPT WHEN ENTERED FROM LIST S, WHEN F4
;*         IS THE KEYSTROKE ALREADY ENTERED.
;*
;*         IF NOT LINPUT,  F3F2 = OLD THREAD OF LINE IN
;*         WORK BUFFER.
;*
;*         F0=00, PC'S POINT AT IOBUFFER
;*
;*   EXIT:  BY OPERATOR PRESS SF KEY OR CARRIAGE RETURN.
;*       EITHER WAY, TEXTEND POINTS AT THE CR WHICH IS AT
;*       THE END OF THE BUFFER.
;*     IF TERMINATION IS BY CARRIAGE RETURN, THE BRANCH
;*       IS TO ENTERX.
;*     IF A SPECIAL FUNCTION KEY (SUBROUTINE OR TEXT
;*       ENTRY) IS PRESSED, READLINE BRANCHES TO KEYFUNC.
;*     IF HALT STEP IS PRESSED IN CI MODE, BRANCH IS MADE
;*       TO STEP.
;*
;*
;*          SPECIAL CHARACTERS:
;*               08 = BACKSPACE (ERASE LAST CHARACTER)
;*               0D = CARRIAGE RETURN (END OF LINE))
;*               00-0F except 08,0D = NULL (IGNORE)
;*               E5 = STATEMENT NUMBER (ONLY AT BEGINNING)
;*               E6 = LINE ERASE (ERASE CURRENT LINE FROM
;*                    CRT AND DELETE LINE FROM I/O BUFFER)
;*               80-FF = TEXT ATOM
;*               'F0 = EDIT MODE SWITCH
;*               'XX   (00-1F) = SPECIAL FUNCTION OR EDIT
;*               'XX   (20-7F) = SPECIAL FUNCTION
;*               'XX   (80-F9 except F0)= FOREIGN LANGUAGE
;*               'XX   (FA-FF) = NULL
;*                             EXCEPT IN INPUT/LINPUT MODE
;*               HALT/STEP - PROCESSED IMMEDIATELY IN CI,
;*                      AFTER THE CR IN INPUT MODE
;*
;*          REGISTER USE:
;*
;*               IBUFBEG = BEGIN OF BUFFER POINTER
;*               TEXTEND = CURRENT END OF BUFFER
;*               IBUFEND = END OF BUFFER LIMIT POINTER
;*               F7F6    = BUFFER POINTER
;*               F5      = STATUS BITS:
;*                  F5 HIGH = MODE:
;*                      80 - LOAD MODE
;*                      40 - CONSOLE INPUT FROM LISTS
;*                           (F4 = CHARACTER TO DISPLAY)
;*                      00 - CONSOLE INPUT
;*                      20 - INPUT mode
;*                      30 - LINPUT mode
;*                      70 - LINPUT (W. underline)
;*                  F5 LOW  = MODE:
;*                      08 - EDIT mode switch
;*                      04 - LIST T mode
;*                      02 - (used by LIST T)
;*                      01 - (used by LIST T, KEYFUNC)
;*      PC'S,CH,CL,K,F4-F0 = SCRATCH
;*          MODIFIED REGISTERS: ALL,0,1,2,IBUFBEG,IBUFEND
;*           COUNTS,CHARCNT,TEXTEND,MODE,TEXTPTR,TEXTLPTR
;         EJECT
;*    RULES AND RESTRICTIONS ON USING EDIT
;* 1. All characters below 10 will be displayed as a
;*    period.  This applies to RECALL from text and
;*    variable, and DEFFN' HEX(.
;*
;*  2. Device type 4 is not supported.  Results are
;*     not predictable and will not be planned.
;*
;*  3. Device type 2 or 7: If these device types are
;*     selected, all information will be on a single line.
;*     Thus backspace will never cause reverse index.
;*
;*  4. Device type 0:  This device type assumes a CRT.
;*     Thus cursor positioning will be by any means
;*     which is legal on the CRT, and will not necessarily
;*     be readable on some other device.
;*
;*  5. Defined width:  If the defined width is 0, no
;*     automatic carriage returns can be issued.  Thus if
;*     more than 1 line is typed by the operator, the
;*     information will be overlayed, and screen integrity
;*     is not guaranteed.
;
READL:
          MOV       R0,0FFH
          TEST      MODE,0400H          ;MODEIMM = 04H
          JZ        READL009            ;Immediate mode line invalid, so flush buffer

READL002: CMP       DWORD PTR [A2],1
          JE        READL001            ;SKIP IF IMMEDIATE MODE (THREAD = 0001)
          CMP       DWORD PTR [A2],0
          JNE       READL009            ;DON'T COPY IF NOT ERROR#01 LINE
          MOV       BYTE PTR [EDX],0FFH
          INC       EDX                 ;ADD AN FF IN FRONT OF THE ERROR 01 LINE

READL001: MOV       AUX00,EDX
          MOV       EDX,IBUFEND
          MOV       DWORD PTR [A2],EDX
          MOV       EDX,DWORD PTR [A6]
          MOV       CH,[EDX]
          XCHG      EDX,AUX00
          INC       AUX00
          MOV       AX,511
READL005:
          CMP       CH,0DH
          JE        READL005E
          CMP       CH,7DH
          JNE       READL005A
          CALL      RESTOR7F
          JMP       READL005D
READL005A:
          CMP       CH,7EH
          JNE       READL005B
          CALL      RESTOR7E
          JMP       READL005D
READL005B:
          CMP       CH,7FH
          JNE       READL005B1
          CALL      RESTOR7F
          JMP       READL005D
READL005B1:
          CMP       CH,0A2H             ;REM --> 0FDH OR 0DH
          JNE       READL005B2
          CALL      RESTORA2
          JNC       READL005D
          JMP       READL005E
READL005B2:
          CMP       CH,0D8H             ;IMAGE --> 0DH
          JNE       READL005B3
          CALL      RESTORD8
          JNC       READL005D
          JMP       READL005E
READL005B3:
          CMP       CH,@HEXLIT          ;HEX(...)
          JNE       READL005B4
          CALL      RESTORFC
          JNC       READL005
          JMP       READL005E
READL005B4:
          CMP       CH,@LTRL            ;"..."
          JNE       READL005C
          CALL      RESTORFE
          JNC       READL005
          JMP       READL005E
READL005C:
          cmp       ch,'"'
          jne       readl005c1
readl005c2:
          mov       byte ptr [edx],ch
          xchg      edx,aux00
          inc       aux00
          cmp       dword ptr [a2],edx
          jb        readl007
          mov       ch,byte ptr [edx]
          xchg      edx,aux00
          inc       aux00
          dec       ax
          jz        readl005e
          cmp       ch,'"'
          je        readl005c3
          cmp       ch,0dh
          je        readl005e
          jmp       readl005c2
readl005c3:
          mov       byte ptr [edx],ch
          xchg      edx,aux00
          inc       aux00
          cmp       dword ptr [a2],edx
          jb        readl007
          mov       ch,byte ptr [edx]
          xchg      edx,aux00
          inc       aux00
          dec       ax
          jz        readl005e
          jmp       readl005

readl005c1:
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX00
          INC       AUX00
READL005D:
          CMP       DWORD PTR [A2],EDX
          JB        READL007
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00           ;COPY UP TO 255 BYTES INTO IOBUFFER
          INC       AUX00
          DEC       AX
          JNZ       READL005
READL005E:
          MOV       R0,0
          JMP       READL008

READL007: XCHG      EDX,AUX00           ;POINT AT IOBUFFER
READL008: TEST      R5,10H              ;SKIP IF LINPUT
          JNZ       READL010
READL009: MOV       BYTE PTR [EDX],0DH  ;WRITE A CR AT END OF IOBUFFER
READL010: TEST      R5,40H              ;SKIP IF WE CAME FROM LIST S
          JNZ       READLINB
          CALL      DISPSTAR            ;Display ':' or '?' to CRT.
READL033:

;*% CONSOLE INPUT/ INPUT  ENTRY POINT
READLINB:
          MOV       R3,0                ;NOT EDIT, NOT UNDERLINE, NOT LINPUT
          MOV       WORD PTR [R6],LRLEN ;MAX COUNT = 400 BYTES CURRENTLY
          MOV       EDX,IBUFBEG
          MOV       AUX0E,EDX           ;XE = BEGGINNING OF BUFFER
          MOV       EDX,IBUFEND
          MOV       AUX0C,EDX           ;XC = END OF BUFFER
          CALL      ENBLCNT             ;ENABLE CONTROL ADDRESS
          MOV       AL,R5
          AND       AL,0F0H
          CMP       AL,40H
          JE        READL223
;*%ISSUE LINE REQUEST
;--------- TSAI -----------
         CMP       CMDBUADR,0          ;
         JE        READ03              ;BR,IF MXD
READ02:
         CALL      RQSTLINM            ;line request for MXF
         JMP       READ06
READ03:
;--------- TSAII ------
          CALL      RQSTLINA            ;ENABLE CONTROL ADDRESS, SELECT CURRENT TERMINAL,

;*_SEND LINE REQUEST TO MXD
;*%END OF LINE REQUEST
;--------- TSAI -----------
READL220:
         CMP       CMDBUADR,0          ;
         JE        READ04              ;BR,IF MXD
READ06:
;        MOV       EBX,CMDBUADR
READ05:
;        CMP       GS:[EBX].cmd_sts,0FH
;        JE        READ05                     ;wait till cmd buf available
         CALL      WAITCMD
         MOV       GS:[EBX].cmd_cbs,?amENDLRT ;
         MOV       GS:[EBX].cmd_abs,06
         MOV       GS:[EBX].cmd_sts,0FH

;         CALL      WAITCMD
;         MOV       GS:[EBX].cmd_cbs,12H       ;
;         MOV       GS:[EBX].cmd_abs,06        ;ABS=06
RA04:
;         MOV       GS:[EBX].cmd_sts,0FH
;         CALL      WAITCMD
;         CMP       BYTE PTR GS:[EBX].cmd_parm,00H
;         JNE       RA04
         JMP       READL221
READ04:
;--------- TSAII -----
;READL220: MOV       AL,?amENDLRT
          MOV       AL,?amENDLRT
          CALL      CBSNT               ;SIGNAL END OF LINE REQUEST SEQUENCE

;*%BREAKPOINT -- UNTIL LINE REQUEST COMPLETE
READL221:
          CALL      BREAKPTD            ;BREAKPOINT (SAVE ALL REG'S)

;*%QUERY LINE REQUEST
;*  LINE REQUEST COMPLETE
;*     ADDRESS 06 HAS BEEN ENABLED BY BREAKPT LOGIC,
;*     CURRENT TERMINAL NUMBER HAS BEEN SELECTED
READL223: CALL      QUERYLR             ;GET LINE REQUEST TERMINATOR FROM MXD

READL230: TEST      R5,20H              ;SKIP IF INPUT/LINPUT MODE
          JNZ       READL24
          TEST      R2,20H              ;BRANCH IF HALT NOT ON
          JZ        READL24
;-------- TSAI -------
         CMP       CMDBUADR,0
         JE        READ07              ;BR,IF NOT MXE
         CALL      WAITCMD
         MOV       GS:[EBX].cmd_cbs,?amDELLR  ;flush line request of MXF
         MOV       GS:[EBX].cmd_abs,06
         MOV       GS:[EBX].cmd_sts,0FH
         JMP       STEP
READ07:
;-------- TSAII --------
READL231: MOV       AL,?amDELLR
          CALL      CBSNT               ;FLUSH LINE REQUEST
          JMP       STEP                ;BRANCH TO STEP IF HALT BIT IS ON (CI ONLY)

READL24:  TEST      R2,4                ;BRANCH IF TERMINATED BY ENDI (SF)
          JNZ       KEYFUNC
          MOV       EAX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EAX].@SPREG3,0
          CMP       R3,01
          JE        READL221            ;BRANCH IF LR NOT COMPLETE
          CMP       R3,0FFH
          JE        RECALL              ;BRANCH IF RECALL
          CMP       R3,0FEH
          JE        STMT_               ;BRANCH IF STMT# KEY
;*%ACCEPT LINE REQUEST DATA
READL25:  CALL      ACCEPTLR            ;ACCEPT LINE REQUEST COMMAND ==> MXD
          CALL      RECLINE             ;get line request data

;*%----------------- logic added rel 3.0 ----------------------------------------
;*        Must check for LR complete and wait for MXD done
;*
;*        Note, this corrects bug that caused $BREAK! not to work when executed
;*        to soon after beginning of program.  The MXD done notification would
;*        wake up the $BREAK!.
;*
READL251:
;--------- TSAI,02-10-92 ------
;          CMP      CMDBUADR,0
;          JE       READL252
;          MOV      K,01H
;--------- TSAI,03-25-92 --
          CMP       CMDBUADR,0
          JZ        READL252            ;BR,IF NOT MXF
;         MOV       K,01H
LINP2511:
          CALL      QUERYLR
          TEST      K,0FH
          JNZ       LINP2511
          JMP       READL40
;--------- TSAI,02-10-92 ------
READL252:
          TEST      K,0FH               ;branch if LR complete & MXD done
          JZ        READL40
          CALL      BREAKPTD            ;break until notified by MXD
          CALL      QUERYLR             ;get LR termination code
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
          JMP       READL252

;*%------------------------------------------------------------------------------
READL40:  MOV       TEXTEND,EDX         ;SAVE END OF BUFFER ADDRESS

;*% TERMINATOR CHARACTER (0D) RECEIVED
READL50:  MOV       BYTE PTR [EDX],0DH  ;WRITE CR TO TEXT AREA
          CALL      ENBLNLLD
          TEST      R5,20H              ;SKIP IF CONSOLE INPUT
          JNZ       NXTINPT             ;PROCESS INPUT DATA
          JMP       PROCST              ;PROCESS CONSOLE INPUT

;         TITLE     RQSTLINE
;*RQSTLINE: ENABLE MXD CONTROL ADDRESS, SELECT TERMINAL, SEND
;*          LINE REQUEST COMMAND.
;*
;*     ENTRY: F7,6 = FIELD LENGTH
;*            F3 = MODE
;*               ,BIT80 = 1 IFF UNDERLINE FIELD
;*               ,BIT40 = 1 TO INDICATE OS > 1.3
;*               ,BIT20 = 1 IFF LINPUT
;*               ,BIT04 = 1 IFF EDIT MODE
;*               ,BIT01 = 1 IFF FLUSH KEYSTROKES FROM SOFT BUFR
;*
;*     MODIFIED REGISTERS: K,PC'S,CHCL,F0
;*
RQSTLINE: CALL      ENBLCNT             ;ENABLE MXD CONTROL ADDRESS, SELECT TERMINL
RQSTLINA: MOV       AL,?amLR
          CALL      CBSNT               ;LINE REQUEST COMMAND
          MOV       AL,R7
          CALL      OBSNT               ;FIELD LENGTH
          MOV       AL,R6
          CALL      OBSNT
          MOV       AL,R3
          OR        AL,40H              ;40-BIT INDICATES OS > 1.3
          CALL      OBSNT               ;MODE
          MOV       AL,BYTE PTR CHARCNT
          MOV       BYTE PTR CHARCNT,0  ;ZERO COLUMN COUNT (FOR LR COMPLETION)
          JMP       OBSNT               ;CURRENT CRT COLUMN TO MXD

;--------- TSAI ------------------------------------
;         MXF version for RQSTLINE
;         ENTRY:
;              EBX:MXF command buffer adr of this terminal
;              R3,R6,R7 same as RQSTLINE definition
;---------------------------------------------------
RQSTLINN:
         CALL      ENBLCNT
RQSTLINM:
;        MOV       EBX,CMDBUADR           ;cmd buf adr of this MXF port
RQSTLN1:
;        CMP       GS:[EBX].cmd_sts,0FH
;        JE        RQSTLN1                ;wait till cmd buf available
         CALL      WAITCMD
         MOV       GS:[EBX].cmd_cbs,?amLR ;line request command
         MOV       GS:[EBX].cmd_abs,06

         MOV       GS:[EBX].cmd_parm,4      ;4 paramter
         MOV       AL,R7
         MOV       GS:[EBX].cmd_parm,AL     ;field length

         MOV       AL,R6
         MOV       GS:[EBX+1].cmd_parm,AL   ;field length

         MOV       AL,R3
         OR        AL,40H
         MOV       GS:[EBX+2].cmd_parm,AL

         MOV       AL,BYTE PTR CHARCNT
         MOV       BYTE PTR CHARCNT,0   ;ZERO COLUMN COUNT (FOR LR COMPLETION)
         MOV       GS:[EBX+3].cmd_parm,AL

         MOV       GS:[EBX].cmd_sts,0FH ;start command
         RET
;--------- TSAII ------
;*QUERYLR: GET LINE REQUEST TERMINATOR FROM MXD
;*
;*     RETURN:
;*          F3 = TERMINAL CHARACTER (00 = NOT TERMINATED)
;*                                  (FF = RECALL)
;*                                  (ELSE, TERMINATION CHAR.)
;*          F2 = TERMINAL STATUS (BIT 04 = 1 IFF TERMINATOR
;*               WITH ENDI -- IE, SF)
;*
;*     MODIFIED REGISTERS: K,F2,F3
;*
;--------- TSAI -------
QUERYLR:
          CMP       CMDBUADR,0
          JNE       QUERYLRM                ;BR,IF MXF
;--------- TSAII ------                     ;QUERY LINE REQUEST FOR MXF
;QUERYLR:
          MOV       AL,?amQUERYLR
          CALL      CBSNT                   ;QUERY LINE REQUEST COMMAND
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
          MOV       BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
M35_01:
          MOV       AL,BYTE PTR FS:[CPUST]
          TEST      AL,2                    ;CPB ON
          JZ        M35_01                  ;WAIT FOR TERMINATOR
          CALL      DELAY5
          MOV       AL,BYTE PTR FS:[CPUST]  ;DELAY FOR WAIT ENDI ON
          MOV       R2,AL                   ;SAVE TERMINATOR STATUS
          TEST      SH,20H
          JZ        M35_33
          OR        R2,20H
M35_33:
          MOV       AL,BYTE PTR FS:[IBGET]
          MOV       K,AL
          MOV       R3,AL                   ;F3 = TERMINATOR
          RET

;-------- TSAI ------
QUERYLRM:
;         MOV       EBX,CMDBUADR                ;cmd buffer adr of this MXF
QUERYLR3:
;         CMP       GS:[EBX].cmd_sts,0FH        ;port
;         JE        QUERYLR3                    ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amQUERYLR ;line request command
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH
QUERYLR1:
          CALL      WAITCMD                     ;07-31-92,tsai-----
;-------- Tsai,07-31-92 ----
          CMP       GS:[EBX].cmd_sts,0F0H       ;if return with value ?
;         JNE       QUERYLR1
          JE        QY1
          CALL      BREAKPTT
          JMP       QUERYLRM
QY1:
;-------- Tsai,07-31-92 ----
;         MOV       AL,FS:[CPUST]
;         MOV       R2,AL                       ;SAVE TERMINATOR STATUS
;         and       r2,0dfh
          mov       r2,0
          TEST      SH,20H
          JZ        QUERYLR2
          OR        R2,20H                      ;HALT ON
QUERYLR2:
          MOV       AX,WORD PTR GS:[EBX].cmd_parm  ;get return value
          MOV       K,AL
          MOV       R3,AL
          CMP       AH,01                          ;check if end with ENDI
          JNE       QUERYLR4
          OR        R2,04H                         ;indicate with ENDI
QUERYLR4:
          RET
;-------- TSAII --------
;         TITLE     ACCEPTLR
;*ACCEPTLR: ACCEPT LINE REQUEST COMMAND TO MXD
;*
;*     RETURN: NONE
;*
;-------- TSAI -----
ACCEPTLR:
          CMP       CMDBUADR,0
          JE        ACCEPT1             ;BR,IF MXD
          RET
ACCEPT1:
;-------- TSAII ----
;ACCEPTLR: MOV       AL,?amRECDATA      ;--TSAI
          MOV       AL,?amRECDATA
          JMP       CBSNT               ;RECEIVE DATA COMMAND

;         TITLE     RECLINE
;*RECLINE: RECEIVE LINE REQUEST DATA FROM MXD
;*
;*     ENTRY: MXD CONTROL ADDRESS ENABLED
;*          TERMINAL SELECTED
;*          LINE REQUEST COMPLETED & ACCEPTED
;*          AUXC = ADDRESS OF END OF BUFFER +1
;*          AUXE = CURRENT BUFFER ADDRESS
;*
;*     RETURN: PC'S POINT AFTER LAST BYTE PUT IN BUFFER
;*            K = TERMINATOR CHARACTER (ENDI)
;*     MODIFIED REGISTERS: PC'S,CH,CL,K,F7F6
;*
;-------- TSAI -----
RECLINE:
          CMP       CMDBUADR,0
          JNE       RECLINEM                ;BR,IF MXF
;-------- TSAII ----
;RECLINE:
          MOV       EBX,AUX0C     ;--TSAI    ;F7F6=END OF BUFFER ADDRESS+1=>
          mov       dword ptr [a6],ebx
          MOV       EDX,AUX0E               ;PC'S = CURRENT BUFFER ADDRESS
RECLINE1:
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
          MOV       BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
RECLINE1B:
          TEST      BYTE PTR FS:[CPUST],2
          JZ        RECLINE1B               ;SKIP IF CHARACTER RECEIVED
          call      delay5
          MOV       AL,BYTE PTR FS:[IBGET]
          MOV       K,AL
;*  CHARACTER RECEIVED FROM MXD
RECLINE2: TEST      BYTE PTR FS:[CPUST],04H ;SKIP IF ENDI BIT IS ON
          JNZ       RECLINE3
          CMP       EBX,EDX
          JB        RECLINE1                ;IGNORE IF BUFFER ALREADY FULL
          MOV       [EDX],AL                ;WRITE INTO BUFFER
          INC       EDX
          JMP       RECLINE1                ;LOOP BACK FOR ANOTHER CHARACTER
RECLINE3: MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
LINPR:    RET
;-------- TSAI ----------
RECLINEM:
;         MOV       EBX,CMDBUADR
RECLIN3:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        RECLIN3

          CALL      WAITCMD
          MOV       ESI,AUX0C               ;F7F6=END OF BUFFER ADDRESS+1=> EBX
          mov       dword ptr [a6],ESI
          MOV       EDX,AUX0E               ;PC'S = CURRENT BUFFER ADDRESS
          MOVZX     ECX,WORD PTR GS:[EBX].lrwre   ;line request buf len
          CMP       ECX,0
          JE        RECLIN2
RECLIN1:
          MOV       AL,BYTE PTR GS:[EBX].lr_buf
          CMP       ESI,EDX
          JB        RECLIN2                 ;BR,if user buffer full
          MOV       [EDX],AL
;         MOV       K,AL                    ;12-20-90
          INC       EDX
          INC       EBX
          LOOP      RECLIN1
RECLIN2:
;         MOV       EBX,CMDBUADR
ACCEPT2:                                        ;accept LR,notify MXF that LR
;         CMP       GS:[EBX].cmd_sts,0FH        ;buffer received complete
;         JE        ACCEPT2                     ;indicate LR complete
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amRECDATA;
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH
          MOV       K,00H                       ;12-20-90
          RET
;-------- TSAII ---------

;ITLE     KEYFUNC
;*     KEYFUNC: PROCESS A SPECIAL FUNCTION KEY COMMAND
;*
;*          SPECIAL FUNCTION KEYS HAVE 2 FORMS OF
;*          DEFINITION.  DEFININTION IS MADE BY THE
;*          CORRESPONDING DEFFN' STATEMENT:
;*
;*             (1) TEXT ENTRY DEFINITION
;*
;*                  DEFFN' integer literal [; literal ...]
;*
;*             (2) SPECIAL FUNCTION SUBROUTINE CALL
;*
;*                  DEFFN' integer [(variable [,var ...])]
;*
;*          ENTRY: BRANCH FROM 'READLINE' (CHAR INPUT)
;*                 K = SPECIAL FUNCTION CODE (BINARY)
;*                 F7F6 POINTS TO NEXT POSITION IN
;*                    INPUT BUFFER.
;*                 TEXTEND POINTS AT CURRENT END OF BUFFER
;*                    (AT THE CARRIAGE RETURN).
;*                 CONSOLE OUTPUT DEVICE ENABLED.
;*
;*          SUBROUTINE CALL:
;*
;*               IN A SPECIAL FUNCTION SUBROUTINE CALL
;*               FROM NORMAL CONSOLE INPUT, A SPECIAL SUB-
;*               ROUTINE ATOM (@SFKEY) IS PUT INTO OS.
;*               NOTHING IS PUT INTO THE VS (UNLIKE OTHER
;*               SUBROUTINE CALLS).  WHEN A RETURN STMT
;*               IS EXECUTED, CONTROL IS PASSED BACK TO
;*               CONSOLE INPUT ('ENTER' ROUTINE).
;*
;*               IN A SUBROUTINE CALL DURING 'INPUT' MODE,
;*               A @SFINPT ATOM IS PUT INTO OS; TEXTPTR TO
;*               AFTER 'INPUT' VERB, TEXTLPTR TO 'INPUT'
;*               LINE, AND STATEMENT COUNT OF 'INPUT' STMT
;*               IS PUT INTO THE VS.  WHEN A 'RETURN' STMT
;*               IS ENCOUNTERED, CONTROL IS PASSED BACK TO
;*               THE 'INPUT' STMT WHICH IS REPEATED FROM
;*               THE BEGINNING.
;*
;*
;*          MODIFIED REGISTERS (TEXT ENTRY DEFINITION):
;*               PC'S,CH,CL,K,F0-3,AUX0,1
;*               TEXTEND UPDATED
;*
;*%SF LOGIC
KEYFUNCL: CALL      SWITCH              ;SAVE TEXTPTRS
KEYFUNC:
          MOV       EAX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EAX].@SPREG3,1
          MOVZX     AX,R3               ;K = SF CODE
          MOV       KX,AX
          CALL      FINDDFA@            ;LOOK FOR CORRESPONDING DEFFN'
          AND       R3,08H              ;(F3 = 00 IF LOCAL, 08 IF GLOBAL)
          TEST      R0,0FH
          JNZ       READL49             ;NF, TREAT LIKE CARRIAGE RETURN
KEYFUNCA:
          CMP       BYTE PTR [TEXTPTR],0DH    ;LOOK FOR CR
          JE        READL42                   ;FIND, BRANCH
          CMP       BYTE PTR [TEXTPTR],0FDH   ;CHECK FOR STMT SEPARATOR
          JE        READL42                   ;FIND, BRANCH
          CMP       BYTE PTR [TEXTPTR],'('    ;CHECK FOR '('
          JNE       KEYFUNC5                  ;NOT FIND, BRANCH
          INC       TEXTPTR
          JMP       READL43                   ;FIND, BRANCH

;  TEXT ENTRY DEFINITION --------------------------------------

KEYFUNC5: MOV       CH,BYTE PTR [TEXTPTR]
          INC       TEXTPTR
          CMP       CH,@HEXLIT
          JE        KEYFUNCX
          CMP       CH,@LTRL
          JNE       KEYF41              ;SKIP IF NOT A LITERAL
;-------- TSAI -------
KEYFUNCX:
          CMP       CMDBUADR,0
          JE        KF1                         ;BR,if not MXF
;         MOV       EBX,CMDBUADR
KF2:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        KF2                         ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amREFILL  ;LR refill cmd
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,0 ;init refill count=0

          MOV       CH,BYTE PTR [TEXTPTR]
          INC       TEXTPTR
          MOV       R2,CH               ;F2= LENGTH OF LITERAL

KFUN4:    MOV       CH,BYTE PTR [TEXTPTR]
          INC       TEXTPTR             ;GET THE NEXT CHARACTER
          MOV       K,CH
          CMP       CH,0DH
          JE        KEYF412             ;EXIT IF CARRIAGE RETURN (HEX(0D)) IN LIT
          CALL      PUTCHAR             ;INSERT THE CHARACTER INTO THE BUFFER
          DEC       R2                  ;DECREMENT LITERAL COUNT
          JNZ       KFUN4               ;LOOP BACK FOR ENTIRE LITERAL

          CALL      WAITCMD
          MOV       GS:[EBX].cmd_sts,0FH ;start refill  command

          CMP       BYTE PTR [TEXTPTR],';'  ;LOOK FOR C';'
          JNE       KEYF41
          INC       TEXTPTR             ;BRANCH IF  ;  FOUND
          JMP       KEYFUNC5
 KF1:
;--------- TSAII -----
;KEYFUNCX: MOV       AL,?amREFILL         ;REFILL COMMAND
          MOV       AL,?amREFILL         ;REFILL COMMAND,--TSAI
          CALL      CBSNT
KF3:                ;---TSAI
          MOV       CH,BYTE PTR [TEXTPTR]
          INC       TEXTPTR
          MOV       R2,CH               ;F2= LENGTH OF LITERAL

KEYFUNC4: MOV       CH,BYTE PTR [TEXTPTR]
          INC       TEXTPTR             ;GET THE NEXT CHARACTER
          MOV       K,CH
          CMP       CH,0DH
          JE        KEYF411            ;EXIT IF CARRIAGE RETURN (HEX(0D)) IN LIT
          CALL      PUTCHAR             ;INSERT THE CHARACTER INTO THE BUFFER
          DEC       R2                  ;DECREMENT LITERAL COUNT
          JNZ       KEYFUNC4            ;LOOP BACK FOR ENTIRE LITERAL
          CMP       BYTE PTR [TEXTPTR],';'  ;LOOK FOR C';'
          JNE       KEYF41
          INC       TEXTPTR             ;BRANCH IF  ;  FOUND
          JMP       KEYFUNC5

KEYF41:   TEST      R5,10H              ;BRANCH IF CI/INPUT
          JZ        READL220
          CALL      SWITCH              ;POINT BACK TO LINPUT
          JMP       LINP22              ;LINPUT

;-------- TSAI -------
KEYF412:
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_sts,0FH ;start refill  command
KEYF411:
          CMP       CMDBUADR,0
          JE        KY1                         ;BR,if not MXF
;         MOV       EBX,CMDBUADR
KY2:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        KY2                         ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amTERMLR  ;terminate LR
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH       ;start this cmd
          JMP       KY3
KY1:
;--------- TSAII -----
;KEYF411:                               ;--TSAI
          MOV       AL,?amTERMLR
          CALL      CBSNT               ;TERMINATE LR
KY3:                ;---TSAI
          TEST      R5,10H              ;BRANCH IF CI/INPUT
          JZ        READL221
          CALL      SWITCH              ;POINT BACK TO LINPUT STMT
          JMP       LINP23              ;LINPUT

;  SUBROUTINE CALL --------------------------------------------

READL42:  AND       R5,0FEH             ;FLAG NO ARGUMENTS IN DEFFN
          JMP       M35_04

READL43:  OR        R5,01H              ;FLAG ARGUMENTS IN DEFFN
M35_04:   CALL      ACCEPTLR            ;F1,0 = DATA COUNT FROM MXD
          CALL      RECLINE             ;RECEIVE LR DATA
          TEST      R5,10H
          JZ        READL430            ;BRANCH IF NOT LINPUT
          CALL      BLNKVAR             ;BLANK OUT REMAINDER OF VARIABLE

;--------- TSAI,03-14-91 ------
          CMP       CMDBUADR,0
          JZ        READL431            ;BR,IF NOT MXF
;         MOV       K,0
RR1:                                    ;--- TSAI,06-24-90 -----
          CALL      QUERYLR
          TEST      K,0FH
          JNZ       RR1                 ;--- TSAI,06-24-90 -----
          JMP       READL435
;--------- TSAI,03-14-91 ------
READL431: TEST      K,0FH               ;branch if end of line request
          JZ        READL435
          CALL      BREAKPTD            ;wait until notified by MXD
          CALL      QUERYLR             ;get LR terminator code
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI off
          JMP       READL431

READL430: MOV       TEXTEND,EDX         ;SAVE END OF DATA ADDRESS
          MOV       BYTE PTR [EDX],0DH  ;WRITE A CARRIAGE RETURN AT END OF DATA (CI,INPUT)

READL435: AND       SL,0FFH-PHASE
          OR        SL,XPHASE           ;PHASE = EXECUTION
          CALL      SWITCH              ;POINT TO 'CURRENT' STATEMENT
          TEST      R5,20H              ;SKIP IF CONSOLE INPUT
          JZ        READL48
;*
;*   INPUT/LINPUT MODE

          AND       MODE,0DFFFH         ;TURN OFF INPUT MODE
          MOV       AL,R3
          OR        AL,@SUBR            ;GOSUB ATOM
          MOV       R0,AL
          TEST      R5,10H
          JNZ       READL65             ;SKIP IF LINPUT

;*    INPUT  MODE

;         CALL      POPRCVR             ;POP INPUT RECEIVER INFO FROM OS, VS
          MOV       EAX,OSPTR
          MOV       CH,BYTE PTR [EAX]
          DEC       OSPTR
          CMP       CH,@NUMREC
          JE        READLT1
          ADD       VSPTR,8             ;REMOVE ALPHA LENGTH AND RECEIVER ADDRESS
          JMP       READLT2
READLT1:
          ADD       VSPTR,4             ;REMOVE NUMERIC RECEIVER ADDRESS
READLT2:
          MOV       EDX,AUX0F
          MOV       TEXTPTR,EDX         ;POINT AFTER 'INPUT' VERB
          MOV       AL,R3
          OR        AL,@SFINPT          ;SPECIAL FUNCTION (INPUT MODE) ATOM
          MOV       R0,AL
          JMP       READL65

;*  CONSOLE INPUT MODE
READL48:  MOV       EDX,CONTLN_
          MOV       TEXTPTR,EDX         ;COPY CONTINUE LINE # INTO FAKE TEXTPTR
          MOV       AL,R3
          OR        AL,@SFKEY
          MOV       R0,AL               ;SPECIAL FUNCTION KEY ATOM (CONSOLE INPUT)

READL65:  MOV       EDX,OSPTR           ;PUSH THE   ATOM --> OS
          INC       EDX
          CMP       EDX,DWORD PTR [@@OSEND]
          JE        ERROR_04
          MOV       AL,R0
          MOV       BYTE PTR [EDX],AL
          MOV       OSPTR,EDX
;         CALL      PUSHNTXT            ;SAVE PTRS TO STATEMENT IN VS
          MOV       EDX,VSPTR
          MOV       EAX,STMTCNT
          MOV       DWORD PTR [EDX-4],EAX
          MOV       EAX,TEXTLPTR
          MOV       DWORD PTR [EDX-8],TEXTPTR
          MOV       DWORD PTR [EDX-12],EAX
          SUB       VSPTR,12
          CMP       EDX,DWORD PTR [@@VSEND]
          JB        ERROR_02
          MOV       AL,R3
          AND       AL,0FH
          CMP       AL,8
          JNE       READL66             ;BRANCH IF DEFFN IS LOCAL
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@XBASE
          MOV       ECX,DWORD PTR [EDX]    ;GET XBASE
          MOV       DWORD PTR [EDX+4],ECX  ;XBASE = IBASE

          mov       edx,vsptr           ;IBASE & (OLD) XBASE ==> VS
          sub       edx,8
          mov       dword ptr [edx],ecx
          mov       dword ptr [edx+4],ecx
          mov       vsptr,edx
          cmp       edx,dword ptr [@@vsend]
          jb        error_02

READL66:  CALL      SAVESTKS            ;SAVE STACK PTRS
          CALL      SWITCH              ;SET POINTERS BACK TO DEFFN'
          MOV       STMTCNT,0           ;ZERO THE STATEMENT COUNT (DEFFN' IS AT BEGIN)
          TEST      R5,1
          JNZ       READL70             ;BRANCH IF ARGUMENTS NEED TO BE PASSED
          MOV       EDX,TEXTENDS
          MOV       TEXTEND,EDX         ;FLUSH THE BUFFER
          JMP       ENDSTIO             ;BRANCH TO DEFFN' (NO ARGUMENTS)

;*  SPECIAL FUNCTION SUBROUTINE WITH ARGUMENT PASSING ---------
;*
READL70:
KEYFUNC8: MOV       EDX,TEXTPTR
          MOV       AUX0F,EDX           ;SAVE PTR TO FIRST VAR.

;*_(IN CASE OF ANOTHER SF KEY)
          AND       MODE,0FFFFFFFBH     ;DISABLE TRACE
          TEST      R5,10H
          JNZ       KEYF85              ;SKIP IF LINPUT
          OR        MODE,2000H          ;INPUT MODE ON
          CALL      AVARR               ;LOOK FOR ALPHA REC VAR
          TEST      R0,0FH
          JZ        M35_05              ;BRANCH IF ALPHA FOUND
          CALL      VARR                ;LOOK FOR NUMERIC RECEIVER
M35_05:
          CALL      SWITCH              ;SAVE PTR TO DEFFN'
          MOV       EDX,TEXTENDS
          MOV       TEXTPTR,EDX
          ADD       TEXTPTR,5
          MOV       TEXTLPTR,EDX
          INC       TEXTLPTR
          MOV       EDX,OFFSET INPUT1   ;RETURN ADDRESS FOR 'GETINPT2'
          MOV       AUX07,EDX
          JMP       GETINPT2

;*  SF WITH ARG PASSING FROM  LINPUT

KEYF85:   MOV       EDX,TEXTENDS
          MOV       TEXTEND,EDX         ;RESTORE TEXTEND TO THE REAL BUFFER
          JMP       INPUT6

;*%UNDEFINED SF (BEEP & IGNORE) -------------------------------
READL49:  TEST      R5,10H
          JZ        READL89             ;BRANCH IF CI/INPUT
          CALL      SWITCH              ;POINT BACK TO LINPUT
;         JMP       LINP38              ;LINPUT
          JMP       LINP38M             ;TSAI,---03/14/91------

;ITLE     LINPUT
;*     LINPUT: PROCESS A 'LINPUT' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               LINPUT [literal] [,] [-]alpha-var.
;*
;*          DESCRIPTION: THE 'LITERAL' FOLLOWED BY '*'
;*               IS OUTPUT TO THE CURRENTLY ENABLED
;*               DEVICE. Then the present value of the
;*               variable is displayed, including trailing
;*               blanks.  No buffer is set up, because the
;*               variable itself is used as a buffer.  If
;*               the - parameter is specified, then all
;*               characters from the variable and from
;*               the keyboard are echoed to the CRT with
;*               the 80 bit ORed on (to produce underline
;*               on an appropriate CRT).  The system is
;*               initially in the EDIT mode, but the
;*               operator may switch to CHARACTER ENTRY
;*               MODE by pressing SF 'F0, the EDIT key.
;*               This will remove the asterisk, and
;*               replace it with a blank.
;*
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'LINPUT'
;*               CONSOLE OUTPUT DEVICE ENABLED (EXEC PHASE
;*
;*          REGISTER USE: AUXA,B,F MUST NOT BE USED BY ANY
;*              ROUTINES CALLED BY LINPUT ('AVAR','ENTER')
;*
;*          AUXF = PTR TO AFTER 'LINPUT' VERB. SO THAT A
;*                 SPECIAL FUNCTION CALL DURING LINPUT
;*                 OPERATION CAN RETURN TO BEGIN OF LINPUT
;*                 STATEMENT.
;*
;*
;*          MODIFIED REG: ALL,AUX0-3
;*
;*_     EXECUTION, DISABLE TRACE, PROCESS CONSOLE MSG.
LINPUT:
          MOV       EAX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EAX].@SPREG3,0
          CALL      INPUTSUB            ;SAVE PTR TO LINPUT STMT, ERROR IF IMMEDIATE
          MOV       DH,08H
          CMP       BYTE PTR [TEXTPTR],'?'
          JNE       M35_90
          INC       TEXTPTR
          MOV       DH,0                ;DH = 00 IF FOUND, 08 IF NOT
M35_90:
          OR        DH,30H
          CMP       BYTE PTR [TEXTPTR],'-'
          JNE       M35_06
          INC       TEXTPTR
          OR        DH,40H              ;LINPUT WITH UNDERLINE OPTION
M35_06:
          MOV       AUX03,EDX           ;AUX 3 CONTAINS FLAG FOR ENTER

;*_  30 - NO UNDERLINE, CHARACTER ENTRY MODE
;*_  70 -    UNDERLINE, CHARACTER ENTRY MODE
;*_  38 - NO UNDERLINE, EDIT MODE
;*_  78 -    UNDERLINE, EDIT MODE
          CALL      AVARD               ;LOOK FOR ALPHA VARIABLE
          TEST      R0,0FH
          JNZ       ERR_29X             ;ERROR IF NOT FOUND
          TEST      SL,2
          JZ        ENDSTMT             ;BRANCH IF NOT EXECUTION PHASE

;*     EXECUTION PHASE
;*%THE FOLLOWING LOGIC IS NEW FOR MXD -------------------------
LINP10:   MOV       R4,0                ;F4 = 0
          MOV       R3,20H              ;LINPUT MODE
          MOV       EDX,AUX03
          TEST      DH,40H
          JZ        M35_07
          OR        R3,80H              ;IF UNDERLINE, SET MODE BIT
M35_07:
          TEST      DH,08H
          JZ        M35_08
          OR        R3,0CH              ;IF EDIT, SET MODE BIT
M35_08:
          mov       edx,vsptr           ;POP OUT ADDRESS AND LENGTH
          mov       eax,dword ptr [edx]
          mov       edx,dword ptr [edx+4]
          add       vsptr,8
          MOV       AUX0E,EDX           ;AUX E POINTS AT BEGINNING OF VARIABLE
          ADD       EDX,EAX
          MOV       AUX0C,EDX           ;AUX C POINTS AT END OF VARIABLE+1
          MOV       WORD PTR R6,AX      ;F7F6 = field length
          CMP       EAX,LRLEN           ;MAXIMUM LR FIELD LENGTH
          JA        ERROR_52            ;error if field too long

          CALL      ENBLCO              ;(MAY ALREADY BE ENABLED ??????****)
          CALL      TWRITESP            ;WRITE A SPACE AT BEGIN OF FIELD

;*%LINE REQUEST
;-------- TSAI --------
          CMP       CMDBUADR,0
          JE        LINP2               ;BR,if not MXF
          CALL      RQSTLINN
          MOV       EDX,AUX03
          MOV       R5,DH               ;F5 = LINPUT MODE FLAGS
;         MOV       EBX,CMDBUADR
LINP1:
;         CMP       GS:[EBX].cmd_sts,0FH ;EBX point to comm mem of the MXF port
;         JE        LINP1                     ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amPREFILL ;line prefill cmd
          MOV       GS:[EBX].cmd_abs,06

          MOV       EDX,AUX0C           ;end buffer adr.
          SUB       EDX,AUX0E           ;substract start buf adr
          MOV       GS:[EBX].lr_count,DX;LR buf count
          MOV       ECX,EDX             ;LOOP COUNT
          MOV       ESI,AUX0E           ;PC'S = BEGIN OF BUFFER ADDRESS
          LEA       EDI,[EBX].lr_buf    ;destination adr to be moved

          PUSH      ES                  ;temporary save ES
          PUSH      GS
          POP       ES
          REP       MOVSB
          POP       ES                  ;restore ES
          MOV       GS:[EBX].cmd_sts,0FH       ;start this cmd
          JMP       LIP2                       ;breakpoint
LINP2:
;--------- TSAII-------
          CALL      RQSTLINE            ;ENABLE CONTROL ADDRESS, SELECT CURRENT TERMINAL,

;*_SEND LINE REQUEST TO MXD
          MOV       EDX,AUX03
          MOV       R5,DH               ;F5 = LINPUT MODE FLAGS

;*%PREFILL
;BP?987   EQU       *         LINPUT SHOULD DO CURLEN -- DON'T SEND TRAILING
;*_SPACES. OK, FOR NOW, SINCE MXD DOEN'T ERASE REMAINDER OF FIELD

LINP19:   MOV       AL,?amPREFILL
LINP190:  CALL      CBSNT               ;PREFILL COMMAND
          MOV       EDX,AUX0C
          MOV       EBX,EDX             ;EBX = END OF BUFFER ADDRESS
          MOV       EDX,AUX0E           ;PC'S = BEGIN OF BUFFER ADDRESS

LINP20:   MOV       AL,[EDX]
          INC       EDX
          CALL      OBSNT               ;STROBE OUT ONE CHARACTER
          CMP       EDX,EBX
          JNE       LINP20              ;LOOP TILL ALL BUFFER IS SENT

;*  NOTE:  IF ADDRESS 5 IS USED INSTEAD OF 6, AND IF
;*    A CBS IS USED TO END EACH COMMAND, THEN TIMEOUT
;*    COULD BE ALLOWED IN THIS COMMAND
;*  NOTE:  MUST CHECK DATA FOR 0D, FF,  BECAUSE PRESENT
;*    MXD DESIGN TERMINATES ON CARRIAGE RETURN
;*%END OF LINE REQUEST

;-------- TSAI -------
LINP22:
          CMP       CMDBUADR,0
          JE        LIP1                        ;BR,if not MXF
;         MOV       EBX,CMDBUADR
LIP2:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        LIP2                        ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amENDLRT  ;end of line request sequence
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH        ;start this cmd

;         CALL      WAITCMD
;         MOV       GS:[EBX].cmd_cbs,12H       ;
;         MOV       GS:[EBX].cmd_abs,06        ;ABS=06
LIP3:
;         MOV       GS:[EBX].cmd_sts,0FH
;         CALL      WAITCMD
;         CMP       BYTE PTR GS:[EBX].cmd_parm,00H
;         JNE       LIP3
          JMP       LINP23
LIP1:
;--------- TSAII -----
;LINP22:
          MOV       AL,?amENDLRT
LINP225:  CALL      CBSNT               ;INDICATE END OF LINE REQUEST SEQUENCE

;*%BREAKPOINT
LINP23:   MOV       DX,WORD PTR R4
          MOV       AUX0D,EDX           ;SAVE F5F4, FLAGS
          MOV       R0,SAV0C            ;SAVE AUXES 0C-1F

;*_(NOTE ONLY AUXES 0C-1F MATTER HERE, ALTHO
;*_ SAVEREGS MAY SAVE MORE)
          MOV       R1,PSTATLR          ;RETURN WHEN LINE REQUEST COMPLETED
          CALL      BREAKPTI

;*%QUERY LINE REQUEST
;*  LINE REQUEST COMPLETE
;*     ADDRESS 06 HAS BEEN ENABLED BY BREAKPT LOGIC,
;*     CURRENT TERMINAL NUMBER HAS BEEN SELECTED

          MOV       EDX,AUX0D
          MOV       WORD PTR R4,DX      ;F5F4= FLAGS
          CALL      QUERYLR             ;GET LINE REQUEST TERMINATOR
          TEST      R2,4
          JNZ       KEYFUNCL            ;BRANCH IF ENDI (SF) ON
          CMP       R3,01H
          JNE       L23
          JMP       LINP23
;         JE        LINP23              ;BRANCH IF LR NOT TERMINATED
L23:
          CMP       R3,0FFH
          JE        LINP37              ;BRANCH IF RECALL
          CMP       R3,0FEH
;         JE        LINP38              ;IGNORE STMT# KEY
          JE        LINP38M             ;TSAI,---03/14/91-----
;*%ACCEPT LINE REQUEST
LINP27:   CALL      ACCEPTLR            ;GET DATA COUNT FROM MXD
          CALL      RECLINE             ;GET LINE REQUEST DATA

;*%END OF DATA
LINP36:
          CALL      BLNKVAR             ;BLANK OUT REST OF VARIABLE
;--------- TSAI,12-20-90 ------
          CMP       CMDBUADR,0
          JZ        LINP365             ;BR,IF NOT MXF
;         MOV       K,01H
LINP369:
          CALL      QUERYLR
          TEST      K,0FH
          JNZ       LINP369
          JMP       LINP367
;--------- TSAI,12-20-90 ------
LINP365:
          TEST      K,0FH
          JZ        LINP367             ;BRANCH IF LR COMPLETE AND MXD DONE
          MOV       R0,SAV10
          MOV       R1,PSTATLR
          CALL      BREAKPTI            ;BREAK UNTIL NOTIFIED BY MXD
          CALL      QUERYLR             ;GET LR TERMINATOR CODE
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
;         JMP       LINP365             ;TRY AGAIN
LINP367:
          JMP       ENDSTIO             ;BRANCH IF TERMINATED BY CR

;*%RECALL
;--------- TSAI ------
LINP37:
          CMP       CMDBUADR,0
          JNE       LINP1                   ;BR,if MXF
;--------- TSAII ------
;LINP37:
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
          MOV       BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
          TEST      BYTE PTR FS:[CPUST],2
          JZ        LINP37                  ;WAIT FOR CHARACTER FROM MXD
          call      delay5
          TEST      BYTE PTR FS:[CPUST],4
          JZ        LINP38                  ;BRANCH IF NOT BEGIN OF BUFFER (ENDI ON)
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
          MOV       AL,?amPREFILL           ;REFILL COMMAND
          JMP       LINP190                 ;SEND VARIABLE TO VALUE TO MXD AGAIN, CONTINUE LR
;-------- TSAI ------
LINP38M:
          CMP       CMDBUADR,0                  ;TSAI,--03/14/91----
          JE        LINP38                      ;br,if not MXF
;         MOV       EBX,CMDBUADR
LINP38M1:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        LINP38M1                    ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amCONTLR  ;continue LR cmd
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH        ;start this cmd
          JMP       LINP23
;--------- TSAII -----
LINP38:   MOV       AL,?amCONTLR            ;BEEP, ILLEGAL RECALL (NOT BEGIN OF BUFFER
          JMP       LINP225                 ;CONTINUE LR (IGNORE RECALL)

;         TITLE     SUBROUTINES
;*  BLNKVAR:  BLANK OUT REMAINDER OF VARIABLE
BLNKVAR:
BLNKVAR2: CMP       DWORD PTR [A6],EDX
          JBE       LINPR               ;EXIT IF BEYOND END OF VARIABLE
          MOV       BYTE PTR [EDX],20H
          INC       EDX                 ;BLANK OUT THE BYTE
          JMP       BLNKVAR2            ;LOOP TILL END OF VARIABLE

;ITLE     KEYIN
;*  2236 MXD CONVENTIONS:
;*
;*   THERE ARE 3 FORMS OF KEYIN.  THE FIRST, OR POLLING
;*   FORM, IS THE ONLY ONE SUPPORTED ON THE 2200T
;*   (KEYIN  A$, 100,200).  THE SECOND AND THIRD, LINE
;*   REQUEST FORMS, ARE ONLY SUPPORTED ON THE VP AND MVP.
;*   (KEYIN A$,,100      KEYIN  A$).
;*
;*
;*   FOR THE POLLING FORM,
;*       AT CONTROL ADDRESS OF MXD,
;*       WR  CBS  05
;*       CPB  IBS   XX,   WHERE IF XX IS 00, THERE WAS
;*       NO KEY IN THE SOFT BUFFER AND THE SEQUENCE IS DONE.
;*       IF XX IS NONZERO,  THERE WAS A KEY IN THE SOFT BUFFER,
;*       AND  CPB IBS   IS USED TO GET IT.
;*
;*   FOR THE LINE REQUEST FORM,
;*       AT CONTROL ADDRESS OF MXD,
;*       WR  CBS  06
;*       CPB  IBS   XX,   WHERE IF XX IS 00, THERE WAS
;*       NO KEY IN THE SOFT BUFFER, SO A KEYIN LINE REQUEST
;*       IS SET UP BY MXD.   IF XX IS NONZERO, THERE WAS A
;*       KEY IN THE SOFT BUFFER, AND   CPB IBS  IS USED TO
;*       GET IT. (NO LINE REQUEST IS THEN SET UP)
;*       IF THE LINE REQUEST IS SET UP, THEN THE COMPLETION
;*       IS SIGNALLED BY A READY AT 02 ADDRESS, WITH THE
;*       LINE REQUEST STATUS BIT ON FOR THE PARTICULAR
;*       TERMINAL.  THEN, THE SEQUENCE IS REPEATED.
;*
;*     KEYIN: PROCESS A KEYIN STATEMENT
;*
;*       FORMAT: KEYIN [/xyy,] alpha-var [,[line#],line#]
;*                      #n,
;*
;*          ENTRY: TEXTPTR POINTS TO CURRENT TEXT CHARACTR
;*                 TEXTLPTR POINTS TO CURRENT TEXT LINE
;*
;*
KEYIN:                                  ;GET DEFAULT INPUT ADDRESS
          MOV       EDX,DWORD PTR [CPBASE]
          MOV       BYTE PTR [EDX].@SPREG3,0
          LEA       EDX,[EDX].@DEVINPT
          MOV       CX,WORD PTR [EDX]
          XCHG      CH,CL
          TEST      SL,2
          JZ        KEYIN20             ;BRANCH IF NOT X PHASE
          MOV       DX,CX
          MOV       ACTDEV,EDX          ;SAVE DEFAULT INPUT ADDRESS

KEYIN20:  CALL      DEVSPEC             ;LOOK FOR #N OR /XYY
          TEST      R1,0F0H
          JNZ       KEYIN22             ;NF,  BRANCH
          TEST      SL,2
          JZ        KEYIN21             ;BRANCH IF NOT X PHASE
          MOV       DX,WORD PTR R0
          MOV       ACTDEV,EDX          ;ACTDEV = DEVICE SPEC

KEYIN21:
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR

KEYIN22:  CALL      AVARD               ;SCAN & PROCESS ALPHA-VARIABLE
          TEST      R0,0FH
          JNZ       ERR_29X             ;ERROR IF NOT FOUND
          TEST      SL,2
          JNZ       KEYIN1              ;BRANCH IF EXECUTION PHASE

;*     ENTRY, RESOLUTION PHASES
;*
DA??4:                                  ;TIMEOUT AFTER 1MS IF NO INPUT ???????????????????
          CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR COMMA
          JNE       KEYIN4              ;BRANCH IF COMMA NOT FOUND
          INC       TEXTPTR
          CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR 2ND COMMA
          JNE       DA??5
          INC       TEXTPTR
          JMP       KEYIN5              ;F, BRANCH
DA??5:
          CALL      TRLINE_             ;LOOK FOR 1ST LINE NUMBER REFERENCE
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR
KEYIN5:   CALL      TRLINE_A            ;LOOK FOR 2ND LINE NUMBER REFERENCE
KEYIN4:   JMP       ENDSTMT             ;EXIT

;*     EXECUTION PHASE
;*
KEYIN1:   MOV       R7,2

          CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR 1ST COMMA
          JNE       M35_11              ;BRANCH IF NOT FOUND
          INC       TEXTPTR
          MOV       AL,1
          CMP       BYTE PTR [TEXTPTR],',' ;LOOK FOR 2ND COMMA
          JNE       KEYIN1X
          INC       TEXTPTR
          MOV       AL,0
KEYIN1X:
          MOV       R7,AL

;*     FORM FLAG (F7) = 0 IF 'KEYIN A$,,200'
;*                      1 IF 'KEYIN A$,100,200'
;*                      2 IF 'KEYIN A$'
M35_11:
          mov       edx,vsptr           ;PC'S = ADDRESS OF ALPHA-VARIABLE; REMOVE OS ATOM
          mov       eax,dword ptr [edx]
          mov       dword ptr [a0],eax
          mov       edx,dword ptr [edx+4]
          add       vsptr,8
          MOV       AUX0E,EDX           ;SAVE ADDRESS OF ALPHA VARIABLE
          MOV       EDX,ACTDEV
          MOV       R0,DL
          AND       R0,38H
          CMP       R0,0
          JNE       KEYIN13             ;BRANCH IF NOT MXD ADDRESS
          MOV       AL,DL
          AND       AL,0FH
          CMP       AL,01H
          JE        KEYIN11             ;BRANCH IF MXD ADDRESS 01
          JMP       ERROR_48            ;ERROR IF SOME OTHER MXD ADDRESS

;*%NON-MXD  FORM OF KEYIN
KEYIN13:  CALL      ENBLDEVI
          TEST      BYTE PTR FS:[CPUST],8
          JNZ       KEYIN14             ;SKIP IF CHARACTER READY
          CMP       R7,1
          JE        KEYIN7              ;BRANCH IF TYPE 1 KEYIN

;*      NON-MXD BREAKPOINT
          MOV       DX,WORD PTR R6
          MOV       AUX0D,EDX           ;SAVE FLAG IN F7
          MOV       R0,SAV0C            ;SAVE AUXES 0C-1F
          CALL      BREAKPTJ            ;BREAK
          MOV       EDX,AUX0D
          MOV       WORD PTR R6,DX      ;RESTORE FLAG IN F7

KEYIN14:  CALL      WAITIBSE            ;WAIT UP TO 1MS FOR CHARACTER
          JMP       KEYIN3              ;TAKE IN THE CHARACTER

;*%BREAK UNTIL CHARACTER READY FOR INPUT
KEYIN15:
          MOV       DX,WORD PTR R6
          MOV       AUX0D,EDX           ;SAVE F7F6
          MOV       R0,SAV0C            ;SAVE AUXES 0C-1F (C,E,F NOT USED PRESENTLY)
          MOV       R1,PSTATLR          ;RETURN WHEN LINE REQUEST COMPLETED
          CALL      BREAKPTI            ;BREAK

;*     CHARACTER READY FOR INPUT
          MOV       EDX,AUX0D
          MOV       WORD PTR R6,DX      ;RESTORE F7 FLAG

;*%KEYIN REQUEST TO MXD
KEYIN11:  CMP       R7,1
          JNE       KEYIN23             ;BRANCH IF NOT T-KEYIN
          MOV       EDX,0
          MOV       DL,PART_
          ADD       EDX,OFFSET PTERM
          TEST      BYTE PTR [EDX],20H  ;PTERMD = 20H
          JNZ       KEYIN7              ;BRANCH IF TERMINAL NOT ATTACHED
KEYIN23:  CALL      ENBLCNT             ;ENABLE CONTROL ADDRESS, SELECT TERMINAL
;-------- TSAI -------
          CMP       CMDBUADR,0
          JE        KEYIN24                     ;BR,if not MXF
KYY2:
          MOV       EBX,CMDBUADR
KYN1:
          CMP       GS:[EBX].cmd_sts,0FH
          JE        KYN1                        ;wat till cmd buf available
;         CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amKEYINVP
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH ;start command
KYN3:
          CALL      WAITCMD
          CMP       GS:[EBX].cmd_sts,0F0H   ;
          JE        KYN4                    ;BR,if any char in KB buffer
;--------- tsai,07-31-92 ----
          CMP       GS:[EBX].cmd_sts,0F1H   ;if nothing in KB buffer
;         JNE       KYN3                    ;MXF cmd not complete
          JE        KYY1
          CALL      BREAKPTT
          JMP       KYY2
KYY1:
;--------- tsai,07-31-92 ----
          CMP       R7,1                    ;
;         JE        KEYIN7                  ;BR,if check KB buffer only
          JE        KYN5
          JMP       KEYIN15                 ;wait til any char in KB buf
KYN5:
          AND       BYTE PTR GS:[EBX+15A1H],0FBH;intbyte in MXF
          JMP       KEYIN7                  ;no more keyin mode
                                            ;--TSAI,03-05-92
KYN4:
;         AND       BYTE PTR GS:[EBX+15A1H],0FBH;intbyte in MXF
                                            ;--TSAI,03-05-92
          MOV       AL,BYTE PTR GS:[EBX].cmd_parm  ;get the char
          INC       EDX
          MOV       K,AL

          MOV       EDX,AUX0E
          MOV       AL,K
          MOV       [EDX],AL            ;PUT CHARACTER IN ALPHA-VAR.
          CALL      ENBLNULL            ;DISABLE KEYIN DEVICE (IE, ENABLE NULL)
          MOV       EBX,CMDBUADR
          MOV       AL,BYTE PTR GS:[EBX+1].cmd_parm  ;get ENDI flag
          CMP       AL,01               ;with ENDI ?
          JNE       KEYIN8              ;br,if not with ENDI
          JMP       KYN8
;--------- TSAII -----

;*%MVP REL 1.9 CHANGE
;*T-KEYIN changed to do VP-KEYIN request to MXD.  When a key is
;*pressed, MXD will set LR complete in status.  MXDSTAT routine
;*changed to set I/O completion if LR complete occurs during
;*a program breakpoint.  The effect is to give T-KEYIN better
;*response time.  The priority given away by automatic $BREAK
;*if no character at execution time of T-KEYIN is restored by
;*the above I/O completion.
;*
;*The following instructions were deleted:
;*
;*         MVI       &KEYINT,K               TYPE 1
;*         BEQL      1,F7,*+2
KEYIN24:            ;---TSAI
          MOV       AL,?amKEYINVP       ;TYPE 0,2
          CALL      CBSNT               ;05 OR 06 = KEYIN REQUEST
          MOV       BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
M35_13:
          TEST      BYTE PTR FS:[CPUST],2
          JZ        M35_13              ;WAIT FOR STROBE
          call      delay5
          MOV       AL,BYTE PTR FS:[IBGET]
          INC       EDX
          CMP       AL,0
          JNE       KEYIN6              ;BRANCH IF CHARACTER READY TO BE INPUT
          CMP       R7,1
          JNE       KEYIN15             ;BRANCH IF LINE REQUEST FORM

KEYIN7:   CALL      BREAKPTR            ;BREAKPOINT IF T-KEYIN & NO CHARACTER
          JMP       REMNULL             ;SKIP TO END OF STMT, DISABLE KEYIN DEVICE

;*%RECEIVE KEYIN CHARACTER
KEYIN6:
          MOV       AX,WORD PTR FS:[CPUST]  ;ENDI OFF
          MOV       BYTE PTR FS:[CPURDY],AL ;ALLOW INPUT
KEYIN6A:
          TEST      BYTE PTR FS:[CPUST],2
          JZ        KEYIN6A                 ;WAIT FOR CHARACTER TO BE INPUT
          call      delay5
          MOV       AL,BYTE PTR FS:[IBGET]
          MOV       K,AL

;* ************************************************************
;*     NOTE-   SHOULD HAVE TIMEOUT, AT LEAST FOR NON-MXD
;*       TO AVOID HANGING UP THE SYSTEM IF A DEVICE SAYS IT
;*       HAS A CHARACTER AND DOESN'T.  SHOULD GIVE ERROR WHEN
;*       TIMEOUT.
;* ************************************************************

KEYIN3:   MOV       EDX,AUX0E
          MOV       AL,K
          MOV       [EDX],AL            ;PUT CHARACTER IN ALPHA-VAR.
          CALL      ENBLNULL            ;DISABLE KEYIN DEVICE (IE, ENABLE NULL)
          TEST      WORD PTR FS:[CPUST],4
          JZ        KEYIN8              ;BRANCH IF CHARACTER REC'D NOT SPECIAL FUNC.
KYN8:               ;--- TSAI
          CMP       R7,0
          JE        KEYIN2              ;BRANCH IF FORM = 'KEYIN A$,,200'
          CMP       R7,2
          JE        KEYIN4              ;BRANCH IF FORM = 'KEYIN A$'
          CALL      TRLINE_A            ;SCAN 1ST LINE NO. REFERENCE
          CMP       BYTE PTR [TEXTPTR],','
          JNE       ERROR_13            ;BRANCH IF NOT MATCH
          INC       TEXTPTR

KEYIN2:   JMP       GOTO                ;EXIT
KEYIN8:   CMP       R7,2
          JE        KEYIN4              ;BRANCH IF FORM = 'KEYIN A$'
          CMP       R7,1
          JE        KEYIN2              ;BRANCH IF FORM = 'KEYIN A$,100,200'
          JMP       REMNULL             ;DISABLE KEYIN DEVICE (IE, ENABLE NULL)

;*_SKIP TO END OF STMT
;BP?76    EQU       *
;*KEYIN-T COULD ISSUE LINE-REQUEST TO MXD & POLL FOR COMPLETION
;*IF RE-EXECUTED.
ERR_29X:  JMP       ERROR_29            ;****** TEMPORARY ON PAGE SYMBOL  ******

FLAG7E    DB        0                   ; 0 -- NOT DOING EDIT RECALL
                                        ; 1 -- DOING EDIT RECALL

;TITLE       RECALL
;*RECALL:  EDIT RECALL LOGIC  (PART OF READLINE)
;*
RECALL:   MOV       FLAG7E,1
          TEST      R5,20H
          JZ        READL85             ;BRANCH IF CI MODE
;-------- TSAI --------
          CMP       CMDBUADR,0          ;BR,if not MXF
          JE        RECALL3
RECALL5:
;         MOV       EBX,CMDBUADR
RECALL4:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        RECALL4                     ;wat till cmd buf available
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amREFILL  ;LR refill cmd
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,0 ;init parm count=0

          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR  ;REPOINT TO I/O BUFFER
          MOV       AUX00,EDX

          CALL      PUTLINF             ;SEND LINE WITHOUT LINE # TO MXD
          MOV       FLAG7E,0

          MOV       EBX,CMDBUADR
          MOV       GS:[EBX].cmd_sts,0FH       ;start this cmd
          JMP       READL220            ;BRANCH TO END LR
RECALL3:
;--------- TSAII -----
          MOV       AX,WORD PTR FS:[CPUST]      ;ENDI OFF
          MOV       BYTE PTR FS:[CPURDY],0      ;ALLOW INPUT
M35_14:
          TEST      BYTE PTR FS:[CPUST],2
          JZ        M35_14                      ;WAIT FOR CHARACTER FROM MXD
          call      delay5
          TEST      BYTE PTR FS:[CPUST],4
          JZ        READL89                     ;BRANCH IF NOT BEGIN OF BUFFER (ENDI)
          MOV       AX,WORD PTR FS:[CPUST]      ;ENDI OFF

;*%INPUT RECALL
RECALL1:
;-------- TSAI -----
          CMP       CMDBUADR,0
          JNE       RECALL5             ;BR,IF MXF
;-------- TSAII ----
          MOV       AL,?amREFILL
          CALL      CBSNT               ;REFILL COMMAND TO MXD
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@IOBUFFR  ;REPOINT TO I/O BUFFER
          MOV       AUX00,EDX
          JMP       READL863            ;RECALL DATA FROM I/O BUFFER

;*%CI RECALL -- TEXT LINE
;*     GET LINE NUMBER.
;*          CHARACTERS IN MXD BUFFER SENT IN REVERSE ORDER FROM
;*          CURRENT POSITION (THIS SHOULD BE THE LINE NUMBER
;*          BACKWARDS).
;*
;*          ENDI INDICATES BEGIN OF BUFFER.
;*
READL85:  MOV       WORD PTR R2,0       ;F3F2 = 0000
          MOV       DX,0                ;--- TSAI,02-28-92 ---
          MOV       R4,39H              ;FLAG = LOOKING FOR DIGIT
          CALL      RCLLDGT             ;GET DIGIT FROM MXD (LAST)
          CMP       R4,0
          JE        RECALL1             ;BRANCH IF BEG. OF BUF. (RECALL FROM I/O BUFR)
          TEST      R4,0F0H
          JZ        READL899            ;IGNORE RECALL IF NON-DIGIT FOUND
          MOV       AL,K
          AND       AL,0FH
          MOV       R2,AL               ;DIGIT ==> F3F2
          INC       DX                  ;--- TSAI,02-28-92 ---

          CALL      RCLLDGT             ;GET DIGIT (2ND FROM LAST)
          TEST      R4,0F0H
          JZ        READL86             ;BRANCH IF NOT DIGIT
          MOV       AH,K
          MOV       AL,R2
          SHL       AH,4
          AND       AL,0FH
          OR        AH,AL
          MOV       R2,AH               ;DIGIT ==> F3F2
          INC       DX                  ;--- TSAI,02-28-92 ---

          CALL      RCLLDGT             ;GET DIGIT (3RD FROM LAST)
          TEST      R4,0F0H
          JZ        READL86             ;BRANCH IF NOT DIGIT
          MOV       AL,K
          AND       AL,0FH
          MOV       R3,AL               ;DIGIT ==> F3F2
          INC       DX                  ;--- TSAI,02-28-92 ---

          CALL      RCLLDGT             ;GET DIGIT (4TH FROM LAST)
          TEST      R4,0F0H
          JZ        READL86             ;BRANCH IF NOT DIGIT
          MOV       AH,K
          MOV       AL,R3
          SHL       AH,4
          AND       AL,0FH
          OR        AH,AL
          MOV       R3,AH       ;DIGIT ==> F3F2
          INC       DX                  ;--- TSAI,02-28-92 ---

;*     IGNORE LEADING ZEROES
;*
M35_15:
          CALL      RCLLDGT             ;GET DIGIT
          TEST      R4,0F0H
          JZ        READL86             ;BRANCH IF NOT DIGIT
          TEST      K,0FH
          JZ        M35_15              ;IGNORE LEADING ZERO

;*     CHECK TERMINATOR
;*
READL86:  CMP       R4,0
          JE        READL861            ;BRANCH IF BEGIN OF BUFFER
          CMP       K,3AH
          JNE       READL899            ;BRANCH IF NOT 'COLON' (IGNORE RECALL)
;*     FIND LINE TO RECALL              ;------- TSAI,02-28-92 ----
;*
READL861: TEST      MODE,40H
          JNZ       READL899            ;BRANCH IF PROGRAM PROTECTED,-02-28-92
          MOV       BX,DX               ;FINDST use EDX as output--02-28-92
          CALL      FINDST              ;FIND LINE
          CMP       R0,0
;         JNE       READL89             ;NF, IGNORE RECALL
          JE        RD86                ;------- TSAI,02-28-92 ----
          MOV       DX,BX               ;------- TSAI,02-28-92 ----
          INC       DX
;------- TSAI,02-28-92 ----
READL899:
          CMP       CMDBUADR,0
          JE        RD89
          MOV       EBX,CMDBUADR
          INC       DX
          ADD       GS:[EBX].lrwre,DX
          JMP       READL89
;------- TSAI,02-28-92 ----

;*     RECALL LINE
;*
;-------- TSAI -------
RD86:
          CMP       CMDBUADR,0
          JE        RD861                       ;BR,if MXD
;         MOV       EBX,CMDBUADR
          CALL      WAITCMD
          MOV       CX,GS:[EBX].lrwre   ;get LR buffer count
          MOV       GS:[EBX].lradd,CX   ;adjust cursour position
;RD862:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        RD862                       ;wat till cmd buf available
          MOV       GS:[EBX].cmd_cbs,?amREFILL  ;LR refill cmd
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,0

          MOV       AUX00,EDX           ;POINT PAST THREAD OF LINE
          ADD       AUX00,4
          CMP       R4,0
          JNE       RL862               ;BRANCH IF NOT BEGIN OF BUFFER
          CALL      PUTLINE             ;SEND LINE TO MXD
          MOV       FLAG7E,0
          JMP       RL864               ;BRANCH TO END LR

RL862:
          CALL      WAITCMD
          MOV       AL,':'
          MOVZX     EDX,BYTE PTR GS:[EBX].cmd_parm
          MOV       GS:[EBX+EDX+1].cmd_parm,AL
          INC       BYTE PTR GS:[EBX].cmd_parm

          MOV       EDX,AUX00
          MOV       AUX00,EDX           ;POINT AFTER LINE #
          ADD       AUX00,2

RL863:    CALL      PUTLINF             ;SEND LINE WITHOUT LINE # TO MXD
          MOV       FLAG7E,0
RL864:
;         MOV       EBX,CMDBUADR
          CALL      WAITCMD
;         MOV       CX,GS:[EBX].lrwre   ;get LR buffer count
;         MOV       GS:[EBX].lradd,CX   ;adjust cursour position
          MOV       GS:[EBX].cmd_sts,0FH;start LR refill command
          JMP       READL220            ;BRANCH TO END LR
RD861:
;--------- TSAII -----
          MOV       AL,?amREFILL
          CALL      CBSNT               ;REFILL COMMAND TO MXD
RD863:              ;---TSAI
          MOV       AUX00,EDX           ;POINT PAST THREAD OF LINE
          ADD       AUX00,4
          CMP       R4,0
          JNE       READL862            ;BRANCH IF NOT BEGIN OF BUFFER
          CALL      PUTLINE             ;SEND LINE TO MXD
          MOV       FLAG7E,0
          JMP       READL220            ;BRANCH TO END LR

READL862: MOV       AL,':'
          CALL      OBSNT               ;OUTPUT COLON
          MOV       EDX,AUX00
          MOV       AUX00,EDX           ;POINT AFTER LINE #
          ADD       AUX00,2

READL863: CALL      PUTLINF             ;SEND LINE WITHOUT LINE # TO MXD
          MOV       FLAG7E,0
          JMP       READL220            ;BRANCH TO END LR

;*     IGNORE RECALL
;*
;-------- TSAI ------
READL89:
          CMP       CMDBUADR,0
          JE        RD89                ;BR,IF MXD
;         MOV       EBX,CMDBUADR
          CALL      WAITCMD
;RD891:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        RD891                       ;wat till cmd buf available
          MOV       GS:[EBX].cmd_cbs,?amCONTLR  ;end line request cmd
          MOV       GS:[EBX].cmd_abs,06
          MOV       GS:[EBX].cmd_sts,0FH       ;start this cmd
          JMP       RD892
RD89:
;--------- TSAII -----
;READL89:
          MOV       AL,?amCONTLR
          CALL      CBSNT               ;BEEP, ILLEGAL RECALL, CONTINUE LR
RD892:
          MOV       FLAG7E,0
          JMP       READL221

;         TITLE     RCLLDGT
;*RCLLDGT: GET LAST NONBLANK CHARACTER BEFORE CURRENT POSTION
;*         IN MXD BUFFER, CHECKING FOR DIGIT.
;*
;*     ENTRY: F4 = 39
;*
;*     RETURN: F4 = 39 IF DIGIT FOUND  (K = DIGIT)
;*                = 00 IF BEGIN OF BUFFER
;*                = 01 IF NON-DIGIT FOUND (K = NON-DIGIT)
;*
;*     MODIFIED REGISTERS: K,F4
;*
RCLLDGT:
;-------- TSAI ------
          CMP       CMDBUADR,0
          JE        RCLLDGTA                ;BR,IF NOT MXF
          MOV       EBX,CMDBUADR
          MOVZX     ECX,GS:[EBX].lrwre      ;LR buffer count
RDGT2:
          CMP       ECX,0                   ;BR,if no char in LR buffer
          JE        RDGT1                   ;
          MOV       AL,GS:[EBX+ECX-1].lr_buf;read char from LR buffer
          DEC       ECX                     ;previous char
          MOV       K,AL
          CMP       AL,20H                  ;ignore space
          JE        RDGT2
          CMP       AL,30H                  ;BR,if char not '0'~'9'
          JB        RDGT4
          CMP       AL,39H
          JA        RDGT4
RDGT3:
          MOV       GS:[EBX].lrwre,CX       ;update LR buffer count
          RET
RDGT1:
          MOV       R4,0
          RET
RDGT4:
          MOV       R4,1
          JMP       RDGT3
RCLLDGTA:
;-------- TSAII ------
          MOV       AX,WORD PTR FS:[CPUST]  ;endi off
          MOV       BYTE PTR FS:[CPURDY],AL ;allow input
M35_16:
          TEST      BYTE PTR FS:[CPUST],2
          JZ        M35_16                  ;WAIT FOR CHARACTER FROM MXD
          call      delay5
          MOV       AL,BYTE PTR FS:[IBGET]
          MOV       K,AL
          TEST      BYTE PTR FS:[CPUST],4
          JNZ       RCLLDGT1                ;BRANCH IF BEGIN OF BUFFER (ENDI ON)
          CMP       K,20H
;         JE        RCLLDGT                 ;IGNORE SPACES
          JE        RCLLDGTA                ;IGNORE SPACES,---- TSAI
          MOV       AH,K
          AND       AH,0F0H
          CMP       AH,30H
          JNE       RCLLDGT3                ;BRANCH IF NOT 3X
          MOV       AL,K
          CMP       R4,AL
          JB        RCLLDGT3                ;BRANCH IF NOT DIGIT
          RET                               ;DIGIT FOUND

RCLLDGT1:
          MOV       AX,WORD PTR FS:[CPUST]  ;endi off
          MOV       R4,0                    ;BEGIN BUFFER
          RET

RCLLDGT3: MOV       R4,1                    ;NON-DIGIT FOUND
          RET

;         TITLE     STMT#
;*STMT#: PROCESS STMT# KEY REQUEST (PART OF READLINE)
;*
;*%CALCULATE NEXT LINE#
STMT_:    TEST      R5,20H
          JNZ       READL89             ;IGNORE IF NOT CI

;*%CALCULATE NEXT LINE#
          MOV       EDX,DWORD PTR [CPBASE]
          LEA       EDX,[EDX].@TEXTBEG
          MOV       ECX,DWORD PTR [EDX]
          CMP       CX,0
          JB        STMT_1              ;BRANCH IF THERE IS NO PROGRAM TEXT
          MOV       R3,0FFH             ;F3,2 = FFXX (SOMETHING > 9999)
          CALL      NXTLOW              ;FIND HIGHEST NUMBERED LINE
          MOV       DWORD PTR A0,EDX
          ADD       EDX,2
          MOV       AUX00,EDX

STMT_1:   MOV       WORD PTR R2,10H     ;GET LINE# OF HIGHEST NUMBERED LINE
          MOV       CX,[EDX]
          XCHG      CH,CL
          CMP       CX,9999H            ;F3,2 = HIGHEST LINE# + 10
          JA        READL89             ;IGNORE IF F3,2 > 9999

;*%SEND LINE# TO MXD
;-------- TSAI ---------
          CMP       CMDBUADR,0
          JE        STMT1                       ;BR,if MXD
;         MOV       EBX,CMDBUADR
          CALL      WAITCMD
;STMT2:
;         CMP       GS:[EBX].cmd_sts,0FH
;         JE        STMT2                       ;wat till cmd buf available
          MOV       GS:[EBX].cmd_cbs,?amREFILL  ;LR refill cmd
          MOV       GS:[EBX].cmd_abs,06
          MOV       BYTE PTR GS:[EBX].cmd_parm,0 ;refill count init to 0

          CALL      PUTLINE_            ;LINE# ==> MXD
          MOV       K,20H
          CALL      PUTCHAR             ;SPACE ==> MXD

          MOV       EBX,CMDBUADR
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_sts,0FH       ;start this cmd
          JMP       READL220
STMT1:
;--------- TSAII -----
          MOV       AL,?amREFILL
          CALL      CBSNT               ;REFILL COMMAND ==> MXD
STMT3:    ;---TSAI
          CALL      PUTLINE_            ;LINE# ==> MXD
          MOV       K,20H
          CALL      PUTCHAR             ;SPACE ==> MXD
          JMP       READL220            ;BRANCH TO END LR

;         TITLE     PUT TEXT LINE INTO BFR
;*     PUTLINE: DEATOMIZE SPECIFIED TEXT LINE TO MXD.
;*               ASSUMES LINE BEGINS WITH A
;*               PACKED LINE NO. ATOMIZED TEXT IS OUTPUT
;*               IN UNATOMIZED FORM.
;*
;*          ENTRY: AUX0 POINT TO THE LINE NUMBER.
;*                 CONSOLE OUTPUT DEVICE ENABLED UNLESS IN
;*                 LOAD MODE.  WE MUST BE AT THE CURRENT
;*                 END OF BUFFER.
;*          MODIFIED REGISTERS: CH,CL,PC'S,AUX0,2,F0-3,K
;*
;*     PUTLINF:  SAME, BUT NO LINE NUMBER AT THE BEGINNING
;*
;*
PUTLINE:  CALL      PUTLN_              ;OUTPUT LINE NUMBER
          MOV       K,20H               ;NEXT IS A BLANK
PUTLN04:  CALL      PUTCHAR
PUTLINF:  CALL      PUTSCAN             ;OUTPUT ANY BLANKS, SCAN FOR NON-BLANK
          CMP       K,7FH               ;BRANCH IF CHARCATRE = VARIABLE ATOM
          JE        PUTLN31
          CMP       K,7DH
          JE        PUTLN31
          CMP       K,7EH
          JE        PUTLN31
          TEST      K,80H
          JZ        PUTLN20             ;SKIP IF NOT ATOM
          CMP       K,0A2H
          JE        PUTLN60             ;BRANCH IF REM (A2)
          CMP       K,0D8H
          JNE       PUTLN31             ;BRANCH IF NOT IMAGE (D8)

;*% IMAGE
;*  NO DEATOMIZATION, NO LITERALS, NO COLON LOOKED FOR
;*
          MOV       K,25H               ;SUBSTITUTE A PERCENT (DEATOMIZE)
PUTLN71:  CALL      PUTSCANP
          MOV       AH,R0
          AND       R0,0F0H
          CMP       AH,0F0H
          JNE       PUTLN71             ;LOOP TILL CARRIAGE RETURN
PUTLNR:
          RET                           ;EXIT IF CARRIAGE RETURN
PUTLN20:  CMP       K,25H
          JE        PUTLN71             ;BRANCH IF IMAGE STATEMENT (PERCENT)
          CMP       K,52H
          JNE       PUTLN31             ;SKIP IF NOT 'R'

          CALL      PUTSCANP            ;ENTER THE R, FIND THE NEXT CHARACTER
          CMP       K,45H
          JNE       PUTLN31             ;SKIP IF NOT 'E'
          CALL      PUTSCANP            ;ENTER THE E, FIND THE NEXT CHARACTER
          CMP       K,4DH
          JNE       PUTLN31             ;SKIP IF NOT 'M'
          JMP       PUTLN61             ;IF 'REM' FOUND, BRANCH TO REM LOGIC

PUTLN25:  CMP       K,22H
          JNE       PUTLN28             ;SKIP IF NOT QUOTES

PUTLN26:  CALL      PUTSCANP
          MOV       AH,R0
          AND       AH,0F0H
          CMP       AH,0F0H
          JE        PUTLNR              ;EXIT IF CR
          CMP       K,22H
          JNE       PUTLN26

PUTLN28:  CALL      PUTCHAR

PUTLN29:  CALL      PUTSCAN
PUTLN31:  TEST      R0,80H
          JNZ       PUTLN70             ;SKIP IF COLON/CARRIAGE RETURN
          CMP       K,7FH               ;BRANCH IF CHARCATRE = VARIABLE ATOM
          JE        PUTLN7F
          CMP       K,7DH
          JE        PUTLN7F             ;SKIP IF 7DH ATOM
          CMP       K,7EH
          JE        PUTLN7E             ;SKIP IF 7EH ATOM
          TEST      K,80H
          JZ        PUTLN25             ;SKIP IF NOT ATOM
          CMP       K,@LINE_
          JE        PUTLN40             ;SKIP IF LINE #
          CMP       K,@HEXLIT
          JE        PUTLN50             ;SKIP IF HEX LITERAL (PACKED)
          CMP       K,@LTRL
          JE        PUTLN55             ;SKIP IF QUOTE LITERAL (PACKED)

;*%  REGULAR ATOM
PUTLN32:  CALL      DEATOM              ;DEATOMIZE A CONVENTIONAL ATOM
          JMP       PUTLN29

;    7FH ATOM
PUTLN7F:  CALL      DEATOM7F            ;DEATOMIZE A CONVENTIONAL ATOM
          JMP       PUTLN29

;    7EH ATOM
PUTLN7E:  CALL      DEATOM7E            ;DEATOMIZE A CONVENTIONAL ATOM
          JMP       PUTLN29

;*%  LINE NUMBER
PUTLN40:  CALL      PUTLN_
          ADD       AUX00,4             ;SKIP 4 BYTE ADDR
          JMP       PUTLN29

;*%  HEX LITERAL
PUTLN50:  CALL      DEATOM              ;PUT OUT HEX(
          MOV       EDX,AUX00
          MOV       CH,[EDX]
          INC       AUX00
          MOV       R0,CH               ;F0= COUNT
          JMP       PUTLN51

;@3.0K    EQU       *         space between bytes added rel. 3.0
PUTLN51B: MOV       K,20H
          CALL      PUTCHAR             ;output space

PUTLN51:  MOV       EDX,AUX00
          MOV       CH,[EDX]
          INC       AUX00
          MOV       R2,CH
          MOV       AL,R2
          SHR       AL,4
          MOV       K,AL
          CALL      PUTHEXCH            ;PUT OUT HIGH ORDER DIGIT
          MOV       AL,R2
          AND       AL,0FH
          MOV       K,AL
          CALL      PUTHEXCH            ;PUT OUT LOW ORDER DIGIT
          DEC       R0
          JNZ       PUTLN51B            ;LOOP TILL END OF HEX LITERAL
          MOV       K,')'
          JMP       PUTLN28

;*%  QUOTE LITERAL (ATOMIZED)
PUTLN55:  CALL      DEATOM              ;PUT OUT THE QUOTE
          MOV       EDX,AUX00
          MOV       CH,[EDX]
          INC       AUX00
          MOV       R0,CH

PUTLN56:  MOV       EDX,AUX00
          MOV       CH,[EDX]
          INC       AUX00
          MOV       K,CH

;*  (OPTIONAL CODE FOR QUOTE WITHIN QUOTES)
;*         BNEH      2,K,PUTLN57
;*         BNEL      2,K,PUTLN57
;*         SB        PUTCHAR                 IF IT'S A QUO
;*         MVI       22,K                    DOUBLE IT

PUTLN57:  CALL      PUTCHAR
          DEC       R0                  ;DECREMENT COUNTER
          JNZ       PUTLN56             ;LOOP FOR EACH BYTE IN THE LITERAL
          MOV       K,22H               ;PUT OUT  TRAILING QUOTE
          JMP       PUTLN28

;*%  REM   (REM, A2)
;*  NO DEATOMIZATION, NO LITERALS

PUTLN60:  CALL      DEATOM              ;DEATOMIZE THE REM
          mov       eax,aux00
putliney: cmp       byte ptr [eax],20h
          jne       putlinex
          inc       eax
          jmp       putliney
putlinex: cmp       byte ptr [eax],'%'
          jne       putln62
          inc       eax
putlinea: cmp       byte ptr [eax],20h
          jne       putlinez
          inc       eax
          jmp       putlinea
putlinez: cmp       byte ptr [eax],'%'
          jne       putln62
          call      putscan
          call      putchar
          call      putscan
          call      putchar
          jmp       putlinf

PUTLN61:  CALL      PUTCHAR

PUTLN62:  CALL      PUTSCAN
          TEST      R0,80H
          JZ        PUTLN61             ;LOOP TILL STMT SEPARATOR

PUTLN70:  MOV       AL,R0
          AND       AL,0F0H
          CMP       AL,0F0H
          JE        PUTLNR              ;EXIT IF CARRIAGE RETURN

;*%STMTSEP OR COLON
          TEST      K,80H
          JZ        PUTLN04             ;LOOP IF COLON (UNATOMIZED)
          CALL      DEATOM              ;PUT OUT COLON, SPACE
          JMP       PUTLINF             ;LOOP BACK FOR NEXT STMT

;         TITLE     PUTSCAN
;  PUTSCAN:  COPY ANY BLANKS, STOP WITH FIRST NON-BLANK
;    CHARACTER IN K.  RETURN FLAG IN F0.
;
;  CHARACTER FOUND:       F0 =
;         CR            HEX(F0)
;         COLON         HEX(E0)
;         ELSE          HEX(00)

PUTSCANP: CALL      PUTCHAR

;%------- correction for German problem ----------------------------------------
;        (patched by Jerry and Bruce for rel 3.3)
;
; Problem:
;        German keyboard can enter a code that looks like a 2-byte atom (eg,
;        a hex literal, hex(FC)).  If this is entered and causes a syntax
;        error (or if program is listed), the byte after the FC is assumed to
;        be a count (length of literal).  This count may put us beyound the
;        CR of that line!  Currently, PUTSCAN keeps going until CR found.
;        This may be beyond program, into next partition, or even past end of
;        of memory, which may cause parity error!
;
;        This fix stops PUTSCANning at end of partition.  This fix is not
;        great, but we couldn't think of anything better.   Our fix replaces
;        the following REMed out instruction.
;

PUTSCAN:  CALL      RPARTEND            ;get end of partition address
          MOV       EDX,AUX00
          ADD       ECX,256             ;end of partition page +1
          CMP       EDX,ECX
          JNE       PUTSCAN1            ;branch if not beyond end of partition
          MOV       BYTE PTR [TEMPSAVE],0DH
          MOV       CH,BYTE PTR [EDX]
          MOV       EDX,AUX00           ;get CR into CH
          JMP       PUTSC4

;-------------------------------------------------------------------------------

PUTSCAN1: MOV       CH,[EDX]
          MOV       AUX00,EDX
          INC       AUX00
          MOV       K,CH
          CMP       CH,20H
          JE        PUTSCANP            ;LOOP IF BLANK

PUTSC4:   MOV       R0,0F0H
          CMP       CH,0DH
          JE        PUTSCR              ;EXIT (F0)IF CARRIAGE RETURN(0D)
          MOV       R0,0E0H
          CMP       CH,0FDH
          JE        PUTSCR              ;EXIT (E0) IF SEPARATOR (FD)
          CMP       CH,3AH
          JE        PUTSCR              ;EXIT (E0) IF SEPARATOR (3A)
          MOV       R0,0                ;EXIT (00) OTHERWISE
PUTSCR:   RET

;         TITLE     PUTLN#
;* PUTLN#:  UNPACK AND COPY LINE NUMBER INTO BUFFER.
;*
;*  ENTRY:  AUX 0 POINTS AT PACKED LINE NUMBER IN THE TEXT
;*          LINE.
;*  RETURN:  AUX 0 HAS BEEN INCREMENTED PAST THE LINE #.
;*  MODIFIED REGISTERS: (AUX0),PC'S,CHCL,F3-F0 ,K
;*
PUTLN_:   MOV       EDX,AUX00
          MOV       CX,[EDX]
          XCHG      CH,CL
          ADD       EDX,2
          MOV       WORD PTR R2,CX      ;F3F2 = LINE NUMBER
          MOV       AUX00,EDX           ;AUX 0 POINTS AFTER THE LINE NUMBER

;*  FALL THROUGH TO PUTLINE#
;         TITLE     PUTLINE#
;*     PUTLINE#: STORE  THE SPECIFIED LINE NO. (2 PACKED
;*               DECIMAL BYTES). LEADING ZEROES ARE NOT
;*               OUTPUT.
;*
;*          ENTRY: F3,2 = PACKED DECIMAL LINE NO.
;*
;*          MODIFIED REGISTERS: K, F1F0, PC's
;*
;*
PUTLINE_: TEST      R3,0F0H
          JNZ       PUTLIN_4            ;BRANCH IF 1ST DIGIT <> 0
          CMP       R3,0
          JNE       PUTLIN_3            ;BRANCH IF 2ND DIGIT <> 0
          TEST      R2,0F0H
          JNZ       PUTLIN_2            ;BRANCH IF 3RD DIGIT <> 0
          JMP       PUTLIN_1

PUTLIN_4: MOV       AL,R3
          SHR       AL,4
          MOV       K,AL
          CALL      PUTCHR3X            ;OUTPUT 1ST DIGIT

PUTLIN_3: MOV       AL,R3
          AND       AL,0FH
          MOV       K,AL
          CALL      PUTCHR3X            ;OUTPUT 2ND DIGIT

PUTLIN_2: MOV       AL,R2
          SHR       AL,4
          MOV       K,AL
          CALL      PUTCHR3X            ;OUTPUT 3RD DIGIT

PUTLIN_1: MOV       AL,R2
          AND       AL,0FH
          MOV       K,AL
          JMP       PUTCHR3X            ;OUTPUT 4TH DIGIT

;   DEATOM: DEATOMIZE A TEXT WORD
;
;   ENTRY:  K = TEXT ATOM
;
;   MODIFIED REGISTERS:  PC'S, CHCL, K, F2F1F0, AUX 0,1
;       (NOTE: AUX 0 NOT CHANGED IF AT END OF BUFFER)

DEATOM:   MOV       AL,K
          SUB       AL,80H
          MOV       R0,AL               ;fix bugs for WORDLENA had been change
          CALL      WORDLENA            ;FIND LOCATION AND LENGTH OF TEXT ATOM
          MOV       AL,R0
          MOV       R2,AL               ;F2 = LENGTH OF TEXT ATOM

DEATOM2:  MOV       CH,[EDX]            ;READ ONE CHARACTER
          MOV       AUX01,EDX
          INC       AUX01
          MOV       K,CH
          CALL      PUTCHAR             ;PUT ONE CHARACTER IN BUFFER, AND ON CRT
          DEC       R2                  ;DECREMENT COUNT
          MOV       EDX,AUX01
          JNZ       DEATOM2             ;LOOP TILL END OF DEATOMIZED TEXT WORD
DEATOMR:  RET


;   DEATOM7F: DEATOMIZE A 7F
;
;   ENTRY:  PC'S POINT TO 7F POSITION
;
;   MODIFIED REGISTERS:  PC'S, CHCL, K, F2F1F0, AUX 0,1
;       (NOTE: AUX 0 NOT CHANGED IF AT END OF BUFFER)

DEATOM7F: MOV       EAX,AUX00
          ADD       AUX00,6
          MOV       R2,0
          MOV       EDX,OFFSET SCRATCH
          MOV       BL,BYTE PTR [EAX-1]
          MOV       CX,WORD PTR [EAX]
          XCHG      CH,CL
          TEST      CH,08H
          JZ        DEATOM7F5
          MOV       BYTE PTR [EDX],'@'
          INC       EDX
          INC       R2

DEATOM7F5:MOV       BYTE PTR [EDX],CL
          INC       EDX
          INC       R2
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,0F0H
          JE        DEATOM7F6
          SHR       AL,4
          ADD       AL,30H
          CMP       AL,3AH
          JB        DEATOM7F7
          ADD       AL,7

DEATOM7F7:MOV       BYTE PTR [EDX],AL
          INC       EDX
          INC       R2

DEATOM7F6:TEST      CH,1
          JZ        DEATOM7F8
          MOV       BYTE PTR [EDX],'$'
          INC       EDX
          INC       R2

DEATOM7F8:CMP       BL,7DH
          JE        DEATOM7F9
          TEST      CH,2
          JZ        DEATOM7F9
          MOV       BYTE PTR [EDX],'('
          INC       EDX
          INC       R2

DEATOM7F9:MOV       EDX,OFFSET SCRATCH

DEATOM7F2:MOV       CH,[EDX]            ;READ ONE CHARACTER
          MOV       AUX01,EDX
          INC       AUX01
          MOV       K,CH
          CALL      PUTCHAR             ;PUT ONE CHARACTER IN BUFFER, AND ON CRT
          DEC       R2                  ;DECREMENT COUNT
          MOV       EDX,AUX01
          JNZ       DEATOM7F2           ;LOOP TILL END OF DEATOMIZED TEXT WORD
          RET

;   DEATOM7E: DEATOMIZE A 7E
;
;   ENTRY:  PC'S POINT TO 7E POSITION
;
;   MODIFIED REGISTERS:  PC'S, CHCL, K, F2F1F0, AUX 0,1
;       (NOTE: AUX 0 NOT CHANGED IF AT END OF BUFFER)

DEATOM7E: PUSH      AUX00
          MOV       EDX,AUX00
          CALL      VVFMTA
          CALL      MVSCRTCH1
          POP       AUX00
          ADD       AUX00,8
          MOV       AL,R0
          MOV       R2,AL               ;F2 = LENGTH OF TEXT ATOM
          CMP       FLAG7E,0
          JE        DEATOM7E2
;-------- TSAI ---------
          CMP       CMDBUADR,0
          JE         DEAT1                       ;BR,if MXD
          JMP       DEAT3
DEAT7E2:  MOV       CH,[EDX]            ;READ ONE CHARACTER
          MOV       AUX01,EDX
          INC       AUX01
          CMP       CH,20H
          JE        DEAT7E4
          MOV       K,CH
          CALL      PUTCHAR             ;PUT ONE CHARACTER IN BUFFER, AND ON CRT
DEAT7E4:
          DEC       R2                  ;DECREMENT COUNT
          MOV       EDX,AUX01
          JNZ       DEAT7E2             ;LOOP TILL END OF DEATOMIZED TEXT WORD
          RET
DEAT1:
;--------- TSAII -----
          MOV       AL,?amREFILL        ;REFILL COMMAND
          CALL      CBSNT
DEAT3:              ;---TSAI
DEATOM7E2:MOV       CH,[EDX]            ;READ ONE CHARACTER
          MOV       AUX01,EDX
          INC       AUX01
          CMP       CH,20H
          JE        DEATOM7E4
          MOV       K,CH
          CALL      PUTCHAR             ;PUT ONE CHARACTER IN BUFFER, AND ON CRT
DEATOM7E4:
          DEC       R2                  ;DECREMENT COUNT
          MOV       EDX,AUX01
          JNZ       DEATOM7E2           ;LOOP TILL END OF DEATOMIZED TEXT WORD
          RET


;         TITLE     PUTCHAR
;*PUTCHAR: SEND CHARACTER TO MXD. IGNORE FA-FF IF CI MODE.
;*
;*     ENTRY: K = CHARACTER TO SEND
;*            F5,BIT 20 = 0 IF CI MODE
;*
;*PUTCH3X: SEND CHARACTER OR'ED WITH 30 TO MXD.
;*
;*PUTHEXCH: SEND A HEXDIGIT TO MXD.
;*
PUTHEXCH: ADD       K,30H
          CMP       K,3AH
          JB        PUTCHAR             ;BRANCH IF 0-9
          ADD       K,07H               ;CONVERT 3A-3F TO 41-46
          JMP       PUTCHAR
PUTCHR3X: OR        K,30H

PUTCHAR:  TEST      R5,4
          JNZ       LISTTA              ;GO PROCESS CHARACTER IN LIST T
          TEST      R5,20H
          JNZ       PUTCH2              ;SKIP IF INPUT/LINPUT
;         MOV       R1,0FAH
;         CMP       K,0FAH
;         JA        PUTCH90             ;BRANCH IF CHARACTER FB-FF

;*%RECALL
PUTCH2:   MOV       AL,K
          TEST      R5,80H
;-------- TSAI -------
;         JZ        OBSNT               ;SEND CHARACTER TO MXD (NO TIMEOUT!)
          JNZ       PUTCHL
          CMP       CMDBUADR,0
          JE        OBSNT               ;BR, IF NOT MXF
          PUSH      ECX
          CALL      WAITCMD
          MOVZX     ECX,BYTE PTR GS:[EBX].cmd_parm  ;count
          CMP       ECX,95               ;
          JNE       PUTCH3               ;parm area of cmd buf is full(99 at
                                         ;most),refill it first
;         MOV       CX,GS:[EBX].lrwre    ;get LR buffer count
;         MOV       GS:[EBX].lradd,CX    ;adjust cursour position
          MOV       GS:[EBX].cmd_sts,0FH
          CALL      WAITCMD
          MOV       GS:[EBX].cmd_cbs,?amENDLRT ;0AH command
          MOV       GS:[EBX].cmd_abs,06        ;ABS=06
          MOV       GS:[EBX].cmd_sts,0FH
          CALL      WAITCMD
;-------- 12-19-90 -----
          MOV       GS:[EBX].cmd_cbs,12H       ;
          MOV       GS:[EBX].cmd_abs,06        ;ABS=06
 PUTCH5:
          MOV       GS:[EBX].cmd_sts,0FH
          CALL      WAITCMD
;PUTCH4:
;         CMP       BYTE PTR GS:[EBX].cmd_sts,0FH
;         JE        PUTCH4
          CMP       BYTE PTR GS:[EBX].cmd_parm,00H
          JNE       PUTCH5
;-------- 12-19-90 -----

          MOV       GS:[EBX].cmd_cbs,?amREFILL  ;LR refill cmd
          MOV       GS:[EBX].cmd_abs,06         ;next refill cycle
          MOV       BYTE PTR GS:[EBX].cmd_parm,0
          MOV       ECX,0
PUTCH3:
          MOV       AL,K                            ;the next char to be
          MOV       GS:[EBX+ECX+1].cmd_parm,AL      ;prefilled
          INC       BYTE PTR GS:[EBX].cmd_parm      ;increase prefill char
          POP       ECX
          RET
;-------- TSAII ----------
;*%LOAD (CARD READER,ETC.)
PUTCHL:   MOV       EDX,IBUFEND
          CMP       WORD PTR R6,DX
          JB        PUTCHAR2    ;BRANCH IF MORE ROOM
PUTCH90:  MOV       R1,0
PUTCHARR: RET

PUTCHAR2: MOV       DX,WORD PTR R6
          MOV       CH,[EDX]            ;GET NEXT CHARACTER
          INC       WORD PTR R6
          MOV       AL,K
          MOV       [EDX],AL
          MOV       EDX,TEXTEND         ;STORE IT

PUTCH7:   MOV       K,CH
          MOV       R1,44H
          CMP       WORD PTR R6,DX
          JB        PUTCHARR
          MOV       R1,40H
          CMP       WORD PTR R6,DX
          JBE       PUTCHARR
          MOV       DX,WORD PTR R6
          MOV       TEXTEND,EDX
          JMP       PUTCH90

;         TITLE     DISPLAY STAR
;*  DISPSTAR:  DISPLAY ASTERISK, COLON, OR QUESTION MARK;
;*    TO REPRESENT EDIT MODE, CONSOLE INPUT, OR INPUT.
;*
DISPSTAR: TEST      R5,8
          JZ        DISPT3              ;SKIP IF NOT EDIT MODE
          MOV       EDX,ACTDEV
          TEST      DH,0FH
          JNZ       DISPT6              ;SKIP IF NOT DEVICE TYPE 0
          MOV       K,0DH
;         CALL      OBSTROBE
          CALL      OBSMXF      ;--TSAI
          MOV       EDX,CHARCNT
          CALL      OBSN09

DISPT6:   MOV       K,'*'
          MOV       AL,R5
          AND       AL,0F0H
          CMP       AL,20H
          JE        DISPT4              ;SKIP IF INPUT

DISPT7:   JMP       TWRITE
DISPT3:   MOV       K,':'               ;IN CON. INP. MODE, WRITE ':'
          TEST      R5,20H
          JZ        DISPT7              ;SKIP IF NOT INPUT/LINPUT
          TEST      R5,10H
          JNZ       DISPT5              ;SKIP IF LINPUT (SPACE)
          MOV       K,'?'

DISPT4:   CALL      TWRITE
DISPT5:   JMP       TWRITESP            ;IN INPUT MODE, WRITE '? ' OR '* '
ERROR_52: MOV       R0,52H
          JMP       ERROR               ;ERROR 52, ALPHA VALUE TOO LONG (LINPUT)

;   RESTOR7F: RESTORE A 7F
;
;   ENTRY:  AUX00 => TEXT AREA
;           EDX   => I/O BUFFER
;
;  RETURN:  AUX00 => I/O BUFFER
;           EDX   => TEXT AREA
;
;   CAN'T MODIFIED REGISTERS:  AX, EDX, AUX00 ,A2A3, A6A7
;

RESTOR7F: PUSH      EAX
          MOV       EAX,AUX00
          ADD       AUX00,6
          MOV       R2,0
          MOV       BL,BYTE PTR [EAX-1]
          MOV       CX,WORD PTR [EAX]
          XCHG      CH,CL
          TEST      CH,08H
          JZ        RESTOR7F5
          MOV       BYTE PTR [EDX],'@'
          INC       EDX
          INC       R2

RESTOR7F5:MOV       BYTE PTR [EDX],CL
          INC       EDX
          INC       R2
          MOV       AL,CH
          AND       AL,0F0H
          CMP       AL,0F0H
          JE        RESTOR7F6
          SHR       AL,4
          ADD       AL,30H
          CMP       AL,3AH
          JB        RESTOR7F7
          ADD       AL,7

RESTOR7F7:MOV       BYTE PTR [EDX],AL
          INC       EDX
          INC       R2

RESTOR7F6:TEST      CH,1
          JZ        RESTOR7F8
          MOV       BYTE PTR [EDX],'$'
          INC       EDX
          INC       R2

RESTOR7F8:CMP       BL,7DH
          JE        RESTOR7F9
          TEST      CH,2
          JZ        RESTOR7F9
          MOV       BYTE PTR [EDX],'('
          INC       EDX
          INC       R2
RESTOR7F9:
          POP       EAX
          MOV       ECX,0
          MOV       CL,R2
          SUB       EAX,ECX
          XCHG      EDX,AUX00
          RET

;   RESTOR7E: RESTORE A 7E
;
;   ENTRY:  AUX00 => TEXT AREA
;           EDX   => I/O BUFFER
;
;  RETURN:  AUX00 => I/O BUFFER
;           EDX   => TEXT AREA
;
;   CAN'T MODIFIED REGISTERS:  AX, EDX, AUX00 ,A2A3, A6A7
;

RESTOR7E: PUSH      EAX
          PUSH      EDX
          MOV       EDX,AUX00
          CALL      VVFMTA
          POP       EDX
          ADD       AUX00,8
          MOV       ESI,OFFSET SCRATCH  ;POINT TO SCRATCH AREA
          MOV       EDI,EDX
          MOV       ECX,0
          MOV       CL,R0
          POP       EAX
          SUB       EAX,ECX
          PUSH      EAX
RESTOR7E2:
          LODSB
          CMP       AL,20H
          JE        RESTOR7E4
          STOSB
RESTOR7E4:
          LOOP      RESTOR7E2
          POP       EAX
          MOV       EDX,EDI
          XCHG      EDX,AUX00
          RET

;   RESTORA2: RESTORE A A2 (REM)
RESTORA2:
          MOV       BYTE PTR [EDX],CH
          CMP       CH,0FDH
          JE        RESTA2_RTN
          CMP       CH,0DH
          JE        RESTA2_ERR
          XCHG      EDX,AUX00
          INC       AUX00
          CMP       DWORD PTR [A2],EDX
          JB        RESTA2_ERR
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00           ;COPY UP TO 255 BYTES INTO IOBUFFER
          INC       AUX00
          DEC       AX
          JNZ       RESTORA2
RESTA2_ERR:
          STC
          RET
RESTA2_RTN:
          XCHG      EDX,AUX00
          INC       AUX00
          CLC
          RET

;   RESTORD8: RESTORE A D8 (IMAGE)
RESTORD8:
          MOV       BYTE PTR [EDX],CH
          CMP       CH,0DH
          JE        RESTA2_ERR
          XCHG      EDX,AUX00
          INC       AUX00
          CMP       DWORD PTR [A2],EDX
          JB        RESTA2_ERR
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00           ;COPY UP TO 255 BYTES INTO IOBUFFER
          INC       AUX00
          DEC       AX
          JNZ       RESTORD8

;   RESTORFC: RESTORE A FC   < HEX() >
RESTORFC:
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX00
          INC       AUX00
          CMP       DWORD PTR [A2],EDX
          JB        RESTA2_ERR
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00
          INC       AUX00
          DEC       AX
          JZ        RESTA2_ERR

          MOV       EBX,0
          MOV       BL,CH
          INC       EBX
RESTORFC2:
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX00
          INC       AUX00
          CMP       DWORD PTR [A2],EDX
          JB        RESTA2_ERR
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00
          INC       AUX00
          DEC       AX
          JZ        RESTA2_ERR
          DEC       EBX
          JNZ       RESTORFC2
          CLC
          RET

;   RESTORFE: RESTORE A FE   < "..." >
RESTORFE:
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX00
          INC       AUX00
          CMP       DWORD PTR [A2],EDX
          JB        RESTA2_ERR
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00
          INC       AUX00
          DEC       AX
          JZ        RESTA2_ERR

          MOV       EBX,0
          MOV       BL,CH
          INC       EBX
RESTORFE2:
          MOV       BYTE PTR [EDX],CH
          XCHG      EDX,AUX00
          INC       AUX00
          CMP       DWORD PTR [A2],EDX
          JB        RESTA2_ERR
          MOV       CH,BYTE PTR [EDX]
          XCHG      EDX,AUX00
          INC       AUX00
          DEC       AX
          JZ        RESTA2_ERR
          DEC       EBX
          JNZ       RESTORFE2
          CLC
          RET

CODE      ENDS
          END
