;===========================================================================
;
;           P R O G R A M   L O A D  /  S A V E
;
;===========================================================================
;           This module was originally M42
;===========================================================================
            .XLIST
            INCLUDE PREAMBLE
            .LIST

PUBLIC       @REVERB
PUBLIC       LOADRUN
PUBLIC       LOAD
PUBLIC       LOADP
PUBLIC       SAWM
PUBLIC       SAVE
PUBLIC       SAVEPBLK
public       saverprg
public       savePR70
public       savePRG7

EXTRN    @LETTER    :NEAR
EXTRN    @@OSEND    :DWORD
EXTRN    @@VSEND    :DWORD
EXTRN    $CLOSEA    :NEAR
EXTRN    ADDFILE    :NEAR
EXTRN    AVARD      :NEAR
EXTRN    CCL        :NEAR
EXTRN    CCLTO      :NEAR
EXTRN    CCNL       :NEAR
EXTRN    CLEARN     :NEAR
EXTRN    CLEARXA    :NEAR
EXTRN    CPBASE     :DWORD
EXTRN    DCRYPT     :NEAR
EXTRN    DEVICET    :NEAR
EXTRN    DIGIT      :NEAR
EXTRN    DISKSELC   :NEAR
EXTRN    DREADSF    :NEAR
EXTRN    DWRITE?DA  :NEAR
EXTRN    DWRITE?DAF :NEAR
EXTRN    ENBLDEVI   :NEAR
EXTRN    ENDSDISK   :NEAR
EXTRN    ENBLNULL   :NEAR
EXTRN    ENDDISKR   :NEAR
EXTRN    ENDSTMT    :NEAR
EXTRN    ENTERF     :NEAR
EXTRN    ENTER_      :NEAR
EXTRN    ERROR      :NEAR
EXTRN    ERROR_02   :NEAR
EXTRN    ERROR_04   :NEAR
EXTRN    ERROR_05   :NEAR
EXTRN    ERROR_08   :NEAR
EXTRN    ERROR_15   :NEAR
EXTRN    ERROR_16   :NEAR
EXTRN    ERROR_20   :NEAR
EXTRN    ERROR_21   :NEAR
EXTRN    ERROR_29   :NEAR
EXTRN    ERROR_34   :NEAR
EXTRN    ERROR_48   :NEAR
EXTRN    ERROR_51   :NEAR
EXTRN    ERROR_81   :NEAR
EXTRN    ERROR_82   :NEAR
EXTRN    ERROR_83   :NEAR
EXTRN    ERROR_85   :NEAR
EXTRN    EXPR       :NEAR
EXTRN    FILELOCS   :NEAR
EXTRN    FILENAME   :NEAR
EXTRN    FILENAMH   :NEAR
EXTRN    FILENAMP   :NEAR
EXTRN    FILENAMS   :NEAR
EXTRN    FILENMXA   :NEAR
EXTRN    FINDNAMH   :NEAR
EXTRN    FINDST     :NEAR
EXTRN    FLTBINA    :NEAR
EXTRN    GTFLPTRS   :NEAR
EXTRN    HEXFIX     :NEAR
EXTRN    HPION      :NEAR
EXTRN    ICLEAR     :NEAR
EXTRN    INITSTKS   :NEAR
EXTRN    INITTEXT   :NEAR
EXTRN    LINE_REF   :NEAR
EXTRN    LITERAL    :NEAR
EXTRN    LN_RANGA   :NEAR
EXTRN    LN_RANGE   :NEAR
EXTRN    LOADBLK    :NEAR
EXTRN    LOADLBLK   :NEAR
EXTRN    MATDSPLA   :NEAR
EXTRN    MOVEELMT   :NEAR
EXTRN    MSWRTBEG   :NEAR
EXTRN    MSWRTEND   :NEAR
EXTRN    MVSCRTCH   :NEAR
EXTRN    NCRYPT     :NEAR
EXTRN    NEWEOF     :NEAR
EXTRN    NEWNAMEF   :NEAR
EXTRN    OBSTROBE   :NEAR
EXTRN    ORG0100    :NEAR
EXTRN    PLATTER    :NEAR
EXTRN    PLATTERA   :NEAR
EXTRN    PLATTERX   :NEAR
EXTRN    PROCST     :NEAR
EXTRN    PRTCTERR   :NEAR
EXTRN    PMODE      :NEAR
EXTRN    PART_      :BYTE
EXTRN    PUTLINF    :NEAR
EXTRN    RAW        :NEAR
EXTRN    RAWON      :NEAR
EXTRN    READPTL    :NEAR
EXTRN    RECSCTR    :NEAR
EXTRN    RUNB       :NEAR
EXTRN    SAVESEED   :BYTE
EXTRN    SCRATCH    :NEAR
EXTRN    SECTOR     :NEAR
EXTRN    SETDEVLD   :NEAR
EXTRN    SQZTEXT    :NEAR
EXTRN    SYSGENFG   :BYTE
EXTRN    SLCT@CLR   :NEAR
EXTRN    THREADL    :NEAR
EXTRN    UNRESLVI   :NEAR
EXTRN    UNRESLVS   :NEAR
EXTRN    UNTHREAD   :NEAR
EXTRN    VVFMTA     :NEAR
EXTRN    VVFMTB     :NEAR
EXTRN    _FILENAM   :BYTE
EXTRN    _NAME      :BYTE

; ------------ 22c11-2 ---------------
extrn    multi_read :near
; ------------ 22c11-2 ---------------

SACR     EQU       80H     ; Compress Rems  <R>
SACS     EQU       40H     ; Compress Spaces <S>
SACST    EQU       20H     ; Compress spaces temp flag
SAWM     EQU       10H     ; Wrap Mode  <W>
SAMS     EQU       08H     ; Multi stmt flag (used to suppress colon)
SAP1     EQU       04H     ; pass 1 flag

;         TITLE     LOADP
;*   Note:  this block of comments describes how it ought to work, for next
;*          release.  This should correct a very obscure likelihood.
;*          (nonwrap mode,  F1=high(IOBUFFER).  "Wrong record type" if we went beyond end of sector.
;*          note that this is to avoid giving Error 01 when what was really wrong was
;*          that a line had no CR.
;

;LOADP70  B         LOADR01   MEMORY FULL ERROR
;LOADDERR
;         SB        UNRESLVS
;         SB        INITTEXT  clearp
;         SB        IMMEDOFF

PUBLIC  LOADP70
LOADP70:
        JMP     LOADR01
LOADDERR:
        CALL    UNRESLVS
        CALL    INITTEXT
        AND     MODE,0FBFFH     ;turn off immediate mode bit (MODEIMM=0400)

;         TAP       ,VSPTR
;         MVX       PHPL,F7F6
;         TAP       ,TEXTEND
;         XPA+3     ,0
;         XPA       ,0        start at TEXTEND+3

        MOV     EDX,VSPTR
        MOV     DWORD PTR A6,EDX
        mov     edi,textend
        add     edi,3

;         MVI       0D,F1
;         OR,W1     +,F1,     initialize text area to 0D's
;         BNR       F6,PL,*-1
;         BNR       F7,PH,*-2
;         MVI       88,F1     Err 88, Wrong Record type
;         B         LOADR02

        mov     al,0dh
bp42c_01:
        stosb
        cmp     edi,dword ptr a6
        jnz     bp42c_01
        MOV     R1,88H
        JMP     LOADR02

;*  Wrap mode jumps here if current line won't fit in available memory.
;LOADR01  MVI       01,F1     Err 01, no more room in memory
;LOADR02  SB        RIOBUFFR
;         SB        ZERO256   zero the IO buffer
;         TAP       ,MODE
;         ANDI      0FF-80,PH,PH        turn off load mode before error 01

LOADR01:
LOADR02:
        mov     edx,dword ptr [cpbase]
        lea     edi,[edx].@iobuffr
        mov     eax,0
        mov     ecx,40h
        rep     stosd
        and     mode,0ffff7fffh

;         TPA       ,MODE
;         MV        F1,F0     Restore error code from F1
;         B         ERROR

        MOV     R0,1
        JMP     ERROR

;         TITLE     LOADP
;*     LOADP: GET THE NEXT PROGRAM LINE FROM THE I/O
;*            BUFFER (FILL I/O BUFFER FROM DISK IF
;*                    NO MORE TEXT IN BUFFER).
;*
;*            LINE IS THREADED INTO TEXT SLOWLY IF 2200
;*            FORMAT, IF 1ST LINE OF LOAD, OR IF LINE NO.
;*            IS > LINE# THAT LAST LINE IS THREADED TO.
;*            OR <= LINE# OF LAST LINE LOADED IN.
;*            SLOW THREAD USES 'THREAD' SUBROUTINE; FAST
;*            THREAD THREADS DIRECTLY (IE, LAST LINE IS
;*            THREADED TO NEW LINE & NEW LINE IS THREADED
;*            TO LINE LAST LINE WAS THREADED TO).
;*
;*          ENTRY:
;*               PHASE = EXECUTION
;*               TEXTEND = ADDR OF WHERE TO PUT NEXT LINE
;*               DEVLOAD = DEVICE TYPE & ADDRESS FOR LOAD
;*               AUXE = PLATTER,FILE#
;*               AUXC = ADDRESS OF NEXT CHARACTER IN BUFFR
;*               AUXD = EOF SECTOR ADDRESS
;*               AUXF = CURRENT SECTOR ADDRESS
;*               AUX5 = LINE NO. OF LINE THAT LAST LINE
;*                    WAS THREADED TO (0 IF BEGIN OF LOAD)
;*               AUX6 = LINE NO. OF LAST LINE (MOST
;*                      RECENTLY LOADED)
;*               AUX4 (IBUFEND) = UPPER LIMIT OF TEXT AREA
;*               RSAVEA  is a 2 byte save area.  bit 0001 is Wrap mode flag.
;*                       bit 0002 is Scramble flag,
;*                       other 14 bits are used by scramble to link sectors together.

; THE FOLLOWING INFORMATION ARE FIRST WRITTEN BY LOADDA(DC)
; & MANTAINED BY LOADP
; BECAUSE WE ALTER THE LOADP STRATGY AS FOLLOW :
;
;        LOADDA(DC)                                  LAODDA(DC)
;
;           |                                           |
;
;       ENTER_(F)                                      ENTER_(F)  -
;     /  /          \                                /  |             \
;   LOADP    |        \                           READL LOADP
;                       \                           \    \               |
;            |                                       \     \
;          READL          |                            - -  PROCST       |
;             \                  ====>                          \
;
;               PROCST    |                                  VERB PROC   |
;
;                |
;                         |                                       \      |
;               VERB PROC                                           ENDSTMT
;
;                |        |
;
;                ENDSTMT
;
;


;THE FOLLOWING INFO. MAY BE ALTERED BY  PROCST .... ETC. PROCEDURES
;WE KEEP THEM IN TEMPORARY STROAGES : cpbase.@iobuffr + 400t

;*
;*          EXIT (END OF PROGRAM, NO MORE TEXT): B ENTER
;*               LOAD MODE OFF
;*
;*          EXIT (TEXT LINE FOUND): B ENTER
;*               TEXT LINE ==> TEXT AREA
;*               TEXT LINE THREADED INTO PROGRAM
;*               TEXTEND POINTS TO CR OF TEXT LINE
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-5
;*                              AUX0,1,4,5,6,A,C,F
;*                                  and more?????????    see TEMP??
;*

;
;*
;* non-wrap mode jumps here at FD marking end of each sector
;LOADP5   SB        RSAVEA
;         BFLL      02,CL,LOADP53       skip if not scrambled
;         TAP       ,C
;         MVI       0,F0
;         BER       F0,PL,LOADP53

LOADP5:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@rsave
        TEST    BYTE PTR [EDX+1],2
        JZ      LOADP53
        MOV     EDX,AUX0C
        CMP     EDX,AUX02
        JZ      LOADP53

;*  note:  Since the T didn't scramble, any non-wrap scrambled programs should
;*        have the tails of the sectors zeroed out.
;LOADP51  OR,R      +,,F0
;         BNR       CH,,LOADDERR        check all trailing bytes for zeroes
;         BNR       F0,PL,LOADP51
;LOADP53  SB        LOADPB    LOAD NEXT PROGRAM BLOCK FROM DISK

LOADP51:
        cmp     byte ptr [edx],0
        JNZ     LOADDERR
        INC     EDX
        CMP     EDX,AUX02               ;AUX02 = I/O BUFFER END ADDRESS
        JNZ     LOADP51

LOADP53:
        CALL    LOADPB
        JMP     LOADADD

;*   Get next program line from load device
;LOADP    SB        RDEVLOAD  GET 'DEVLOAD'
;         BEQL      6,CH,LOADPT         BRANCH IF LOAD DEVICE TYPE = 6 (PAPER TAPE)
;         TAP       ,IBUFEND
;         XPA+3     ,0

LOADP:
        test    counts,2000h
        jnz     loadadd

        mov     edx,dword ptr [cpbase]
        lea     esi,[edx].@iobuffr              ; I/O BUFFR + 400T  =====>
        add     esi,400
        lea     edi,aux0c                       ; AUX0C       400
        mov     ecx,4                           ; AUX0D       404
        rep     movsd                           ; AUX0E       408
        lea     edi,aux05                       ; AUX0F       412
        mov     ecx,2                           ; AUX05       416
        rep     movsd                           ; AUX06       420

LOADADD:
        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr

        ADD     EDX,100H
        MOV     AUX02,EDX       ;AUX02 -- END ADDRESS OD I/O BUFFER
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@DEVLOAD
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        CMP     CH,6
        JZ      LOADPT
        MOV     EDX,IBUFEND

;         XPA       ,0        give us an additional 3 bytes safety
;         MVX       PHPL,F7F6 F7,6 = UPPER LIMIT OF TEXT AREA
;         SB        IMMEDOFF  flag the immediate mode line
;*                                     as invalid, since we're about
;*                                     overwrite it.

        ADD     EDX,3                   ;ADDITOINAL 3 BYTES FOR SAFETY
        MOV     DWORD PTR A6,EDX
        AND     MODE,0FBFFH     ;turn off immediate mode bit (MODEIMM=0400)

;         SB        RSAVEA
;         BTL       1,CL,LOADWskip if wrap mode
;LOADP00  TAP       ,C
;         TPA+1,R   ,C        GET NEXT CHARACTER FROM I/O BUFFER
;         BER       +,PL,LOADDERR       error if end of sector
;         BER       CH,,LOADP00         IGNORE NULLS

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@rsave
        TEST    BYTE PTR [EDX+1],1
        JNZ     LOADW
LOADP00:
        MOV     EDX,AUX0C
        MOV     CH,[EDX]
        INC     AUX0C
        CMP     EDX,AUX02
        JZ      LOADDERR
        INC     EDX
        CMP     CH,0
        JZ      LOADP00

;         BNEH      0F,CH,LOADP01       Next byte must be an FF,FE,or FD
;         BEQL      0F,CH,LOAD22P       BRANCH IF another line in this sector
;         BEQL      0D,CH,LOADP5        BRANCH IF EOB CHARACTER (end sector)
;         BEQL      0E,CH,LOADEOF       branch if EOF character
;LOADP01  B         LOADDERR

        CMP     CH,0FFH
        JZ      LOAD22P
        CMP     CH,0FDH
        JZ      LOADP5
        CMP     CH,0FEH
        JZ      LOADEOF
LOADP01:
        JMP     LOADDERR

;*      (note:  LOADW0 is only used if the previous program line ends exactly
;*               on a sector boundary, and the next count will be in the next sector)
;LOADW0   SB        LOADPB    load next sector

LOADW0:
        CALL    LOADPB

;* -------  Wrap mode line transfer:  ----------
;*           In wrap mode, disk file is a stream (formed by multiple 254 byte sectors)
;*           of counted strings.  Each string represents exactly a MVP memory image
;*           of a program line.  No leading FF, no KLUGESCN, no trailing CR,
;*           no trailing nulls.
;LOADW    TAP       ,C
;         BNEL      0,PL,*+2
;         BEQH      0,PL,LOADW0         jump back if end-of-sector

LOADW:
        test    counts,2000h
        jz      loadw_1

        mov     edx,aux0c
        cmp     edx,aux02
        jz      loadw0                  ;jump back if end-of sector
        mov     ch,[edx]                ;get COUNT byte
        inc     aux0c
        cmp     ch,0
        jz      loadweof                ;done file if zero file length
        mov     r6,ch
        mov     r2,ch                   ;
;
;       r2 = count byte of current byte
;       a7a6= upper limit of text area
;       aux0c= pointer in i/o buffer
;       textend= next available byte in text area
;
        mov     edx,textend
        mov     aux00,edx
        mov     dword ptr a4,edx
        xor     eax,eax
        mov     al,r2
        add     edx,eax
        cmp     edx,dword ptr a6        ;if the line won't fit in text area
        jae     loadr01
loadw3_1:                               ;          --> 1 in next sector
        mov     edx,aux0c
        cmp     edx,aux02
        jnz     loadw4_1
        call    loadpb
loadw4_1:
        mov     edx,aux0c
        xor     eax,eax
        mov     al,r2
        add     edx,eax
        mov     dword ptr a0,edx;a1a0 = terminal address
        mov     r2,0
        cmp     edx,aux02
        jb      loadw4_2        ;skip if the line is entirely in this sector
        sub     edx,aux02
        mov     r2,dl           ;r2 = byte count in next sector
        mov     edx,aux02
        mov     dword ptr a0,edx
loadw4_2:
        mov     edx,dword ptr a4
        xchg    edx,aux0c
loadw5_1:
        mov     ch,[edx]       ; up to this stmt. edx --> i/o buffer ; aux0c --> text area
        xchg    edx,aux0c
        inc     aux0c
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        cmp     edx,dword ptr a0
        jnz     loadw5_1
        xchg    edx,aux0c
        mov     dword ptr a4,edx
        cmp     r2,0
        jnz     loadw3_1
loadw9_1:
        inc     r6
        mov     byte ptr [edx],0dh
;
;       aux00           point to first character in current line
;       dword ptr a4    point to last character( hex(0d)) in current line
;       r6              byte count (including hex(0d))
;
        mov     edx,aux00       ;point to first character
scanone:
        mov     ch,[edx]        ;read one character
        inc     edx
        dec     r6              ;decrease one count
        test    ch,80h
        jnz     scanone_1
;
        cmp     ch,7ch          ;expand 7C XX ====> 7E 00 00 00 XX 00 00 00 00
        jz      loadw7c
;
        cmp     ch,7dh          ;expand 7D XX XX ==> 7D XX XX 00 00 00 00
        jz      loadw7d
;
        cmp     ch,7eh          ;just skip 7E XX XX XX XX XX XX XX XX
        jz      loadw7e
;
        cmp     ch,7fh          ;expand 7F XX XX ==> 7F XX XX 00 00 00 00
        jz      loadw7f
;
        jmp     scancont
scanone_1:
        cmp     ch,0a2h
        jz      loadwrem

        cmp     ch,0d8h
        jz      loadwrem_x
;
        cmp     ch,0fch          ;just skip FC NN XX XX ... XX
        jz      loadwfc
;
        cmp     ch,0feh          ;just skip FE NN XX XX ... XX
        jz      loadwfe
;
        cmp     ch,0ffh          ;expand FF XX XX ===> FF XX XX 00 00 00 00
        jz      loadwff
scancont:
        cmp     r6,0
        jnz     scanone
        jmp     go_ahead
loadwfc:
loadwfe:
        mov     cl,[edx]
        and     ecx,0ffh
        inc     edx
        dec     r6
loadfe_1:
        sub     r6,cl
        add     edx,ecx
        jmp     scancont
loadw7e:
        mov     ecx,8
        jmp     loadfe_1
loadwff:
loadw7d:
loadw7f:
        add     edx,2
        sub     r6,2
        mov     eax,4
        call    adjusting
        mov     dword ptr [edx],0
        add     edx,4
        jmp     scancont
loadw7c:
        mov     byte ptr [edx-1],7eh
        add     edx,1
        dec     r6
        mov     eax,7
        call    adjusting
        mov     ch,[edx-1]
        mov     dword ptr [edx-1],0
        mov     dword ptr [edx+3],0
        mov     [edx+1],ch
        add     edx,7
        jmp     scancont
loadwrem:
        cmp     byte ptr [edx],20h
        jne     loadwremx
        inc     edx
        dec     r6
        jmp     loadwrem
loadwremx:
        cmp     byte ptr [edx],'%'
        jne     loadwremz
        inc     edx
        dec     r6
loadwrema:
        cmp     byte ptr [edx],20h
        jne     loadwremy
        inc     edx
        dec     r6
        jmp     loadwrema
loadwremy:
        cmp     byte ptr [edx],'%'
        jne     loadwremz
        inc     edx
        dec     r6
        jmp     scancont
loadwremz:
        mov     ch,[edx]
        inc     edx
        dec     r6
        cmp     ch,0fdh
        jz      scancont
        cmp     ch,0dh
        jz      scancont
        jmp     loadwrem

loadwrem_x:
        mov     ch,[edx]
        inc     edx
        dec     r6
        cmp     ch,0fdh
        jz      scancont
        cmp     ch,0dh
        jz      scancont
        jmp     loadwrem_x
;
;       eax = space # will be allocated
;
adjusting:
        mov     esi,dword ptr a4
        mov     edi,esi
        add     edi,eax
        mov     dword ptr a4,edi
        mov     cl,r6
        and     ecx,0ffh
        std
        rep     movsb
        cld
        ret
go_ahead:
        mov     edx,dword ptr a4
        jmp     loadp21_1
loadw_1:
        MOV     EDX,AUX0C
        CMP     EDX,AUX02
        JZ      LOADW0

;         TPA+1,R   ,C        get COUNT byte
;         BER       CH,,LOADWEOF        done file if zero length line
;         MV        CH,F2

        MOV     CH,[EDX]                ;FIRST BYTE = COUNT BYTE
        INC     AUX0C
        CMP     CH,0
        JZ      LOADWEOF
        MOV     R2,CH

;         TAP       ,TEXTEND
;         TPA       ,0
;         MVX       PHPL,F5F4 F5F4   is destination ptr

;*    F2      =  count byte of current line
;*    A7A6    =  upper limit of text area
;*    AUXC    =  pointer in disk buffer
;*    TEXTEND =  next available byte in text area

        MOV     EDX,TEXTEND                     ; EDX   = TEXT AREA ADDRESS
        MOV     TEXTENDS,EDX                    ;  CR,x,x,x,x ^
        SUB     TEXTENDS,5
        MOV     AUX00,EDX
        MOV     DWORD PTR  A4,EDX               ;A5A4 = NEXT AVAILABLE BYTE IN TEXT AREA

;         AC,0      F2,PL,PL
;         ACI       00,PH,PH  Find where this line would end
;         BLERX     F7F6,PHPL,LOADR01   error 01 if this line won't fit.

        MOV     AL,R2
        AND     EAX,0FFH
        ADD     EDX,EAX
        CMP     EDX,DWORD PTR A6
        JA      LOADR01
        MOV     R7,0

;LOADW3
;         TAP       ,C        get pointer to first byte of line
;         BNEL      0,PL,LOADW4
;         BNEH      0,PL,LOADW4         skip if not at end of sector
;         SB        LOADPB    Load next (wrapmode) prog block

; 2ND. & 3RD.  BYTE ARE LINE NUMBER

        MOV     R6,0                    ;FLAG R6=0 DENOTE NOT CROSS BOUNDARY
        CALL    LOADADDW3               ;CONVERT FIRST LINE BCD
        CMP     R6,1
        JZ      LOADADD10
        DEC     R2                      ;IF NOT CROSS BOUND. THEN DECREASE R2
LOADADD10:
        CALL    LOADADDW3               ;CONVERT SECOND LINE BCD
        CMP     R6,1
        JZ      LOADW3
        DEC     R2
LOADW3:
        MOV     R6,0                    ;FLAG R6=0 DENOTE NOT CROSS BOUNDARY
        MOV     EDX,AUX0C
        CMP     EDX,AUX02
        JNZ     LOADW4
        CALL    LOADPB

;LOADW4   TAP       ,C
;         AC,0      F2,PL,F1  F1=last address+1 in sector
;         MVI       00,F2
;         BFL       1,SH,*+3  skip if this line is entirely in this sector

;************************************************************************
;  IN WRAP MODE :
;* CASE (1) --- the line is entirely in this sector
;* CASE (2) --- the line occupy end of this sector & begin of next sector
;*************************************************************************

LOADW4:
        MOV     EDX,AUX0C
        MOV     AL,R2
        MOV     R2,0
        AND     EAX,0FFH
        ADD     EDX,EAX
        MOV     DWORD PTR A0,EDX        ;NOT CROSS BOUNDARY  & A1A0 = TERMINATE ADDRESS
        CMP     EDX,AUX02
        JB      BP42C_10        ;BR IF THE LINE IS ENTIRELY IN THIS SECTOR & R2 =0

;         MV        F1,F2
;         MVI       00,F1
;         MVX       F5F4,PHPL
;         XPA       ,C

        SUB     EDX,AUX02       ; CROSS BOUNDARY &  A1A0 ( = END OF IOBUFFR) = TERMINATE ADDRESS
        MOV     R2,DL           ; R2  = BYTE # IN NEXT SECTOR
        MOV     EDX,AUX02
        MOV     DWORD PTR A0,EDX
BP42C_10:
        MOV     EDX,DWORD PTR A4
        XCHG    EDX,AUX0C      ;BEFORE XCHG, EDX = NEXT AVAILABLE TEXT ADDRESS, AUX0C= I/O BUFFER ADDRESS

;LOADW5   XPA+1,R   ,C
;         XPA+1,W1  CH,C
;         BNR       F1,PL,LOADW5        loop till end of sector or end of line
;         XPA       ,C
;         MVX       PHPL,F5F4
;         BNR       F2,,LOADW3loop back if it's not all copied

LOADW5:
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        CMP     CH,0FDH
        JNZ     MOD42_15
        MOV     R7,0            ;FLAG R7 = 0 MORMAL CONVERSION, R7 = 1 DON'T CONVERT
MOD42_15:
        CMP     R7,1
        JZ      LOADPW3
        CMP     CH,80H
        JB      LOADPW3
;************************************************************
;ATOM CONVERT TO ASCII CHARACTERS  IN WRAP MODE
;************************************************************
        CMP     CH,0FEH         ;FE 4 30 31 32 33 ===> "0123"
        JZ      LOADPW11
        CMP     CH,0FCH         ;FC 4 30 31 32 33 ===> HEX(33 30 33 31 33 32 33 33)
        JZ      LOADPW12
        CMP     CH,0A2H
        JZ      MOD42_14X       ;REM  STMT. DON'T CONVERT ATOM  IF ANY  UNTIL  FD ENCOUNT OR END OF LINE(R2=0)
        CMP     CH,0D8H
        JNZ     MOD42_14
        jmp     m_z
MOD42_14X:
        mov     eax,aux0c
m_y:    cmp     byte ptr [eax],20h
        jne     m_x
        inc     eax
        jmp     m_y
m_x:    cmp     byte ptr [eax],'%'
        jne     m_z
        inc     eax
m_b:    cmp     byte ptr [eax],20h
        jne     m_a
        inc     eax
        jmp     m_b
m_a:    cmp     byte ptr [eax],'%'
        jne     m_z
        mov     r7,0
        jmp     m_c
m_z:    MOV     R7,1
m_c:    CALL    ATOMKEY         ;ATOM CONVERT
        XCHG    EDX,AUX0C       ; R7=1 AFTER HERE , DON'T CONVERT
        JMP     LOADPW7
MOD42_14:
        CMP     CH,0FFH
        JNZ     LOADPW8         ; RUGULAR ATOM CONVERSION
        MOV     DWORD PTR A4,EDX
        CALL    LINENOW         ;FF 1230    ===> 31 32 33 30
        XCHG    EDX,AUX0C
        JMP     LOADPW7
LOADPW10:
        XCHG    EDX,AUX0C
        JMP     LOADPW7
;
; FOR PROCESS  FE 4 30 31 32 33 ===> "0123"
;
LOADPW11:
         CALL   ATOMKEY
         XCHG   EDX,AUX0C
         MOV    R6,0            ;FLAG THAT ALREADY CROSS BOUNDARY ?
                                ; R6 = 0 , NO         R6 = 1 , YES
                                ; R2 DECREASE ONE IF R6=1 , R2 =SAME IF R6=0
                                ; R2 FOR GOBACK LOADW3 USE ( COMPUTE LENGTH UNPROCESS YET)
;*   QUOTE literal logic.   Assumes nonzero literal length

        CMP     EDX,AUX02
        JNZ     LOADPW20
        XCHG    EDX,AUX0C
        PUSH    EDX             ;LOADPB DESTROY EDX ,THEREFORE PUSH EDX
        CALL    LOADPB
        DEC     R2              ;CASE(1)
        MOV     R6,1
        POP     EDX
        XCHG    EDX,AUX0C
LOADPW20:
        MOV     CH,[EDX]        ;(1) .... FE, 4 41 42 43 44 ....
        MOV     R3,CH           ;(2) .... FE 4, 41 42 43 44 ....
        INC     EDX             ;(3) .... FE 4 41, 42 43 44 ....
LOADPW13:
        CMP     EDX,AUX02       ;CASE(2) & CASE(3)
        JNZ     LOADPW21
        XCHG    EDX,AUX0C
        PUSH    EDX
        CALL    LOADPB          ; IF CROSS BOUNDARY , LOAD NEXT SECTOR & SET R6
        MOV     R6,1            ; OTHERS THE SAME
        POP     EDX             ;
        XCHG    EDX,AUX0C       ; AFTER XCHG, EDX= I/O BUFFER ADDRESS , AUX0C = AVAIL TEXT AREA
LOADPW21:
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C           ; READ A CHARACTER
        CMP     R6,1            ; IF R6=1 THEN R2=R2-1
        JNZ     LOADPW26
        DEC     R2
LOADPW26:
        MOV     [EDX],CH        ;WRITE A CHARACTER
        XCHG    EDX,AUX0C
        INC     AUX0C           ; UP TO NOW, AUX0C= AVAIL TEXT AREA & EDX = I/O BUFFER
        DEC     R3
        JNZ     LOADPW13        ; IF END OF QUOTE LITERIALS
        XCHG    EDX,AUX0C
        MOV     BYTE PTR [EDX],'"'    ; IF END OF QUOTE , WRITE A '"'
        XCHG    EDX,AUX0C
        INC     AUX0C
        JMP     LOADPW7
;
; FOR PROCEEE FC 4 30 31 32 33  ====>  HEX(33 30 33 31 33 32 33 33)
;
LOADPW12:
         CALL   ATOMKEY
         XCHG   EDX,AUX0C
         MOV    R6,0

;*   HEX( ) literal logic.   Assumes nonzero literal length

        CMP     EDX,AUX02
        JNZ     LOADPW22
        XCHG    EDX,AUX0C
        PUSH    EDX
        CALL    LOADPB
        MOV     R6,1
        DEC     R2
        POP     EDX
        XCHG    EDX,AUX0C               ;SAME AS "    "
LOADPW22:
        MOV     CH,[EDX]
        MOV     R3,CH
        INC     EDX
LOADPW14:
        CMP     EDX,AUX02
        JNZ     LOADPW23
        XCHG    EDX,AUX0C
        PUSH    EDX
        CALL    LOADPB
        MOV     R6,1
        POP     EDX
        XCHG    EDX,AUX0C
LOADPW23:
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        CMP     R6,1
        JNZ     LOADPW27
        DEC     R2
;
; DIFFERENT BETWEEN HEX(  ) AND "    "
;
LOADPW27:
        PUSH    CX              ;save ch
        MOV     AL,CH
        SHR     AL,4
        MOV     R0,AL
        CALL    HEXFIX          ; HIGH NIBBLE ====> ASCII
        MOV     CH,R0
        MOV     [EDX],CH
        INC     EDX             ;restore ch
;
        POP     CX
        MOV     R0,CH
        AND     R0,0FH
        CALL    HEXFIX
        MOV     CH,R0
        MOV     [EDX],CH        ; LOW NIBBLE ====> ASCII
;
        XCHG    EDX,AUX0C
        INC     AUX0C           ; EDX= I/O BUFFER & EDX= AVAIL TEXT AREA
        DEC     R3
        JNZ     LOADPW14
        XCHG    EDX,AUX0C
        MOV     BYTE PTR [EDX],')'
        XCHG    EDX,AUX0C
        INC     AUX0C
        JMP     LOADPW7

LOADPW8:
        CALL    ATOMKEY                         ;REGULAR ATOM CONVERSION
        XCHG    EDX,AUX0C
        JMP     LOADPW7

LOADPW3:                                         ;JUST COPY CHARACTER ( BELOW 80H)
        MOV     [EDX],CH
        XCHG    EDX,AUX0C
        INC     AUX0C
LOADPW7:
        CMP     R6,1
        JZ      LOADPW25                        ; IF NOT CORSS BOUNDARY
        CMP     EDX,DWORD PTR A0                ; A1A0 = TERMINATE ADDRESS
        JNZ     LOADW5
LOADPW25:
        MOV     R6,0                            ; IF CROSS BOUNDARY
        XCHG    EDX,AUX0C                       ; RESET R6
        MOV     DWORD PTR A4,EDX                ; A5A4 = AVAIL TEXT AREA
        CMP     R2,0
        JNZ     LOADW3                          ; R2 = BYTE COUNT

;LOADW9   MVX       F5F4,PHPL
;         MVI       0D,F0     write a CR into memory
;         B         LOADP21   goto end of line processing

LOADW9:
        MOV     R7,0
        MOV     EDX,DWORD PTR A4
        MOV     R0,0DH
        JMP     LOADP4

;
;**** FOR PROCESS A ACTUAL TEXT LINE IN NON-WRAP MODE ONLY ****
;
LOAD22P:

        test    counts,2000h
        jz      load22p_1               ;br if 2200 format

        mov     edx,aux0c               ;aux0c point to iobuffer
        mov     ch,[edx]                ;get first character in line
        inc     aux0c
        mov     edx,textend             ;point to text area
        mov     aux00,edx               ;save ptr to line # in text area
        cmp     edx,dword ptr a6        ; up to now, edx = point to text area
        jae     loadp70                 ;            aux0c = point to i/o buffer
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c                   ; write one character
loadp2_1:
        mov     ch,[edx]                ; read  next character
        xchg    edx,aux0c
        inc     aux0c
        cmp     ch,0dh                  ; skip if it's CR
        jz      loadp22_1
        test    ch,80h
        jnz     head_fx                 ; br if r0 may be Fx ,otherwise may be 7x
        cmp     ch,7ch
        jz      loadsmall               ; 7C XX =====> 7E 00 00 XX 00 00 00 00 00
        cmp     ch,7eh
        jz      loadcon                 ; just copy constant 7E XX XX XX XX XX XX XX XX
        cmp     ch,7fh
        jz      loadvar
        cmp     ch,7dh                  ; just copy variable & matrix  7F XX XX xx xx xx xx
        jz      loadvar                 ; insert xx xx xx xx
        cmp     edx,dword ptr a6        ; up to now, edx = point to text area
        jae     loadp70                 ;            aux0c = point to i/o buffer
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c                   ; write one character
        jmp     loadp2_1
head_fx:
        cmp     ch,0a2h
        jz      loadrem
        cmp     ch,0D8h
        jz      loadrem_x
        cmp     ch,0ffh                 ; just  copy line reference  FF XX XX xx xx xx xx
        jz      loadlin
        cmp     ch,0feh
        jz      loadhexx                ; just copy FC XX XX XX .... XX
        cmp     ch,0fch
        jz      loadquotx               ; just copy FE XX XX XX .... XX
fixx:
        cmp     edx,dword ptr a6        ; up to now, edx = point to text area
        jae     loadp70                 ;            aux0c = point to i/o buffer
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c                   ; write one character
        jmp     loadp2_1
loadsmall:
        mov     byte ptr [edx],7eh
        mov     dword ptr [edx+1],0
        mov     dword ptr [edx+5],0
        mov     ebx,aux0c
        mov     ch,[ebx]
        mov     [edx+3],ch
        add     edx,9
        inc     aux0c
        xchg    edx,aux0c
        jmp     loadp2_1

loadrem:
        mov     eax,aux0c
l_y:    cmp     byte ptr [eax],20h
        jne     l_x
        inc     eax
        jmp     l_y
l_x:    cmp     byte ptr [eax],'%'
        jne     l_z
        inc     eax
l_b:    cmp     byte ptr [eax],20h
        jne     l_a
        inc     eax
        jmp     l_b
l_a:    cmp     byte ptr [eax],'%'
        jne     l_z
        inc     eax
        mov     byte ptr [edx],ch
        inc     edx
        push    ecx
        push    esi
        push    edi
        mov     ecx,eax
        sub     ecx,aux0c
        mov     esi,aux0c
        mov     edi,edx
        rep     movsb
        mov     edx,edi
        mov     aux0c,esi
        pop     edi
        pop     esi
        pop     ecx
        xchg    edx,aux0c
        jmp     loadp2_1

loadrem_x:
l_z:    mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
loadrem1:
        mov     ch,[edx]
        xchg    edx,aux0c
        inc     aux0c
        cmp     ch,0dh
        jz      loadp22_1
        cmp     ch,0fdh
        jz      fixx
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        jmp     loadrem1
loadcon:
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        mov     al,8
loadcon1:
        mov     ch,[edx]
        xchg    edx,aux0c
        inc     aux0c
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        dec     al
        jnz     loadcon1
        jmp     loadp2_1
loadlin:
loadvar:
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        mov     al,2
loadlin1:
        mov     ch,[edx]
        xchg    edx,aux0c
        inc     aux0c
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        dec     al
        jnz     loadlin1
        mov     eax,aux0c
        mov     dword ptr [eax],0
        add     aux0c,4
        jmp     loadp2_1
loadhexx:
loadquotx:
        mov     [edx],ch
        xchg    edx,aux0c
        inc     aux0c
        mov     al,[edx]
        xchg    edx,aux0c
        inc     aux0c
        mov     [edx],al
        xchg    edx,aux0c
        inc     aux0c
        jmp     loadcon1
loadp22_1:
        cmp     dword ptr a6,edx
        jbe     loadp70
        xchg    edx,aux0c
        cmp     edx,aux02
        jae     loadderr
        xchg    edx,aux0c
loadp21_1:
        mov     byte ptr [edx],0dh      ; CR ====> text area
        mov     textend,edx             ; textend point to CR
        mov     edx,aux00
        mov     textlptr,edx
        sub     textlptr,4              ; textlptr point to THREAD
        mov     textptr,edx
        add     textptr,2               ; textptr  point to FIRST CHARACTER
        mov     cx,[edx]                ; edx      point to LINE #
        xchg    ch,cl
        mov     dx,cx
        xchg    edx,aux06
        cmp     cx,dx                   ; skip if line # <= line # of last line
        jbe     loadp21_2
        mov     edx,aux05               ; aux05 = line # last threaded to
        cmp     cx,dx
        jb      loadp3_1
loadp21_2:
        mov     word ptr r2,cx          ;slow thread
        call    threadl
        jmp     loadp8_1
loadp3_1:
        mov     eax,textlptr            ;fast thread
        mov     edx,aux0a               ;eax= thread of new line
        mov     ecx,[edx]               ;ecx= thread of last line
        mov     [edx],eax               ;thread last line to new line
        mov     edx,textlptr
        mov     [edx],ecx               ;thread new line to line last line was threaded to
loadp8_1:
        mov     edx,textlptr
        mov     aux0a,edx               ;aux0a=address of new line (last line next time)
        mov     ecx,[edx]
        cmp     ecx,0
        ja      loadp8_2
        mov     edx,0ffffh
        jmp     loadp12_1
loadp8_2:
        mov     edx,ecx
        add     edx,4
        mov     cx,[edx]
        xchg    ch,cl
        mov     dx,cx
loadp12_1:
        mov     aux05,edx
        jmp     enter_

load22p_1:
        MOV     EDX,TEXTEND                     ; EDX   = TEXT AREA ADDRESS
        MOV     TEXTENDS,EDX                    ;  CR,x,x,x,x ^
        SUB     TEXTENDS,5                      ; SET TEXTENDS HERE & SET TEXTEND AFTER FOR PROCST PROCEDURE ENTRY
        CALL    LINENO                          ; CONVERT PACKED BCD LINE NO. TO ASCII
        XCHG    EDX,AUX0C
        MOV     CH,[EDX]                        ; CH = CHARACTER READ FROM I/O BUFFER
        XCHG    EDX,AUX0C
        INC     AUX0C                           ; AUX0C = POINT TO NEXT CHARACTER IN I/O BUFFER
;*********************************************************************
;* ANOTHER DIFFICULTY IS
;*  SKIP REM STMT. UNTIL <CR> ,":"    (ATOM)A2  10 REM xxxxxxxxxxx
;*                                              xxxx has ":"
;*  SKIP '"' UNTIL '"'                (ASCII)   10 A$="____"
;*
;*  DATA & % HAS "        "  INHABIT NORMAL CONVERT
;*
;*********************************************************************
LOADP2:
        CMP     CH,0DH
        JZ      LOADP4          ;BR IF CARRIAGE RETURN
;
        CMP     CH,'"'          ;ENCOUNT FIRST " (BEGIN QUOTE)
        JNZ     MOD42_01
MOD42_02:
        MOV     [EDX],CH
        XCHG    EDX,AUX0C
        INC     AUX0C           ;JUST SKIP(COPY) THE LITERALS IN "    "
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        CMP     CH,'"'          ;ENCOUNT LAST "  (END QUOTE)
        JZ      loadp3
        cmp     ch,0dh
        jz      loadp4
        JMP     mod42_02
;
MOD42_01:
        CMP     CH,80H
        JB      LOADP3
;******************************* ******************
;ATOM CONVERT TO ASCII CHARACTERS  IN NON-WRAP MODE
;******************************* ******************
        CMP     CH,0A2H
        JZ      MOD42_XX
        CMP     CH,@?PE                         ;REM
        JNZ     MOD42_04
        MOV     DUM_FLG1,1      ;W.R. 7/25/89
        call    atomkey
        xchg    edx,aux0c
        jmp     mod42_05
;
MOD42_XX:
        CALL    ATOMKEY
;;      mov     dum_flg,0
        XCHG    EDX,AUX0C
        mov     eax,edx
k_y:    cmp     byte ptr [eax],20h
        jne     k_x
        inc     eax
        jmp     k_y
k_x:    cmp     byte ptr [eax],'%'
        jne     k_z
        inc     eax
k_b:    cmp     byte ptr [eax],20h
        jne     k_a
        inc     eax
        jmp     k_b
k_a:    cmp     byte ptr [eax],'%'
        jne     k_z

        mov     ch,[edx]
        xchg    edx,aux0c
        inc     aux0c
        MOV     [EDX],CH
        XCHG    EDX,AUX0C
        INC     AUX0C
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        jmp     loadp2
k_z:
MOD42_05:
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C                           ; SKIP UNTIL <CR> ENCOUNTER
        CMP     CH,0DH
        JZ      LOADP4
        MOV     [EDX],CH
        XCHG    EDX,AUX0C
        INC     AUX0C
;;
;;      cmp     ch,22h
;;      je      mod42x_0
;;
        TEST    DUM_FLG1,1
        JNZ     MOD42_05

        CMP     CH,':'                          ; OR SKIP UNTIL : ENCOUNTER
        JNZ     MOD42_05
;;
;;      test    dum_flg,1               ;if in "  " nest?
;;      jnz     mod42_05                ;br, if yes
;;
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        JMP     LOADP2

;;
;;mod42x_0:
;;        test    dum_flg,1               ;chk if the 2nd "
;;        jz      mod42x_1                ;no
;;        mov     dum_flg,0               ;reset flag
;;        jmp     mod42_05                ;get next
;;mod42x_1:
;;        mov     dum_flg,1               ;1st recieved
;;        jmp     mod42_05                ;get next
;;
 MOD42_04:
;
        CMP     CH,0FFH                         ;PROCESS LINE NO. REFERENCE
        JNZ     LOADP8
        CALL    LINENO
LOADP10:
        XCHG    EDX,AUX0C
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        JMP     LOADP2
LOADP8:
        CALL    ATOMKEY
        XCHG    EDX,AUX0C
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        JMP     LOADP2

LOADP3:                                         ;JUST COPY
        MOV     [EDX],CH
        XCHG    EDX,AUX0C
        INC     AUX0C
        MOV     CH,[EDX]
        XCHG    EDX,AUX0C
        INC     AUX0C
        JMP     LOADP2
LOADP4:
        MOV     BYTE PTR [EDX],0DH
        MOV     TEXTEND,EDX                     ;SET TEXTEND HERE & SET TEXTENDS BEFORE
        MOV     DUM_FLG1,0

        mov     edx,dword ptr [cpbase]
        lea     edi,[edx].@iobuffr              ; I/O BUFFR + 400T  <=======
        add     edi,400
        lea     esi,aux0c
        mov     ecx,4
        rep     movsd
        lea     esi,aux05
        mov     ecx,2
        rep     movsd

        JMP     PROCST

;**** FOR PROCESS END OF FILE ****

LOADWEOF:
        MOV     CH,[EDX]
        INC     EDX
        CMP     CH,0
        JNZ     LOADDERR
        CMP     EDX,AUX02
        JNZ     LOADWEOF
LOADEOF:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        TEST    BYTE PTR [EDX],20H
        JZ      LOADDERR
        AND     MODE,0FFFF7FFFH

;         SB        ROSBEG39  GET DA FLAG ('OSBEG'+39)
;         BER       CH,,LOADP11         BRANCH IF NOT DA
;         TPA+3     ,0        AUX0 = ADDRESS OF 'OSBEG'+3C
;         MV        CH,F0
;         MV        CH,F2

;**** HOW TO ARRANGE THE 'OSBEG' + 39  -- DA FLAG           (1)
;                                + 3A  -- RECEIVER COUNT    (2)
;                                + 3C  -- RECEVIER ADDRESS  (4)


        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@OSBEG
        ADD     EDX,39H
        MOV     CH,BYTE PTR [EDX]
        CMP     CH,0
        JZ      LOADP11
        MOV     AUX00,EDX
        ADD     AUX00,5
        MOV     R0,CH
        MOV     R2,CH

;         SB        PUSHFO    RECEIVER VAR. ATOM ==> OS
;         TAP       ,0
;         TPA-2,R   ,0        AUX0 = ADDRESS OF 'OSBEG'+3A
;         MVX       CHCL,F1F0
;         SB        PUSHFV2   RECEIVER VAR. ADDRESS ==> VS

        MOV     EDX,OSPTR    ;GET POINTER TO LAST OS ATOM
        INC     EDX          ;INCREMENT PC'S
        CMP     EDX,DWORD PTR [@@OSEND]   ;OVER LIMIT?
        JE      ERROR_04
        MOV     AL,R0        ;STORE ATOM IN OS, INCREMENT OSPTR
        MOV     BYTE PTR [EDX],AL
        MOV     OSPTR,EDX
        MOV     EDX,AUX00
        MOV     ECX,[EDX]
        SUB     AUX00,4
        MOV     EDX,VSPTR
        MOV     [EDX-4],ECX
        SUB     VSPTR,4

;         BEQL      0,F2,LOADP14        BRANCH IF NUMERIC RECEIVER
;         TAP       ,0
;         ,R        ,
;         MVX       CHCL,F1F0
;         SB        PUSHFV2   RECEIVER VAR. COUNT ==> VS

        TEST    R2,0FH
        JZ      LOADP14
        MOV     EDX,AUX00
        MOV     ECX,[EDX]
        MOV     DWORD PTR A0,ECX
        MOV     EDX,VSPTR
        MOV     [EDX-4],ECX
        SUB     VSPTR,4

;LOADP14  SB        RECSCTR   UPDATE RECEIVER VARIABLE
;LOADP11  SB        ZDATAPTR  INIT. DATA PTRS
;         TAP       ,9
;         BNR       -,PL,LOADP13        BRANCH IF MORE FILES TO LOAD
;         SB        ENDDISKR  CLOSE DISK IF NOT HOGGED

LOADP14:
        CALL    RECSCTR
LOADP11:
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     DWORD PTR [EDX].@DBASE,EDX   ;@DBASE = CPBASE
        MOV     ECX,DWORD PTR [EDX].@TEXTBEG ;GET TEXTBEG POINTED TO BY CPBASE
        MOV     DWORD PTR [EDX].@DATAPTR,0   ;DATAPTR = 0
        MOV     DWORD PTR [EDX].@DATALPT,ECX ;DATALPT = TEXTBEG
        MOV     EDX,AUX09
        CMP     DL,0
        JNZ     LOADP13         ;IN LOADP13 LABEL ,WE DECREASE EDX
        CALL    ENDDISKR
LOADP15:
        MOV     EDX,MODE
        TEST    DH,2
        JNZ     BP42C_15
        JMP     LOADP6
BP42C_15:
        AND     DH,0FDH
        MOV     MODE,EDX

        MOV     EDX,CONTLN_
        AND     DH,0F0H
        CMP     DH,0F0H
        JZ      LOADP9
        MOV     EDX,MODE
        OR      DL,1
        MOV     MODE,EDX
LOADP9:
        CALL    ENBLNULL
        MOV     CH,SYSGENFG
        AND     CH,0FFH-MIBOOT
        MOV     SYSGENFG,CH
        CALL    SLCT@CLR
        JMP     RUNB

;LOADP13  TPA       ,9        DECREMENT NO. OF FILES TO LOAD
;         ORI       XPHASE,SL,SL        RESET PHASE TO EXECUTION
;         B         LOADDC4

LOADP13:
        DEC     EDX
        MOV     AUX09,EDX
        OR      SL,XPHASE
        JMP     LOADDC4

;         TITLE     LOADPW
;*     note:  should consider not using aux 0 in mainline, to avoid
;*            this routine having to save/restore.
;*     LOADPB: load program block
;*              mod regs:  PC's , F0,F1  K    Aux 0 C F
;*              Aux usage:   Aux C - address in IObuffer
;*                  MODE - protect, load mode
;*     NOTE: in MVP @3.L  I removed the logic to check whether protected sectors
;*           were mixed with unprotected.  It still seems like it was a good idea,
;*           but some vendor was generating code at the end of his scrambled program.
;*           Well, at least if they try it with Wrap-Mode scramble, it won't work.
;LOADPB
;         TAP       ,MODE
;         ANDI      0FF-80,PH,PH        Load mode off (in case of errors)
;         TPA       ,MODE
;         TAP       ,0        Save aux 0

LOADPB:
        MOV     EDX,MODE
        AND     DH,0FFH-80H
        MOV     MODE,EDX
        MOV     EDX,AUX00

;         TPS
;         SB        RIOBUFFR  CH= byte 0 of previous sector
;         BTHH      20,CH,LOADDERR      error if last was EOF, and we didn't notice it
;         SB        LOADPBLK  read in (next) sector of program

        PUSH    EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,[EDX]
        XCHG    CH,CL
        CMP     CH,20H

        JE      LOADDERR
        CALL    LOADPBLK

;LOADPB5
;         TSP
;         TPA       ,0        restore aux 0
;         SB        RSAVEA
;         BFLL      01,CL,LOADPB6
;         TAP       ,C        if wrap mode, then
;         TPA+2     ,C        increment past the FF in byte 01
;*                                        and checksum in 02
;         SB        CHECKSUM
;         BNR       F0,,LOADDERR        check the checksum
LOADPB5:
        POP     EDX
        MOV     AUX00,EDX
        MOV     EDX,DWORD PTR [CPBASE]    ;2 byte scratch area used currently only
        LEA     EDX,[EDX].@RSAVE          ;only by SAVE/LOAD during X phase.
        MOV     CX,[EDX]
        XCHG    CH,CL
        TEST    CL,1
        JZ      LOADPB6
        MOV     EDX,AUX0C
        ADD     AUX0C,2
        CALL    CHECKSUM
        CMP     R0,0
        JNZ     LOADDERR

;LOADPB6  SB        RIOBUFFR
;         ANDI      0FF-3F,CH,F1
;         BNR       F1,,LOADDERR        byte 00 may be 0X,1X,2X,or3X
;         MVI       0FE,F1
;         AND       F1,CL,F0

LOADPB6:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        MOV     AL,CH
        AND     AL,0FFH-3FH
        MOV     R1,AL
        CMP     AL,0
        JNZ     LOADDERR
        MOV     R1,0FEH
        MOV     AL,R1
        AND     AL,CL
        MOV     R0,AL

;         BNR       F1,F0,LOADDERR      byte 01 may be FF or FE
;         TAP       ,MODE
;         ORI       80,PH,PH  Load mode on
;         TPA       ,MODE
;         SR

        CMP     AL,R1
        JNZ     LOADDERR
        MOV     EDX,MODE
        OR      DH,80H
        MOV     MODE,EDX
        RET

;         TITLE     LOADPT
;*     LOADPT: GET NEXT TEXT LINE FROM PAPER TAPE
;*             READER AND PROCESS IT.
;*
;*
;LOADPT   MVX       CHCL,PHPL
;         SB        ENBLDEVI  ENABLE LOAD DEVICE
;         MVI       02,K
;         SB        OBSTROBE  START OF OPERATION (MVP FLAG FOR CARD READER)
;         SB        READPTL   GET NEXT LINE OF PROGRAM

LOADPT:
        MOV     DX,CX
        CALL    ENBLDEVI
        MOV     K,2
        CALL    OBSTROBE
        CALL    READPTL

;         BEQL      3,K,LOADPT1         BRANCH IF X-OFF FOUND (EOF)
;         SB        RIOBUFFR  POINT TO 'IOBUFFER'
;         TPA       ,0        POINT TO LINE NUMBER
;         TAP       ,IBUFBEG
;         MVX       PHPL,F7F6 POINT TO END OF TEXT

        CMP     K,13H
        JZ      LOADPT1
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     AUX00,EDX
        MOV     EDX,IBUFBEG
        MOV     DWORD PTR A6,EDX

;         MVI       80,F5     FLAG = LOAD MODE
;         SB        PUTLINF   TRANSFER LINE TO TEXT AREA
;         TAP       ,TEXTEND
;         ORI,W1    0D,,      PUT CR AT END OF TEXT LINE
;         B         PROCST    PROCESS TEXT LINE (ENTRY PHASE)

        MOV     R5,80H
        CALL    PUTLINF
        MOV     EDX,TEXTEND
        MOV     BYTE PTR [EDX],0DH
        JMP     PROCST

;LOADPT1  TAP       ,MODE
;         ANDI      7F,PH,PH  LOAD MODE OFF
;         TPA       ,MODE
;         B         LOADP15

LOADPT1:
        MOV     EDX,MODE
        AND     DH,07FH
        MOV     MODE,EDX
        JMP     LOADP15

;****************************************************************
;* GOAL : REPLACE THE ATOM  BY THE ASCII KEYWORD
;       FOR EXAMPLE:
;               A0     ====>   PRINT
;       ENTRY:  ^  ^           ^     ^
;              AUX0C          EDX    |
;                 AUX0C             EDX
;*****************************************************************
ATOMKEY:

        lea     esi,org0100
        mov     edi,edx
        mov     bl,ch
        sub     bl,80h
        and     ebx,0ffh
        shl     ebx,3
        mov     esi,[esi+ebx]
        and     esi,0fffffffh
        mov     cl,[esi]
        inc     esi
        and     ecx,0ffh
        rep     movsb
        mov     edx,edi

        RET

;********************************************************************
; GOAL: CONVERT PACKED BCD LINE # TO ASCII LINE #
;       FOR EXAMPLE:
;                10 30        =====>       31 30 33 30
;       ENTRY:   ^     ^                   ^           ^
;                      |                               |
;               AUX0C  |                  EDX          |
;                      |                               |
;       RETURN:       AUX0C                           EDX
;
;*********************************************************************

LINENO:
        MOV     ESI,AUX0C
        CALL    LINENO1
LINENO1:
        MOV     CH,[ESI]
        MOV     CL,CH
        SHR     CH,4            ;GET HIGH NIBBLE
        ADD     CH,00H
        MOV     [EDX],CH
        INC     EDX
        AND     CL,0FH          ;GET LOW NIBBLE
        ADD     CL,00H
        MOV     [EDX],CL
        INC     EDX
        INC     ESI
        MOV     AUX0C,ESI
        RET
;**********************************************************************
; GOAL: IN WRAP MODE , CONVERT PACKED BCD LINE NO. TO  ASCII
;       SAME AS LINENO SUBROUTINE, EXCEPT CHECK THE I/O BUFFER BOUNDARY
;       ENTRY:
;            AUX0C = POINTER TO I/O BUFFER
;            A5A4  = POINTER TO TEXT AREA
;
;       RETURN:
;            AUX0C= POINT TO NEXT CHAR IN I/O BUFFER
;            A5A4 = PONIT TO NEXT AVAIL TEXT AREA
;            R6   = FLAG 0  -- NOT CROSS BOUNDARY YET
;                        1  -- CROSS BOUNDARY
;            R2   =  DECREASE IF R6=1
;                    SAME        R6=0
;**********************************************************************

LINENOW:
        MOV     R6,0
        CALL    LOADADDW3               ;(1) ...... 10 , 12 30 .....
LOADADDW3:                              ;(2) ...... 10 12 , 30 .....
        MOV     EDX,AUX0C               ;(3) .......10 12 30, ......
        CMP     EDX,AUX02               ;            ^  ^_^
        JNZ     LOADADDW4               ;         count, line number
        CALL    LOADPB                  ;
        MOV     R6,1                    ; FF,12 30
LOADADDW4:                              ; FF 12,30
        MOV     ESI,AUX0C               ; FF 12 30
        MOV     EDX,DWORD PTR A4
        CALL    LINENO1
        CMP     R6,1
        JNZ     LOADADDW5
        DEC     R2
LOADADDW5:
        MOV     DWORD PTR A4,EDX
        RET

;         TITLE     SAVEBYTE
;*   SAVEBYTE -- save a byte to buffer, build a program save file
;*               this emulates a stream file, in that successive writes
;*               automatically add to the 'end'.
;*   ENTRY:         F0 = character to write
;*                  F2 = count in current line
;*                  F6 bit SAP1 contains pass 1 flag
;*                        in pass 0, only increment the count.  Pass 1 actually writes
;*                  AUX C = buffer pointer
;*                       ( buffer is on 256 byte boundary)
;*                  AUX E = flags
;*                  AUX 2 = pointer to current lin  #
;*                  AUX C,E as needed
;*    RETURN:       F2 contains running count of bytes written for this line
;*                         in pass0, it increments from 00, in pass1 it decrements back to 00
;*
;*   Alternate Entry:   SAVEBCH   write byte from CH   (changes F0, obviously)
;*   Other alternate:   SAVEBY    writes F0, assumes pass 1, doesn't count F2
;*
;*  MODIFIED REGISTERS:   F2,F7, PHPL, CHCL, K    AUX 0,1,F
;*           NOTE:   F0 is preserved

;SAVEBCH  MV        CH,F0     output byte in CH
;SAVEBYTE
;         BTLL      SAP1,F6,SAVEB1      skip if pass 1
;*     pass 0, increment count only
;         AC,1      F2,,F2    increment byte count
;         BFL       1,SH,SAVEBR         return if <255

;***************************************************************************
;* EVERY BYTE IN EVERY LINE MUST BE PROCESSED BY SAVEBYTE
;*         PASS 0 --- WE CAN PREVIOUSELY KNOW BYTE # IN THIS LINE
;*         PASS 1 --- WE CAN CHECK THIS LINE BYTE # EXCEED I/O BUFFER OR NOT ?
;*                    THEN ACTUALLY WRITE IT
;****************************************************************************
SAVEBCH:
        MOV     R0,CH
SAVEBYTE:
        TEST    R6,SAP1         ;PASS 0  ---- R2 INCREMENTS FROM 00 ONLY
        JNZ     SAVEB1          ;PASS 1  ---- R2 DECREMENTS BACK TO 00 & ACTUALLY WRITES
        ADD     R2,1
        JNC     SAVEBR

;WRAPERR  B         ERROR#05  err=5, line too long
;* pass 1, write out the byte to the disk buffer
;SAVEB1
;         AI        0FF,F2,F2 decrement byte count
;SAVEBY   TAP       ,C
;         BNR       +,PL,SAVEB2         skip if not end of buffer


        mov     eax,dword ptr [cpbase]
        mov     edx,aux02
        mov     dword ptr [eax].@spreg1,edx

WRAPERR:
        JMP     ERROR_05
SAVEB1:
        DEC     R2
SAVEBY:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EBX,[EDX].@IOBUFFR
        ADD     EBX,100H
        MOV     EDX,AUX0C       ;NOW, THE BUFFER MAY NOT BE ON 256 BYTE BOUNDARY
                                ;ENTRY:   CALL  RIOBUFFR
        CMP     EDX,EBX         ;         ADD   EDX,100H
        JNZ     SAVEB2          ;         MOV   EBX,EDX  -- END ADDRESS OF I/O BUFFER

;*  Buffer full, write a block   (saving and restoring F1F0)
;         BTHH      SAWM,F6,*+2         ????????????????????
;         B         ERROR#00  system error if not wrap mode ??????
;         MVX       F1F0,PHPL
;         TPS

        TEST    R6,SAWM
        JNZ     BP42A_01
        JMP     ERROR_00
BP42A_01:
        MOV     DX,WORD PTR R0
        PUSH    EDX
        push    esi

;         SB        SAVEPBLB  write block
;         TSP
;         MVX       PHPL,F1F0

        CALL    SAVEPBLB
        pop     esi
        POP     EDX
        MOV     WORD PTR R0,DX

;SAVEB2
;         TAP       ,C
;         TPA+1,W1  F0,C      write the byte to the buffer
;SAVEBR   SR

SAVEB2:
        MOV     EDX,AUX0C
        MOV     AL,R0
        MOV     BYTE PTR [EDX],AL
        INC     AUX0C
SAVEBR:
        RET

;         TITLE     SAVERPRG
;*     SAVERPRG:   Save program (or specified portion thereof)
;*            currently in memory on disk in the 2600 program
;*            record format.
;*
;*            (For other record format devices patch into 'SAVEPBLK')
;*
;*     ENTRY:
;*        phase = execution
;*        disk enabled
;*        auxE = platter, file#, R/w, saveP
;*        F7F6 = Starting line-no for save
;*               F7,6 = STARTING LINE-NO. FOR SAVE
;*               F5,4 = ENDING LINE-NO. FOR SAVE
;*               AUXD = EOF ADDRESS (CANNOT RECORD BEYOND
;*                      THIS POINT)
;*               AUXB = START ADDRESS OF FILE
;*
;*               WORKSPACE CONTAINS PROGRAM NAME.
;*
;*          RETURN:
;*               AUXF = ADDR OF PROGRAM TRAILER BLOCK +1
;*
;*          REGISTER USE:
;*               AUX4 = program pointer. (points to next
;*                      byte in text line to copy from).
;*               AUXC = BUFFER POINTER (Points to next
;*                      character location in block buffer.)
;*
;*               AUX2 = ADDRESS OF LINE-NUMBER OF LINE
;*                      CURRENTLY BEING ENTERED
;*               AUXE = flags
;*                           *  8000 bit R compression mode
;*                           *  4000 bit S compression mode
;*                              2000 bit Read-after-write  ($)
;*                           *  1000 bit P protect mode
;*                              0F00 bits   File#
;*                           *  0080 bit ! protect mode
;*                           *  0040 bit Wrap mode    (new in MVP 3.0)
;*                              0020 bit   (unused)
;*                              0010 bit   (unused)
;*                              000F bits  platter  (F R T)
;*               F2   = Count in current line  (maintained mostly by SAVEBYTE)
;*               F3   = Count for leading space per statement, and for literals
;*               F5F4 = Ending line #
;*               F6   = FLAGS:  80=R, 40=S, 20=local'space compress'
;*                              10=wrap mode
;*                              08= flag that this is non the first statement
;*                                       (Zero used to suppress colon)
;*                              04= pass 1 flag
;*     COMPRESSION FLAG:  XXXW L000    (F6)
;*                        !!!! !!----- Pass 1 flag
;*                        !!!! !------ Not first stmt on line
;*                        !!!!
;*                        !!!!-------- wrap mode
;*                        !!!--------- 0 IF SPACE COMPRESS
;*                        !!              DISABLED
;*                        !!---------- 1 IF COMPRES SPACES
;*                        !----------- 1 IF COMPRESS REM'S
;*               F5,4 = END LINE-NUMBER FOR SAVE
;*               F3 = count for literals
;*               F2 = count for current text line
;*                     This count increments in Pass 0, then decrements in
;*                     pass 1, to end at 00.  If it doesn't, then system error.
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0-3,F7,F6
;*                              AUX0,1,2,3,4,???,C,F
;*
;*     PROCESS HEADER BLOCK
;*
;         ORG       *
;SAVERPRG SB        MSWRTBEG  BEGIN OF MULTI-SECTOR WRITE
;         SB        HPION     HIGH PRIORITY I/O ON
;         MVX       F7F6,F3F2 F3,2 = STARTING LINE-NO. FOR SAVE
;         TAP       ,B
;         TPA       ,F        AUXF = START ADDRESS OF FILE
;
DFLG    DB      ?
;       HIGH NIBBLE 10 -- DENOTE IN DATA PROCESS
;       LOW  NIBBLE 01 -- DENOTE IN REM PROCESS
;
SAVERPRG:
        CALL    MSWRTBEG
        CALL    HPION
        MOV     AX,WORD PTR R6
        MOV     WORD PTR R2,AX
        MOV     EDX,AUX0B
        MOV     AUX0F,EDX

;         SB        RIOBUFFR  POINT TO I/O BUFFER
;         ORI,W1    40,,      CONTROL BYTE (PROGRAM HEADER) ==> I/O BUFFER
;         TPA+1     ,C        INCREMENT BUFFER POINTER
;         SB        RWORKSPC  POINT TO PROGRAM NAME

        mov     edx,dword ptr [cpbase]
        lea     edx,[edx].@iobuffr
        mov     ch,40h
        test    counts,1000h
        jz      cs386_1
        mov     ch,60h
cs386_1:
        mov     [edx],ch        ;40h ---- normal 2200 program style
        mov     edi,edx         ;60h ---- new CS-386  program style
        inc     edi
        mov     edx,dword ptr [cpbase]
        lea     esi,[edx].@workspc

;         XPA+1,R   ,C        PROGRAM NAME ==> I/O BUFFER
;         XPA+1,W1  CH,C
;         BNEL      8,PL,*-2  BRANCH IF MORE TO NAME

        mov     ecx,8
        rep     movsb
        mov     aux0c,edi

;         TAP       ,E
;         ANDI      SACR+SACS,PH,F6     F6 = COMPRESSION FLAG
;         BFHH      40,PL,*+2 Wrap mode?
;         ORI       SAWM,F6,F6set wrap mode
;         SB        SAVEPBLK  RECORD PROGRAM HEADER BLOCK ON DISK

        MOV     EDX,AUX0E
        MOV     R6,DH
        AND     R6,SACR+SACS    ;SET COMPRESS FLAG
        TEST    DL,40H
        JZ      BP42A_03
        OR      R6,SAWM
BP42A_03:
        CALL    SAVEPBLK

;         SB        RSAVEA    Initialize Savearea for !
;         MVI,W1    00,
;         MVI,W2    00,       Initially 0000

        MOV     EDX,DWORD PTR [CPBASE]    ;2 byte scratch area used currently only
        LEA     EDX,[EDX].@RSAVE          ;only by SAVE/LOAD during X phase.
        MOV     WORD PTR [EDX],0

;*     PROCESS TEXT BLOCKS
;*
;         BFHH      SAWM,F6,SAVEPR69    skip if not wrap mode
;         MVI       0FF,F0
;         SB        SAVEBY
;         MVI       0A0,F0
;         SB        SAVEBY    Wrap Signature is FFA0

        TEST    R6,SAWM
        JZ      SAVEPR69

;------- ONLY WRAP MODE BEIGNS  HERE -------

        MOV     R0,0FFH
        CALL    SAVEBY
        MOV     R0,0A0H
        CALL    SAVEBY          ;WRAP SIGNATURE IS FFA0

;         TAP       ,E
;         BTHH      80,PL,SAVEP68       skip if scrambled+wrap mode
;         MVI       00,F0
;         SB        SAVEBY    'randomizer' is 0000
;         MVI       00,F0
;         B         SAVEP68B

        MOV     EDX,AUX0E
        TEST    DL,80H
        JNZ     SAVEP68
        MOV     R0,0
        CALL    SAVEBY
        MOV     R0,0
        JMP     SAVEP68B        ;FOR WRAP MODE RANDIMIZER IS 0

;SAVEP68  LPI,R     SAVESEED
;         MV        CH,F0
;         SB        SAVEBY    randomizer is used so that
;         LPI,R     SAVESEED  saves of the same program will differ
;         MV        CL,F0

;------- SCRAMBLED + WRAP MODE -------------

SAVEP68:
        MOV     EDX,OFFSET SAVESEED
        MOV     CH,[EDX]
        MOV     R0,CH
        CALL    SAVEBY          ;SAVEBY SUBROUTINE HAS ALTERED THE CX REGISTER
        MOV     EDX,OFFSET SAVESEED
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     R0,CL

;SAVEP68B SB        SAVEBY
;SAVEPR69 SB        FINDST    FIND START LINE OR NEXT HIGHER
;         BEQL      1,F0,SAVEPRG1       BRANCH IF NF
;         TPA+2     ,2        SAVE PTR TO CURRENT LINE'S LINE-NO.
;         B         SAVEPRG4

SAVEP68B:
        CALL    SAVEBY

;-------  NON-WRAP MODE BEGIN HERE  -----------
SAVEPR69:
        CALL    FINDST          ;FIND START LINE OR NEXT HIGHER LINE
        MOV     AL,R0
        AND     AL,0FH
        CMP     AL,1
        JZ      SAVEPRG1
        MOV     AUX02,EDX
        ADD     AUX02,4
        JMP     SAVEPRG4

;*     POINT TO NEXT TEXT LINE
;*
;SAVEPRG7 TAP       ,2        POINT TO BEGIN OF CURRENT LINE
;         OR        -,,
;         OR        -,,
;         ,R        ,         GET THREAD TO NEXT LINE
SAVEPRG7:
        MOV     EDX,AUX02
        SUB     EDX,4           ;THREAD DEFINE DWORD ,ORIGINAL PLUS(MINUS) 2
        MOV     ECX,[EDX]       ;                     NOW PLUS(MINUS) 4
;         BNR       CH,,*+2
;         BER       CL,,SAVEPRG1        BRANCH IF NO MORE TEXT
;         MVX       CHCL,PHPL PC'S POINT TO NEXT LINE
;         TPA+2     ,2
        CMP     ECX,0
        JZ      SAVEPRG1
        MOV     EDX,ECX
        MOV     AUX02,EDX
        ADD     AUX02,4
;         TAP       ,2
;         ,R        ,         GET LINE NUMBER OF NEXT LINE
;
;SAVEPRG4 BLERX     CHCL,F5F4,SAVEPR41  BRANCH IF LINE <= END LINE-NO.
;         SPACE
        MOV     EDX,AUX02       ;LINE NUMBER DEFINE WORD
        MOV     CX,[EDX]
        XCHG    CH,CL
SAVEPRG4:
        CMP     CX,WORD PTR R4
        JBE     SAVEPR41

;*     RECORD PROGRAM TRAILER BLOCK
;SAVEPRG1
;         MVI       0FE,F0    FE = eof flag, old files
;         BFHH      SAWM,F6,*+2         skip if not wrap mode
;         MVI       00,F0     00 = eof flag, wrap mode
;         SB        SAVEBY    write the EOF byte

SAVEPRG1:
        MOV     R0,0FEH
        TEST    R6,SAWM
        JZ      BP42A_05
        MOV     R0,0
BP42A_05:
        CALL    SAVEBY

;         SB        RIOBUFFR  point to begin of buffer
;         ORI,W1    20,,      control byte 20 (program trailer)
;         SB        SAVEPBLA  RECORD TRAILER BLOCK
;         B         MSWRTEND  END OF MULTI-SECTOR WRITE

        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     BYTE PTR [EDX],20H
        CALL    SAVEPBLA
        JMP     MSWRTEND

;* This point is reached at the beginning of each prog line to be saved

;*  Pass 0

;SAVEPR41 ANDI      0FF-SAP1-SACST,F6,F6flag pass 0
;*                                  (and turn off temp space compress flag, just in case)
;         MVI       0,F2      zero the count for current text line

SAVEPR41:
        AND     R6,0FFH-SAP1-SACST
        MOV     DFLG,0
        MOV     R2,0

;*  Pass 0 or 1, beginning of each prog line
;SAVEPRG8 TAP       ,2        AUX2 points to LINE-NO. of current line
;         TPA+2     ,AUX4     Point aux 4 to first token
;         ANDI      0FF-SAMS,F6,F6      turn off multi-stmt flag
;         BFHH      SACR+SACS,F6,SAVEPR31         Skip if not Compress (R or S)
;         B         SAVEPR19  Branch if compression active

SAVEPRG8:
        MOV     EDX,AUX02       ;TEXTLINE FORMAT IN MEMORY
        MOV     AUX04,EDX       ;----------------------------------------
        ADD     AUX04,2         ;| 4     |  2 |    TOKEN ...            |
        AND     R6,0FFH-SAMS    ;----------------------------------------
        TEST    R6,SACR+SACS    ; THREAD  LINE#  TEXT
        JZ      SAVEPR31
        JMP     SAVEPR19
;
;SAVEPRG3 SB        SAVEBYTE
;
;SAVEPR31 TAP       ,AUX4
;         TPA+1,R   ,AUX4     GET NEXT CHARACTER OF TEXT LINE
;         BFHH      SACR+SACS+SACST,F6,SAVEPR13   skip if no compression spec

SAVEPRG3:
        CALL    SAVEBYTE
SAVEPR31:
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        TEST    R6,SACR+SACS+SACST
        JZ      SAVEPR13

;*   Space compression when current statement is not a REM or Image
;SAVEPR20 BNEHH     @STMTSEP,CH,*+2
;         BEQLL     @STMTSEP,CH,SAVEPR19BRANCH IF STMT SEPARATOR
;         BFHH      SACST,F6,SAVEPR13   BRANCH IF SPACE DELETE NOT ACTIVE
;         BNEHH     20,CH,SAVEPR13
;         BEQLL     20,CH,SAVEPR31      ignore (loop back) if Space

SAVEPR20:
        CMP     CH,@STMTSEP
        JZ      SAVEPR19
        TEST    R6,SACST
        JZ      SAVEPR13
        CMP     CH,20H
        JZ      SAVEPR31

;SAVEPR13 MV        CH,F0     hang onto this byte
;         BNEHH     0FF,F0,SAVEPR22     BRANCH IF NOT (F-)
;         BEQL      @LINE#L,F0,SAVELN   BRANCH IF LINE NUMBER REFERENCE
;         BEQL      @LTRLL,F0,SAVEQUOT  BRANCH IF LITERAL ATOM
;         BEQL      @HEXLITL,F0,SAVEHEX BRANCH IF HEX LITERAL ATOM
;         BNEL      @STMTSPL,F0,SAVEPR22BRANCH IF NOT STMT SEPARATOR ATOM
;         BTHH      SAWM,F6,SAVEPRG3
;         MVI       C':',F0   REPLACE STMT SEPARATOR ATOM WITH COLON

SAVEPR13:

        test    counts,1000h
        jz      savepr13_1
        mov     r0,ch           ; for cs-386 new format
        test    r0,80h
        jnz     head_f          ; br if r0 may be Fx ,otherwise may be 7x
        cmp     r0,7eh
        jz      savecon         ; just copy constant 7E XX XX XX XX XX XX XX XX
        cmp     r0,7fh
        jz      savevar
        cmp     r0,7dh          ; just copy variable & matrix 7F XX XX xx xx xx xx
        jz      savevar         ; and discard address (xx xx xx xx)
        jmp     BP42A_16
head_f:
        cmp     r0,0a2h         ; REM stmt. has the 7e 7f 7d ... code
        jz      saverem
        cmp     r0,0D8h         ; REM stmt. has the 7e 7f 7d ... code
        jz      saverem_x
        cmp     r0,0ffh
        jz      savelin         ; just copy line number FF XX XX xx xx xx xx
        cmp     r0,0feh
        jz      savehexx
        cmp     r0,0fch         ; just copy hex & quot FC XX XX XX .... XX
        jz      savequotx       ;                      FE XX XX XX .... XX
        jmp     BP42A_16
saverem:
        mov     eax,aux04
s_y:    cmp     byte ptr [eax],20h
        jne     s_x
        inc     eax
        jmp     s_y
s_x:    cmp     byte ptr [eax],'%'
        jne     s_z
        inc     eax
s_b:    cmp     byte ptr [eax],20h
        jne     s_a
        inc     eax
        jmp     s_b
s_a:    cmp     byte ptr [eax],'%'
        jne     s_z
        call    savebyte
        mov     edx,aux04
        mov     ch,[edx]
        jmp     savepr31
s_z:
saverem_x:
        call    savebyte
saverem1:
        mov     edx,aux04
        mov     ch,[edx]
        cmp     ch,0dh
        jz      savepr31
        cmp     ch,0fdh
        jz      savepr31
        inc     aux04
        call    savebch
        jmp     saverem1
savecon:
        mov     edx,aux04               ; already increase one
        mov     ebx,[edx]               ; 7E XX XX XX XX XX XX XX XX
        and     ebx,0ff00ffffh           ;    EXPON     MANTISSA
        cmp     ebx,0
        jnz     saveconn
        cmp     dword ptr [edx+4],0     ; when this number >= 0 , <= 255
        jnz     saveconn                ; 7E 00 00 XX 00 00 00 00 00 ===> 7C XX
        mov     r0,7ch
        call    savebyte                ; savebyte will alter edx register
        mov     edx,aux04               ; already increase one
        mov     ch,[edx+2]
        call    savebch
        add     aux04,8
        jmp     savepr31
saveconn:
        call    savebyte
        mov     r3,8
savecon1:
        mov     edx,aux04
        mov     ch,[edx]
        inc     aux04
        call    savebch
        dec     r3
        jnz     savecon1
        jmp     savepr31
savevar:
savelin:
        call    savebyte
        mov     r3,2
savelin1:
        mov     edx,aux04
        mov     ch,[edx]
        inc     aux04
        call    savebch
        dec     r3
        jnz     savelin1
        add     aux04,4         ;skip address (four bytes)
        jmp     savepr31
savehexx:
savequotx:
        call    savebyte
        mov     edx,aux04
        mov     ch,[edx]
        inc     aux04
        mov     r3,ch
        call    savebch
        jmp     savecon1
savepr13_1:

        MOV     R0,CH
        TEST    DFLG,0FH
        JNZ     MOD42_25
;
        CMP     CH,@DATA
        JNZ     MOD42_124       ;CHECK IF 97 IS IN REM STATEMENT.
        MOV     DFLG,10H
        JMP     BP42A_16
MOD42_124:
        CMP     CH,0A2H
        JZ      MOD42_24X       ;REM  STMT. DON'T CONVERT ATOM  IF ANY  UNTIL  FD,CR  ENCOUNT
        CMP     CH,0D8H
        JNZ     MOD42_24        ;REM  STMT. DON'T CONVERT ATOM  IF ANY  UNTIL  FD,CR  ENCOUNT
MOD42_24X:
        TEST    DFLG,0F0H       ;CHECK IF 0A2 IS A DATUM IN DATA STATEMENT.
        JNZ     BP42A_16
        cmp     ch,0d8h
        je      f_x
        mov     eax,aux04
f_z:    cmp     byte ptr [eax],20h
        jne     f_y
        inc     eax
        jmp     f_z
f_y:    cmp     byte ptr [eax],'%'
        jne     f_x
        inc     eax
f_c:    cmp     byte ptr [eax],20h
        jne     f_b
        inc     eax
        jmp     f_c
f_b:    cmp     byte ptr [eax],'%'
        jne     f_x
        mov     dflg,0
        jmp     bp42a_16
f_x:
        MOV     DFLG,1
        JMP     BP42A_16
MOD42_24:
        CMP     CH,@LINE_               ;FF
        JZ      SAVELN
        CMP     CH,@LTRL
        JZ      SAVEQUOT                ;FE
        CMP     CH,@HEXLIT
        JZ      SAVEHEX                 ;FC
MOD42_25:
        CMP     CH,@STMTSEP             ;FD
        JNZ     SAVEPR22
        MOV     DFLG,0
        TEST    R6,SAWM
        JNZ     SAVEPRG3
        MOV     R0,':'

;SAVEPR22
;         BNEH      0,F0,SAVEPRG3
;         BNEL      0D,F0,SAVEPRG3      loop back IF CHARACTER <> CR

;**********************************************

SAVEPR22:
        TEST    DFLG,0FH
        JNZ     BP42A_16
        CMP     R0,7EH          ; 7EH DENOTES CONSTANCE
        JNZ     BP42A_15
        CALL    CONCON          ; CONVERT 8 BYTE REPRESENTATION TO ASCII
        JMP     SAVEPR31
BP42A_15:
        CMP     R0,7FH          ; 7FH DENOTES VARIABLE
        JE      BP42A_X
        CMP     R0,7DH          ; 7FH DENOTES VARIABLE
        JNZ     BP42A_16
BP42A_X:CALL    CONVAR          ; CONVERT TO ORIGINAL FORM
        JMP     SAVEPR31
;***********************************************
BP42A_16:
        CMP     R0,0DH
        JNZ     SAVEPRG3
        MOV     DFLG,0

;         BTLL      SAP1,F6,SAVEPR64    skip tests if pass 1
;         BER       F2,,SAVEPR70        skip if nothing was on this line
;         MVI       0F8,F0
;         BLER      F2,F0,SAVEPR64         skip if line <F8
;         B         ERROR#05  Wrap error = 05, line too long

        TEST    R6,SAP1
        JNZ     SAVEPR64
        CMP     R2,0
        JZ      SAVEPR70
        CMP     R2,0F8H
        JBE     SAVEPR64

        mov     eax,dword ptr [cpbase]
        mov     edx,aux02
        mov     dword ptr [eax].@spreg1,edx

        JMP     ERROR_05

;SAVEPR64 BTHH      SAWM,F6,SAVEPR65    skip if wrap mode
;         SB        SAVEBYTE  save the CR
;         MVI       00,F0
;         SB        SAVEBYTE  HEX(00) ==> BUFFER
;         SB        SAVEBYTE  HEX(00) ==> BUFFER

SAVEPR64:
        TEST    R6,SAWM
        JNZ     SAVEPR65
        CALL    SAVEBYTE
        MOV     R0,0
        CALL    SAVEBYTE
        CALL    SAVEBYTE

;         BTL       SAP1,F6,SAVEPR71    next line if already done pass 1
;* end pass 0;  non-wrap mode.   Will it fit?
;         ORI       SAP1,F6,F6 set pass # to 1
;         AI        3,F2,F2   F2= total line length
;*                (the 3 is for the FF and the two byte line number)
;         TAP       ,C
;         AC,0      F2,PL,

        TEST    R6,SAP1
        JNZ     SAVEPR71
        OR      R6,SAP1
        ADD     R2,3
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        ADD     EDX,100H
        MOV     EBX,EDX
        MOV     EDX,AUX0C
        MOV     AL,R2
        AND     EAX,0FFH
        ADD     EDX,EAX
        CMP     EDX,EBX

;         BFL       1,SH,*+2  branch if the line will fit in disk buffer
;         SB        SAVEPBLK  record text block on disk
;         MVI       0FF,F0    FF is first byte of new line
;         B         SAVEPR67

        JB      BP42A_11
        CALL    SAVEPBLK
BP42A_11:
        MOV     R0,0FFH
        JMP     SAVEPR67

;*  wrap mode.
;SAVEPR65 BTLL      SAP1,F6,SAVEPR71    next line if already done pass 1
;* END PASS 0;  wrap mode
;         ORI       SAP1,F6,F6Tell SAVEBYTE to really write now
;         AI        02,F2,F0  F0 = count of number of bytes
;         AI        3,F2,F2   f2 = final count, including the count byte

SAVEPR65:
        TEST    R6,SAP1
        JNZ     SAVEPR71
        OR      R6,SAP1
        MOV     AL,R2
        ADD     AL,2
        MOV     R0,AL           ;1 BYTE FOR COUNT & 2 BYTES FOR LINE NO.
        ADD     R2,3

;* Start Pass 1, both wrap and non-wrap mode
;SAVEPR67 SB        SAVEBYTE  write FF or count
;         TAP       ,2
;         ,R        read line #
;         SB        SAVEBCH   write high byte
;         TAP       ,2
;         ,R        reread line #
;         MV        CL,F0
;         SB        SAVEBYTE  write low byte (of line#)
;         B         SAVEPRG8  (rest of logic is repeat of pass 0)

SAVEPR67:
        CALL    SAVEBYTE
        MOV     EDX,AUX02
        MOV     CX,[EDX]
        XCHG    CH,CL
        CALL    SAVEBCH
        MOV     EDX,AUX02
        MOV     CX,[EDX]
        XCHG    CH,CL
        MOV     R0,CL
        CALL    SAVEBYTE
        JMP     SAVEPRG8

;* End of prog line, go look for another
;SAVEPR71
;         BER       F2,,SAVEPR70        skip if pass2 count = pass 1 count ????
;ERROR#00 MVI       0,F0      This is integrity check, temporary
;         B         ERROR
;SAVEPR70 EQU       SAVEPRG7

SAVEPR71:
        CMP     R2,0
        JZ      SAVEPR70
ERROR_00:
        MOV     R0,0
        JMP     ERROR

SAVEPR70        EQU     SAVEPRG7

;* reference to line number  (eg.  GOTO, GOSUB, ONGOTO, ...)
;SAVELN   SB        SAVEBYTE  write the FF
;         TAP       ,AUX4
;         TPA+1,R   ,AUX4     LINE NUMBER (PACKED DECIMAL) ==> BUFFER
;         SB        SAVEBCH   high byte

SAVELN:
        CALL    SAVEBYTE
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        CALL    SAVEBCH

;         TAP       ,AUX4
;         TPA+1,R   ,AUX4
;         SB        SAVEBCH   low byte
;         B         SAVEPR31

        MOV     EDX,AUX04
        MOV     CH,[EDX]
        ADD     AUX04,5         ;**** SKIP FOUR BYTES ADDRESS
        CALL    SAVEBCH
        JMP     SAVEPR31

;*  HEX( literal logic.    Assumes nonzero literal length
;SAVEHEX  BTHH      SAWM,F6,SAVEQU1     if wrap mode, treat like quote literal
;         MVI       @HEX(,F0  CHANGE PACKED HEX ATOM TO 'HEX(' ATOM
;         SB        SAVEBYTE
;         TAP       ,AUX4
;         TPA+1,R   ,AUX4     get the byte count
;         MV        CH,F3         in F3

SAVEHEX:
        TEST    R6,SAWM
        JNZ     SAVEQU1
        MOV     R0,@HEX?LP
        CALL    SAVEBYTE
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        MOV     R3,CH

;SAVEHEX2
;         TAP       ,AUX4
;         ,R        read next (packed) hex byte
;         SHLH      CH,,F0
;         SB        HEXFIX

SAVEHEX2:
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        MOV     AL,CH
        SHR     AL,4
        MOV     R0,AL
        CALL    HEXFIX

;         SB        SVEBYTE  Save high digit
;         TAP       ,AUX4
;         TPA+1,R   ,AUX4     re-read the byte
;         SHLL      CH,,F0

        CALL    SAVEBYTE
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        MOV     R0,CH
        AND     R0,0FH

;         SB        HEXFIX
;         SB        SAVEBYTE  Save low digit
;         AI        0FF,F3,F3 decrement byte count
;         BNR       F3,,SAVEHEX2

        CALL    HEXFIX
        CALL    SAVEBYTE
        DEC     R3
        JNZ     SAVEHEX2

;         MVI       C')',F0
;         B         SAVEPRG3  save trailing paren, and continue
;         SPACE     3

        MOV     R0,')'
        JMP     SAVEPRG3
;****************************************************************
;* GOAL : CONVERT CONSTANCE REPRESENTATION TO ASCII REPESENTATION
;*        FOR EXAMPLE:
;*        00 00 11 00 00 00 00 00   ---->   33
;*         S  E <----- M ------->           A
;*         I  X        A                    S
;*         G  P        N                    C
;*         N  O        T                    I
;*            N.       I.                   I
;  ENTRY:
;       AUX4 = PROGRAM POINTER (POINT TO NEXT BYTE IN TEXT LINE TO COPY FROM)
;       AUXC = BUFFER POINTER (POINT TO NEXT BYTE LOCATION IN BLOCK BUFFER)
;  RETURN:
;       AUX4 = AUX4 + 8
;       AUXC = AUXC + LENGTH (CONVERTED ASCII)
;
;****************************************************************
CONCON:
        MOV     EDX,AUX04
        ADD     AUX04,8
        PUSH    WORD PTR R2
        PUSH    AUX02
        CALL    VVFMTB          ;SEE M12.ASM FOR ENTRY & RETURN DESCRIPTION
        POP     AUX02
        POP     WORD PTR R2
        MOV     EDI,DWORD PTR [CPBASE]
        LEA     EDI,[EDI].@IOBUFFR
        ADD     EDI,300
        MOV     EDX,EDI
        MOV     ESI,OFFSET SCRATCH
        XOR     ECX,ECX
        MOV     CL,R0
;       CLD
        REP     MOVSB
        MOV     ESI,EDX
        LODSB
        CMP     AL,20H
        JZ      CONCON1
        MOV     R0,AL
        CALL    SAVEBYTE
CONCON1:
        LODSB
        CMP     AL,20H
        JZ      CONSR
        MOV     R0,AL
        CALL    SAVEBYTE
        JMP     CONCON1
CONSR:
        RET

;******************************************************************
;* GOAL: CONVERT SPEED-UP VARIABLE REPRESENTATION TO ORIGINAL FORM
;        FOR EXAMPLE:
;           |7 F|   |   |   |   |   |   |    -----> [@] LETTER [DIGIT] [$] [(]
;                D T  C  <----  A  ----->
;                I Y  H         D
;                G P  A         D
;                I E  R         R
;                T    A.        E.
;
;       DIGIT :  0 - 9  ----- CORRESPONDING DIGIT FOLLOWS LETTER
;                0F   ------- NO DIGIT
;
;       TYPE  :  BIT 8  --- 1 @ EXISTS , 0 NO @
;                BIT 2  --- 1 ( EXISTS , 0 NO (
;                BIT 1  --- 1 APLHA    , 0 NUMERICAL
;  ENTRY:
;       AUX04 = TEXT POINTER
;       AUX0C = BUFFER POINTER
; RETURN:
;        AUX04 = AUX04 + 6
;        AUX0C = AUX0C + LENGTH (VARIABLE)
;*******************************************************

CONVAR:
        MOV     EDX,AUX04
        CALL    VVFMTV
        MOV     EDI,DWORD PTR [CPBASE]
        LEA     EDI,[EDI].@IOBUFFR
        ADD     EDI,300
        MOV     EDX,EDI
        MOV     ESI,OFFSET SCRATCH
        XOR     ECX,ECX
        MOV     CL,R0
;       CLD
        REP     MOVSB

        ADD     AUX04,6
        MOV     ESI,EDX
        JMP     CONCON1
;********************************************************
;*  ENTRY: EDX POINT TO DIGIT BTYE
;*  RETURN: IN SCRATCH AREA (TERMINATED BY 20H)
;********************************************************

VVFMTV:
        MOV     BL,BYTE PTR [EDX-1]
        MOV     EDI,OFFSET SCRATCH
        MOV     R0,0
        MOV     CH,[EDX]
        TEST    CH,08
        JZ      VVFMTV1
        MOV     AL,'@'
        STOSB
        INC     R0
VVFMTV1:
        INC     EDX
        MOV     AL,[EDX]
        STOSB
        INC     R0
        MOV     AL,CH
        SHR     AL,4
        CMP     AL,0FH
        JZ      VVFMTV2
        ADD     AL,30H
        STOSB
        INC     R0
VVFMTV2:
        TEST    CH,01
        JZ      VVFMTV3
        MOV     AL,'$'
        STOSB
        INC     R0
VVFMTV3:
        CMP     BL,7DH
        JE      VVFMTV4
        TEST    CH,02H
        JZ      VVFMTV4
        MOV     AL,'('
        STOSB
        INC     R0
VVFMTV4:
        MOV     BYTE PTR [EDI],20H
        INC     R0
        RET

;*   QUOTE literal logic.   Assumes nonzero literal length
;SAVEQUOT BTHH      SAWM,F6,SAVEQU1     skip if wrap mode
;         MVI       C'"',F0   CHANGE LITERAL ATOM TO QUOTE

SAVEQUOT:
        TEST    R6,SAWM
        JNZ     SAVEQU1
        MOV     R0,'"'

;SAVEQU1  SB        SAVEBYTE
;         TAP       ,AUX4
;         TPA+1,R   ,AUX4     GET LENGTH OF LITERAL
;         MV        CH,F3     F3 = LENGTH OF LITERAL

SAVEQU1:
        CALL    SAVEBYTE
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        MOV     R3,CH

;         BFHH      SAWM,F6,SAVEQU2
;         SB        SAVEBCH   If wrap mode, write count byte

        TEST    R6,SAWM
        JZ      SAVEQU2
        CALL    SAVEBCH

;SAVEQU2  TAP       ,AUX4     GET NEXT CHARACTER OF LITERAL
;         TPA+1,R   ,AUX4
;         SB        SAVEBCH   PUT CHARACTER INTO I/O BUFFER

SAVEQU2:
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        CALL    SAVEBCH

;         AI        0FF,F3,F3 DECREMENT LITERAL COUNT
;         BNR       F3,,SAVEQU2         loop IF MORE TO
;         BTHH      SAWM,F6,SAVEPR31    done if wrap mode

        DEC     R3
        JNZ     SAVEQU2
        TEST    R6,SAWM
        JNZ     SAVEPR31
;         MVI       C'"',F0   save trailing quote to buffer
;         B         SAVEPRG3

        MOV     R0,'"'
        JMP     SAVEPRG3

;*  Space/Rem compression
;*     SPECIAL CASES:
;*         1. DON'T DELETE SPACES IN IMAGE (%) STATEMENTS,
;*            REM STMTS, OR LITERALS.
;*         2. Don't delete REM if first nonblank is !
;*         3. IF deleting REM that was ONLY STMT ON LINE, DELETE ENTIRE LINE
;*
;*   Savepr19   is branched to at begin of line, and for each stmt separator
;*       if either S or R compression is active.
;*       The colon is not output until some non-trivial character for the new
;*       stmt is discovered.  Thus the check for leading spaces and for REM
;*       atom occurs before the colon is actually sent.  The SAMS flag is
;*       used to suppress the colon for the first stmt per line.
;SAVEP19A TPA       ,AUX4
;SAVEPR19 MVI       0,F3      zero the (leading) space count
;         ANDI      0FF-SACST,F6,F6     turn off temp space compression
;         TAP       ,AUX4

SAVEP19A:
        MOV     AUX04,EDX
SAVEPR19:
        MOV     R3,0
        AND     R6,0FFH-SACST
        MOV     EDX,AUX04
        MOV     DFLG,0          ;BEGINNING OF LINE

;*     PROCESS SPACES IMMEDIATELY AFTER LINE# or statement separator
;*
;SAVEPR11 TPA,R     ,AUX4     GET 1ST CHARACTER OF NEXT STMT
;         BNEHH     20,CH,SAVEPR18
;         BNELL     20,CH,SAVEPR18      BRANCH IF not SPACE CHAR.

SAVEPR11:
        MOV     CH,[EDX]
        MOV     AUX04,EDX
        CMP     CH,20H
        JNZ     SAVEPR18

;         AC,1      +,F3,F3   increment (leading) space count
;         B         SAVEPR11  loop back till nonspace

        INC     R3
        INC     EDX
        JMP     SAVEPR11

;SAVEPR18
;         BFHH      SACR,F6,SAVEPR15    BRANCH IF DON'T COMPRESS REM'S
;         BNEH      @REMH,CH,SAVEPR15   BRANCH IF STMT <> REM
;         BNEL      @REML,CH,SAVEPR15

SAVEPR18:
        TEST    R6,SACR
        JZ      SAVEPR15
        CMP     CH,@REM
        JNZ     SAVEPR15


;*     REM COMPRESSION
;*             ( If  <R> is used, delete any REM not beginning with REM ! )
;*
;SAVEP18A OR        +,,
;         ,R        read first character after REM
;         BNEH      2,CH,SAVEPR12
;         BEQL      0,CH,SAVEP18A       loop back if it's a blank
;         BEQLL     C'!',CH,SAVEPR15    skip ahead if it's '!'
;

SAVEP18A:
        INC     EDX
        MOV     CH,[EDX]
        CMP     CH,20H
        JZ      SAVEP18A
        CMP     CH,'!'
        JZ      SAVEPR15

;*  It's a REM that's being compressed out.
;*          PC's point to first nonblank after REM token.
;SAVEPR12 OR,R,0    +,,       GET NEXT CHARACTER OF REM
;         BNEH      @STMTSPH,CH,*+2
;         BEQL      @STMTSPL,CH,SAVEP19Aloop back IF STMT SEPARATOR
;         BNEH      0,CH,SAVEPR12
;         BNEL      0D,CH,SAVEPR12      BRANCH IF NOT CR

SAVEPR12:
        MOV     CH,[EDX]
        INC     EDX
        CMP     CH,@STMTSEP
        JZ      SAVEP19A
        CMP     CH,0DH
        JNZ     SAVEPR12

;         TPA       ,AUX4
;         B         SAVEPR13  Go handle the CR

        MOV     AUX04,EDX
        JMP     SAVEPR13

;*     SPACE COMPRESSION?    (AUX4 points at first token)
;*
;SAVEPR15
;         BFLL      SAMS,F6,SAVEP15B    skip if no statements yet
;         MVI       C':',F0   colon for stmt separator, non wrap mode
;         BFHH      SAWM,F6,*+2

SAVEPR15:
        TEST    R6,SAMS
        JZ      SAVEP15B
        MOV     R0,':'

        test    counts,1000h
        jnz     bp42a_09x

        TEST    R6,SAWM
        JZ      BP42A_09

;         MVI       @STMTSEP,F0         use atom if wrap mode
;         SB        SAVEBYTE

bp42a_09x:
        MOV     R0,@STMTSEP
BP42A_09:
        CALL    SAVEBYTE

;SAVEP15B ORI       SAMS,F6,F6flag that a statement has occurred
;         BTHH      SACS,F6,SAVEP14     skip if space compression
;         BER       F3,,SAVEP15D
;         MVI       20,F0

SAVEP15B:
        OR      R6,SAMS
        TEST    R6,SACR
        JNZ     SAVEP14
        CMP     R3,0
        JZ      SAVEP15D
        MOV     R0,20H

;SAVEP15C SB        SAVEBYTE  send out the leading spaces of this statement
;         AI        0FF,F3,F3
;         BNR       F3,,SAVEP15C        loop till all spaces sent
;         B         SAVEPR31

SAVEP15C:
        CALL    SAVEBYTE
        DEC     R3
        CMP     R3,0
        JNZ     SAVEP15C
        JMP     SAVEPR31

;* (AUX4 points at first token)
;SAVEP15D EQU       SAVEPR31
;SAVEP14
;         TAP       ,AUX4
;         TPA+1,R   ,AUX4
;         BNEH      @REMH,CH,*+2
;         BEQL      @REML,CH,SAVEPR13   BRANCH IF 'REM'

SAVEP15D        EQU     SAVEPR31
SAVEP14:
        MOV     EDX,AUX04
        MOV     CH,[EDX]
        INC     AUX04
        CMP     CH,@REM
        JZ      SAVEPR13

;         BNEH      @%H,CH,*+2
;         BEQL      @%L,CH,SAVEPR13     branch if '%'
;         ORI       SACST,F6,F6         flag temporary SPACE COMPRESSION for  not REM or %
;         B         SAVEPR13

BP42A_10:
        CMP     CH,@?PE
        JZ      SAVEPR13
        OR      R6,SACST
        JMP     SAVEPR13

;* CH is first token, AUX4 points to next
;SAVEP14D EQU       SAVEPR13

SAVEP14D        EQU     SAVEPR13

;         TITLE     SAVEPBLK
;*     SAVEPBLK: RECORD PROGRAM BLOCK ON DISK. BEFORE
;*               RECORDING, EOB IS PUT INTO BUFFER AND
;*               PROTECT BIT (X'10') IN CONTROL BYTE IS
;*               PUT ON IF 'SAVEP'
;*
;*               USES STANDARD I/O BUFFER; MUST BE AT xx00
;*
;*          ENTRY:
;*               PHASE = EXECUTION
;*               DISK ENABLED
;*               F6 bit SAWM used for wrap mode
;*               AUXE = PLATTER,FILE#,R/W,SAVEP
;*               AUXE,BIT12 = 1 IFF SAVE P (PROTECT PRGM)
;*               AUXC = ADDRESS OF LAST VALID CHARACTER
;*                      IN BUFFER +1
;*               AUXD = EOF SECTOR ADDRESS (CANNOT WRITE
;*                      BEYOND THIS)
;*               AUXF = SECTOR ADDRESS TO WRITE TO
;*
;*          RETURN:
;*               1ST BYTE OF BUFFER ZEROED  (and if Wrap mode, 2nd is FF)
;*               AUXC = ADDRESS OF NEXT AVAILABLE BYTE IN BUFFER
;*                      ( byte 1 if old program, byte 2 if wrap mode)
;*               AUXF INCREMENTED BY 1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K,F0,F1,F6,F7
;*                              AUX 0,1,C,F
;*
;*     SAVEPBLA: SAME AS ABOVE EXCEPT 'EOB' NOT PUT INTO
;*                BUFFER
;*
;*          ENTRY: SAME AS 'SAVEPBLK'
;*
;*     SAVEPBLB:  same as above except no zeroing is done, buffer
;*          is written as is.  AUXC not relevant.
;*
;SAVEPBLK TAP       ,C
;         ORI,W1    0FD,,     EOB ==> I/O BUFFER
;         TPA+1     ,C

SAVEPBLK:
        MOV     EDX,AUX0C
        MOV     BYTE PTR [EDX],0FDH
        INC     AUX0C

;SAVEPBLA TAP       ,C
;         MVI       0,F0
;         B         *+2
;         OR,W1     +,,       ZERO UNUSED PORTION OF BUFFER
;         BNR       F0,PL,*-1

SAVEPBLA:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        ADD     EDX,100H
        MOV     EBX,EDX         ;EBX -- END ADDRESS OF I/O BUFFER
        MOV     EDX,AUX0C
        JMP     BP42A_06
BP42A_07:
        MOV     BYTE PTR [EDX],0
        INC     EDX
BP42A_06:
        CMP     EDX,EBX
        JNZ     BP42A_07

;SAVEPBLB TAP       ,ACTDEV   GET DEVICE TYPE & ADDRESS
;         BEQL      #PHOENIX,PH,*+4
;         BEQL      3,PH,*+3
;         BEQL      0B,PH,*+2

SAVEPBLB:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      BP42A_08
        CMP     DH,3
        JZ      BP42A_08
        CMP     DH,0BH
        JZ      BP42A_08

;ERR#48C  B         ERROR#48  ERROR IF NOT DISK
;         BFHH      SAWM,F6,SAVEPB1     skip if not wrap mode
;         SB        RIOBUFFR
;         BTHH      40,CH,SAVEPB1       skip if header record
;         SB        CHECKSUM  Body of wrapmode program gets checksum

ERR_48C:
        JMP     ERROR_48
BP42A_08:
        TEST    R6,SAWM
        JZ      SAVEPB1
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        TEST    CH,40H
        JNZ     SAVEPB1
        CALL    CHECKSUM

;SAVEPB1
;         TAP       ,E
;         ANDI      10,PH,K   K = PROTECT BIT
;         BFH       8,PL,SAVEPB2        skip if not scramble
;         SB        RIOBUFFR

SAVEPB1:
        MOV     EDX,AUX0E
        AND     DH,10H
        MOV     K,DH
        TEST    DL,80H
        JZ      SAVEPB2
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL

;         BTH       4,CH,SAVEPB2
;         SB        NCRYPT    ENCRYPT DATA if not header

        TEST    CH,40H
        JNZ     SAVEPB2
        CALL    NCRYPT

;SAVEPB2
;         TAP       ,D
;         MVX       PHPL,F1F0 F1,0 = EOF ADDRESS
;         SB        RIOBUFFR  POINT TO BEGIN OF I/O BUFFER; GET CONTROL BYTE

SAVEPB2:
        MOV     EDX,AUX0D
        MOV     WORD PTR R0,DX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL

;         OR,W1     CH,K,     OR PROTECT BIT INTO SOB CONTROL BYTE
;         XPA       ,F        AUXF = ADDRESS OF I/O BUFFER; PC'S = SECTOR ADDR
;         BLERX     F1F0,PHPL,ERR#81A   ERROR IF EOF < SECTOR ADDRESS
;         SB        DWRITE$   RECORD BLOCK ON DISK

        MOV     AL,K
        OR      AL,CH
        MOV     [EDX],AL
        XCHG    EDX,AUX0F
        CMP     WORD PTR R0,DX
        JBE     ERR_81A
        mov     eax,dword ptr [cpbase]
        cmp     byte ptr [eax].@spreg4,1
        jne     savepb_xxx
        inc     edx
        xchg    edx,aux0f
        jmp     savepb_yyy
savepb_xxx:
        CALL    DWRITE?DA

;         SB        RIOBUFFR  POINT TO BEGIN OF I/O BUFFER
;         TPA+1,W1  ,C        zero byte 0 of IOBUFFER, point AUXC at byte 01
;         BFHH      SAWM,F6,SAVEPBR     skip if not wrap mode
;         OR        +,,

savepb_yyy:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     BYTE PTR [EDX],0
        MOV     AUX0C,EDX
        INC     AUX0C
        TEST    R6,SAWM
        JZ      SAVEPBR
        INC     EDX

;         SC,0,W1   +,,       byte 01 is FF
;         TPA+1,W1  ,C        byte 02 is 00

        MOV     BYTE PTR [EDX],0FFH
        INC     EDX
        MOV     BYTE PTR [EDX],0
        MOV     AUX0C,EDX
        INC     AUX0C

;SAVEPBR  SR        ,         return with AUX C pointing to next available byte
;ERR#81A  B         ERROR#81  FILE FULL

SAVEPBR:
        RET
ERR_81A:
        JMP     ERROR_81

;         TITLE     CHECKSUM
;*   CHECKSUM:  Calculate and store a checksum in the RIOBUFFR.  This is
;*         called only in wrap-mode.
;* when called from SAVEPBLK
;*   ENTRY  byte 2 is 00
;*   RETURN:  F0= checksum written, but nobody looks at F0
;* when called from Load logic,
;*   ENTRY  byte 2 is the checksum written by save logic
;*   RETURN byte 2 and F0 have been zeroed, if the checksum was good.
;*       If checksum was bad, F0 is nonzero.
;*  modified regs:  PC's  CHCL   F1F0
;CHECKSUM SB        RIOBUFFR
;         MVI       3,PL
;         AND,0     F0,,F0    f0= initial checksum, carry off

CHECKSUM:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        PUSH    EDX
        MOV     EBX,EDX
        ADD     EBX,100H
        ADD     EDX,3
        MOV     R0,0
        CLC
        PUSHF

;CHECK2   OR,R      +,,F1
;         AC        CH,F0,F0  calculate a running sum, with carry
;         BNR       F1,PL,CHECK2
;         AI        0FF,PH,PH

CHECK2:
        POPF
        MOV     CH,[EDX]
        ADC     R0,CH
        PUSHF
        INC     EDX
        CMP     EDX,EBX         ;NOTICE !!!!  CMP INSTRUCTION MAY ALTER THE CARRY FLAG
        JNZ     CHECK2          ;WHEN YOU LOOP BACK , THE CARRY MAY BE NOT ORIGINAL
        POPF
        POP     EDX

;         MVI       2,PL      point at checksum location
;         ,R
;         XOR,W1    CH,F0,F0  store the checksum, byte 2, and F0
;         SR

        ADD     EDX,2
        MOV     CH,[EDX]
        XOR     R0,CH
        MOV     AL,R0
        MOV     [EDX],AL
        RET

;         MODULE    MOD-42 DISK SAVE & LOAD
;         TITLE     DISK SAVE & LOAD
;*     ****************************************
;*     *                                      *
;*     *  MOD-42  DISK SAVE AND LOAD          *
;*     *                                      *
;*     ****************************************
;*
;*
;*  STANDARD 2600 PROGRAM RECORD FORMATS:
;*
;*      HEADER RECORD     PROGRAM RECORD    TRAILER RECORD
;*     ---------------   ---------------   ---------------
;*     ! SOB (X'40') !   ! SOB (X'00') !   ! SOB (X'20') !
;*     ---------------   ---------------   ---------------
;*     ! PROGRAM NAME!   ! TEXT LINE   !   ! TEXT LINE   !
;*     ! (8 BYTES)   !   !             !   !             !
;*     ---------------   !             !   !             !
;*     ! EOB (X'FD') !   ---------------   ---------------
;*     ---------------   ! TEXT LINE   !   ! TEXT LINE   !
;*     !             !   !             !   !             !
;*     ! -not used-  !   !             !   !             !
;*     !             !   ---------------   ---------------
;*     ---------------   !    .        !   !   .         !
;*                       !    .        !   !   .         !
;*                       !    .        !   !   .         !
;*                       ---------------   ---------------
;*                       ! TEXT LINE   !   ! TEXT LINE   !
;*                       ---------------   ---------------
;*                       ! EOB (X'FD') !   ! EOF (X'FE') !
;*                       ---------------   ---------------
;*                       !             !   !             !
;*                       ! -not used-  !   ! -not used-  !
;*                       !             !   !             !
;*                       ---------------   ---------------
;*
;*     SOB: IF PROGRAM IS PROTECTED, SOB CHARACTER HAS THE
;*          X'10' BIT OR'ED ON; THUS, THEY ARE X'50',
;*          X'10', AND X'30', RESPECTIVELY.
;*
;*     PROGRAM NAME: 8 BYTES, PADDED WITH TRAILING SPACES
;*                   IF NECESSARY
;*
;*     TEXTLINE:  [ X'FF' 'actual textline' X'0D0000' ]
;*          1. TEXTLINE IS COMPLETELY ATOMIZED EXCEPT:
;*
;*               A. LITERALS ARE NOT ATOMIZED.
;*               B. STATEMENT SEPARATORS ARE COLONS.
;        TITLE     SAVE
;*     SAVE: PROCESS A 'SAVE' STATEMENT
;*
;*          STMT FORMAT:
;*
;*               1. SAVE DA ...
;*               2. SAVE [DC] ...
;*
;*          ENTRY: TEXTPTR POINT AFTER 'SAVE'
;*
;*
;         ORG       *
;SAVE     SB        PRTCTERR  MAKE SURE PROGRAM NOT PROTECTED
;         MVI       @DA,F0
;         SB        CCL       LOOK FOR 'DA'
;         BEQL      0,F0,SAVEDA         F, BRANCH

SAVE:
        CALL    PRTCTERR
        MOV     R0,@DA
        CALL    CCL
        TEST    R0,0FH
        JZ      SAVEDA

;         MVI       @DC,F0
;         SB        CCL       LOOK FOR 'DC'
;         B         SAVEDC

        MOV     R0,@DC
        CALL    CCL
        JMP     SAVEDC

;         TITLE     SAVEDA
;*     SAVEDA: PROCESS A 'SAVEDA' STATEMENT
;*
;*          STMT FORMAT:
;*                         S
;*               SAVE DA [<SR>] platter [$] [file#   ,]
;*                                          [disk-addr,]
;*
;*        [P] (sector-addr[,[variable]]) [line#][,[line#]]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'SAVE DA'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX B-F
;*
;*          WORKSPACE USED TO STORE DUMMY PROGRAM NAME
;*               (ALL SPACES)
;*
;SAVEDA   SB        CMPRSS    PROCESS COMPRESS PARAMETER
;         SB        PLATTER   PROCESS PLATTER SPECIFICATIOIN
;         SB        RAW       PROCESS READ-AFTER-WRITE SPECIFICATION
;         SB        DISKSELC  PROCESS #n, OR /xyy, SPECIFICATION
;         SB        PROTECT   PROCESS PROTECT PARAMETER
;         SB        SECTOR    PROCESS SECTOR ADDRESS PARAMETER
;         SB        LN#RANGE  GET SAVE LINE# RANGE

SAVEDA:
        CALL    CMPRSS
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSELC
        CALL    PROTECT
        CALL    SECTOR
        CALL    LN_RANGE

;         BFL       2,SL,SAVEDA1        BRANCH IF NOT EXECUTION PHASE
;         SCX,0     F1F0,F1F0,PHPL      PC'S = FFFF
;         TPA       ,D        EOF ADDRESS = FFFF
;         TAP       ,F

        TEST    SL,2
        JZ      SAVEDA1
        MOV     EDX,0FFFFH                ;EOF if 2 byte addressing     ^A12T
        MOV     EAX,DWORD PTR [CPBASE]    ;                             ^A12T
        CMP     BYTE PTR [EAX].@SPREG9,0  ;select 3 flag                ^A12T
        JE      SAVEDA4                   ;jump if select 3 off         ^A12T      
        MOV     EDX,0FFFFFFH              ;EOF for 3 byte addressing    ^A12T
SAVEDA4:                                  ;                             ^A12T
        MOV     AUX0D,EDX
        MOV     EDX,AUX0F

;         TPA       ,B        START OF FILE ADDRESS = SPECIFIED SECTOR
;         SB        RWORKSPC  POINT TO WORKSPACE
;         MVI       20,F0
;         OR,W1     +,F0,     DUMMY PROGRAM NAME = ALL SPACES
;         BNEL      8,PL,*-1

        MOV     AUX0B,EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        MOV     EDI,EDX
        MOV     AL,20H
        MOV     ECX,8
;       CLD
        REP     STOSB

;         SB        SAVERPRG  SAVE PROGRAM ON DISK
;         SB        RECSCTR   SET RCVR VARIABLE = NEXT AVAILABLE SECTOR ADDRESS
;SAVEDA1  B         ENDSDISK  DISABLE DISK, EXIT

        MOV     EAX,DWORD PTR [CPBASE]      ;                        ^A03B
        MOV     BYTE PTR [EAX].@SPREG4,0    ;Clear resave flag       ^A03B
        CALL    SAVERPRG
        CALL    RECSCTR
SAVEDA1:
        JMP     ENDSDISK

;         TITLE     SAVE DC
;*     SAVEDC: PROCESS A 'SAVEDC' STATEMENT
;*
;*          STMT FORMAT:
;*                           S
;*               SAVE [DC] [<SR>] platter [$] [file#,  ]
;*                                           [disk-addr,]
;*
;*           [([filename])] [P] filename [line#][,[line#]]
;*              expression
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUX7-F
;*
;         ORG       *
;SAVEDC   SB        CMPRSS    PROCESS COMPRESS PARAMETER <SR>
;         SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAW       PROCESS READ-AFTER-WRITE SPECIFICATION
;         SB        DISKSELC  PROCESS #n, OR /xyy,
;         SB        FILELOCS  PROCESS FILE LOCATION PARAMETER
;         SB        PROTECT   PROCESS PROTECT PARAMETER
;         SB        NEWNAMEF  PROCESS NAME OF PROGRAM

SAVEDC:
        CALL    CMPRSS
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSELC
        CALL    FILELOCS
        CALL    PROTECT
        CALL    NEWNAMEF

;SAVEDC9  SB        LN#RANGE  PROCESS START & END LINE-NUMBERS
;         BFL       2,SL,SAVEDC4        BRANCH IF NOT EXECUTION PHASE
;         SB        SAVERPRG  SAVE PROGRAM ON DISK
;         TAP       ,F

SAVEDC9:
        CALL    LN_RANGE
        TEST    SL,2
        JZ      SAVEDC4
        cmp     aux0a,1
        jne     savedc_xxx
        PUSH    DWORD PTR [R4]
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@spreg4,1
        call    saverprg
        mov     eax,dword ptr [cpbase]
        mov     byte ptr [eax].@spreg4,0
        POP     DWORD PTR [R4]
savedc_xxx:
        MOV     EAX,DWORD PTR [CPBASE]      ;                        ^A03B
        MOV     BYTE PTR [EAX].@SPREG4,0    ;Clear resave flag       ^A03B
        CALL    SAVERPRG
        MOV     EDX,AUX0F

;         TPA       ,7        AUX7 = SECTOR ADDRESS OF TRAILER BLOCK +1
;         TAP       ,A
;         BFL       2,PL,*+3  BRANCH IF OVERWRITING A FILE

        MOV     AUX07,EDX
        MOV     EDX,AUX0A
        TEST    DL,2
        JZ      BP42_02

;         TAP       ,F
;         TPA       ,D        AUXD = SECTOR ADDR OF TRAILER BLOCK (CURRENT EOF) +1
;         SB        NEWEOF    CALCULATE & CHECK NEW EOF (ADD NO. OF EXTRA SECTORS

        MOV     EDX,AUX0F
        MOV     AUX0D,EDX
BP42_02:
        CALL    NEWEOF

;SAVEDC5  SB        FINDNAMH  SEARCH INDEX FOR PROGRAM NAME
;         MVI       80,F7     FLAG = PROGRAM FILE
;         SB        ADDFILE   ADD FILE TO DISK CATALOG
;SAVEDC4  B         ENDSDISK  DISABLE DISK, EXIT

SAVEDC5:
        CALL    FINDNAMH
;
; cs-386 format
;
        MOV     R7,80H
        test    counts,1000h
        jz      savedc386
        mov     r7,40h

savedc386:
        CALL    ADDFILE
SAVEDC4:
        JMP     ENDSDISK

;         TITLE     PROTECT
;*     PROTECT: PROCESS A 'SAVE' PROTECT PARAMETER
;*
;*          FORMAT:  [P]
;*                    !
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER PROTECT PARAMETER
;*                  F0 = 0 IF 'P' FOUND
;*                       1 IF 'P' NOT FOUND
;*                  IN EXECUTION PHASE,
;*                    AUXE,BIT12 = 0 IF 'P' NOT FOUND
;*                                 1 IF 'P' FOUND
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0
;*               IN EXECUTION PHASE, AUXE,BIT12
;*
;         ORG       *
;PROTECT  MVI       C'!',F0
;         SB        NXTCH     LOOK FOR '!'
;         BNEL      0,F0,PROTECT3       BRANCH IF NOT FOUND

PROTECT:
        CMP     BYTE PTR [TEXTPTR],'!'
        JNE     PROTECT3
        INC     TEXTPTR

;         BFL       2,SL,PROTECT1       BRANCH IF NOT EXECUTION PHASE
;         TAP       ,E
;         ORI       80,PL,PL  2600 PROTECT
;         B         PROTECT4

        TEST    SL,2
        JZ      PROTECT1
        MOV     EDX,AUX0E
        OR      DL,80H
        JMP     PROTECT4


;PROTECT3 SB        NXTCHP    LOOK FOR 'P'
;         BNEL      0,F0,PROTECT2       BRANCH IF NOT FOUND
;         TPA       ,0        SAVE TEXTPTR
;         SB        NXTCH$    LOOK FOR '$' (MAKE SURE NOT P$ OR P1$)
;         BEQL      0,F0,*+2  BRANCH IF '$' FOUND
;         SB        DIGIT     LOOK FOR DIGIT
;         XORI      1,F0,F0
;         BEQL      0,F0,PROTECT2
;         TAP       ,0
;         TPA       ,TEXTPTR  RESET TEXTPTR

PROTECT3:
        MOV     R0,1
        CMP     BYTE PTR [TEXTPTR],'P'
        JNE     PROTECT2
        MOV     AUX00,TEXTPTR
        INC     TEXTPTR
        MOV     R0,0
        INC     TEXTPTR
        CMP     BYTE PTR [TEXTPTR-1],'$'
        JE      BP42_03
        DEC     TEXTPTR
        MOV     R0,1
        CALL    DIGIT
BP42_03:
        XOR     R0,1
        TEST    R0,0FH
        JZ      PROTECT2
        MOV     EDX,AUX00
        MOV     TEXTPTR,EDX

;PROTECT2 BFL       2,SL,PROTECT1       BRANCH IF NOT EXECUTION PHASE
;         TAP       ,E
;         ANDI      0EF,PH,PH SAVE P BIT OFF
;         BNEL      0,F0,*+2  BRANCH IF 'P' NOT FOUND
;PROTECT4 ORI       10,PH,PH  SAVE P BIT ON
;         TPA       ,E
;PROTECT1 SR

PROTECT2:
        TEST    SL,2
        JZ      PROTECT1
        MOV     EDX,AUX0E
        AND     DH,0EFH
        TEST    R0,0FH
        JNZ     BP42_04
PROTECT4:
        OR      DH,10H
BP42_04:
        MOV     AUX0E,EDX
PROTECT1:
        RET

;         TITLE     CMPRSS
;*     CMPRSS: PROCESS SAVE COMPRESSION PARAMETER
;*
;*          FORMAT: [< [W] [S] [R] >]
;*
;*          ENTRY: TEXTPTR POINTS TO NEXT TEXT CHARACTER
;*
;*          RETURN: TEXTPTR POINTS AFTER COMPRESS PARAMETR
;*               IN EXECUTION PHASE,
;*                    AUXE,bit 4000 = 1 IFF 'S' SPECIFIED
;*                        ,bit 8000 = 1 IFF 'R' SPECIFIED
;*                        ,bit 0040 = 1 IFF 'W' specified
;*                        ,bit 3FBF - 0
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-2
;*
;         ORG       *
;CMPRSS   XORX      F2F1,F2F1,F2F1      cler all flags
;         SB        NXTCH<    LOOK FOR '<'
;         BNEL      0,F0,CMPRSS1        BRANCH IF NOT FOUND

CMPRSS:
        MOV     WORD PTR R1,0
        CMP     BYTE PTR [TEXTPTR],'<'
        JNE     CMPRSS1
        INC     TEXTPTR

;         MVI       C'W',F0
;         SB        NXTCH     look for 'W'
;         BNEL      0,F0,*+2  branch if not found
;         ORI       40,F1,F1  flag = wrap program lines

        CMP     BYTE PTR [TEXTPTR],'W'
        JNE     BP42_05
        INC     TEXTPTR
        OR      R1,40H

;         SB        NXTCHS    LOOK FOR 'S'
;         BNEL      0,F0,*+2  NF, BRANCH
;         ORI       40,F2,F2  FLAG = DELETE SPACES

BP42_05:
        CMP     BYTE PTR [TEXTPTR],'S'
        JNE     BP42_06
        INC     TEXTPTR
        OR      R2,40H          ;'S' DENOTES SPACE COMPRESS

;         SB        NXTCHR    LOOK FOR 'R'
;         BNEL      0,F0,*+2
;         ORI       80,F2,F2  FLAG = DELETE REM'S

BP42_06:
        CMP     BYTE PTR [TEXTPTR],'R'
        JNE     BP42_07
        INC     TEXTPTR
        OR      R2,80H

;         SB        NXTCH>    LOOK FOR '>'
;         BEQL      0,F0,*+2

BP42_07:
        CMP     BYTE PTR [TEXTPTR],'>'
        JNE     ERROR_15
        INC     TEXTPTR

;ERR#15A  B         ERROR#15  NF, ERROR (MISSING '>')
;
;CMPRSS1  BFL       2,SL,CMPRSS2        BRANCH IF NOT EXECUTION PHASE
;         MVX       F2F1,PHPL
;         TPA       ,E        set AUXE
;CMPRSS2  SR

CMPRSS1:
        TEST    SL,2
        JZ      CMPRSS2
        MOV     DX,WORD PTR R1
        MOV     AUX0E,EDX
CMPRSS2:
        RET

;         TITLE     LOAD
;*     LOAD: PROCESS A 'LOAD' STATEMENT
;*
;*          DISK STMT FORMAT (IMMEDIATE EXECUTION):
;*
;*               LOAD [DC] platter [file#[,]] filename
;*                                 disk-addr[,]
;*
;*          DISK STMT FORMAT (PROGRAM MODE):
;*
;*               LOAD [DC] platter [file#[,]] filename
;*                                 disk-addr[,]
;*
;*                    [line-no.] [,[line-no.]]
;*
;*          PAPER TAPE FORMAT (IMMEDIATE EXECUTION):
;*
;*               LOAD  [file#  [,]]
;*                     [dev-addr[,]]
;*
;*          PAPER TAPE FORMAT (PROGRAM MODE):
;*
;*               LOAD [file# [,]] [line-no.] [,[line-no.]]
;*                    [dev-addr[,]]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'LOAD'
;*
;*          NOTE: (OSBEG+39) - (OSBEG+3E) USED TO STORE
;*                 LOAD DA RECEIVER INFORMATION
;*
;         ORG       *
;LOAD     BFL       2,SL,LOAD6BRANCH IF NOT EXECUTION PHASE
;         TAP       ,MODE
;         ANDI      0FF-82,PH,PH        LOAD & OVERLAY OFF
;         TPA       ,MODE

LOAD:
        TEST    SL,2
        JZ      LOAD6
        MOV     EDX,MODE
        AND     DH,0FFH-82H
        MOV     MODE,EDX

;         SB        ICLEAR    CLEAR INTERRUPT TABLE
;         ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,9        NO. OF FILES TO LOAD = 0
;         SB        INITSTKS  INITIALIZE STACKS

        CALL    ICLEAR
        MOV     EDX,0
        MOV     AUX09,EDX
        CALL    INITSTKS

;         SB        ROSBEG39  POINT TO 'OSBEG+39'
;         ORI,W1    0,,       FLAG = NOT DA


        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@OSBEG
        ADD     EDX,39H
        MOV     BYTE PTR [EDX],0

;LOAD6    MVI       @DA,F0
;         SB        CCL       LOOK FOR 'DA'
;         BNEL      0,F0,*+2  .NF, BRANCH
;         B         LOADDA    .F, BRNACH

LOAD6:
        MOV     R0,@DA
        CALL    CCL
        TEST    R0,0FH
        JNZ     BP42B_01
        JMP     LOADDA

;         MVI       @DC,F0
;         SB        CCL       LOOK FOR 'DC'
;         BEQL      0,F0,LOADDC         F, BRANCH

BP42B_01:
        MOV     R0,@DC
        CALL    CCL
        TEST    R0,0FH
        JZ      LOADDC

;         MVI       @RUN,F0
;         SB        CCL       LOOK FOR 'RUN'
;         BNEL      0,F0,*+2  NF, BRANCH
;         B         LOADRUN

        MOV     R0,@RUN
        CALL    CCL
        TEST    R0,0FH
        JNZ     BP42B_02
        JMP     LOADRUN

;         SB        PLATTERA  LOOK FOR PLATTER SPEC.
;         BNEH      0F,F0,LOADDCA       BRANCH IF FOUND
;         SB        DEVICET   PROCESS #n OR /xyy (DEFAULT = TAPE)

BP42B_02:
        CALL    PLATTERA
        CMP     R0,0FFH
        JNZ     LOADDCA
        CALL    DEVICET

;         BTL       2,SL,LOAD1BRANCH IF EXECUTION PHASE
;         BEQL      1,F0,LOAD7BRANCH IF #N OR /XYY BUT NO COMMA

        TEST    SL,2
        JNZ     LOAD1
        CMP     R0,1
        JZ      LOAD7

;*     ENTRY OR RESOLUTION PHASE
;*
;LOADA    TAP       ,MODE
;         BTL       2,PL,LOAD7BRANCH IF IMMEDIATE EXECUTION
;         SB        LN#RANGE  LOOK FOR START & END LINE NUMBERS

LOADA:
        MOV     EDX,MODE
        TEST    DL,2
        JNZ     LOAD7
        CALL    LN_RANGE

;         MVI       @BEG,F0
;         SB        CCL       LOOK FOR 'BEG'
;         BNEL      0,F0,LOAD7NF, BRANCH
;         SB        LINE#REF  LOOK FOR BEGIN LINE#
;         BEQL      0,F0,LOAD7

        MOV     R0,@BEG
        CALL    CCL
        TEST    R0,0FH
        JNZ     LOAD7
        CALL    LINE_REF
        TEST    R0,0FH
        JZ      LOAD7

;ERR#21D  B         ERROR#21  NF, ERROR
;LOAD7    B         ENDSTMT

ERR_21D:
        JMP     ERROR_21
LOAD7:
        JMP     ENDSTMT

;*     EXECUTION PHASE
;*
;LOAD1    TAP       ,ACTDEV   GET DEVICE TYPE
;         BEQL      #PHOENIX,PH,LOAD4
;         BEQL      3,PH,LOAD4BRANCH IF DISK
;         BEQL      0B,PH,LOAD4         BRANCH IF DISK
;         BEQL      6,PH,*+2  BRANCH IF PAPER TAPE
;         B         ERR#48C

LOAD1:
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      LOAD4
        CMP     DH,3
        JZ      LOAD4
        CMP     DH,0BH
        JZ      LOAD4
        CMP     DH,6
        JZ      BP42B_03
        JMP     ERR_48C

;         SB        SETDEVLD  DEVLOAD = ACTDEV
;LOADB    TAP       ,MODE
;         ORI       80,PH,PH  LOAD MODE ON
;         BTL       2,PH,LOAD5BRANCH IF OVERLAY ON (LOADING MULTIPLE FILES,
;*_     1ST FILE ALREADY LOADED)

BP42B_03:
        CALL    SETDEVLD
LOADB:
        MOV     EDX,MODE
        OR      DH,080H
        TEST    DH,2
        JNZ     LOAD5

;         ORI       82,PH,PH  LOAD MODE ON, OVERLAY MODE ON)
;         BFL       2,PL,LOAD2BRANCH IF NOT IMMEDIATE EXECUTION
;         ANDI      0FD,PH,PH OVERLAY MODE OFF

        OR      DH,82H
        TEST    DL,2
        JZ      LOAD2
        AND     DH,0FDH

;LOAD5    TPA       ,MODE
;         B         LOAD3

LOAD5:
        MOV     MODE,EDX
        JMP     LOAD3

;*     OVERLAYING (NOT IMMEDIATE EXECUTION)
;*
;LOAD2    TPA       ,MODE
;         SB        CLEARN    REMOVE NONCOMMON VARIABLES
;         SB        INITSTKS  INITIALIZE STACKS

LOAD2:
        MOV     MODE,EDX
        CALL    CLEARN
        CALL    INITSTKS

;         ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,STMTCNT  CONTINUE STATEMENT COUNT = 0 (BEGIN OF LINE)
;         SB        LINE#REF  LOOK FOR LINE#
;         BEQL      0,F0,LOAD15         F, BRANCH

        MOV     EDX,0
        MOV     STMTCNT,EDX
        CALL    LINE_REF
        TEST    R0,0FH
        JZ      LOAD15

;@3.0LD15 EQU       *         FIX FOR LOAD T"NAME" ,LINE#
;         SB        NXTCHCOM  look for comma
;         BEQL      0,F0,LOAD14         branch if found
@3?PD0LD15:
        CMP     BYTE PTR [TEXTPTR],','
        JNE     @3?PD1X
        INC     TEXTPTR
        JMP     LOAD14
@3?PD1X:

;         SB        BEGLINE#  LOOK FOR 'BEG XXXX'
;         TAP       ,MODE     IF OVERLAY WITH NO LINE#S,
;*                                                 unprotect partition
;         ANDI      0FF-40,PL,PL
;         TPA       ,MODE

        CALL    BEGLINE_

;PATCH IN 3.2 TO CHECK I/O BUFFER
        MOV     EDX,ACTDEV
        AND     DH,0FH
        CMP     DH,_PHOENIX
        JZ      @3?PD21A
        CMP     DH,03
        JZ      @3?PD21A
        CMP     DH,0BH
        JNZ     @3?PD21B
@3?PD21A:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,[EDX]
        XCHG    CH,CL
        TEST    CH,10H
        JNZ     @3?PD21B
        MOV     EDX,MODE
        AND     DL,0FFH-40H
        MOV     MODE,EDX

;         SB        INITTEXT  CLEAR ALL TEXT
;         B         LOAD16    START RUNNNING AT LOWEST NUMBERED LINE
;*_     (CONTLN# = FFXX)
;
;LOAD14   TPA       ,TEXTPTR  point back to comma
;         XORX      F3F2,F3F2,F3F2      start# = 0

@3?PD21B:
        CALL    INITTEXT
        JMP     LOAD16
LOAD14:
        MOV     TEXTPTR,EDX
        MOV     WORD PTR R2,0
        JMP     LOAD15A

;LOAD15   MVX       F3F2,PHPL
;         TPA       ,CONTLN#  CONTLN# = LINE# FOUND (START RUN AT THIS LINE)
;         SB        LN#RANGA  PROCESS REST OF LINE# RANGE SPEC.
;         SB        BEGLINE#  LOOK FOR 'BEG XXXX'
;         MVX       F7F6,F3F2 F3,2 = START LINE NUMBER

LOAD15:
        MOV     DX,WORD PTR R2
        MOV     CONTLN_,EDX
LOAD15A:
        CALL    LN_RANGA
        CALL    BEGLINE_
        MOV     AX,WORD PTR R6
        MOV     WORD PTR R2,AX

;         SB        UNTHREAD  DELETE TEXT FROM START LINE TO END LINE
;         SB        ZDATAPTR  INITIALIZE DATAPTRS
;LOAD16   SB        UNRESLVI  CLEAR DEFFN@PART, UNRESOLVED, CLEAR INTRPT

        CALL    UNTHREAD
        MOV     EDX,DWORD PTR [CPBASE]
        MOV     DWORD PTR [EDX].@DBASE,EDX   ;@DBASE = CPBASE
        MOV     ECX,DWORD PTR [EDX].@TEXTBEG ;GET TEXTBEG POINTED TO BY CPBASE
        MOV     DWORD PTR [EDX].@DATAPTR,0   ;DATAPTR = 0
        MOV     DWORD PTR [EDX].@DATALPT,ECX ;DATALPT = TEXTBEG
LOAD16:
        CALL    UNRESLVI

;LOAD3    ANDX      DD,DK,PHPLPC'S = 0
;         TPA       ,5        AUX5 = 0 (START VALUE FOR LINE# THAT LAST
;         TPA       ,6        AUX6 = 0 (LINE# OF LATEST LINE LOADED)
;LOADP6   B         ENTERF         LINE WAS THREADED TO)
;LOAD4    B         ERROR#16  PLATTER SPEC. MISSING

LOAD3:
        MOV     EDX,0
        MOV     AUX05,EDX
        MOV     AUX06,EDX


        test    counts,2000h
        jz      loadp6
        jmp     enterf

LOADP6:

        mov     edx,dword ptr [cpbase]
        lea     edi,[edx].@iobuffr              ; I/O BUFFR + 400T  <=====
        add     edi,400
        lea     esi,aux0c
        mov     ecx,4
        rep     movsd
        lea     esi,aux05
        mov     ecx,2
        rep     movsd

        JMP     ENTERF
LOAD4:
        JMP     ERROR_16

;*     BEGLINE#: PROCESS 'BEG XXXX' PARAMETER
;*
;BEGLINE# MVI       @BEG,F0
;         SB        CCL       LOOK FOR 'BEG'
;         BNEL      0,F0,BEGLIN#1       NF, BRANCH

BEGLINE_:
        MOV     R0,@BEG
        CALL    CCL
        TEST    R0,0FH
        JNZ     BEGLIN_1

;         SB        LINE#REF  LOOK FOR BEGIN LINE NUMBER
;         BNEL      0,F0,ERR#21D        NF, ERROR
;         MVX       F3F2,PHPL
;         TPA       ,CONTLN#  CONTINUE LINE# = BEGIN#
;BEGLIN#1 SR

        CALL    LINE_REF
        TEST    R0,0FH
        JNZ     ERR_21D
        MOV     DX,WORD PTR R2
        MOV     CONTLN_,EDX
BEGLIN_1:
        RET

;         TITLE     LOAD DC
;*     LOADDC: PROCESS A  'LOAD DC' STATEMENT
;*
;*          STMT FORMAT (IMMEDIATE EXECUTION):
;*
;*               LOAD [DC] platter [file#,] filename
;*                                 disk-addr,
;*
;*          STMT FORMAT (PROGRAM MODE):
;*
;*               LOAD [DC] platter [file#,] filename
;*                                 disk-addr,
;*
;*                 [line-no.] [,[line-no.]] [BEG line-no]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'LOAD DC'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               (IN EXECUTION PHASE, AUXA-F,4 (IBUFEND),5
;*
;*          WORKSPACE USED TO STORE PROGRAM NAME.
;*
;LOADDC   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;LOADDCA  SB        DISKSELC  PROCESS #n, OR /xyy, PARAMETER
;         SB        NXTCH<    LOOK FOR '<'
;         BEQL      0,F0,LOADDC2        BRANCH IF FOUND
;         SB        FILENAMP  GET PROGRAM NAME FROM TEXT; SEARCH FOR IT IN INDX
;         BFL       2,SL,LOADABRANCH IF NOT EXECUTION PHASE

LOADDC:
        CALL    PLATTER
LOADDCA:
        CALL    DISKSELC
        CMP     BYTE PTR [TEXTPTR],'<'
        JNE     LOADDCAX
        INC     TEXTPTR
        JMP     LOADDC2
LOADDCAX:
        CALL    FILENAMP
        TEST    SL,2
        JZ      LOADA

;LOADDCC  SB        GTFLPTRS  AUXB = START OF FILE ADDR; AUXD = EOF ADDR
;         TAP       ,B
;         TPA       ,F        AUX F = START OF FILE SECTOR ADDRESS

LOADDCC:
        CALL    GTFLPTRS
        MOV     EDX,AUX0B
        MOV     AUX0F,EDX

;LOADDCB  SB        HPION     HIGH PRIORITY I/O ON
;         SB        LOADBLK   LOAD NEXT SECTOR FROM LOAD DEVICE
;         BEQH      4,CH,LOADDCB1       .
;         BEQH      5,CH,*+2  .BRANCH IF PROGRAM HEADER BLOCK
;         B         ERR#88L   .
;         SB        PRGPRTCT  SET PROGRAM PROTECT BIT

LOADDCB:

; ------------------ 22c11-2 ---------------
        call    multi_read
; ------------------ 22c11-2 ---------------

        CALL    HPION
        CALL    LOADBLK

        and     counts,0ffffdfffh      ;2000h bit on ---> select new
                                       ;          off --> select old
        CMP     CH,40H
        JZ      LOADDCB1
        CMP     CH,50H
        JZ      BP42B_04

        or      counts ,02000h         ;

        cmp     ch,60h
        jz      loaddcb1
        cmp     ch,70h
        jz      bp42b_04

        JMP     ERR_88L
BP42B_04:
        CALL    PRGPRTCT

;*   Following section changed greatly in 3.0
;@3.0LOAD
;LOADDCB1 SB        SETDEVLD  devload=ACTDEV
;         SB        RSAVEA
;         OR,W1     +,,       turn off wrap mode flag
;         OR,W1     +,,         and set scramble seed as 0000

@3?PD0LOAD:
LOADDCB1:
        CALL    SETDEVLD
        MOV     EDX,DWORD PTR [CPBASE]    ;2 byte scratch area used currently only
        LEA     EDX,[EDX].@RSAVE          ;only by SAVE/LOAD during X phase.
        MOV     WORD PTR [EDX],0
        ADD     EDX,2

;         SB        LOADPB    load first program text block
;         TAP       ,C        point to first sector of file
;         SC,R,0    +,,F0     read byte 1, and set F0 to 'FF'
;         BNR       F0,CH,LOADDCB2      If byte 01 of sector not FF,
;*                                                   it's either EOF or bug

        CALL    LOADPB
        MOV     EDX,AUX0C
        MOV     CH,[EDX]
        INC     EDX
        MOV     R0,0FFH
        CMP     CH,R0
        JNZ     LOADDCB2

;         OR        +,,       Skip over the checksum in 02
;         OR,R      +,,
;         BNR       CH,F0,LOADDCB2      if byte 03 is not FF, it's old style sector
;*                                                    and there's no signature word
;         TPA+3,R   ,C        prog line starts after two byte signature
;*                                                   and two more random bytes
        INC     EDX
        MOV     CH,[EDX]
        INC     EDX
        CMP     CH,R0
        JNZ     LOADDCB2
        MOV     CH,[EDX]
        MOV     AUX0C,EDX
        ADD     AUX0C,3

;         BNEH      0A,CH,LOADDERR
;         BNEL      00,CH,LOADDERR      Error if signature not FFA0
;         SB        RSAVEA    FFA0 is called wrap mode

        CMP     CH,0A0H
        JNZ     LOADDERR
        MOV     EDX,DWORD PTR [CPBASE]    ;2 byte scratch area used currently only
        LEA     EDX,[EDX].@RSAVE          ;only by SAVE/LOAD during X phase.
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL

;         ORI,W2    01,CL,    turn on wrap mode flag (while
;*                                                 preserving checksum of this first sector)
;         SB        CHECKSUM  check checksum if wrap mode
;         BNR       F0,,LOADDERR

        MOV     AL,CL
        OR      AL,01
        MOV     [EDX+1],AL
        CALL    CHECKSUM
        CMP     R0,0
        JNZ     LOADDERR

;LOADDCB2 B         LOADB     go load rest of file
;LOADDC2  SB        EXPR      EVALUATE EXPRESSION
;         BFL       2,SL,LOADDC3        BRANCH IF NOT EXECUTION PHASE
;         SB        FLTBINA   CONVERT VALUE TO BINARY

LOADDCB2:
        JMP     LOADB
LOADDC2:
        CALL    EXPR
        TEST    SL,2
        JZ      LOADDC3
        CALL    FLTBINA

;         BER       F0,,ERR#34A         ERROR IF VALUE = 0
;         MV        F0,PL
;         TPA-1     ,9        AUX9,BITS00FF = NO. OF FILES TO LOAD -1

        CMP     DWORD PTR [A0],0
        JZ      ERR_34A
        MOVZX   EDX,A0
        MOV     AUX09,EDX
        DEC     AUX09

;LOADDC3  SB        NXTCH>    LOOK FOR '>'
;         BEQL      0,F0,*+2  NF, ERROR
;         B         ERR#15A

LOADDC3:
        CMP     BYTE PTR [TEXTPTR],'>'
        JNE     ERROR_15
        INC     TEXTPTR

;         SB        AVARD     LOOK FOR ALPHA VARIABLE
;         BNEL      0,F0,ERR#29A        NF, ERROR
;         BFL       2,SL,LOADABRANCH IF NOT EXECUTION PHASE
;         SB        POPV4     GET ADDRESS & LENGTH OF VARIABLE (NAMES)

BP42B_05:
        CALL    AVARD
        TEST    R0,0FH
        JNZ     ERR_29A
        TEST    SL,2
        JZ      LOADA
;       CALL    POPV4           ;ADDRESS OF VARIABLE ==> EDX  , LENGTH ==>  R1,0
        MOV     EDX,VSPTR
        MOV     EAX,DWORD PTR [EDX]
        MOV     DWORD PTR [A0],EAX
        MOV     ECX,DWORD PTR [EDX+4]
        ADD     VSPTR,8
        MOV     EDX,ECX

;         TPA       ,8        AUX8 = ADDRESS OF VARIABLE
;         MVX       PHPL,F5F4 F5,4 = ADDRESS OF VARIABLE
;         MVX       F1F0,F3F2 F3,2 = LENGTH OF VARIABLE
;         TAP       ,9
;         AI        1,PL,F0   F0 = NO. OF FILES TO LOAD
;         SB        MATDSPLA  F1,0 = 8 * NO. OF FILES

        MOV     AUX08,EDX
        MOV     DWORD PTR A4,EDX
        MOV     EAX,DWORD PTR A0
        MOV     DWORD PTR A2,EAX
        MOV     EDX,AUX09
        MOVZX   EAX,DL
        INC     EAX
        SHL     EAX,3
        MOV     DWORD PTR [A0],EAX

;         BLRX      F3F2,F1F0,ERR#51A   ERROR IF VARIABLE TOO SHORT
;         SB        RCOMPTR
;         BLRX      F5F4,CHCL,ERR#54A   .ERROR IF VARIABLE NOT COMMON
;LOADDC4  SB        RWORKSPC  POINT TO WORKSPACE
;         XPA       ,8
;         AI        8,PL,F0

        MOV     EAX,DWORD PTR A2
        CMP     EAX,DWORD PTR A0
        JB      ERR_51A
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@COMPTR
        MOV     ECX,DWORD PTR [EDX]
        CMP     ECX,DWORD PTR A4
        JAE     ERR_54A
LOADDC4:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        XCHG    EDX,AUX08
        MOV     EBX,EDX
        ADD     EBX,8

;         XPA+1,R   ,8        GET NEXT CHARACTER OF NAME
;         XPA+1,W1  CH,8      NAME CHARACTER ==> WORKSPACE
;         BNR       F0,PL,*-2 BRANCH IF MORE TO NAME
;         TPA       ,8        BUMP NAME PTR

BP42B_06:
        MOV     CH,[EDX]
        XCHG    EDX,AUX08
        INC     AUX08
        MOV     [EDX],CH
        XCHG    EDX,AUX08
        INC     AUX08
        CMP     EDX,EBX
        JNZ     BP42B_06
        MOV     AUX08,EDX

;         SB        FINDNAMH  SCAN FOR NAME INDEX
;         MVI       80,F0     FLAG = PROGRAM FILE
;         SB        FILENMXA  CHECK FILE TYPE / STATUS
;         B         LOADDCC

        CALL    FINDNAMH
;
; cs-386 format
;
        mov     al,40h
;
        MOV     R0,80H
        CALL    FILENMXA
        JMP     LOADDCC

;ERR#34A  B         ERROR#34  ILLEGAL VALUE
;ERR#51A  B         ERROR#51  VARIABLE TOO SMALL
;ERR#29A  B         ERROR#29  MISSING ALPHA VARIABLE
;ERR#54A  B         ERROR#54  .VARIABLE NOT COMMON

ERR_34A:
        JMP     ERROR_34
ERR_51A:
        JMP     ERROR_51
ERR_29A:
        JMP     ERROR_29
ERR_54A:
        JMP     ERROR_54

;         TITLE     LOADDA
;*     LOADDA: PROCESS A  'LOAD DA' STATEMENT
;*
;*          STMT FORMAT (IMMEDIATE EXECUTION):
;*
;*   LOAD DA platter [file#,] (sector-addr[,[variable]])
;*                   disk-addr,
;*
;*          STMT FORMAT (PROGRAM MODE):
;*
;*   LOAD DA platter [file#,] (sector-addr[,[variable])
;*                   disk-addr,
;*
;*                 [line-no.] [,[line-no.]] [BEG line-no]
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'LOAD DA'
;*
;*          MODIFIED REGISTERS: ALL,AUX0,1,2
;*               IN EXECUTION PHASE, AUXA-F,4(IBUFEND),5
;*
;LOADDA   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSELC  PROCESS #n, OR /xyy, PARAMETER
;         SB        SECTOR    PROCESS SECTOR ADDRESS PARAMETER
;         BTL       2,SL,*+2  .BRANCH IF  EXECUTION PHASE

LOADDA:
        CALL    PLATTER
        CALL    DISKSELC
        CALL    SECTOR
        TEST    SL,2
        JNZ     BP42B_07

;         B         LOADA     .
;         TAP       ,OSPTR
;         TAP,R     ,VSPTR    GET LAST OS ATOM
;         BNEH      @NUMRECH,CH,LOADDA1 BRANCH IF NOT SECTOR-ADDR-RECEIVER
;         MV        CH,F0
;         BEQL      @NUMRECL,CH,LOADDA2 BRANCH IF NUMERIC RECEIVER VARIABLE
;         BNEL      @ALPHRCL,CH,LOADDA1 BRANCH IF NOT ALPHA RECEIVER VARIABL

        JMP     LOADA
BP42B_07:
        MOV     EDX,OSPTR
        MOV     CH,[EDX]
        MOV     EDX,VSPTR
        MOV     R0,CH
        CMP     CH,@NUMREC
        JZ      LOADDA2
        CMP     CH,@ALPHREC
        JZ      BP42B_08
        JMP     LOADDA1

;         OR,R      +,,
;         OR        +,,
;         MVX       CHCL,F2F1 SAVE LENGTH OF ALPHA VARIABLE

BP42B_08:
        MOV     ECX,[EDX]
        ADD     EDX,4
        MOV     DWORD PTR A1,ECX

;LOADDA2  ,R        ,         GET RECEIVER VARIABLE ADDRESS
;         MVX       CHCL,F4F3 SAVE VARIABLE ADDRESS
;         SB        ROSBEG39  POINT TO 'OSBEG+39'

LOADDA2:
        MOV     ECX,[EDX]
        MOV     EBX,ECX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@OSBEG
        ADD     EDX,39H

;         OR,W1     +,F0,
;         OR,W1     +,F2,     RECEIVER VAR. INFO. ==> END OF OS
;         OR,W1     +,F1,
;         OR,W1     +,F4,
;         OR,W1     F3,,

        MOV     AL,R0
        MOV     [EDX],AL        ;ATOM (1)
        INC     EDX
        MOV     EAX,DWORD PTR [A1]
        MOV     [EDX],EAX       ;LENGTH (2)
        ADD     EDX,4
        MOV     [EDX],EBX       ;ADDRESS (4)

;         SB        RCOMPTR
;         BLRX      F4F3,CHCL,LOADDA3   BRANCH IF RECEIVER VARIABLE NOT COMMON

        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@COMPTR
        MOV     ECX,DWORD PTR [EDX]
        CMP     ECX,EBX
        JA      LOADDA3

;LOADDA1  SCX,0     F1F0,F1F0,PHPL      PC'S = FFFF
;         TPA       ,D        AUXD = EOF ADDRESS (FFFF)
;         B         LOADDCB

LOADDA1:
        MOV     EDX,0FFFFH                ;EOF if 2 byte addressing     ^A12T
        MOV     EAX,DWORD PTR [CPBASE]    ;                             ^A12T
        CMP     BYTE PTR [EAX].@SPREG9,0  ;select 3 flag                ^A12T
        JE      LOADDA4                   ;jump if select 3 off         ^A12T      
        MOV     EDX,0FFFFFFH              ;EOF for 3 byte addressing    ^A12T
LOADDA4:                                  ;                             ^A12T
        MOV     AUX0D,EDX
        JMP     LOADDCB

;LOADDA3  TAP       ,MODE
;         BTL       2,PL,LOADDA1        BRANCH IF IMMEDIATE EXECUTION

LOADDA3:
        MOV     EDX,MODE
        TEST    DL,2
        JNZ     LOADDA1

;ERROR#54 MVI       54,F0     VARIABLE NOT COMMON
;         B         ERROR

ERROR_54:
        MOV     R0,54H
        JMP     ERROR


;         TITLE     LOADPBLK PRGPRTCT
;*     LOADPBLK: GET THE NEXT PROGRAM BLOCK FROM THE LOAD
;*               DEVICE. IF PROTECTED PROGRAM, SET THE
;*               PROGRAM PROTECT BIT.  This is NOT called for the Header sector
;*
;*          ERROR CONDITIONS:
;*               47 = DEVICE NOT DISK
;*               88 = NOT PROGRAM TEXT BLOCK, or this block not scrambled when
;*
;*               89 = SECTOR ADDRESS > EOF
;*
;*          ENTRY:
;*               PHASE = EXECUTION
;*               DEVLOAD = LOAD DEVICE TYPE & ADDRESS
;*                 DEVICE TYPE = 3 OR B
;*                               (IF NOT, ERROR#47. IF
;*                                LOGIC IS TO BE USED TO
;*                                CONTROL OTHER DEVICES,
;*                                PATCH IN AT 'B ERROR#47'
;*                 AUXF = SECTOR ADDRESS OF SECTOR TO READ
;*                 AUXE,LOW BYTE = PLATTER
;*                AUXD = EOF SECTOR ADDRESS (CANNOT READ
;*                       BEYOND EOF
;*
;*          RETURN: BLOCK READ IN I/O BUFFER
;*                  CH,CL = 1ST 2 BYTES OF BLOCK READ
;*                  AUXF = ADDRESS OF SECTOR ACCESSED
;*                  PROGRAM PROTECT BIT SET IF PROGRAM
;*                     IS PROTECTED
;*                  AUXC = ADDRESS OF I/O BUFFER + 1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0,1,K
;*                              AUX0,C,F
;*
;*     PRGPRTCT: SET THE PROGRAM PROTECT BIT IF PROGRAM
;*               IS PROTECTED
;*
;*          ENTRY: CH = CONTROL BYTE OF BLOCK
;*
;*          RETURN: PC'S = MODE
;*
;*          MODIFIED REGISTERS: PC'S
;*
;LOADPBLK SB        LOADLBLK  LOAD SECTOR FROM THE LOAD DEVICE
;         TPA+1     ,C        AUXC = ADDRESS OF I/O BUFFER
;         BFH       0C,CH,*+2 BRANCH IF PROGRAM TEXT BLOCK

LOADPBLK:
        CALL    LOADLBLK
        MOV     AUX0C,EDX
        INC     AUX0C
        TEST    CH,0C0H
        JZ     BP42D_03

;ERR#88L  B         LOADDERR  ERROR IF NOT PRORAM TEXT BLOCK
;
;         BFHH      10,CH,LOADPBL1      BRANCH IF PROGRAM NOT PROTECTED
;         BTHH      80,CL,LOADPBL2      BRANCH IF 2200 STYLE PROTECT
;         SB        DCRYPT    UNSCRAMBLE PROGRAM
;         SB        RSAVEA
;         ORI,W2    02,CL,    flag the fact that this sector is scrambled
;         B         LOADPBL3

ERR_88L:
        JMP     LOADDERR
BP42D_03:
        TEST    CH,10H
        JZ      LOADPBL1
        TEST    CL,80H
        JNZ     LOADPBL2
        CALL    DCRYPT
        MOV     EDX,DWORD PTR [CPBASE]    ;2 byte scratch area used currently only
        LEA     EDX,[EDX].@RSAVE          ;only by SAVE/LOAD during X phase.
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        OR      CL,02
        MOV     [EDX+1],CL
        JMP     LOADPBL3

;*  This sector isn't scrambled.  Make sure last one wasn't either.
;LOADPBL2
;         SB        RSAVEA
;         BTLL      02,CL,ERR#88L       error 88 if the previous sector was scrambled
;LOADPBL3
;         SB        RIOBUFFR

LOADPBL2:
        MOV     EDX,DWORD PTR [CPBASE]    ;2 byte scratch area used currently only
        LEA     EDX,[EDX].@RSAVE          ;only by SAVE/LOAD during X phase.
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL
        TEST    CL,02
        JNZ     ERR_88L
LOADPBL3:
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        MOV     CX,WORD PTR [EDX]
        XCHG    CH,CL

;PRGPRTCT BFH       1,CH,LOADPBL1       BRANCH IF PROGRAM NOT PROTECTED
;         TAP       ,MODE
;         ORI       40,PL,PL  SET PROGRAM PROTECT BIT
;         TPA       ,MODE
;LOADPBL1 SR

PRGPRTCT:
        TEST    CH,10H
        JZ      LOADPBL1
        OR      MODE,040H
LOADPBL1:
        RET

;         TITLE     LOADRUN
;*     LOADRUN: PROCESS A 'LOADRUN' COMMAND
;*
;*          ENTRY: TEXTPTR POINTS AFTER 'RUN'
;*
;*          FORMAT:
;*
;*              LOAD RUN [platter] [disk-addr,] [filename]
;*                                  file#,
;*
;*      Made programmable in Release 1.9
;*
;         ORG       *
;LOADRUN  EQU       *
;         BFL       2,SL,*+2
;         SB        $CLOSEA   CLOSE ALL DEVICES FOR THIS PARTITION (X-PHASE)
;         SB        PLATTERA  LOOK FOR PLATTER SPECIFICATION

LOADRUN:
        TEST    SL,2
        JZ      BP42D_02
        CALL    $CLOSEA
BP42D_02:
        CALL    PLATTERA

;         BNEH      0F,F0,*+3 F, BRANCH
;         MVI       0,F0      PLATTER = 'T'
;         SB        PLATTERX  PLATTER = 'T'
;         SB        DISKSELC  PROCESS /XYY, OR #N,
;         SB        NXTCHCR   LOOK FOR 'CR'
;         BEQL      0,F0,LOADRUN3       BRANCH IF FOUND
;         TAP       ,MODE
;         BFL       2,PL,LOADRUN4       branch if not immediate execution
;         SB        RPMODE

        CMP     R0,0FFH
        JNZ     BP42D_01
        MOV     R0,0
        CALL    PLATTERX
BP42D_01:
        CALL    DISKSELC
        mov     edx,textptr
        CMP     BYTE PTR [TEXTPTR],0DH
        JNE     BP42D_01X
        INC     TEXTPTR
        JMP     LOADRUN3
BP42D_01X:
        MOV     EDX,MODE
        TEST    DL,2
        JZ      LOADRUN4
        MOV     EDX,0
        MOV     DL,BYTE PTR [PART_]
        ADD     EDX,OFFSET PMODE
        MOV     CH,BYTE PTR [EDX]

;         BFL       PMODEP,CH,LOADRUN4  BRANCH IF PROGRAMMING NOT DISABLED
;         BTL       PMODEB,CH,LOADRUN4  BRANCH IF PROGRAM BOOTSTRAPPING
;         B         ERROR#08  CANNOT SPECIFY NAME IF PROGRAMMING DISABLED

        TEST    CH,PMODEP
        JZ      LOADRUN4
        TEST    CH,PMODEB
        JNZ     LOADRUN4

;LOADRUN4 SB        FILENAMP  PROCESS PROGRAM NAME
;         BTL       2,SL,LOADRUN1       BRANCH IF EXECUTION PHASE
;LOADRUN2 B         ENDSTMT   EXIT

LOADRUN4:
        CALL    FILENAMP
        TEST    SL,2
        JNZ     LOADRUN1
LOADRUN2:
        JMP     ENDSTMT

;*     DEFAULT FILENAME LOGIC
;*
;LOADRUN3 TPA       ,TEXTPTR  POINT TO 'CR'
;         BFL       2,SL,LOADRUN2       BRANCH IF NOT EXECUTION PHASE
;         SB        RWORKSPC  POINT TO WORKSPACE
;         TPA       ,3

LOADRUN3:
        MOV     TEXTPTR,EDX
        TEST    SL,2
        JZ      LOADRUN2
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC
        MOV     AUX03,EDX

;         LPI       #FILENAM
;         SB        MOVEELMT  FILENAME ==> WORKSPACE
;         SB        FINDNAMH  FIND NAME IN INDEX
;         SB        FILENAMS  CHECK FILE STATUS

        MOV     EDX,OFFSET _FILENAM
        CALL    MOVEELMT
        CALL    FINDNAMH
        CALL    FILENAMS

;LOADRUN1 SB        CLEARXA   CLEAR SYSTEM LOGIC
;         SB        ICLEAR    CLEAR INTERRUPT TABLE
;         SB        INITSTKS  INITIALIZE STACKS
;         TAP       ,MODE
;         ORI       82,PH,PH  LOAD,OVERLAY ON
;         B         LOADDCC

LOADRUN1:
        CALL    CLEARXA
        CALL    ICLEAR
        CALL    INITSTKS
        MOV     EDX,MODE
        OR      DH,82H
        JMP     LOADDCC

;         TITLE     @REVERB
;*        @REVERB: ENTRY POINT FOR RE, CHECKS FOR RESAVE OR RENAME
;*                 AND BRANCHES TO THE APPROPRIATE ROUTINE.
;*
;*                 ENTRY: TEXTPTR POINTS AFTER 'RE'.
;*
;*                 EXIT: TEXTPTR POINTS AFTER 'SAVE' OR 'NAME'.
;*
;         ORG       *
;@REVERB  MVI       @SAVE,F0  LOOK FOR SAVE ATOM
;         SB        CCL
;         BNEL      0,F0,@REVERB1       NOT FOUND - LOOK FOR NAME
;         B         RESAVE    FOUND - BR TO RESAVE

@REVERB:
        MOV     R0,@SAVE
        CALL    CCL
        TEST    R0,0FH
        JNZ     @REVERB1
        JMP     RESAVE
;
;*        LOOK FOR 'NAME'
;@REVERB1 LPI       #NAME     LOOK FOR 'NAME'
;         SB        CCNL
;         BNEL      0,F0,@REVERB2       NOT FOUND - ERROR
;         B         RENAME    FOUND - BR TO RENAME
;@REVERB2 B         ERROR#20  END OF VALID SYNTAX

@REVERB1:
        MOV     EDX,OFFSET _NAME
        CALL    CCNL
        TEST    R0,0FH
        JNZ     @REVERB2
        JMP     RENAME
@REVERB2:
        JMP     ERROR_20

;         TITLE     RENAME
;*        RENAME: PROCESSES A 'RENAME' STATEMENT
;*
;*           STMT FORMAT:
;*
;*                  RENAME PLATTER [FILE#    ] FILENAME TO FILENAME
;*                                 [DISK-ADDR]
;*
;*           ENTRY: TEXTPTR POINTS AFTER RENAME
;*
;*           MODIFIED REGISTERS: ALL AUX 0, 1, 2
;*                  IN EXECUTION PHASE AUX 3-F
;*
;         ORG       *
;RENAME   SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        DISKSELC  PROCESS #N, OR /XYY, PARAMTERS
;         SB        FILENAMH  LOOK FOR OLD FILENAME & SCAN INDEX IF EXECUTION PHASE
;         BFL       2,SL,RENAME02       BR IF NOT EXECUTION PHASE
;         BEQH      1,F3,*+2  FOUND - BRANCH
;         B         ERROR#82  FILE NOT FOUND

RENAME:
        CALL    PLATTER
        CALL    DISKSELC
        CALL    FILENAMH
        TEST    SL,2
        JZ      RENAME02
        TEST    R3,0F0H
        JNZ     JS42E_01
        JMP     ERROR_82

;         TAP       ,F        SAVE SECTOR ADDRESS OF ENTRY
;         TPA       ,5
;         TAP       ,C        SAVE ADDRESS W/I I/O BUFFER OF ENTRY
;         TPA       ,4
;         SB        PUSHV8    SAVE EIGHT BYTES OF INDEX

JS42E_01:
        MOV     EDX,AUX0F
        MOV     AUX05,EDX       ;SAVE SECTOR ADDRESS FOR LATER WRITE BACK
        MOV     EDX,AUX0C
        MOV     AUX04,EDX       ;SAVE ADDRESS IN I/O BUFFER OF ENTRY WITH FILENAME
        MOV     EAX,VSPTR
        MOV     EBX,DWORD PTR [EDX]
        MOV     DWORD PTR [EAX-8],EBX
        MOV     EBX,DWORD PTR [EDX+4]
        MOV     DWORD PTR [EAX-4],EBX
        SUB     VSPTR,8
        CMP     EAX,DWORD PTR [@@VSEND]
        JB      ERROR_02

;RENAME02 SB        CCLTO     LOOK FOR 'TO'
;         SB        FILENAMH  LOOK FOR NEW FILENAME AND SCAN INDEX IF EXECUTION PHASE
;         BFL       2,SL,RENAME09       BR IF NOT EXECUTION PHASE
;         BER       F3,,RENAME03        FILE NOT FOUND & INDEX NOT FULL- BRANCH
;         BNEH      0,F3,*+2  BR IF INDEX NOT FULL
;         B         ERROR#85  INDEX FULL
;         B         ERROR#83  FILE ALREADY EXISTS
;

RENAME02:
        CALL    CCLTO
        CALL    FILENAMH        ; ONE ENTRY = 16 BYTE
        TEST    SL,2            ; FIRST 8 BYTES = FILE TYPE & STATUS,
        JZ      RENAME09        ;                 SOF,EOF,UNUSED
        CMP     R3,0            ; LAST 8 BYTES  = FILENAME
        JZ      RENAME03
        TEST    R3,0F0H
        JNZ     JS42E_02
        JMP     ERROR_85
JS42E_02:
        JMP     ERROR_83

;RENAME03 TAP       ,C        COPY OLD 8 INDEX BYTES INTO NEW FILE NAME LOCATION
;         SB        POPV8
;         TPA+2     ,C        SAVE PTR TO FILE NAME
;         SB        RWORKSPC  POINT AT WORKSPACE

RENAME03:
        MOV     EDX,AUX0C       ;AUX0C = ADDRESS OF UNUSED ENTRY IN I/O BUFFER
        MOV     EAX,VSPTR
        MOV     EBX,DWORD PTR [EAX]
        MOV     DWORD PTR [EDX],EBX
        MOV     EBX,DWORD PTR [EAX+4]
        MOV     DWORD PTR [EDX+4],EBX
        ADD     EDX,6
        ADD     VSPTR,8

        mov     edi,edx
        add     edi,2

        mov     edx,dword ptr [cpbase]
        lea     esi,[edx].@workspc

;         XPA+2,R   ,C        COPY FILE NAME FROM WORKSPACE TO INDEX SECTOR
;         OR,W1     CH,,
;         XPA+2,W2  CL,C
;         XPA+2,R   ,C        COPY FILE NAME FROM WORKSPACE TO INDEX SECTOR
;         OR,W1     CH,,
;         XPA+2,W2  CL,C
;         XPA+2,R   ,C        COPY FILE NAME FROM WORKSPACE TO INDEX SECTOR
;         OR,W1     CH,,
;         XPA+2,W2  CL,C
;         XPA+2,R   ,C        COPY FILE NAME FROM WORKSPACE TO INDEX SECTOR
;         OR,W1     CH,,
;         XPA+2,W2  CL,C

        mov     ecx,2
        rep     movsd

;         SB        RIOBUFFR  WRITE UPDATED INDEX SECTOR FOR NEW NAME
;         XPA       ,0F       PC'=S SECTOR, AUX F= DATA
;         SB        DWRITE$

        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        XCHG    EDX,AUX0F
        CALL    DWRITE?DA

;*        READ OLD INDEX SECTOR INTO I/O BUFFER AND SET ENTRY TO HEX(21)
;
;         TAP       ,5        PC'S = OLD INDEX SECTOR ADDR
;         TPA       ,F
;         SB        DREADSF   READ OLD INDEX SECTOR
;         TAP       ,4        PC'S POINT AT SLOT WITHIN INDEX
;         ORI,W1    X'21',,   CHANGE TO 21
;         TAP       ,5        REWRITE OLD SECTOR
;         TPA       ,0F
;         SB        RIOBUFFR  PT AT I/O BUFFER
;         XPA       ,0F       PC=SECTOR ADDR, AUX = DATA
;         SB        DWRITE$   WRITE OLD INDEX SECTOR

        MOV     EDX,AUX05
        MOV     AUX0F,EDX
        CALL    DREADSF
        MOV     EDX,AUX04
        MOV     BYTE PTR [EDX],21H
        MOV     EDX,AUX05
        MOV     AUX0F,EDX
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        XCHG    EDX,AUX0F
        CALL    DWRITE?DA

;*        UPDATE PROGRAM HEADER IF RENAMED FILE = ACTIVE PROGRAM
;
;         TAP       ,4        POINT AT OLD INDEX ENTRY
;         OR,R      +,,       CHCL = INDEX ID, PROG/DATA FLAG
;         BNEH      8,CL,RENAME09       BR IF NOT PROGRAM

        MOV     EDX,AUX04
        MOV     CX,[EDX]
        XCHG    CH,CL
        INC     EDX
;
;  cs-386 format
;
        cmp     cl,40h
        jz      rename386
;
        CMP     CL,80H          ; TYPE = 80H -- PROGRAM
        JNZ     RENAME09

;         OR        +,,       PC'S PT TO SECTOR ADDR OF HDR
;         ORI,R     0,,       CHCL SECTOR ADDR
;         MVX       CHCL,PHPL
;         TPA       ,0F       SAVE SECTOR ADDR
;         SB        DREADSF   READ SECTOR
;         SB        RWORKSPC  PC'S POINT TO NEW NAME

rename386:
        INC     EDX            ;point to header sector number
        
        MOV     ECX,CPBASE                                           ; ^A11T
        CMP     BYTE PTR [ECX].@HASHFL,02H                           ; ^A11T
        JE      RENAMEHDR1     ;Jump if 3 byte addressing            ; ^A11T
                                                                       
        XOR     ECX,ECX        ;clear top byte                       ; ^A11T
        MOV     CX,[EDX]       ;get bottom bytes                     ; ^A11T
        XCHG    CH,CL          ;- reversed                           ; ^A11T
        JMP     RENAMEHDR2                                           ; ^A11T

RENAMEHDR1:                                                          ; ^A11T
        MOVZX   ECX,BYTE PTR [EDX]                                   ; ^A11T
        SHL     ECX,16         ;get top byte                         ; ^A11T
        MOV     CX,[EDX+1]     ;get bottom bytes                     ; ^A11T
        XCHG    CH,CL          ;- reversed                           ; ^A11T

RENAMEHDR2:                                                          ; ^A11T
        MOV     AUX0F,ECX
        CALL    DREADSF         ;RETURN FROM SUBROUTINE "DREADSF" , AUX0C = ADDRESS OF I/O BUFFER
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@WORKSPC

;         XPA+2,R   ,0C       CHCL = 1ST 2 CHAR OF NAME
;*                                                 PC'S PT TO I/O BUFFER
;         OR        +,,       PT TO 1ST CHAR OF NAME IN HDR
;         OR,W1     +,CH,     UPDATE CHAR 1
;         OR,W1     +,CL,     UPDATE CHAR 2
;         XPA       ,0C
;         XPA+2,R   ,0C       CHCL = CHAR 3&4
;         OR,W1     +,CH,     UPDATE CHAR 3
;         OR,W1     +,CL,     UPDATE CHAR 4
;         XPA       ,0C
;         XPA+2,R   ,0C       CHCL = CHAR 5&6
;         OR,W1     +,CH,     UPDATE CHAR 5
;         OR,W1     +,CL,     UPDATE CHAR 6
;         XPA       ,0C
;         XPA+2,R   ,0C       CHCL = CHAR 7&8
;         OR,W1     +,CH,     UPDATE CHAR 7
;         OR,W1     +,CL,     UPDATE CHAR 8

        MOV     ESI,EDX
        MOV     EDI,AUX0C       ;AUX0C RESET TO ADDRESS OF I/O BUFFER IN DREADSF PROCEDURE
        INC     EDI             ;SKIP THE PROGRAM HEADER-RECORD'S LEADING CODE (40H)
        MOV     ECX,8
;       CLD
        REP     MOVSB

;         TAP       ,0F       UPDATE SECTOR ADDR
;         TPA-1     ,0F
;         SB        RIOBUFFR  PT AT I/O BUFFER
;         XPA       ,0F       PC'S=SEC ADR, AUX F=DATA
;         SB        DWRITE$   WRITE NEW HDR

        DEC     AUX0F
        MOV     EDX,DWORD PTR [CPBASE]
        LEA     EDX,[EDX].@IOBUFFR
        XCHG    EDX,AUX0F
        CALL    DWRITE?DA

;RENAME09 B         ENDSDISK

RENAME09:
        JMP     ENDSDISK

;(ok)     TITLE     RESAVE
;*
;* RESAVE  : PROCESS A 'RESAVEDC' STATEMENT
;*
;*        STATMENT FORMAT:
;*                 <S>               FILE#,          !
;*   RESAVE [DC] [<SR>] PLATTER [$] [DISK-ADDRESS,] [P] FILENAME
;*                                         [START-LINE-NO.] [, [END-LINE-NO.] ]
;*
;*        MODIFIED REGISTERS: ALL, AUX0,1,2
;*                IN EXECUTION PHASE,  AUX7-F
;*
;*        ENTRY: TEXTPTR POINTS AFTER 'RESAVE'
;*
;         ORG       *
;RESAVE   SB        PRTCTERR  MAKE SURE ITS NOT PROTECTED
;         MVI       @DC,F0
;         SB        CCL       LOOK FOR 'DC'
;         SB        CMPRSS    PROCESS COMPRESS PARAMETER
;         SB        PLATTER   PROCESS PLATTER SPECIFICATION
;         SB        RAW       PROCESS READ-AFTER-WRITE PARAMETER
;         SB        DISKSELC  PROCESS #N OR /XYY

RESAVE:
        CALL    PRTCTERR
        MOV     R0,@DC
        CALL    CCL
        CALL    CMPRSS
        CALL    PLATTER
        CALL    RAW
        CALL    DISKSELC

;         XPA       ,A
;         LPI       1         SET UP TO OVERWRITE SAME FILE
;         XPA       ,A


;         SB        PROTECT   PROCESS PROTECT PARAMETER
;         SB        FILENAME  PROCESS FILENAME
;         BNEL      0,F0,RESAVERA       BRANCH IF FILENAME NOT GIVEN
;         BFL       2,SL,RESAVE1        BRANCH IF NOT EXECUTION PHASE

        CALL    PROTECT
        CALL    FILENAME
        TEST    R0,0FH
        JNZ     RESAVERA
        TEST    SL,2
        JZ      RESAVE1

;         SB        FINDNAMH  FIND THE FILE IN THE INDEX
;         BNEH      1,F3,RESAVERB       BRANCH IF FILE NOT FOUND

        CALL    FINDNAMH
        TEST    R3,0F0H
        JZ      RESAVERB

;         TAP       ,C
;         TPA+2     ,C

        MOV     EDX,AUX0C       ;AUX0C = ADDRESS IN I/O BUFFER OF ENTRY WITH FILENAME
        ADD     AUX0C,2

;*        SCRATCH FILE IN CASE OF FILE FULL ERROR  (REL 3.1.1)
;         ORI,W1    11,,      SCRATCH ENTRY
;         SB        RAWON     SET READ AFTER WRITE ON
;         SB        DWRITE$F  UPDATE INDEX ENTRY
;         SB        GTFLPTRS  AUX B = SOF ADDRESS; AUXD = EOF ADDRESS

        MOV     BYTE PTR [EDX],11H
        XCHG    EDX,AUX0E
        MOV     R2,DH
        XCHG    EDX,AUX0E
        CALL    RAWON
        CALL    DWRITE?DAF
        XCHG    EDX,AUX0E
        MOV     DH,R2
        XCHG    EDX,AUX0E
        CALL    GTFLPTRS
;
        MOV     AUX0A,1         ; TO OVERWRITE SAME FILE
;
;RESAVE1  B         SAVEDC9   REUSE 'SAVEDC' LOGIC TO SAVE PROGRAM
;RESAVERA B         ERROR#29
;RESAVERB B         ERROR#82

RESAVE1:
        JMP     SAVEDC9
RESAVERA:
        JMP     ERROR_29
RESAVERB:
        JMP     ERROR_82

;;dum_flg  db      0
DUM_FLG1 DB      0

CODE    ENDS
        END
